# Node.js 10 ChangeLog

<!--lint disable maximum-line-length no-literal-urls prohibited-strings-->

<table>
<tr>
<th>LTS 'Dubnium'</th>
<th title="Previously called 'Stable'">Current</th>
</tr>
<tr>
<td valign="top">
<a href="#10.24.1">10.24.1</a><br/>
<a href="#10.24.0">10.24.0</a><br/>
<a href="#10.23.3">10.23.3</a><br/>
<a href="#10.23.2">10.23.2</a><br/>
<a href="#10.23.1">10.23.1</a><br/>
<a href="#10.23.0">10.23.0</a><br/>
<a href="#10.22.1">10.22.1</a><br/>
<a href="#10.22.0">10.22.0</a><br/>
<a href="#10.21.0">10.21.0</a><br/>
<a href="#10.20.1">10.20.1</a><br/>
<a href="#10.20.0">10.20.0</a><br/>
<a href="#10.19.0">10.19.0</a><br/>
<a href="#10.18.1">10.18.1</a><br/>
<a href="#10.18.0">10.18.0</a><br/>
<a href="#10.17.0">10.17.0</a><br/>
<a href="#10.16.3">10.16.3</a><br/>
<a href="#10.16.2">10.16.2</a><br/>
<a href="#10.16.1">10.16.1</a><br/>
<a href="#10.16.0">10.16.0</a><br/>
<a href="#10.15.3">10.15.3</a><br/>
<a href="#10.15.2">10.15.2</a><br/>
<a href="#10.15.1">10.15.1</a><br/>
<a href="#10.15.0">10.15.0</a><br/>
<a href="#10.14.2">10.14.2</a><br/>
<a href="#10.14.1">10.14.1</a><br/>
<a href="#10.14.0">10.14.0</a><br/>
<a href="#10.13.0">10.13.0</a><br/>
</td>
<td valign="top">
<a href="#10.12.0">10.12.0</a><br/>
<a href="#10.11.0">10.11.0</a><br/>
<a href="#10.10.0">10.10.0</a><br/>
<a href="#10.9.0">10.9.0</a><br/>
<a href="#10.8.0">10.8.0</a><br/>
<a href="#10.7.0">10.7.0</a><br/>
<a href="#10.6.0">10.6.0</a><br/>
<a href="#10.5.0">10.5.0</a><br/>
<a href="#10.4.1">10.4.1</a><br/>
<a href="#10.4.0">10.4.0</a><br/>
<a href="#10.3.0">10.3.0</a><br/>
<a href="#10.2.1">10.2.1</a><br/>
<a href="#10.2.0">10.2.0</a><br/>
<a href="#10.1.0">10.1.0</a><br/>
<a href="#10.0.0">10.0.0</a><br/>
</td>
</tr>
</table>

* Other Versions
  * [17.x](CHANGELOG_V17.md)
  * [16.x](CHANGELOG_V16.md)
  * [15.x](CHANGELOG_V15.md)
  * [14.x](CHANGELOG_V14.md)
  * [13.x](CHANGELOG_V13.md)
  * [12.x](CHANGELOG_V12.md)
  * [11.x](CHANGELOG_V11.md)
  * [9.x](CHANGELOG_V9.md)
  * [8.x](CHANGELOG_V8.md)
  * [7.x](CHANGELOG_V7.md)
  * [6.x](CHANGELOG_V6.md)
  * [5.x](CHANGELOG_V5.md)
  * [4.x](CHANGELOG_V4.md)
  * [0.12.x](CHANGELOG_V012.md)
  * [0.10.x](CHANGELOG_V010.md)
  * [io.js](CHANGELOG_IOJS.md)
  * [Archive](CHANGELOG_ARCHIVE.md)

<a id="10.24.1"></a>

## 2021-04-06, Version 10.24.1 'Dubnium' (LTS), @mylesborins

This is a security release.

### Notable Changes

Vulerabilties fixed:

* **CVE-2021-3450**: OpenSSL - CA certificate check bypass with X509\_V\_FLAG\_X509\_STRICT (High)
  * This is a vulnerability in OpenSSL which may be exploited through Node.js. You can read more about it in <https://www.openssl.org/news/secadv/20210325.txt>
  * Impacts:
    * All versions of the 15.x, 14.x, 12.x and 10.x releases lines
* **CVE-2021-3449**: OpenSSL - NULL pointer deref in signature\_algorithms processing (High)
  * This is a vulnerability in OpenSSL which may be exploited through Node.js. You can read more about it in <https://www.openssl.org/news/secadv/20210325.txt>
  * Impacts:
    * All versions of the 15.x, 14.x, 12.x and 10.x releases lines
* **CVE-2020-7774**: npm upgrade - Update y18n to fix Prototype-Pollution (High)
  * This is a vulnerability in the y18n npm module which may be exploited by prototype pollution. You can read more about it in <https://github.com/advisories/GHSA-c4w7-xm78-47vh>
  * Impacts:
    * All versions of the 14.x, 12.x and 10.x releases lines

### Commits

* \[[`5e526b96ce`](https://github.com/nodejs/node/commit/5e526b96ce)] - **deps**: upgrade npm to 6.14.12 (Ruy Adorno) [#37918](https://github.com/nodejs/node/pull/37918)
* \[[`781cb6df5c`](https://github.com/nodejs/node/commit/781cb6df5c)] - **deps**: update archs files for OpenSSL-1.1.1k (Tobias Nießen) [#37940](https://github.com/nodejs/node/pull/37940)
* \[[`5db0a05a90`](https://github.com/nodejs/node/commit/5db0a05a90)] - **deps**: upgrade openssl sources to 1.1.1k (Tobias Nießen) [#37940](https://github.com/nodejs/node/pull/37940)

<a id="10.24.0"></a>

## 2021-02-23, Version 10.24.0 'Dubnium' (LTS), @richardlau

This is a security release.

### Notable changes

Vulnerabilities fixed:

* **CVE-2021-22883**: HTTP2 'unknownProtocol' cause Denial of Service by resource exhaustion
  * Affected Node.js versions are vulnerable to denial of service attacks when too many connection attempts with an 'unknownProtocol' are established. This leads to a leak of file descriptors. If a file descriptor limit is configured on the system, then the server is unable to accept new connections and prevent the process also from opening, e.g. a file. If no file descriptor limit is configured, then this lead to an excessive memory usage and cause the system to run out of memory.
* **CVE-2021-22884**: DNS rebinding in --inspect
  * Affected Node.js versions are vulnerable to denial of service attacks when the whitelist includes “localhost6”. When “localhost6” is not present in /etc/hosts, it is just an ordinary domain that is resolved via DNS, i.e., over network. If the attacker controls the victim's DNS server or can spoof its responses, the DNS rebinding protection can be bypassed by using the “localhost6” domain. As long as the attacker uses the “localhost6” domain, they can still apply the attack described in CVE-2018-7160.
* **CVE-2021-23840**: OpenSSL - Integer overflow in CipherUpdate
  * This is a vulnerability in OpenSSL which may be exploited through Node.js. You can read more about it in <https://www.openssl.org/news/secadv/20210216.txt>

### Commits

* \[[`0afcb4f6bb`](https://github.com/nodejs/node/commit/0afcb4f6bb)] - **deps**: update archs files for OpenSSL-1.1.1j (Daniel Bevenius) [#37415](https://github.com/nodejs/node/pull/37415)
* \[[`447be941cd`](https://github.com/nodejs/node/commit/447be941cd)] - **deps**: upgrade openssl sources to 1.1.1j (Daniel Bevenius) [#37415](https://github.com/nodejs/node/pull/37415)
* \[[`3f2e9dc40c`](https://github.com/nodejs/node/commit/3f2e9dc40c)] - **(SEMVER-MINOR)** **http2**: add unknownProtocol timeout (Daniel Bevenius) [nodejs-private/node-private#246](https://github.com/nodejs-private/node-private/pull/246)
* \[[`d1cf6a9b0f`](https://github.com/nodejs/node/commit/d1cf6a9b0f)] - **src**: drop localhost6 as allowed host for inspector (Matteo Collina) [nodejs-private/node-private#244](https://github.com/nodejs-private/node-private/pull/244)

<a id="10.23.3"></a>

## 2021-02-09, Version 10.23.3 'Dubnium' (LTS), @richardlau

### Notable changes

The update to npm 6.14.11 has been relanded so that npm correctly reports its version.

### Commits

* \[[`953a85035d`](https://github.com/nodejs/node/commit/953a85035d)] - **crypto**: fix crash when calling digest after piping (Tobias Nießen) [#28251](https://github.com/nodejs/node/pull/28251)
* \[[`fe2c98003e`](https://github.com/nodejs/node/commit/fe2c98003e)] - **deps**: upgrade npm to 6.14.11 (Ruy Adorno) [#37173](https://github.com/nodejs/node/pull/37173)
* \[[`7b7fb43b8a`](https://github.com/nodejs/node/commit/7b7fb43b8a)] - _**Revert**_ "**deps**: upgrade npm to 6.14.11" (Richard Lau) [#37278](https://github.com/nodejs/node/pull/37278)
* \[[`1c6fbd6ffe`](https://github.com/nodejs/node/commit/1c6fbd6ffe)] - **test**: add test that verifies crypto stream pipeline (Evan Lucas) [#37009](https://github.com/nodejs/node/pull/37009)

<a id="10.23.2"></a>

## 2021-01-26, Version 10.23.2 'Dubnium' (LTS), @richardlau

### Notable changes

Release keys have been synchronized with the main branch.

* **deps**:
  * upgrade npm to 6.14.11 (Darcy Clarke) [#36838](https://github.com/nodejs/node/pull/36838)

### Commits

* \[[`cc6b69557a`](https://github.com/nodejs/node/commit/cc6b69557a)] - **deps**: upgrade npm to 6.14.11 (Darcy Clarke) [#36838](https://github.com/nodejs/node/pull/36838)
* \[[`aefb66528a`](https://github.com/nodejs/node/commit/aefb66528a)] - **doc**: update contact information for @BethGriggs (Beth Griggs) [#35451](https://github.com/nodejs/node/pull/35451)
* \[[`08931481d8`](https://github.com/nodejs/node/commit/08931481d8)] - **doc**: update contact information for richardlau (Richard Lau) [#35450](https://github.com/nodejs/node/pull/35450)
* \[[`bc0617f4ea`](https://github.com/nodejs/node/commit/bc0617f4ea)] - **doc**: update release key for Danielle Adams (Danielle Adams) [#36793](https://github.com/nodejs/node/pull/36793)
* \[[`d7c09fcfd3`](https://github.com/nodejs/node/commit/d7c09fcfd3)] - **doc**: add release key for Danielle Adams (Danielle Adams) [#35545](https://github.com/nodejs/node/pull/35545)
* \[[`ac49d415b0`](https://github.com/nodejs/node/commit/ac49d415b0)] - **doc**: add release key for Ruy Adorno (Ruy Adorno) [#34628](https://github.com/nodejs/node/pull/34628)
* \[[`b8426ae3ce`](https://github.com/nodejs/node/commit/b8426ae3ce)] - **doc**: add release key for Richard Lau (Richard Lau) [#34397](https://github.com/nodejs/node/pull/34397)

<a id="10.23.1"></a>

## 2021-01-04, Version 10.23.1 'Dubnium' (LTS), @richardlau

### Notable changes

This is a security release.

Vulnerabilities fixed:

* **CVE-2020-8265**: use-after-free in TLSWrap (High)
  Affected Node.js versions are vulnerable to a use-after-free bug in its
  TLS implementation. When writing to a TLS enabled socket,
  node::StreamBase::Write calls node::TLSWrap::DoWrite with a freshly
  allocated WriteWrap object as first argument. If the DoWrite method does
  not return an error, this object is passed back to the caller as part of
  a StreamWriteResult structure. This may be exploited to corrupt memory
  leading to a Denial of Service or potentially other exploits
* **CVE-2020-8287**: HTTP Request Smuggling in nodejs
  Affected versions of Node.js allow two copies of a header field in a
  http request. For example, two Transfer-Encoding header fields. In this
  case Node.js identifies the first header field and ignores the second.
  This can lead to HTTP Request Smuggling
  (<https://cwe.mitre.org/data/definitions/444.html>).
* **CVE-2020-1971**: OpenSSL - EDIPARTYNAME NULL pointer de-reference (High)
  This is a vulnerability in OpenSSL which may be exploited through Node.js.
  You can read more about it in
  <https://www.openssl.org/news/secadv/20201208.txt>

### Commits

* \[[`bd44b0ee7f`](https://github.com/nodejs/node/commit/bd44b0ee7f)] - **build,win**: accept Python 3 if 2 is not available (João Reis) [#29236](https://github.com/nodejs/node/pull/29236)
* \[[`d5c9b09bdc`](https://github.com/nodejs/node/commit/d5c9b09bdc)] - **build,win**: find Python in paths with spaces (João Reis) [#29236](https://github.com/nodejs/node/pull/29236)
* \[[`323a6f114a`](https://github.com/nodejs/node/commit/323a6f114a)] - **deps**: update http-parser to http-parser\@ec8b5ee63f (Richard Lau) [nodejs-private/node-private#235](https://github.com/nodejs-private/node-private/pull/235)
* \[[`f08d0fef64`](https://github.com/nodejs/node/commit/f08d0fef64)] - **deps**: upgrade npm to 6.14.10 (Ruy Adorno) [#36571](https://github.com/nodejs/node/pull/36571)
* \[[`b0608b574a`](https://github.com/nodejs/node/commit/b0608b574a)] - **deps**: update archs files for OpenSSL-1.1.1i (Richard Lau) [#36541](https://github.com/nodejs/node/pull/36541)
* \[[`d936e1833f`](https://github.com/nodejs/node/commit/d936e1833f)] - **deps**: upgrade openssl sources to 1.1.1i (Myles Borins) [#36541](https://github.com/nodejs/node/pull/36541)
* \[[`9c4970715c`](https://github.com/nodejs/node/commit/9c4970715c)] - **deps**: upgrade npm to 6.14.9 (Myles Borins) [#36450](https://github.com/nodejs/node/pull/36450)
* \[[`aa6b97fb99`](https://github.com/nodejs/node/commit/aa6b97fb99)] - **http**: add test for http transfer encoding smuggling (Richard Lau) [nodejs-private/node-private#235](https://github.com/nodejs-private/node-private/pull/235)
* \[[`fc70ce08f5`](https://github.com/nodejs/node/commit/fc70ce08f5)] - **http**: unset `F_CHUNKED` on new `Transfer-Encoding` (Fedor Indutny) [nodejs-private/node-private#235](https://github.com/nodejs-private/node-private/pull/235)
* \[[`7f178663eb`](https://github.com/nodejs/node/commit/7f178663eb)] - **src**: use unique\_ptr for WriteWrap (Daniel Bevenius) [nodejs-private/node-private#238](https://github.com/nodejs-private/node-private/pull/238)
* \[[`357e2857c8`](https://github.com/nodejs/node/commit/357e2857c8)] - **test**: add test-tls-use-after-free-regression (Daniel Bevenius) [nodejs-private/node-private#238](https://github.com/nodejs-private/node-private/pull/238)

<a id="10.23.0"></a>

## 2020-10-27, Version 10.23.0 'Dubnium' (LTS), @richardlau

### Notable changes

* **deps**:
  * upgrade npm to 6.14.8 (Ruy Adorno) [#34834](https://github.com/nodejs/node/pull/34834)
* **n-api**:
  * create N-API version 7 (Gabriel Schulhof) [#35199](https://github.com/nodejs/node/pull/35199)
  * expose napi\_build\_version variable (NickNaso) [#27835](https://github.com/nodejs/node/pull/27835)
* **tools**:
  * add debug entitlements for macOS 10.15+ (Gabriele Greco) [#34378](https://github.com/nodejs/node/pull/34378)

### Commits

* \[[`b83f9a56fc`](https://github.com/nodejs/node/commit/b83f9a56fc)] - **build**: expose napi\_build\_version variable (NickNaso) [#27835](https://github.com/nodejs/node/pull/27835)
* \[[`020ba1a2b8`](https://github.com/nodejs/node/commit/020ba1a2b8)] - **build**: enable backtrace when V8 is built for PPC and S390x (Michaël Zasso) [#32113](https://github.com/nodejs/node/pull/32113)
* \[[`eee9412a8c`](https://github.com/nodejs/node/commit/eee9412a8c)] - **deps**: upgrade npm to 6.14.8 (Ruy Adorno) [#34834](https://github.com/nodejs/node/pull/34834)
* \[[`038593d5ff`](https://github.com/nodejs/node/commit/038593d5ff)] - **deps**: upgrade npm to 6.14.7 (claudiahdz) [#34468](https://github.com/nodejs/node/pull/34468)
* \[[`3564424625`](https://github.com/nodejs/node/commit/3564424625)] - **deps**: V8: cherry-pick eec10a2fd8fa (Stephen Belanger) [#33778](https://github.com/nodejs/node/pull/33778)
* \[[`e9e86e1b60`](https://github.com/nodejs/node/commit/e9e86e1b60)] - **http2**: support non-empty DATA frame with END\_STREAM flag (Carlos Lopez) [#33875](https://github.com/nodejs/node/pull/33875)
* \[[`751820b6c2`](https://github.com/nodejs/node/commit/751820b6c2)] - **http2,doc**: minor fixes (Alba Mendez) [#28044](https://github.com/nodejs/node/pull/28044)
* \[[`54c2bc2e62`](https://github.com/nodejs/node/commit/54c2bc2e62)] - **(SEMVER-MINOR)** **n-api**: create N-API version 7 (Gabriel Schulhof) [#35199](https://github.com/nodejs/node/pull/35199)
* \[[`2eb627301c`](https://github.com/nodejs/node/commit/2eb627301c)] - **src**: allows escaping NODE\_OPTIONS with backslashes (Maël Nison) [#24065](https://github.com/nodejs/node/pull/24065)
* \[[`5170d14b36`](https://github.com/nodejs/node/commit/5170d14b36)] - **test**: fix test-linux-perf flakiness (Matheus Marchini) [#27615](https://github.com/nodejs/node/pull/27615)
* \[[`21b86d7f19`](https://github.com/nodejs/node/commit/21b86d7f19)] - **test,v8**: skip less and stabilize test-linux-perf.js (Refael Ackermann) [#27364](https://github.com/nodejs/node/pull/27364)
* \[[`ee11ab50a7`](https://github.com/nodejs/node/commit/ee11ab50a7)] - **tools**: add debug entitlements for macOS 10.15+ (Gabriele Greco) [#34378](https://github.com/nodejs/node/pull/34378)

<a id="10.22.1"></a>

## 2020-09-15, Version 10.22.1 'Dubnium' (LTS), @BethGriggs

### Notable changes

This is a security release.

Vulnerabilities fixed:

* **CVE-2020-8252**: fs.realpath.native on may cause buffer overflow (Medium).

### Commits

* \[[`57badcf93e`](https://github.com/nodejs/node/commit/57badcf93e)] - **deps**: libuv: cherry-pick 0e6e8620 (Colin Ihrig) [libuv/libuv#2966](https://github.com/libuv/libuv/pull/2966)

<a id="10.22.0"></a>

## 2020-07-21, Version 10.22.0 'Dubnium' (LTS), @BethGriggs prepared by @richardlau

### Notable changes

* **deps**:
  * upgrade npm to 6.14.6 (claudiahdz) [#34246](https://github.com/nodejs/node/pull/34246)
  * upgrade openssl sources to 1.1.1g (Hassaan Pasha) [#32982](https://github.com/nodejs/node/pull/32982)
* **n-api**:
  * add `napi_detach_arraybuffer` (legendecas) [#29768](https://github.com/nodejs/node/pull/29768)

### Commits

* \[[`9915774d18`](https://github.com/nodejs/node/commit/9915774d18)] - **build**: log detected compilers in --verbose mode (Richard Lau) [#32715](https://github.com/nodejs/node/pull/32715)
* \[[`145dcc2c1c`](https://github.com/nodejs/node/commit/145dcc2c1c)] - **build**: move doc versions JSON file out of out/doc (Richard Lau) [#32728](https://github.com/nodejs/node/pull/32728)
* \[[`24b927ab66`](https://github.com/nodejs/node/commit/24b927ab66)] - **build**: allow clang 10+ in configure.py (Kamil Rytarowski) [#29541](https://github.com/nodejs/node/pull/29541)
* \[[`97b59527c7`](https://github.com/nodejs/node/commit/97b59527c7)] - **deps**: upgrade npm to 6.14.6 (claudiahdz) [#34246](https://github.com/nodejs/node/pull/34246)
* \[[`84fca3c691`](https://github.com/nodejs/node/commit/84fca3c691)] - **deps**: upgrade npm to 6.14.5 (Ruy Adorno) [#33239](https://github.com/nodejs/node/pull/33239)
* \[[`745b329260`](https://github.com/nodejs/node/commit/745b329260)] - **deps**: update archs files for OpenSSL-1.1.1g (Hassaan Pasha) [#32982](https://github.com/nodejs/node/pull/32982)
* \[[`94702c1560`](https://github.com/nodejs/node/commit/94702c1560)] - **deps**: upgrade openssl sources to 1.1.1g (Hassaan Pasha) [#32982](https://github.com/nodejs/node/pull/32982)
* \[[`ef9413be1a`](https://github.com/nodejs/node/commit/ef9413be1a)] - **deps**: upgrade openssl sources to 1.1.1f (Hassaan Pasha) [#32583](https://github.com/nodejs/node/pull/32583)
* \[[`3acc89f8f2`](https://github.com/nodejs/node/commit/3acc89f8f2)] - **deps**: V8: backport cd21f71f9cb5 (Michaël Zasso) [#33862](https://github.com/nodejs/node/pull/33862)
* \[[`89a306bca9`](https://github.com/nodejs/node/commit/89a306bca9)] - **deps**: fix V8 compiler error with clang++-11 (Sam Roberts) [#33094](https://github.com/nodejs/node/pull/33094)
* \[[`00f04e3b79`](https://github.com/nodejs/node/commit/00f04e3b79)] - **doc**: fix quotes in tls.md (Sparsh Garg) [#33641](https://github.com/nodejs/node/pull/33641)
* \[[`193d1d0e84`](https://github.com/nodejs/node/commit/193d1d0e84)] - **doc**: document fs.watchFile() bigint option (cjihrig) [#32128](https://github.com/nodejs/node/pull/32128)
* \[[`5dab101b03`](https://github.com/nodejs/node/commit/5dab101b03)] - **doc,n-api**: mark napi\_detach\_arraybuffer as experimental (legendecas) [#30703](https://github.com/nodejs/node/pull/30703)
* \[[`069b6e14a4`](https://github.com/nodejs/node/commit/069b6e14a4)] - **http**: disable headersTimeout check when set to zero (Paolo Insogna) [#33307](https://github.com/nodejs/node/pull/33307)
* \[[`aaf2f827c6`](https://github.com/nodejs/node/commit/aaf2f827c6)] - **inspector**: more conservative minimum stack size (Ben Noordhuis) [#27855](https://github.com/nodejs/node/pull/27855)
* \[[`b744ffd586`](https://github.com/nodejs/node/commit/b744ffd586)] - **(SEMVER-MINOR)** **n-api**: implement napi\_is\_detached\_arraybuffer (Denys Otrishko) [#30613](https://github.com/nodejs/node/pull/30613)
* \[[`961598b9be`](https://github.com/nodejs/node/commit/961598b9be)] - **(SEMVER-MINOR)** **n-api**: add `napi_detach_arraybuffer` (legendecas) [#29768](https://github.com/nodejs/node/pull/29768)
* \[[`7a109febc4`](https://github.com/nodejs/node/commit/7a109febc4)] - **test**: remove timers-blocking-callback (Jeremiah Senkpiel) [#32870](https://github.com/nodejs/node/pull/32870)
* \[[`3dbd8cd3a9`](https://github.com/nodejs/node/commit/3dbd8cd3a9)] - _**Revert**_ "**test**: mark empty udp tests flaky on OS X" (Luigi Pinca) [#32489](https://github.com/nodejs/node/pull/32489)
* \[[`543656928c`](https://github.com/nodejs/node/commit/543656928c)] - **test**: flaky test-stdout-close-catch on freebsd (Sam Roberts) [#32849](https://github.com/nodejs/node/pull/32849)
* \[[`74b00cca64`](https://github.com/nodejs/node/commit/74b00cca64)] - **tls**: allow empty subject even with altNames defined (Jason Macgowan) [#22906](https://github.com/nodejs/node/pull/22906)

<a id="10.21.0"></a>

## 2020-06-02, Version 10.21.0 'Dubnium' (LTS), @BethGriggs

### Notable changes

This is a security release.

Vulnerabilities fixed:

* **CVE-2020-8174**: napi\_get\_value\_string\_\*() allows various kinds of memory corruption (High).
* **CVE-2020-10531**: ICU-20958 Prevent SEGV\_MAPERR in append (High).
* **CVE-2020-11080**: HTTP/2 Large Settings Frame DoS (Low).

### Commits

* \[[`0ad7970256`](https://github.com/nodejs/node/commit/0ad7970256)] - **deps**: fix OPENSSLDIR on Windows (Shigeki Ohtsu) [#29456](https://github.com/nodejs/node/pull/29456)
* \[[`bd78c6ea46`](https://github.com/nodejs/node/commit/bd78c6ea46)] - **deps**: backport ICU-20958 to fix CVE-2020-10531 (Richard Lau) [#33572](https://github.com/nodejs/node/pull/33572)
* \[[`33e9a12241`](https://github.com/nodejs/node/commit/33e9a12241)] - **(SEMVER-MINOR)** **deps**: update nghttp2 to 1.41.0 (James M Snell) [nodejs-private/node-private#204](https://github.com/nodejs-private/node-private/pull/204)
* \[[`881c244a4e`](https://github.com/nodejs/node/commit/881c244a4e)] - **(SEMVER-MINOR)** **http2**: implement support for max settings entries (James M Snell) [nodejs-private/node-private#204](https://github.com/nodejs-private/node-private/pull/204)
* \[[`cd9827f105`](https://github.com/nodejs/node/commit/cd9827f105)] - **napi**: fix memory corruption vulnerability (Tobias Nießen) [nodejs-private/node-private#203](https://github.com/nodejs-private/node-private/pull/203)

<a id="10.20.1"></a>

## 2020-04-12, Version 10.20.1 'Dubnium' (LTS), @BethGriggs

### Notable changes

Due to release process failures, Node.js v10.20.0 shipped with source
and header tarballs that did not properly match the final release
commit that was used to build the binaries. We recommend that Node.js
v10.20.0 not be used, particularly in any applications using native
add-ons or where compiling Node.js from source is involved.

Node.js v10.20.1 is a clean release with the correct sources and is
strongly recommended in place of v10.20.0.

<a id="10.20.0"></a>

## 2020-04-08, Version 10.20.0 'Dubnium' (LTS), @BethGriggs

### macOS package notarization and a change in builder configuration

The macOS binaries for this release, and future 10.x releases, are now
being compiled on macOS 10.15 (Catalina) with Xcode 11 to support
package notarization, a requirement for installing .pkg files on macOS
10.15 and later. Previous builds of Node.js 10.x were compiled on macOS
10.10 (Yosemite) with a minimum deployment target of macOS 10.7 (Lion).
As binaries are still being compiled to support a minimum of macOS 10.7
(Lion) we do not anticipate this having a negative impact on Node.js
10.x users with older versions of macOS.

### Notable changes

* **buffer**: add {read|write}Big\[U]Int64{BE|LE} methods (garygsc) [#19691](https://github.com/nodejs/node/pull/19691)
* **build**: macOS package notarization (Rod Vagg) [#31459](https://github.com/nodejs/node/pull/31459)
* **deps**:
  * update npm to 6.14.3 (Myles Borins) [#32368](https://github.com/nodejs/node/pull/32368)
  * upgrade openssl sources to 1.1.1e (Hassaan Pasha) [#32328](https://github.com/nodejs/node/pull/32328)
  * upgrade to libuv 1.34.2 (cjihrig) [#31477](https://github.com/nodejs/node/pull/31477)
* **n-api**:
  * add napi\_get\_all\_property\_names (himself65) [#30006](https://github.com/nodejs/node/pull/30006)
  * add APIs for per-instance state management (Gabriel Schulhof) [#28682](https://github.com/nodejs/node/pull/28682)
  * define release 6 [#32058](https://github.com/nodejs/node/pull/32058)
  * turn NAPI\_CALL\_INTO\_MODULE into a function (Anna Henningsen) [#26128](https://github.com/nodejs/node/pull/26128)
* **tls**:
  * expose keylog event on TLSSocket (Alba Mendez) [#27654](https://github.com/nodejs/node/pull/27654)
  * support TLS min/max protocol defaults in CLI (Sam Roberts) [#27946](https://github.com/nodejs/node/pull/27946)
* **url**: handle quasi-WHATWG URLs in urlToOptions() (cjihrig) [#26226](https://github.com/nodejs/node/pull/26226)

### Commits

* \[[`64744a282e`](https://github.com/nodejs/node/commit/64744a282e)] - **(SEMVER-MINOR)** **buffer**: add {read|write}Big\[U]Int64{BE|LE} methods (garygsc) [#19691](https://github.com/nodejs/node/pull/19691)
* \[[`8a0ed8f1ff`](https://github.com/nodejs/node/commit/8a0ed8f1ff)] - **build**: macOS package notarization (Rod Vagg) [#31459](https://github.com/nodejs/node/pull/31459)
* \[[`42af3b861a`](https://github.com/nodejs/node/commit/42af3b861a)] - **build,win**: fix goto exit in vcbuild (João Reis) [#30931](https://github.com/nodejs/node/pull/30931)
* \[[`b164a2e3bf`](https://github.com/nodejs/node/commit/b164a2e3bf)] - **console**: add trace-events for time and count (James M Snell) [#23703](https://github.com/nodejs/node/pull/23703)
* \[[`04cd67f85e`](https://github.com/nodejs/node/commit/04cd67f85e)] - **deps**: upgrade npm to 6.14.4 (Ruy Adorno) [#32495](https://github.com/nodejs/node/pull/32495)
* \[[`8d85a43d99`](https://github.com/nodejs/node/commit/8d85a43d99)] - **deps**: update term-size with signed version (Rod Vagg) [#31459](https://github.com/nodejs/node/pull/31459)
* \[[`76033c5495`](https://github.com/nodejs/node/commit/76033c5495)] - **deps**: update archs files for OpenSSL-1.1.1e (Hassaan Pasha) [#32328](https://github.com/nodejs/node/pull/32328)
* \[[`64c184836b`](https://github.com/nodejs/node/commit/64c184836b)] - **deps**: adjust openssl configuration for 1.1.1e (Hassaan Pasha) [#32328](https://github.com/nodejs/node/pull/32328)
* \[[`c8f5ab2089`](https://github.com/nodejs/node/commit/c8f5ab2089)] - **deps**: upgrade openssl sources to 1.1.1e (Hassaan Pasha) [#32328](https://github.com/nodejs/node/pull/32328)
* \[[`bf26c44c92`](https://github.com/nodejs/node/commit/bf26c44c92)] - **deps**: remove \*.pyc files from deps/npm (Ben Noordhuis) [#32387](https://github.com/nodejs/node/pull/32387)
* \[[`c2b3cf61ce`](https://github.com/nodejs/node/commit/c2b3cf61ce)] - **deps**: update npm to 6.14.3 (Myles Borins) [#32368](https://github.com/nodejs/node/pull/32368)
* \[[`8cae4dde91`](https://github.com/nodejs/node/commit/8cae4dde91)] - **deps**: upgrade npm to 6.14.1 (Isaac Z. Schlueter) [#31977](https://github.com/nodejs/node/pull/31977)
* \[[`47046aa5a9`](https://github.com/nodejs/node/commit/47046aa5a9)] - **deps**: openssl: cherry-pick 4dcb150ea30f (Adam Majer) [#32002](https://github.com/nodejs/node/pull/32002)
* \[[`098704c85d`](https://github.com/nodejs/node/commit/098704c85d)] - **deps**: upgrade to libuv 1.34.2 (Colin Ihrig) [#31477](https://github.com/nodejs/node/pull/31477)
* \[[`4b1cccc4ce`](https://github.com/nodejs/node/commit/4b1cccc4ce)] - **deps**: upgrade to libuv 1.34.1 (Colin Ihrig) [#31332](https://github.com/nodejs/node/pull/31332)
* \[[`fff6162693`](https://github.com/nodejs/node/commit/fff6162693)] - **(SEMVER-MINOR)** **deps**: upgrade to libuv 1.34.0 (Colin Ihrig) [#30783](https://github.com/nodejs/node/pull/30783)
* \[[`6826ef0568`](https://github.com/nodejs/node/commit/6826ef0568)] - **deps**: upgrade to libuv 1.33.1 (Colin Ihrig) [#29996](https://github.com/nodejs/node/pull/29996)
* \[[`aed7ca4fb0`](https://github.com/nodejs/node/commit/aed7ca4fb0)] - **deps**: upgrade to libuv 1.32.0 (Colin Ihrig) [#29508](https://github.com/nodejs/node/pull/29508)
* \[[`794abbc758`](https://github.com/nodejs/node/commit/794abbc758)] - **deps**: upgrade to libuv 1.31.0 (Colin Ihrig) [#29070](https://github.com/nodejs/node/pull/29070)
* \[[`ed71f55a54`](https://github.com/nodejs/node/commit/ed71f55a54)] - **deps**: upgrade to libuv 1.30.1 (Colin Ihrig) [#28511](https://github.com/nodejs/node/pull/28511)
* \[[`7cde563235`](https://github.com/nodejs/node/commit/7cde563235)] - **deps**: upgrade to libuv 1.30.0 (Colin Ihrig) [#28449](https://github.com/nodejs/node/pull/28449)
* \[[`b53ce6e6c5`](https://github.com/nodejs/node/commit/b53ce6e6c5)] - **deps**: upgrade to libuv 1.29.1 (Colin Ihrig) [#27718](https://github.com/nodejs/node/pull/27718)
* \[[`9b2b66b7d8`](https://github.com/nodejs/node/commit/9b2b66b7d8)] - **deps**: V8: cherry-pick d89f4ef1cd62 (Milad Farazmand) [#31753](https://github.com/nodejs/node/pull/31753)
* \[[`7eac95981e`](https://github.com/nodejs/node/commit/7eac95981e)] - **deps**: upgrade npm to 6.13.7 (Michael Perrotte) [#31558](https://github.com/nodejs/node/pull/31558)
* \[[`db24641fbe`](https://github.com/nodejs/node/commit/db24641fbe)] - **deps**: upgrade npm to 6.13.6 (Ruy Adorno) [#31304](https://github.com/nodejs/node/pull/31304)
* \[[`2e3d511cff`](https://github.com/nodejs/node/commit/2e3d511cff)] - **doc**: correct version metadata for Readable.from (Dave Vandyke) [#32639](https://github.com/nodejs/node/pull/32639)
* \[[`34c1c2a82b`](https://github.com/nodejs/node/commit/34c1c2a82b)] - **doc**: add missing version metadata for Readable.from (Anna Henningsen) [#28695](https://github.com/nodejs/node/pull/28695)
* \[[`aa7d369c72`](https://github.com/nodejs/node/commit/aa7d369c72)] - **doc**: update releaser list in README.md (Myles Borins) [#32577](https://github.com/nodejs/node/pull/32577)
* \[[`05f5b3ecc4`](https://github.com/nodejs/node/commit/05f5b3ecc4)] - **doc**: remove em dashes (Rich Trott) [#32080](https://github.com/nodejs/node/pull/32080)
* \[[`ffa9f9bd1b`](https://github.com/nodejs/node/commit/ffa9f9bd1b)] - **doc**: fix changelog for v10.18.1 (Andrew Hughes) [#31358](https://github.com/nodejs/node/pull/31358)
* \[[`0177464b0e`](https://github.com/nodejs/node/commit/0177464b0e)] - **doc,tools**: get altDocs versions from CHANGELOG.md (Richard Lau) [#27661](https://github.com/nodejs/node/pull/27661)
* \[[`e9c590ea00`](https://github.com/nodejs/node/commit/e9c590ea00)] - **(SEMVER-MINOR)** **n-api**: define release 6 (Gabriel Schulhof) [#32058](https://github.com/nodejs/node/pull/32058)
* \[[`239377b654`](https://github.com/nodejs/node/commit/239377b654)] - **(SEMVER-MINOR)** **n-api**: correct instance data tests (Gabriel Schulhof) [#32488](https://github.com/nodejs/node/pull/32488)
* \[[`ecbb331be0`](https://github.com/nodejs/node/commit/ecbb331be0)] - **(SEMVER-MINOR)** **n-api**: add napi\_get\_all\_property\_names (himself65) [#30006](https://github.com/nodejs/node/pull/30006)
* \[[`f29fb14cf6`](https://github.com/nodejs/node/commit/f29fb14cf6)] - **(SEMVER-MINOR)** **n-api**: add APIs for per-instance state management (Gabriel Schulhof) [#28682](https://github.com/nodejs/node/pull/28682)
* \[[`20177b9946`](https://github.com/nodejs/node/commit/20177b9946)] - **n-api**: turn NAPI\_CALL\_INTO\_MODULE into a function (Anna Henningsen) [#26128](https://github.com/nodejs/node/pull/26128)
* \[[`017909b847`](https://github.com/nodejs/node/commit/017909b847)] - **test**: fix tool path in test-doctool-versions.js (Richard Lau) [#32645](https://github.com/nodejs/node/pull/32645)
* \[[`1ea70d641d`](https://github.com/nodejs/node/commit/1ea70d641d)] - **test**: fix flaky doctool and test (Rich Trott) [#29979](https://github.com/nodejs/node/pull/29979)
* \[[`89692ff19b`](https://github.com/nodejs/node/commit/89692ff19b)] - **test**: end tls connection with some data (Sam Roberts) [#32328](https://github.com/nodejs/node/pull/32328)
* \[[`9bd1317764`](https://github.com/nodejs/node/commit/9bd1317764)] - **test**: mark empty udp tests flaky on OS X (Sam Roberts) [#31936](https://github.com/nodejs/node/pull/31936)
* \[[`5484e061b5`](https://github.com/nodejs/node/commit/5484e061b5)] - **test**: scale keepalive timeouts for slow machines (Ben Noordhuis) [#30834](https://github.com/nodejs/node/pull/30834)
* \[[`3f9cec3f51`](https://github.com/nodejs/node/commit/3f9cec3f51)] - **test**: add debugging output to test-net-listen-after-destroy-stdin (Rich Trott) [#31698](https://github.com/nodejs/node/pull/31698)
* \[[`f1a8791316`](https://github.com/nodejs/node/commit/f1a8791316)] - **test**: allow EAI\_FAIL in test-http-dns-error.js (Colin Ihrig) [#27500](https://github.com/nodejs/node/pull/27500)
* \[[`4b9a77909b`](https://github.com/nodejs/node/commit/4b9a77909b)] - **test**: mark tests as flaky (João Reis) [#30848](https://github.com/nodejs/node/pull/30848)
* \[[`a8fd8a1a61`](https://github.com/nodejs/node/commit/a8fd8a1a61)] - **test**: mark http2 tests as flaky on 10.x (AshCripps) [#31887](https://github.com/nodejs/node/pull/31887)
* \[[`2315270cb6`](https://github.com/nodejs/node/commit/2315270cb6)] - **test**: try to stabalize test-child-process-fork-exec-path.js (Refael Ackermann) [#27277](https://github.com/nodejs/node/pull/27277)
* \[[`a2b0e9ef6a`](https://github.com/nodejs/node/commit/a2b0e9ef6a)] - **(SEMVER-MINOR)** **tls**: expose keylog event on TLSSocket (Alba Mendez) [#27654](https://github.com/nodejs/node/pull/27654)
* \[[`1cfb45732a`](https://github.com/nodejs/node/commit/1cfb45732a)] - **(SEMVER-MINOR)** **tls**: support TLS min/max protocol defaults in CLI (Sam Roberts) [#27946](https://github.com/nodejs/node/pull/27946)
* \[[`a175b8d3a7`](https://github.com/nodejs/node/commit/a175b8d3a7)] - **tools**: only fetch previous versions when necessary (Richard Lau) [#32518](https://github.com/nodejs/node/pull/32518)
* \[[`3756be8511`](https://github.com/nodejs/node/commit/3756be8511)] - **tools**: add NODE\_TEST\_NO\_INTERNET to the doc builder (Joyee Cheung) [#31849](https://github.com/nodejs/node/pull/31849)
* \[[`ac1ea7312a`](https://github.com/nodejs/node/commit/ac1ea7312a)] - **tools**: make doctool work if no internet available (Richard Lau) [#30214](https://github.com/nodejs/node/pull/30214)
* \[[`f235eea8b3`](https://github.com/nodejs/node/commit/f235eea8b3)] - **tools**: unify make-v8.sh for ppc64le and s390x (Richard Lau) [#31628](https://github.com/nodejs/node/pull/31628)
* \[[`61e2d4856d`](https://github.com/nodejs/node/commit/61e2d4856d)] - **tools**: use CC instead of CXX when pointing to gcc (Milad Farazmand) [#30817](https://github.com/nodejs/node/pull/30817)
* \[[`4390674624`](https://github.com/nodejs/node/commit/4390674624)] - **url**: handle quasi-WHATWG URLs in urlToOptions() (Colin Ihrig) [#26226](https://github.com/nodejs/node/pull/26226)
* \[[`dc61e09feb`](https://github.com/nodejs/node/commit/dc61e09feb)] - **v8**: fix load elimination liveness checks (Ben Noordhuis) [#31613](https://github.com/nodejs/node/pull/31613)

<a id="10.19.0"></a>

## 2020-02-06, Version 10.19.0 'Dubnium' (LTS), @BethGriggs

### Notable changes

This is a security release.

Vulnerabilities fixed:

* **CVE-2019-15606**: HTTP header values do not have trailing OWS trimmed.
* **CVE-2019-15605**: HTTP request smuggling using malformed Transfer-Encoding header.
* **CVE-2019-15604**: Remotely trigger an assertion on a TLS server with a malformed certificate string.

Also, HTTP parsing is more strict to be more secure. Since this may
cause problems in interoperability with some non-conformant HTTP
implementations, it is possible to disable the strict checks with the
`--insecure-http-parser` command line flag, or the `insecureHTTPParser`
http option. Using the insecure HTTP parser should be avoided.

### Commits

* \[[`f940bee3b7`](https://github.com/nodejs/node/commit/f940bee3b7)] - **crypto**: fix assertion caused by unsupported ext (Fedor Indutny) [nodejs-private/node-private#175](https://github.com/nodejs-private/node-private/pull/175)
* \[[`49f4220ce5`](https://github.com/nodejs/node/commit/49f4220ce5)] - **deps**: upgrade http-parser to v2.9.3 (Sam Roberts) [nodejs-private/http-parser-private#4](https://github.com/nodejs-private/http-parser-private/pull/4)
* \[[`a28e5cc1ed`](https://github.com/nodejs/node/commit/a28e5cc1ed)] - **(SEMVER-MINOR)** **deps**: upgrade http-parser to v2.9.1 (Sam Roberts) [#30471](https://github.com/nodejs/node/pull/30471)
* \[[`0082f62d9c`](https://github.com/nodejs/node/commit/0082f62d9c)] - **(SEMVER-MINOR)** **http**: make --insecure-http-parser configurable per-stream or per-server (Anna Henningsen) [#31448](https://github.com/nodejs/node/pull/31448)
* \[[`a9849c0ff6`](https://github.com/nodejs/node/commit/a9849c0ff6)] - **(SEMVER-MINOR)** **http**: opt-in insecure HTTP header parsing (Sam Roberts) [#30567](https://github.com/nodejs/node/pull/30567)
* \[[`2eee90e959`](https://github.com/nodejs/node/commit/2eee90e959)] - **http**: strip trailing OWS from header values (Sam Roberts) [nodejs-private/node-private#191](https://github.com/nodejs-private/node-private/pull/191)
* \[[`e2c8f89b75`](https://github.com/nodejs/node/commit/e2c8f89b75)] - **test**: using TE to smuggle reqs is not possible (Sam Roberts) [nodejs-private/node-private#192](https://github.com/nodejs-private/node-private/pull/192)
* \[[`d616722f65`](https://github.com/nodejs/node/commit/d616722f65)] - **test**: check that --insecure-http-parser works (Sam Roberts) [#31253](https://github.com/nodejs/node/pull/31253)

<a id="10.18.1"></a>

## 2020-01-09, Version 10.18.1 'Dubnium' (LTS), @BethGriggs

### Notable changes

* **http2**: fix session memory accounting after pausing (Michael Lehenbauer) [#30684](https://github.com/nodejs/node/pull/30684)
* **n-api**: correct bug in napi\_get\_last\_error (Octavian Soldea) [#28702](https://github.com/nodejs/node/pull/28702)
* **tools**: update tzdata to 2019c (Myles Borins) [#30479](https://github.com/nodejs/node/pull/30479)

### Commits

* \[[`a80c59130e`](https://github.com/nodejs/node/commit/a80c59130e)] - **build**: fix configure script to work with Apple Clang 11 (Saagar Jha) [#28071](https://github.com/nodejs/node/pull/28071)
* \[[`68b2b5cc51`](https://github.com/nodejs/node/commit/68b2b5cc51)] - **build,win**: propagate error codes in vcbuild (João Reis) [#30724](https://github.com/nodejs/node/pull/30724)
* \[[`3e0709cf5e`](https://github.com/nodejs/node/commit/3e0709cf5e)] - **deps**: V8: backport fb63e5cf55e9 (Michaël Zasso) [#30372](https://github.com/nodejs/node/pull/30372)
* \[[`25b8fbda35`](https://github.com/nodejs/node/commit/25b8fbda35)] - **doc**: allow \<code> in header elements (Rich Trott) [#31086](https://github.com/nodejs/node/pull/31086)
* \[[`a1b095dd46`](https://github.com/nodejs/node/commit/a1b095dd46)] - **doc,dns**: use code markup/markdown in headers (Rich Trott) [#31086](https://github.com/nodejs/node/pull/31086)
* \[[`8f3b8ca515`](https://github.com/nodejs/node/commit/8f3b8ca515)] - **http2**: fix session memory accounting after pausing (Michael Lehenbauer) [#30684](https://github.com/nodejs/node/pull/30684)
* \[[`20f64a96de`](https://github.com/nodejs/node/commit/20f64a96de)] - **http2**: use the latest settings (ZYSzys) [#29780](https://github.com/nodejs/node/pull/29780)
* \[[`81c31005fd`](https://github.com/nodejs/node/commit/81c31005fd)] - **lib**: fix comment nits in bootstrap\loaders.js (Vse Mozhet Byt) [#24641](https://github.com/nodejs/node/pull/24641)
* \[[`88e8b7cf83`](https://github.com/nodejs/node/commit/88e8b7cf83)] - **n-api**: correct bug in napi\_get\_last\_error (Octavian Soldea) [#28702](https://github.com/nodejs/node/pull/28702)
* \[[`77e0318849`](https://github.com/nodejs/node/commit/77e0318849)] - **stream**: increase MAX\_HWM (Robert Nagy) [#29938](https://github.com/nodejs/node/pull/29938)
* \[[`894aaa2040`](https://github.com/nodejs/node/commit/894aaa2040)] - **stream**: extract Readable.from in its own file (Matteo Collina) [#30140](https://github.com/nodejs/node/pull/30140)
* \[[`7e941eb17d`](https://github.com/nodejs/node/commit/7e941eb17d)] - **test**: do not fail SLOW tests if they are not slow (Yang Guo) [#25868](https://github.com/nodejs/node/pull/25868)
* \[[`0f3ae77aaf`](https://github.com/nodejs/node/commit/0f3ae77aaf)] - **tools**: update tzdata to 2019c (Myles Borins) [#30479](https://github.com/nodejs/node/pull/30479)
* \[[`4ae8d204cb`](https://github.com/nodejs/node/commit/4ae8d204cb)] - **tools**: move python code out of jenkins shell (Sam Roberts) [#28458](https://github.com/nodejs/node/pull/28458)
* \[[`4879b80d87`](https://github.com/nodejs/node/commit/4879b80d87)] - **tools**: fix v8 testing with devtoolset on ppcle (Sam Roberts) [#28458](https://github.com/nodejs/node/pull/28458)

<a id="10.18.0"></a>

## 2019-12-17, Version 10.18.0 'Dubnium' (LTS), @MylesBorins

This is a security release.

For more details about the vulnerability please consult the npm blog:

<https://blog.npmjs.org/post/189618601100/binary-planting-with-the-npm-cli>

### Notable changes

* **deps**: update npm to 6.13.4 [#30904](https://github.com/nodejs/node/pull/30904)

### Commits

* \[[`54a466a865`](https://github.com/nodejs/node/commit/54a466a865)] - **build,win**: add test-ci-native and test-ci-js (João Reis) [#30724](https://github.com/nodejs/node/pull/30724)
* \[[`f9b31edb25`](https://github.com/nodejs/node/commit/f9b31edb25)] - **deps**: update npm to 6.13.4 (Isaac Z. Schlueter) [#30904](https://github.com/nodejs/node/pull/30904)

<a id="10.17.0"></a>

## 2019-10-22, Version 10.17.0 'Dubnium' (LTS), @BethGriggs

### Notable changes

* **crypto**:
  * add support for chacha20-poly1305 for AEAD (chux0519) [#24081](https://github.com/nodejs/node/pull/24081)
  * increase maxmem range from 32 to 53 bits (Tobias Nießen) [#28799](https://github.com/nodejs/node/pull/28799)
* **deps**:
  * update npm to 6.11.3 (claudiahdz) [#29430](https://github.com/nodejs/node/pull/29430)
  * upgrade openssl sources to 1.1.1d (Sam Roberts) [#29921](https://github.com/nodejs/node/pull/29921)
* **dns**: remove dns.promises experimental warning (cjihrig) [#26592](https://github.com/nodejs/node/pull/26592)
* **fs**: remove experimental warning for fs.promises (Anna Henningsen) [#26581](https://github.com/nodejs/node/pull/26581)
* **http**: makes response.writeHead return the response (Mark S. Everitt) [#25974](https://github.com/nodejs/node/pull/25974)
* **http2**: makes response.writeHead return the response (Mark S. Everitt) [#25974](https://github.com/nodejs/node/pull/25974)
* **n-api**:
  * make func argument of napi\_create\_threadsafe\_function optional (legendecas) [#27791](https://github.com/nodejs/node/pull/27791)
  * mark version 5 N-APIs as stable (Gabriel Schulhof) [#29401](https://github.com/nodejs/node/pull/29401)
  * implement date object (Jarrod Connolly) [#25917](https://github.com/nodejs/node/pull/25917)
* **process**: add --unhandled-rejections flag (Ruben Bridgewater) [#26599](https://github.com/nodejs/node/pull/26599)
* **stream**:
  * implement Readable.from async iterator utility (Guy Bedford) [#27660](https://github.com/nodejs/node/pull/27660)
  * make Symbol.asyncIterator support stable (Matteo Collina) [#26989](https://github.com/nodejs/node/pull/26989)

### Commits

* \[[`f1a5a36961`](https://github.com/nodejs/node/commit/f1a5a36961)] - **build**: update Windows icon to Feb 2016 rebrand (Mike MacCana) [#28524](https://github.com/nodejs/node/pull/28524)
* \[[`63de2ade85`](https://github.com/nodejs/node/commit/63de2ade85)] - **(SEMVER-MINOR)** **crypto**: add support for chacha20-poly1305 for AEAD (chux0519) [#24081](https://github.com/nodejs/node/pull/24081)
* \[[`4f0f12c3d6`](https://github.com/nodejs/node/commit/4f0f12c3d6)] - **crypto**: fix rsa key gen with non-default exponent (Sam Roberts) [#27092](https://github.com/nodejs/node/pull/27092)
* \[[`7735824d2c`](https://github.com/nodejs/node/commit/7735824d2c)] - **(SEMVER-MINOR)** **crypto**: increase maxmem range from 32 to 53 bits (Tobias Nießen) [#28799](https://github.com/nodejs/node/pull/28799)
* \[[`e53dbba6bc`](https://github.com/nodejs/node/commit/e53dbba6bc)] - **deps**: update npm to 6.11.3 (claudiahdz) [#29430](https://github.com/nodejs/node/pull/29430)
* \[[`55cd01c5c3`](https://github.com/nodejs/node/commit/55cd01c5c3)] - **(SEMVER-MINOR)** **deps**: update npm to 6.10.3 (isaacs) [#29023](https://github.com/nodejs/node/pull/29023)
* \[[`e2291cf805`](https://github.com/nodejs/node/commit/e2291cf805)] - **deps**: upgrade npm to 6.10.2 (isaacs) [#28853](https://github.com/nodejs/node/pull/28853)
* \[[`03b69660f9`](https://github.com/nodejs/node/commit/03b69660f9)] - **deps**: upgrade npm to 6.10.0 (isaacs) [#28525](https://github.com/nodejs/node/pull/28525)
* \[[`333963ef73`](https://github.com/nodejs/node/commit/333963ef73)] - **deps**: dlloads node static linked executable (Luca Lindhorst) [#28045](https://github.com/nodejs/node/pull/28045)
* \[[`7202792ad3`](https://github.com/nodejs/node/commit/7202792ad3)] - **deps**: update archs files for OpenSSL-1.1.1d (Sam Roberts) [#29921](https://github.com/nodejs/node/pull/29921)
* \[[`9c393f1d02`](https://github.com/nodejs/node/commit/9c393f1d02)] - **deps**: upgrade openssl sources to 1.1.1d (Sam Roberts) [#29921](https://github.com/nodejs/node/pull/29921)
* \[[`7f48519413`](https://github.com/nodejs/node/commit/7f48519413)] - **deps**: do not link against librt (Sam Roberts) [#29729](https://github.com/nodejs/node/pull/29729)
* \[[`fcc22d31a0`](https://github.com/nodejs/node/commit/fcc22d31a0)] - **(SEMVER-MINOR)** **dns**: make dns.promises enumerable (cjihrig) [#26592](https://github.com/nodejs/node/pull/26592)
* \[[`fa27aac5fb`](https://github.com/nodejs/node/commit/fa27aac5fb)] - **(SEMVER-MINOR)** **dns**: remove dns.promises experimental warning (cjihrig) [#26592](https://github.com/nodejs/node/pull/26592)
* \[[`90fb146933`](https://github.com/nodejs/node/commit/90fb146933)] - **(SEMVER-MINOR)** **doc**: move dns.promises to stable status (cjihrig) [#26592](https://github.com/nodejs/node/pull/26592)
* \[[`65e68d1f4f`](https://github.com/nodejs/node/commit/65e68d1f4f)] - **doc**: add documentation for stream readableFlowing (Chetan Karande) [#29506](https://github.com/nodejs/node/pull/29506)
* \[[`c285e694e2`](https://github.com/nodejs/node/commit/c285e694e2)] - **doc**: fix the links tls default version sections (Chetan Karande) [#28827](https://github.com/nodejs/node/pull/28827)
* \[[`cef5010135`](https://github.com/nodejs/node/commit/cef5010135)] - **doc**: describe tls.DEFAULT\_MIN\_VERSION/\_MAX\_VERSION (Chetan Karande) [#28827](https://github.com/nodejs/node/pull/28827)
* \[[`15c2eb0e58`](https://github.com/nodejs/node/commit/15c2eb0e58)] - **doc**: update N-API version matrix (Gabriel Schulhof) [#29461](https://github.com/nodejs/node/pull/29461)
* \[[`a3eda2896d`](https://github.com/nodejs/node/commit/a3eda2896d)] - **doc**: fixup changelog for v10.16.3 (Andrew Hughes) [#29159](https://github.com/nodejs/node/pull/29159)
* \[[`56a834a53f`](https://github.com/nodejs/node/commit/56a834a53f)] - **doc,test**: clarify that Http2Stream is destroyed after data is read (Alba Mendez) [#27891](https://github.com/nodejs/node/pull/27891)
* \[[`85ce8ef19a`](https://github.com/nodejs/node/commit/85ce8ef19a)] - **(SEMVER-MINOR)** **fs**: remove experimental warning for fs.promises (Anna Henningsen) [#26581](https://github.com/nodejs/node/pull/26581)
* \[[`ccf2823f83`](https://github.com/nodejs/node/commit/ccf2823f83)] - **(SEMVER-MINOR)** **http**: makes response.writeHead return the response (Mark S. Everitt) [#25974](https://github.com/nodejs/node/pull/25974)
* \[[`66387cd45e`](https://github.com/nodejs/node/commit/66387cd45e)] - **http2**: send out pending data earlier (Anna Henningsen) [#29398](https://github.com/nodejs/node/pull/29398)
* \[[`925849650b`](https://github.com/nodejs/node/commit/925849650b)] - **(SEMVER-MINOR)** **http2**: makes response.writeHead return the response (Mark S. Everitt) [#25974](https://github.com/nodejs/node/pull/25974)
* \[[`69b0212df3`](https://github.com/nodejs/node/commit/69b0212df3)] - **http2**: do not start reading after write if new write is on wire (Anna Henningsen) [#29399](https://github.com/nodejs/node/pull/29399)
* \[[`36a0e9a063`](https://github.com/nodejs/node/commit/36a0e9a063)] - **http2**: do not crash on stream listener removal w/ destroyed session (Anna Henningsen) [#29459](https://github.com/nodejs/node/pull/29459)
* \[[`c74c6a5ccf`](https://github.com/nodejs/node/commit/c74c6a5ccf)] - **n-api**: mark version 5 N-APIs as stable (Gabriel Schulhof) [#29401](https://github.com/nodejs/node/pull/29401)
* \[[`f8622762e3`](https://github.com/nodejs/node/commit/f8622762e3)] - **(SEMVER-MINOR)** **n-api**: make func argument of napi\_create\_threadsafe\_function optional (legendecas) [#27791](https://github.com/nodejs/node/pull/27791)
* \[[`4f41e4f471`](https://github.com/nodejs/node/commit/4f41e4f471)] - **(SEMVER-MINOR)** **n-api**: implement date object (Jarrod Connolly) [#25917](https://github.com/nodejs/node/pull/25917)
* \[[`69bf5b7944`](https://github.com/nodejs/node/commit/69bf5b7944)] - **net**: treat ENOTCONN at shutdown as success (Anna Henningsen) [#29912](https://github.com/nodejs/node/pull/29912)
* \[[`d6c998a478`](https://github.com/nodejs/node/commit/d6c998a478)] - **process**: use public readableFlowing property (Chetan Karande) [#29502](https://github.com/nodejs/node/pull/29502)
* \[[`b43d7e8f42`](https://github.com/nodejs/node/commit/b43d7e8f42)] - **(SEMVER-MINOR)** **process**: add --unhandled-rejections flag (Ruben Bridgewater) [#26599](https://github.com/nodejs/node/pull/26599)
* \[[`79f3844fb0`](https://github.com/nodejs/node/commit/79f3844fb0)] - **(SEMVER-MINOR)** **readline**: make Symbol.asyncIterator support stable (Matteo Collina) [#26989](https://github.com/nodejs/node/pull/26989)
* \[[`18b140ae75`](https://github.com/nodejs/node/commit/18b140ae75)] - **src**: use maybe version v8::Function::Call (Ouyang Yadong) [#23826](https://github.com/nodejs/node/pull/23826)
* \[[`1bb5102999`](https://github.com/nodejs/node/commit/1bb5102999)] - **src**: use more explicit return type in Sign::SignFinal() (Anna Henningsen) [#23779](https://github.com/nodejs/node/pull/23779)
* \[[`859d47593e`](https://github.com/nodejs/node/commit/859d47593e)] - **src**: reduce platform worker barrier lifetime (Ali Ijaz Sheikh) [#23419](https://github.com/nodejs/node/pull/23419)
* \[[`00831f0293`](https://github.com/nodejs/node/commit/00831f0293)] - **(SEMVER-MINOR)** **stream**: make Symbol.asyncIterator support stable (Matteo Collina) [#26989](https://github.com/nodejs/node/pull/26989)
* \[[`ddb5152e9b`](https://github.com/nodejs/node/commit/ddb5152e9b)] - **(SEMVER-MINOR)** **stream**: implement Readable.from async iterator utility (Guy Bedford) [#27660](https://github.com/nodejs/node/pull/27660)
* \[[`13d8549abd`](https://github.com/nodejs/node/commit/13d8549abd)] - **test**: well-defined DH groups now verify clean (Sam Roberts) [#29550](https://github.com/nodejs/node/pull/29550)
* \[[`f78ecc3f93`](https://github.com/nodejs/node/commit/f78ecc3f93)] - **test**: fix race in test-http2-origin (Alba Mendez) [#28903](https://github.com/nodejs/node/pull/28903)
* \[[`2afbb3efab`](https://github.com/nodejs/node/commit/2afbb3efab)] - **test,win**: cleanup exec-timeout processes (João Reis) [#28723](https://github.com/nodejs/node/pull/28723)
* \[[`fe58bca878`](https://github.com/nodejs/node/commit/fe58bca878)] - **tls**: group chunks into TLS segments (Alba Mendez) [#27861](https://github.com/nodejs/node/pull/27861)
* \[[`2eae030a4b`](https://github.com/nodejs/node/commit/2eae030a4b)] - **(SEMVER-MINOR)** **worker**: add missing return value in case of fatal exceptions (Ruben Bridgewater) [#29036](https://github.com/nodejs/node/pull/29036)
* \[[`e8c90bf4d1`](https://github.com/nodejs/node/commit/e8c90bf4d1)] - **zlib**: do not coalesce multiple `.flush()` calls (Anna Henningsen) [#28520](https://github.com/nodejs/node/pull/28520)

<a id="10.16.3"></a>

## 2019-08-15, Version 10.16.3 'Dubnium' (LTS), @BethGriggs

### Notable changes

This is a security release.

Node.js, as well as many other implementations of HTTP/2, have been found
vulnerable to Denial of Service attacks.
See <https://github.com/Netflix/security-bulletins/blob/master/advisories/third-party/2019-002.md>
for more information.

Vulnerabilities fixed:

* **CVE-2019-9511 “Data Dribble”**: The attacker requests a large amount of data from a specified resource over multiple streams. They manipulate window size and stream priority to force the server to queue the data in 1-byte chunks. Depending on how efficiently this data is queued, this can consume excess CPU, memory, or both, potentially leading to a denial of service.
* **CVE-2019-9512 “Ping Flood”**: The attacker sends continual pings to an HTTP/2 peer, causing the peer to build an internal queue of responses. Depending on how efficiently this data is queued, this can consume excess CPU, memory, or both, potentially leading to a denial of service.
* **CVE-2019-9513 “Resource Loop”**: The attacker creates multiple request streams and continually shuffles the priority of the streams in a way that causes substantial churn to the priority tree. This can consume excess CPU, potentially leading to a denial of service.
* **CVE-2019-9514 “Reset Flood”**: The attacker opens a number of streams and sends an invalid request over each stream that should solicit a stream of RST\_STREAM frames from the peer. Depending on how the peer queues the RST\_STREAM frames, this can consume excess memory, CPU, or both, potentially leading to a denial of service.
* **CVE-2019-9515 “Settings Flood”**: The attacker sends a stream of SETTINGS frames to the peer. Since the RFC requires that the peer reply with one acknowledgement per SETTINGS frame, an empty SETTINGS frame is almost equivalent in behavior to a ping. Depending on how efficiently this data is queued, this can consume excess CPU, memory, or both, potentially leading to a denial of service.
* **CVE-2019-9516 “0-Length Headers Leak”**: The attacker sends a stream of headers with a 0-length header name and 0-length header value, optionally Huffman encoded into 1-byte or greater headers. Some implementations allocate memory for these headers and keep the allocation alive until the session dies. This can consume excess memory, potentially leading to a denial of service.
* **CVE-2019-9517 “Internal Data Buffering”**: The attacker opens the HTTP/2 window so the peer can send without constraint; however, they leave the TCP window closed so the peer cannot actually write (many of) the bytes on the wire. The attacker then sends a stream of requests for a large response object. Depending on how the servers queue the responses, this can consume excess memory, CPU, or both, potentially leading to a denial of service.
* **CVE-2019-9518 “Empty Frames Flood”**: The attacker sends a stream of frames with an empty payload and without the end-of-stream flag. These frames can be DATA, HEADERS, CONTINUATION and/or PUSH\_PROMISE. The peer spends time processing each frame disproportionate to attack bandwidth. This can consume excess CPU, potentially leading to a denial of service. (Discovered by Piotr Sikora of Google)

### Commits

* \[[`74507fae34`](https://github.com/nodejs/node/commit/74507fae34)] - **deps**: update nghttp2 to 1.39.2 (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`a397c881ec`](https://github.com/nodejs/node/commit/a397c881ec)] - **deps**: update nghttp2 to 1.39.1 (gengjiawen) [#28448](https://github.com/nodejs/node/pull/28448)
* \[[`fedfa12a33`](https://github.com/nodejs/node/commit/fedfa12a33)] - **deps**: update nghttp2 to 1.38.0 (gengjiawen) [#27295](https://github.com/nodejs/node/pull/27295)
* \[[`ab0f2ace36`](https://github.com/nodejs/node/commit/ab0f2ace36)] - **deps**: update nghttp2 to 1.37.0 (gengjiawen) [#26990](https://github.com/nodejs/node/pull/26990)
* \[[`0acbe05ee2`](https://github.com/nodejs/node/commit/0acbe05ee2)] - **http2**: allow security revert for Ping/Settings Flood (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`c152449012`](https://github.com/nodejs/node/commit/c152449012)] - **http2**: pause input processing if sending output (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`0ce699c7b1`](https://github.com/nodejs/node/commit/0ce699c7b1)] - **http2**: stop reading from socket if writes are in progress (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`17357d37a9`](https://github.com/nodejs/node/commit/17357d37a9)] - **http2**: consider 0-length non-end DATA frames an error (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`460f896c63`](https://github.com/nodejs/node/commit/460f896c63)] - **http2**: shrink default `vector::reserve()` allocations (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`f4242e24f9`](https://github.com/nodejs/node/commit/f4242e24f9)] - **http2**: handle 0-length headers better (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`477461a51f`](https://github.com/nodejs/node/commit/477461a51f)] - **http2**: limit number of invalid incoming frames (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`05dada46ee`](https://github.com/nodejs/node/commit/05dada46ee)] - **http2**: limit number of rejected stream openings (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`7f11465572`](https://github.com/nodejs/node/commit/7f11465572)] - **http2**: do not create ArrayBuffers when no DATA received (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`2eb914ff5f`](https://github.com/nodejs/node/commit/2eb914ff5f)] - **http2**: only call into JS when necessary for session events (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`76a7ada15d`](https://github.com/nodejs/node/commit/76a7ada15d)] - **http2**: improve JS-side debug logging (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)
* \[[`00f153da13`](https://github.com/nodejs/node/commit/00f153da13)] - **http2**: improve http2 code a bit (James M Snell) [#23984](https://github.com/nodejs/node/pull/23984)
* \[[`a0a14c809f`](https://github.com/nodejs/node/commit/a0a14c809f)] - **src**: pass along errors from http2 object creation (Anna Henningsen) [#25822](https://github.com/nodejs/node/pull/25822)
* \[[`d85e4006ab`](https://github.com/nodejs/node/commit/d85e4006ab)] - **test**: apply test-http2-max-session-memory-leak from v12.x (Anna Henningsen) [#29122](https://github.com/nodejs/node/pull/29122)

<a id="10.16.2"></a>

## 2019-08-06, Version 10.16.2 'Dubnium' (LTS), @BethGriggs

### Notable changes

This release patches a [regression](https://github.com/nodejs/node/issues/28932) in the OpenSSL upgrade to 1.1.1c that causes intermittent hangs in machines that have low entropy.

### Commits

* \[[`894a9dd230`](https://github.com/nodejs/node/commit/894a9dd230)] - **deps**: cherry-pick c19c5a6 from openssl upstream (Ali Ijaz Sheikh) [#28983](https://github.com/nodejs/node/pull/28983)

<a id="10.16.1"></a>

## 2019-07-31, Version 10.16.1 'Dubnium' (LTS), @BethGriggs

### Notable changes

* **deps**: upgrade openssl sources to 1.1.1c (Sam Roberts) [#28212](https://github.com/nodejs/node/pull/28212)
* **stream**: do not unconditionally call `_read()` on `resume()` (Anna Henningsen) [#26965](https://github.com/nodejs/node/pull/26965)
* **worker**: fix nullptr deref after MessagePort deser failure (Anna Henningsen) [#25076](https://github.com/nodejs/node/pull/25076)

### Commits

* \[[`65ef26fdcb`](https://github.com/nodejs/node/commit/65ef26fdcb)] - **async\_hooks**: avoid double-destroy HTTPParser (Gerhard Stoebich) [#27477](https://github.com/nodejs/node/pull/27477)
* \[[`8f5d6cf5f5`](https://github.com/nodejs/node/commit/8f5d6cf5f5)] - **deps**: update archs files for OpenSSL-1.1.1c (Sam Roberts) [#28212](https://github.com/nodejs/node/pull/28212)
* \[[`9e62852724`](https://github.com/nodejs/node/commit/9e62852724)] - **deps**: upgrade openssl sources to 1.1.1c (Sam Roberts) [#28212](https://github.com/nodejs/node/pull/28212)
* \[[`c59e0c256d`](https://github.com/nodejs/node/commit/c59e0c256d)] - **deps**: updated openssl upgrade instructions (Sam Roberts) [#28212](https://github.com/nodejs/node/pull/28212)
* \[[`609d2b9ea4`](https://github.com/nodejs/node/commit/609d2b9ea4)] - **deps**: V8: backport f27ac28 (Michaël Zasso) [#28061](https://github.com/nodejs/node/pull/28061)
* \[[`8f780e8f99`](https://github.com/nodejs/node/commit/8f780e8f99)] - **deps**: cherry-pick 88f8fe1 from upstream V8 (Yang Guo) [#24514](https://github.com/nodejs/node/pull/24514)
* \[[`ad588eb5fc`](https://github.com/nodejs/node/commit/ad588eb5fc)] - **doc**: adjust TOC margins (Roman Reiss) [#28075](https://github.com/nodejs/node/pull/28075)
* \[[`b3d8a1b1d0`](https://github.com/nodejs/node/commit/b3d8a1b1d0)] - **doc**: add missing changes entry (Ruben Bridgewater) [#24758](https://github.com/nodejs/node/pull/24758)
* \[[`819a647d8f`](https://github.com/nodejs/node/commit/819a647d8f)] - **esm**: fix esm load bug (ZYSzys) [#25491](https://github.com/nodejs/node/pull/25491)
* \[[`f34bb968c4`](https://github.com/nodejs/node/commit/f34bb968c4)] - **process**: make stdout and stderr emit 'close' on destroy (Matteo Collina) [#26691](https://github.com/nodejs/node/pull/26691)
* \[[`0339fba1bb`](https://github.com/nodejs/node/commit/0339fba1bb)] - **src**: handle empty Maybe in uv binding initialize (Anna Henningsen) [#25079](https://github.com/nodejs/node/pull/25079)
* \[[`f9e8e8856a`](https://github.com/nodejs/node/commit/f9e8e8856a)] - **src**: fix Get() usage in tls\_wrap.cc (cjihrig) [#24060](https://github.com/nodejs/node/pull/24060)
* \[[`b689008dea`](https://github.com/nodejs/node/commit/b689008dea)] - **src**: in-source comments and minor TLS cleanups (Sam Roberts) [#25713](https://github.com/nodejs/node/pull/25713)
* \[[`76af23a32b`](https://github.com/nodejs/node/commit/76af23a32b)] - **src**: remove internalBinding('config').warningFile (Joyee Cheung) [#24959](https://github.com/nodejs/node/pull/24959)
* \[[`b7dbc1c537`](https://github.com/nodejs/node/commit/b7dbc1c537)] - **src**: fix warning in cares\_wrap.cc (cjihrig) [#25230](https://github.com/nodejs/node/pull/25230)
* \[[`a8f78f02cb`](https://github.com/nodejs/node/commit/a8f78f02cb)] - **src**: fulfill Maybe contract in InlineDecoder (Anna Henningsen) [#25140](https://github.com/nodejs/node/pull/25140)
* \[[`0dee607409`](https://github.com/nodejs/node/commit/0dee607409)] - **src**: extract common Bind method (Jon Moss) [#22315](https://github.com/nodejs/node/pull/22315)
* \[[`08a32fbf57`](https://github.com/nodejs/node/commit/08a32fbf57)] - **src**: elevate v8 namespaces for node\_process.cc (Jayasankar) [#24578](https://github.com/nodejs/node/pull/24578)
* \[[`f3841c6750`](https://github.com/nodejs/node/commit/f3841c6750)] - **stream**: convert existing buffer when calling .setEncoding (Anna Henningsen) [#27936](https://github.com/nodejs/node/pull/27936)
* \[[`274b97c4ea`](https://github.com/nodejs/node/commit/274b97c4ea)] - **stream**: do not unconditionally call `_read()` on `resume()` (Anna Henningsen) [#26965](https://github.com/nodejs/node/pull/26965)
* \[[`044e753aaf`](https://github.com/nodejs/node/commit/044e753aaf)] - **stream**: make \_read() be called indefinitely if the user wants so (Matteo Collina) [#26135](https://github.com/nodejs/node/pull/26135)
* \[[`f332265cda`](https://github.com/nodejs/node/commit/f332265cda)] - **test**: remove `util.inherits()` usage (ZYSzys) [#25245](https://github.com/nodejs/node/pull/25245)
* \[[`ada0ed55d1`](https://github.com/nodejs/node/commit/ada0ed55d1)] - **test**: fix pty test hangs on aix (Ben Noordhuis) [#28600](https://github.com/nodejs/node/pull/28600)
* \[[`2ae99160e5`](https://github.com/nodejs/node/commit/2ae99160e5)] - **test**: skip stringbytes-external-exceed-max on AIX (Sam Roberts) [#28516](https://github.com/nodejs/node/pull/28516)
* \[[`39637cb95f`](https://github.com/nodejs/node/commit/39637cb95f)] - **test**: skip tests related to CI failures on AIX (Sam Roberts) [#28469](https://github.com/nodejs/node/pull/28469)
* \[[`35be08a16f`](https://github.com/nodejs/node/commit/35be08a16f)] - **test**: clean up build files (Gabriel Schulhof) [#28297](https://github.com/nodejs/node/pull/28297)
* \[[`cc3ca08046`](https://github.com/nodejs/node/commit/cc3ca08046)] - **test**: clearing require cache crashes esm loader (Antoine du HAMEL) [#25491](https://github.com/nodejs/node/pull/25491)
* \[[`75052cadaa`](https://github.com/nodejs/node/commit/75052cadaa)] - **tls**: add debugging to native TLS code (Anna Henningsen) [#26843](https://github.com/nodejs/node/pull/26843)
* \[[`99dad28ebf`](https://github.com/nodejs/node/commit/99dad28ebf)] - **tls**: add CHECK for impossible condition (Anna Henningsen) [#26843](https://github.com/nodejs/node/pull/26843)
* \[[`5ffe04753e`](https://github.com/nodejs/node/commit/5ffe04753e)] - **tls**: renegotiate should take care of its own state (Sam Roberts) [#25997](https://github.com/nodejs/node/pull/25997)
* \[[`4a607fab49`](https://github.com/nodejs/node/commit/4a607fab49)] - **tools**: replace rollup with ncc (Rich Trott) [#24813](https://github.com/nodejs/node/pull/24813)
* \[[`14090b59fc`](https://github.com/nodejs/node/commit/14090b59fc)] - **worker**: fix nullptr deref after MessagePort deser failure (Anna Henningsen) [#25076](https://github.com/nodejs/node/pull/25076)

<a id="10.16.0"></a>

## 2019-05-28, Version 10.16.0 'Dubnium' (LTS), @BethGriggs

### Notable Changes

* **deps**:
  * update ICU to 64.2 (Ujjwal Sharma) [#27361](https://github.com/nodejs/node/pull/27361)
  * upgrade npm to 6.9.0 (Kat Marchán) [#26244](https://github.com/nodejs/node/pull/26244)
  * upgrade openssl sources to 1.1.1b (Sam Roberts) [#26327](https://github.com/nodejs/node/pull/26327)
  * upgrade to libuv 1.28.0 (cjihrig) [#27241](https://github.com/nodejs/node/pull/27241)
* **events**: add once method to use promises with EventEmitter (Matteo Collina) [#26078](https://github.com/nodejs/node/pull/26078)
* **n-api**: mark thread-safe function as stable (Gabriel Schulhof) [#25556](https://github.com/nodejs/node/pull/25556)
* **repl**: support top-level for-await-of (Shelley Vohr) [#23841](https://github.com/nodejs/node/pull/23841)
* **zlib**:  add brotli support (Anna Henningsen) [#24938](https://github.com/nodejs/node/pull/24938)

### Commits

* \[[`77ed1bbea4`](https://github.com/nodejs/node/commit/77ed1bbea4)] - **benchmark**: fix net-wrap-js-stream-passthrough (Rich Trott) [#25273](https://github.com/nodejs/node/pull/25273)
* \[[`a8cbe0e6d2`](https://github.com/nodejs/node/commit/a8cbe0e6d2)] - **benchmark**: replace deprecated and eliminate var in buffer-from.js (gengjiawen) [#26585](https://github.com/nodejs/node/pull/26585)
* \[[`5249a22704`](https://github.com/nodejs/node/commit/5249a22704)] - **benchmark**: refactor path benchmarks (Ruben Bridgewater) [#26359](https://github.com/nodejs/node/pull/26359)
* \[[`de7db26879`](https://github.com/nodejs/node/commit/de7db26879)] - **benchmark,lib**: add process.hrtime.bigint benchmark (Anna Henningsen) [#26381](https://github.com/nodejs/node/pull/26381)
* \[[`c670358d7e`](https://github.com/nodejs/node/commit/c670358d7e)] - **(SEMVER-MINOR)** **benchmark,test**: add brotli (Anna Henningsen) [#24938](https://github.com/nodejs/node/pull/24938)
* \[[`ff647fda13`](https://github.com/nodejs/node/commit/ff647fda13)] - **buffer**: do not affect memory after target for utf16 write (Anna Henningsen) [#26432](https://github.com/nodejs/node/pull/26432)
* \[[`99a653e9ee`](https://github.com/nodejs/node/commit/99a653e9ee)] - **build**: make compress\_json python3 compatible (Sakthipriyan Vairamani (thefourtheye)) [#25582](https://github.com/nodejs/node/pull/25582)
* \[[`1c7f6a51c4`](https://github.com/nodejs/node/commit/1c7f6a51c4)] - **build**: make configure.py compatible with python 3 (Sakthipriyan Vairamani (thefourtheye)) [#25580](https://github.com/nodejs/node/pull/25580)
* \[[`de268667e7`](https://github.com/nodejs/node/commit/de268667e7)] - **build**: remove AIX/ppc (32bit) dead code (Refael Ackermann) [#25523](https://github.com/nodejs/node/pull/25523)
* \[[`a575a410fa`](https://github.com/nodejs/node/commit/a575a410fa)] - **build**: remove erroneous duplicate declaration from node\_inspector.gypi (Refael Ackermann) [#25586](https://github.com/nodejs/node/pull/25586)
* \[[`6348d71a8a`](https://github.com/nodejs/node/commit/6348d71a8a)] - **build**: do not lint python scripts under test/fixtures (Joyee Cheung) [#25639](https://github.com/nodejs/node/pull/25639)
* \[[`7ead9af0f5`](https://github.com/nodejs/node/commit/7ead9af0f5)] - **build**: add check for empty openssl-fips flag (Daniel Bevenius) [#25391](https://github.com/nodejs/node/pull/25391)
* \[[`554a4345c2`](https://github.com/nodejs/node/commit/554a4345c2)] - **build**: fix Windows shared lib build (Richard Lau) [#25166](https://github.com/nodejs/node/pull/25166)
* \[[`ffd62b129d`](https://github.com/nodejs/node/commit/ffd62b129d)] - **build**: correct fi indentation in Makefile (Daniel Bevenius) [#25107](https://github.com/nodejs/node/pull/25107)
* \[[`5760e419d7`](https://github.com/nodejs/node/commit/5760e419d7)] - **build**: add a space to clarify skipping crypto msg (Daniel Bevenius) [#25011](https://github.com/nodejs/node/pull/25011)
* \[[`513913c672`](https://github.com/nodejs/node/commit/513913c672)] - **build**: restore running tests on Travis (Richard Lau) [#26720](https://github.com/nodejs/node/pull/26720)
* \[[`9512f3938a`](https://github.com/nodejs/node/commit/9512f3938a)] - **build**: temporarily don't run tests on Travis (Richard Lau) [#26720](https://github.com/nodejs/node/pull/26720)
* \[[`add5141933`](https://github.com/nodejs/node/commit/add5141933)] - **build**: use Xenial and gcc 6 on Travis (Richard Lau) [#26720](https://github.com/nodejs/node/pull/26720)
* \[[`9f5ad9b476`](https://github.com/nodejs/node/commit/9f5ad9b476)] - **build,deps**: less warnings from V8 (Refael Ackermann) [#26405](https://github.com/nodejs/node/pull/26405)
* \[[`16a92f66a1`](https://github.com/nodejs/node/commit/16a92f66a1)] - **child\_process**: truncate output when maxBuffer is exceeded (Jeremiah Senkpiel) [#24951](https://github.com/nodejs/node/pull/24951)
* \[[`274fc16178`](https://github.com/nodejs/node/commit/274fc16178)] - **child\_process**: simplify argument handling (cjihrig) [#25194](https://github.com/nodejs/node/pull/25194)
* \[[`fce822f6e9`](https://github.com/nodejs/node/commit/fce822f6e9)] - **child\_process**: ensure message sanity at source (Gireesh Punathil) [#24787](https://github.com/nodejs/node/pull/24787)
* \[[`a193a0f9dd`](https://github.com/nodejs/node/commit/a193a0f9dd)] - **child\_process**: spawn ignores options in case args is undefined (Eduard Bondarenko) [#24913](https://github.com/nodejs/node/pull/24913)
* \[[`4b3e9486ca`](https://github.com/nodejs/node/commit/4b3e9486ca)] - **cluster**: refactor empty for in round\_robin\_handle.js (gengjiawen) [#26560](https://github.com/nodejs/node/pull/26560)
* \[[`fb73c06025`](https://github.com/nodejs/node/commit/fb73c06025)] - **cluster**: improve for-loop (gengjiawen) [#26336](https://github.com/nodejs/node/pull/26336)
* \[[`b8b23a3d78`](https://github.com/nodejs/node/commit/b8b23a3d78)] - **crypto**: add crypto modules to cannotUseCache (Daniel Bevenius) [#25606](https://github.com/nodejs/node/pull/25606)
* \[[`3a2814367b`](https://github.com/nodejs/node/commit/3a2814367b)] - **crypto**: add crypto/keys to cannotUseCache (Daniel Bevenius) [#25237](https://github.com/nodejs/node/pull/25237)
* \[[`a0dc65d0ed`](https://github.com/nodejs/node/commit/a0dc65d0ed)] - **crypto**: update root certificates (Sam Roberts) [#25113](https://github.com/nodejs/node/pull/25113)
* \[[`4c87c1b1bc`](https://github.com/nodejs/node/commit/4c87c1b1bc)] - **deps**: upgrade to libuv 1.28.0 (cjihrig) [#27241](https://github.com/nodejs/node/pull/27241)
* \[[`7e5ef4a0e1`](https://github.com/nodejs/node/commit/7e5ef4a0e1)] - **deps**: upgrade to libuv 1.27.0 (cjihrig) [#26707](https://github.com/nodejs/node/pull/26707)
* \[[`8ea22bbb88`](https://github.com/nodejs/node/commit/8ea22bbb88)] - **deps**: upgrade to libuv 1.26.0 (cjihrig) [#26037](https://github.com/nodejs/node/pull/26037)
* \[[`e6275f939a`](https://github.com/nodejs/node/commit/e6275f939a)] - **deps**: upgrade to libuv 1.25.0 (cjihrig) [#25571](https://github.com/nodejs/node/pull/25571)
* \[[`aceac0581c`](https://github.com/nodejs/node/commit/aceac0581c)] - **deps**: patch to fix \*.onion MX query on c-ares (XadillaX) [#25840](https://github.com/nodejs/node/pull/25840)
* \[[`be219bd559`](https://github.com/nodejs/node/commit/be219bd559)] - **deps**: update archs files for OpenSSL-1.1.1b (Sam Roberts) [#26327](https://github.com/nodejs/node/pull/26327)
* \[[`6a6aa6f038`](https://github.com/nodejs/node/commit/6a6aa6f038)] - **(SEMVER-MINOR)** **deps**: add s390 asm rules for OpenSSL-1.1.1 (Shigeki Ohtsu) [#25381](https://github.com/nodejs/node/pull/25381)
* \[[`5109c4f432`](https://github.com/nodejs/node/commit/5109c4f432)] - **deps**: add ARM64 Windows support in openssl (Shigeki Ohtsu) [#26001](https://github.com/nodejs/node/pull/26001)
* \[[`f270eeec52`](https://github.com/nodejs/node/commit/f270eeec52)] - **deps**: openssl-1.1.1b no longer packages .gitignore (Sam Roberts) [#26327](https://github.com/nodejs/node/pull/26327)
* \[[`ebe0b05a24`](https://github.com/nodejs/node/commit/ebe0b05a24)] - **deps**: upgrade openssl sources to 1.1.1b (Sam Roberts) [#26327](https://github.com/nodejs/node/pull/26327)
* \[[`bbf5373041`](https://github.com/nodejs/node/commit/bbf5373041)] - **deps**: update OpenSSL upgrade process (Sam Roberts) [#26378](https://github.com/nodejs/node/pull/26378)
* \[[`a9c68a05d9`](https://github.com/nodejs/node/commit/a9c68a05d9)] - **(SEMVER-MINOR)** **deps**: add brotli (Hackzzila) [#24938](https://github.com/nodejs/node/pull/24938)
* \[[`281b52d6ec`](https://github.com/nodejs/node/commit/281b52d6ec)] - **deps**: upgrade npm to 6.9.0 (Kat Marchán) [#26244](https://github.com/nodejs/node/pull/26244)
* \[[`d2413d630c`](https://github.com/nodejs/node/commit/d2413d630c)] - **deps**: upgrade npm to 6.7.0 (Kat Marchán) [#25804](https://github.com/nodejs/node/pull/25804)
* \[[`e880904d22`](https://github.com/nodejs/node/commit/e880904d22)] - **deps**: upgrade npm to v6.5.0 (Jordan Harband) [#25234](https://github.com/nodejs/node/pull/25234)
* \[[`f91a818508`](https://github.com/nodejs/node/commit/f91a818508)] - **deps**: backport ICU-20575 to fix err/crasher (Steven R. Loomis) [#27435](https://github.com/nodejs/node/pull/27435)
* \[[`c7931e4438`](https://github.com/nodejs/node/commit/c7931e4438)] - **deps**: backport ICU-20558 to fix Intl crasher (Steven R. Loomis) [#27415](https://github.com/nodejs/node/pull/27415)
* \[[`c9d0b6a9a0`](https://github.com/nodejs/node/commit/c9d0b6a9a0)] - **deps**: update ICU to 64.2 (Ujjwal Sharma) [#27361](https://github.com/nodejs/node/pull/27361)
* \[[`391185e550`](https://github.com/nodejs/node/commit/391185e550)] - **(SEMVER-MINOR)** **deps**: upgrade npm to 6.5.0 (Audrey Eschright) [#24734](https://github.com/nodejs/node/pull/24734)
* \[[`4875e881cd`](https://github.com/nodejs/node/commit/4875e881cd)] - **deps**: upgrade to libuv 1.24.1 (cjihrig) [#25078](https://github.com/nodejs/node/pull/25078)
* \[[`74f4741b63`](https://github.com/nodejs/node/commit/74f4741b63)] - **(SEMVER-MINOR)** **deps**: upgrade to libuv 1.24.0 (cjihrig) [#24332](https://github.com/nodejs/node/pull/24332)
* \[[`e9a9c88363`](https://github.com/nodejs/node/commit/e9a9c88363)] - **(SEMVER-MINOR)** **deps**: icu 63.1 bump (CLDR 34) (Steven R. Loomis) [#23715](https://github.com/nodejs/node/pull/23715)
* \[[`23ea7ee64b`](https://github.com/nodejs/node/commit/23ea7ee64b)] - **deps**: v8, backport coverage fixes (bcoe) [#26579](https://github.com/nodejs/node/pull/26579)
* \[[`b0b73fa561`](https://github.com/nodejs/node/commit/b0b73fa561)] - **(SEMVER-MINOR)** **deps**: update archs files for OpenSSL-1.1.1a (Sam Roberts) [#25381](https://github.com/nodejs/node/pull/25381)
* \[[`56441a0900`](https://github.com/nodejs/node/commit/56441a0900)] - **(SEMVER-MINOR)** **deps**: fix for non GNU assembler in AIX (Shigeki Ohtsu) [#25381](https://github.com/nodejs/node/pull/25381)
* \[[`639b1d2f68`](https://github.com/nodejs/node/commit/639b1d2f68)] - **(SEMVER-MINOR)** **deps**: add only avx2 configs for OpenSSL-1.1.1 (Shigeki Ohtsu) [#25381](https://github.com/nodejs/node/pull/25381)
* \[[`f5369da047`](https://github.com/nodejs/node/commit/f5369da047)] - **(SEMVER-MINOR)** **deps**: fix MacOS and Win build for OpenSSL-1.1.1 (Shigeki Ohtsu) [#25381](https://github.com/nodejs/node/pull/25381)
* \[[`70a785cd9f`](https://github.com/nodejs/node/commit/70a785cd9f)] - **(SEMVER-MINOR)** **deps**: fix gyp/gypi for openssl-1.1.1 (Shigeki Ohtsu) [#25381](https://github.com/nodejs/node/pull/25381)
* \[[`0e7019ff76`](https://github.com/nodejs/node/commit/0e7019ff76)] - **(SEMVER-MINOR)** **deps**: add s390 asm rules for OpenSSL-1.1.1 (Shigeki Ohtsu) [#25381](https://github.com/nodejs/node/pull/25381)
* \[[`2d396fe058`](https://github.com/nodejs/node/commit/2d396fe058)] - **(SEMVER-MINOR)** **deps**: upgrade openssl sources to 1.1.1a (Sam Roberts) [#25381](https://github.com/nodejs/node/pull/25381)
* \[[`ce6fec53a4`](https://github.com/nodejs/node/commit/ce6fec53a4)] - **(SEMVER-MINOR)** **deps,tools**: update license-builder.sh and LICENSE (Hackzzila) [#24938](https://github.com/nodejs/node/pull/24938)
* \[[`b7dd0b841e`](https://github.com/nodejs/node/commit/b7dd0b841e)] - **deps,tools**: include SipHash in LICENSE (Rod Vagg) [#26367](https://github.com/nodejs/node/pull/26367)
* \[[`4fcfa5a63f`](https://github.com/nodejs/node/commit/4fcfa5a63f)] - **dns**: fix TTL value for AAAA replies to `resolveAny()` (Anna Henningsen) [#25187](https://github.com/nodejs/node/pull/25187)
* \[[`2a98b9cf2f`](https://github.com/nodejs/node/commit/2a98b9cf2f)] - **doc**: add "tick" function name and argument description (Artur Hayrapetyan) [#23551](https://github.com/nodejs/node/pull/23551)
* \[[`93edf907ca`](https://github.com/nodejs/node/commit/93edf907ca)] - **(SEMVER-MINOR)** **doc**: add documentation for brotli support (Anna Henningsen) [#24938](https://github.com/nodejs/node/pull/24938)
* \[[`7ed29fc1e8`](https://github.com/nodejs/node/commit/7ed29fc1e8)] - **doc**: revise breaking changes material in COLLABORATOR\_GUIDE (Rich Trott) [#25730](https://github.com/nodejs/node/pull/25730)
* \[[`498edfde9b`](https://github.com/nodejs/node/commit/498edfde9b)] - **doc**: fix http.Agent timeout option description (Luigi Pinca) [#25489](https://github.com/nodejs/node/pull/25489)
* \[[`a040a73ee3`](https://github.com/nodejs/node/commit/a040a73ee3)] - **doc**: fix file extension on ESM file example (Eric Whitebloom) [#25692](https://github.com/nodejs/node/pull/25692)
* \[[`6a2d9d192f`](https://github.com/nodejs/node/commit/6a2d9d192f)] - **doc**: remove outdated s\_client information in tls.md (Rich Trott) [#25678](https://github.com/nodejs/node/pull/25678)
* \[[`bb96d79a7e`](https://github.com/nodejs/node/commit/bb96d79a7e)] - **doc**: clarify what dns.setResolvers() affects (Sam Roberts) [#25570](https://github.com/nodejs/node/pull/25570)
* \[[`a382932097`](https://github.com/nodejs/node/commit/a382932097)] - **doc**: simplify process.binding() deprecation message (Rich Trott) [#25654](https://github.com/nodejs/node/pull/25654)
* \[[`b1a15ab4cf`](https://github.com/nodejs/node/commit/b1a15ab4cf)] - **doc**: add note regarding pushing release tags (Myles Borins) [#25569](https://github.com/nodejs/node/pull/25569)
* \[[`6ae41bde4d`](https://github.com/nodejs/node/commit/6ae41bde4d)] - **doc**: reword stream docs to clarify that decodeStrings encodes strings (Daniel George Holz) [#25468](https://github.com/nodejs/node/pull/25468)
* \[[`13205d5805`](https://github.com/nodejs/node/commit/13205d5805)] - **doc**: correct my wrong note about buf.fill() (Vse Mozhet Byt) [#25585](https://github.com/nodejs/node/pull/25585)
* \[[`12fe2d30fe`](https://github.com/nodejs/node/commit/12fe2d30fe)] - **doc**: add a note to `buf.fill()` description (Vse Mozhet Byt) [#25547](https://github.com/nodejs/node/pull/25547)
* \[[`92d0794d63`](https://github.com/nodejs/node/commit/92d0794d63)] - **doc**: fix typo in Buffer API (H1Gdev) [#25544](https://github.com/nodejs/node/pull/25544)
* \[[`37082bd149`](https://github.com/nodejs/node/commit/37082bd149)] - **doc**: add Rich back to TSC list (Michael Dawson) [#25535](https://github.com/nodejs/node/pull/25535)
* \[[`5631d7a6e0`](https://github.com/nodejs/node/commit/5631d7a6e0)] - **doc**: add metadata about ecdh curve options (Sam Roberts) [#25502](https://github.com/nodejs/node/pull/25502)
* \[[`5c602dabc4`](https://github.com/nodejs/node/commit/5c602dabc4)] - **doc**: add TLSSocket.isSessionReused() docs (Sam Roberts) [#25423](https://github.com/nodejs/node/pull/25423)
* \[[`07f878b0c1`](https://github.com/nodejs/node/commit/07f878b0c1)] - **doc**: fix sorting in buffer.md (Vse Mozhet Byt) [#25477](https://github.com/nodejs/node/pull/25477)
* \[[`9dffc2ba0c`](https://github.com/nodejs/node/commit/9dffc2ba0c)] - **doc**: fix `napi_open_callback_scope` description (Philipp Renoth) [#25366](https://github.com/nodejs/node/pull/25366)
* \[[`0c33ecb2bd`](https://github.com/nodejs/node/commit/0c33ecb2bd)] - **doc**: document that stream.on('close') was changed in Node 10 (Matteo Collina) [#25413](https://github.com/nodejs/node/pull/25413)
* \[[`8f0fa61406`](https://github.com/nodejs/node/commit/8f0fa61406)] - **doc**: fix the path to postMessage() (Mitar) [#25332](https://github.com/nodejs/node/pull/25332)
* \[[`3a30c87e88`](https://github.com/nodejs/node/commit/3a30c87e88)] - **doc**: update `os.networkInterfaces()` example (jvelezpo) [#25417](https://github.com/nodejs/node/pull/25417)
* \[[`530f005d7d`](https://github.com/nodejs/node/commit/530f005d7d)] - **doc**: make sure that calls to .read() are looped (Matteo Collina) [#25375](https://github.com/nodejs/node/pull/25375)
* \[[`487f6536bc`](https://github.com/nodejs/node/commit/487f6536bc)] - **doc**: add history to http.request.setTimeout() (James Bunton) [#25121](https://github.com/nodejs/node/pull/25121)
* \[[`66ab7e4a99`](https://github.com/nodejs/node/commit/66ab7e4a99)] - **doc**: add clarification for exception behaviour (Michael Dawson) [#25339](https://github.com/nodejs/node/pull/25339)
* \[[`ce3cf0dffd`](https://github.com/nodejs/node/commit/ce3cf0dffd)] - **doc**: clarify timing of socket.connecting (Sam Roberts) [#25333](https://github.com/nodejs/node/pull/25333)
* \[[`b68d47a246`](https://github.com/nodejs/node/commit/b68d47a246)] - **doc**: update benchmark doc (Kazushi Kitaya) [#25367](https://github.com/nodejs/node/pull/25367)
* \[[`252a696568`](https://github.com/nodejs/node/commit/252a696568)] - **doc**: use lowercase for zlib (Rich Trott) [#25371](https://github.com/nodejs/node/pull/25371)
* \[[`0d3212aa5c`](https://github.com/nodejs/node/commit/0d3212aa5c)] - **doc**: fix heading in cpp style guide (Kazushi Kitaya) [#25303](https://github.com/nodejs/node/pull/25303)
* \[[`8d5ac6c8ef`](https://github.com/nodejs/node/commit/8d5ac6c8ef)] - **doc**: fix process.stdin example (Anna Henningsen) [#25344](https://github.com/nodejs/node/pull/25344)
* \[[`ef6e4f15a0`](https://github.com/nodejs/node/commit/ef6e4f15a0)] - **doc**: fs.mkdir('/') throws EPERM on Windows (Corey Farrell) [#25340](https://github.com/nodejs/node/pull/25340)
* \[[`fc5dc9c13e`](https://github.com/nodejs/node/commit/fc5dc9c13e)] - **doc**: include license for src/large\_pages in LICENSE (Ujjwal Sharma) [#25246](https://github.com/nodejs/node/pull/25246)
* \[[`b76931b7e9`](https://github.com/nodejs/node/commit/b76931b7e9)] - **doc**: describe TLS session resumption (Sam Roberts) [#25174](https://github.com/nodejs/node/pull/25174)
* \[[`c84b4fb51a`](https://github.com/nodejs/node/commit/c84b4fb51a)] - **doc**: link and expand --tls-cipher-list docs (Sam Roberts) [#25174](https://github.com/nodejs/node/pull/25174)
* \[[`18e0a61f91`](https://github.com/nodejs/node/commit/18e0a61f91)] - **doc**: revise "Breaking Changes to Internal Elements" (Rich Trott) [#25190](https://github.com/nodejs/node/pull/25190)
* \[[`b980fa3a21`](https://github.com/nodejs/node/commit/b980fa3a21)] - **doc**: fix NAPI typo (Philipp Renoth) [#25216](https://github.com/nodejs/node/pull/25216)
* \[[`173e5fee9d`](https://github.com/nodejs/node/commit/173e5fee9d)] - **doc**: revise "Breaking Changes and Deprecations" (Rich Trott) [#25116](https://github.com/nodejs/node/pull/25116)
* \[[`c571e9e18b`](https://github.com/nodejs/node/commit/c571e9e18b)] - **doc**: describe root cert update process (Sam Roberts) [#25113](https://github.com/nodejs/node/pull/25113)
* \[[`09a97f29df`](https://github.com/nodejs/node/commit/09a97f29df)] - **doc**: edit LTS material in Collaborator Guide (Rich Trott) [#26845](https://github.com/nodejs/node/pull/26845)
* \[[`f52160d385`](https://github.com/nodejs/node/commit/f52160d385)] - **doc**: change error message to 'not defined' (Mohammed Essehemy) [#26857](https://github.com/nodejs/node/pull/26857)
* \[[`6bd33dde62`](https://github.com/nodejs/node/commit/6bd33dde62)] - **doc**: fix comma of the list in worker\_threads.md (Hang Jiang) [#26838](https://github.com/nodejs/node/pull/26838)
* \[[`889d68ce6d`](https://github.com/nodejs/node/commit/889d68ce6d)] - **doc**: remove discord community (Aymen Naghmouchi) [#26830](https://github.com/nodejs/node/pull/26830)
* \[[`ddfa756797`](https://github.com/nodejs/node/commit/ddfa756797)] - **doc**: remove How Does LTS Work section from Collaborator Guide (Rich Trott) [#26723](https://github.com/nodejs/node/pull/26723)
* \[[`a228254d6b`](https://github.com/nodejs/node/commit/a228254d6b)] - **doc**: condense LTS material in Collaborator Guide (Rich Trott) [#26722](https://github.com/nodejs/node/pull/26722)
* \[[`09f162b18f`](https://github.com/nodejs/node/commit/09f162b18f)] - **doc**: add Note of options.stdio into child\_process (kohta ito) [#26604](https://github.com/nodejs/node/pull/26604)
* \[[`83c2a14e08`](https://github.com/nodejs/node/commit/83c2a14e08)] - **doc**: update spawnSync() status value possibilities (Rich Trott) [#26680](https://github.com/nodejs/node/pull/26680)
* \[[`621099ebed`](https://github.com/nodejs/node/commit/621099ebed)] - **doc**: add ZYSzys to collaborators (ZYSzys) [#26730](https://github.com/nodejs/node/pull/26730)
* \[[`30021881f8`](https://github.com/nodejs/node/commit/30021881f8)] - **doc**: simplify force-push guidelines (Rich Trott) [#26699](https://github.com/nodejs/node/pull/26699)
* \[[`1e6faf9ee0`](https://github.com/nodejs/node/commit/1e6faf9ee0)] - **doc**: note about DNS ANY queries / RFC 8482 (Thomas Hunter II) [#26695](https://github.com/nodejs/node/pull/26695)
* \[[`fc3552305a`](https://github.com/nodejs/node/commit/fc3552305a)] - **doc**: simplify Troubleshooting text (Rich Trott) [#26652](https://github.com/nodejs/node/pull/26652)
* \[[`983ea7f3e0`](https://github.com/nodejs/node/commit/983ea7f3e0)] - **doc**: update copy/paste error message in Troubleshooting (Rich Trott) [#26652](https://github.com/nodejs/node/pull/26652)
* \[[`c07619d581`](https://github.com/nodejs/node/commit/c07619d581)] - **doc**: add Gireesh to TSC (Rich Trott) [#26657](https://github.com/nodejs/node/pull/26657)
* \[[`07ded7c975`](https://github.com/nodejs/node/commit/07ded7c975)] - **doc**: edit "Technical How-To" section of guide (Rich Trott) [#26601](https://github.com/nodejs/node/pull/26601)
* \[[`0a976ecb63`](https://github.com/nodejs/node/commit/0a976ecb63)] - **doc**: fix misleading sentence in http.md (Luigi Pinca) [#26465](https://github.com/nodejs/node/pull/26465)
* \[[`f30172fa25`](https://github.com/nodejs/node/commit/f30172fa25)] - **doc**: fix typo in http2.md (TJKoury) [#26616](https://github.com/nodejs/node/pull/26616)
* \[[`4fed47ab79`](https://github.com/nodejs/node/commit/4fed47ab79)] - **doc**: edit "Using git-node" section of Guide (Rich Trott) [#26580](https://github.com/nodejs/node/pull/26580)
* \[[`033d49c1f4`](https://github.com/nodejs/node/commit/033d49c1f4)] - **doc**: add version for http.createServer() options addition (Ben Swinburne) [#25001](https://github.com/nodejs/node/pull/25001)
* \[[`d4a1d79e3d`](https://github.com/nodejs/node/commit/d4a1d79e3d)] - **doc**: add inspector API example for heapdump (Sam Roberts) [#26498](https://github.com/nodejs/node/pull/26498)
* \[[`72f0efc1f2`](https://github.com/nodejs/node/commit/72f0efc1f2)] - **doc**: edit Landing Pull Requests (Rich Trott) [#26536](https://github.com/nodejs/node/pull/26536)
* \[[`132a457ed4`](https://github.com/nodejs/node/commit/132a457ed4)] - **doc**: add decode() & encode() methods into querystring.md (ZYSzys) [#23889](https://github.com/nodejs/node/pull/23889)
* \[[`74dac5913d`](https://github.com/nodejs/node/commit/74dac5913d)] - **doc**: update partner communities link in releases.md (Beth Griggs) [#26475](https://github.com/nodejs/node/pull/26475)
* \[[`5279a884cc`](https://github.com/nodejs/node/commit/5279a884cc)] - **doc**: fix nits in writing-tests.md (Vse Mozhet Byt) [#26543](https://github.com/nodejs/node/pull/26543)
* \[[`11d163b439`](https://github.com/nodejs/node/commit/11d163b439)] - **doc**: edit "Involving the TSC" (Rich Trott) [#26481](https://github.com/nodejs/node/pull/26481)
* \[[`5fedf0f257`](https://github.com/nodejs/node/commit/5fedf0f257)] - **doc**: add guidance on console output in tests (Sam Roberts) [#26456](https://github.com/nodejs/node/pull/26456)
* \[[`40657859ca`](https://github.com/nodejs/node/commit/40657859ca)] - **doc**: add caveat and tradeoff example to readline (Vse Mozhet Byt) [#26472](https://github.com/nodejs/node/pull/26472)
* \[[`77eae4ecd6`](https://github.com/nodejs/node/commit/77eae4ecd6)] - **doc**: fix the example implementation of MemoryRetainer (Joyee Cheung) [#26262](https://github.com/nodejs/node/pull/26262)
* \[[`aa49bf53f2`](https://github.com/nodejs/node/commit/aa49bf53f2)] - **doc**: clarify http.Agent constructor options (Luigi Pinca) [#26412](https://github.com/nodejs/node/pull/26412)
* \[[`a562aba84c`](https://github.com/nodejs/node/commit/a562aba84c)] - **doc**: hello addon example should return "world" (Geir Hauge) [#26328](https://github.com/nodejs/node/pull/26328)
* \[[`b450ee28e3`](https://github.com/nodejs/node/commit/b450ee28e3)] - **doc**: fix up N-API support matrix (Michael Dawson) [#26377](https://github.com/nodejs/node/pull/26377)
* \[[`3ff7c631a6`](https://github.com/nodejs/node/commit/3ff7c631a6)] - **doc**: edit deprecation identifier info in Collaborator Guide (Rich Trott) [#26372](https://github.com/nodejs/node/pull/26372)
* \[[`8d22048756`](https://github.com/nodejs/node/commit/8d22048756)] - **doc**: update LICENSE file (Thomas Leah) [#24898](https://github.com/nodejs/node/pull/24898)
* \[[`e05eb3e041`](https://github.com/nodejs/node/commit/e05eb3e041)] - **(SEMVER-MINOR)** **doc**: fix assembler requirement for OpenSSL-1.1.1 (Shigeki Ohtsu) [#25381](https://github.com/nodejs/node/pull/25381)
* \[[`ecae7275bd`](https://github.com/nodejs/node/commit/ecae7275bd)] - **doc**: fix REPLACEME for tls min/max protocol option (Sam Roberts) [#24759](https://github.com/nodejs/node/pull/24759)
* \[[`1ae6853015`](https://github.com/nodejs/node/commit/1ae6853015)] - **doc,n-api**: update matrix for N-API version 4 (Richard Lau)
* \[[`98193d1d4d`](https://github.com/nodejs/node/commit/98193d1d4d)] - **doc,tools**: updates for 6.x End-of-Life (Richard Lau) [#27658](https://github.com/nodejs/node/pull/27658)
* \[[`25d73aa187`](https://github.com/nodejs/node/commit/25d73aa187)] - **domain**: avoid circular memory references (Anna Henningsen) [#25993](https://github.com/nodejs/node/pull/25993)
* \[[`46a816fa00`](https://github.com/nodejs/node/commit/46a816fa00)] - **events**: show inspected error in uncaught 'error' message (Anna Henningsen) [#25621](https://github.com/nodejs/node/pull/25621)
* \[[`aca5ed5563`](https://github.com/nodejs/node/commit/aca5ed5563)] - **events**: simplify stack compare function (Ruben Bridgewater) [#24744](https://github.com/nodejs/node/pull/24744)
* \[[`064511ec4b`](https://github.com/nodejs/node/commit/064511ec4b)] - **(SEMVER-MINOR)** **events**: add once method to use promises with EventEmitter (Matteo Collina) [#26078](https://github.com/nodejs/node/pull/26078)
* \[[`e1f293c7a1`](https://github.com/nodejs/node/commit/e1f293c7a1)] - **events**: improve for-loop (gengjiawen) [#26354](https://github.com/nodejs/node/pull/26354)
* \[[`cb0fc6520a`](https://github.com/nodejs/node/commit/cb0fc6520a)] - **events**: onceWrapper returns target value (himself65) [#25818](https://github.com/nodejs/node/pull/25818)
* \[[`af301b2821`](https://github.com/nodejs/node/commit/af301b2821)] - **fs**: fix infinite loop with async recursive mkdir on Windows (Richard Lau) [#27207](https://github.com/nodejs/node/pull/27207)
* \[[`3516a2735f`](https://github.com/nodejs/node/commit/3516a2735f)] - **(SEMVER-MINOR)** **fs**: default open/openSync flags argument to 'r' (Ben Noordhuis) [#23767](https://github.com/nodejs/node/pull/23767)
* \[[`ae465f6fc4`](https://github.com/nodejs/node/commit/ae465f6fc4)] - **(SEMVER-MINOR)** **fs,net**: standardize `pending` stream property (Anna Henningsen) [#24067](https://github.com/nodejs/node/pull/24067)
* \[[`ced7f67fbb`](https://github.com/nodejs/node/commit/ced7f67fbb)] - **http**: make ClientRequest#setTimeout() noop at end (Tim De Pauw) [#25536](https://github.com/nodejs/node/pull/25536)
* \[[`33a9d17733`](https://github.com/nodejs/node/commit/33a9d17733)] - **http**: reuse noop function in socketOnError() (cjihrig) [#25566](https://github.com/nodejs/node/pull/25566)
* \[[`378d4f18f1`](https://github.com/nodejs/node/commit/378d4f18f1)] - **http**: remove unused variable in \_http\_server.js (gengjiawen) [#26407](https://github.com/nodejs/node/pull/26407)
* \[[`cb88c58e42`](https://github.com/nodejs/node/commit/cb88c58e42)] - **http**: check for existance in resetHeadersTimeoutOnReqEnd (Matteo Collina) [#26402](https://github.com/nodejs/node/pull/26402)
* \[[`277271c4a9`](https://github.com/nodejs/node/commit/277271c4a9)] - **http**: send connection: close when closing conn (Yann Hamon) [#26467](https://github.com/nodejs/node/pull/26467)
* \[[`decba1c59b`](https://github.com/nodejs/node/commit/decba1c59b)] - **http2**: allow fully synchronous `_final()` (Anna Henningsen) [#25609](https://github.com/nodejs/node/pull/25609)
* \[[`ba6829d1b8`](https://github.com/nodejs/node/commit/ba6829d1b8)] - **http2**: add test case for goaway (Anto Aravinth) [#24054](https://github.com/nodejs/node/pull/24054)
* \[[`91b1b2cf84`](https://github.com/nodejs/node/commit/91b1b2cf84)] - **http2**: delete unused enum in node\_http2.h (gengjiawen) [#26704](https://github.com/nodejs/node/pull/26704)
* \[[`59b348e0e4`](https://github.com/nodejs/node/commit/59b348e0e4)] - **http2**: `Http2ServerResponse.end()` should always return self (Robert Nagy) [#24346](https://github.com/nodejs/node/pull/24346)
* \[[`32b83eaf38`](https://github.com/nodejs/node/commit/32b83eaf38)] - **http2**: refactor deprecated method in core.js (gengjiawen) [#26275](https://github.com/nodejs/node/pull/26275)
* \[[`cc25f22094`](https://github.com/nodejs/node/commit/cc25f22094)] - **http2**: improve compatibility with http/1 (Sagi Tsofan) [#23908](https://github.com/nodejs/node/pull/23908)
* \[[`4f60364201`](https://github.com/nodejs/node/commit/4f60364201)] - **(SEMVER-MINOR)** **http2**: add Http2Stream.bufferSize (Ouyang Yadong) [#23711](https://github.com/nodejs/node/pull/23711)
* \[[`b7b08d1009`](https://github.com/nodejs/node/commit/b7b08d1009)] - **https**: add missing localPort while create socket (leeight) [#24554](https://github.com/nodejs/node/pull/24554)
* \[[`66ca795028`](https://github.com/nodejs/node/commit/66ca795028)] - **inspector**: print all listening addresses (Ben Noordhuis) [#26008](https://github.com/nodejs/node/pull/26008)
* \[[`cbc428c803`](https://github.com/nodejs/node/commit/cbc428c803)] - **inspector, test**: verify reported console message (Eugene Ostroukhov) [#25455](https://github.com/nodejs/node/pull/25455)
* \[[`73230cc2c8`](https://github.com/nodejs/node/commit/73230cc2c8)] - **(SEMVER-MINOR)** **lib**: support overriding http\s.globalAgent (Roy Sommer) [#25170](https://github.com/nodejs/node/pull/25170)
* \[[`ec90cefdd9`](https://github.com/nodejs/node/commit/ec90cefdd9)] - **lib**: simplify several debug() calls (cjihrig) [#25241](https://github.com/nodejs/node/pull/25241)
* \[[`43f41beff2`](https://github.com/nodejs/node/commit/43f41beff2)] - **(SEMVER-MINOR)** **lib**: enable TypedArray and DataView for the v8 module (Ouyang Yadong) [#23953](https://github.com/nodejs/node/pull/23953)
* \[[`bda45a5cfe`](https://github.com/nodejs/node/commit/bda45a5cfe)] - **(SEMVER-MINOR)** **lib**: add escapeCodeTimeout as an option to createInterface (Raoof) [#19780](https://github.com/nodejs/node/pull/19780)
* \[[`81cf2b450d`](https://github.com/nodejs/node/commit/81cf2b450d)] - **lib,test**: remove lib/internal/test/unicode.js (Rich Trott) [#25298](https://github.com/nodejs/node/pull/25298)
* \[[`a49bd36a1a`](https://github.com/nodejs/node/commit/a49bd36a1a)] - **module**: revert module.\_compile to original state if module is patched (Ujjwal Sharma) [#21573](https://github.com/nodejs/node/pull/21573)
* \[[`590e8d37e9`](https://github.com/nodejs/node/commit/590e8d37e9)] - **module**: use compileFunction over Module.wrap (Ujjwal Sharma) [#21573](https://github.com/nodejs/node/pull/21573)
* \[[`0dc6f03873`](https://github.com/nodejs/node/commit/0dc6f03873)] - **(SEMVER-MINOR)** **module**: support multi-dot file extension (Geoffrey Booth) [#23416](https://github.com/nodejs/node/pull/23416)
* \[[`2643801d9d`](https://github.com/nodejs/node/commit/2643801d9d)] - **n-api**: improve performance creating strings (Anthony Tuininga) [#26439](https://github.com/nodejs/node/pull/26439)
* \[[`b5588daef0`](https://github.com/nodejs/node/commit/b5588daef0)] - **n-api**: finalize during second-pass callback (Gabriel Schulhof) [#25992](https://github.com/nodejs/node/pull/25992)
* \[[`48a5241b46`](https://github.com/nodejs/node/commit/48a5241b46)] - **(SEMVER-MINOR)** **n-api**: mark thread-safe function as stable (Gabriel Schulhof) [#25556](https://github.com/nodejs/node/pull/25556)
* \[[`f17b61e071`](https://github.com/nodejs/node/commit/f17b61e071)] - **net**: check for close on stream, not parent (David Halls) [#25026](https://github.com/nodejs/node/pull/25026)
* \[[`eef2debcc7`](https://github.com/nodejs/node/commit/eef2debcc7)] - **os**: implement os.release() using uv\_os\_uname() (cjihrig) [#25600](https://github.com/nodejs/node/pull/25600)
* \[[`d4688485b5`](https://github.com/nodejs/node/commit/d4688485b5)] - **os**: use uv\_os\_gethostname() in hostname() (cjihrig) [#25111](https://github.com/nodejs/node/pull/25111)
* \[[`ff3d977f04`](https://github.com/nodejs/node/commit/ff3d977f04)] - **perf\_hooks**: clean up GC listeners (Anna Henningsen) [#25647](https://github.com/nodejs/node/pull/25647)
* \[[`45481bce63`](https://github.com/nodejs/node/commit/45481bce63)] - **querystring**: remove eslint-disable (cjihrig) [#24995](https://github.com/nodejs/node/pull/24995)
* \[[`d3f15b0ffb`](https://github.com/nodejs/node/commit/d3f15b0ffb)] - **(SEMVER-MINOR)** **readline**: add support for async iteration (Timothy Gu) [#23916](https://github.com/nodejs/node/pull/23916)
* \[[`2f1ad8efbd`](https://github.com/nodejs/node/commit/2f1ad8efbd)] - **repl**: improve doc for disabling REPL history on Windows (Samuel D. Leslie) [#25672](https://github.com/nodejs/node/pull/25672)
* \[[`b061a08cab`](https://github.com/nodejs/node/commit/b061a08cab)] - **repl**: indicate if errors are thrown or not (Ruben Bridgewater) [#25253](https://github.com/nodejs/node/pull/25253)
* \[[`ef767a28b2`](https://github.com/nodejs/node/commit/ef767a28b2)] - **repl**: eliminate var in function \_memory (gengjiawen) [#26496](https://github.com/nodejs/node/pull/26496)
* \[[`600929d4f8`](https://github.com/nodejs/node/commit/600929d4f8)] - **repl**: simplify regex expression (gengjiawen) [#26496](https://github.com/nodejs/node/pull/26496)
* \[[`1080a1af3d`](https://github.com/nodejs/node/commit/1080a1af3d)] - **repl**: remove redundant escape (gengjiawen) [#26496](https://github.com/nodejs/node/pull/26496)
* \[[`b9188d473b`](https://github.com/nodejs/node/commit/b9188d473b)] - **(SEMVER-MINOR)** **repl**: support top-level for-await-of (Shelley Vohr) [#23841](https://github.com/nodejs/node/pull/23841)
* \[[`b9ea23c0ed`](https://github.com/nodejs/node/commit/b9ea23c0ed)] - **src**: add WeakReference utility (Anna Henningsen) [#25993](https://github.com/nodejs/node/pull/25993)
* \[[`57469e62d9`](https://github.com/nodejs/node/commit/57469e62d9)] - **src**: extract common sockaddr creation code (Daniel Bevenius) [#26070](https://github.com/nodejs/node/pull/26070)
* \[[`bc5e04b5f7`](https://github.com/nodejs/node/commit/bc5e04b5f7)] - **src**: fix race condition in `~NodeTraceBuffer` (Anna Henningsen) [#25896](https://github.com/nodejs/node/pull/25896)
* \[[`51ec21cb17`](https://github.com/nodejs/node/commit/51ec21cb17)] - **src**: remove unused field in node\_http2.h (gengjiawen) [#25727](https://github.com/nodejs/node/pull/25727)
* \[[`550af6d72f`](https://github.com/nodejs/node/commit/550af6d72f)] - **src**: remove unnecessary call to SSL\_get\_mode (Sam Roberts) [#25711](https://github.com/nodejs/node/pull/25711)
* \[[`b31035d0b3`](https://github.com/nodejs/node/commit/b31035d0b3)] - **src**: fix macro duplicate declaration in env.h (gengjiawen) [#25703](https://github.com/nodejs/node/pull/25703)
* \[[`cd4a932af3`](https://github.com/nodejs/node/commit/cd4a932af3)] - **src**: remove outdated `Neuter()` call in `node_buffer.cc` (Anna Henningsen) [#25479](https://github.com/nodejs/node/pull/25479)
* \[[`883d61c7ae`](https://github.com/nodejs/node/commit/883d61c7ae)] - **src**: trace\_events: fix race with metadata events (Ali Ijaz Sheikh) [#25235](https://github.com/nodejs/node/pull/25235)
* \[[`7655253251`](https://github.com/nodejs/node/commit/7655253251)] - **src**: remove unused method declaration (Ben Noordhuis) [#25329](https://github.com/nodejs/node/pull/25329)
* \[[`f5e4a1e9d8`](https://github.com/nodejs/node/commit/f5e4a1e9d8)] - **src**: remove unused variable from string\_search.h (Anna Henningsen) [#25139](https://github.com/nodejs/node/pull/25139)
* \[[`5d5ac23bb7`](https://github.com/nodejs/node/commit/5d5ac23bb7)] - **src**: do not leak NodeTraceStateObserver (Anna Henningsen) [#25180](https://github.com/nodejs/node/pull/25180)
* \[[`870549b8ac`](https://github.com/nodejs/node/commit/870549b8ac)] - **src**: port GetLoadedLibraries for freebsd (Gireesh Punathil) [#25106](https://github.com/nodejs/node/pull/25106)
* \[[`74b034fe94`](https://github.com/nodejs/node/commit/74b034fe94)] - **src**: schedule destroy hooks in BeforeExit early during bootstrap (Joyee Cheung) [#25020](https://github.com/nodejs/node/pull/25020)
* \[[`42c26a6afb`](https://github.com/nodejs/node/commit/42c26a6afb)] - **src**: remove unused variable in class InspectorSocketServer (gengjiawen) [#26633](https://github.com/nodejs/node/pull/26633)
* \[[`84db29c93b`](https://github.com/nodejs/node/commit/84db29c93b)] - **src**: remove usage of deprecated IsNearDeath (Michaël Zasso) [#26630](https://github.com/nodejs/node/pull/26630)
* \[[`4274542a39`](https://github.com/nodejs/node/commit/4274542a39)] - **(SEMVER-MINOR)** **src**: deprecate AddPromiseHook() (Anna Henningsen) [#26529](https://github.com/nodejs/node/pull/26529)
* \[[`479ef60013`](https://github.com/nodejs/node/commit/479ef60013)] - **src**: remove redundant cast in util-inl.h (gengjiawen) [#26410](https://github.com/nodejs/node/pull/26410)
* \[[`44f62607a1`](https://github.com/nodejs/node/commit/44f62607a1)] - **src**: remove redundant cast in string\_search.h (gengjiawen) [#26426](https://github.com/nodejs/node/pull/26426)
* \[[`dc9f1c60e2`](https://github.com/nodejs/node/commit/dc9f1c60e2)] - **src**: remove unused function in cares\_wrap.cc (gengjiawen) [#26429](https://github.com/nodejs/node/pull/26429)
* \[[`e418b4f650`](https://github.com/nodejs/node/commit/e418b4f650)] - **src**: fix if indent in node\_http2.cc (gengjiawen) [#26396](https://github.com/nodejs/node/pull/26396)
* \[[`0bff833df9`](https://github.com/nodejs/node/commit/0bff833df9)] - **src**: remove unused struct in test\_inspector\_socket.cc (gengjiawen) [#26284](https://github.com/nodejs/node/pull/26284)
* \[[`281eb0f928`](https://github.com/nodejs/node/commit/281eb0f928)] - **src**: extra-semi warning in node\_platform.h (Jeremy Apthorp) [#26330](https://github.com/nodejs/node/pull/26330)
* \[[`0fa3a512c1`](https://github.com/nodejs/node/commit/0fa3a512c1)] - **src**: reduce to simple `const char*` in OptionsParser (ZYSzys) [#26297](https://github.com/nodejs/node/pull/26297)
* \[[`44fd3a2fce`](https://github.com/nodejs/node/commit/44fd3a2fce)] - **src**: remove already elevated Isolate namespce (Juan José Arboleda) [#26294](https://github.com/nodejs/node/pull/26294)
* \[[`5cd96b367b`](https://github.com/nodejs/node/commit/5cd96b367b)] - **src**: avoid race condition in tracing code (Anna Henningsen) [#25624](https://github.com/nodejs/node/pull/25624)
* \[[`452b6aad5a`](https://github.com/nodejs/node/commit/452b6aad5a)] - **src**: remove redundant cast in PipeWrap::Fchmod (gengjiawen) [#26242](https://github.com/nodejs/node/pull/26242)
* \[[`55d3be7e9e`](https://github.com/nodejs/node/commit/55d3be7e9e)] - **src**: simplify native immediate by using v8::Global (Anna Henningsen) [#26254](https://github.com/nodejs/node/pull/26254)
* \[[`a92286d6da`](https://github.com/nodejs/node/commit/a92286d6da)] - **src**: ensure no more platform foreground tasks after Deinit (Clemens Hammacher) [#25653](https://github.com/nodejs/node/pull/25653)
* \[[`f4be1767a5`](https://github.com/nodejs/node/commit/f4be1767a5)] - **src**: dispose of V8 platform in `process.exit()` (Anna Henningsen) [#25061](https://github.com/nodejs/node/pull/25061)
* \[[`c2dab8e642`](https://github.com/nodejs/node/commit/c2dab8e642)] - **(SEMVER-MINOR)** **src,test**: add public wrapper for Environment::GetCurrent (Shelley Vohr) [#23676](https://github.com/nodejs/node/pull/23676)
* \[[`99c555a1de`](https://github.com/nodejs/node/commit/99c555a1de)] - **stream**: ensure writable.destroy() emits error once (Luigi Pinca) [#26057](https://github.com/nodejs/node/pull/26057)
* \[[`a1b253a416`](https://github.com/nodejs/node/commit/a1b253a416)] - **(SEMVER-MINOR)** **stream**: add auto-destroy mode (Mathias Buus) [#22795](https://github.com/nodejs/node/pull/22795)
* \[[`cda0d16414`](https://github.com/nodejs/node/commit/cda0d16414)] - **test**: unskip copyfile permission test (cjihrig) [#27241](https://github.com/nodejs/node/pull/27241)
* \[[`1fc2c5bed1`](https://github.com/nodejs/node/commit/1fc2c5bed1)] - **test**: move known issue test to parallel (cjihrig) [#27241](https://github.com/nodejs/node/pull/27241)
* \[[`57eb6b2129`](https://github.com/nodejs/node/commit/57eb6b2129)] - **test**: fix error code typo (cjihrig) [#27024](https://github.com/nodejs/node/pull/27024)
* \[[`ec02117232`](https://github.com/nodejs/node/commit/ec02117232)] - **test**: add fs.watchFile() + worker.terminate() test (Anna Henningsen) [#21179](https://github.com/nodejs/node/pull/21179)
* \[[`f76776b354`](https://github.com/nodejs/node/commit/f76776b354)] - **test**: update test for libuv update (cjihrig) [#26707](https://github.com/nodejs/node/pull/26707)
* \[[`7b76acb6c8`](https://github.com/nodejs/node/commit/7b76acb6c8)] - **test**: fix expectation in test-bootstrap-modules (Myles Borins) [#27727](https://github.com/nodejs/node/pull/27727)
* \[[`583dc5f42c`](https://github.com/nodejs/node/commit/583dc5f42c)] - **test**: add known\_issues test for fs.copyFile() (Rich Trott) [#26939](https://github.com/nodejs/node/pull/26939)
* \[[`d22b9130a2`](https://github.com/nodejs/node/commit/d22b9130a2)] - **test**: add test about unencrypted PKCS#8 private key for RSA (Daiki Ihara) [#26898](https://github.com/nodejs/node/pull/26898)
* \[[`38d85623bd`](https://github.com/nodejs/node/commit/38d85623bd)] - **test**: use assert.rejects() and assert.throws() (Richard Lau) [#27207](https://github.com/nodejs/node/pull/27207)
* \[[`4733a56caf`](https://github.com/nodejs/node/commit/4733a56caf)] - **test**: move tick.js from test/async-hooks to test/common (Artur Hayrapetyan) [#23551](https://github.com/nodejs/node/pull/23551)
* \[[`fe21dd39c3`](https://github.com/nodejs/node/commit/fe21dd39c3)] - **test**: mark some known flakes (Refael Ackermann) [#27225](https://github.com/nodejs/node/pull/27225)
* \[[`3ca5f23ea7`](https://github.com/nodejs/node/commit/3ca5f23ea7)] - **test**: fix zlib-brotli output assumptions (Adam Majer) [#25697](https://github.com/nodejs/node/pull/25697)
* \[[`1afd614104`](https://github.com/nodejs/node/commit/1afd614104)] - **test**: rewrite fs {f}utimes test file (Jeremiah Senkpiel) [#25656](https://github.com/nodejs/node/pull/25656)
* \[[`48505d8321`](https://github.com/nodejs/node/commit/48505d8321)] - **test**: remove unused uncaughtException handler (Anna Henningsen) [#25641](https://github.com/nodejs/node/pull/25641)
* \[[`301f5fb32e`](https://github.com/nodejs/node/commit/301f5fb32e)] - **test**: fix sequential/test-performance delay (Anatoli Papirovski) [#25695](https://github.com/nodejs/node/pull/25695)
* \[[`52d321d836`](https://github.com/nodejs/node/commit/52d321d836)] - **test**: remove common.isOSXMojave (Rich Trott) [#25658](https://github.com/nodejs/node/pull/25658)
* \[[`6ba4ac007a`](https://github.com/nodejs/node/commit/6ba4ac007a)] - **test**: remove known\_issues/test-cluster-bind-privileged-port (Rich Trott) [#25649](https://github.com/nodejs/node/pull/25649)
* \[[`5d69e69b38`](https://github.com/nodejs/node/commit/5d69e69b38)] - **test**: fix pummel/test-exec (Rich Trott) [#25677](https://github.com/nodejs/node/pull/25677)
* \[[`710f650032`](https://github.com/nodejs/node/commit/710f650032)] - **test**: add stdio checks to cp-exec-maxBuffer (Jeremiah Senkpiel) [#24951](https://github.com/nodejs/node/pull/24951)
* \[[`fbf8e60679`](https://github.com/nodejs/node/commit/fbf8e60679)] - **test**: revoke flaky designation for tests (Gireesh Punathil) [#25611](https://github.com/nodejs/node/pull/25611)
* \[[`554b562d2b`](https://github.com/nodejs/node/commit/554b562d2b)] - **test**: remove potential race condition in https renegotiation test (Rich Trott) [#25601](https://github.com/nodejs/node/pull/25601)
* \[[`b27e3c8b89`](https://github.com/nodejs/node/commit/b27e3c8b89)] - **test**: replace common.PORT with `0` in https renegotiation test (Rich Trott) [#25599](https://github.com/nodejs/node/pull/25599)
* \[[`faf1a18640`](https://github.com/nodejs/node/commit/faf1a18640)] - **test**: changed function to arrow function (yathamravali) [#25441](https://github.com/nodejs/node/pull/25441)
* \[[`7bae3d841b`](https://github.com/nodejs/node/commit/7bae3d841b)] - **test**: use stronger curves for keygen (Daniel Bevenius) [#25564](https://github.com/nodejs/node/pull/25564)
* \[[`b4b4c117fd`](https://github.com/nodejs/node/commit/b4b4c117fd)] - **test**: relax chunk count expectations (Gireesh Punathil) [#25415](https://github.com/nodejs/node/pull/25415)
* \[[`6b6c628b02`](https://github.com/nodejs/node/commit/6b6c628b02)] - **test**: improve code coverage for i18n (Michael Dawson) [#25428](https://github.com/nodejs/node/pull/25428)
* \[[`d5316e0a1b`](https://github.com/nodejs/node/commit/d5316e0a1b)] - **test**: use fipsMode instead of common.hasFipsCrypto (Daniel Bevenius) [#25510](https://github.com/nodejs/node/pull/25510)
* \[[`48482b02f8`](https://github.com/nodejs/node/commit/48482b02f8)] - **test**: do not use uninitialized memory in common flags check (Anna Henningsen) [#25475](https://github.com/nodejs/node/pull/25475)
* \[[`3e9d9927ee`](https://github.com/nodejs/node/commit/3e9d9927ee)] - **test**: prepare test-hash-seed for CI (Rich Trott) [#25522](https://github.com/nodejs/node/pull/25522)
* \[[`1592ebd652`](https://github.com/nodejs/node/commit/1592ebd652)] - **test**: refactor min() in test-hash-seed (Rich Trott) [#25522](https://github.com/nodejs/node/pull/25522)
* \[[`f4da641c31`](https://github.com/nodejs/node/commit/f4da641c31)] - **test**: add check for wrk to test-keep-alive (Rich Trott) [#25516](https://github.com/nodejs/node/pull/25516)
* \[[`3fcc44d46d`](https://github.com/nodejs/node/commit/3fcc44d46d)] - **test**: fix test-repl timeout and tmpdir refresh (Brian White) [#25425](https://github.com/nodejs/node/pull/25425)
* \[[`e5b305d4fe`](https://github.com/nodejs/node/commit/e5b305d4fe)] - **test**: refactor pummel/test-net-pingpong (Rich Trott) [#25485](https://github.com/nodejs/node/pull/25485)
* \[[`47cf1a2f70`](https://github.com/nodejs/node/commit/47cf1a2f70)] - **test**: refactor pummel/test-net-many-clients (Rich Trott) [#25485](https://github.com/nodejs/node/pull/25485)
* \[[`017b99a881`](https://github.com/nodejs/node/commit/017b99a881)] - **test**: refactor pummel/test-net-connect-econnrefused (Rich Trott) [#25485](https://github.com/nodejs/node/pull/25485)
* \[[`e3437131b6`](https://github.com/nodejs/node/commit/e3437131b6)] - **test**: refactor pummel/test-keep-alive (Rich Trott) [#25485](https://github.com/nodejs/node/pull/25485)
* \[[`1b6dfac1f0`](https://github.com/nodejs/node/commit/1b6dfac1f0)] - **test**: add test for fs.lchmod (ZYSzys) [#25439](https://github.com/nodejs/node/pull/25439)
* \[[`0a80e61e0f`](https://github.com/nodejs/node/commit/0a80e61e0f)] - **test**: rework ephemeralkeyinfo to run in parallel (Sam Roberts) [#25409](https://github.com/nodejs/node/pull/25409)
* \[[`266a07d09d`](https://github.com/nodejs/node/commit/266a07d09d)] - **test**: check for tls renegotiation errors (Sam Roberts) [#25437](https://github.com/nodejs/node/pull/25437)
* \[[`8bebbd6ec1`](https://github.com/nodejs/node/commit/8bebbd6ec1)] - **test**: fix test-net-connect-econnrefused (again) (Rich Trott) [#25438](https://github.com/nodejs/node/pull/25438)
* \[[`d2df34d870`](https://github.com/nodejs/node/commit/d2df34d870)] - **test**: remove unnecessary skipIfWorker() (Rich Trott) [#25427](https://github.com/nodejs/node/pull/25427)
* \[[`9833bffaca`](https://github.com/nodejs/node/commit/9833bffaca)] - **test**: improve test coverage of native crypto code (Tobias Nießen) [#25400](https://github.com/nodejs/node/pull/25400)
* \[[`c8153ce411`](https://github.com/nodejs/node/commit/c8153ce411)] - **test**: move require('https') to after crypto check (Daniel Bevenius) [#25388](https://github.com/nodejs/node/pull/25388)
* \[[`05f9873de4`](https://github.com/nodejs/node/commit/05f9873de4)] - **test**: fix test-net-connect-econnrefused (Rich Trott) [#25389](https://github.com/nodejs/node/pull/25389)
* \[[`771213ad18`](https://github.com/nodejs/node/commit/771213ad18)] - **test**: remove test/pummel/test-http-client-reconnect-bug.js (Rich Trott) [#25387](https://github.com/nodejs/node/pull/25387)
* \[[`82dd321e91`](https://github.com/nodejs/node/commit/82dd321e91)] - **test**: refactor test-fs-watch-non-recursive (Rich Trott) [#25386](https://github.com/nodejs/node/pull/25386)
* \[[`82bc4ac226`](https://github.com/nodejs/node/commit/82bc4ac226)] - **test**: fix test/pummel/test-fs-watch-non-recursive.js (Rich Trott) [#25386](https://github.com/nodejs/node/pull/25386)
* \[[`af2d22a804`](https://github.com/nodejs/node/commit/af2d22a804)] - **test**: fix test/pummel/test-fs-watch-file.js (Rich Trott) [#25384](https://github.com/nodejs/node/pull/25384)
* \[[`95f311c664`](https://github.com/nodejs/node/commit/95f311c664)] - **test**: fix test/pummel/test-fs-largefile.js (Rich Trott) [#25372](https://github.com/nodejs/node/pull/25372)
* \[[`c103e98ad6`](https://github.com/nodejs/node/commit/c103e98ad6)] - **test**: more tests for internal/util/types (ZYSzys) [#25225](https://github.com/nodejs/node/pull/25225)
* \[[`4a22299bb2`](https://github.com/nodejs/node/commit/4a22299bb2)] - **test**: tune test-uv-threadpool-schedule (Rich Trott) [#25358](https://github.com/nodejs/node/pull/25358)
* \[[`26165ac1b6`](https://github.com/nodejs/node/commit/26165ac1b6)] - **test**: remove redundant fchmod test (ZYSzys) [#25282](https://github.com/nodejs/node/pull/25282)
* \[[`f58dbb35b1`](https://github.com/nodejs/node/commit/f58dbb35b1)] - **test**: move test-tls-securepair-client out of pummel (Rich Trott) [#25222](https://github.com/nodejs/node/pull/25222)
* \[[`26b69fd050`](https://github.com/nodejs/node/commit/26b69fd050)] - **test**: fix test-tls-securepair-client (Rich Trott) [#25222](https://github.com/nodejs/node/pull/25222)
* \[[`374a07d4a7`](https://github.com/nodejs/node/commit/374a07d4a7)] - **test**: http2 origin length ERR\_HTTP2\_ORIGIN\_LENGTH (Furqan Shaikh) [#25296](https://github.com/nodejs/node/pull/25296)
* \[[`acd6915299`](https://github.com/nodejs/node/commit/acd6915299)] - **test**: fix test-benchmark-zlib (Rich Trott) [#25365](https://github.com/nodejs/node/pull/25365)
* \[[`8a4fe98ec9`](https://github.com/nodejs/node/commit/8a4fe98ec9)] - **test**: set umask explicitly (Thomas Chung) [#25213](https://github.com/nodejs/node/pull/25213)
* \[[`d9aa19f98e`](https://github.com/nodejs/node/commit/d9aa19f98e)] - **test**: make sure tmpdir is created before using it (Joyee Cheung) [#25224](https://github.com/nodejs/node/pull/25224)
* \[[`4155b7431a`](https://github.com/nodejs/node/commit/4155b7431a)] - **test**: remove unused --expose-native-as V8 flag (peterwmwong) [#25275](https://github.com/nodejs/node/pull/25275)
* \[[`5095d6cb70`](https://github.com/nodejs/node/commit/5095d6cb70)] - **test**: mark test-util-callbackify flaky on AIX (Rich Trott) [#25284](https://github.com/nodejs/node/pull/25284)
* \[[`9eb677b21f`](https://github.com/nodejs/node/commit/9eb677b21f)] - **test**: slightly refactor test-child-process-execsync (Denys Otrishko) [#25227](https://github.com/nodejs/node/pull/25227)
* \[[`fcc03c1d44`](https://github.com/nodejs/node/commit/fcc03c1d44)] - **test**: remove try/catch in common.isMainThread (Rich Trott) [#25249](https://github.com/nodejs/node/pull/25249)
* \[[`d44a93ad94`](https://github.com/nodejs/node/commit/d44a93ad94)] - **test**: regression test for uv threadpool congestion (Gireesh Punathil) [#23099](https://github.com/nodejs/node/pull/23099)
* \[[`0fe72b88a0`](https://github.com/nodejs/node/commit/0fe72b88a0)] - **test**: mark two tests as flaky in AIX (Gireesh Punathil) [#25126](https://github.com/nodejs/node/pull/25126)
* \[[`19ed5c7428`](https://github.com/nodejs/node/commit/19ed5c7428)] - **test**: refactor stdio handling in test-esm-cjs-main (Richard Lau) [#25169](https://github.com/nodejs/node/pull/25169)
* \[[`5f72f393f5`](https://github.com/nodejs/node/commit/5f72f393f5)] - **test**: refactor test-esm-namespace.mjs (Rich Trott) [#25117](https://github.com/nodejs/node/pull/25117)
* \[[`6014b476c3`](https://github.com/nodejs/node/commit/6014b476c3)] - **test**: fix test-tls-session-timeout (Rich Trott) [#25188](https://github.com/nodejs/node/pull/25188)
* \[[`facf36e6df`](https://github.com/nodejs/node/commit/facf36e6df)] - **test**: mark test-trace-events-api-worker-disabled flaky (Rich Trott) [#25197](https://github.com/nodejs/node/pull/25197)
* \[[`8d791ab001`](https://github.com/nodejs/node/commit/8d791ab001)] - **test**: remove Files: comment processing from Python test runner (Rich Trott) [#25183](https://github.com/nodejs/node/pull/25183)
* \[[`424f254e15`](https://github.com/nodejs/node/commit/424f254e15)] - **test**: add hasCrypto check to common flags check (Daniel Bevenius) [#25147](https://github.com/nodejs/node/pull/25147)
* \[[`ead4bb6fb5`](https://github.com/nodejs/node/commit/ead4bb6fb5)] - **test**: verify input flags (Ruben Bridgewater) [#24876](https://github.com/nodejs/node/pull/24876)
* \[[`1ff2f4b6a7`](https://github.com/nodejs/node/commit/1ff2f4b6a7)] - **test**: add signal check to test-esm-cjs-main (Rich Trott) [#25073](https://github.com/nodejs/node/pull/25073)
* \[[`20980a3a28`](https://github.com/nodejs/node/commit/20980a3a28)] - **(SEMVER-MINOR)** **test**: test TLS client authentication (Sam Roberts) [#24733](https://github.com/nodejs/node/pull/24733)
* \[[`f015eec2ba`](https://github.com/nodejs/node/commit/f015eec2ba)] - **test**: complete console.assert() coverage (Rich Trott) [#26827](https://github.com/nodejs/node/pull/26827)
* \[[`9ca4ce3cc3`](https://github.com/nodejs/node/commit/9ca4ce3cc3)] - **test**: fix test-console-stdio-setters to test setters (Rich Trott) [#26796](https://github.com/nodejs/node/pull/26796)
* \[[`44660c1757`](https://github.com/nodejs/node/commit/44660c1757)] - **test**: optimize test-http2-large-file (Rich Trott) [#26737](https://github.com/nodejs/node/pull/26737)
* \[[`8855395a19`](https://github.com/nodejs/node/commit/8855395a19)] - **test**: fix test case in test-http2-respond-file-304.js (gengjiawen) [#26565](https://github.com/nodejs/node/pull/26565)
* \[[`4378042452`](https://github.com/nodejs/node/commit/4378042452)] - **test**: use semicolon for clarity (gengjiawen) [#26566](https://github.com/nodejs/node/pull/26566)
* \[[`7f3b27fa4a`](https://github.com/nodejs/node/commit/7f3b27fa4a)] - **test**: fix test by removing node-inspect/lib/\_inspect (Ruben Bridgewater) [#26619](https://github.com/nodejs/node/pull/26619)
* \[[`6bc7fd9b3c`](https://github.com/nodejs/node/commit/6bc7fd9b3c)] - **test**: fix compiler warning in test\_string.c (Daniel Bevenius) [#26539](https://github.com/nodejs/node/pull/26539)
* \[[`f0acdfd445`](https://github.com/nodejs/node/commit/f0acdfd445)] - **test**: mark `test-worker-prof` as Flaky on ARM (Refael Ackermann) [#26557](https://github.com/nodejs/node/pull/26557)
* \[[`cc0bb02e86`](https://github.com/nodejs/node/commit/cc0bb02e86)] - **test**: rewrite ocsp test to run in parallel (Sam Roberts) [#26460](https://github.com/nodejs/node/pull/26460)
* \[[`ee9694668b`](https://github.com/nodejs/node/commit/ee9694668b)] - **test**: improve code coverage in timers (Juan José Arboleda) [#26310](https://github.com/nodejs/node/pull/26310)
* \[[`60880d79a5`](https://github.com/nodejs/node/commit/60880d79a5)] - **test**: remove flaky designation for test\_threadsafe\_function (Rich Trott) [#26403](https://github.com/nodejs/node/pull/26403)
* \[[`6d4731e46e`](https://github.com/nodejs/node/commit/6d4731e46e)] - **test**: improve test coverage in perf\_hooks (Juan José Arboleda) [#26290](https://github.com/nodejs/node/pull/26290)
* \[[`7d6afb3dbf`](https://github.com/nodejs/node/commit/7d6afb3dbf)] - **test**: remove duplicated buffer negative allocation test (ZYSzys) [#26160](https://github.com/nodejs/node/pull/26160)
* \[[`dcf1310351`](https://github.com/nodejs/node/commit/dcf1310351)] - **test**: only inspect on failure (Ruben Bridgewater) [#26360](https://github.com/nodejs/node/pull/26360)
* \[[`a87c605e1c`](https://github.com/nodejs/node/commit/a87c605e1c)] - **test**: remove s\_client from test-tls-ci-reneg-attack (Rich Trott) [#25700](https://github.com/nodejs/node/pull/25700)
* \[[`3fab8be211`](https://github.com/nodejs/node/commit/3fab8be211)] - **test**: replace Google servers with localhost (Rich Trott) [#25694](https://github.com/nodejs/node/pull/25694)
* \[[`7cceecfd52`](https://github.com/nodejs/node/commit/7cceecfd52)] - **test**: increase error information in test-cli-syntax-\* (Rich Trott) [#25021](https://github.com/nodejs/node/pull/25021)
* \[[`92792f04be`](https://github.com/nodejs/node/commit/92792f04be)] - **test**: split test-cli-syntax into multiple tests (Rich Trott) [#24922](https://github.com/nodejs/node/pull/24922)
* \[[`fe8e07ddd9`](https://github.com/nodejs/node/commit/fe8e07ddd9)] - **(SEMVER-MINOR)** **test**: assert on client and server side seperately (Sam Roberts) [#25381](https://github.com/nodejs/node/pull/25381)
* \[[`26288c8ab7`](https://github.com/nodejs/node/commit/26288c8ab7)] - **test**: fix module loading error for AIX 7.1 (Richard Lau) [#25418](https://github.com/nodejs/node/pull/25418)
* \[[`38c9d2bfea`](https://github.com/nodejs/node/commit/38c9d2bfea)] - **test**: add missing tmpdir.refresh() in recently-added test (Rich Trott) [#25098](https://github.com/nodejs/node/pull/25098)
* \[[`3eab58f3ed`](https://github.com/nodejs/node/commit/3eab58f3ed)] - **test,console**: add testing for monkeypatching of console stdio (Rich Trott) [#26561](https://github.com/nodejs/node/pull/26561)
* \[[`2319bc55ca`](https://github.com/nodejs/node/commit/2319bc55ca)] - **(SEMVER-MINOR)** **tls**: make tls.connect() accept a timeout option (Luigi Pinca) [#25517](https://github.com/nodejs/node/pull/25517)
* \[[`858a42e4ce`](https://github.com/nodejs/node/commit/858a42e4ce)] - **tls**: do not confuse TLSSocket and Socket (Sam Roberts) [#25153](https://github.com/nodejs/node/pull/25153)
* \[[`8dd8033519`](https://github.com/nodejs/node/commit/8dd8033519)] - **(SEMVER-MINOR)** **tls**: workaround handshakedone in renegotiation (Shigeki Ohtsu) [#25381](https://github.com/nodejs/node/pull/25381)
* \[[`d3ebad2d6d`](https://github.com/nodejs/node/commit/d3ebad2d6d)] - **(SEMVER-MINOR)** **tls**: add min/max protocol version options (Sam Roberts) [#24405](https://github.com/nodejs/node/pull/24405)
* \[[`e01f3d362a`](https://github.com/nodejs/node/commit/e01f3d362a)] - **tools**: add `12.x` to alternative docs versions (Richard Lau) [#27658](https://github.com/nodejs/node/pull/27658)
* \[[`0fd4b35336`](https://github.com/nodejs/node/commit/0fd4b35336)] - **tools**: update LICENSE and tools/icu/current\_ver.dep (Ujjwal Sharma) [#27361](https://github.com/nodejs/node/pull/27361)
* \[[`c6a2be2d68`](https://github.com/nodejs/node/commit/c6a2be2d68)] - **tools**: make test.py Queue part Python 3 compatible (gengjiawen) [#25701](https://github.com/nodejs/node/pull/25701)
* \[[`40f5d15468`](https://github.com/nodejs/node/commit/40f5d15468)] - **tools**: make mkssldef.py Python 3 compatible (Sakthipriyan Vairamani (thefourtheye)) [#25584](https://github.com/nodejs/node/pull/25584)
* \[[`f8800c90b1`](https://github.com/nodejs/node/commit/f8800c90b1)] - **tools**: improve valgrind support (Anna Henningsen) [#25498](https://github.com/nodejs/node/pull/25498)
* \[[`b8b585376e`](https://github.com/nodejs/node/commit/b8b585376e)] - **tools**: update ESLint to 5.12.1 (cjihrig) [#25573](https://github.com/nodejs/node/pull/25573)
* \[[`e6d1eb3f77`](https://github.com/nodejs/node/commit/e6d1eb3f77)] - **tools**: lint for use of internalBinding() (cjihrig) [#25395](https://github.com/nodejs/node/pull/25395)
* \[[`21500a81fc`](https://github.com/nodejs/node/commit/21500a81fc)] - **tools**: update crypo check rule (cjihrig) [#25399](https://github.com/nodejs/node/pull/25399)
* \[[`a254b930f5`](https://github.com/nodejs/node/commit/a254b930f5)] - **tools**: add openssl-cli to macos-firewall.sh (Daniel Bevenius) [#25385](https://github.com/nodejs/node/pull/25385)
* \[[`21dc7cc3ac`](https://github.com/nodejs/node/commit/21dc7cc3ac)] - **tools**: update ESLint to 5.12.0 (cjihrig) [#25347](https://github.com/nodejs/node/pull/25347)
* \[[`225dfed85f`](https://github.com/nodejs/node/commit/225dfed85f)] - **tools**: replace NULL with nullptr (Juan José Arboleda) [#25179](https://github.com/nodejs/node/pull/25179)
* \[[`b7095ba764`](https://github.com/nodejs/node/commit/b7095ba764)] - **tools**: enable no-useless-catch lint rule (cjihrig) [#25236](https://github.com/nodejs/node/pull/25236)
* \[[`0098cde626`](https://github.com/nodejs/node/commit/0098cde626)] - **tools**: update ESLint to 5.11.1 (cjihrig) [#25236](https://github.com/nodejs/node/pull/25236)
* \[[`629fb36dce`](https://github.com/nodejs/node/commit/629fb36dce)] - **tools**: update ESLint to 5.11.0 (cjihrig) [#25191](https://github.com/nodejs/node/pull/25191)
* \[[`6e329a8dac`](https://github.com/nodejs/node/commit/6e329a8dac)] - **tools**: update certdata.txt (Sam Roberts) [#25113](https://github.com/nodejs/node/pull/25113)
* \[[`3445080c33`](https://github.com/nodejs/node/commit/3445080c33)] - **tools**: tidy function arguments in eslint rules (Rich Trott) [#26668](https://github.com/nodejs/node/pull/26668)
* \[[`700df16a04`](https://github.com/nodejs/node/commit/700df16a04)] - **tools**: update to mdast-util-to-hast v3.0.2 (Sam Ruby) [#22140](https://github.com/nodejs/node/pull/22140)
* \[[`6586003bfe`](https://github.com/nodejs/node/commit/6586003bfe)] - **tools**: fix test.py --shell (Yang Guo) [#26449](https://github.com/nodejs/node/pull/26449)
* \[[`481929653e`](https://github.com/nodejs/node/commit/481929653e)] - **tools**: roll inspector\_protocol to f67ec5 (Pavel Feldman) [#26303](https://github.com/nodejs/node/pull/26303)
* \[[`416aa6e4e7`](https://github.com/nodejs/node/commit/416aa6e4e7)] - **tools**: update extend to 3.0.2 (Rich Trott) [#26392](https://github.com/nodejs/node/pull/26392)
* \[[`d4a8769b31`](https://github.com/nodejs/node/commit/d4a8769b31)] - **tools**: remove unneeded .gitignore entries (Rich Trott) [#26370](https://github.com/nodejs/node/pull/26370)
* \[[`3ded3df714`](https://github.com/nodejs/node/commit/3ded3df714)] - **(SEMVER-MINOR)** **tools, icu**: actually failover if there are multiple URLs (Steven R. Loomis) [#23715](https://github.com/nodejs/node/pull/23715)
* \[[`437a90cfe4`](https://github.com/nodejs/node/commit/437a90cfe4)] - **trace\_events**: remove usage of require('util') (dnlup) [#26822](https://github.com/nodejs/node/pull/26822)
* \[[`4285b57e78`](https://github.com/nodejs/node/commit/4285b57e78)] - **(SEMVER-MINOR)** **tty**: add hasColors function (Ruben Bridgewater) [#26247](https://github.com/nodejs/node/pull/26247)
* \[[`3f51a60092`](https://github.com/nodejs/node/commit/3f51a60092)] - **url**: return backslashes from fileURLToPath on win (Kevin Smith) [#25349](https://github.com/nodejs/node/pull/25349)
* \[[`ca4f0dbec1`](https://github.com/nodejs/node/commit/ca4f0dbec1)] - **(SEMVER-MINOR)** **url**: support LF, CR and TAB in pathToFileURL (Charles Samborski) [#23720](https://github.com/nodejs/node/pull/23720)
* \[[`65392be665`](https://github.com/nodejs/node/commit/65392be665)] - **util**: fixes type in argument type validation error (Ankur Oberoi) [#25103](https://github.com/nodejs/node/pull/25103)
* \[[`4e2ceba908`](https://github.com/nodejs/node/commit/4e2ceba908)] - **util**: fix util.inspect with proxied function (Weijia Wang) [#25244](https://github.com/nodejs/node/pull/25244)
* \[[`5dd31bcf07`](https://github.com/nodejs/node/commit/5dd31bcf07)] - **util**: simplify code (Kazushi Kitaya) [#25162](https://github.com/nodejs/node/pull/25162)
* \[[`3f281b2d70`](https://github.com/nodejs/node/commit/3f281b2d70)] - **util**: remove todo (Ruben Bridgewater) [#24982](https://github.com/nodejs/node/pull/24982)
* \[[`d9d31e8d51`](https://github.com/nodejs/node/commit/d9d31e8d51)] - **(SEMVER-MINOR)** **vm**: allow `cachedData` to also be TypedArray|DataView (Benjamin Chen) [#22921](https://github.com/nodejs/node/pull/22921)
* \[[`91c4d280f4`](https://github.com/nodejs/node/commit/91c4d280f4)] - **win, build**: fix building addons on Windows (Bartosz Sosnowski) [#25108](https://github.com/nodejs/node/pull/25108)
* \[[`680ef36675`](https://github.com/nodejs/node/commit/680ef36675)] - **win,build**: update Windows build documentation (Jon Kunkee) [#25995](https://github.com/nodejs/node/pull/25995)
* \[[`fa74b3eb03`](https://github.com/nodejs/node/commit/fa74b3eb03)] - **win,build**: scope NASM warning to only x64 and x86 (Jon Kunkee) [#25995](https://github.com/nodejs/node/pull/25995)
* \[[`7e89684b8c`](https://github.com/nodejs/node/commit/7e89684b8c)] - **win,build**: add ARM64 sections to common.gypi (Jon Kunkee) [#25995](https://github.com/nodejs/node/pull/25995)
* \[[`103635c23b`](https://github.com/nodejs/node/commit/103635c23b)] - **win,build**: add ARM64 support to vcbuild.bat (Jon Kunkee) [#25995](https://github.com/nodejs/node/pull/25995)
* \[[`a762907f8e`](https://github.com/nodejs/node/commit/a762907f8e)] - **win,build**: add arbitrary and binlog options (Jon Kunkee) [#25994](https://github.com/nodejs/node/pull/25994)
* \[[`53e9c8508c`](https://github.com/nodejs/node/commit/53e9c8508c)] - **(SEMVER-MINOR)** **zlib**: add brotli support (Anna Henningsen) [#24938](https://github.com/nodejs/node/pull/24938)
* \[[`dd8d1dabd7`](https://github.com/nodejs/node/commit/dd8d1dabd7)] - **zlib**: split JS code as prep for non-zlib-backed streams (Anna Henningsen) [#24939](https://github.com/nodejs/node/pull/24939)

<a id="10.15.3"></a>

## 2019-03-05, Version 10.15.3 'Dubnium' (LTS), @BethGriggs

### Notable Changes

* **doc**
  * add antsmartian to collaborators (Anto Aravinth) [#24655](https://github.com/nodejs/node/pull/24655)
* **http**
  * fix error check in Execute() (Brian White) [#25863](https://github.com/nodejs/node/pull/25863)
* **stream**
  * fix end-of-stream for HTTP/2 (Anna Henningsen) [#24926](https://github.com/nodejs/node/pull/24926)

### Commits

* \[[`732088dd44`](https://github.com/nodejs/node/commit/732088dd44)] - **assert**: fix loose deepEqual map comparison (Ruben Bridgewater) [#24749](https://github.com/nodejs/node/pull/24749)
* \[[`5a81a4f6cd`](https://github.com/nodejs/node/commit/5a81a4f6cd)] - **assert,util**: fix sparse array comparison (Ruben Bridgewater) [#24749](https://github.com/nodejs/node/pull/24749)
* \[[`bd08ede3ab`](https://github.com/nodejs/node/commit/bd08ede3ab)] - **buffer**: remove checkNumberType() (cjihrig) [#24815](https://github.com/nodejs/node/pull/24815)
* \[[`15756e0acc`](https://github.com/nodejs/node/commit/15756e0acc)] - **build**: set `-blibpath:` for AIX (Richard Lau) [#25447](https://github.com/nodejs/node/pull/25447)
* \[[`fde56fa748`](https://github.com/nodejs/node/commit/fde56fa748)] - **build**: make lint-addon-docs run only if needed (Daniel Bevenius) [#24993](https://github.com/nodejs/node/pull/24993)
* \[[`8d4d3963e0`](https://github.com/nodejs/node/commit/8d4d3963e0)] - **build**: fix compiler version detection (Richard Lau) [#24879](https://github.com/nodejs/node/pull/24879)
* \[[`552a5c080a`](https://github.com/nodejs/node/commit/552a5c080a)] - **build**: add '.git' to 'make lint-py' exclude list (cclauss) [#24802](https://github.com/nodejs/node/pull/24802)
* \[[`02e9a93d2c`](https://github.com/nodejs/node/commit/02e9a93d2c)] - **build**: fix check-xz for platforms defaulting to sh (Rod Vagg) [#24841](https://github.com/nodejs/node/pull/24841)
* \[[`920cab76cf`](https://github.com/nodejs/node/commit/920cab76cf)] - **build**: make tar.xz creation opt-out, fail if no xz (Rod Vagg) [#24551](https://github.com/nodejs/node/pull/24551)
* \[[`b72bc11a93`](https://github.com/nodejs/node/commit/b72bc11a93)] - **build**: fix line length off by one error (Ruben Bridgewater) [#24748](https://github.com/nodejs/node/pull/24748)
* \[[`18d81c94a6`](https://github.com/nodejs/node/commit/18d81c94a6)] - **build**: add line break as soon tests are done (Ruben Bridgewater) [#24748](https://github.com/nodejs/node/pull/24748)
* \[[`c57008e549`](https://github.com/nodejs/node/commit/c57008e549)] - **build**: fix c++ code coverage on macOS (Refael Ackermann) [#24520](https://github.com/nodejs/node/pull/24520)
* \[[`95a3b3e142`](https://github.com/nodejs/node/commit/95a3b3e142)] - **build**: replace `-not` with `!` in `find` (Rich Trott) [#24635](https://github.com/nodejs/node/pull/24635)
* \[[`32d93cde01`](https://github.com/nodejs/node/commit/32d93cde01)] - **build, tools, win**: add .S files support to GYP (Bartosz Sosnowski) [#24553](https://github.com/nodejs/node/pull/24553)
* \[[`a2155e1010`](https://github.com/nodejs/node/commit/a2155e1010)] - **crypto**: harden bignum-to-binary conversions (Ben Noordhuis) [#24719](https://github.com/nodejs/node/pull/24719)
* \[[`6f4e30d029`](https://github.com/nodejs/node/commit/6f4e30d029)] - **crypto**: convert to arrow function (yosuke ota) [#24597](https://github.com/nodejs/node/pull/24597)
* \[[`3b9fd0881a`](https://github.com/nodejs/node/commit/3b9fd0881a)] - **deps**: V8: cherry-pick 3cc6919 (milad) [#25872](https://github.com/nodejs/node/pull/25872)
* \[[`70322ea2ca`](https://github.com/nodejs/node/commit/70322ea2ca)] - **deps**: V8: cherry-pick d0468de (Milad Farazmand) [#25827](https://github.com/nodejs/node/pull/25827)
* \[[`c9a3e401da`](https://github.com/nodejs/node/commit/c9a3e401da)] - **deps**: cherry-pick d9fbfeb from upstream V8 (Alexey Kozyatinskiy) [#25330](https://github.com/nodejs/node/pull/25330)
* \[[`e20e3472a4`](https://github.com/nodejs/node/commit/e20e3472a4)] - **deps**: V8: backport 442977e (Ali Ijaz Sheikh) [#25242](https://github.com/nodejs/node/pull/25242)
* \[[`8af4f44130`](https://github.com/nodejs/node/commit/8af4f44130)] - **dns**: simplify dns.promises warning logic (cjihrig) [#24788](https://github.com/nodejs/node/pull/24788)
* \[[`cfd5773f8d`](https://github.com/nodejs/node/commit/cfd5773f8d)] - **doc**: document fs.write limitation with TTY (Matteo Collina) [#24571](https://github.com/nodejs/node/pull/24571)
* \[[`89ba5f41c8`](https://github.com/nodejs/node/commit/89ba5f41c8)] - **doc**: revise "Breaking Changes" section of Collaborator Guide (Rich Trott) [#25071](https://github.com/nodejs/node/pull/25071)
* \[[`7382e8f648`](https://github.com/nodejs/node/commit/7382e8f648)] - **doc**: fix node.1 --http-parser sort order (cjihrig) [#25045](https://github.com/nodejs/node/pull/25045)
* \[[`66e6c2a88b`](https://github.com/nodejs/node/commit/66e6c2a88b)] - **doc**: add EventTarget link to worker\_threads (Azard) [#25058](https://github.com/nodejs/node/pull/25058)
* \[[`d1f19a033c`](https://github.com/nodejs/node/commit/d1f19a033c)] - **doc**: make README formatting more consistent (wenjun ye) [#25003](https://github.com/nodejs/node/pull/25003)
* \[[`1880f23ed2`](https://github.com/nodejs/node/commit/1880f23ed2)] - **doc**: add codebytere's info to release team (Shelley Vohr) [#25022](https://github.com/nodejs/node/pull/25022)
* \[[`8f434414a4`](https://github.com/nodejs/node/commit/8f434414a4)] - **doc**: revise internal vs. public API in Collaborator Guide (Rich Trott) [#24975](https://github.com/nodejs/node/pull/24975)
* \[[`8ae649d105`](https://github.com/nodejs/node/commit/8ae649d105)] - **doc**: update a link of npm repository (Daijiro Wachi) [#24969](https://github.com/nodejs/node/pull/24969)
* \[[`9ffa8270b1`](https://github.com/nodejs/node/commit/9ffa8270b1)] - **doc**: fix author-ready conflict (Ruben Bridgewater) [#25015](https://github.com/nodejs/node/pull/25015)
* \[[`bdf21c1f10`](https://github.com/nodejs/node/commit/bdf21c1f10)] - **doc**: update Useful CI Jobs section of Collaborator Guide (Rich Trott) [#24916](https://github.com/nodejs/node/pull/24916)
* \[[`f8ac170608`](https://github.com/nodejs/node/commit/f8ac170608)] - **doc**: add class worker documentation (yoshimoto koki) [#24849](https://github.com/nodejs/node/pull/24849)
* \[[`f68ff0619c`](https://github.com/nodejs/node/commit/f68ff0619c)] - **doc**: remove bad link to irc info (Richard Lau) [#24967](https://github.com/nodejs/node/pull/24967)
* \[[`0701559336`](https://github.com/nodejs/node/commit/0701559336)] - **doc**: simplify author ready (Ruben Bridgewater) [#24893](https://github.com/nodejs/node/pull/24893)
* \[[`e7e8a25bb8`](https://github.com/nodejs/node/commit/e7e8a25bb8)] - **doc**: update "Testing and CI" in Collaborator Guide (Rich Trott) [#24884](https://github.com/nodejs/node/pull/24884)
* \[[`a7f36dde00`](https://github.com/nodejs/node/commit/a7f36dde00)] - **doc**: update http doc for new Agent()/support options in socket.connect() (Beni von Cheni) [#24846](https://github.com/nodejs/node/pull/24846)
* \[[`e9ad526297`](https://github.com/nodejs/node/commit/e9ad526297)] - **doc**: fix order of events when request is aborted (Luigi Pinca) [#24779](https://github.com/nodejs/node/pull/24779)
* \[[`189d2e2ab2`](https://github.com/nodejs/node/commit/189d2e2ab2)] - **doc**: revise Waiting for Approvals documentation (Rich Trott) [#24845](https://github.com/nodejs/node/pull/24845)
* \[[`f2df92cfc0`](https://github.com/nodejs/node/commit/f2df92cfc0)] - **doc**: list all versions WHATWG URL api was added (Thomas Watson) [#24847](https://github.com/nodejs/node/pull/24847)
* \[[`2b03878de3`](https://github.com/nodejs/node/commit/2b03878de3)] - **doc**: add authority and scheme psuedo headers (Kenigbolo Meya Stephen) [#24777](https://github.com/nodejs/node/pull/24777)
* \[[`23cd76e9ef`](https://github.com/nodejs/node/commit/23cd76e9ef)] - **doc**: add triaging section to releases.md (Beth Griggs) [#20165](https://github.com/nodejs/node/pull/20165)
* \[[`f52ff588e2`](https://github.com/nodejs/node/commit/f52ff588e2)] - **doc**: use author's titles for linked resources (Rich Trott) [#24837](https://github.com/nodejs/node/pull/24837)
* \[[`0a3c88551a`](https://github.com/nodejs/node/commit/0a3c88551a)] - **doc**: revise code review guidelines (Rich Trott) [#24790](https://github.com/nodejs/node/pull/24790)
* \[[`7bd7328f0d`](https://github.com/nodejs/node/commit/7bd7328f0d)] - **doc**: add a note on usage scope of AliasedBuffer (Gireesh Punathil) [#24724](https://github.com/nodejs/node/pull/24724)
* \[[`184425e7e8`](https://github.com/nodejs/node/commit/184425e7e8)] - **doc**: hide undocumented object artifacts in async\_hooks (Gireesh Punathil) [#24741](https://github.com/nodejs/node/pull/24741)
* \[[`ad40e781af`](https://github.com/nodejs/node/commit/ad40e781af)] - **doc**: fix added version of randomFill+randomFillSync (Thomas Watson) [#24812](https://github.com/nodejs/node/pull/24812)
* \[[`56916c8430`](https://github.com/nodejs/node/commit/56916c8430)] - **doc**: streamline Accepting Modifications in Collaborator Guide (Rich Trott) [#24807](https://github.com/nodejs/node/pull/24807)
* \[[`7ae17573e6`](https://github.com/nodejs/node/commit/7ae17573e6)] - **doc**: make release README link be consistent with text (ZYSzys) [#24783](https://github.com/nodejs/node/pull/24783)
* \[[`1c593c8192`](https://github.com/nodejs/node/commit/1c593c8192)] - **doc**: cookie is joined using '; ' (Gerhard Stoebich) [#24740](https://github.com/nodejs/node/pull/24740)
* \[[`3e4b93ac8e`](https://github.com/nodejs/node/commit/3e4b93ac8e)] - **doc**: add antsmartian to collaborators (Anto Aravinth) [#24655](https://github.com/nodejs/node/pull/24655)
* \[[`fe698d8ca0`](https://github.com/nodejs/node/commit/fe698d8ca0)] - **doc**: revise accepting-modifications in guide (Rich Trott) [#24650](https://github.com/nodejs/node/pull/24650)
* \[[`546f9419d7`](https://github.com/nodejs/node/commit/546f9419d7)] - **doc**: clarify symlink resolution for \_\_filename (Rich Trott) [#24587](https://github.com/nodejs/node/pull/24587)
* \[[`a1a393bfbf`](https://github.com/nodejs/node/commit/a1a393bfbf)] - **doc**: use arrow function for anonymous callbacks (koki-oshima) [#24606](https://github.com/nodejs/node/pull/24606)
* \[[`6788d856d5`](https://github.com/nodejs/node/commit/6788d856d5)] - **doc**: revise handling-own-pull-requests text (Rich Trott) [#24583](https://github.com/nodejs/node/pull/24583)
* \[[`bda73542be`](https://github.com/nodejs/node/commit/bda73542be)] - **doc**: fix duplicate "this" and "the" on http2.md (Yusuke Kawasaki) [#24611](https://github.com/nodejs/node/pull/24611)
* \[[`73b99c7013`](https://github.com/nodejs/node/commit/73b99c7013)] - **doc**: replace anonymous function with arrow function (ka2jun8) [#24617](https://github.com/nodejs/node/pull/24617)
* \[[`1eeb37c39c`](https://github.com/nodejs/node/commit/1eeb37c39c)] - **doc**: use arrow function (sadness\_ojisan) [#24590](https://github.com/nodejs/node/pull/24590)
* \[[`283172771e`](https://github.com/nodejs/node/commit/283172771e)] - **doc**: replace anonymous function with arrow function (yuriettys) [#24627](https://github.com/nodejs/node/pull/24627)
* \[[`dd5bfd7f74`](https://github.com/nodejs/node/commit/dd5bfd7f74)] - **doc**: mark napi\_add\_finalizer experimental (Michael Dawson) [#24572](https://github.com/nodejs/node/pull/24572)
* \[[`dacdd0113f`](https://github.com/nodejs/node/commit/dacdd0113f)] - **esm**: refactor dynamic modules (Myles Borins) [#24560](https://github.com/nodejs/node/pull/24560)
* \[[`576d9c513a`](https://github.com/nodejs/node/commit/576d9c513a)] - **fs**: simplify fs.promises warning logic (cjihrig) [#24788](https://github.com/nodejs/node/pull/24788)
* \[[`741c5ef6cd`](https://github.com/nodejs/node/commit/741c5ef6cd)] - **http**: fix error check in `Execute()` (Brian White) [#25863](https://github.com/nodejs/node/pull/25863)
* \[[`f4aed8c3df`](https://github.com/nodejs/node/commit/f4aed8c3df)] - **http2**: make compat writeHead not crash if the stream is destroyed (Matteo Collina) [#24723](https://github.com/nodejs/node/pull/24723)
* \[[`d12c5a7a75`](https://github.com/nodejs/node/commit/d12c5a7a75)] - **http2**: add compat support for nested array headers (Sebastiaan Deckers) [#24665](https://github.com/nodejs/node/pull/24665)
* \[[`c7f876be38`](https://github.com/nodejs/node/commit/c7f876be38)] - **http2**: fix session\[kSession] undefined issue (leeight) [#24547](https://github.com/nodejs/node/pull/24547)
* \[[`e8dfdc063d`](https://github.com/nodejs/node/commit/e8dfdc063d)] - **lib**: ensure readable stream flows to end (Mikko Rantanen) [#24918](https://github.com/nodejs/node/pull/24918)
* \[[`d5d8670783`](https://github.com/nodejs/node/commit/d5d8670783)] - **lib**: remove some useless assignments (Gus Caplan) [#23199](https://github.com/nodejs/node/pull/23199)
* \[[`96036ef798`](https://github.com/nodejs/node/commit/96036ef798)] - **lib**: do not register DOMException in a module (Joyee Cheung) [#24708](https://github.com/nodejs/node/pull/24708)
* \[[`ef68349617`](https://github.com/nodejs/node/commit/ef68349617)] - **lib**: move setupAllowedFlags() into per\_thread.js (Joyee Cheung) [#24704](https://github.com/nodejs/node/pull/24704)
* \[[`1b48c9d9e3`](https://github.com/nodejs/node/commit/1b48c9d9e3)] - **lib**: convert to arrow function in fs.js (exoego) [#24604](https://github.com/nodejs/node/pull/24604)
* \[[`eaa5e3efa4`](https://github.com/nodejs/node/commit/eaa5e3efa4)] - **lib**: change callbacks to arrow function (/Jesse) [#24625](https://github.com/nodejs/node/pull/24625)
* \[[`4eec736a5e`](https://github.com/nodejs/node/commit/4eec736a5e)] - **lib**: chenged anonymous function to arrow function (nakashima) [#24605](https://github.com/nodejs/node/pull/24605)
* \[[`8c93bd4d17`](https://github.com/nodejs/node/commit/8c93bd4d17)] - **lib**: rearm pre-existing signal event registrations (Gireesh Punathil) [#24651](https://github.com/nodejs/node/pull/24651)
* \[[`8f427eb987`](https://github.com/nodejs/node/commit/8f427eb987)] - **lib**: convert to arrow function (horihiro) [#24623](https://github.com/nodejs/node/pull/24623)
* \[[`e5abfe191e`](https://github.com/nodejs/node/commit/e5abfe191e)] - **lib**: convert to Arrow Function (Daiki Arai) [#24615](https://github.com/nodejs/node/pull/24615)
* \[[`ccefef2d45`](https://github.com/nodejs/node/commit/ccefef2d45)] - **lib**: suppress crypto related env vars in help msg (Daniel Bevenius) [#24556](https://github.com/nodejs/node/pull/24556)
* \[[`1c2ce239a1`](https://github.com/nodejs/node/commit/1c2ce239a1)] - **lib**: convert to arrow function (Naojirou Hisada) [#24596](https://github.com/nodejs/node/pull/24596)
* \[[`c87af34886`](https://github.com/nodejs/node/commit/c87af34886)] - **lib**: change anonymous function to arrow function (takato) [#24589](https://github.com/nodejs/node/pull/24589)
* \[[`ce2aa807f5`](https://github.com/nodejs/node/commit/ce2aa807f5)] - **lib**: simplify own keys retrieval (Vse Mozhet Byt) [#24582](https://github.com/nodejs/node/pull/24582)
* \[[`9daf175483`](https://github.com/nodejs/node/commit/9daf175483)] - **lib**: fix nits in lib/internal/bootstrap/cache.js (Vse Mozhet Byt) [#24581](https://github.com/nodejs/node/pull/24581)
* \[[`f2287c61e1`](https://github.com/nodejs/node/commit/f2287c61e1)] - **module**: use validateString in modules/esm (ZYSzys) [#24868](https://github.com/nodejs/node/pull/24868)
* \[[`229f901a0f`](https://github.com/nodejs/node/commit/229f901a0f)] - **module**: use validateString in modules/cjs (ZYSzys) [#24863](https://github.com/nodejs/node/pull/24863)
* \[[`fe0e119f55`](https://github.com/nodejs/node/commit/fe0e119f55)] - **n-api**: handle reference delete before finalize (Michael Dawson) [#24494](https://github.com/nodejs/node/pull/24494)
* \[[`760277e490`](https://github.com/nodejs/node/commit/760277e490)] - **n-api,test**: remove last argument in assert.strictEqual() (susantruong) [#24584](https://github.com/nodejs/node/pull/24584)
* \[[`f6e07fd809`](https://github.com/nodejs/node/commit/f6e07fd809)] - **net**: use strict comparisons for fd (cjihrig) [#25014](https://github.com/nodejs/node/pull/25014)
* \[[`7eda47e5c9`](https://github.com/nodejs/node/commit/7eda47e5c9)] - **path**: replace assertPath() with validator (cjihrig) [#24840](https://github.com/nodejs/node/pull/24840)
* \[[`33a907de20`](https://github.com/nodejs/node/commit/33a907de20)] - **perf\_hooks**: make GC tracking state per-Environment (Anna Henningsen) [#25053](https://github.com/nodejs/node/pull/25053)
* \[[`931a04e37e`](https://github.com/nodejs/node/commit/931a04e37e)] - **process**: fix omitting `--` from `process.execArgv` (Anna Henningsen) [#24654](https://github.com/nodejs/node/pull/24654)
* \[[`a4068d9827`](https://github.com/nodejs/node/commit/a4068d9827)] - **process**: properly close file descriptor on exit (Ruben Bridgewater) [#24972](https://github.com/nodejs/node/pull/24972)
* \[[`fd8a481a12`](https://github.com/nodejs/node/commit/fd8a481a12)] - **process**: simplify check in previousValueIsValid() (cjihrig) [#24836](https://github.com/nodejs/node/pull/24836)
* \[[`5bca4c7cc0`](https://github.com/nodejs/node/commit/5bca4c7cc0)] - **process**: emit unhandled warning immediately (Anatoli Papirovski) [#24632](https://github.com/nodejs/node/pull/24632)
* \[[`944e75d10b`](https://github.com/nodejs/node/commit/944e75d10b)] - **src**: emit 'params' instead of 'data' for NodeTracing.dataCollected (Kelvin Jin) [#24949](https://github.com/nodejs/node/pull/24949)
* \[[`1cc5834180`](https://github.com/nodejs/node/commit/1cc5834180)] - **src**: add GetLoadedLibraries routine (Gireesh Punathil) [#24825](https://github.com/nodejs/node/pull/24825)
* \[[`fa84e91813`](https://github.com/nodejs/node/commit/fa84e91813)] - **src**: create env->inspector\_console\_api\_object earlier (Joyee Cheung) [#24906](https://github.com/nodejs/node/pull/24906)
* \[[`12f0485c8c`](https://github.com/nodejs/node/commit/12f0485c8c)] - **src**: remove use of CallOnForegroundThread() (cjihrig) [#24925](https://github.com/nodejs/node/pull/24925)
* \[[`16a1f96d6e`](https://github.com/nodejs/node/commit/16a1f96d6e)] - **src**: do not alias new and old signal masks (Sam Roberts) [#24810](https://github.com/nodejs/node/pull/24810)
* \[[`f0e7b2f509`](https://github.com/nodejs/node/commit/f0e7b2f509)] - **src**: fix warning for potential snprintf truncation (Sam Roberts) [#24810](https://github.com/nodejs/node/pull/24810)
* \[[`7455597815`](https://github.com/nodejs/node/commit/7455597815)] - **src**: remove finalized\_ member from Hash class (Daniel Bevenius) [#24822](https://github.com/nodejs/node/pull/24822)
* \[[`37047fc70a`](https://github.com/nodejs/node/commit/37047fc70a)] - **src**: use arraysize instead of hardcode number (leeight) [#24473](https://github.com/nodejs/node/pull/24473)
* \[[`eb20e3d23e`](https://github.com/nodejs/node/commit/eb20e3d23e)] - **src**: set HAS\_USERNAME/PASSWORD more strictly (Timothy Gu) [#24495](https://github.com/nodejs/node/pull/24495)
* \[[`4444cdb6cd`](https://github.com/nodejs/node/commit/4444cdb6cd)] - **src**: elevate v8 namespaces referenced (Juan José Arboleda) [#24657](https://github.com/nodejs/node/pull/24657)
* \[[`28a1cc1377`](https://github.com/nodejs/node/commit/28a1cc1377)] - **src**: simplify uptime and ppid return values (cjihrig) [#24562](https://github.com/nodejs/node/pull/24562)
* \[[`8c48302a50`](https://github.com/nodejs/node/commit/8c48302a50)] - **src**: elevate v8 namespaces for node\_url.cc (Jayasankar) [#24573](https://github.com/nodejs/node/pull/24573)
* \[[`863d1987a3`](https://github.com/nodejs/node/commit/863d1987a3)] - **src**: elevate v8 namespaces of node\_trace\_events.cc (Jayasankar) [#24469](https://github.com/nodejs/node/pull/24469)
* \[[`26f7edbf71`](https://github.com/nodejs/node/commit/26f7edbf71)] - **src**: re-sort the symbol macros (Sam Roberts) [#24382](https://github.com/nodejs/node/pull/24382)
* \[[`450bcde462`](https://github.com/nodejs/node/commit/450bcde462)] - **src**: use v8:: for consistency in util (ZYSzys) [#23934](https://github.com/nodejs/node/pull/23934)
* \[[`3f969d61ff`](https://github.com/nodejs/node/commit/3f969d61ff)] - **stream**: re-use existing `once()` implementation (Anna Henningsen) [#24991](https://github.com/nodejs/node/pull/24991)
* \[[`bb8a65dd84`](https://github.com/nodejs/node/commit/bb8a65dd84)] - **stream**: fix end-of-stream for HTTP/2 (Anna Henningsen) [#24926](https://github.com/nodejs/node/pull/24926)
* \[[`e356ce851f`](https://github.com/nodejs/node/commit/e356ce851f)] - **stream**: make async iterator .next() always resolve (Matteo Collina) [#24668](https://github.com/nodejs/node/pull/24668)
* \[[`e338e50213`](https://github.com/nodejs/node/commit/e338e50213)] - **stream**: use arrow function for callback (DoiChris) [#24609](https://github.com/nodejs/node/pull/24609)
* \[[`6be2d6187c`](https://github.com/nodejs/node/commit/6be2d6187c)] - **test**: improve comparison coverage to 100% (Ruben Bridgewater) [#24749](https://github.com/nodejs/node/pull/24749)
* \[[`1d083e29e5`](https://github.com/nodejs/node/commit/1d083e29e5)] - **test**: test internal/util/types in vm (ZYSzys) [#25056](https://github.com/nodejs/node/pull/25056)
* \[[`56c6686fe5`](https://github.com/nodejs/node/commit/56c6686fe5)] - **test**: merge test with unnecessary child process (Sam Roberts) [#25025](https://github.com/nodejs/node/pull/25025)
* \[[`ee054110b5`](https://github.com/nodejs/node/commit/ee054110b5)] - **test**: remove unnecessary linter comment (cjihrig) [#25013](https://github.com/nodejs/node/pull/25013)
* \[[`c9b0a36989`](https://github.com/nodejs/node/commit/c9b0a36989)] - **test**: use global.gc() instead of gc() (cjihrig) [#25012](https://github.com/nodejs/node/pull/25012)
* \[[`bcfc1d1a7d`](https://github.com/nodejs/node/commit/bcfc1d1a7d)] - **test**: run eslint on test file and fix errors (Ruben Bridgewater) [#25009](https://github.com/nodejs/node/pull/25009)
* \[[`17527981d0`](https://github.com/nodejs/node/commit/17527981d0)] - **test**: remove dead code (Ruben Bridgewater) [#25009](https://github.com/nodejs/node/pull/25009)
* \[[`48c54137d4`](https://github.com/nodejs/node/commit/48c54137d4)] - **test**: use blocks instead of async IIFE (Anna Henningsen) [#24989](https://github.com/nodejs/node/pull/24989)
* \[[`54d7e82530`](https://github.com/nodejs/node/commit/54d7e82530)] - **test**: adding history regression test case (Anto Aravinth) [#24843](https://github.com/nodejs/node/pull/24843)
* \[[`dd2b553874`](https://github.com/nodejs/node/commit/dd2b553874)] - **test**: mark test-child-process-execfile flaky (Rich Trott) [#25051](https://github.com/nodejs/node/pull/25051)
* \[[`bfa396a81e`](https://github.com/nodejs/node/commit/bfa396a81e)] - **test**: mark test-child-process-exit-code flaky (Rich Trott) [#25050](https://github.com/nodejs/node/pull/25050)
* \[[`55680e3ecb`](https://github.com/nodejs/node/commit/55680e3ecb)] - **test**: mark test-worker-memory flaky on Windows CI (Rich Trott) [#25042](https://github.com/nodejs/node/pull/25042)
* \[[`89b6d1b1fa`](https://github.com/nodejs/node/commit/89b6d1b1fa)] - **test**: mark test-child-process-execsync flaky on AIX (Rich Trott) [#25031](https://github.com/nodejs/node/pull/25031)
* \[[`11d5c07c7d`](https://github.com/nodejs/node/commit/11d5c07c7d)] - **test**: refactor test-enable-in-init (Mitch Hankins) [#24976](https://github.com/nodejs/node/pull/24976)
* \[[`0658424227`](https://github.com/nodejs/node/commit/0658424227)] - **test**: from functools import reduce in test/testpy/\_\_init\_\_.py (cclauss) [#24954](https://github.com/nodejs/node/pull/24954)
* \[[`3bdff05cdb`](https://github.com/nodejs/node/commit/3bdff05cdb)] - **test**: improve internet/test-dns (Ilarion Halushka) [#24927](https://github.com/nodejs/node/pull/24927)
* \[[`3f2c6ce9aa`](https://github.com/nodejs/node/commit/3f2c6ce9aa)] - **test**: replace callback with arrows (Shubham Urkade) [#24866](https://github.com/nodejs/node/pull/24866)
* \[[`2869b7810d`](https://github.com/nodejs/node/commit/2869b7810d)] - **test**: mark test-cli-syntax as flaky/unreliable (Rich Trott) [#24957](https://github.com/nodejs/node/pull/24957)
* \[[`83c6f0a86e`](https://github.com/nodejs/node/commit/83c6f0a86e)] - **test**: do not lint macros files (again) (cclauss) [#24886](https://github.com/nodejs/node/pull/24886)
* \[[`a67d37d226`](https://github.com/nodejs/node/commit/a67d37d226)] - **test**: prepare test/pseudo-tty/testcfg.py Python 3 (cclauss) [#24887](https://github.com/nodejs/node/pull/24887)
* \[[`4e51e3d550`](https://github.com/nodejs/node/commit/4e51e3d550)] - **test**: move test-cli-syntax to sequential (Rich Trott) [#24907](https://github.com/nodejs/node/pull/24907)
* \[[`e20ad2e446`](https://github.com/nodejs/node/commit/e20ad2e446)] - **test**: move http2 test to parallel (Rich Trott) [#24877](https://github.com/nodejs/node/pull/24877)
* \[[`1a1811d1e0`](https://github.com/nodejs/node/commit/1a1811d1e0)] - **test**: make http2 timeout test robust (Rich Trott) [#24877](https://github.com/nodejs/node/pull/24877)
* \[[`a2dd3a62a7`](https://github.com/nodejs/node/commit/a2dd3a62a7)] - **test**: fix wrong parameter (zhmushan) [#24844](https://github.com/nodejs/node/pull/24844)
* \[[`1dff257280`](https://github.com/nodejs/node/commit/1dff257280)] - **test**: improve test-net-socket-timeout (Rich Trott) [#24859](https://github.com/nodejs/node/pull/24859)
* \[[`5e29865375`](https://github.com/nodejs/node/commit/5e29865375)] - **test**: prepare test/pseudo-tty/testcfg.py for Python 3 (cclauss) [#24791](https://github.com/nodejs/node/pull/24791)
* \[[`520d041afb`](https://github.com/nodejs/node/commit/520d041afb)] - **test**: refactor test-fs-write-file-sync.js (cjihrig) [#24834](https://github.com/nodejs/node/pull/24834)
* \[[`b1bbac726e`](https://github.com/nodejs/node/commit/b1bbac726e)] - **test**: prepare test/message/testcfg.py for Python 3 (cclauss) [#24793](https://github.com/nodejs/node/pull/24793)
* \[[`ff90d17eb3`](https://github.com/nodejs/node/commit/ff90d17eb3)] - **test**: remove unused addons-napi directory (Rich Trott) [#24839](https://github.com/nodejs/node/pull/24839)
* \[[`d08b5e94f5`](https://github.com/nodejs/node/commit/d08b5e94f5)] - **test**: add .gitignore file for node-api (Rich Trott) [#24839](https://github.com/nodejs/node/pull/24839)
* \[[`546fc68ae4`](https://github.com/nodejs/node/commit/546fc68ae4)] - **test**: fix `common.mustNotCall()` usage in HTTP test (Anna Henningsen) [#24750](https://github.com/nodejs/node/pull/24750)
* \[[`1c746c7524`](https://github.com/nodejs/node/commit/1c746c7524)] - **test**: use ES2017 syntax in test-fs-open-\* (jy95) [#23031](https://github.com/nodejs/node/pull/23031)
* \[[`e17dbd22c3`](https://github.com/nodejs/node/commit/e17dbd22c3)] - **test**: add flag scenario in test-fs-write-file-sync (Gireesh Punathil) [#24766](https://github.com/nodejs/node/pull/24766)
* \[[`fd5af6bfa9`](https://github.com/nodejs/node/commit/fd5af6bfa9)] - **test**: check invalid argument error for option (timothy searcy) [#24736](https://github.com/nodejs/node/pull/24736)
* \[[`46e37adf59`](https://github.com/nodejs/node/commit/46e37adf59)] - **test**: show stdout and stderr in test-cli-syntax when it fails (Joyee Cheung) [#24720](https://github.com/nodejs/node/pull/24720)
* \[[`31c1ee405e`](https://github.com/nodejs/node/commit/31c1ee405e)] - **test**: minor refactoring of onticketkeycallback (Daniel Bevenius) [#24718](https://github.com/nodejs/node/pull/24718)
* \[[`a7c72d7d5e`](https://github.com/nodejs/node/commit/a7c72d7d5e)] - **test**: mark test\_threadsafe\_function/test as flaky (Gireesh Punathil) [#24714](https://github.com/nodejs/node/pull/24714)
* \[[`e74345b2f5`](https://github.com/nodejs/node/commit/e74345b2f5)] - **test**: verify order of error in h2 server stream (Myles Borins) [#24685](https://github.com/nodejs/node/pull/24685)
* \[[`288a421dcc`](https://github.com/nodejs/node/commit/288a421dcc)] - **test**: cover path empty string case (lakatostamas) [#24569](https://github.com/nodejs/node/pull/24569)
* \[[`d4b1666686`](https://github.com/nodejs/node/commit/d4b1666686)] - **test**: use arrow syntax for anonymous callbacks (Shubham Urkade) [#24691](https://github.com/nodejs/node/pull/24691)
* \[[`af582096ad`](https://github.com/nodejs/node/commit/af582096ad)] - **test**: fix the arguments order in assert.strictEqual (pastak) [#24620](https://github.com/nodejs/node/pull/24620)
* \[[`e89f5e59ea`](https://github.com/nodejs/node/commit/e89f5e59ea)] - **test**: mark test-vm-timeout-escape-nexttick flaky (Gireesh Punathil) [#24712](https://github.com/nodejs/node/pull/24712)
* \[[`288d60c2f6`](https://github.com/nodejs/node/commit/288d60c2f6)] - **test**: fix the arguments order in assert.strictEqual (sigwyg) [#24624](https://github.com/nodejs/node/pull/24624)
* \[[`9f66105e29`](https://github.com/nodejs/node/commit/9f66105e29)] - **test**: fix the arguments order in `assert.strictEqual` (rt33) [#24626](https://github.com/nodejs/node/pull/24626)
* \[[`06208c8313`](https://github.com/nodejs/node/commit/06208c8313)] - **test**: reach res.\_dump after abort ClientRequest (Tadhg Creedon) [#24191](https://github.com/nodejs/node/pull/24191)
* \[[`85e948753b`](https://github.com/nodejs/node/commit/85e948753b)] - **test**: validate fs.rename() when NODE\_TEST\_DIR on separate mount (Drew Folta) [#24707](https://github.com/nodejs/node/pull/24707)
* \[[`5966dbed05`](https://github.com/nodejs/node/commit/5966dbed05)] - **test**: test and docs for detached fork process (timothy searcy) [#24524](https://github.com/nodejs/node/pull/24524)
* \[[`1c609bf6e2`](https://github.com/nodejs/node/commit/1c609bf6e2)] - **test**: fix arguments order in `assert.strictEqual` (sota1235) [#24607](https://github.com/nodejs/node/pull/24607)
* \[[`dc7ed30437`](https://github.com/nodejs/node/commit/dc7ed30437)] - **test**: fix arguments order in assert.strictEqual (grimrose) [#24608](https://github.com/nodejs/node/pull/24608)
* \[[`be17cc59c7`](https://github.com/nodejs/node/commit/be17cc59c7)] - **test**: make test-uv-binding-constant JS engine neutral (Rich Trott) [#24666](https://github.com/nodejs/node/pull/24666)
* \[[`2318c7fea3`](https://github.com/nodejs/node/commit/2318c7fea3)] - **test**: use arrow function (sagirk) [#24482](https://github.com/nodejs/node/pull/24482)
* \[[`43bfb136f9`](https://github.com/nodejs/node/commit/43bfb136f9)] - **test**: fix arguments order in `assert.strictEqual` (Takahiro Nakamura) [#24621](https://github.com/nodejs/node/pull/24621)
* \[[`3811817290`](https://github.com/nodejs/node/commit/3811817290)] - **test**: update strictEqual argument order (VeysonD) [#24622](https://github.com/nodejs/node/pull/24622)
* \[[`ec7bd18146`](https://github.com/nodejs/node/commit/ec7bd18146)] - **test**: fix argument order in assert.strictEqual (feng jianmei) [#24594](https://github.com/nodejs/node/pull/24594)
* \[[`4cc91ff2b5`](https://github.com/nodejs/node/commit/4cc91ff2b5)] - **test**: use arrow functions in callbacks (apoorvanand) [#24441](https://github.com/nodejs/node/pull/24441)
* \[[`4093572c4d`](https://github.com/nodejs/node/commit/4093572c4d)] - **test**: add test for socket.end callback (ajido) [#24087](https://github.com/nodejs/node/pull/24087)
* \[[`7dee5e5d16`](https://github.com/nodejs/node/commit/7dee5e5d16)] - **test**: replace anonymous closure functions with arrow functions (tpanthera) [#24443](https://github.com/nodejs/node/pull/24443)
* \[[`82d9ffc6a6`](https://github.com/nodejs/node/commit/82d9ffc6a6)] - **test**: fix arguments order in `assert.strictEqual` (tottokotkd) [#24612](https://github.com/nodejs/node/pull/24612)
* \[[`372073e8da`](https://github.com/nodejs/node/commit/372073e8da)] - **test**: convert callback to arrow function (jamesgeorge007) [#24513](https://github.com/nodejs/node/pull/24513)
* \[[`82376015ab`](https://github.com/nodejs/node/commit/82376015ab)] - **test**: change anonymous function to arrow function (Gagandeep Singh) [#24528](https://github.com/nodejs/node/pull/24528)
* \[[`5e3b34fbfd`](https://github.com/nodejs/node/commit/5e3b34fbfd)] - **test**: split out http2 from test-stream-pipeline (Rich Trott) [#24631](https://github.com/nodejs/node/pull/24631)
* \[[`b6cceae96f`](https://github.com/nodejs/node/commit/b6cceae96f)] - **test**: cover path.basename when path and ext are the same (Laszlo.Moczo) [#24570](https://github.com/nodejs/node/pull/24570)
* \[[`7f0fb163a0`](https://github.com/nodejs/node/commit/7f0fb163a0)] - **test**: fix assert.strictEqual (mki-skt) [#24619](https://github.com/nodejs/node/pull/24619)
* \[[`e464a1dca5`](https://github.com/nodejs/node/commit/e464a1dca5)] - **test**: fix arguments order in assert.strictEqual (teppeis) [#24591](https://github.com/nodejs/node/pull/24591)
* \[[`ec70330dab`](https://github.com/nodejs/node/commit/ec70330dab)] - **test**: fix http2-binding strictEqual order (dominikeinkemmer) [#24616](https://github.com/nodejs/node/pull/24616)
* \[[`7b096026d8`](https://github.com/nodejs/node/commit/7b096026d8)] - **test**: fix the arguments order in `assert.strictEqual` (sota1235) [#24595](https://github.com/nodejs/node/pull/24595)
* \[[`1658924d90`](https://github.com/nodejs/node/commit/1658924d90)] - **test**: replace callback with arrow functions (prodroy1) [#24434](https://github.com/nodejs/node/pull/24434)
* \[[`0e63d0abd5`](https://github.com/nodejs/node/commit/0e63d0abd5)] - **test**: confirm tls server suite default is its own (Sam Roberts) [#24374](https://github.com/nodejs/node/pull/24374)
* \[[`3c2b40ba04`](https://github.com/nodejs/node/commit/3c2b40ba04)] - **test**: rename agent1-pfx.pem to agent1.pfx (Sam Roberts) [#24374](https://github.com/nodejs/node/pull/24374)
* \[[`43dcbbedb9`](https://github.com/nodejs/node/commit/43dcbbedb9)] - **test**: add independent multi-alg crypto identities (Sam Roberts) [#24374](https://github.com/nodejs/node/pull/24374)
* \[[`83145ec3a6`](https://github.com/nodejs/node/commit/83145ec3a6)] - **test**: cover tls multi-identity option mixtures (Sam Roberts) [#24374](https://github.com/nodejs/node/pull/24374)
* \[[`77cf877ea2`](https://github.com/nodejs/node/commit/77cf877ea2)] - **tls**: re-define max supported version as 1.2 (Sam Roberts) [#25024](https://github.com/nodejs/node/pull/25024)
* \[[`027ca95b46`](https://github.com/nodejs/node/commit/027ca95b46)] - **tools**: make apilinks building more robust (Joyee Cheung) [#25019](https://github.com/nodejs/node/pull/25019)
* \[[`694ea008d1`](https://github.com/nodejs/node/commit/694ea008d1)] - **tools**: enable no-useless-constructor lint rule (cjihrig) [#25055](https://github.com/nodejs/node/pull/25055)
* \[[`5cbc0dbeaf`](https://github.com/nodejs/node/commit/5cbc0dbeaf)] - **tools**: prepare ./tools/compress\_json.py for Python 3 (cclauss) [#24889](https://github.com/nodejs/node/pull/24889)
* \[[`87f20822c1`](https://github.com/nodejs/node/commit/87f20822c1)] - **tools**: prepare tools/testp.py for Python 3 (cclauss) [#24890](https://github.com/nodejs/node/pull/24890)
* \[[`91a96e446a`](https://github.com/nodejs/node/commit/91a96e446a)] - **tools**: prepare tools/icu/icutrim.py for Python 3 (cclauss) [#24888](https://github.com/nodejs/node/pull/24888)
* \[[`34212b531f`](https://github.com/nodejs/node/commit/34212b531f)] - **tools**: update ESLint to 5.10.0 (cjihrig) [#24903](https://github.com/nodejs/node/pull/24903)
* \[[`229c0e0cc9`](https://github.com/nodejs/node/commit/229c0e0cc9)] - **tools**: do not lint tools/inspector\_protocol or tools/markupsafe (cclauss) [#24882](https://github.com/nodejs/node/pull/24882)
* \[[`bece371639`](https://github.com/nodejs/node/commit/bece371639)] - **tools**: prepare tools/js2c.py for Python 3 (cclauss) [#24798](https://github.com/nodejs/node/pull/24798)
* \[[`e6afaa350b`](https://github.com/nodejs/node/commit/e6afaa350b)] - **tools**: prepare tools/specialize\_node\_d.py for Python 3 (cclauss) [#24797](https://github.com/nodejs/node/pull/24797)
* \[[`544a20f37c`](https://github.com/nodejs/node/commit/544a20f37c)] - **tools**: prepare tools/test.py for Python 3 (cclauss) [#24799](https://github.com/nodejs/node/pull/24799)
* \[[`388ec8d77c`](https://github.com/nodejs/node/commit/388ec8d77c)] - **tools**: prepare tools/genv8constants.py for Python 3 (cclauss) [#24801](https://github.com/nodejs/node/pull/24801)
* \[[`039097e276`](https://github.com/nodejs/node/commit/039097e276)] - **tools**: prepare tools/install.py for Python 3 (cclauss) [#24800](https://github.com/nodejs/node/pull/24800)
* \[[`f21137976e`](https://github.com/nodejs/node/commit/f21137976e)] - **tools**: fix eslint usage for Node.js 8 and before (Ruben Bridgewater) [#24753](https://github.com/nodejs/node/pull/24753)
* \[[`691e1a69ff`](https://github.com/nodejs/node/commit/691e1a69ff)] - **tools**: don't use GH API for commit message checks (Rod Vagg) [#24574](https://github.com/nodejs/node/pull/24574)
* \[[`f5f1266326`](https://github.com/nodejs/node/commit/f5f1266326)] - **tools**: only sign release if promotion successful (Rod Vagg) [#24669](https://github.com/nodejs/node/pull/24669)
* \[[`cc880fbeeb`](https://github.com/nodejs/node/commit/cc880fbeeb)] - **tools**: check for git tag before promoting release (Rod Vagg) [#24670](https://github.com/nodejs/node/pull/24670)
* \[[`8a5b5e1fd0`](https://github.com/nodejs/node/commit/8a5b5e1fd0)] - **tools**: use print() function on both Python 2 and 3 (cclauss) [#24486](https://github.com/nodejs/node/pull/24486)
* \[[`f9933ff2c8`](https://github.com/nodejs/node/commit/f9933ff2c8)] - **tools,doc**: fix version picker bug in html.js (Rich Trott) [#24638](https://github.com/nodejs/node/pull/24638)
* \[[`b3932ef8e3`](https://github.com/nodejs/node/commit/b3932ef8e3)] - **url**: remove an eslint-disable comment (cjihrig) [#24995](https://github.com/nodejs/node/pull/24995)
* \[[`c0423cf34c`](https://github.com/nodejs/node/commit/c0423cf34c)] - **url**: simplify native URL object construction (Timothy Gu) [#24495](https://github.com/nodejs/node/pull/24495)
* \[[`d06ea3e505`](https://github.com/nodejs/node/commit/d06ea3e505)] - **url**: reuse existing context in href setter (Timothy Gu) [#24495](https://github.com/nodejs/node/pull/24495)
* \[[`4e111ce050`](https://github.com/nodejs/node/commit/4e111ce050)] - _**Revert**_ "**url**: make the context non-enumerable" (Timothy Gu) [#24495](https://github.com/nodejs/node/pull/24495)
* \[[`7048cba388`](https://github.com/nodejs/node/commit/7048cba388)] - **url**: use SafeSet to filter known special protocols (Mike Samuel) [#24703](https://github.com/nodejs/node/pull/24703)
* \[[`8d953b7d26`](https://github.com/nodejs/node/commit/8d953b7d26)] - **vm**: simplify Script constructor options validation (cjihrig) [#25054](https://github.com/nodejs/node/pull/25054)
* \[[`134d1e9526`](https://github.com/nodejs/node/commit/134d1e9526)] - **vm**: add dynamic import support (Gus Caplan) [#22381](https://github.com/nodejs/node/pull/22381)
* \[[`595bdc7603`](https://github.com/nodejs/node/commit/595bdc7603)] - **win, build**: skip building cctest by default (Bartosz Sosnowski) [#21408](https://github.com/nodejs/node/pull/21408)
* \[[`483ff7bcc7`](https://github.com/nodejs/node/commit/483ff7bcc7)] - **worker**: drain messages from internal message port (Yael Hermon) [#24932](https://github.com/nodejs/node/pull/24932)

<a id="10.15.2"></a>

## 2019-02-28, Version 10.15.2 'Dubnium' (LTS), @rvagg

This is a security release. All Node.js users should consult the security release summary at:

<https://nodejs.org/en/blog/vulnerability/february-2019-security-releases/>

for details on patched vulnerabilities.

A fix for the following CVE is included in this release:

* Node.js: Slowloris HTTP Denial of Service with keep-alive (CVE-2019-5737)

### Notable Changes

* **http**: Further prevention of "Slowloris" attacks on HTTP and HTTPS connections by consistently applying the receive timeout set by `server.headersTimeout` to connections in keep-alive mode. Reported by Marco Pracucci ([Voxnest](https://voxnest.com)). (CVE-2019-5737 / Matteo Collina)

### Commits

* \[[`1a7302bd48`](https://github.com/nodejs/node/commit/1a7302bd48)] - **http**: prevent slowloris with keepalive connections (Matteo Collina) [nodejs-private/node-private#158](https://github.com/nodejs-private/node-private/pull/158)

<a id="10.15.1"></a>

## 2019-01-29, Version 10.15.1 'Dubnium' (LTS), @codebytere

### Notable Changes

* **doc**:
  * add oyyd to collaborators (Ouyang Yadong) [#24300](https://github.com/nodejs/node/pull/24300)

* **tls**:
  * throw if protocol too long (Andre Jodat-Danbrani) [#23606](https://github.com/nodejs/node/pull/23606)

### Commits

* \[[`fbf5321dcf`](https://github.com/nodejs/node/commit/fbf5321dcf)] - **async\_hooks**: add HandleScopes to C++ embedder/addon API (Anna Henningsen) [#24285](https://github.com/nodejs/node/pull/24285)
* \[[`0c206e0d6d`](https://github.com/nodejs/node/commit/0c206e0d6d)] - **benchmark**: support more options in startup benchmark (Joyee Cheung) [#24220](https://github.com/nodejs/node/pull/24220)
* \[[`9a64ceca39`](https://github.com/nodejs/node/commit/9a64ceca39)] - **buffer**: fix writeUInt16BE range check (Brian White) [#24208](https://github.com/nodejs/node/pull/24208)
* \[[`0b81054d17`](https://github.com/nodejs/node/commit/0b81054d17)] - **build**: fix Python detection when depot\_tools are in PATH in Windows (Guy Bedford) [#22539](https://github.com/nodejs/node/pull/22539)
* \[[`b61a51c4f5`](https://github.com/nodejs/node/commit/b61a51c4f5)] - **build**: remove sudo:false from .travis.yml (Rich Trott) [#24511](https://github.com/nodejs/node/pull/24511)
* \[[`5c3736a772`](https://github.com/nodejs/node/commit/5c3736a772)] - **build**: use print() function in configure.py (cclauss) [#24484](https://github.com/nodejs/node/pull/24484)
* \[[`5d2dadccff`](https://github.com/nodejs/node/commit/5d2dadccff)] - **build**: check minimum ICU in configure for system-icu (Steven R. Loomis) [#24255](https://github.com/nodejs/node/pull/24255)
* \[[`31376d9a97`](https://github.com/nodejs/node/commit/31376d9a97)] - **build**: remove unnecessary prerequisite in Makefile (Rich Trott) [#24342](https://github.com/nodejs/node/pull/24342)
* \[[`33fd13c5ce`](https://github.com/nodejs/node/commit/33fd13c5ce)] - **build**: fix benchmark tests on CI (Rich Trott) [#24307](https://github.com/nodejs/node/pull/24307)
* \[[`07b7db2f81`](https://github.com/nodejs/node/commit/07b7db2f81)] - **build**: use BUILDTYPE in bench-addons-build targets (Daniel Bevenius) [#24033](https://github.com/nodejs/node/pull/24033)
* \[[`4e21eb4004`](https://github.com/nodejs/node/commit/4e21eb4004)] - **build**: lint commit message in separate Travis job (Richard Lau) [#24254](https://github.com/nodejs/node/pull/24254)
* \[[`042749fd23`](https://github.com/nodejs/node/commit/042749fd23)] - **build**: only try to find node when it's needed by the target (Joyee Cheung) [#24115](https://github.com/nodejs/node/pull/24115)
* \[[`72d2d2cd8e`](https://github.com/nodejs/node/commit/72d2d2cd8e)] - **build**: expose more openssl categories for addons (Jonathan Cardoso Machado) [#23344](https://github.com/nodejs/node/pull/23344)
* \[[`dc5647f71b`](https://github.com/nodejs/node/commit/dc5647f71b)] - **build,tools**: update make-v8.sh for ppc64le (Refael Ackermann) [#24293](https://github.com/nodejs/node/pull/24293)
* \[[`5dfc1bb46c`](https://github.com/nodejs/node/commit/5dfc1bb46c)] - **build,tools**: update make-v8.sh for s390x (Refael Ackermann) [#23839](https://github.com/nodejs/node/pull/23839)
* \[[`04f8d6bffd`](https://github.com/nodejs/node/commit/04f8d6bffd)] - **child\_process**: allow 'http\_parser' monkey patching again (Jimb Esser) [#24006](https://github.com/nodejs/node/pull/24006)
* \[[`3ef68d8d97`](https://github.com/nodejs/node/commit/3ef68d8d97)] - **cli**: add missing env vars to --help (cjihrig) [#24383](https://github.com/nodejs/node/pull/24383)
* \[[`4f13ac7941`](https://github.com/nodejs/node/commit/4f13ac7941)] - **console**: improve code readability (gengjiawen) [#24412](https://github.com/nodejs/node/pull/24412)
* \[[`07b9a663e0`](https://github.com/nodejs/node/commit/07b9a663e0)] - **console**: cover .assert with single argument (Morgan Roderick) [#24188](https://github.com/nodejs/node/pull/24188)
* \[[`4749640b2e`](https://github.com/nodejs/node/commit/4749640b2e)] - **crypto**: reduce memory usage of SignFinal (Tobias Nießen) [#23427](https://github.com/nodejs/node/pull/23427)
* \[[`733cb1ef84`](https://github.com/nodejs/node/commit/733cb1ef84)] - **deps**: cherry-pick b87d408 from upstream V8 (Peter Marshall) [#24272](https://github.com/nodejs/node/pull/24272)
* \[[`17b55bf1a4`](https://github.com/nodejs/node/commit/17b55bf1a4)] - **deps**: V8: cherry-pick 52a9e67 (Ali Ijaz Sheikh) [#25027](https://github.com/nodejs/node/pull/25027)
* \[[`185ccedf7c`](https://github.com/nodejs/node/commit/185ccedf7c)] - **doc**: clarify who may land on an LTS staging branch (Myles Borins) [#24465](https://github.com/nodejs/node/pull/24465)
* \[[`3283186934`](https://github.com/nodejs/node/commit/3283186934)] - **doc**: revise `author ready` explanation (Rich Trott) [#24558](https://github.com/nodejs/node/pull/24558)
* \[[`f918ad8e98`](https://github.com/nodejs/node/commit/f918ad8e98)] - **doc**: add readable and writable property to Readable and Writable (Dexter Leng) [#23933](https://github.com/nodejs/node/pull/23933)
* \[[`d288a395f6`](https://github.com/nodejs/node/commit/d288a395f6)] - **doc**: move trott to tsc emeritus (Rich Trott) [#24492](https://github.com/nodejs/node/pull/24492)
* \[[`f0602f8df3`](https://github.com/nodejs/node/commit/f0602f8df3)] - **doc**: add Ruben Bridgewater to release team (Ruben Bridgewater) [#23432](https://github.com/nodejs/node/pull/23432)
* \[[`b1bbedd701`](https://github.com/nodejs/node/commit/b1bbedd701)] - **doc**: edit COLLABORATOR\_GUIDE.md on closing issues (Rich Trott) [#24477](https://github.com/nodejs/node/pull/24477)
* \[[`08284dcdd8`](https://github.com/nodejs/node/commit/08284dcdd8)] - **doc**: move Timothy to TSC emeritus (Timothy Gu) [#24535](https://github.com/nodejs/node/pull/24535)
* \[[`6bb860cd20`](https://github.com/nodejs/node/commit/6bb860cd20)] - **doc**: add NODE\_DEBUG\_NATIVE to API docs (cjihrig) [#24383](https://github.com/nodejs/node/pull/24383)
* \[[`ef1056f4bd`](https://github.com/nodejs/node/commit/ef1056f4bd)] - **doc**: add missing env variables to man page (cjihrig) [#24383](https://github.com/nodejs/node/pull/24383)
* \[[`40c9ee028b`](https://github.com/nodejs/node/commit/40c9ee028b)] - **doc**: minor cleanup of tls.getProtocol() (Sam Roberts) [#24533](https://github.com/nodejs/node/pull/24533)
* \[[`c16b93233c`](https://github.com/nodejs/node/commit/c16b93233c)] - **doc**: add Beth Griggs to release team (Beth Griggs) [#24532](https://github.com/nodejs/node/pull/24532)
* \[[`492e2a4d11`](https://github.com/nodejs/node/commit/492e2a4d11)] - **doc**: add filehandle.write(string\[, position\[, encoding]]) (Dara Hayes) [#23224](https://github.com/nodejs/node/pull/23224)
* \[[`a620c25c76`](https://github.com/nodejs/node/commit/a620c25c76)] - **doc**: udpate list item spacing in changelogs (Rich Trott) [#24391](https://github.com/nodejs/node/pull/24391)
* \[[`7fd4ef7df1`](https://github.com/nodejs/node/commit/7fd4ef7df1)] - **doc**: update crypto examples to not use deprecated api (Mayank Asthana) [#24107](https://github.com/nodejs/node/pull/24107)
* \[[`2734c20bd9`](https://github.com/nodejs/node/commit/2734c20bd9)] - **doc**: simplify first-time contributors section of Collaborator Guide (Rich Trott) [#24387](https://github.com/nodejs/node/pull/24387)
* \[[`e11d46cb84`](https://github.com/nodejs/node/commit/e11d46cb84)] - **doc**: adjusting formatting when printing (Thomas Hunter II) [#24325](https://github.com/nodejs/node/pull/24325)
* \[[`c19d6e26a3`](https://github.com/nodejs/node/commit/c19d6e26a3)] - **doc**: better linkage to node-addon-api (Michael Dawson) [#24371](https://github.com/nodejs/node/pull/24371)
* \[[`ae3a19486f`](https://github.com/nodejs/node/commit/ae3a19486f)] - **doc**: update collaborator guide with LTS labels (Charalampos Fanoulis) [#24379](https://github.com/nodejs/node/pull/24379)
* \[[`e111d71e60`](https://github.com/nodejs/node/commit/e111d71e60)] - **doc**: document http request.finished boolean (Thomas Watson) [#24319](https://github.com/nodejs/node/pull/24319)
* \[[`1ca3c9d3e2`](https://github.com/nodejs/node/commit/1ca3c9d3e2)] - **doc**: document NODE\_TLS\_REJECT\_UNAUTHORIZED (cjihrig) [#24289](https://github.com/nodejs/node/pull/24289)
* \[[`68aecff860`](https://github.com/nodejs/node/commit/68aecff860)] - **doc**: clarify issues and pull requests guidance (Rich Trott) [#24316](https://github.com/nodejs/node/pull/24316)
* \[[`ac3e264f1c`](https://github.com/nodejs/node/commit/ac3e264f1c)] - **doc**: fix comma splices in process.md (Rich Trott) [#24357](https://github.com/nodejs/node/pull/24357)
* \[[`672879f406`](https://github.com/nodejs/node/commit/672879f406)] - **doc**: use real protocol names in ALPN example (Sam Roberts) [#24232](https://github.com/nodejs/node/pull/24232)
* \[[`8a60798f4c`](https://github.com/nodejs/node/commit/8a60798f4c)] - **doc**: update core-validate-commit url (Daijiro Wachi) [#24331](https://github.com/nodejs/node/pull/24331)
* \[[`a9a6cb1b06`](https://github.com/nodejs/node/commit/a9a6cb1b06)] - **doc**: fix echo example programs (Sam Roberts) [#24235](https://github.com/nodejs/node/pull/24235)
* \[[`90f3f5e88f`](https://github.com/nodejs/node/commit/90f3f5e88f)] - **doc**: clarify allowed encoding parameter types (Sam Roberts) [#24230](https://github.com/nodejs/node/pull/24230)
* \[[`4209e122b7`](https://github.com/nodejs/node/commit/4209e122b7)] - **doc**: correct async\_hooks resource names (Gerhard Stoebich) [#24001](https://github.com/nodejs/node/pull/24001)
* \[[`d2cc9d72b6`](https://github.com/nodejs/node/commit/d2cc9d72b6)] - **doc**: sort bottom-of-file markdown links (Sam Roberts) [#24679](https://github.com/nodejs/node/pull/24679)
* \[[`b4c1d8273c`](https://github.com/nodejs/node/commit/b4c1d8273c)] - **doc**: update fs.open() changes record for optional 'flags' (Rod Vagg) [#24240](https://github.com/nodejs/node/pull/24240)
* \[[`cf209171c9`](https://github.com/nodejs/node/commit/cf209171c9)] - **doc**: add links to Stream section (Dmitry Igrishin) [#24301](https://github.com/nodejs/node/pull/24301)
* \[[`0260db525a`](https://github.com/nodejs/node/commit/0260db525a)] - **doc**: correct async\_hooks sample outputs (Gerhard Stoebich) [#24050](https://github.com/nodejs/node/pull/24050)
* \[[`c8d2635ed1`](https://github.com/nodejs/node/commit/c8d2635ed1)] - **doc**: add oyyd to collaborators (Ouyang Yadong) [#24300](https://github.com/nodejs/node/pull/24300)
* \[[`b305db8634`](https://github.com/nodejs/node/commit/b305db8634)] - **doc**: edit BUILDING.md (Rich Trott) [#24243](https://github.com/nodejs/node/pull/24243)
* \[[`abe3edad48`](https://github.com/nodejs/node/commit/abe3edad48)] - **doc**: fix code examples in stream.md (Grant Carthew) [#24112](https://github.com/nodejs/node/pull/24112)
* \[[`31441f42c4`](https://github.com/nodejs/node/commit/31441f42c4)] - **doc**: describe what tls servername is for (Sam Roberts) [#24236](https://github.com/nodejs/node/pull/24236)
* \[[`cc688bb23f`](https://github.com/nodejs/node/commit/cc688bb23f)] - **doc**: fix some inconsistent use of hostname (Sam Roberts) [#24199](https://github.com/nodejs/node/pull/24199)
* \[[`6f3bc0d28a`](https://github.com/nodejs/node/commit/6f3bc0d28a)] - **doc, test**: document and test vm timeout escapes (James M Snell) [#23743](https://github.com/nodejs/node/pull/23743)
* \[[`ef8c1deda6`](https://github.com/nodejs/node/commit/ef8c1deda6)] - **doc,meta**: update PR approving info (Vse Mozhet Byt) [#24561](https://github.com/nodejs/node/pull/24561)
* \[[`be56fb7ab9`](https://github.com/nodejs/node/commit/be56fb7ab9)] - **events**: extract listener check as a function (ZYSzys) [#24303](https://github.com/nodejs/node/pull/24303)
* \[[`4a16a4da45`](https://github.com/nodejs/node/commit/4a16a4da45)] - **fs**: inline typeof check (dexterleng) [#24390](https://github.com/nodejs/node/pull/24390)
* \[[`35d2397ae5`](https://github.com/nodejs/node/commit/35d2397ae5)] - **http**: remove obsolete function escapeHeaderValue (Lauri Piisang) [#24173](https://github.com/nodejs/node/pull/24173)
* \[[`8df4a168b3`](https://github.com/nodejs/node/commit/8df4a168b3)] - **http2**: replace unreachable error with assertion (Rich Trott) [#24407](https://github.com/nodejs/node/pull/24407)
* \[[`5516fbf1d7`](https://github.com/nodejs/node/commit/5516fbf1d7)] - **http2**: order declarations in http2.js (ZYSzys) [#24411](https://github.com/nodejs/node/pull/24411)
* \[[`5e3c6799cb`](https://github.com/nodejs/node/commit/5e3c6799cb)] - **http2**: elevate v8 namespaces of repeated references (Gagandeep Singh) [#24453](https://github.com/nodejs/node/pull/24453)
* \[[`4246a40b30`](https://github.com/nodejs/node/commit/4246a40b30)] - **lib**: move encodeStr function to internal for reusable (ZYSzys) [#24242](https://github.com/nodejs/node/pull/24242)
* \[[`6bd055f7de`](https://github.com/nodejs/node/commit/6bd055f7de)] - **lib**: refactor setupInspector in bootstrap/node.js (leeight) [#24446](https://github.com/nodejs/node/pull/24446)
* \[[`62a5679ca3`](https://github.com/nodejs/node/commit/62a5679ca3)] - **lib**: set stderr.\_destroy to dummyDestroy (Joyee Cheung) [#24398](https://github.com/nodejs/node/pull/24398)
* \[[`3450a4c536`](https://github.com/nodejs/node/commit/3450a4c536)] - **lib**: gather all errors constant in the same place for consistency (ZYSzys) [#24038](https://github.com/nodejs/node/pull/24038)
* \[[`5c2c5b9094`](https://github.com/nodejs/node/commit/5c2c5b9094)] - **lib**: improved conditional check in zlib (Dan Corman) [#24190](https://github.com/nodejs/node/pull/24190)
* \[[`7527632235`](https://github.com/nodejs/node/commit/7527632235)] - **lib**: adjust params from uvExceptionWithHostPort (msmichellegar) [#24159](https://github.com/nodejs/node/pull/24159)
* \[[`3966b698f6`](https://github.com/nodejs/node/commit/3966b698f6)] - **lib**: combine contructor, tag, Object into a function (Paul Isache) [#24171](https://github.com/nodejs/node/pull/24171)
* \[[`c84b420457`](https://github.com/nodejs/node/commit/c84b420457)] - _**Revert**_ "**net**: partially revert "simplify Socket.prototype.\_final"" (Anna Henningsen) [#24290](https://github.com/nodejs/node/pull/24290)
* \[[`0c2d1d57e8`](https://github.com/nodejs/node/commit/0c2d1d57e8)] - **net**: add comments explaining error check (Steven Gabarro) [#24222](https://github.com/nodejs/node/pull/24222)
* \[[`2d0105c751`](https://github.com/nodejs/node/commit/2d0105c751)] - **net**: remove unreachable check in internalConnect (Philipp Dunkel) [#24158](https://github.com/nodejs/node/pull/24158)
* \[[`897114bf94`](https://github.com/nodejs/node/commit/897114bf94)] - **net**: partially revert "simplify Socket.prototype.\_final" (Anna Henningsen) [#24288](https://github.com/nodejs/node/pull/24288)
* \[[`10a27277ad`](https://github.com/nodejs/node/commit/10a27277ad)] - **net**: simplify Socket.prototype.\_final (Anna Henningsen) [#24075](https://github.com/nodejs/node/pull/24075)
* \[[`b7876ba6e1`](https://github.com/nodejs/node/commit/b7876ba6e1)] - **src**: elevate namespaces for repeated entities (Sarath Govind K K) [#24475](https://github.com/nodejs/node/pull/24475)
* \[[`4b82aa80fe`](https://github.com/nodejs/node/commit/4b82aa80fe)] - **src**: elevate namespaces of repeated artifacts (Maya Anilson) [#24429](https://github.com/nodejs/node/pull/24429)
* \[[`bfde244576`](https://github.com/nodejs/node/commit/bfde244576)] - **src**: elevate repeated use of v8 namespaced type (Shubham Urkade) [#24427](https://github.com/nodejs/node/pull/24427)
* \[[`be14283bcd`](https://github.com/nodejs/node/commit/be14283bcd)] - **src**: use smart pointers in cares\_wrap.cc (Daniel Bevenius) [#23813](https://github.com/nodejs/node/pull/23813)
* \[[`fa52ba621b`](https://github.com/nodejs/node/commit/fa52ba621b)] - **src**: elevate v8 namespaces of referenced artifacts (Kanika Singhal) [#24424](https://github.com/nodejs/node/pull/24424)
* \[[`9a69d030ce`](https://github.com/nodejs/node/commit/9a69d030ce)] - **src**: reuse std::make\_unique (alyssaq) [#24132](https://github.com/nodejs/node/pull/24132)
* \[[`44a1993e9d`](https://github.com/nodejs/node/commit/44a1993e9d)] - **src**: avoid extra `Persistent` in `DefaultTriggerAsyncIdScope` (Anna Henningsen) [#23844](https://github.com/nodejs/node/pull/23844)
* \[[`15d05bbf02`](https://github.com/nodejs/node/commit/15d05bbf02)] - **src**: simplify `TimerFunctionCall()` in `node_perf.cc` (Anna Henningsen) [#23782](https://github.com/nodejs/node/pull/23782)
* \[[`383d512ed7`](https://github.com/nodejs/node/commit/383d512ed7)] - **src**: memory management using smart pointer (Uttam Pawar) [#23628](https://github.com/nodejs/node/pull/23628)
* \[[`ffb4087def`](https://github.com/nodejs/node/commit/ffb4087def)] - **src**: remove function hasTextDecoder in encoding.js (Chi-chi Wang) [#23625](https://github.com/nodejs/node/pull/23625)
* \[[`fa60eb83be`](https://github.com/nodejs/node/commit/fa60eb83be)] - **stream**: correctly pause and resume after once('readable') (Matteo Collina) [#24366](https://github.com/nodejs/node/pull/24366)
* \[[`a7c1d0908a`](https://github.com/nodejs/node/commit/a7c1d0908a)] - **stream**: do not use crypto.DEFAULT\_ENCODING in lazy\_transform.js (Joyee Cheung) [#24396](https://github.com/nodejs/node/pull/24396)
* \[[`965098a8ca`](https://github.com/nodejs/node/commit/965098a8ca)] - **stream**: change comment on duplex stream options (Jesse W. Collins) [#24247](https://github.com/nodejs/node/pull/24247)
* \[[`6ce4ef3387`](https://github.com/nodejs/node/commit/6ce4ef3387)] - **stream**: make `.destroy()` interact better with write queue (Anna Henningsen) [#24062](https://github.com/nodejs/node/pull/24062)
* \[[`bdab2e98f1`](https://github.com/nodejs/node/commit/bdab2e98f1)] - **test**: mark test-cli-node-options flaky on arm (Rich Trott) [#25032](https://github.com/nodejs/node/pull/25032)
* \[[`e5c4759eab`](https://github.com/nodejs/node/commit/e5c4759eab)] - **test**: use destructuring on require (Juan José Arboleda) [#24455](https://github.com/nodejs/node/pull/24455)
* \[[`cb860870cd`](https://github.com/nodejs/node/commit/cb860870cd)] - **test**: fix test case in test-child-process-fork-dgram.js (gengjiawen) [#24459](https://github.com/nodejs/node/pull/24459)
* \[[`9d7cb1f6d7`](https://github.com/nodejs/node/commit/9d7cb1f6d7)] - **test**: replace callback with arrow functions (sreepurnajasti) [#24541](https://github.com/nodejs/node/pull/24541)
* \[[`a9795f701d`](https://github.com/nodejs/node/commit/a9795f701d)] - **test**: replace callback with arrow function (potham) [#24531](https://github.com/nodejs/node/pull/24531)
* \[[`088b0db932`](https://github.com/nodejs/node/commit/088b0db932)] - **test**: replace anonymous function with arrow (Gagandeep Singh) [#24527](https://github.com/nodejs/node/pull/24527)
* \[[`083925def0`](https://github.com/nodejs/node/commit/083925def0)] - **test**: replace anonymous function with arrow (Gagandeep Singh) [#24526](https://github.com/nodejs/node/pull/24526)
* \[[`95ba7615d1`](https://github.com/nodejs/node/commit/95ba7615d1)] - **test**: add information to assertion (Rich Trott) [#24566](https://github.com/nodejs/node/pull/24566)
* \[[`313eaf958d`](https://github.com/nodejs/node/commit/313eaf958d)] - **test**: replace anonymous function with arrow func (Gagandeep Singh) [#24525](https://github.com/nodejs/node/pull/24525)
* \[[`6b904f6799`](https://github.com/nodejs/node/commit/6b904f6799)] - **test**: change anonymous closure function to arrow function (Nethra Ravindran) [#24433](https://github.com/nodejs/node/pull/24433)
* \[[`46e63a2a78`](https://github.com/nodejs/node/commit/46e63a2a78)] - **test**: replace closure functions with arrow functions (Gagandeep Singh) [#24522](https://github.com/nodejs/node/pull/24522)
* \[[`8e6729bb82`](https://github.com/nodejs/node/commit/8e6729bb82)] - **test**: replace anonymous function with arrow function (Gagandeep Singh) [#24529](https://github.com/nodejs/node/pull/24529)
* \[[`54abfda5d3`](https://github.com/nodejs/node/commit/54abfda5d3)] - **test**: favor arrow function in callback (Pranay Kothapalli) [#24542](https://github.com/nodejs/node/pull/24542)
* \[[`d82c0de250`](https://github.com/nodejs/node/commit/d82c0de250)] - **test**: remove unused reject handlers (Dan Foley) [#24540](https://github.com/nodejs/node/pull/24540)
* \[[`e0a11142b4`](https://github.com/nodejs/node/commit/e0a11142b4)] - **test**: refactor test to use arrow functions (sagirk) [#24479](https://github.com/nodejs/node/pull/24479)
* \[[`7dd64858c2`](https://github.com/nodejs/node/commit/7dd64858c2)] - **test**: replace closure with arrow function (Maya Anilson) [#24489](https://github.com/nodejs/node/pull/24489)
* \[[`d71a607a09`](https://github.com/nodejs/node/commit/d71a607a09)] - **test**: using arrow functions (NoSkillGirl) [#24436](https://github.com/nodejs/node/pull/24436)
* \[[`5b1fd6e246`](https://github.com/nodejs/node/commit/5b1fd6e246)] - **test**: replace anonymous closure with arrow func (suman-mitra) [#24480](https://github.com/nodejs/node/pull/24480)
* \[[`b7b6c12510`](https://github.com/nodejs/node/commit/b7b6c12510)] - **test**: replace callback with arrow functions (sreepurnajasti) [#24490](https://github.com/nodejs/node/pull/24490)
* \[[`e02d553f7b`](https://github.com/nodejs/node/commit/e02d553f7b)] - **test**: replcae anonymous closure with arrow function (Sarath Govind K K) [#24476](https://github.com/nodejs/node/pull/24476)
* \[[`351e69d5c5`](https://github.com/nodejs/node/commit/351e69d5c5)] - **test**: refactor test-http-write-empty-string to use arrow functions (sagirk) [#24483](https://github.com/nodejs/node/pull/24483)
* \[[`d245f53db4`](https://github.com/nodejs/node/commit/d245f53db4)] - **test**: replace anonymous closure with arrow functions (suman-mitra) [#24481](https://github.com/nodejs/node/pull/24481)
* \[[`8734c679f8`](https://github.com/nodejs/node/commit/8734c679f8)] - **test**: add whatwg-encoding TextDecoder custom inspection with showHidden (ZauberNerd) [#24166](https://github.com/nodejs/node/pull/24166)
* \[[`7920e7bfb4`](https://github.com/nodejs/node/commit/7920e7bfb4)] - **test**: replace anonymous closure functions with arrow functions (sagirk) [#24478](https://github.com/nodejs/node/pull/24478)
* \[[`283a6b86bb`](https://github.com/nodejs/node/commit/283a6b86bb)] - **test**: replace anonymous closure functions with arrow function (Abhishek Dixit) [#24420](https://github.com/nodejs/node/pull/24420)
* \[[`66c3dcab72`](https://github.com/nodejs/node/commit/66c3dcab72)] - **test**: replace anonymous closure with arrow funct (Prabu Subra) [#24439](https://github.com/nodejs/node/pull/24439)
* \[[`e7d41c0312`](https://github.com/nodejs/node/commit/e7d41c0312)] - **test**: modify order of parameters for assertion (Mrityunjoy Saha) [#24430](https://github.com/nodejs/node/pull/24430)
* \[[`164069cdb0`](https://github.com/nodejs/node/commit/164069cdb0)] - **test**: replace closure with arrow functions (kanishk30) [#24440](https://github.com/nodejs/node/pull/24440)
* \[[`f129e2c063`](https://github.com/nodejs/node/commit/f129e2c063)] - **test**: replace anonymous closure function with arrow function (Kunda Sunil Kumar) [#24435](https://github.com/nodejs/node/pull/24435)
* \[[`94553b2ea5`](https://github.com/nodejs/node/commit/94553b2ea5)] - **test**: add typeerror test for EC crypto keygen (Matteo) [#24400](https://github.com/nodejs/node/pull/24400)
* \[[`1ec6923276`](https://github.com/nodejs/node/commit/1ec6923276)] - **test**: compare objects not identical by reference (Marie Terrier) [#24189](https://github.com/nodejs/node/pull/24189)
* \[[`4425926452`](https://github.com/nodejs/node/commit/4425926452)] - **test**: change anonymous closure functions to arrow functions (Namit Bhalla) [#24418](https://github.com/nodejs/node/pull/24418)
* \[[`40773c0f2a`](https://github.com/nodejs/node/commit/40773c0f2a)] - **test**: use print() function on both Python 2 and 3 (cclauss) [#24485](https://github.com/nodejs/node/pull/24485)
* \[[`2ffbde3963`](https://github.com/nodejs/node/commit/2ffbde3963)] - **test**: favor arrow functions in callbacks (UjjwalUpadhyay) [#24425](https://github.com/nodejs/node/pull/24425)
* \[[`8f7326c369`](https://github.com/nodejs/node/commit/8f7326c369)] - **test**: replace anonymous closure functions with arrow function (Amanpreet) [#24417](https://github.com/nodejs/node/pull/24417)
* \[[`644a9d6919`](https://github.com/nodejs/node/commit/644a9d6919)] - **test**: fix arguments order in napi test\_exception (kanishk30) [#24413](https://github.com/nodejs/node/pull/24413)
* \[[`abe9778ea4`](https://github.com/nodejs/node/commit/abe9778ea4)] - **test**: fix the arguments order in `assert.strictEqual` (Jay Arthanareeswaran) [#24416](https://github.com/nodejs/node/pull/24416)
* \[[`94d200fe46`](https://github.com/nodejs/node/commit/94d200fe46)] - **test**: replace closure with arrow functions (Amanpreet) [#24438](https://github.com/nodejs/node/pull/24438)
* \[[`380da0473a`](https://github.com/nodejs/node/commit/380da0473a)] - **test**: change callback function to arrow function (Jay Arthanareeswaran) [#24419](https://github.com/nodejs/node/pull/24419)
* \[[`5ad224d6ae`](https://github.com/nodejs/node/commit/5ad224d6ae)] - **test**: fix the arguments order in `assert.strictEqual` (apoorvanand) [#24431](https://github.com/nodejs/node/pull/24431)
* \[[`52259d71d6`](https://github.com/nodejs/node/commit/52259d71d6)] - **test**: assertion equality fix (NoSkillGirl) [#24422](https://github.com/nodejs/node/pull/24422)
* \[[`2d25cddbc1`](https://github.com/nodejs/node/commit/2d25cddbc1)] - **test**: remove unused function arguments in async-hooks tests (Simon Bruce) [#24406](https://github.com/nodejs/node/pull/24406)
* \[[`c29c510b5a`](https://github.com/nodejs/node/commit/c29c510b5a)] - **test**: fix actual parameter order for 'assert.strictEqual' (Selvaraj) [#24428](https://github.com/nodejs/node/pull/24428)
* \[[`bf3bed56db`](https://github.com/nodejs/node/commit/bf3bed56db)] - **test**: swap actual\&optional params (Nikhil M) [#24426](https://github.com/nodejs/node/pull/24426)
* \[[`d2d6287355`](https://github.com/nodejs/node/commit/d2d6287355)] - **test**: skip test that use --tls-v1.x flags (Daniel Bevenius) [#24376](https://github.com/nodejs/node/pull/24376)
* \[[`39a561b3bc`](https://github.com/nodejs/node/commit/39a561b3bc)] - **test**: change callback function to arrow function (Lakshmi Shanmugam) [#24421](https://github.com/nodejs/node/pull/24421)
* \[[`f4c2d9efbc`](https://github.com/nodejs/node/commit/f4c2d9efbc)] - **test**: replace anonymous closure for test-http-expect-handling.js (Jayasankar) [#24423](https://github.com/nodejs/node/pull/24423)
* \[[`cf7bf27325`](https://github.com/nodejs/node/commit/cf7bf27325)] - **test**: replace callback functions with arrow functions (potham) [#24432](https://github.com/nodejs/node/pull/24432)
* \[[`518bc9679d`](https://github.com/nodejs/node/commit/518bc9679d)] - **test**: use arrow functions for callbacks (Pushkal B) [#24444](https://github.com/nodejs/node/pull/24444)
* \[[`53973fde9d`](https://github.com/nodejs/node/commit/53973fde9d)] - **test**: replace anonymous closure function (Jayasankar) [#24415](https://github.com/nodejs/node/pull/24415)
* \[[`555ef65042`](https://github.com/nodejs/node/commit/555ef65042)] - **test**: fixed the arguments order in `assert.strictEqual` (Lakshmi Shanmugam) [#24414](https://github.com/nodejs/node/pull/24414)
* \[[`3b6135ff2c`](https://github.com/nodejs/node/commit/3b6135ff2c)] - **test**: use destructuring and remove unused arguments (Julia) [#24375](https://github.com/nodejs/node/pull/24375)
* \[[`8c8199211b`](https://github.com/nodejs/node/commit/8c8199211b)] - **test**: https agent clientcertengine coverage (Osmond van Hemert) [#24248](https://github.com/nodejs/node/pull/24248)
* \[[`987df276cb`](https://github.com/nodejs/node/commit/987df276cb)] - **test**: remove unused function arguments in async-hooks tests (Rich Trott) [#24368](https://github.com/nodejs/node/pull/24368)
* \[[`585db59b0a`](https://github.com/nodejs/node/commit/585db59b0a)] - **test**: add typeerror for vm/compileFunction params (Dan Corman) [#24179](https://github.com/nodejs/node/pull/24179)
* \[[`6cad1b6877`](https://github.com/nodejs/node/commit/6cad1b6877)] - **test**: deep object to table not covered (Osmond van Hemert) [#24257](https://github.com/nodejs/node/pull/24257)
* \[[`916ead940d`](https://github.com/nodejs/node/commit/916ead940d)] - **test**: add tests for Socket.setNoDelay (James Herrington) [#24250](https://github.com/nodejs/node/pull/24250)
* \[[`fbdfd608dd`](https://github.com/nodejs/node/commit/fbdfd608dd)] - **test**: add process no deprecation (razvanbh) [#24196](https://github.com/nodejs/node/pull/24196)
* \[[`b29b23546d`](https://github.com/nodejs/node/commit/b29b23546d)] - **test**: fix arguments order in assertions (Emanuel Kluge) [#24149](https://github.com/nodejs/node/pull/24149)
* \[[`d4fd76a782`](https://github.com/nodejs/node/commit/d4fd76a782)] - **test**: remove unused parameters in function definition (Paul Hodgson) [#24268](https://github.com/nodejs/node/pull/24268)
* \[[`817d871327`](https://github.com/nodejs/node/commit/817d871327)] - **test**: esm loader unknown builtin module (Fran Herrero) [#24183](https://github.com/nodejs/node/pull/24183)
* \[[`8728361533`](https://github.com/nodejs/node/commit/8728361533)] - **test**: fixed order of actual and expected arguments (kiyomizumia) [#24178](https://github.com/nodejs/node/pull/24178)
* \[[`e21d784cf8`](https://github.com/nodejs/node/commit/e21d784cf8)] - **test**: add else and error case for TextDecoder (Lauri Piisang) [#24162](https://github.com/nodejs/node/pull/24162)
* \[[`aba7b47e5c`](https://github.com/nodejs/node/commit/aba7b47e5c)] - **test**: url format path ending hashchar not covered (Osmond van Hemert) [#24259](https://github.com/nodejs/node/pull/24259)
* \[[`9970d562c6`](https://github.com/nodejs/node/commit/9970d562c6)] - **test**: test add and remove for lib/domain (Petar Dodev) [#24163](https://github.com/nodejs/node/pull/24163)
* \[[`51643c208e`](https://github.com/nodejs/node/commit/51643c208e)] - **test**: fix args order in process-getactiverequests (Vladyslav Kopylash) [#24186](https://github.com/nodejs/node/pull/24186)
* \[[`454ede2d90`](https://github.com/nodejs/node/commit/454ede2d90)] - **test**: check control characters replacing (Alessandro Gatti) [#24182](https://github.com/nodejs/node/pull/24182)
* \[[`4d1a80363a`](https://github.com/nodejs/node/commit/4d1a80363a)] - **test**: fix v8 Set/Get compiler warnings (Daniel Bevenius) [#24246](https://github.com/nodejs/node/pull/24246)
* \[[`a30f5a02b8`](https://github.com/nodejs/node/commit/a30f5a02b8)] - **test**: fix flaky test-vm-timeout-escape-nexttick (Rich Trott) [#24251](https://github.com/nodejs/node/pull/24251)
* \[[`1bceb9d397`](https://github.com/nodejs/node/commit/1bceb9d397)] - **test**: fix test-repl-envvars (Anna Henningsen) [#25226](https://github.com/nodejs/node/pull/25226)
* \[[`d04c3c2718`](https://github.com/nodejs/node/commit/d04c3c2718)] - **test**: move benchmark tests out of main test suite (Rich Trott) [#24265](https://github.com/nodejs/node/pull/24265)
* \[[`09bb49165f`](https://github.com/nodejs/node/commit/09bb49165f)] - **test**: fix strictEqual argument order (Martin Kask) [#24153](https://github.com/nodejs/node/pull/24153)
* \[[`704d886000`](https://github.com/nodejs/node/commit/704d886000)] - **test**: correct order of args in assert.strictEqual() (Natalie Cluer) [#24157](https://github.com/nodejs/node/pull/24157)
* \[[`63dc2214f9`](https://github.com/nodejs/node/commit/63dc2214f9)] - **test**: add test case for completion bash flag (Aivo Paas) [#24168](https://github.com/nodejs/node/pull/24168)
* \[[`dd67f39ae2`](https://github.com/nodejs/node/commit/dd67f39ae2)] - **test**: add test for deepEqual Float32Array (Yehiyam Livneh) [#24164](https://github.com/nodejs/node/pull/24164)
* \[[`2359273868`](https://github.com/nodejs/node/commit/2359273868)] - **test**: fix arguments order in assert.strictEqual() (Ulises Santana Suárez) [#24192](https://github.com/nodejs/node/pull/24192)
* \[[`3bb63721e3`](https://github.com/nodejs/node/commit/3bb63721e3)] - **test**: fix assert.strictEqual argument order (John Mc Quillan) [#24172](https://github.com/nodejs/node/pull/24172)
* \[[`a6f786dee9`](https://github.com/nodejs/node/commit/a6f786dee9)] - **test**: replacing fixture directory with temp (saurabhSiddhu) [#24077](https://github.com/nodejs/node/pull/24077)
* \[[`704b68aee4`](https://github.com/nodejs/node/commit/704b68aee4)] - **test**: increase coverage internal readline (Berry de Witte) [#24150](https://github.com/nodejs/node/pull/24150)
* \[[`d8ac55a012`](https://github.com/nodejs/node/commit/d8ac55a012)] - **test**: use NULL instead of 0 in common.h (Daniel Bevenius) [#24104](https://github.com/nodejs/node/pull/24104)
* \[[`4b9518dba3`](https://github.com/nodejs/node/commit/4b9518dba3)] - **test**: move test-fs-watch-system-limit from sequential to pummel (Marcus Scott) [#23692](https://github.com/nodejs/node/pull/23692)
* \[[`4054c24cac`](https://github.com/nodejs/node/commit/4054c24cac)] - **test**: fix uses of deprecated assert.fail with multiple args (ivan.filenko) [#23673](https://github.com/nodejs/node/pull/23673)
* \[[`c417c7a89a`](https://github.com/nodejs/node/commit/c417c7a89a)] - **test**: use assert.strictEqual instead of assert.equal (ivan.filenko) [#23673](https://github.com/nodejs/node/pull/23673)
* \[[`1b5b1cc08b`](https://github.com/nodejs/node/commit/1b5b1cc08b)] - **test**: add test for strictDeepEqual (Nikita Malyschkin) [#24197](https://github.com/nodejs/node/pull/24197)
* \[[`cd2dedfa4f`](https://github.com/nodejs/node/commit/cd2dedfa4f)] - **test**: add coverage for systemerror set name (Amer Alimanović) [#24200](https://github.com/nodejs/node/pull/24200)
* \[[`9fa71468f5`](https://github.com/nodejs/node/commit/9fa71468f5)] - **test**: fix order of arguments in assert.strictEqual (Alex Seifert) [#24145](https://github.com/nodejs/node/pull/24145)
* \[[`2d6e942035`](https://github.com/nodejs/node/commit/2d6e942035)] - **test**: add test for 'ERR\_INVALID\_CALLBACK' (razvanbh) [#24224](https://github.com/nodejs/node/pull/24224)
* \[[`540b741ae2`](https://github.com/nodejs/node/commit/540b741ae2)] - **test**: add coverage for escape key switch case (Artur Daschevici) [#24194](https://github.com/nodejs/node/pull/24194)
* \[[`53b12c3731`](https://github.com/nodejs/node/commit/53b12c3731)] - **test**: fix NewFromUtf8 compiler warning (Daniel Bevenius) [#24216](https://github.com/nodejs/node/pull/24216)
* \[[`8e9ff69d7f`](https://github.com/nodejs/node/commit/8e9ff69d7f)] - **test**: add error code tests in dgram test (Mark Arranz) [#24215](https://github.com/nodejs/node/pull/24215)
* \[[`e57a5c3734`](https://github.com/nodejs/node/commit/e57a5c3734)] - **test**: fix order of arguments in test-delayed-require assertion (reineke-fox) [#24165](https://github.com/nodejs/node/pull/24165)
* \[[`d7a3a3bd9f`](https://github.com/nodejs/node/commit/d7a3a3bd9f)] - **test**: change arguments order in strictEqual (Paul Isache) [#24156](https://github.com/nodejs/node/pull/24156)
* \[[`efd697bc57`](https://github.com/nodejs/node/commit/efd697bc57)] - **test**: switch order of strictEqual arguments (Jonah Polack) [#24185](https://github.com/nodejs/node/pull/24185)
* \[[`9052a22dd1`](https://github.com/nodejs/node/commit/9052a22dd1)] - **test**: fix the arguments order in `assert.strictEqual` (mzucker) [#24227](https://github.com/nodejs/node/pull/24227)
* \[[`d7722dd9d8`](https://github.com/nodejs/node/commit/d7722dd9d8)] - **test**: fix the arguments order in `assert.strictEqual` (mzucker) [#24226](https://github.com/nodejs/node/pull/24226)
* \[[`2e0d3c9de9`](https://github.com/nodejs/node/commit/2e0d3c9de9)] - **test**: fix order in assert.strictEqual to actual, expected (Kevin Seidel) [#24184](https://github.com/nodejs/node/pull/24184)
* \[[`b63e9cb3fe`](https://github.com/nodejs/node/commit/b63e9cb3fe)] - **test**: fix arguments order in assert.strictEqual (szabolcsit) [#24143](https://github.com/nodejs/node/pull/24143)
* \[[`e0c6f5cbf7`](https://github.com/nodejs/node/commit/e0c6f5cbf7)] - **test**: fix assert argument order (Manish Poddar) [#24160](https://github.com/nodejs/node/pull/24160)
* \[[`fc84ccd0f0`](https://github.com/nodejs/node/commit/fc84ccd0f0)] - **test**: removed extraneous argument 's' (Jackson Chui) [#24213](https://github.com/nodejs/node/pull/24213)
* \[[`90f98905f1`](https://github.com/nodejs/node/commit/90f98905f1)] - **test**: fix arguments order in test-fs-write-buffer (razvanbh) [#24155](https://github.com/nodejs/node/pull/24155)
* \[[`1588fba73f`](https://github.com/nodejs/node/commit/1588fba73f)] - **test**: fix argument order in assert.strictEqual() (Clement) [#24147](https://github.com/nodejs/node/pull/24147)
* \[[`f46fa9072a`](https://github.com/nodejs/node/commit/f46fa9072a)] - **test**: switch arguments in strictEqual (Mathieu Pavageau) [#24141](https://github.com/nodejs/node/pull/24141)
* \[[`8f2bdaca69`](https://github.com/nodejs/node/commit/8f2bdaca69)] - **test**: fix arguments order (Simona Cotin) [#24151](https://github.com/nodejs/node/pull/24151)
* \[[`380789eb68`](https://github.com/nodejs/node/commit/380789eb68)] - **test**: fixe argument order in assert.strictEqual (Marc Posth) [#24140](https://github.com/nodejs/node/pull/24140)
* \[[`cd07b02472`](https://github.com/nodejs/node/commit/cd07b02472)] - **test**: fixing arguments order in `assert.strictEqual()` (G. Carcaci) [#24152](https://github.com/nodejs/node/pull/24152)
* \[[`6e8fa5361a`](https://github.com/nodejs/node/commit/6e8fa5361a)] - **test**: add tests for OutgoingMessage setTimeout (Robin Drexler) [#24148](https://github.com/nodejs/node/pull/24148)
* \[[`abf9bd15db`](https://github.com/nodejs/node/commit/abf9bd15db)] - **test**: swap expected and actual in assert.strictEqual (Florin-Daniel BÎLBÎE) [#24146](https://github.com/nodejs/node/pull/24146)
* \[[`f0eee63ee0`](https://github.com/nodejs/node/commit/f0eee63ee0)] - **test**: fix assert parameter order (Roland Broekema) [#24144](https://github.com/nodejs/node/pull/24144)
* \[[`78a320130d`](https://github.com/nodejs/node/commit/78a320130d)] - **test**: change order of assert.strictEqual() (Remy Parzinski) [#24142](https://github.com/nodejs/node/pull/24142)
* \[[`64fd19f102`](https://github.com/nodejs/node/commit/64fd19f102)] - **test**: fix invalid argument order in test-http-expect-continue.js (Morgan Roderick) [#24138](https://github.com/nodejs/node/pull/24138)
* \[[`2d88af354f`](https://github.com/nodejs/node/commit/2d88af354f)] - **test**: strictEqual argument order (actual, expected) (Ahmad Nassri) [#24137](https://github.com/nodejs/node/pull/24137)
* \[[`11a84a7b32`](https://github.com/nodejs/node/commit/11a84a7b32)] - **test**: swap the order of arguments (Musa Hamwala) [#24134](https://github.com/nodejs/node/pull/24134)
* \[[`e599889649`](https://github.com/nodejs/node/commit/e599889649)] - **test**: fs readfile, swap arguments in strictEqual (Petar Dodev) [#24133](https://github.com/nodejs/node/pull/24133)
* \[[`c37b3196b6`](https://github.com/nodejs/node/commit/c37b3196b6)] - **test**: fix arguments order (Fran Herrero) [#24131](https://github.com/nodejs/node/pull/24131)
* \[[`74f1dad613`](https://github.com/nodejs/node/commit/74f1dad613)] - **test**: http-client-timeout error assert arguments (Tadhg Creedon) [#24130](https://github.com/nodejs/node/pull/24130)
* \[[`b16311b19f`](https://github.com/nodejs/node/commit/b16311b19f)] - **test**: mark test-vm-timeout-\* known issue tests flaky (James M Snell) [#23743](https://github.com/nodejs/node/pull/23743)
* \[[`0f6a9524f8`](https://github.com/nodejs/node/commit/0f6a9524f8)] - **tls**: destroy TLS socket if StreamWrap is destroyed (Anna Henningsen) [#24290](https://github.com/nodejs/node/pull/24290)
* \[[`0c73221699`](https://github.com/nodejs/node/commit/0c73221699)] - **tls**: do not rely on 'drain' handlers in StreamWrap (Anna Henningsen) [#24290](https://github.com/nodejs/node/pull/24290)
* \[[`3170cb49d8`](https://github.com/nodejs/node/commit/3170cb49d8)] - **tls**: throw if protocol too long (Andre Jodat-Danbrani) [#23606](https://github.com/nodejs/node/pull/23606)
* \[[`cc4d866697`](https://github.com/nodejs/node/commit/cc4d866697)] - **tools**: update to remark-lint-preset-node\@1.2.0 (Rich Trott) [#24391](https://github.com/nodejs/node/pull/24391)
* \[[`21843c7659`](https://github.com/nodejs/node/commit/21843c7659)] - **tools**: fix `make lint-md-rollup` and run it (Daijiro Wachi) [#24333](https://github.com/nodejs/node/pull/24333)
* \[[`e8e93df148`](https://github.com/nodejs/node/commit/e8e93df148)] - **tools**: update remark-lint to v6.0.3 from v6.0.2 (Daijiro Wachi) [#24333](https://github.com/nodejs/node/pull/24333)
* \[[`2bed68f341`](https://github.com/nodejs/node/commit/2bed68f341)] - **tools**: update remark version to v10 from v8 (Daijiro Wachi) [#24333](https://github.com/nodejs/node/pull/24333)
* \[[`39ccf1461e`](https://github.com/nodejs/node/commit/39ccf1461e)] - **tools**: update ESLint to 5.9.0 (cjihrig) [#24280](https://github.com/nodejs/node/pull/24280)
* \[[`a1d7ed7de6`](https://github.com/nodejs/node/commit/a1d7ed7de6)] - **tracing**: fix static destruction order issue (Anna Henningsen) [#24123](https://github.com/nodejs/node/pull/24123)
* \[[`8c107a37f9`](https://github.com/nodejs/node/commit/8c107a37f9)] - **url**: make the context non-enumerable (Joyee Cheung) [#24218](https://github.com/nodejs/node/pull/24218)
* \[[`eeb4715a56`](https://github.com/nodejs/node/commit/eeb4715a56)] - **util**: remove unreachable branch (rahulshuklab4u) [#24447](https://github.com/nodejs/node/pull/24447)
* \[[`7576a518b8`](https://github.com/nodejs/node/commit/7576a518b8)] - **util**: deleted unreachable code from util.inspect (kiyomizumia) [#24187](https://github.com/nodejs/node/pull/24187)
* \[[`c6a43fa2ef`](https://github.com/nodejs/node/commit/c6a43fa2ef)] - **zlib**: do not leak on destroy (Mathias Buus) [#23734](https://github.com/nodejs/node/pull/23734)

<a id="10.15.0"></a>

## 2018-12-26, Version 10.15.0 'Dubnium' (LTS), @MylesBorins

The 10.14.0 security release introduced some unexpected breakages on the 10.x release line.
This is a special release to fix a regression in the HTTP binary upgrade response body and add
a missing CLI flag to adjust the max header size of the http parser.

### Notable Changes

* **cli**:
  * add --max-http-header-size flag (cjihrig) [#24811](https://github.com/nodejs/node/pull/24811)
* **http**:
  * add maxHeaderSize property (cjihrig) [#24860](https://github.com/nodejs/node/pull/24860)

### Commits

* \[[`9b2ffc81c0`](https://github.com/nodejs/node/commit/9b2ffc81c0)] - **(SEMVER-MINOR)** **cli**: add --max-http-header-size flag (cjihrig) [#24811](https://github.com/nodejs/node/pull/24811)
* \[[`6183c7107d`](https://github.com/nodejs/node/commit/6183c7107d)] - **(SEMVER-MINOR)** **deps**: cherry-pick http\_parser\_set\_max\_header\_size (cjihrig) [#24811](https://github.com/nodejs/node/pull/24811)
* \[[`e669733595`](https://github.com/nodejs/node/commit/e669733595)] - **doc**: describe current HTTP header size limit (Sam Roberts) [#24700](https://github.com/nodejs/node/pull/24700)
* \[[`b6d3afb257`](https://github.com/nodejs/node/commit/b6d3afb257)] - **(SEMVER-MINOR)** **http**: add maxHeaderSize property (cjihrig) [#24860](https://github.com/nodejs/node/pull/24860)
* \[[`1aea1e3634`](https://github.com/nodejs/node/commit/1aea1e3634)] - **http**: fix regression of binary upgrade response body (Matteo Collina) [#25039](https://github.com/nodejs/node/pull/25039)
* \[[`a57aed144a`](https://github.com/nodejs/node/commit/a57aed144a)] - **(SEMVER-MINOR)** **src**: add kUInteger parsing (Matteo Collina) [#24811](https://github.com/nodejs/node/pull/24811)
* \[[`527407c49f`](https://github.com/nodejs/node/commit/527407c49f)] - **src**: cache the result of GetOptions() in JS land (Joyee Cheung) [#24091](https://github.com/nodejs/node/pull/24091)
* \[[`728bc631e5`](https://github.com/nodejs/node/commit/728bc631e5)] - **test**: fix expectation in test-bootstrap-modules (Ali Ijaz Sheikh) [#25112](https://github.com/nodejs/node/pull/25112)
* \[[`3e14212f0e`](https://github.com/nodejs/node/commit/3e14212f0e)] - **test**: remove magic numbers in test-gc-http-client-onerror (Rich Trott) [#24943](https://github.com/nodejs/node/pull/24943)

<a id="10.14.2"></a>

## 2018-12-11, Version 10.14.2 'Dubnium' (LTS), @MylesBorins prepared by @codebytere

This LTS release comes with 374 commits. This includes 165 which are test or benchmark related,
77 which are doc related, 29 which are build / tool related and 15 commits which update dependencies.

### Notable Changes

* **deps**:
  * upgrade to c-ares v1.15.0 (Ben Noordhuis) [#23854](https://github.com/nodejs/node/pull/23854)
* **Windows**:
  * A crashing process will now show the names of stack frames if the node.pdb file is available. (Refael Ackermann) [#23822](https://github.com/nodejs/node/pull/23822)
* **Added new collaborators**:
  * [psmarshall](https://github.com/psmarshall) - Peter Marshall. <https://github.com/nodejs/node/pull/24170>
  * [shisama](https://github.com/shisama) - Masashi Hirano. <https://github.com/nodejs/node/pull/24136>

### Commits

* \[[`dedf0e5cde`](https://github.com/nodejs/node/commit/dedf0e5cde)] - **assert**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`6a21d3e72f`](https://github.com/nodejs/node/commit/6a21d3e72f)] - **async\_hooks**: add missing async\_hooks destroys in AsyncReset (Bastian Krol) [#23272](https://github.com/nodejs/node/pull/23272)
* \[[`eed47b022d`](https://github.com/nodejs/node/commit/eed47b022d)] - **benchmark**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`c75d4bb106`](https://github.com/nodejs/node/commit/c75d4bb106)] - **benchmark**: fix bench-mkdirp to use recursive option (Klaus Meinhardt) [#23699](https://github.com/nodejs/node/pull/23699)
* \[[`60fe7f1f29`](https://github.com/nodejs/node/commit/60fe7f1f29)] - **benchmark**: coerce PORT to number (Ali Ijaz Sheikh) [#23721](https://github.com/nodejs/node/pull/23721)
* \[[`192c2af64e`](https://github.com/nodejs/node/commit/192c2af64e)] - **benchmark**: added a test benchmark for worker (Muzafar Umarov) [#23475](https://github.com/nodejs/node/pull/23475)
* \[[`0600e753b0`](https://github.com/nodejs/node/commit/0600e753b0)] - **bootstrap**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`e872089158`](https://github.com/nodejs/node/commit/e872089158)] - **bootstrapper**: move internalBinding to NativeModule (Gus Caplan) [#23025](https://github.com/nodejs/node/pull/23025)
* \[[`95814f2b08`](https://github.com/nodejs/node/commit/95814f2b08)] - **build**: change repo to https protocol in Makefile (mritunjaygoutam12) [#24073](https://github.com/nodejs/node/pull/24073)
* \[[`5ed39d987b`](https://github.com/nodejs/node/commit/5ed39d987b)] - **build**: use latest node on travis (cjihrig) [#24198](https://github.com/nodejs/node/pull/24198)
* \[[`19bda8a225`](https://github.com/nodejs/node/commit/19bda8a225)] - **build**: fix Travis non-PR builds (Richard Lau) [#24093](https://github.com/nodejs/node/pull/24093)
* \[[`3bac885b74`](https://github.com/nodejs/node/commit/3bac885b74)] - **build**: do not lint on non-PR Travis builds (Anna Henningsen) [#24076](https://github.com/nodejs/node/pull/24076)
* \[[`aa8848321b`](https://github.com/nodejs/node/commit/aa8848321b)] - **build**: only check REPLACEME & DEP...X for releases (Rod Vagg) [#24575](https://github.com/nodejs/node/pull/24575)
* \[[`d809e7485f`](https://github.com/nodejs/node/commit/d809e7485f)] - **build**: make benchmark/napi all prereq order-only (Daniel Bevenius) [#23951](https://github.com/nodejs/node/pull/23951)
* \[[`2e83f1eb20`](https://github.com/nodejs/node/commit/2e83f1eb20)] - **build**: add -Werror=undefined-inline to clang builds (Refael Ackermann) [#23961](https://github.com/nodejs/node/pull/23961)
* \[[`bf61fe5dd7`](https://github.com/nodejs/node/commit/bf61fe5dd7)] - **build**: add lint-py which uses flake8 (cclauss) [#21952](https://github.com/nodejs/node/pull/21952)
* \[[`7a39fec1db`](https://github.com/nodejs/node/commit/7a39fec1db)] - **build**: allow for overwriting of use\_openssl\_def (Shelley Vohr) [#23763](https://github.com/nodejs/node/pull/23763)
* \[[`dc38427c64`](https://github.com/nodejs/node/commit/dc38427c64)] - **build**: fix coverage generation (Michael Dawson) [#23769](https://github.com/nodejs/node/pull/23769)
* \[[`e737c71936`](https://github.com/nodejs/node/commit/e737c71936)] - **build**: fix `./configure --enable-d8` (Ben Noordhuis) [#23656](https://github.com/nodejs/node/pull/23656)
* \[[`d886095377`](https://github.com/nodejs/node/commit/d886095377)] - **build**: add .DS\_store to .gitgnore (Marcos Frony) [#23554](https://github.com/nodejs/node/pull/23554)
* \[[`83b8c1fb90`](https://github.com/nodejs/node/commit/83b8c1fb90)] - **build,meta**: don't fail Travis for commit message (Refael Ackermann) [#23739](https://github.com/nodejs/node/pull/23739)
* \[[`156fa12674`](https://github.com/nodejs/node/commit/156fa12674)] - **build,meta**: switch to gcc-4.9 on travis (Refael Ackermann) [#23778](https://github.com/nodejs/node/pull/23778)
* \[[`df5a19f468`](https://github.com/nodejs/node/commit/df5a19f468)] - **child\_process**: handle undefined/null for fork() args (Shobhit Chittora) [#22416](https://github.com/nodejs/node/pull/22416)
* \[[`a97e79ce12`](https://github.com/nodejs/node/commit/a97e79ce12)] - **crypto**: add SET\_INTEGER\_CONSANT macro (Daniel Bevenius) [#23687](https://github.com/nodejs/node/pull/23687)
* \[[`90ac77440b`](https://github.com/nodejs/node/commit/90ac77440b)] - **crypto**: strip unwanted space from openssl version (Sam Roberts) [#23678](https://github.com/nodejs/node/pull/23678)
* \[[`806242bf40`](https://github.com/nodejs/node/commit/806242bf40)] - **crypto**: remove DiffieHellman.initialised\_ (Tobias Nießen) [#23717](https://github.com/nodejs/node/pull/23717)
* \[[`4b98ff299d`](https://github.com/nodejs/node/commit/4b98ff299d)] - **crypto**: simplify internal state handling (Tobias Nießen) [#23648](https://github.com/nodejs/node/pull/23648)
* \[[`d4b5f9f591`](https://github.com/nodejs/node/commit/d4b5f9f591)] - **crypto**: simplify error handling in ECDH::New (Tobias Nießen) [#23647](https://github.com/nodejs/node/pull/23647)
* \[[`0e0c7b8bf2`](https://github.com/nodejs/node/commit/0e0c7b8bf2)] - **crypto**: move field initialization to class (Diana Holland) [#23610](https://github.com/nodejs/node/pull/23610)
* \[[`a81696accd`](https://github.com/nodejs/node/commit/a81696accd)] - **crypto**: fix length argument to snprintf() (Ben Noordhuis) [#23622](https://github.com/nodejs/node/pull/23622)
* \[[`c8b018f930`](https://github.com/nodejs/node/commit/c8b018f930)] - **deps**: c-ares float, version number patch (Ben Noordhuis) [#23854](https://github.com/nodejs/node/pull/23854)
* \[[`52afdae394`](https://github.com/nodejs/node/commit/52afdae394)] - **deps**: upgrade to c-ares v1.15.0 (Ben Noordhuis) [#23854](https://github.com/nodejs/node/pull/23854)
* \[[`2e4ef5b5c0`](https://github.com/nodejs/node/commit/2e4ef5b5c0)] - **deps**: remove old c-ares configure files (Ben Noordhuis) [#23854](https://github.com/nodejs/node/pull/23854)
* \[[`983e3a1b7c`](https://github.com/nodejs/node/commit/983e3a1b7c)] - **deps**: cherry-pick 2987946 from upstream V8 (Refael Ackermann) [#24555](https://github.com/nodejs/node/pull/24555)
* \[[`1bed1107c7`](https://github.com/nodejs/node/commit/1bed1107c7)] - **deps**: icu: apply workaround patch (Steven R. Loomis) [#23764](https://github.com/nodejs/node/pull/23764)
* \[[`e231bf5a3f`](https://github.com/nodejs/node/commit/e231bf5a3f)] - **deps**: V8: Add virtual dtor to avoid aix gcc error (Vasili Skurydzin) [#23695](https://github.com/nodejs/node/pull/23695)
* \[[`1bea8db1ef`](https://github.com/nodejs/node/commit/1bea8db1ef)] - **deps**: cherry-pick 67b5499 from V8 upstream (Vasili Skurydzin) [#23695](https://github.com/nodejs/node/pull/23695)
* \[[`4233bd977c`](https://github.com/nodejs/node/commit/4233bd977c)] - **deps**: cherry-pick d2e0166 from V8 upstream (Vasili Skurydzin) [#23695](https://github.com/nodejs/node/pull/23695)
* \[[`bb55cc178c`](https://github.com/nodejs/node/commit/bb55cc178c)] - **deps**: cherry-pick a51f429 from V8 upstream (Vasili Skurydzin) [#23695](https://github.com/nodejs/node/pull/23695)
* \[[`e9901dde82`](https://github.com/nodejs/node/commit/e9901dde82)] - **deps**: cherry-pick abab9fb from V8 upstream (Vasili Skurydzin) [#23695](https://github.com/nodejs/node/pull/23695)
* \[[`e5f795a8af`](https://github.com/nodejs/node/commit/e5f795a8af)] - **deps**: cherry-pick d9e7832 from V8 upstream (Vasili Skurydzin) [#23695](https://github.com/nodejs/node/pull/23695)
* \[[`c8304f6567`](https://github.com/nodejs/node/commit/c8304f6567)] - **deps**: backport 525b396195 from upstream V8 (Peter Marshall) [#23827](https://github.com/nodejs/node/pull/23827)
* \[[`ff57f0fb7e`](https://github.com/nodejs/node/commit/ff57f0fb7e)] - **deps**: partially revert 'increase V8 deprecation levels' (Peter Marshall) [#24195](https://github.com/nodejs/node/pull/24195)
* \[[`06782fe5a3`](https://github.com/nodejs/node/commit/06782fe5a3)] - **deps**: add missing ares\_android.h file (cjihrig) [#23682](https://github.com/nodejs/node/pull/23682)
* \[[`f928d99da9`](https://github.com/nodejs/node/commit/f928d99da9)] - **dns**: fix inconsistent (hostname vs host) (Ulises Gascón) [#23572](https://github.com/nodejs/node/pull/23572)
* \[[`5ed5f034c7`](https://github.com/nodejs/node/commit/5ed5f034c7)] - **doc**: fix linting errors (cjihrig) [#24229](https://github.com/nodejs/node/pull/24229)
* \[[`e0f99a2250`](https://github.com/nodejs/node/commit/e0f99a2250)] - **doc**: wrap GOVERNANCE.md at 80 characters (Rich Trott) [#24094](https://github.com/nodejs/node/pull/24094)
* \[[`5fae45075c`](https://github.com/nodejs/node/commit/5fae45075c)] - **doc**: add text about error.code stability (Rich Trott) [#24090](https://github.com/nodejs/node/pull/24090)
* \[[`2659a43905`](https://github.com/nodejs/node/commit/2659a43905)] - **doc**: update System Errors documentation (Rich Trott) [#24090](https://github.com/nodejs/node/pull/24090)
* \[[`bcfb824154`](https://github.com/nodejs/node/commit/bcfb824154)] - **doc**: add psmarshall to collaborators (Peter Marshall) [#24170](https://github.com/nodejs/node/pull/24170)
* \[[`ec43b3287e`](https://github.com/nodejs/node/commit/ec43b3287e)] - **doc**: add shisama to collaborators (Masashi Hirano) [#24136](https://github.com/nodejs/node/pull/24136)
* \[[`0b6c1bb346`](https://github.com/nodejs/node/commit/0b6c1bb346)] - **doc**: implement minor text fixes to path.md (Rich Trott) [#24118](https://github.com/nodejs/node/pull/24118)
* \[[`7f1e0e55f8`](https://github.com/nodejs/node/commit/7f1e0e55f8)] - **doc**: inspector security warning for changing host (Сковорода Никита Андреевич) [#23640](https://github.com/nodejs/node/pull/23640)
* \[[`1609ddaa74`](https://github.com/nodejs/node/commit/1609ddaa74)] - **doc**: fix minor text issues in stream.md (Rich Trott) [#24116](https://github.com/nodejs/node/pull/24116)
* \[[`91b81092c1`](https://github.com/nodejs/node/commit/91b81092c1)] - **doc**: streamline CONTRIBUTING.md (Rich Trott) [#24010](https://github.com/nodejs/node/pull/24010)
* \[[`f081a8cccd`](https://github.com/nodejs/node/commit/f081a8cccd)] - **doc**: add table of contents to release guide (Michaël Zasso) [#24042](https://github.com/nodejs/node/pull/24042)
* \[[`9fd209169a`](https://github.com/nodejs/node/commit/9fd209169a)] - **doc**: add missing comma in net documentation (Rich Trott) [#24074](https://github.com/nodejs/node/pull/24074)
* \[[`f5f916f344`](https://github.com/nodejs/node/commit/f5f916f344)] - **doc**: correct link to test coverage command (mritunjaygoutam12) [#24049](https://github.com/nodejs/node/pull/24049)
* \[[`d21a8b66d3`](https://github.com/nodejs/node/commit/d21a8b66d3)] - **doc**: fix socket.connecting description (Anna Henningsen) [#24066](https://github.com/nodejs/node/pull/24066)
* \[[`6dc0a1c87c`](https://github.com/nodejs/node/commit/6dc0a1c87c)] - **doc**: add SECURITY.md to readme.md (warnerp18) [#24031](https://github.com/nodejs/node/pull/24031)
* \[[`0079dd793c`](https://github.com/nodejs/node/commit/0079dd793c)] - **doc**: edit man page for superfluous "node" usage (Rich Trott) [#24029](https://github.com/nodejs/node/pull/24029)
* \[[`a7523072b8`](https://github.com/nodejs/node/commit/a7523072b8)] - **doc**: fix dublication in net.createServer() docs (Ivan Filenko) [#24026](https://github.com/nodejs/node/pull/24026)
* \[[`13ca306d4a`](https://github.com/nodejs/node/commit/13ca306d4a)] - **doc**: address bits of proof reading work (Jagannath Bhat) [#23978](https://github.com/nodejs/node/pull/23978)
* \[[`93e2035e58`](https://github.com/nodejs/node/commit/93e2035e58)] - **doc**: revise COLLABORATOR\_GUIDE.md (Rich Trott) [#23990](https://github.com/nodejs/node/pull/23990)
* \[[`985c62d9e3`](https://github.com/nodejs/node/commit/985c62d9e3)] - **doc**: simplify CODE\_OF\_CONDUCT.md (Rich Trott) [#23989](https://github.com/nodejs/node/pull/23989)
* \[[`f8ebd0efe2`](https://github.com/nodejs/node/commit/f8ebd0efe2)] - **doc**: revise CHANGELOG.md text (Rich Trott) [#23988](https://github.com/nodejs/node/pull/23988)
* \[[`52215a4c35`](https://github.com/nodejs/node/commit/52215a4c35)] - **doc**: improve COLLABORATOR\_GUIDE (Jagannath Bhat) [#23977](https://github.com/nodejs/node/pull/23977)
* \[[`4871b116f8`](https://github.com/nodejs/node/commit/4871b116f8)] - **doc**: improve BUILDING.md (Jagannath Bhat) [#23976](https://github.com/nodejs/node/pull/23976)
* \[[`8ec4856941`](https://github.com/nodejs/node/commit/8ec4856941)] - **doc**: add types and their corresponding return values (Ouyang Yadong) [#23998](https://github.com/nodejs/node/pull/23998)
* \[[`10e66814ff`](https://github.com/nodejs/node/commit/10e66814ff)] - **doc**: add branding to style guide (Rich Trott) [#23967](https://github.com/nodejs/node/pull/23967)
* \[[`3de7858f13`](https://github.com/nodejs/node/commit/3de7858f13)] - **doc**: use Node.js instead of Node (Rich Trott) [#23967](https://github.com/nodejs/node/pull/23967)
* \[[`52fe6dd286`](https://github.com/nodejs/node/commit/52fe6dd286)] - **doc**: revise BUILDING.md (Rich Trott) [#23966](https://github.com/nodejs/node/pull/23966)
* \[[`95812953be`](https://github.com/nodejs/node/commit/95812953be)] - **doc**: clarify fd behaviour with {read,write}File (Sakthipriyan Vairamani (thefourtheye)) [#23706](https://github.com/nodejs/node/pull/23706)
* \[[`f54f640704`](https://github.com/nodejs/node/commit/f54f640704)] - **doc**: fix typographical issues (Denis McDonald) [#23970](https://github.com/nodejs/node/pull/23970)
* \[[`2fb89d0b86`](https://github.com/nodejs/node/commit/2fb89d0b86)] - **doc**: document HPE\_HEADER\_OVERFLOW error (Sam Roberts) [#23963](https://github.com/nodejs/node/pull/23963)
* \[[`c68aab1705`](https://github.com/nodejs/node/commit/c68aab1705)] - **doc**: add documentation for http.IncomingMessage$complete (James M Snell) [#23914](https://github.com/nodejs/node/pull/23914)
* \[[`1ac473f3a4`](https://github.com/nodejs/node/commit/1ac473f3a4)] - **doc**: remove mailing list (Rich Trott) [#23932](https://github.com/nodejs/node/pull/23932)
* \[[`c8bf42af51`](https://github.com/nodejs/node/commit/c8bf42af51)] - **doc**: remove notice of dashes in V8 options (Denys Otrishko) [#23903](https://github.com/nodejs/node/pull/23903)
* \[[`96004d6b7a`](https://github.com/nodejs/node/commit/96004d6b7a)] - **doc**: rename README section for Release Keys (Rich Trott) [#23927](https://github.com/nodejs/node/pull/23927)
* \[[`2752091628`](https://github.com/nodejs/node/commit/2752091628)] - **doc**: add note about ABI compatibility (Myles Borins) [#22237](https://github.com/nodejs/node/pull/22237)
* \[[`cc22a2a847`](https://github.com/nodejs/node/commit/cc22a2a847)] - **doc**: add optional callback to socket.end() (Ajido) [#23937](https://github.com/nodejs/node/pull/23937)
* \[[`6099f5cbdc`](https://github.com/nodejs/node/commit/6099f5cbdc)] - **doc**: make example more clarified in cluster.md (ZYSzys) [#23931](https://github.com/nodejs/node/pull/23931)
* \[[`437908a90b`](https://github.com/nodejs/node/commit/437908a90b)] - **doc**: simplify valid security issue descriptions (Rich Trott) [#23881](https://github.com/nodejs/node/pull/23881)
* \[[`abeba5f8b5`](https://github.com/nodejs/node/commit/abeba5f8b5)] - **doc**: simplify path.basename() on POSIX and Windows (ZYSzys) [#23864](https://github.com/nodejs/node/pull/23864)
* \[[`d830033274`](https://github.com/nodejs/node/commit/d830033274)] - **doc**: document nullptr comparisons in style guide (Anna Henningsen) [#23805](https://github.com/nodejs/node/pull/23805)
* \[[`8b358ecf4d`](https://github.com/nodejs/node/commit/8b358ecf4d)] - **doc**: remove problematic example from README (Rich Trott) [#23817](https://github.com/nodejs/node/pull/23817)
* \[[`1921865be2`](https://github.com/nodejs/node/commit/1921865be2)] - **doc**: use Cookie in request.setHeader() examples (Luigi Pinca) [#23707](https://github.com/nodejs/node/pull/23707)
* \[[`913c4910c7`](https://github.com/nodejs/node/commit/913c4910c7)] - **doc**: NODE\_EXTRA\_CA\_CERTS is ignored if setuid root (Ben Noordhuis) [#23770](https://github.com/nodejs/node/pull/23770)
* \[[`ace83a24a2`](https://github.com/nodejs/node/commit/ace83a24a2)] - **doc**: add review suggestions to require() (erickwendel) [#23605](https://github.com/nodejs/node/pull/23605)
* \[[`e87e9f2567`](https://github.com/nodejs/node/commit/e87e9f2567)] - **doc**: document and warn if the ICU version is too old (Steven R. Loomis) [#23766](https://github.com/nodejs/node/pull/23766)
* \[[`070d87af65`](https://github.com/nodejs/node/commit/070d87af65)] - **doc**: move @phillipj to emeriti (Phillip Johnsen) [#23790](https://github.com/nodejs/node/pull/23790)
* \[[`98fc848545`](https://github.com/nodejs/node/commit/98fc848545)] - **doc**: add note about removeListener order (James M Snell) [#23762](https://github.com/nodejs/node/pull/23762)
* \[[`540168ce57`](https://github.com/nodejs/node/commit/540168ce57)] - **doc**: document ACL limitation for fs.access on Windows (James M Snell) [#23772](https://github.com/nodejs/node/pull/23772)
* \[[`32df77c21f`](https://github.com/nodejs/node/commit/32df77c21f)] - **doc**: document that addMembership must be called once in a cluster (James M Snell) [#23746](https://github.com/nodejs/node/pull/23746)
* \[[`2a2882b470`](https://github.com/nodejs/node/commit/2a2882b470)] - **doc**: add missing YAML labels (Vse Mozhet Byt) [#23810](https://github.com/nodejs/node/pull/23810)
* \[[`5d5f85eb2e`](https://github.com/nodejs/node/commit/5d5f85eb2e)] - **doc**: remove reference to sslv3 in tls.md (James M Snell) [#23745](https://github.com/nodejs/node/pull/23745)
* \[[`0b1e41799d`](https://github.com/nodejs/node/commit/0b1e41799d)] - **doc**: revise security-reporting example text (Rich Trott) [#23759](https://github.com/nodejs/node/pull/23759)
* \[[`75082ee15b`](https://github.com/nodejs/node/commit/75082ee15b)] - **doc**: formalize non-const reference usage in C++ style guide (Anna Henningsen) [#23155](https://github.com/nodejs/node/pull/23155)
* \[[`4315899377`](https://github.com/nodejs/node/commit/4315899377)] - **doc**: add missing deprecation labels (James M Snell) [#23761](https://github.com/nodejs/node/pull/23761)
* \[[`aaf669d284`](https://github.com/nodejs/node/commit/aaf669d284)] - **doc**: document use of buffer.swap16() for utf16be (James M Snell) [#23747](https://github.com/nodejs/node/pull/23747)
* \[[`e85d15a47f`](https://github.com/nodejs/node/commit/e85d15a47f)] - **doc**: add Backport-PR-URL info in backport guide (Ali Ijaz Sheikh) [#23701](https://github.com/nodejs/node/pull/23701)
* \[[`535f113aea`](https://github.com/nodejs/node/commit/535f113aea)] - **doc**: improve README.md (Rich Trott) [#23705](https://github.com/nodejs/node/pull/23705)
* \[[`d81b143af0`](https://github.com/nodejs/node/commit/d81b143af0)] - **doc**: simplify security reporting text (Rich Trott) [#23686](https://github.com/nodejs/node/pull/23686)
* \[[`2a19518d18`](https://github.com/nodejs/node/commit/2a19518d18)] - **doc**: cleanup and references in C++ guide (Refael Ackermann) [#23650](https://github.com/nodejs/node/pull/23650)
* \[[`5bea331d6d`](https://github.com/nodejs/node/commit/5bea331d6d)] - **doc**: fix url example to match behavior (Сковорода Никита Андреевич) [#23359](https://github.com/nodejs/node/pull/23359)
* \[[`3db26d9f2f`](https://github.com/nodejs/node/commit/3db26d9f2f)] - **doc**: use reserved domains for examples in url.md (Сковорода Никита Андреевич) [#23359](https://github.com/nodejs/node/pull/23359)
* \[[`ac752c6a8c`](https://github.com/nodejs/node/commit/ac752c6a8c)] - **doc**: fix pr-url in repl.md (Сковорода Никита Андреевич) [#23359](https://github.com/nodejs/node/pull/23359)
* \[[`6748c0517b`](https://github.com/nodejs/node/commit/6748c0517b)] - **doc**: wrap links in <> (Сковорода Никита Андреевич) [#23359](https://github.com/nodejs/node/pull/23359)
* \[[`011116cc5b`](https://github.com/nodejs/node/commit/011116cc5b)] - **doc**: edit BUILDING.md (Rich Trott) [#23435](https://github.com/nodejs/node/pull/23435)
* \[[`e449bbbd54`](https://github.com/nodejs/node/commit/e449bbbd54)] - **doc**: describe SNI host name format (Sam Roberts) [#23357](https://github.com/nodejs/node/pull/23357)
* \[[`d5b1368173`](https://github.com/nodejs/node/commit/d5b1368173)] - **doc**: revise security-reporting text in README (Rich Trott) [#23407](https://github.com/nodejs/node/pull/23407)
* \[[`2798ac1709`](https://github.com/nodejs/node/commit/2798ac1709)] - **doc**: rewrite consensus seeking in guide (Rich Trott) [#23349](https://github.com/nodejs/node/pull/23349)
* \[[`56d1bc9762`](https://github.com/nodejs/node/commit/56d1bc9762)] - **doc**: edit for minor fixes to prcoess.md (Rich Trott) [#23347](https://github.com/nodejs/node/pull/23347)
* \[[`4c04e7c321`](https://github.com/nodejs/node/commit/4c04e7c321)] - **doc**: remove personal pronoun from worker\_threads (Rich Trott) [#23347](https://github.com/nodejs/node/pull/23347)
* \[[`df512961ce`](https://github.com/nodejs/node/commit/df512961ce)] - **doc**: remove personal pronoun from domain.md (Rich Trott) [#23347](https://github.com/nodejs/node/pull/23347)
* \[[`647eba6656`](https://github.com/nodejs/node/commit/647eba6656)] - **doc**: remove style instruction that is not followed (Rich Trott) [#23346](https://github.com/nodejs/node/pull/23346)
* \[[`457d22fa43`](https://github.com/nodejs/node/commit/457d22fa43)] - **doc**: add WebAssembly to globals (Steven) [#23339](https://github.com/nodejs/node/pull/23339)
* \[[`73f490a5fd`](https://github.com/nodejs/node/commit/73f490a5fd)] - **doc,meta**: assign PR semantics (Refael Ackermann) [#23292](https://github.com/nodejs/node/pull/23292)
* \[[`2ddf867030`](https://github.com/nodejs/node/commit/2ddf867030)] - **doc,meta**: refresh wording in colab guide (Refael Ackermann) [#23292](https://github.com/nodejs/node/pull/23292)
* \[[`04f27aa764`](https://github.com/nodejs/node/commit/04f27aa764)] - **doc,meta**: add references to outside C++ guides (Refael Ackermann) [#23317](https://github.com/nodejs/node/pull/23317)
* \[[`1491f32144`](https://github.com/nodejs/node/commit/1491f32144)] - **esm**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`e2b96da6ba`](https://github.com/nodejs/node/commit/e2b96da6ba)] - **events**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`a5462baf57`](https://github.com/nodejs/node/commit/a5462baf57)] - **fs**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`765a3a9466`](https://github.com/nodejs/node/commit/765a3a9466)] - **fs**: handle result of access binding directly in fs.existsSync (Joyee Cheung) [#24015](https://github.com/nodejs/node/pull/24015)
* \[[`63f2649577`](https://github.com/nodejs/node/commit/63f2649577)] - **http**: reduce duplicated code for cleaning parser (Weijia Wang) [#23351](https://github.com/nodejs/node/pull/23351)
* \[[`d08d252a94`](https://github.com/nodejs/node/commit/d08d252a94)] - **http2**: make Http2Settings constructors delegate (Daniel Bevenius) [#23326](https://github.com/nodejs/node/pull/23326)
* \[[`d79d978cd8`](https://github.com/nodejs/node/commit/d79d978cd8)] - **inspector**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`4035ca16c5`](https://github.com/nodejs/node/commit/4035ca16c5)] - **lib**: add crypto dependant modules cannotUseCache (Daniel Bevenius) [#24100](https://github.com/nodejs/node/pull/24100)
* \[[`a0b4f7a10e`](https://github.com/nodejs/node/commit/a0b4f7a10e)] - **lib**: move process prototype manipulation into setupProcessObject (Joyee Cheung) [#24089](https://github.com/nodejs/node/pull/24089)
* \[[`cb883bcbb0`](https://github.com/nodejs/node/commit/cb883bcbb0)] - **lib**: fix grammar error and make it clearer for comments (MaleDong) [#23799](https://github.com/nodejs/node/pull/23799)
* \[[`8ef5de55fd`](https://github.com/nodejs/node/commit/8ef5de55fd)] - **lib**: move module exports proxy into a separate method (Joyee Cheung) [#24057](https://github.com/nodejs/node/pull/24057)
* \[[`1841d0f776`](https://github.com/nodejs/node/commit/1841d0f776)] - **lib**: fix code cache generation (Joyee Cheung) [#23855](https://github.com/nodejs/node/pull/23855)
* \[[`b5eacfa5bd`](https://github.com/nodejs/node/commit/b5eacfa5bd)] - **lib**: remove useless cwd in posix.resolve (ZYSzys) [#23902](https://github.com/nodejs/node/pull/23902)
* \[[`d07cef7ed4`](https://github.com/nodejs/node/commit/d07cef7ed4)] - **lib**: migrate from process.binding('config') to getOptions() (Vladimir Ilic) [#23588](https://github.com/nodejs/node/pull/23588)
* \[[`5ebe7f7fc7`](https://github.com/nodejs/node/commit/5ebe7f7fc7)] - **lib**: migrate process.binding to internalBinding (surreal8) [#23517](https://github.com/nodejs/node/pull/23517)
* \[[`9b22e2a53a`](https://github.com/nodejs/node/commit/9b22e2a53a)] - **lib**: migrate process.binding to getOptions (Randy Wressell) [#23522](https://github.com/nodejs/node/pull/23522)
* \[[`83f4fcc176`](https://github.com/nodejs/node/commit/83f4fcc176)] - **lib**: migrate process.binding('config') to getOptions() (Jonny Kalambay) [#23526](https://github.com/nodejs/node/pull/23526)
* \[[`66119ed158`](https://github.com/nodejs/node/commit/66119ed158)] - **lib**: removed unused variable (Long Nguyen) [#23497](https://github.com/nodejs/node/pull/23497)
* \[[`33cf3b26b0`](https://github.com/nodejs/node/commit/33cf3b26b0)] - **lib**: switch to internalBinding for cjs loader (Steven Scott) [#23492](https://github.com/nodejs/node/pull/23492)
* \[[`cb597f231a`](https://github.com/nodejs/node/commit/cb597f231a)] - **lib**: migrate from process.binding to internalBinding (Andres Monge) [#23586](https://github.com/nodejs/node/pull/23586)
* \[[`6f01a792c8`](https://github.com/nodejs/node/commit/6f01a792c8)] - **lib**: migrate to getOptions in loaders.js (David Xue) [#23455](https://github.com/nodejs/node/pull/23455)
* \[[`f219f82eb7`](https://github.com/nodejs/node/commit/f219f82eb7)] - **lib**: remove an unused variable (Claire Liu) [#23482](https://github.com/nodejs/node/pull/23482)
* \[[`2ce8f7a507`](https://github.com/nodejs/node/commit/2ce8f7a507)] - **lib**: remove unused 'e' from catch (Matt Holmes) [#23458](https://github.com/nodejs/node/pull/23458)
* \[[`1fa9d91d37`](https://github.com/nodejs/node/commit/1fa9d91d37)] - **lib**: http server, friendly error messages (Sagi Tsofan) [#22995](https://github.com/nodejs/node/pull/22995)
* \[[`9718919da9`](https://github.com/nodejs/node/commit/9718919da9)] - **meta**: clarify fast-track approval (James M Snell) [#23744](https://github.com/nodejs/node/pull/23744)
* \[[`a116e32a09`](https://github.com/nodejs/node/commit/a116e32a09)] - **meta,doc**: ping community about new release (Refael Ackermann) [#24064](https://github.com/nodejs/node/pull/24064)
* \[[`19e2e6d891`](https://github.com/nodejs/node/commit/19e2e6d891)] - **module**: removed unused variable (Martin Omander) [#23624](https://github.com/nodejs/node/pull/23624)
* \[[`9f8349c49c`](https://github.com/nodejs/node/commit/9f8349c49c)] - **n-api**: add missing handle scopes (Daniel Bevenius) [#24011](https://github.com/nodejs/node/pull/24011)
* \[[`02a54ed1fa`](https://github.com/nodejs/node/commit/02a54ed1fa)] - **n-api**: make per-`Context`-ness of `napi_env` explicit (Anna Henningsen) [#23689](https://github.com/nodejs/node/pull/23689)
* \[[`56afb7b481`](https://github.com/nodejs/node/commit/56afb7b481)] - **net**: `net.Server.listen()` avoid operations on `null` when fail (Ouyang Yadong) [#23920](https://github.com/nodejs/node/pull/23920)
* \[[`4a79bef6c6`](https://github.com/nodejs/node/commit/4a79bef6c6)] - **os**: fix memory leak in `userInfo()` (Anna Henningsen) [#23893](https://github.com/nodejs/node/pull/23893)
* \[[`8001beefac`](https://github.com/nodejs/node/commit/8001beefac)] - **querystring**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`f11907c32d`](https://github.com/nodejs/node/commit/f11907c32d)] - **readline**: assert without the use of event listener (Lian Li) [#23472](https://github.com/nodejs/node/pull/23472)
* \[[`4b456d566a`](https://github.com/nodejs/node/commit/4b456d566a)] - **repl**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`f866a0bcb9`](https://github.com/nodejs/node/commit/f866a0bcb9)] - **repl**: use promise#finally (Weijia Wang) [#23971](https://github.com/nodejs/node/pull/23971)
* \[[`307b277b15`](https://github.com/nodejs/node/commit/307b277b15)] - **repl**: migrate from process.binding('config') to getOptions() (Jose Bucio) [#23684](https://github.com/nodejs/node/pull/23684)
* \[[`d07ee1ca0b`](https://github.com/nodejs/node/commit/d07ee1ca0b)] - **repl**: remove unused variable from try catch (mmisiarek) [#23452](https://github.com/nodejs/node/pull/23452)
* \[[`4c0e7b4d66`](https://github.com/nodejs/node/commit/4c0e7b4d66)] - **repl**: remove unused variable e from try catch (Khalid Adil) [#23449](https://github.com/nodejs/node/pull/23449)
* \[[`9106ccf9ca`](https://github.com/nodejs/node/commit/9106ccf9ca)] - **src**: prefer param function check over args length (Shelley Vohr) [#23835](https://github.com/nodejs/node/pull/23835)
* \[[`c6ad469ae4`](https://github.com/nodejs/node/commit/c6ad469ae4)] - **src**: fix fully-static & large-pages combination (Suresh Srinivas) [#23964](https://github.com/nodejs/node/pull/23964)
* \[[`d82e818848`](https://github.com/nodejs/node/commit/d82e818848)] - **src**: use "constants" string instead of creating new one (Ouyang Yadong) [#23894](https://github.com/nodejs/node/pull/23894)
* \[[`bb05aa3206`](https://github.com/nodejs/node/commit/bb05aa3206)] - **src**: reduce duplication in tcp\_wrap Connect (Daniel Bevenius) [#23753](https://github.com/nodejs/node/pull/23753)
* \[[`b53b0d1475`](https://github.com/nodejs/node/commit/b53b0d1475)] - **src**: refactor deprecated v8::String::NewFromTwoByte call (Romain Lanz) [#23803](https://github.com/nodejs/node/pull/23803)
* \[[`17db407ba2`](https://github.com/nodejs/node/commit/17db407ba2)] - **src**: refactor deprecated v8::Function::Call call (Romain Lanz) [#23804](https://github.com/nodejs/node/pull/23804)
* \[[`6bc66bf756`](https://github.com/nodejs/node/commit/6bc66bf756)] - **src**: fix CreatePlatform header param mismatch (Shelley Vohr) [#23947](https://github.com/nodejs/node/pull/23947)
* \[[`511fa20983`](https://github.com/nodejs/node/commit/511fa20983)] - **src**: trace\_event: secondary storage for metadata (Ali Ijaz Sheikh) [#20900](https://github.com/nodejs/node/pull/20900)
* \[[`71557d3f70`](https://github.com/nodejs/node/commit/71557d3f70)] - **src**: initial large page (2M) support (Suresh Srinivas) [#22079](https://github.com/nodejs/node/pull/22079)
* \[[`f1fc05b45c`](https://github.com/nodejs/node/commit/f1fc05b45c)] - **src**: changed stdio\_pipes\_ to std::vector (Steven Auger) [#23615](https://github.com/nodejs/node/pull/23615)
* \[[`018a8683d6`](https://github.com/nodejs/node/commit/018a8683d6)] - **src**: update v8::Object::GetPropertyNames() usage (cjihrig) [#23660](https://github.com/nodejs/node/pull/23660)
* \[[`05409c9075`](https://github.com/nodejs/node/commit/05409c9075)] - **src**: remove OCB support ifdef OPENSSL\_NO\_OCB (Shelley Vohr) [#23635](https://github.com/nodejs/node/pull/23635)
* \[[`e7bf838b1e`](https://github.com/nodejs/node/commit/e7bf838b1e)] - **src**: change macro to fn (Gino Notto) [#23603](https://github.com/nodejs/node/pull/23603)
* \[[`d152d7fb60`](https://github.com/nodejs/node/commit/d152d7fb60)] - **src**: add default initializer in tls\_wrap (Richard Hoehn) [#23567](https://github.com/nodejs/node/pull/23567)
* \[[`3d76ab9287`](https://github.com/nodejs/node/commit/3d76ab9287)] - **src**: use MallocedBuffer abstraction for buffers (Cody Hazelwood) [#23543](https://github.com/nodejs/node/pull/23543)
* \[[`b258b377db`](https://github.com/nodejs/node/commit/b258b377db)] - **src**: use default initializers over settings fields on the constructor (Andrew J D McCann) [#23532](https://github.com/nodejs/node/pull/23532)
* \[[`e04a128731`](https://github.com/nodejs/node/commit/e04a128731)] - **src**: remove unused UVHandle methods (MarianneDr) [#23535](https://github.com/nodejs/node/pull/23535)
* \[[`c854879dd4`](https://github.com/nodejs/node/commit/c854879dd4)] - **src**: ready background workers before bootstrap (Ali Ijaz Sheikh) [#23233](https://github.com/nodejs/node/pull/23233)
* \[[`84aa6b2c59`](https://github.com/nodejs/node/commit/84aa6b2c59)] - **src**: move default assignment of async\_id\_ in async\_wrap.h (David Corona) [#23495](https://github.com/nodejs/node/pull/23495)
* \[[`a663d5674d`](https://github.com/nodejs/node/commit/a663d5674d)] - **src**: fix bug in MallocedBuffer constructor (Tobias Nießen) [#23434](https://github.com/nodejs/node/pull/23434)
* \[[`38f5644449`](https://github.com/nodejs/node/commit/38f5644449)] - **src**: improve SSL version extraction logic (Gireesh Punathil) [#23050](https://github.com/nodejs/node/pull/23050)
* \[[`8cfbce3163`](https://github.com/nodejs/node/commit/8cfbce3163)] - **src**: revert removal of SecureContext `_external` getter (Vitaly Dyatlov) [#21711](https://github.com/nodejs/node/pull/21711)
* \[[`7ed4079286`](https://github.com/nodejs/node/commit/7ed4079286)] - **src**: remove unused limits header from util-inl.h (Daniel Bevenius) [#23353](https://github.com/nodejs/node/pull/23353)
* \[[`eb71ab5f99`](https://github.com/nodejs/node/commit/eb71ab5f99)] - **src**: replace NO\_RETURN with \[\[noreturn]] (Refael Ackermann) [#23337](https://github.com/nodejs/node/pull/23337)
* \[[`a22ef72afb`](https://github.com/nodejs/node/commit/a22ef72afb)] - **src**: fix usage of deprecated v8::Date::New (Michaël Zasso) [#23288](https://github.com/nodejs/node/pull/23288)
* \[[`b4cdd478b9`](https://github.com/nodejs/node/commit/b4cdd478b9)] - **src,win**: informative stack traces (Refael Ackermann) [#23822](https://github.com/nodejs/node/pull/23822)
* \[[`cb861a4897`](https://github.com/nodejs/node/commit/cb861a4897)] - **stream**: do not error async iterators on destroy(null) (Matteo Collina) [#23901](https://github.com/nodejs/node/pull/23901)
* \[[`6f4a638175`](https://github.com/nodejs/node/commit/6f4a638175)] - **stream**: ended streams should resolve the async iteration (Matteo Collina) [#23901](https://github.com/nodejs/node/pull/23901)
* \[[`ce79ae6544`](https://github.com/nodejs/node/commit/ce79ae6544)] - **stream**: async iteration should work with destroyed stream (Matteo Collina) [#23785](https://github.com/nodejs/node/pull/23785)
* \[[`78be4771a6`](https://github.com/nodejs/node/commit/78be4771a6)] - **test**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`43097d9d7f`](https://github.com/nodejs/node/commit/43097d9d7f)] - **test**: disable color formating for test-internal-errors.js (Refael Ackermann) [#24204](https://github.com/nodejs/node/pull/24204)
* \[[`dddb466f59`](https://github.com/nodejs/node/commit/dddb466f59)] - **test**: add crypto check to test-benchmark-http2 (Daniel Bevenius) [#24096](https://github.com/nodejs/node/pull/24096)
* \[[`1b6c00e3fa`](https://github.com/nodejs/node/commit/1b6c00e3fa)] - **test**: increase --stack\_size test-async-wrap-pop (Daniel Bevenius) [#23996](https://github.com/nodejs/node/pull/23996)
* \[[`b3ab546b37`](https://github.com/nodejs/node/commit/b3ab546b37)] - **test**: assert that invalidcmd throws error code (Jerome Covington) [#23942](https://github.com/nodejs/node/pull/23942)
* \[[`52c9209f1c`](https://github.com/nodejs/node/commit/52c9209f1c)] - **test**: fix strictEqual arguments order (Esteban Sotillo) [#23956](https://github.com/nodejs/node/pull/23956)
* \[[`1d6dd961ef`](https://github.com/nodejs/node/commit/1d6dd961ef)] - **test**: add property for RangeError in test-buffer-copy (mritunjaygoutam12) [#23968](https://github.com/nodejs/node/pull/23968)
* \[[`5bedd1ce2f`](https://github.com/nodejs/node/commit/5bedd1ce2f)] - **test**: fix test-fs-watch-system-limit (Ali Ijaz Sheikh) [#23986](https://github.com/nodejs/node/pull/23986)
* \[[`c5577c17ac`](https://github.com/nodejs/node/commit/c5577c17ac)] - **test**: run code cache test by default and test generator (Joyee Cheung) [#23855](https://github.com/nodejs/node/pull/23855)
* \[[`4eab8a1079`](https://github.com/nodejs/node/commit/4eab8a1079)] - **test**: fix regression when compiled with FIPS (Adam Majer) [#23871](https://github.com/nodejs/node/pull/23871)
* \[[`682361cd4a`](https://github.com/nodejs/node/commit/682361cd4a)] - **test**: fix strictEqual() argument order (Loic) [#23829](https://github.com/nodejs/node/pull/23829)
* \[[`d1c6238e1d`](https://github.com/nodejs/node/commit/d1c6238e1d)] - **test**: verify `performance.timerify()` works w/ non-Node Contexts (Anna Henningsen) [#23784](https://github.com/nodejs/node/pull/23784)
* \[[`55ca2a71fd`](https://github.com/nodejs/node/commit/55ca2a71fd)] - **test**: add test-benchmark-napi (Emily Marigold Klassen) [#23585](https://github.com/nodejs/node/pull/23585)
* \[[`ce6ddc404d`](https://github.com/nodejs/node/commit/ce6ddc404d)] - **test**: increase coverage of internal/stream/end-of-stream (Tyler Vann-Campbell) [#23751](https://github.com/nodejs/node/pull/23751)
* \[[`0ce76be843`](https://github.com/nodejs/node/commit/0ce76be843)] - **test**: fix strictEqual() arguments order (Nolan Rigo) [#23800](https://github.com/nodejs/node/pull/23800)
* \[[`1747e473bd`](https://github.com/nodejs/node/commit/1747e473bd)] - **test**: fix invalid modulesLength for DSA keygen (Adam Majer) [#23732](https://github.com/nodejs/node/pull/23732)
* \[[`9b6b2800e6`](https://github.com/nodejs/node/commit/9b6b2800e6)] - **test**: fix test-require-symlink on Windows (Bartosz Sosnowski) [#23691](https://github.com/nodejs/node/pull/23691)
* \[[`874d02375b`](https://github.com/nodejs/node/commit/874d02375b)] - **test**: fix strictEqual() argument order (Romain Lanz) [#23768](https://github.com/nodejs/node/pull/23768)
* \[[`3d43679907`](https://github.com/nodejs/node/commit/3d43679907)] - **test**: fix strictEqual() arguments order (Thomas GENTILHOMME) [#23771](https://github.com/nodejs/node/pull/23771)
* \[[`cc040f6887`](https://github.com/nodejs/node/commit/cc040f6887)] - **test**: fix assertion arguments order (Elian Gutierrez) [#23787](https://github.com/nodejs/node/pull/23787)
* \[[`5844932b6c`](https://github.com/nodejs/node/commit/5844932b6c)] - **test**: add blocks and comments to fs-promises tests (Ian Sutherland) [#23627](https://github.com/nodejs/node/pull/23627)
* \[[`9aced4c384`](https://github.com/nodejs/node/commit/9aced4c384)] - **test**: add a test for `tls.Socket` with `allowHalfOpen` (Ouyang Yadong) [#23866](https://github.com/nodejs/node/pull/23866)
* \[[`9979c71d67`](https://github.com/nodejs/node/commit/9979c71d67)] - **test**: increase coverage for readfile with withFileTypes (christian-bromann) [#23557](https://github.com/nodejs/node/pull/23557)
* \[[`3bc7b5efd2`](https://github.com/nodejs/node/commit/3bc7b5efd2)] - **test**: skip failing tests for osx mojave (jn99) [#23550](https://github.com/nodejs/node/pull/23550)
* \[[`51ceaf5bc1`](https://github.com/nodejs/node/commit/51ceaf5bc1)] - **test**: enable trace-events tests for workers (Richard Lau) [#23698](https://github.com/nodejs/node/pull/23698)
* \[[`3e143dfdd9`](https://github.com/nodejs/node/commit/3e143dfdd9)] - **test**: improve test coverage for fs module (<garrik.leonardo@gmail.com>) [#23601](https://github.com/nodejs/node/pull/23601)
* \[[`65b37324c2`](https://github.com/nodejs/node/commit/65b37324c2)] - **test**: fix argument order in assertion (Illescas, Ricardo) [#23581](https://github.com/nodejs/node/pull/23581)
* \[[`d61901499a`](https://github.com/nodejs/node/commit/d61901499a)] - **test**: reversed params in assert.strictEqual() (Dusan Radovanovic) [#23591](https://github.com/nodejs/node/pull/23591)
* \[[`6baba1d54a`](https://github.com/nodejs/node/commit/6baba1d54a)] - **test**: correct order of args in buffer compare (James Irwin) [#23521](https://github.com/nodejs/node/pull/23521)
* \[[`232fe58a4c`](https://github.com/nodejs/node/commit/232fe58a4c)] - **test**: check codes of thrown errors (Nancy Truong) [#23519](https://github.com/nodejs/node/pull/23519)
* \[[`c2aa762fd7`](https://github.com/nodejs/node/commit/c2aa762fd7)] - **test**: fix strictEqual arguments order (Jonathan Samines) [#23486](https://github.com/nodejs/node/pull/23486)
* \[[`dc12fa19ab`](https://github.com/nodejs/node/commit/dc12fa19ab)] - **test**: add test coverage for fs.truncate (christian-bromann) [#23620](https://github.com/nodejs/node/pull/23620)
* \[[`4daf8e0910`](https://github.com/nodejs/node/commit/4daf8e0910)] - **test**: use smaller keys for a faster keygen test (Sam Roberts) [#23430](https://github.com/nodejs/node/pull/23430)
* \[[`6d8669c5d8`](https://github.com/nodejs/node/commit/6d8669c5d8)] - **test**: increased code coverage for slowCases (Jared Haines) [#23592](https://github.com/nodejs/node/pull/23592)
* \[[`51c3685dbd`](https://github.com/nodejs/node/commit/51c3685dbd)] - **test**: assertions arguments match docs (Amanuel Ghebreweldi) [#23594](https://github.com/nodejs/node/pull/23594)
* \[[`4ab822329e`](https://github.com/nodejs/node/commit/4ab822329e)] - **test**: fix assert.strictEqual() argument order (Derek) [#23598](https://github.com/nodejs/node/pull/23598)
* \[[`779d5ec0fe`](https://github.com/nodejs/node/commit/779d5ec0fe)] - **test**: fix assert parameter order in test-https-localaddress.js (Ian Sutherland) [#23599](https://github.com/nodejs/node/pull/23599)
* \[[`fad9d805ef`](https://github.com/nodejs/node/commit/fad9d805ef)] - **test**: change order of assert.strictEquals arguments (Chuck Theobald) [#23600](https://github.com/nodejs/node/pull/23600)
* \[[`07c8a9e7a7`](https://github.com/nodejs/node/commit/07c8a9e7a7)] - **test**: fix assert equal order of arguments (David Jiang) [#23602](https://github.com/nodejs/node/pull/23602)
* \[[`591af98268`](https://github.com/nodejs/node/commit/591af98268)] - **test**: fix order of assert args in client response domain test (Emily Kolar) [#23604](https://github.com/nodejs/node/pull/23604)
* \[[`ede9ce14d5`](https://github.com/nodejs/node/commit/ede9ce14d5)] - **test**: re-order strictEqual paramater calls (Paul Tichonczuk) [#23607](https://github.com/nodejs/node/pull/23607)
* \[[`61cf1cfb20`](https://github.com/nodejs/node/commit/61cf1cfb20)] - **test**: fix assertions args order (Milton Sosa) [#23608](https://github.com/nodejs/node/pull/23608)
* \[[`7b2e7aa64e`](https://github.com/nodejs/node/commit/7b2e7aa64e)] - **test**: fix parameters in test-repl.js (Israel Ortiz) [#23609](https://github.com/nodejs/node/pull/23609)
* \[[`f7f5c5c477`](https://github.com/nodejs/node/commit/f7f5c5c477)] - **test**: reverse arguments in assert.strictEqual (Vsevolod Geraskin) [#23613](https://github.com/nodejs/node/pull/23613)
* \[[`8be279af17`](https://github.com/nodejs/node/commit/8be279af17)] - **test**: update assertion parameter order (Sean Healy) [#23614](https://github.com/nodejs/node/pull/23614)
* \[[`4c35953fb2`](https://github.com/nodejs/node/commit/4c35953fb2)] - **test**: fix backward assertion arguments (Stéphane Vasseur) [#23616](https://github.com/nodejs/node/pull/23616)
* \[[`3eb8938778`](https://github.com/nodejs/node/commit/3eb8938778)] - **test**: reversed 1st and 2nd arguments for assert.strictEqual() (vchoubey08) [#23617](https://github.com/nodejs/node/pull/23617)
* \[[`5ce59a148f`](https://github.com/nodejs/node/commit/5ce59a148f)] - **test**: correct assertion argument order (Jeff Marvin) [#23618](https://github.com/nodejs/node/pull/23618)
* \[[`1957001f19`](https://github.com/nodejs/node/commit/1957001f19)] - **test**: fix assertion order (erickwendel) [#23626](https://github.com/nodejs/node/pull/23626)
* \[[`5d7676c047`](https://github.com/nodejs/node/commit/5d7676c047)] - **test**: updated assert test values to doc standards (keeysnc) [#23593](https://github.com/nodejs/node/pull/23593)
* \[[`7c35f7f608`](https://github.com/nodejs/node/commit/7c35f7f608)] - **test**: switch order of assertion arguments (Mel) [#23563](https://github.com/nodejs/node/pull/23563)
* \[[`46ca12f81e`](https://github.com/nodejs/node/commit/46ca12f81e)] - **test**: fix assert.strictEqual() argument order (Savio Resende) [#23564](https://github.com/nodejs/node/pull/23564)
* \[[`bf32cde70a`](https://github.com/nodejs/node/commit/bf32cde70a)] - **test**: fix parameter order of assertions (Pete Lombardo) [#23565](https://github.com/nodejs/node/pull/23565)
* \[[`d9e58b8bed`](https://github.com/nodejs/node/commit/d9e58b8bed)] - **test**: fix assert value order (Ethan Weber) [#23566](https://github.com/nodejs/node/pull/23566)
* \[[`d574d865d8`](https://github.com/nodejs/node/commit/d574d865d8)] - **test**: fix strictEqual order for timers test (Saleh Abdel Motaal) [#23568](https://github.com/nodejs/node/pull/23568)
* \[[`f33fe7428e`](https://github.com/nodejs/node/commit/f33fe7428e)] - **test**: corrected assertion arguments order (francois) [#23569](https://github.com/nodejs/node/pull/23569)
* \[[`524222e55a`](https://github.com/nodejs/node/commit/524222e55a)] - **test**: fix strictEqual input parameters order (AlixAng) [#23570](https://github.com/nodejs/node/pull/23570)
* \[[`0f8709ce4b`](https://github.com/nodejs/node/commit/0f8709ce4b)] - **test**: fix order of arguments passed to strictEqual (Joe Shindelar) [#23571](https://github.com/nodejs/node/pull/23571)
* \[[`8f1cea6e18`](https://github.com/nodejs/node/commit/8f1cea6e18)] - **test**: fix arguments ordering for assertions to match the docs (Liran Tal) [#23575](https://github.com/nodejs/node/pull/23575)
* \[[`7fed93d699`](https://github.com/nodejs/node/commit/7fed93d699)] - **test**: fixed strictEqual arguments order (Ruy Adorno) [#23576](https://github.com/nodejs/node/pull/23576)
* \[[`86fd1fc0f7`](https://github.com/nodejs/node/commit/86fd1fc0f7)] - **test**: add crypto.scrypt test case with different encoding (Yitong) [#23578](https://github.com/nodejs/node/pull/23578)
* \[[`94c7406546`](https://github.com/nodejs/node/commit/94c7406546)] - **test**: reversed actual and expected values for .strictEqual() (Salman Shakeel) [#23579](https://github.com/nodejs/node/pull/23579)
* \[[`3d1e51e130`](https://github.com/nodejs/node/commit/3d1e51e130)] - **test**: increased code coverage for proxySessionHandler (Justin Lee) [#23583](https://github.com/nodejs/node/pull/23583)
* \[[`56043109da`](https://github.com/nodejs/node/commit/56043109da)] - **test**: fix assertion arguments order (seantcoyote) [#23584](https://github.com/nodejs/node/pull/23584)
* \[[`38b6fffb78`](https://github.com/nodejs/node/commit/38b6fffb78)] - **test**: fix assert.strictEqual() parameter order in test-path-maklong.js (blakehall) [#23587](https://github.com/nodejs/node/pull/23587)
* \[[`88cbb4afe6`](https://github.com/nodejs/node/commit/88cbb4afe6)] - **test**: fix argument order in assertions (Illescas, Ricardo) [#23589](https://github.com/nodejs/node/pull/23589)
* \[[`ff22625173`](https://github.com/nodejs/node/commit/ff22625173)] - **test**: fix order of parameters to assert.strictEqual (Jason Nutter) [#23590](https://github.com/nodejs/node/pull/23590)
* \[[`2498369f29`](https://github.com/nodejs/node/commit/2498369f29)] - **test**: removed unused variable in fs-watch-file-slow (Maki Toda) [#23548](https://github.com/nodejs/node/pull/23548)
* \[[`9a79824348`](https://github.com/nodejs/node/commit/9a79824348)] - **test**: update strictEqual arguments order (Clinton Pahl) [#23552](https://github.com/nodejs/node/pull/23552)
* \[[`720262bacb`](https://github.com/nodejs/node/commit/720262bacb)] - **test**: removed unused error variable in try catch (Murtaza H) [#23553](https://github.com/nodejs/node/pull/23553)
* \[[`f55a5027b6`](https://github.com/nodejs/node/commit/f55a5027b6)] - **test**: reverse order of args in reconnect-error assert (Jackelin Herrera) [#23555](https://github.com/nodejs/node/pull/23555)
* \[[`402cb65b8f`](https://github.com/nodejs/node/commit/402cb65b8f)] - **test**: added async-hook benchmark (peter) [#23556](https://github.com/nodejs/node/pull/23556)
* \[[`fcd273e6a7`](https://github.com/nodejs/node/commit/fcd273e6a7)] - **test**: fix order of assert arguments in vm-new-script-this-context (Victor Poriazov) [#23558](https://github.com/nodejs/node/pull/23558)
* \[[`699a1ace7c`](https://github.com/nodejs/node/commit/699a1ace7c)] - **test**: modernize test-crypto-domain (naris93) [#23559](https://github.com/nodejs/node/pull/23559)
* \[[`c64126905c`](https://github.com/nodejs/node/commit/c64126905c)] - **test**: fix strictEqual assertion order on readline tests (Joe Grosspietsch) [#23561](https://github.com/nodejs/node/pull/23561)
* \[[`29db84a7cc`](https://github.com/nodejs/node/commit/29db84a7cc)] - **test**: switch strictEqual parameters - actual first before expected (Chris Bautista) [#23537](https://github.com/nodejs/node/pull/23537)
* \[[`9bc7d839af`](https://github.com/nodejs/node/commit/9bc7d839af)] - **test**: assert.strictEqual parameters ordered correctly (Justin denBroeder) [#23538](https://github.com/nodejs/node/pull/23538)
* \[[`f1c0538d32`](https://github.com/nodejs/node/commit/f1c0538d32)] - **test**: fix assert.strictEqual() arguments order (Ivan Lukasevych) [#23539](https://github.com/nodejs/node/pull/23539)
* \[[`f2d10452b7`](https://github.com/nodejs/node/commit/f2d10452b7)] - **test**: reverse the order of assertion statement arguments in pingpong test (Allan Zheng) [#23540](https://github.com/nodejs/node/pull/23540)
* \[[`5292f54316`](https://github.com/nodejs/node/commit/5292f54316)] - **test**: added test for generateKeyPair (David Xue) [#23541](https://github.com/nodejs/node/pull/23541)
* \[[`a8501e4ade`](https://github.com/nodejs/node/commit/a8501e4ade)] - **test**: swap expected and actual arguments in assert.strictEqual() (Erin Bush) [#23542](https://github.com/nodejs/node/pull/23542)
* \[[`a1ad454615`](https://github.com/nodejs/node/commit/a1ad454615)] - **test**: fix assertions argument order (KelvinLawHF1) [#23544](https://github.com/nodejs/node/pull/23544)
* \[[`643004f08b`](https://github.com/nodejs/node/commit/643004f08b)] - **test**: fix assertion argument order (Carl Richmond) [#23545](https://github.com/nodejs/node/pull/23545)
* \[[`d54e15f6f7`](https://github.com/nodejs/node/commit/d54e15f6f7)] - **test**: refactor callback functions to arrow functions (Sean Healy) [#23546](https://github.com/nodejs/node/pull/23546)
* \[[`299285a2ff`](https://github.com/nodejs/node/commit/299285a2ff)] - **test**: updating assertion and expect order in test-tls-client-verify.js (Eli Itah) [#23547](https://github.com/nodejs/node/pull/23547)
* \[[`91816adb8f`](https://github.com/nodejs/node/commit/91816adb8f)] - **test**: use correct argument order for assert.strictEqual() (Oktavianus Ludiro) [#23527](https://github.com/nodejs/node/pull/23527)
* \[[`c91497b29b`](https://github.com/nodejs/node/commit/c91497b29b)] - **test**: corrected the order of arguments in assert.strictEqual() (Diana Lee) [#23528](https://github.com/nodejs/node/pull/23528)
* \[[`8a7fa5ef4b`](https://github.com/nodejs/node/commit/8a7fa5ef4b)] - **test**: fix assert.strictEqual() argument order (ssamuels0916) [#23529](https://github.com/nodejs/node/pull/23529)
* \[[`e25f288367`](https://github.com/nodejs/node/commit/e25f288367)] - **test**: fix strictEqual assertion argument in test-tls-ecdh-auto (jaxyz) [#23530](https://github.com/nodejs/node/pull/23530)
* \[[`04ec990857`](https://github.com/nodejs/node/commit/04ec990857)] - **test**: correct labelling of asserts errors (nofwayy) [#23531](https://github.com/nodejs/node/pull/23531)
* \[[`3c5d312662`](https://github.com/nodejs/node/commit/3c5d312662)] - **test**: reorder asserts arguments (Marcos Frony) [#23534](https://github.com/nodejs/node/pull/23534)
* \[[`a665e3ac1e`](https://github.com/nodejs/node/commit/a665e3ac1e)] - **test**: updating assertion on test so it fits the new method signature (<garrik.leonardo@gmail.com>) [#23536](https://github.com/nodejs/node/pull/23536)
* \[[`bf39c9c56e`](https://github.com/nodejs/node/commit/bf39c9c56e)] - **test**: refactor functions to es6 (Michael Chen) [#23510](https://github.com/nodejs/node/pull/23510)
* \[[`0267e2fbec`](https://github.com/nodejs/node/commit/0267e2fbec)] - **test**: replaced functions with arrow functions (edgarzapeka) [#23511](https://github.com/nodejs/node/pull/23511)
* \[[`a059180f57`](https://github.com/nodejs/node/commit/a059180f57)] - **test**: corret assertion arg order in test-regress-GH-892.js (Elvis-Philip N) [#23513](https://github.com/nodejs/node/pull/23513)
* \[[`abb583bc4f`](https://github.com/nodejs/node/commit/abb583bc4f)] - **test**: fix test-dgram-pingpong assertion arg order (David Ward) [#23514](https://github.com/nodejs/node/pull/23514)
* \[[`283766474a`](https://github.com/nodejs/node/commit/283766474a)] - **test**: fix assert.strictEqual() argument order (Ben Schaaf) [#23515](https://github.com/nodejs/node/pull/23515)
* \[[`1e0a969b85`](https://github.com/nodejs/node/commit/1e0a969b85)] - **test**: fix assert.strictEqual arg order in test-tls-ecdh-multiple.js (Takdeer Sodhan) [#23516](https://github.com/nodejs/node/pull/23516)
* \[[`d54d2f0743`](https://github.com/nodejs/node/commit/d54d2f0743)] - **test**: use the correct parameter order on assert.strictEqual() (Tyler Vann-Campbell) [#23520](https://github.com/nodejs/node/pull/23520)
* \[[`98b4a94ebc`](https://github.com/nodejs/node/commit/98b4a94ebc)] - **test**: fix assert order in test-vm-context (Lee Gray) [#23523](https://github.com/nodejs/node/pull/23523)
* \[[`168cc9d9d5`](https://github.com/nodejs/node/commit/168cc9d9d5)] - **test**: switch arguments of assert() (Arne Schramm) [#23524](https://github.com/nodejs/node/pull/23524)
* \[[`1cf532fc06`](https://github.com/nodejs/node/commit/1cf532fc06)] - **test**: swap assert argument order in test-vm-create-and-run-in-context.js (Pascal Lambert) [#23525](https://github.com/nodejs/node/pull/23525)
* \[[`cf0dbbd49f`](https://github.com/nodejs/node/commit/cf0dbbd49f)] - **test**: fix order of assert.strictEqual() args to actual, expected (Joshua Belcher) [#23501](https://github.com/nodejs/node/pull/23501)
* \[[`30c31ba005`](https://github.com/nodejs/node/commit/30c31ba005)] - **test**: fixed incorrect variable order in assert.strictEqual() (Daniyal Mokhammad) [#23502](https://github.com/nodejs/node/pull/23502)
* \[[`2e879a6979`](https://github.com/nodejs/node/commit/2e879a6979)] - **test**: properly order test assertion variables (David Scott) [#23503](https://github.com/nodejs/node/pull/23503)
* \[[`e3f34934fc`](https://github.com/nodejs/node/commit/e3f34934fc)] - **test**: modernize test-child-process-flush-stdio (Viacheslav Liakhov) [#23504](https://github.com/nodejs/node/pull/23504)
* \[[`a8a30a9167`](https://github.com/nodejs/node/commit/a8a30a9167)] - **test**: put expected assert value in correct place (Jean-Francois Arseneau) [#23505](https://github.com/nodejs/node/pull/23505)
* \[[`ac70ab0bc9`](https://github.com/nodejs/node/commit/ac70ab0bc9)] - **test**: fix argument order in assertions (Illescas, Ricardo) [#23506](https://github.com/nodejs/node/pull/23506)
* \[[`7577de59b2`](https://github.com/nodejs/node/commit/7577de59b2)] - **test**: fix assertions args order in test/parallel/test-fs-chmod.js (Milton Sosa) [#23507](https://github.com/nodejs/node/pull/23507)
* \[[`99d3c66d1c`](https://github.com/nodejs/node/commit/99d3c66d1c)] - **test**: fix strictEqual assertion arguments (Alejandro Oviedo Garcia) [#23508](https://github.com/nodejs/node/pull/23508)
* \[[`c1b752355c`](https://github.com/nodejs/node/commit/c1b752355c)] - **test**: fix ordering of assertion values (Andrew MacCuaig)
* \[[`894fe38814`](https://github.com/nodejs/node/commit/894fe38814)] - **test**: update function keywords to fat arrows (Robert Monks) [#23493](https://github.com/nodejs/node/pull/23493)
* \[[`91ec3137fc`](https://github.com/nodejs/node/commit/91ec3137fc)] - **test**: reversed arguments in strictqual to reflect documentation (scabhi) [#23494](https://github.com/nodejs/node/pull/23494)
* \[[`85059a94f6`](https://github.com/nodejs/node/commit/85059a94f6)] - **test**: modernized test to use arrow functions (Greg Goforth) [#23496](https://github.com/nodejs/node/pull/23496)
* \[[`164c7daebc`](https://github.com/nodejs/node/commit/164c7daebc)] - **test**: use arrow functions in test-exception-handler (Jenna Zeigen) [#23498](https://github.com/nodejs/node/pull/23498)
* \[[`1eed9caf53`](https://github.com/nodejs/node/commit/1eed9caf53)] - **test**: fix argument order in asserts (@CAYdenberg) [#23499](https://github.com/nodejs/node/pull/23499)
* \[[`283decb45a`](https://github.com/nodejs/node/commit/283decb45a)] - **test**: modernizing test-dgram-listen-after-bind with arrow functions (chrisforrette) [#23500](https://github.com/nodejs/node/pull/23500)
* \[[`189d74669c`](https://github.com/nodejs/node/commit/189d74669c)] - **test**: fix strictEqual argument order (Felix Schlenkrich) [#23490](https://github.com/nodejs/node/pull/23490)
* \[[`f4ef1361fb`](https://github.com/nodejs/node/commit/f4ef1361fb)] - **test**: rename process.argv\[0] to process.execPath, rename ex to err (Kayla Altepeter) [#23488](https://github.com/nodejs/node/pull/23488)
* \[[`01bfb22441`](https://github.com/nodejs/node/commit/01bfb22441)] - **test**: fix assertion argument order (Carl Richmond) [#23489](https://github.com/nodejs/node/pull/23489)
* \[[`0753c9e1b4`](https://github.com/nodejs/node/commit/0753c9e1b4)] - **test**: fix assertion order test-tls-server-verify (Carolina Pinzon) [#23549](https://github.com/nodejs/node/pull/23549)
* \[[`860a097567`](https://github.com/nodejs/node/commit/860a097567)] - **test**: fix assertion order (Chris Nguyen) [#23533](https://github.com/nodejs/node/pull/23533)
* \[[`925a3df275`](https://github.com/nodejs/node/commit/925a3df275)] - **test**: change to arrow functions in send-bad-arguments (Anna Zhao) [#23483](https://github.com/nodejs/node/pull/23483)
* \[[`b6b3dde360`](https://github.com/nodejs/node/commit/b6b3dde360)] - **test**: removed unused variable (Michal Hynek) [#23481](https://github.com/nodejs/node/pull/23481)
* \[[`d14b07b501`](https://github.com/nodejs/node/commit/d14b07b501)] - **test**: fix argument order for assert.strictEqual (Stacey) [#23485](https://github.com/nodejs/node/pull/23485)
* \[[`c6f166bf21`](https://github.com/nodejs/node/commit/c6f166bf21)] - **test**: fix assert.strictEqual params order (Rock Hu) [#23480](https://github.com/nodejs/node/pull/23480)
* \[[`5432957af0`](https://github.com/nodejs/node/commit/5432957af0)] - **test**: removed mustCallAsync from common and added inside testcase (Quinn Langille) [#23467](https://github.com/nodejs/node/pull/23467)
* \[[`1c648fb161`](https://github.com/nodejs/node/commit/1c648fb161)] - **test**: remove unused "e" from catch in http2 test (Stephen Heitman) [#23476](https://github.com/nodejs/node/pull/23476)
* \[[`012d848767`](https://github.com/nodejs/node/commit/012d848767)] - **test**: remove unused variable from catch (Paige Kato) [#23477](https://github.com/nodejs/node/pull/23477)
* \[[`f6e1acf9ac`](https://github.com/nodejs/node/commit/f6e1acf9ac)] - **test**: inline common module boolean (ashleysimpson) [#23479](https://github.com/nodejs/node/pull/23479)
* \[[`c23cc5763c`](https://github.com/nodejs/node/commit/c23cc5763c)] - **test**: swap the order arguments are passed to assert (Dylson Valente Neto) [#23580](https://github.com/nodejs/node/pull/23580)
* \[[`8515a7d507`](https://github.com/nodejs/node/commit/8515a7d507)] - **test**: flip assertion arguments for make-callback/test.js (Tim Cheung) [#23470](https://github.com/nodejs/node/pull/23470)
* \[[`1ae0aaf089`](https://github.com/nodejs/node/commit/1ae0aaf089)] - **test**: replace function with arrow function (Yitong) [#23474](https://github.com/nodejs/node/pull/23474)
* \[[`762c2d03fc`](https://github.com/nodejs/node/commit/762c2d03fc)] - **test**: swap actual and expected in assertions (Yitong) [#23474](https://github.com/nodejs/node/pull/23474)
* \[[`5b95bdf256`](https://github.com/nodejs/node/commit/5b95bdf256)] - **test**: correctly order assertion arguments (Emily Kolar) [#23473](https://github.com/nodejs/node/pull/23473)
* \[[`51aa50c60c`](https://github.com/nodejs/node/commit/51aa50c60c)] - **test**: mark `test-http2-session-timeout` as flake on ARM (Refael Ackermann) [#23639](https://github.com/nodejs/node/pull/23639)
* \[[`434ca4ff27`](https://github.com/nodejs/node/commit/434ca4ff27)] - **test**: update test-cluster-worker-events to use arrow functions (S. Everett Abbott) [#23469](https://github.com/nodejs/node/pull/23469)
* \[[`3d284c856c`](https://github.com/nodejs/node/commit/3d284c856c)] - **test**: correct order for assert.strictEqual for inspector-helper test (Maggie Nolan) [#23468](https://github.com/nodejs/node/pull/23468)
* \[[`6ca3876b6d`](https://github.com/nodejs/node/commit/6ca3876b6d)] - **test**: fix incorrect expectation order (Amie) [#23466](https://github.com/nodejs/node/pull/23466)
* \[[`f007c8b513`](https://github.com/nodejs/node/commit/f007c8b513)] - **test**: remove unused e variable in catch statement (Denny Scott) [#23465](https://github.com/nodejs/node/pull/23465)
* \[[`f6b59ced0b`](https://github.com/nodejs/node/commit/f6b59ced0b)] - **test**: correct assert test (Richard Markins) [#23463](https://github.com/nodejs/node/pull/23463)
* \[[`6e0b984431`](https://github.com/nodejs/node/commit/6e0b984431)] - **test**: fix incorrect ordering of args in assert.strictEqual() (mdaum) [#23461](https://github.com/nodejs/node/pull/23461)
* \[[`deb180e3c6`](https://github.com/nodejs/node/commit/deb180e3c6)] - **test**: swap assert.strictEqual args to actual, expected (epeden) [#23459](https://github.com/nodejs/node/pull/23459)
* \[[`bc7c872e8f`](https://github.com/nodejs/node/commit/bc7c872e8f)] - **test**: fix assert.strictEqual argument order (andy addington) [#23457](https://github.com/nodejs/node/pull/23457)
* \[[`55e23000ad`](https://github.com/nodejs/node/commit/55e23000ad)] - **test**: strictEqual correct order for http-information-processing test (Ivan Sieder) [#23456](https://github.com/nodejs/node/pull/23456)
* \[[`ee3c23d568`](https://github.com/nodejs/node/commit/ee3c23d568)] - **test**: fix http local address test assertion (Danu Widatama) [#23451](https://github.com/nodejs/node/pull/23451)
* \[[`7e38e9e580`](https://github.com/nodejs/node/commit/7e38e9e580)] - **test**: fix order of values in test assertions (Jared Haines) [#23450](https://github.com/nodejs/node/pull/23450)
* \[[`0eba1b25e4`](https://github.com/nodejs/node/commit/0eba1b25e4)] - **test**: fix `assert.strictEqual` arguments in test/parallel/test-c-ares.js (jungkumseok) [#23448](https://github.com/nodejs/node/pull/23448)
* \[[`3adfe99e5c`](https://github.com/nodejs/node/commit/3adfe99e5c)] - **test**: fix parameter order passed to strictEqual (Shannon) [#23577](https://github.com/nodejs/node/pull/23577)
* \[[`f55b4f1cdf`](https://github.com/nodejs/node/commit/f55b4f1cdf)] - **test**: adding test coverage for SourceTextModule.evaluate (Kayla Altepeter) [#23595](https://github.com/nodejs/node/pull/23595)
* \[[`9003c74f16`](https://github.com/nodejs/node/commit/9003c74f16)] - **test**: rename common.ddCommand() (Rich Trott) [#23411](https://github.com/nodejs/node/pull/23411)
* \[[`1cdfd1ae03`](https://github.com/nodejs/node/commit/1cdfd1ae03)] - **test**: refactor common.ddCommand() (Rich Trott) [#23411](https://github.com/nodejs/node/pull/23411)
* \[[`a29c8da033`](https://github.com/nodejs/node/commit/a29c8da033)] - **test**: move some gc tests back to parallel/, unmark flaky (Anna Henningsen) [#23356](https://github.com/nodejs/node/pull/23356)
* \[[`8d091c2dd3`](https://github.com/nodejs/node/commit/8d091c2dd3)] - **test**: improve test-gc-http-client-onerror (Denys Otrishko) [#23196](https://github.com/nodejs/node/pull/23196)
* \[[`6bea43c392`](https://github.com/nodejs/node/commit/6bea43c392)] - **test**: improve test-gc-http-client-connaborted (Denys Otrishko) [#23193](https://github.com/nodejs/node/pull/23193)
* \[[`b2e173be48`](https://github.com/nodejs/node/commit/b2e173be48)] - **test**: fix assert.strictEqual argument order (et4891) [#23518](https://github.com/nodejs/node/pull/23518)
* \[[`45151bc0d9`](https://github.com/nodejs/node/commit/45151bc0d9)] - **test**: fixing assertion value order (Joe Sepi) [#23574](https://github.com/nodejs/node/pull/23574)
* \[[`2ea6546f73`](https://github.com/nodejs/node/commit/2ea6546f73)] - **test**: separate WPT console test from other test (Rich Trott) [#23340](https://github.com/nodejs/node/pull/23340)
* \[[`d4f25ed656`](https://github.com/nodejs/node/commit/d4f25ed656)] - **test**: add WPT console-label-conversion test (Rich Trott) [#23340](https://github.com/nodejs/node/pull/23340)
* \[[`9b9b3eb5c9`](https://github.com/nodejs/node/commit/9b9b3eb5c9)] - **test**: rename WPT console test (Rich Trott) [#23340](https://github.com/nodejs/node/pull/23340)
* \[[`ad47ae7608`](https://github.com/nodejs/node/commit/ad47ae7608)] - **test**: add logging to test-worker-memory (Rich Trott) [#23418](https://github.com/nodejs/node/pull/23418)
* \[[`6493e0165a`](https://github.com/nodejs/node/commit/6493e0165a)] - **test**: add test for a vm indexed property (conectado) [#23318](https://github.com/nodejs/node/pull/23318)
* \[[`7b4c4db3ad`](https://github.com/nodejs/node/commit/7b4c4db3ad)] - **test**: fix compiler warning in doc/api/addons.md (Daniel Bevenius) [#23323](https://github.com/nodejs/node/pull/23323)
* \[[`317b51caad`](https://github.com/nodejs/node/commit/317b51caad)] - **tls**: close StreamWrap and its stream correctly (Ouyang Yadong) [#23654](https://github.com/nodejs/node/pull/23654)
* \[[`ed0a97a524`](https://github.com/nodejs/node/commit/ed0a97a524)] - **tls**: prevent multiple connection errors (cjihrig) [#23636](https://github.com/nodejs/node/pull/23636)
* \[[`9487c42424`](https://github.com/nodejs/node/commit/9487c42424)] - **tls**: make StreamWrap work correctly in "drain" callback (Ouyang Yadong) [#23294](https://github.com/nodejs/node/pull/23294)
* \[[`a67e04ee8a`](https://github.com/nodejs/node/commit/a67e04ee8a)] - **tools**: lint for unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`2152c07102`](https://github.com/nodejs/node/commit/2152c07102)] - **tools**: enable 80-char line length markdown linting (Rich Trott) [#24094](https://github.com/nodejs/node/pull/24094)
* \[[`1538148d2a`](https://github.com/nodejs/node/commit/1538148d2a)] - **tools**: add script to lint first PR commit message (Richard Lau) [#24030](https://github.com/nodejs/node/pull/24030)
* \[[`fe75543af6`](https://github.com/nodejs/node/commit/fe75543af6)] - **tools**: update alternative docs versions (Richard Lau) [#23980](https://github.com/nodejs/node/pull/23980)
* \[[`c5d909886a`](https://github.com/nodejs/node/commit/c5d909886a)] - **tools**: update ESLint to 5.8.0 (cjihrig) [#23904](https://github.com/nodejs/node/pull/23904)
* \[[`7670bc5917`](https://github.com/nodejs/node/commit/7670bc5917)] - **tools**: clarify commit message linting (Rich Trott) [#23742](https://github.com/nodejs/node/pull/23742)
* \[[`36bd9a98d7`](https://github.com/nodejs/node/commit/36bd9a98d7)] - **tools**: do not lint commit message if var undefined (Rich Trott) [#23725](https://github.com/nodejs/node/pull/23725)
* \[[`ca1c42f3c7`](https://github.com/nodejs/node/commit/ca1c42f3c7)] - **tools**: prefer filter to remove empty strings (Sakthipriyan Vairamani (thefourtheye)) [#23727](https://github.com/nodejs/node/pull/23727)
* \[[`9182ad38f5`](https://github.com/nodejs/node/commit/9182ad38f5)] - **tools**: update ESLint to 5.7.0 (cjihrig) [#23629](https://github.com/nodejs/node/pull/23629)
* \[[`4bcbc86230`](https://github.com/nodejs/node/commit/4bcbc86230)] - **tools**: update node-lint-md-cli-rollup (Rich Trott) [#23358](https://github.com/nodejs/node/pull/23358)
* \[[`cae703ce33`](https://github.com/nodejs/node/commit/cae703ce33)] - **tools,icu**: read full ICU version info from file (Refael Ackermann) [#23269](https://github.com/nodejs/node/pull/23269)
* \[[`e1f7924b42`](https://github.com/nodejs/node/commit/e1f7924b42)] - **tools,test**: add list of slow tests (Refael Ackermann) [#23251](https://github.com/nodejs/node/pull/23251)
* \[[`8e08a27edf`](https://github.com/nodejs/node/commit/8e08a27edf)] - **tools,test**: cleanup and dedup code (Refael Ackermann) [#23251](https://github.com/nodejs/node/pull/23251)
* \[[`1b8b5e525c`](https://github.com/nodejs/node/commit/1b8b5e525c)] - **trace\_events**: destroy platform before tracing (Ali Ijaz Sheikh) [#22938](https://github.com/nodejs/node/pull/22938)
* \[[`90014b6c3c`](https://github.com/nodejs/node/commit/90014b6c3c)] - **util**: handle null prototype on inspect (Anto Aravinth) [#22331](https://github.com/nodejs/node/pull/22331)
* \[[`80ab31eb49`](https://github.com/nodejs/node/commit/80ab31eb49)] - **v8\_prof\_polyfill**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* \[[`9503365d20`](https://github.com/nodejs/node/commit/9503365d20)] - **vm**: clarify timeout option in vm (Vladimir de Turckheim) [#23512](https://github.com/nodejs/node/pull/23512)
* \[[`e9c7243909`](https://github.com/nodejs/node/commit/e9c7243909)] - **vm**: pass parsing\_context to ScriptCompiler::CompileFunctionInContext (Dara Hayes) [#23206](https://github.com/nodejs/node/pull/23206)
* \[[`a5dd25fc1b`](https://github.com/nodejs/node/commit/a5dd25fc1b)] - **worker**: remove delete MessagePort.prototype.hasRef (James Traver) [#23471](https://github.com/nodejs/node/pull/23471)
* \[[`bae674ee5d`](https://github.com/nodejs/node/commit/bae674ee5d)] - **zlib**: refactor zlib internals (Anna Henningsen) [#23360](https://github.com/nodejs/node/pull/23360)
* \[[`0763d256dc`](https://github.com/nodejs/node/commit/0763d256dc)] - **zlib**: generate error code names in C++ (Anna Henningsen) [#23413](https://github.com/nodejs/node/pull/23413)

<a id="10.14.1"></a>

## 2018-11-29, Version 10.14.1 'Dubnium' (LTS), @MylesBorins

### Notable Changes

* **win/msi**: Revert changes to installer causing issues on Windows systems.

### Commits

* \[[`5d17bf1e13`](https://github.com/nodejs/node/commit/5d17bf1e13)] - **win**: add prompt to tools installation script (João Reis) [#23987](https://github.com/nodejs/node/pull/23987)
* \[[`589f0d2192`](https://github.com/nodejs/node/commit/589f0d2192)] - **win**: clarify Boxstarter behavior on install tools (Rob Reynolds) [#23987](https://github.com/nodejs/node/pull/23987)
* \[[`9e293c1328`](https://github.com/nodejs/node/commit/9e293c1328)] - _**Revert**_ "**win,msi**: install tools for native modules" (Refael Ackermann) [#24344](https://github.com/nodejs/node/pull/24344)

<a id="10.14.0"></a>

## 2018-11-27, Version 10.14.0 'Dubnium' (LTS), @rvagg

This is a security release. All Node.js users should consult the security release summary at:

<https://nodejs.org/en/blog/vulnerability/november-2018-security-releases/>

for details on patched vulnerabilities.

Fixes for the following CVEs are included in this release:

* Node.js: Denial of Service with large HTTP headers (CVE-2018-12121)
* Node.js: Slowloris HTTP Denial of Service (CVE-2018-12122 / Node.js)
* Node.js: Hostname spoofing in URL parser for javascript protocol (CVE-2018-12123)
* OpenSSL: Timing vulnerability in DSA signature generation (CVE-2018-0734)
* OpenSSL: Timing vulnerability in ECDSA signature generation (CVE-2019-0735)

### Notable Changes

* **deps**: Upgrade to OpenSSL 1.1.0j, fixing CVE-2018-0734 and CVE-2019-0735
* **http**:
  * Headers received by HTTP servers must not exceed 8192 bytes in total to prevent possible Denial of Service attacks. Reported by Trevor Norris. (CVE-2018-12121 / Matteo Collina)
  * A timeout of 40 seconds now applies to servers receiving HTTP headers. This value can be adjusted with `server.headersTimeout`. Where headers are not completely received within this period, the socket is destroyed on the next received chunk. In conjunction with `server.setTimeout()`, this aids in protecting against excessive resource retention and possible Denial of Service. Reported by Jan Maybach ([liebdich.com](https://liebdich.com)). (CVE-2018-12122 / Matteo Collina)
* **url**: Fix a bug that would allow a hostname being spoofed when parsing URLs with `url.parse()` with the `'javascript:'` protocol. Reported by [Martin Bajanik](https://twitter.com/_bayotop) ([Kentico](https://kenticocloud.com/)). (CVE-2018-12123 / Matteo Collina)

### Commits

* \[[`38ca8baf81`](https://github.com/nodejs/node/commit/38ca8baf81)] - **deps**: update openssl 1.1.0 upgrade docs (Sam Roberts) [#24523](https://github.com/nodejs/node/pull/24523)
* \[[`241ba81a5b`](https://github.com/nodejs/node/commit/241ba81a5b)] - **deps**: update archs files for OpenSSL-1.1.0 (Sam Roberts) [#24523](https://github.com/nodejs/node/pull/24523)
* \[[`acc40efa90`](https://github.com/nodejs/node/commit/acc40efa90)] - **deps**: add s390 asm rules for OpenSSL-1.1.0 (Shigeki Ohtsu) [#24523](https://github.com/nodejs/node/pull/24523)
* \[[`7efd184bb1`](https://github.com/nodejs/node/commit/7efd184bb1)] - **deps**: upgrade openssl sources to 1.1.0j (Sam Roberts) [#24523](https://github.com/nodejs/node/pull/24523)
* \[[`a8532d4d23`](https://github.com/nodejs/node/commit/a8532d4d23)] - **deps,http**: http\_parser set max header size to 8KB (Matteo Collina) [nodejs-private/node-private#143](https://github.com/nodejs-private/node-private/pull/143)
* \[[`eb43bc04b1`](https://github.com/nodejs/node/commit/eb43bc04b1)] - **(SEMVER-MINOR)** **http,https**: protect against slow headers attack (Matteo Collina) [nodejs-private/node-private#150](https://github.com/nodejs-private/node-private/pull/150)
* \[[`8b1405ee01`](https://github.com/nodejs/node/commit/8b1405ee01)] - **url**: avoid hostname spoofing w/ javascript protocol (Matteo Collina) [nodejs-private/node-private#145](https://github.com/nodejs-private/node-private/pull/145)

<a id="10.13.0"></a>

## 2018-10-30, Version 10.13.0 'Dubnium' (LTS), @MylesBorins

This release marks the transition of Node.js 10.x into Long Term
Support (LTS) with the codename 'Dubnium'. The 10.x release line
now moves in to "Active LTS" and will remain so until April 2020.
After that time it will move in to "Maintenance" until end of
life in April 2021.

### Notable Changes

This release only includes minimal changes necessary to fix known regressions prior to LTS.

### Commits

* \[[`2ba6010082`](https://github.com/nodejs/node/commit/2ba6010082)] - **buffer**: fix crash for invalid index types (Anna Henningsen)
* \[[`2cd68be69d`](https://github.com/nodejs/node/commit/2cd68be69d)] - **build**: spawn `make test-ci` with `-j1` (Refael Ackermann) [#23733](https://github.com/nodejs/node/pull/23733)
* \[[`1003f4c975`](https://github.com/nodejs/node/commit/1003f4c975)] - **deps**: fix wrong default for v8 handle zapping (Refael Ackermann) [#23801](https://github.com/nodejs/node/pull/23801)

<a id="10.12.0"></a>

## 2018-10-10, Version 10.12.0 (Current), @targos

### Notable changes

* **assert**
  * The diff output is now a tiny bit improved by sorting object properties when
    inspecting the values that are compared with each other. [#22788](https://github.com/nodejs/node/pull/22788)
* **cli**
  * The options parser now normalizes `_` to `-` in all multi-word command-line
    flags, e.g. `--no_warnings` has the same effect as `--no-warnings`. [#23020](https://github.com/nodejs/node/pull/23020)
  * Added bash completion for the `node` binary. To generate a bash completion
    script, run `node --completion-bash`. The output can be saved to a file
    which can be sourced to enable completion. [#20713](https://github.com/nodejs/node/pull/20713)
* **crypto**
  * Added support for PEM-level encryption. [#23151](https://github.com/nodejs/node/pull/23151)
  * Added an API asymmetric key pair generation. The new methods
    `crypto.generateKeyPair` and `crypto.generateKeyPairSync` can be used to
    generate public and private key pairs. The API supports RSA, DSA and EC and
    a variety of key encodings (both PEM and DER). [#22660](https://github.com/nodejs/node/pull/22660)
* **fs**
  * Added a `recursive` option to `fs.mkdir` and `fs.mkdirSync`. If this option
    is set to true, non-existing parent folders will be automatically created. [#21875](https://github.com/nodejs/node/pull/21875)
* **http2**
  * Added a `'ping'` event to `Http2Session` that is emitted whenever a non-ack
    `PING` is received. [#23009](https://github.com/nodejs/node/pull/23009)
  * Added support for the `ORIGIN` frame. [#22956](https://github.com/nodejs/node/pull/22956)
  * Updated nghttp2 to 1.34.0. This adds RFC 8441 extended connect protocol
    support to allow use of WebSockets over HTTP/2. [#23284](https://github.com/nodejs/node/pull/23284)
* **module**
  * Added `module.createRequireFromPath(filename)`. This new method can be used
    to create a custom require function that will resolve modules relative to
    the filename path. [#19360](https://github.com/nodejs/node/pull/19360)
* **process**
  * Added a `'multipleResolves'` process event that is emitted whenever a
    `Promise` is attempted to be resolved multiple times, e.g. if the `resolve`
    and `reject` functions are both called in a `Promise` executor. [#22218](https://github.com/nodejs/node/pull/22218)
* **url**
  * Added `url.fileURLToPath(url)` and `url.pathToFileURL(path)`. These methods
    can be used to correctly convert between file: URLs and absolute paths. [#22506](https://github.com/nodejs/node/pull/22506)
* **util**
  * Added the `sorted` option to `util.inspect()`. If set to `true`, all
    properties of an object and Set and Map entries will be sorted in the
    returned string. If set to a function, it is used as a compare function. [#22788](https://github.com/nodejs/node/pull/22788)
  * The `util.instpect.custom` symbol is now defined in the global symbol
    registry as `Symbol.for('nodejs.util.inspect.custom')`. [#20857](https://github.com/nodejs/node/pull/20857)
  * Added support for `BigInt` numbers in `util.format()`. [#22097](https://github.com/nodejs/node/pull/22097)
* **V8 API**
  * A number of V8 C++ APIs have been marked as deprecated since they have been
    removed in the upstream repository. Replacement APIs are added where
    necessary. [#23159](https://github.com/nodejs/node/pull/23159)
* **Windows**
  * The Windows msi installer now provides an option to automatically install
    the tools required to build native modules. [#22645](https://github.com/nodejs/node/pull/22645)
* **Workers**
  * Debugging support for Workers using the DevTools protocol has been
    implemented. [#21364](https://github.com/nodejs/node/pull/21364)
  * The public `inspector` module is now enabled in Workers. [#22769](https://github.com/nodejs/node/pull/22769)
* **Added new collaborators**:
  * [digitalinfinity](https://github.com/digitalinfinity) - Hitesh Kanwathirtha

### Commits

* \[[`12ff395e35`](https://github.com/nodejs/node/commit/12ff395e35)] - **assert**: remove internal errorCache property (Rich Trott) [#23304](https://github.com/nodejs/node/pull/23304)
* \[[`efdb32603c`](https://github.com/nodejs/node/commit/efdb32603c)] - **(SEMVER-MINOR)** **assert**: improve diff output (Ruben Bridgewater) [#22788](https://github.com/nodejs/node/pull/22788)
* \[[`9749d48729`](https://github.com/nodejs/node/commit/9749d48729)] - **benchmark**: increase lint compliance (Rich Trott) [#23305](https://github.com/nodejs/node/pull/23305)
* \[[`90bbab6f71`](https://github.com/nodejs/node/commit/90bbab6f71)] - **benchmark**: refactor util benchmarks (Ruben Bridgewater) [#22503](https://github.com/nodejs/node/pull/22503)
* \[[`2d7e4e0116`](https://github.com/nodejs/node/commit/2d7e4e0116)] - **benchmark,doc,lib,src,test,tools**: fix typos (Brandon Smith) [#23302](https://github.com/nodejs/node/pull/23302)
* \[[`e6484c2c11`](https://github.com/nodejs/node/commit/e6484c2c11)] - **build**: restore js2c direct dependency on config.gypi (Refael Ackermann) [#23355](https://github.com/nodejs/node/pull/23355)
* \[[`c4aa0331c1`](https://github.com/nodejs/node/commit/c4aa0331c1)] - **build**: make configure script verbose by default (Michaël Zasso) [#23408](https://github.com/nodejs/node/pull/23408)
* \[[`cf17759113`](https://github.com/nodejs/node/commit/cf17759113)] - **build**: toggle lint-cpp using verbose (V) variable (Daniel Bevenius) [#23217](https://github.com/nodejs/node/pull/23217)
* \[[`b0dc0ca9a9`](https://github.com/nodejs/node/commit/b0dc0ca9a9)] - **build**: make lint-addon-docs quiet (Daniel Bevenius) [#23217](https://github.com/nodejs/node/pull/23217)
* \[[`0f236c8d42`](https://github.com/nodejs/node/commit/0f236c8d42)] - **build**: add pgo specific variables to common.gypi (Denys Otrishko) [#23102](https://github.com/nodejs/node/pull/23102)
* \[[`de4d688d1f`](https://github.com/nodejs/node/commit/de4d688d1f)] - **build**: cleanup in .gitignore (Refael Ackermann) [#23180](https://github.com/nodejs/node/pull/23180)
* \[[`49b0ec4fe7`](https://github.com/nodejs/node/commit/49b0ec4fe7)] - **build**: add loader path to rpath for cctest (Sam Ruby) [#23168](https://github.com/nodejs/node/pull/23168)
* \[[`7d21cc2177`](https://github.com/nodejs/node/commit/7d21cc2177)] - **build**: reduce chance of unneeded rebuild (Refael Ackermann) [#23156](https://github.com/nodejs/node/pull/23156)
* \[[`aae0eceea0`](https://github.com/nodejs/node/commit/aae0eceea0)] - **build**: encapsulate node/inspector gyp scafolding (Refael Ackermann) [#23156](https://github.com/nodejs/node/pull/23156)
* \[[`180099a5ac`](https://github.com/nodejs/node/commit/180099a5ac)] - **build**: enabling pgo at configure (Octavian Soldea) [#21596](https://github.com/nodejs/node/pull/21596)
* \[[`f4cffffc96`](https://github.com/nodejs/node/commit/f4cffffc96)] - **build**: add --quiet to lint-cpp (Daniel Bevenius) [#23075](https://github.com/nodejs/node/pull/23075)
* \[[`d572f6001a`](https://github.com/nodejs/node/commit/d572f6001a)] - **build**: remove unnecessary Makefile output (Rich Trott) [#23129](https://github.com/nodejs/node/pull/23129)
* \[[`fb03faa835`](https://github.com/nodejs/node/commit/fb03faa835)] - **build**: move addons message in Makefile (Rich Trott) [#23114](https://github.com/nodejs/node/pull/23114)
* \[[`948dc71664`](https://github.com/nodejs/node/commit/948dc71664)] - **build**: make config verbose on CI (Refael Ackermann) [#22935](https://github.com/nodejs/node/pull/22935)
* \[[`b69ed9c80c`](https://github.com/nodejs/node/commit/b69ed9c80c)] - **build**: stop printing execution of lint-md command (Ruben Bridgewater) [#22904](https://github.com/nodejs/node/pull/22904)
* \[[`2b8f569388`](https://github.com/nodejs/node/commit/2b8f569388)] - **build,deps**: refactor and fix v8.gyp (Refael Ackermann) [#23182](https://github.com/nodejs/node/pull/23182)
* \[[`4db9e36b57`](https://github.com/nodejs/node/commit/4db9e36b57)] - **build,doc**: remove outdated `lint-md-build` (Michaël Zasso) [#22991](https://github.com/nodejs/node/pull/22991)
* \[[`c29e5ac5be`](https://github.com/nodejs/node/commit/c29e5ac5be)] - **(SEMVER-MINOR)** **cli**: normalize `_` → `-` when parsing options (Anna Henningsen) [#23020](https://github.com/nodejs/node/pull/23020)
* \[[`54ca0e159f`](https://github.com/nodejs/node/commit/54ca0e159f)] - **cluster**: move handle tracking out of utils (cjihrig) [#23131](https://github.com/nodejs/node/pull/23131)
* \[[`cb0d8239b7`](https://github.com/nodejs/node/commit/cb0d8239b7)] - **cluster**: use Map to track handles in master (cjihrig) [#23125](https://github.com/nodejs/node/pull/23125)
* \[[`0f133eb5a3`](https://github.com/nodejs/node/commit/0f133eb5a3)] - **cluster**: use Map to track handles in cluster child (cjihrig) [#23125](https://github.com/nodejs/node/pull/23125)
* \[[`2dd157fbf3`](https://github.com/nodejs/node/commit/2dd157fbf3)] - **cluster**: use Map to track indexes (cjihrig) [#23125](https://github.com/nodejs/node/pull/23125)
* \[[`64f840a767`](https://github.com/nodejs/node/commit/64f840a767)] - **cluster**: use Map to track round robin workers (cjihrig) [#23125](https://github.com/nodejs/node/pull/23125)
* \[[`22f51a6a83`](https://github.com/nodejs/node/commit/22f51a6a83)] - **cluster**: use Map to track callbacks (cjihrig) [#23125](https://github.com/nodejs/node/pull/23125)
* \[[`26c36efa2f`](https://github.com/nodejs/node/commit/26c36efa2f)] - **crypto**: remove node::crypto::CheckResult (Tobias Nießen) [#23225](https://github.com/nodejs/node/pull/23225)
* \[[`5f450f3f92`](https://github.com/nodejs/node/commit/5f450f3f92)] - **crypto**: replace goto SSL\_CTX\_use\_certificate\_chain (Daniel Bevenius) [#23113](https://github.com/nodejs/node/pull/23113)
* \[[`db8d99dbc2`](https://github.com/nodejs/node/commit/db8d99dbc2)] - **crypto**: add virtual dtor to KeyPairGenerationConfig (Daniel Bevenius) [#23215](https://github.com/nodejs/node/pull/23215)
* \[[`f98d441461`](https://github.com/nodejs/node/commit/f98d441461)] - **crypto**: extract throwInvalidArgType function (Daniel Bevenius) [#22947](https://github.com/nodejs/node/pull/22947)
* \[[`1a21cf13cb`](https://github.com/nodejs/node/commit/1a21cf13cb)] - **crypto**: make PEM parsing RFC7468-compliant (Tobias Nießen) [#23164](https://github.com/nodejs/node/pull/23164)
* \[[`9c96573124`](https://github.com/nodejs/node/commit/9c96573124)] - **(SEMVER-MINOR)** **crypto**: add support for PEM-level encryption (Tobias Nießen) [#23151](https://github.com/nodejs/node/pull/23151)
* \[[`398c0e03e4`](https://github.com/nodejs/node/commit/398c0e03e4)] - **crypto**: replace gotos (Tobias Nießen) [#23132](https://github.com/nodejs/node/pull/23132)
* \[[`a51d839a31`](https://github.com/nodejs/node/commit/a51d839a31)] - **crypto**: remove unnecessary calls to TLS\_method() (Daniel Bevenius) [#23077](https://github.com/nodejs/node/pull/23077)
* \[[`074b7af7ef`](https://github.com/nodejs/node/commit/074b7af7ef)] - **crypto**: enable auto cert chaining for BoringSSL (Jeremy Apthorp) [#22110](https://github.com/nodejs/node/pull/22110)
* \[[`2888f809e3`](https://github.com/nodejs/node/commit/2888f809e3)] - **crypto**: deduplicate cipher initialization code (Tobias Nießen) [#23011](https://github.com/nodejs/node/pull/23011)
* \[[`0bc4529a07`](https://github.com/nodejs/node/commit/0bc4529a07)] - **crypto**: remove unnecessary usage of goto (Tobias Nießen) [#23018](https://github.com/nodejs/node/pull/23018)
* \[[`cc8219433c`](https://github.com/nodejs/node/commit/cc8219433c)] - **(SEMVER-MINOR)** **crypto**: allow promisifying generateKeyPair (Tobias Nießen) [#22660](https://github.com/nodejs/node/pull/22660)
* \[[`421909394c`](https://github.com/nodejs/node/commit/421909394c)] - **(SEMVER-MINOR)** **crypto**: add API for key pair generation (Tobias Nießen) [#22660](https://github.com/nodejs/node/pull/22660)
* \[[`76cb52ca11`](https://github.com/nodejs/node/commit/76cb52ca11)] - **deps**: upgrade to libuv 1.23.2 (cjihrig) [#23336](https://github.com/nodejs/node/pull/23336)
* \[[`95bdf37265`](https://github.com/nodejs/node/commit/95bdf37265)] - **(SEMVER-MINOR)** **deps**: update nghttp2 to 1.34.0 (James M Snell) [#23284](https://github.com/nodejs/node/pull/23284)
* \[[`46c7d0d21f`](https://github.com/nodejs/node/commit/46c7d0d21f)] - **(SEMVER-MINOR)** **deps**: increase V8 deprecation levels (Anna Henningsen) [#23159](https://github.com/nodejs/node/pull/23159)
* \[[`e3550f2366`](https://github.com/nodejs/node/commit/e3550f2366)] - **deps**: backport 958b761 from upstream V8 (Matheus Marchini) [#22914](https://github.com/nodejs/node/pull/22914)
* \[[`f08373f18d`](https://github.com/nodejs/node/commit/f08373f18d)] - **deps**: cherry-pick 64-bit hash seed commits from V8 (Yang Guo) [#23260](https://github.com/nodejs/node/pull/23260)
* \[[`e93c94c327`](https://github.com/nodejs/node/commit/e93c94c327)] - **deps**: add no-strict-aliasing to ICU cflags (Daniel Bevenius) [#23112](https://github.com/nodejs/node/pull/23112)
* \[[`5d70652d86`](https://github.com/nodejs/node/commit/5d70652d86)] - **deps**: fix Array.prototype.forEach on v8 6.8 (Mike Stanton) [#22899](https://github.com/nodejs/node/pull/22899)
* \[[`e668815a24`](https://github.com/nodejs/node/commit/e668815a24)] - **deps**: cherry-pick dbfcc48 from upstream V8 (Alexey Kozyatinskiy) [#22251](https://github.com/nodejs/node/pull/22251)
* \[[`e5efdba75c`](https://github.com/nodejs/node/commit/e5efdba75c)] - **deps**: upgrade to libuv 1.23.1 (cjihrig) [#22997](https://github.com/nodejs/node/pull/22997)
* \[[`39d7699a87`](https://github.com/nodejs/node/commit/39d7699a87)] - **deps**: cherry-pick d48bd16 from upstream V8 (Junliang Yan) [#22909](https://github.com/nodejs/node/pull/22909)
* \[[`62a2c81214`](https://github.com/nodejs/node/commit/62a2c81214)] - **doc**: simplify and clarify README language (Rich Trott) [#23322](https://github.com/nodejs/node/pull/23322)
* \[[`7c0d6ac0bd`](https://github.com/nodejs/node/commit/7c0d6ac0bd)] - **doc**: simplify governance info in README intro (Rich Trott) [#23320](https://github.com/nodejs/node/pull/23320)
* \[[`5ff43006d1`](https://github.com/nodejs/node/commit/5ff43006d1)] - **doc**: add link to ABI guide (Gabriel Schulhof)
* \[[`9dd47bcf99`](https://github.com/nodejs/node/commit/9dd47bcf99)] - **doc**: fix minor typo in streams.md (Rich Trott) [#23306](https://github.com/nodejs/node/pull/23306)
* \[[`a0e8e7fea6`](https://github.com/nodejs/node/commit/a0e8e7fea6)] - **doc**: standardize versions in stream module doc (Rich Trott) [#23306](https://github.com/nodejs/node/pull/23306)
* \[[`eee71d6d16`](https://github.com/nodejs/node/commit/eee71d6d16)] - **doc**: add util.inspect() legacy signature (siddhant) [#23216](https://github.com/nodejs/node/pull/23216)
* \[[`fbbb25b901`](https://github.com/nodejs/node/commit/fbbb25b901)] - **doc**: edit building-node text (Rich Trott) [#23335](https://github.com/nodejs/node/pull/23335)
* \[[`037063c6ee`](https://github.com/nodejs/node/commit/037063c6ee)] - **doc**: remove 72-hour mentions in pull-requests.md (Rich Trott) [#23309](https://github.com/nodejs/node/pull/23309)
* \[[`4c54f897f8`](https://github.com/nodejs/node/commit/4c54f897f8)] - **doc**: fix minor typo in n-api.md (Aleksey Chemakin) [#23310](https://github.com/nodejs/node/pull/23310)
* \[[`f1cb8ab4bf`](https://github.com/nodejs/node/commit/f1cb8ab4bf)] - **doc**: remove ABI guide (Gabriel Schulhof) [#23303](https://github.com/nodejs/node/pull/23303)
* \[[`39e3ef7739`](https://github.com/nodejs/node/commit/39e3ef7739)] - **doc**: Replace vague 'may not' with definitive 'will not' (Mike MacCana) [#23143](https://github.com/nodejs/node/pull/23143)
* \[[`11c674549b`](https://github.com/nodejs/node/commit/11c674549b)] - **doc**: update author-ready label terms (Vse Mozhet Byt) [#23249](https://github.com/nodejs/node/pull/23249)
* \[[`33e3eb44f7`](https://github.com/nodejs/node/commit/33e3eb44f7)] - **doc**: update onboarding task (Rich Trott) [#23300](https://github.com/nodejs/node/pull/23300)
* \[[`df4ade7dc7`](https://github.com/nodejs/node/commit/df4ade7dc7)] - **doc**: use backticks around file names in README.md (Rich Trott) [#23299](https://github.com/nodejs/node/pull/23299)
* \[[`80964d36b7`](https://github.com/nodejs/node/commit/80964d36b7)] - **doc**: improve API Documentation text in README (Rich Trott) [#23268](https://github.com/nodejs/node/pull/23268)
* \[[`ef0f7e613a`](https://github.com/nodejs/node/commit/ef0f7e613a)] - **doc**: shorten pull request wait time to 48 hours (Rich Trott) [#23082](https://github.com/nodejs/node/pull/23082)
* \[[`5b76313059`](https://github.com/nodejs/node/commit/5b76313059)] - **doc**: improve instructions for verifying binaries (Rich Trott) [#23248](https://github.com/nodejs/node/pull/23248)
* \[[`6943fa9fc7`](https://github.com/nodejs/node/commit/6943fa9fc7)] - **doc**: shorten intro of README.md (Rich Trott) [#23073](https://github.com/nodejs/node/pull/23073)
* \[[`e5bfab0fb6`](https://github.com/nodejs/node/commit/e5bfab0fb6)] - **doc**: add guide about abi stability (Gabriel Schulhof) [#23229](https://github.com/nodejs/node/pull/23229)
* \[[`e283206047`](https://github.com/nodejs/node/commit/e283206047)] - **doc**: improve `stream.Writable` ctor encoding option docs (Anna Henningsen) [#23246](https://github.com/nodejs/node/pull/23246)
* \[[`bd59d4efbf`](https://github.com/nodejs/node/commit/bd59d4efbf)] - **doc**: fix code snippets in tls.md (Ouyang Yadong) [#23239](https://github.com/nodejs/node/pull/23239)
* \[[`27c5e96ffe`](https://github.com/nodejs/node/commit/27c5e96ffe)] - **doc**: leave pull requests open for 72 hours (Rich Trott) [#22275](https://github.com/nodejs/node/pull/22275)
* \[[`5836b9fcc8`](https://github.com/nodejs/node/commit/5836b9fcc8)] - **doc**: specify cluster worker.kill() caveat (cjihrig) [#23165](https://github.com/nodejs/node/pull/23165)
* \[[`ed01b38295`](https://github.com/nodejs/node/commit/ed01b38295)] - **doc**: use stronger language about security of vm (Gus Caplan) [#23198](https://github.com/nodejs/node/pull/23198)
* \[[`eb8721977f`](https://github.com/nodejs/node/commit/eb8721977f)] - **doc**: improve Download section of README (Rich Trott) [#23212](https://github.com/nodejs/node/pull/23212)
* \[[`003d85d2d9`](https://github.com/nodejs/node/commit/003d85d2d9)] - **doc**: remove GA tracking (Ben Noordhuis) [#23083](https://github.com/nodejs/node/pull/23083)
* \[[`6912376562`](https://github.com/nodejs/node/commit/6912376562)] - **doc**: move gibfahn to TSC Emeritus (Gibson Fahnestock) [#23238](https://github.com/nodejs/node/pull/23238)
* \[[`1553e21007`](https://github.com/nodejs/node/commit/1553e21007)] - **doc**: clarify assigning issues to the TSC (Franziska Hinkelmann) [#22759](https://github.com/nodejs/node/pull/22759)
* \[[`71901d6b30`](https://github.com/nodejs/node/commit/71901d6b30)] - **doc**: improve Release Types text in README (Rich Trott) [#23190](https://github.com/nodejs/node/pull/23190)
* \[[`8191bee313`](https://github.com/nodejs/node/commit/8191bee313)] - **doc**: simplify support section of README (Rich Trott) [#23170](https://github.com/nodejs/node/pull/23170)
* \[[`548934d412`](https://github.com/nodejs/node/commit/548934d412)] - **doc**: fix incorrect anchoring (#vcbuild.bat -> #vcbuildbat) (Justin Lee) [#23211](https://github.com/nodejs/node/pull/23211)
* \[[`ce006eb68d`](https://github.com/nodejs/node/commit/ce006eb68d)] - **doc**: fix minor typo (to early -> too early) (Justin Lee) [#23211](https://github.com/nodejs/node/pull/23211)
* \[[`21490c2a87`](https://github.com/nodejs/node/commit/21490c2a87)] - **doc**: remove recommendation to use node-eps (Richard Lau) [#23148](https://github.com/nodejs/node/pull/23148)
* \[[`e71a72fbf2`](https://github.com/nodejs/node/commit/e71a72fbf2)] - **doc**: add contents table to CONTRIBUTING.md (ZYSzys) [#23140](https://github.com/nodejs/node/pull/23140)
* \[[`818db4036b`](https://github.com/nodejs/node/commit/818db4036b)] - **doc**: move perf tools and APIs to Tier 3 (Matheus Marchini) [#22915](https://github.com/nodejs/node/pull/22915)
* \[[`e791abe5ef`](https://github.com/nodejs/node/commit/e791abe5ef)] - **doc**: formalize `auto` usage in C++ style guide (Anna Henningsen) [#23028](https://github.com/nodejs/node/pull/23028)
* \[[`310109691b`](https://github.com/nodejs/node/commit/310109691b)] - **doc**: fix casing in stream.md (Sintendo) [#23166](https://github.com/nodejs/node/pull/23166)
* \[[`bb5c6892ee`](https://github.com/nodejs/node/commit/bb5c6892ee)] - **doc**: add table of contents in BUILDING.md (ZYSzys) [#23147](https://github.com/nodejs/node/pull/23147)
* \[[`cbcf5f88cd`](https://github.com/nodejs/node/commit/cbcf5f88cd)] - **doc**: deeper link to downloads site (Refael Ackermann) [#23084](https://github.com/nodejs/node/pull/23084)
* \[[`9109187948`](https://github.com/nodejs/node/commit/9109187948)] - **doc**: update guide for assert team (Rich Trott) [#23085](https://github.com/nodejs/node/pull/23085)
* \[[`2731d08c33`](https://github.com/nodejs/node/commit/2731d08c33)] - **doc**: add links for fs.createWriteStream() (Rich Trott) [#23104](https://github.com/nodejs/node/pull/23104)
* \[[`9fa3813845`](https://github.com/nodejs/node/commit/9fa3813845)] - **doc**: edit fast-tracking section (cjihrig) [#23059](https://github.com/nodejs/node/pull/23059)
* \[[`14327aea7b`](https://github.com/nodejs/node/commit/14327aea7b)] - **doc**: improve instruction to purple merge (Refael Ackermann) [#23007](https://github.com/nodejs/node/pull/23007)
* \[[`87565c763a`](https://github.com/nodejs/node/commit/87565c763a)] - **doc**: require two approvals to land changes (Rich Trott) [#22255](https://github.com/nodejs/node/pull/22255)
* \[[`e7be1edc49`](https://github.com/nodejs/node/commit/e7be1edc49)] - **doc**: fix optional parameters in n-api.md (Lars-Magnus Skog) [#22998](https://github.com/nodejs/node/pull/22998)
* \[[`24073cef6b`](https://github.com/nodejs/node/commit/24073cef6b)] - **doc**: add callback parameters of worker.terminate() (Denis Fäcke) [#23002](https://github.com/nodejs/node/pull/23002)
* \[[`6b2e2ff036`](https://github.com/nodejs/node/commit/6b2e2ff036)] - **doc**: improve metadata for http.request (Tobias Nießen) [#22949](https://github.com/nodejs/node/pull/22949)
* \[[`91b410259e`](https://github.com/nodejs/node/commit/91b410259e)] - **doc**: add missing metadata for recursive mkdir (Tobias Nießen) [#22949](https://github.com/nodejs/node/pull/22949)
* \[[`15c7c57a78`](https://github.com/nodejs/node/commit/15c7c57a78)] - **doc**: add missing metadata for dns.lookup (Tobias Nießen) [#22949](https://github.com/nodejs/node/pull/22949)
* \[[`05196893b9`](https://github.com/nodejs/node/commit/05196893b9)] - **doc**: fix heading levels in C++ style guide (Anna Henningsen) [#23061](https://github.com/nodejs/node/pull/23061)
* \[[`29a9e8498a`](https://github.com/nodejs/node/commit/29a9e8498a)] - **doc**: remove outdated notes on stdio in workers (Anna Henningsen) [#23054](https://github.com/nodejs/node/pull/23054)
* \[[`d3bc862d88`](https://github.com/nodejs/node/commit/d3bc862d88)] - **doc**: match program and console output in synopsis.md (Mohammed Essehemy) [#23006](https://github.com/nodejs/node/pull/23006)
* \[[`15b91b9eb8`](https://github.com/nodejs/node/commit/15b91b9eb8)] - **doc**: add links for repl.ReplServer (Rich Trott) [#23005](https://github.com/nodejs/node/pull/23005)
* \[[`b0e86ea8d0`](https://github.com/nodejs/node/commit/b0e86ea8d0)] - **doc**: update maintaining V8 guide (Michaël Zasso) [#22913](https://github.com/nodejs/node/pull/22913)
* \[[`00dd9738ee`](https://github.com/nodejs/node/commit/00dd9738ee)] - **doc**: specify fast-tracking (Ruben Bridgewater) [#22929](https://github.com/nodejs/node/pull/22929)
* \[[`ef5d90dfdc`](https://github.com/nodejs/node/commit/ef5d90dfdc)] - **doc**: add digitalinfinity to collaborators (Hitesh Kanwathirtha) [#22984](https://github.com/nodejs/node/pull/22984)
* \[[`b48dc0b667`](https://github.com/nodejs/node/commit/b48dc0b667)] - **doc,test**: fix inspect's sorted compare function (Michaël Zasso) [#22992](https://github.com/nodejs/node/pull/22992)
* \[[`d9d9d23191`](https://github.com/nodejs/node/commit/d9d9d23191)] - **errors**: fix ERR\_SOCKET\_BAD\_PORT message (Giovanny Andres Gongora Granada (Gioyik)) [#23015](https://github.com/nodejs/node/pull/23015)
* \[[`bb6530b31b`](https://github.com/nodejs/node/commit/bb6530b31b)] - **fs**: consistently return symlink type from readdir (Klaus Meinhardt) [#22808](https://github.com/nodejs/node/pull/22808)
* \[[`7e45daf494`](https://github.com/nodejs/node/commit/7e45daf494)] - **(SEMVER-MINOR)** **fs**: implement mkdir recursive (mkdirp) (Benjamin Coe) [#21875](https://github.com/nodejs/node/pull/21875)
* \[[`c29734c9d6`](https://github.com/nodejs/node/commit/c29734c9d6)] - **fs**: improve fs.watch ENOSPC error message (Anna Henningsen) [#21846](https://github.com/nodejs/node/pull/21846)
* \[[`7b327ea909`](https://github.com/nodejs/node/commit/7b327ea909)] - **(SEMVER-MINOR)** **http2**: add RFC 8441 extended connect protocol support (James M Snell) [#23284](https://github.com/nodejs/node/pull/23284)
* \[[`001881f33e`](https://github.com/nodejs/node/commit/001881f33e)] - **http2**: set nghttp2\_option\_set\_no\_closed\_streams (David Halls) [#23134](https://github.com/nodejs/node/pull/23134)
* \[[`8fe62f8d38`](https://github.com/nodejs/node/commit/8fe62f8d38)] - **http2**: don't send trailers on a closed connection (André Cruz) [#23146](https://github.com/nodejs/node/pull/23146)
* \[[`d1826fed41`](https://github.com/nodejs/node/commit/d1826fed41)] - **http2**: close fd in doSendFileFD() (cjihrig) [#23047](https://github.com/nodejs/node/pull/23047)
* \[[`8bf004b96d`](https://github.com/nodejs/node/commit/8bf004b96d)] - **(SEMVER-MINOR)** **http2**: add ping event (James M Snell) [#23009](https://github.com/nodejs/node/pull/23009)
* \[[`badc38f305`](https://github.com/nodejs/node/commit/badc38f305)] - **http2**: do not falsely emit 'aborted' on push (Anatoli Papirovski) [#22878](https://github.com/nodejs/node/pull/22878)
* \[[`24675a4306`](https://github.com/nodejs/node/commit/24675a4306)] - **(SEMVER-MINOR)** **http2**: add origin frame support (James M Snell) [#22956](https://github.com/nodejs/node/pull/22956)
* \[[`89fe9edd08`](https://github.com/nodejs/node/commit/89fe9edd08)] - **http2**: check if stream is not destroyed before sending trailers (Matteo Collina) [#22896](https://github.com/nodejs/node/pull/22896)
* \[[`aa48192f9d`](https://github.com/nodejs/node/commit/aa48192f9d)] - **inspector**: add virtual destructor to WorkerDelegate (Daniel Bevenius) [#23215](https://github.com/nodejs/node/pull/23215)
* \[[`16f7f52b24`](https://github.com/nodejs/node/commit/16f7f52b24)] - **inspector**: workers debugging (Eugene Ostroukhov) [#21364](https://github.com/nodejs/node/pull/21364)
* \[[`f66e9abcb3`](https://github.com/nodejs/node/commit/f66e9abcb3)] - **inspector**: implemented V8InspectorClient::resourceNameToUrl (Alexey Kozyatinskiy) [#22251](https://github.com/nodejs/node/pull/22251)
* \[[`1c3a2ebfcf`](https://github.com/nodejs/node/commit/1c3a2ebfcf)] - **inspector**: enable Inspector JS API in workers (Eugene Ostroukhov) [#22769](https://github.com/nodejs/node/pull/22769)
* \[[`c40e2dd6c9`](https://github.com/nodejs/node/commit/c40e2dd6c9)] - **lib**: reword help text for clarity (Gireesh Punathil) [#23016](https://github.com/nodejs/node/pull/23016)
* \[[`f38eff29e7`](https://github.com/nodejs/node/commit/f38eff29e7)] - **lib**: change abstract equal to strict equal (ZYSzys) [#22974](https://github.com/nodejs/node/pull/22974)
* \[[`0140a98e05`](https://github.com/nodejs/node/commit/0140a98e05)] - **lib**: make DOMException attributes configurable and enumerable (Joyee Cheung) [#22550](https://github.com/nodejs/node/pull/22550)
* \[[`5e7b1082d9`](https://github.com/nodejs/node/commit/5e7b1082d9)] - **lib**: set Symbol.toStringTag of DOMException (Joyee Cheung) [#22933](https://github.com/nodejs/node/pull/22933)
* \[[`a7f4d5e134`](https://github.com/nodejs/node/commit/a7f4d5e134)] - **lib**: refactor variable declarations (ZYSzys) [#22643](https://github.com/nodejs/node/pull/22643)
* \[[`fb68ef2e74`](https://github.com/nodejs/node/commit/fb68ef2e74)] - **lib**: added common.restoreStderr(); to end of file (Mark Abel) [#22487](https://github.com/nodejs/node/pull/22487)
* \[[`600c225439`](https://github.com/nodejs/node/commit/600c225439)] - **(SEMVER-MINOR)** **module**: add createRequireFunction method (Gus Caplan) [#19360](https://github.com/nodejs/node/pull/19360)
* \[[`a65bb42551`](https://github.com/nodejs/node/commit/a65bb42551)] - **net**: use connect() instead of connect.call() (Jackson Tian) [#23289](https://github.com/nodejs/node/pull/23289)
* \[[`5a306748e9`](https://github.com/nodejs/node/commit/5a306748e9)] - **process**: allow reading from stdout/stderr sockets (Anna Henningsen) [#23053](https://github.com/nodejs/node/pull/23053)
* \[[`66484b82c4`](https://github.com/nodejs/node/commit/66484b82c4)] - **(SEMVER-MINOR)** **process**: add `multipleResolves` event (Ruben Bridgewater) [#22218](https://github.com/nodejs/node/pull/22218)
* \[[`e16dd6d165`](https://github.com/nodejs/node/commit/e16dd6d165)] - **repl**: refactor ERR\_SCRIPT\_EXECUTION\_INTERRUPTED stack handling (Ruben Bridgewater) [#22436](https://github.com/nodejs/node/pull/22436)
* \[[`b1ffda6c17`](https://github.com/nodejs/node/commit/b1ffda6c17)] - **repl**: improve error output (Ruben Bridgewater) [#22436](https://github.com/nodejs/node/pull/22436)
* \[[`cd69e1b6c3`](https://github.com/nodejs/node/commit/cd69e1b6c3)] - **src**: fix ToObject() usage in node\_http\_parser.cc (cjihrig) [#23314](https://github.com/nodejs/node/pull/23314)
* \[[`5228ec4410`](https://github.com/nodejs/node/commit/5228ec4410)] - **src**: fix ToObject() usage in exceptions.cc (cjihrig) [#23314](https://github.com/nodejs/node/pull/23314)
* \[[`4d761d4224`](https://github.com/nodejs/node/commit/4d761d4224)] - **src**: reduce variable scope in stream\_base.cc (cjihrig) [#23297](https://github.com/nodejs/node/pull/23297)
* \[[`740741b279`](https://github.com/nodejs/node/commit/740741b279)] - **src**: reduce variable scope in node\_worker.cc (cjihrig) [#23297](https://github.com/nodejs/node/pull/23297)
* \[[`56c2f5702f`](https://github.com/nodejs/node/commit/56c2f5702f)] - **src**: reduce variable scope in node\_trace\_writer.cc (cjihrig) [#23297](https://github.com/nodejs/node/pull/23297)
* \[[`046fd987e4`](https://github.com/nodejs/node/commit/046fd987e4)] - **src**: reduce variable scope in node\_url.cc (cjihrig) [#23297](https://github.com/nodejs/node/pull/23297)
* \[[`36c430796b`](https://github.com/nodejs/node/commit/36c430796b)] - **src**: remove unneeded variables in node\_crypto.cc (cjihrig) [#23297](https://github.com/nodejs/node/pull/23297)
* \[[`902ba0ecb4`](https://github.com/nodejs/node/commit/902ba0ecb4)] - **src**: reduce variable scope in module\_wrap.cc (cjihrig) [#23297](https://github.com/nodejs/node/pull/23297)
* \[[`402867c0a9`](https://github.com/nodejs/node/commit/402867c0a9)] - **src**: reduce variable scope in cares\_wrap.cc (cjihrig) [#23297](https://github.com/nodejs/node/pull/23297)
* \[[`315bf257e5`](https://github.com/nodejs/node/commit/315bf257e5)] - **src**: fix ToObject() usage in node\_crypto.cc (cjihrig) [#23298](https://github.com/nodejs/node/pull/23298)
* \[[`950ccee386`](https://github.com/nodejs/node/commit/950ccee386)] - **src**: name EmbededderGraph edges and use class names for nodes (Joyee Cheung) [#23072](https://github.com/nodejs/node/pull/23072)
* \[[`390fc85ff0`](https://github.com/nodejs/node/commit/390fc85ff0)] - **src**: implement the new EmbedderGraph::AddEdge() (Joyee Cheung) [#22106](https://github.com/nodejs/node/pull/22106)
* \[[`5a8396796d`](https://github.com/nodejs/node/commit/5a8396796d)] - **src**: use JS inheritance for `AsyncWrap` (Anna Henningsen) [#23094](https://github.com/nodejs/node/pull/23094)
* \[[`894210ec12`](https://github.com/nodejs/node/commit/894210ec12)] - **src**: add virtual desctructor to Options class (Daniel Bevenius) [#23215](https://github.com/nodejs/node/pull/23215)
* \[[`8f5fb6f90c`](https://github.com/nodejs/node/commit/8f5fb6f90c)] - **src**: clean up zlib write code (Anna Henningsen) [#23183](https://github.com/nodejs/node/pull/23183)
* \[[`2da6f622dc`](https://github.com/nodejs/node/commit/2da6f622dc)] - **(SEMVER-MINOR)** **src**: deprecate `UVException()` without `Isolate*` (Anna Henningsen) [#23175](https://github.com/nodejs/node/pull/23175)
* \[[`e9a0cffbd6`](https://github.com/nodejs/node/commit/e9a0cffbd6)] - **(SEMVER-MINOR)** **src**: deprecate V8 date conversion helpers (Anna Henningsen) [#23179](https://github.com/nodejs/node/pull/23179)
* \[[`a2c1ce24b5`](https://github.com/nodejs/node/commit/a2c1ce24b5)] - **src**: fix indentation for `AsyncResource` (Anna Henningsen) [#23177](https://github.com/nodejs/node/pull/23177)
* \[[`64689edf76`](https://github.com/nodejs/node/commit/64689edf76)] - **src**: remove unused using declarations (Daniel Bevenius) [#23120](https://github.com/nodejs/node/pull/23120)
* \[[`0202c6c808`](https://github.com/nodejs/node/commit/0202c6c808)] - **src**: remove unused locale.h (Daniel Bevenius) [#23120](https://github.com/nodejs/node/pull/23120)
* \[[`20a4f14c57`](https://github.com/nodejs/node/commit/20a4f14c57)] - **src**: make req\_wrap a unique\_ptr in AfterConnect (Daniel Bevenius) [#23115](https://github.com/nodejs/node/pull/23115)
* \[[`ce7fad5b79`](https://github.com/nodejs/node/commit/ce7fad5b79)] - **src**: use unique\_ptr for obj in SetWeak lambda (Daniel Bevenius) [#23117](https://github.com/nodejs/node/pull/23117)
* \[[`7d7dc16240`](https://github.com/nodejs/node/commit/7d7dc16240)] - **src**: unique\_ptrs in few lambdas (Gireesh Punathil) [#23124](https://github.com/nodejs/node/pull/23124)
* \[[`4bd3b6e332`](https://github.com/nodejs/node/commit/4bd3b6e332)] - **src**: refactor crypto code with RAII cleanup (Gireesh Punathil) [#23014](https://github.com/nodejs/node/pull/23014)
* \[[`f3d09b6e4f`](https://github.com/nodejs/node/commit/f3d09b6e4f)] - **src**: simplify `MessagePort` construction code a bit (Anna Henningsen) [#23036](https://github.com/nodejs/node/pull/23036)
* \[[`4d61c34b9e`](https://github.com/nodejs/node/commit/4d61c34b9e)] - **src**: fix a typo in the comment (Gireesh Punathil) [#23078](https://github.com/nodejs/node/pull/23078)
* \[[`fa833828b2`](https://github.com/nodejs/node/commit/fa833828b2)] - **src**: added URL::FromFilePath method (Alexey Kozyatinskiy) [#22251](https://github.com/nodejs/node/pull/22251)
* \[[`109aa63910`](https://github.com/nodejs/node/commit/109aa63910)] - **src**: cache and resue isolate and contex pointers (Gireesh Punathil) [#23024](https://github.com/nodejs/node/pull/23024)
* \[[`2f659a3d74`](https://github.com/nodejs/node/commit/2f659a3d74)] - **src**: use RAII cleanup in node\_i18n.cc (Anna Henningsen) [#23021](https://github.com/nodejs/node/pull/23021)
* \[[`90f1200be9`](https://github.com/nodejs/node/commit/90f1200be9)] - **src**: define zlib constants in node\_zlib.cc (Anna Henningsen) [#23019](https://github.com/nodejs/node/pull/23019)
* \[[`d72867ec0c`](https://github.com/nodejs/node/commit/d72867ec0c)] - **src**: make `ZCtx::Init()` non-static (Anna Henningsen) [#23019](https://github.com/nodejs/node/pull/23019)
* \[[`56b1a3cf6e`](https://github.com/nodejs/node/commit/56b1a3cf6e)] - **src**: refactor zlib dictionary to STL vector (Anna Henningsen) [#23019](https://github.com/nodejs/node/pull/23019)
* \[[`76453f1878`](https://github.com/nodejs/node/commit/76453f1878)] - **src**: replace deprecated uses of FunctionTemplate::GetFunction (Andreas Haas) [#22993](https://github.com/nodejs/node/pull/22993)
* \[[`cb3062aa42`](https://github.com/nodejs/node/commit/cb3062aa42)] - **src**: remove calls to SetWrapperClassId() (Joyee Cheung) [#22975](https://github.com/nodejs/node/pull/22975)
* \[[`ab032e4ff4`](https://github.com/nodejs/node/commit/ab032e4ff4)] - **src**: refactor win32 `DebugProcess()` to use RAII cleanup (Anna Henningsen) [#22981](https://github.com/nodejs/node/pull/22981)
* \[[`b6cd18517c`](https://github.com/nodejs/node/commit/b6cd18517c)] - **src**: add CheckOptions to Options classes (Daniel Bevenius) [#22943](https://github.com/nodejs/node/pull/22943)
* \[[`ace6e07f0e`](https://github.com/nodejs/node/commit/ace6e07f0e)] - **src**: initialize pid variable before goto (Jeremy Apthorp) [#22961](https://github.com/nodejs/node/pull/22961)
* \[[`25bf1f5e28`](https://github.com/nodejs/node/commit/25bf1f5e28)] - **stream**: improve buffer list inspection (Ruben Bridgewater) [#23109](https://github.com/nodejs/node/pull/23109)
* \[[`2b77b94c05`](https://github.com/nodejs/node/commit/2b77b94c05)] - **streams**: refactor ReadableStream asyncIterator creation and a few fixes (Gus Caplan) [#23042](https://github.com/nodejs/node/pull/23042)
* \[[`df54db667c`](https://github.com/nodejs/node/commit/df54db667c)] - **test**: remove internal errorCache property (Rich Trott) [#23304](https://github.com/nodejs/node/pull/23304)
* \[[`70abcf2d10`](https://github.com/nodejs/node/commit/70abcf2d10)] - **test**: remove eslint-disable from fixtures (Rich Trott) [#23345](https://github.com/nodejs/node/pull/23345)
* \[[`b2d3445644`](https://github.com/nodejs/node/commit/b2d3445644)] - **test**: read() on dir on AIX does not return EISDIR (Ben Noordhuis) [#23330](https://github.com/nodejs/node/pull/23330)
* \[[`b523f13fa2`](https://github.com/nodejs/node/commit/b523f13fa2)] - **test**: add module require tests for certain package.json errors (Tom White) [#23285](https://github.com/nodejs/node/pull/23285)
* \[[`45e0080cf1`](https://github.com/nodejs/node/commit/45e0080cf1)] - **test**: remove flaky designation for test (Rich Trott) [#22856](https://github.com/nodejs/node/pull/22856)
* \[[`085de6fe18`](https://github.com/nodejs/node/commit/085de6fe18)] - **test**: swap arguments in strictEqual() (Duarte David) [#23204](https://github.com/nodejs/node/pull/23204)
* \[[`a070842e97`](https://github.com/nodejs/node/commit/a070842e97)] - **test**: remove obsolete domain test (Julien Gilli)
* \[[`cb68188805`](https://github.com/nodejs/node/commit/cb68188805)] - **test**: add stdin writable regression test (Anna Henningsen) [#23053](https://github.com/nodejs/node/pull/23053)
* \[[`06b5ef3868`](https://github.com/nodejs/node/commit/06b5ef3868)] - **test**: terminate cluster worker in infinite loop (cjihrig) [#23165](https://github.com/nodejs/node/pull/23165)
* \[[`9352d9d596`](https://github.com/nodejs/node/commit/9352d9d596)] - **test**: harden test-gc-http-client-timeout (Denys Otrishko) [#23184](https://github.com/nodejs/node/pull/23184)
* \[[`748d9d22fa`](https://github.com/nodejs/node/commit/748d9d22fa)] - **test**: add process.stdin.end() TTY regression test (Matteo Collina) [#23051](https://github.com/nodejs/node/pull/23051)
* \[[`44db98a7b6`](https://github.com/nodejs/node/commit/44db98a7b6)] - **test**: add more descriptive err message to assert (Josh Broomfield) [#23118](https://github.com/nodejs/node/pull/23118)
* \[[`b2a1cf3793`](https://github.com/nodejs/node/commit/b2a1cf3793)] - **test**: mark some flakes (Refael Ackermann) [#23208](https://github.com/nodejs/node/pull/23208)
* \[[`9b30a635e0`](https://github.com/nodejs/node/commit/9b30a635e0)] - **test**: improve test-gc-http-client (Rich Trott) [#23145](https://github.com/nodejs/node/pull/23145)
* \[[`23525b0547`](https://github.com/nodejs/node/commit/23525b0547)] - **test**: replace localhost with os.hostname in fs-readfilesync (Denys Otrishko) [#23101](https://github.com/nodejs/node/pull/23101)
* \[[`bebd7b2cdc`](https://github.com/nodejs/node/commit/bebd7b2cdc)] - **test**: fix flaky test-gc-net-timeout (Rich Trott) [#23139](https://github.com/nodejs/node/pull/23139)
* \[[`efeb49d224`](https://github.com/nodejs/node/commit/efeb49d224)] - **test**: increase test coverage for fs.promises read (Jennifer Bland) [#22800](https://github.com/nodejs/node/pull/22800)
* \[[`39c2a3f1c1`](https://github.com/nodejs/node/commit/39c2a3f1c1)] - **test**: improve test-gc-http-client-connaborted (Rich Trott) [#23091](https://github.com/nodejs/node/pull/23091)
* \[[`48c1c428f9`](https://github.com/nodejs/node/commit/48c1c428f9)] - **test**: improve debugging information for http2 test (Rich Trott) [#23058](https://github.com/nodejs/node/pull/23058)
* \[[`f486186e25`](https://github.com/nodejs/node/commit/f486186e25)] - **test**: remove setImmediate from timeout test (Rich Trott) [#23058](https://github.com/nodejs/node/pull/23058)
* \[[`85c4ecb8a5`](https://github.com/nodejs/node/commit/85c4ecb8a5)] - **test**: test undefined in util (ZYSzys) [#22741](https://github.com/nodejs/node/pull/22741)
* \[[`3e4af49157`](https://github.com/nodejs/node/commit/3e4af49157)] - **test**: add dns.onlookupall() to increase coverage (Masashi Hirano) [#22985](https://github.com/nodejs/node/pull/22985)
* \[[`d68dfa9243`](https://github.com/nodejs/node/commit/d68dfa9243)] - **test**: console.table when `null` in data (ZYSzys) [#22974](https://github.com/nodejs/node/pull/22974)
* \[[`4cda83dae2`](https://github.com/nodejs/node/commit/4cda83dae2)] - **test**: improve test-gc-http-client-onerror (Rich Trott) [#23090](https://github.com/nodejs/node/pull/23090)
* \[[`52c6ee789b`](https://github.com/nodejs/node/commit/52c6ee789b)] - **test**: improve test-gc-http-client-timeout (Rich Trott) [#23088](https://github.com/nodejs/node/pull/23088)
* \[[`69d3c08be1`](https://github.com/nodejs/node/commit/69d3c08be1)] - **test**: improve reliability of test-gc-http-client (Rich Trott) [#23087](https://github.com/nodejs/node/pull/23087)
* \[[`a566f0f43e`](https://github.com/nodejs/node/commit/a566f0f43e)] - **test**: improve reliability of test-gc-net-timeout (Rich Trott) [#23086](https://github.com/nodejs/node/pull/23086)
* \[[`c54e42362c`](https://github.com/nodejs/node/commit/c54e42362c)] - **test**: remove unnecessary assertions (Anna Henningsen) [#23040](https://github.com/nodejs/node/pull/23040)
* \[[`adaf530cdb`](https://github.com/nodejs/node/commit/adaf530cdb)] - **test**: check parameter type of fs.mkdir() (Masashi Hirano) [#22616](https://github.com/nodejs/node/pull/22616)
* \[[`a3b3485b34`](https://github.com/nodejs/node/commit/a3b3485b34)] - **test**: add comment describing test-fs-mkdir (Jennifer Bland) [#22424](https://github.com/nodejs/node/pull/22424)
* \[[`5d4bec3e0f`](https://github.com/nodejs/node/commit/5d4bec3e0f)] - **test**: fix flaky sequential/test-fs-watch-system-limit (Anna Henningsen) [#23038](https://github.com/nodejs/node/pull/23038)
* \[[`9de6b26a0c`](https://github.com/nodejs/node/commit/9de6b26a0c)] - **test**: remove string literals for strictEquals/notStrictEquals (MaleDong) [#22891](https://github.com/nodejs/node/pull/22891)
* \[[`43e3cf93e8`](https://github.com/nodejs/node/commit/43e3cf93e8)] - **test**: do not export common.leakedGlobals() (Rich Trott) [#22965](https://github.com/nodejs/node/pull/22965)
* \[[`70ccec2d91`](https://github.com/nodejs/node/commit/70ccec2d91)] - **test**: increase coverage for worker\_threads (Rich Trott) [#22942](https://github.com/nodejs/node/pull/22942)
* \[[`83278b23a7`](https://github.com/nodejs/node/commit/83278b23a7)] - **test**: fix flaky key pair generation test (Tobias Nießen) [#22980](https://github.com/nodejs/node/pull/22980)
* \[[`d38ce82756`](https://github.com/nodejs/node/commit/d38ce82756)] - **test**: remove common.hasSmallICU (Rich Trott) [#22937](https://github.com/nodejs/node/pull/22937)
* \[[`dcce2d67ae`](https://github.com/nodejs/node/commit/dcce2d67ae)] - **test**: add tests to check error in dns.lookupService. (Masashi Hirano) [#22908](https://github.com/nodejs/node/pull/22908)
* \[[`079760f28b`](https://github.com/nodejs/node/commit/079760f28b)] - **test**: mark some tests as flaky (João Reis) [#22941](https://github.com/nodejs/node/pull/22941)
* \[[`4436a3d660`](https://github.com/nodejs/node/commit/4436a3d660)] - **timers**: use custom inspection for linked lists (Ruben Bridgewater) [#23108](https://github.com/nodejs/node/pull/23108)
* \[[`4b976df9e2`](https://github.com/nodejs/node/commit/4b976df9e2)] - **tls**: fix DEP0083 after upgrading to OpenSSL 1.1.0 (Tobias Nießen) [#22953](https://github.com/nodejs/node/pull/22953)
* \[[`acc4a761b7`](https://github.com/nodejs/node/commit/acc4a761b7)] - **tools**: make Travis commit linting more robust (Rich Trott) [#23397](https://github.com/nodejs/node/pull/23397)
* \[[`e2a6e051b3`](https://github.com/nodejs/node/commit/e2a6e051b3)] - **tools**: apply linting to first commit in PRs (Rich Trott) [#22452](https://github.com/nodejs/node/pull/22452)
* \[[`42e67a4e68`](https://github.com/nodejs/node/commit/42e67a4e68)] - **tools**: remove useless assignment from configure.py (Gus Caplan) [#23200](https://github.com/nodejs/node/pull/23200)
* \[[`1010ef5df7`](https://github.com/nodejs/node/commit/1010ef5df7)] - **tools**: fix ICU shrinker and docs (Steven R. Loomis) [#23266](https://github.com/nodejs/node/pull/23266)
* \[[`d7031df415`](https://github.com/nodejs/node/commit/d7031df415)] - **tools**: allow input for TTY tests (Anna Henningsen) [#23053](https://github.com/nodejs/node/pull/23053)
* \[[`1a92335543`](https://github.com/nodejs/node/commit/1a92335543)] - **tools**: unify .editorconfig rules for 2-space (Roman Reiss) [#23163](https://github.com/nodejs/node/pull/23163)
* \[[`ef00e5c967`](https://github.com/nodejs/node/commit/ef00e5c967)] - **tools**: fix cpplint --quiet option (Daniel Bevenius) [#23075](https://github.com/nodejs/node/pull/23075)
* \[[`1cbc2ee034`](https://github.com/nodejs/node/commit/1cbc2ee034)] - **tools**: update ESLint to 5.6.1 (cjihrig) [#23149](https://github.com/nodejs/node/pull/23149)
* \[[`f6fc7e7aa5`](https://github.com/nodejs/node/commit/f6fc7e7aa5)] - **tools**: .eslintrc.js messages "default" typo style (Lovingly) [#22868](https://github.com/nodejs/node/pull/22868)
* \[[`a22485d8f1`](https://github.com/nodejs/node/commit/a22485d8f1)] - **(SEMVER-MINOR)** **tools**: add bash completion for node (Daniel Bevenius) [#20713](https://github.com/nodejs/node/pull/20713)
* \[[`a6562685c3`](https://github.com/nodejs/node/commit/a6562685c3)] - _**Revert**_ "**tools,gyp**: don't force build actions with multiple outputs" (Sakthipriyan Vairamani (thefourtheye)) [#23257](https://github.com/nodejs/node/pull/23257)
* \[[`73917387f4`](https://github.com/nodejs/node/commit/73917387f4)] - **tools,gyp**: cosmetic change to GYP `make` generator outputs (Refael Ackermann) [#23156](https://github.com/nodejs/node/pull/23156)
* \[[`d8cedf545e`](https://github.com/nodejs/node/commit/d8cedf545e)] - **tools,gyp**: don't force build actions with multiple outputs (Refael Ackermann) [#23156](https://github.com/nodejs/node/pull/23156)
* \[[`bf17708aa2`](https://github.com/nodejs/node/commit/bf17708aa2)] - **tty**: document `WriteStream.cursorTo()` and others (Umang Raghuvanshi) [#22893](https://github.com/nodejs/node/pull/22893)
* \[[`9c36827e94`](https://github.com/nodejs/node/commit/9c36827e94)] - **(SEMVER-MINOR)** **tty**: make `readStream.setRawMode()` return `this` (Alexander Mills) [#22950](https://github.com/nodejs/node/pull/22950)
* \[[`36028caf8c`](https://github.com/nodejs/node/commit/36028caf8c)] - **tty**: handle setRawMode errors (Nikolai Vavilov) [#22886](https://github.com/nodejs/node/pull/22886)
* \[[`d22ee2c698`](https://github.com/nodejs/node/commit/d22ee2c698)] - **url**: use foreach-style C++ loop (Tobias Nießen) [#23138](https://github.com/nodejs/node/pull/23138)
* \[[`f1b1b73c2b`](https://github.com/nodejs/node/commit/f1b1b73c2b)] - **(SEMVER-MINOR)** **url**: provide pathToFileURL and fileURLToPath (guybedford) [#22506](https://github.com/nodejs/node/pull/22506)
* \[[`384221e75c`](https://github.com/nodejs/node/commit/384221e75c)] - **(SEMVER-MINOR)** **util**: support BigInt in util.format (Masashi Hirano) [#22097](https://github.com/nodejs/node/pull/22097)
* \[[`77de1beaf0`](https://github.com/nodejs/node/commit/77de1beaf0)] - **util**: move inspect in separate file (Ruben Bridgewater) [#22845](https://github.com/nodejs/node/pull/22845)
* \[[`f2dfebb7b4`](https://github.com/nodejs/node/commit/f2dfebb7b4)] - **util**: update definition of DISALLOW\_COPY\_AND\_ASSIGN macro (Nitish Sakhawalkar) [#23092](https://github.com/nodejs/node/pull/23092)
* \[[`68eaa8789a`](https://github.com/nodejs/node/commit/68eaa8789a)] - **(SEMVER-MINOR)** **util**: add order option to `.inspect()` (Ruben Bridgewater) [#22788](https://github.com/nodejs/node/pull/22788)
* \[[`a2a1ebfecf`](https://github.com/nodejs/node/commit/a2a1ebfecf)] - **(SEMVER-MINOR)** **util**: use a shared symbol for util.inspect.custom (chocolateboy) [#20857](https://github.com/nodejs/node/pull/20857)
* \[[`077e7e0ce7`](https://github.com/nodejs/node/commit/077e7e0ce7)] - **util**: fix indentationLvl when exceeding max call stack size (Ruben Bridgewater) [#22787](https://github.com/nodejs/node/pull/22787)
* \[[`5a13e66088`](https://github.com/nodejs/node/commit/5a13e66088)] - **util**: improve inspect performance (Ruben Bridgewater) [#22503](https://github.com/nodejs/node/pull/22503)
* \[[`92e0f38a65`](https://github.com/nodejs/node/commit/92e0f38a65)] - **util**: remove outdated TODO (Ruben Bridgewater) [#22503](https://github.com/nodejs/node/pull/22503)
* \[[`3b895d1258`](https://github.com/nodejs/node/commit/3b895d1258)] - **win,msi**: display license notes before installing tools (João Reis) [#23044](https://github.com/nodejs/node/pull/23044)
* \[[`cf284c80a9`](https://github.com/nodejs/node/commit/cf284c80a9)] - **win,msi**: install Boxstarter from elevated shell (João Reis) [#22988](https://github.com/nodejs/node/pull/22988)
* \[[`2b7e18dec5`](https://github.com/nodejs/node/commit/2b7e18dec5)] - **win,msi**: highlight installation of 3rd-party tools (Tobias Nießen) [#23003](https://github.com/nodejs/node/pull/23003)
* \[[`ebf36cd180`](https://github.com/nodejs/node/commit/ebf36cd180)] - **(SEMVER-MINOR)** **win,msi**: install tools for native modules (João Reis) [#22645](https://github.com/nodejs/node/pull/22645)
* \[[`c34db7a9c2`](https://github.com/nodejs/node/commit/c34db7a9c2)] - **worker**: reduce `MessagePort` prototype to documented API (Anna Henningsen) [#23037](https://github.com/nodejs/node/pull/23037)
* \[[`2e30a6897d`](https://github.com/nodejs/node/commit/2e30a6897d)] - **worker**: hide MessagePort init function behind symbol (Anna Henningsen) [#23037](https://github.com/nodejs/node/pull/23037)
* \[[`b5889d0b84`](https://github.com/nodejs/node/commit/b5889d0b84)] - **worker**: only stop inspector if started (Anna Henningsen) [#22927](https://github.com/nodejs/node/pull/22927)
* \[[`7639390032`](https://github.com/nodejs/node/commit/7639390032)] - **worker,coverage**: support V8 coverage generation (Anna Henningsen) [#22928](https://github.com/nodejs/node/pull/22928)
* \[[`18cbde5ade`](https://github.com/nodejs/node/commit/18cbde5ade)] - **zlib**: simplify flushing mechanism (Anna Henningsen) [#23186](https://github.com/nodejs/node/pull/23186)
* \[[`e749a28c55`](https://github.com/nodejs/node/commit/e749a28c55)] - **zlib**: use common owner symbol to access JS wrapper (Anna Henningsen) [#23189](https://github.com/nodejs/node/pull/23189)
* \[[`a6b55c73b0`](https://github.com/nodejs/node/commit/a6b55c73b0)] - **zlib**: move, rename, document internal params() cb (Anna Henningsen) [#23187](https://github.com/nodejs/node/pull/23187)

<a id="10.11.0"></a>

## 2018-09-20, Version 10.11.0 (Current), @targos

### Notable Changes

* **fs**
  * Fixed fsPromises.readdir `withFileTypes`. [#22832](https://github.com/nodejs/node/pull/22832)
* **http2**
  * Added `http2stream.endAfterHeaders` property. [#22843](https://github.com/nodejs/node/pull/22843)
* **util**
  * Added `util.types.isBoxedPrimitive(value)`. [#22620](https://github.com/nodejs/node/pull/22620)
* **Added new collaborators**:
  * [boneskull](https://github.com/boneskull) - Christopher Hiller
* **The Technical Steering Committee has new members**:
  * [apapirovski](https://github.com/apapirovski) - Anatoli Papirovski
  * [gabrielschulhof](https://github.com/gabrielschulhof) - Gabriel Schulhof

### Commits

* \[[`add1fcd301`](https://github.com/nodejs/node/commit/add1fcd301)] - **assert**: add default operator to `assert.fail()` (Ruben Bridgewater) [#22694](https://github.com/nodejs/node/pull/22694)
* \[[`0015430b2c`](https://github.com/nodejs/node/commit/0015430b2c)] - **assert**: align argument names (Ruben Bridgewater) [#22760](https://github.com/nodejs/node/pull/22760)
* \[[`3fcd54fe46`](https://github.com/nodejs/node/commit/3fcd54fe46)] - **build**: do not lint fixtures in make lint-md (Joyee Cheung) [#22549](https://github.com/nodejs/node/pull/22549)
* \[[`84d498c044`](https://github.com/nodejs/node/commit/84d498c044)] - **build**: skip cctest on Windows shared lib build (Yihong Wang) [#21228](https://github.com/nodejs/node/pull/21228)
* \[[`3ff425e7e9`](https://github.com/nodejs/node/commit/3ff425e7e9)] - **build**: remove /MP from default additonal options (William Skellenger) [#22661](https://github.com/nodejs/node/pull/22661)
* \[[`a78a946648`](https://github.com/nodejs/node/commit/a78a946648)] - **build**: make doc generation work on Windows (Tobias Nießen) [#22749](https://github.com/nodejs/node/pull/22749)
* \[[`5bae8b9728`](https://github.com/nodejs/node/commit/5bae8b9728)] - **build**: add `--verbose` to `./configure` (Refael Ackermann) [#22450](https://github.com/nodejs/node/pull/22450)
* \[[`db10db9e18`](https://github.com/nodejs/node/commit/db10db9e18)] - **build**: move meta-shebang back to `configure` (Refael Ackermann) [#22450](https://github.com/nodejs/node/pull/22450)
* \[[`db52f8f913`](https://github.com/nodejs/node/commit/db52f8f913)] - **build**: rename configure to configure.py (Refael Ackermann) [#22450](https://github.com/nodejs/node/pull/22450)
* \[[`b4a79acd98`](https://github.com/nodejs/node/commit/b4a79acd98)] - **build,win**: exclude warning 4244 only for deps (Refael Ackermann) [#22698](https://github.com/nodejs/node/pull/22698)
* \[[`dbe27d7c80`](https://github.com/nodejs/node/commit/dbe27d7c80)] - **build,win**: generate single PDB file per target (Refael Ackermann) [#22698](https://github.com/nodejs/node/pull/22698)
* \[[`b3bc642d96`](https://github.com/nodejs/node/commit/b3bc642d96)] - **build,win**: WHOLEARCHIVE needs just lib name (Refael Ackermann) [#22698](https://github.com/nodejs/node/pull/22698)
* \[[`624e516fb7`](https://github.com/nodejs/node/commit/624e516fb7)] - **crypto**: fix edge case in authenticated encryption (Tobias Nießen) [#22828](https://github.com/nodejs/node/pull/22828)
* \[[`329ac60441`](https://github.com/nodejs/node/commit/329ac60441)] - **crypto**: remove unused scrypt validation parameter (Tobias Nießen) [#22902](https://github.com/nodejs/node/pull/22902)
* \[[`9b58b79372`](https://github.com/nodejs/node/commit/9b58b79372)] - **crypto**: rename symbols to match guidelines (Tobias Nießen) [#22770](https://github.com/nodejs/node/pull/22770)
* \[[`ff17b39008`](https://github.com/nodejs/node/commit/ff17b39008)] - **crypto**: fix public key encryption internals (Tobias Nießen) [#22780](https://github.com/nodejs/node/pull/22780)
* \[[`566075967d`](https://github.com/nodejs/node/commit/566075967d)] - **deps**: cherry-pick 9a23bdd from upstream V8 (Daniel Beckert) [#22910](https://github.com/nodejs/node/pull/22910)
* \[[`bb3292fd1f`](https://github.com/nodejs/node/commit/bb3292fd1f)] - **deps**: add missing HandleScope in FieldType::PrintTo (Yang Guo) [#22890](https://github.com/nodejs/node/pull/22890)
* \[[`967fbebf47`](https://github.com/nodejs/node/commit/967fbebf47)] - **deps**: cherry-pick 2363cdf from upstream V8 (Ali Ijaz Sheikh) [#22812](https://github.com/nodejs/node/pull/22812)
* \[[`e85aa19a82`](https://github.com/nodejs/node/commit/e85aa19a82)] - **deps**: patch V8 to 6.8.275.32 (Michaël Zasso) [#22682](https://github.com/nodejs/node/pull/22682)
* \[[`6a333999cf`](https://github.com/nodejs/node/commit/6a333999cf)] - **deps**: backport detailed line info for CPU profiler (Peter Marshall) [#22688](https://github.com/nodejs/node/pull/22688)
* \[[`6ed58457e2`](https://github.com/nodejs/node/commit/6ed58457e2)] - **doc**: explain how to invoke gc (isurusiri) [#20431](https://github.com/nodejs/node/pull/20431)
* \[[`6e9f1d6d08`](https://github.com/nodejs/node/commit/6e9f1d6d08)] - **doc**: add boneskull as collaborator (Christopher Hiller) [#22917](https://github.com/nodejs/node/pull/22917)
* \[[`f0679d9b24`](https://github.com/nodejs/node/commit/f0679d9b24)] - **doc**: update 6.x to 8.x in backporting wiki (Kamat, Trivikram) [#22879](https://github.com/nodejs/node/pull/22879)
* \[[`5c5d881beb`](https://github.com/nodejs/node/commit/5c5d881beb)] - **doc**: improve asymmetric crypto docs (Anna Henningsen) [#22820](https://github.com/nodejs/node/pull/22820)
* \[[`0873d0abfb`](https://github.com/nodejs/node/commit/0873d0abfb)] - **doc**: add missing options for crypto sign.sign() (Mohit kumar Bajoria) [#22824](https://github.com/nodejs/node/pull/22824)
* \[[`08e427afea`](https://github.com/nodejs/node/commit/08e427afea)] - **doc**: add full deprecation history (Tobias Nießen) [#22766](https://github.com/nodejs/node/pull/22766)
* \[[`ed142e1355`](https://github.com/nodejs/node/commit/ed142e1355)] - **doc**: add withFileTypes option to fsPromises.readdir (Bryan English) [#22833](https://github.com/nodejs/node/pull/22833)
* \[[`8e8748c329`](https://github.com/nodejs/node/commit/8e8748c329)] - **doc**: fix typo in dns docs (Mohammed Essehemy) [#22866](https://github.com/nodejs/node/pull/22866)
* \[[`cadb3606f8`](https://github.com/nodejs/node/commit/cadb3606f8)] - **doc**: update AUTHORS list (Anna Henningsen) [#22771](https://github.com/nodejs/node/pull/22771)
* \[[`0c39fa4240`](https://github.com/nodejs/node/commit/0c39fa4240)] - **doc**: add reference to guide for N-API additions (Michael Dawson) [#22593](https://github.com/nodejs/node/pull/22593)
* \[[`ef2a0bdc2e`](https://github.com/nodejs/node/commit/ef2a0bdc2e)] - **doc**: document http2 timeouts (Sagi Tsofan) [#22798](https://github.com/nodejs/node/pull/22798)
* \[[`cf95b61ad5`](https://github.com/nodejs/node/commit/cf95b61ad5)] - **doc**: add gabrielschulhof to TSC (Rich Trott) [#22818](https://github.com/nodejs/node/pull/22818)
* \[[`678673098f`](https://github.com/nodejs/node/commit/678673098f)] - **doc**: add history for withFileTypes in fs.readdir\[Sync]\() (Tien Do) [#22794](https://github.com/nodejs/node/pull/22794)
* \[[`bda3311afe`](https://github.com/nodejs/node/commit/bda3311afe)] - **doc**: `node debug` → `node inspect` in CLI docs (Anna Henningsen) [#22774](https://github.com/nodejs/node/pull/22774)
* \[[`9942117e6e`](https://github.com/nodejs/node/commit/9942117e6e)] - **doc**: update mmarchini's e-mail (Matheus Marchini) [#22776](https://github.com/nodejs/node/pull/22776)
* \[[`6579d05b15`](https://github.com/nodejs/node/commit/6579d05b15)] - **doc**: fix description of DEP0024 (Tobias Nießen) [#22755](https://github.com/nodejs/node/pull/22755)
* \[[`c1c78ca4eb`](https://github.com/nodejs/node/commit/c1c78ca4eb)] - **doc**: improve assert documentation (Ruben Bridgewater) [#22692](https://github.com/nodejs/node/pull/22692)
* \[[`e5cdfb0856`](https://github.com/nodejs/node/commit/e5cdfb0856)] - **doc**: fix typo in CHANGELOG\_V10.md (Chakravarthy S M) [#22744](https://github.com/nodejs/node/pull/22744)
* \[[`2b49b43f79`](https://github.com/nodejs/node/commit/2b49b43f79)] - **doc**: added symbols guidelines (Matteo Collina) [#22684](https://github.com/nodejs/node/pull/22684)
* \[[`688d01c7be`](https://github.com/nodejs/node/commit/688d01c7be)] - **doc**: add warning to readline's close() method (cjihrig) [#22679](https://github.com/nodejs/node/pull/22679)
* \[[`47acb78528`](https://github.com/nodejs/node/commit/47acb78528)] - **doc**: add apapirovski to TSC (Rich Trott) [#22717](https://github.com/nodejs/node/pull/22717)
* \[[`5da1f0ca2c`](https://github.com/nodejs/node/commit/5da1f0ca2c)] - **doc, win**: improve os.setPriority documentation (Bartosz Sosnowski) [#22817](https://github.com/nodejs/node/pull/22817)
* \[[`d69d06bbf7`](https://github.com/nodejs/node/commit/d69d06bbf7)] - **errors**: add useOriginalName to internal/errors (Joyee Cheung) [#22556](https://github.com/nodejs/node/pull/22556)
* \[[`2cb01f0d12`](https://github.com/nodejs/node/commit/2cb01f0d12)] - **errors**: decapitalize PBKDF2 error (Tobias Nießen) [#22687](https://github.com/nodejs/node/pull/22687)
* \[[`24a35f914a`](https://github.com/nodejs/node/commit/24a35f914a)] - **fs**: fix promisified fs.readdir withFileTypes (Anatoli Papirovski) [#22832](https://github.com/nodejs/node/pull/22832)
* \[[`f0a40172a8`](https://github.com/nodejs/node/commit/f0a40172a8)] - **fs**: ensure readdir() callback is only called once (cjihrig) [#22793](https://github.com/nodejs/node/pull/22793)
* \[[`790864bf9b`](https://github.com/nodejs/node/commit/790864bf9b)] - **(SEMVER-MINOR)** **http2**: add http2stream.endAfterHeaders property (James M Snell) [#22843](https://github.com/nodejs/node/pull/22843)
* \[[`2abdbf4368`](https://github.com/nodejs/node/commit/2abdbf4368)] - **lib**: generate allowedNodeEnvironmentFlags lazily (Anna Henningsen) [#22638](https://github.com/nodejs/node/pull/22638)
* \[[`49b59334d0`](https://github.com/nodejs/node/commit/49b59334d0)] - **lib**: simplify 'processChunkSync' (MaleDong) [#22802](https://github.com/nodejs/node/pull/22802)
* \[[`e2b72c2ca3`](https://github.com/nodejs/node/commit/e2b72c2ca3)] - **lib**: remove unnecessary symbols (MaleDong) [#22455](https://github.com/nodejs/node/pull/22455)
* \[[`25220f0ce1`](https://github.com/nodejs/node/commit/25220f0ce1)] - **lib,doc**: remove unused parameter, improve docs (MaleDong) [#22858](https://github.com/nodejs/node/pull/22858)
* \[[`bb2bbc8ebe`](https://github.com/nodejs/node/commit/bb2bbc8ebe)] - **n-api**: add generic finalizer callback (Gabriel Schulhof) [#22244](https://github.com/nodejs/node/pull/22244)
* \[[`4e3f1aef8d`](https://github.com/nodejs/node/commit/4e3f1aef8d)] - **net**: port isIPv6 to JS (Weijia Wang) [#22673](https://github.com/nodejs/node/pull/22673)
* \[[`5c8495349a`](https://github.com/nodejs/node/commit/5c8495349a)] - **path**: remove unnecessary if statement (William Chargin) [#22273](https://github.com/nodejs/node/pull/22273)
* \[[`4ab9d6f3db`](https://github.com/nodejs/node/commit/4ab9d6f3db)] - **process**: generate list of allowed env flags programmatically (Anna Henningsen) [#22638](https://github.com/nodejs/node/pull/22638)
* \[[`5d5c3fab25`](https://github.com/nodejs/node/commit/5d5c3fab25)] - **src**: refactor `Environment::GetCurrent()` usage (Anna Henningsen) [#22819](https://github.com/nodejs/node/pull/22819)
* \[[`5a494aed8c`](https://github.com/nodejs/node/commit/5a494aed8c)] - **src**: move no\_async\_hooks\_checks to env (Daniel Bevenius) [#22784](https://github.com/nodejs/node/pull/22784)
* \[[`bc076120f3`](https://github.com/nodejs/node/commit/bc076120f3)] - **src**: fix `--prof-process` CLI argument handling (Anna Henningsen) [#22790](https://github.com/nodejs/node/pull/22790)
* \[[`7e4f29f201`](https://github.com/nodejs/node/commit/7e4f29f201)] - **src**: move DebugPortGetter/Setter to node\_process.cc (James M Snell) [#22758](https://github.com/nodejs/node/pull/22758)
* \[[`1d3a63f079`](https://github.com/nodejs/node/commit/1d3a63f079)] - **src**: move getActiveResources/Handles to node\_process.cc (James M Snell) [#22758](https://github.com/nodejs/node/pull/22758)
* \[[`0c3242862a`](https://github.com/nodejs/node/commit/0c3242862a)] - **src**: make `FIXED_ONE_BYTE_STRING` an inline fn (Anna Henningsen) [#22725](https://github.com/nodejs/node/pull/22725)
* \[[`7fa5f54e6f`](https://github.com/nodejs/node/commit/7fa5f54e6f)] - **src**: remove trace\_sync\_io\_ from env (Daniel Bevenius) [#22726](https://github.com/nodejs/node/pull/22726)
* \[[`c3c5141f68`](https://github.com/nodejs/node/commit/c3c5141f68)] - **src**: remove abort\_on\_uncaught\_exception node.cc (Daniel Bevenius) [#22724](https://github.com/nodejs/node/pull/22724)
* \[[`44f1438b79`](https://github.com/nodejs/node/commit/44f1438b79)] - **src**: fix trace-event-file-pattern description (Andreas Madsen) [#22690](https://github.com/nodejs/node/pull/22690)
* \[[`a10d03d4fe`](https://github.com/nodejs/node/commit/a10d03d4fe)] - **string\_decoder**: support typed array or data view (Benjamin Chen) [#22562](https://github.com/nodejs/node/pull/22562)
* \[[`ff6e4ea4bd`](https://github.com/nodejs/node/commit/ff6e4ea4bd)] - **test**: prepare test-assert for strictEqual linting (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`5a0632666b`](https://github.com/nodejs/node/commit/5a0632666b)] - **test**: remove string literal from assertion (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`5d4cbd7fa1`](https://github.com/nodejs/node/commit/5d4cbd7fa1)] - **test**: remove string literal from assertion (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`5316334955`](https://github.com/nodejs/node/commit/5316334955)] - **test**: remove string literal arg from assertion (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`59b6968fb6`](https://github.com/nodejs/node/commit/59b6968fb6)] - **test**: remove string literal message from assertion (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`266f1a9cd8`](https://github.com/nodejs/node/commit/266f1a9cd8)] - **test**: remove string literal from assertion (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`a5f7f1d985`](https://github.com/nodejs/node/commit/a5f7f1d985)] - **test**: refactor flag check (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`e5de225680`](https://github.com/nodejs/node/commit/e5de225680)] - **test**: simplify assertion in http2 tests (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`b31a4d0808`](https://github.com/nodejs/node/commit/b31a4d0808)] - **test**: improve assertion in test-inspector.js (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`b301a7b7ec`](https://github.com/nodejs/node/commit/b301a7b7ec)] - **test**: remove string literal message in assertions (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`a15bfdad78`](https://github.com/nodejs/node/commit/a15bfdad78)] - **test**: remove string literal message from assertion (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`e580a44ab6`](https://github.com/nodejs/node/commit/e580a44ab6)] - **test**: don't inspect values if not necessary (Ruben Bridgewater) [#22903](https://github.com/nodejs/node/pull/22903)
* \[[`9e1f7366db`](https://github.com/nodejs/node/commit/9e1f7366db)] - **test**: minor refactor in common/index.js (James M Snell) [#22738](https://github.com/nodejs/node/pull/22738)
* \[[`bd6b2ab21d`](https://github.com/nodejs/node/commit/bd6b2ab21d)] - **test**: checks on napi factory wrap’s finalization (Lucas Woo) [#22612](https://github.com/nodejs/node/pull/22612)
* \[[`b1d667bca9`](https://github.com/nodejs/node/commit/b1d667bca9)] - **test**: refactor structure of common/index (James M Snell) [#22511](https://github.com/nodejs/node/pull/22511)
* \[[`d5e9801d8d`](https://github.com/nodejs/node/commit/d5e9801d8d)] - **test**: remove string literal from deepStrictEqual (iliashkolyar) [#22742](https://github.com/nodejs/node/pull/22742)
* \[[`649288bef6`](https://github.com/nodejs/node/commit/649288bef6)] - **test**: remove string argument to strictEqual() (Hariss096) [#22718](https://github.com/nodejs/node/pull/22718)
* \[[`36666629f6`](https://github.com/nodejs/node/commit/36666629f6)] - **test**: replaces assert.throws() with common.expectsError() (Saud Khanzada) [#22689](https://github.com/nodejs/node/pull/22689)
* \[[`13b8011589`](https://github.com/nodejs/node/commit/13b8011589)] - **test**: remove usage of deprecated V8 APIs in addons (Michaël Zasso) [#22704](https://github.com/nodejs/node/pull/22704)
* \[[`1ce94164a5`](https://github.com/nodejs/node/commit/1ce94164a5)] - **test**: fix flaky addons/callback-scope/test-resolve-async (Anna Henningsen) [#22664](https://github.com/nodejs/node/pull/22664)
* \[[`6367349a95`](https://github.com/nodejs/node/commit/6367349a95)] - **tools**: synchronize deepStrictEqual() message rules (Rich Trott) [#22887](https://github.com/nodejs/node/pull/22887)
* \[[`8ffcb2d2ca`](https://github.com/nodejs/node/commit/8ffcb2d2ca)] - **tools**: prevent string literals in some assertions (Rich Trott) [#22849](https://github.com/nodejs/node/pull/22849)
* \[[`4ff49ae81c`](https://github.com/nodejs/node/commit/4ff49ae81c)] - **tools**: merge custom cpplint with cpplint v1.3.0 (Christopher Hiller) [#22864](https://github.com/nodejs/node/pull/22864)
* \[[`15a59bb2b2`](https://github.com/nodejs/node/commit/15a59bb2b2)] - **tools**: update ESLint to 5.6.0 (Rich Trott) [#22882](https://github.com/nodejs/node/pull/22882)
* \[[`b2abeff43c`](https://github.com/nodejs/node/commit/b2abeff43c)] - **tools**: implement update-authors in JS (Anna Henningsen) [#22771](https://github.com/nodejs/node/pull/22771)
* \[[`9564f7a123`](https://github.com/nodejs/node/commit/9564f7a123)] - **tools**: fix doc tool behavior for version arrays (Tobias Nießen) [#22766](https://github.com/nodejs/node/pull/22766)
* \[[`d03ce9df05`](https://github.com/nodejs/node/commit/d03ce9df05)] - **tools**: use lint-md.js (Refael Ackermann) [#20109](https://github.com/nodejs/node/pull/20109)
* \[[`22fefaeeeb`](https://github.com/nodejs/node/commit/22fefaeeeb)] - **tools**: `make lint-md-rollup` & checkin `lint-md.js` (Refael Ackermann) [#20109](https://github.com/nodejs/node/pull/20109)
* \[[`350a3e17f5`](https://github.com/nodejs/node/commit/350a3e17f5)] - **tools**: relocate `remark-preset-lint-node` (Refael Ackermann) [#20109](https://github.com/nodejs/node/pull/20109)
* \[[`25e1060ce4`](https://github.com/nodejs/node/commit/25e1060ce4)] - **tools**: update `node-lint-md-cli-rollup` (Refael Ackermann) [#20109](https://github.com/nodejs/node/pull/20109)
* \[[`37b27a5604`](https://github.com/nodejs/node/commit/37b27a5604)] - **tools**: vendor in node-lint-md-cli-rollup (Refael Ackermann) [#20109](https://github.com/nodejs/node/pull/20109)
* \[[`62d73042c6`](https://github.com/nodejs/node/commit/62d73042c6)] - **tools**: update eslint to v5.5.0 (Ruben Bridgewater) [#22720](https://github.com/nodejs/node/pull/22720)
* \[[`a7e8949cb7`](https://github.com/nodejs/node/commit/a7e8949cb7)] - **tools**: add \[src] links to child-process.html (Sam Ruby) [#22706](https://github.com/nodejs/node/pull/22706)
* \[[`ca06e65b08`](https://github.com/nodejs/node/commit/ca06e65b08)] - **tools**: update dmn to 2.0.0 (Rich Trott) [#22733](https://github.com/nodejs/node/pull/22733)
* \[[`649fcbba6f`](https://github.com/nodejs/node/commit/649fcbba6f)] - **tools,doc**: apilinks should handle root scenarios (Kyle Farnung) [#22721](https://github.com/nodejs/node/pull/22721)
* \[[`0fc79d48f8`](https://github.com/nodejs/node/commit/0fc79d48f8)] - **tools,win**: fix find\_python error (Kyle Farnung) [#22797](https://github.com/nodejs/node/pull/22797)
* \[[`aa05c8b117`](https://github.com/nodejs/node/commit/aa05c8b117)] - **trace\_events**: avoid flusing uninitialized traces (Ali Ijaz Sheikh) [#22812](https://github.com/nodejs/node/pull/22812)
* \[[`db7927683c`](https://github.com/nodejs/node/commit/db7927683c)] - **tracing**: remove shutdown-on-signal (Anna Henningsen) [#22734](https://github.com/nodejs/node/pull/22734)
* \[[`8cfa88aa5c`](https://github.com/nodejs/node/commit/8cfa88aa5c)] - **(SEMVER-MINOR)** **util**: add util.types.isBoxedPrimitive (Ruben Bridgewater) [#22620](https://github.com/nodejs/node/pull/22620)
* \[[`a96a8468d6`](https://github.com/nodejs/node/commit/a96a8468d6)] - **worker**: correct (de)initialization order (Anna Henningsen) [#22773](https://github.com/nodejs/node/pull/22773)

<a id="10.10.0"></a>

## 2018-09-06, Version 10.10.0 (Current), @targos

### Notable Changes

* **child\_process**:
  * `TypedArray` and `DataView` values are now accepted as input by
    `execFileSync` and `spawnSync`. [#22409](https://github.com/nodejs/node/pull/22409)
* **coverage**:
  * Native V8 code coverage information can now be output to disk by setting the
    environment variable `NODE_V8_COVERAGE` to a directory. [#22527](https://github.com/nodejs/node/pull/22527)
* **deps**:
  * The bundled npm was upgraded to version 6.4.1. [#22591](https://github.com/nodejs/node/pull/22591)
    * Changelogs:
      [6.3.0-next.0](https://github.com/npm/cli/releases/tag/v6.3.0-next.0)
      [6.3.0](https://github.com/npm/cli/releases/tag/v6.3.0)
      [6.4.0](https://github.com/npm/cli/releases/tag/v6.4.0)
      [6.4.1](https://github.com/npm/cli/releases/tag/v6.4.1)
* **fs**:
  * The methods `fs.read`, `fs.readSync`, `fs.write`, `fs.writeSync`,
    `fs.writeFile` and `fs.writeFileSync` now all accept `TypedArray` and
    `DataView` objects. [#22150](https://github.com/nodejs/node/pull/22150)
  * A new boolean option, `withFileTypes`, can be passed to `fs.readdir` and
    `fs.readdirSync`. If set to true, the methods return an array of directory
    entries. These are objects that can be used to determine the type of each
    entry and filter them based on that without calling `fs.stat`. [#22020](https://github.com/nodejs/node/pull/22020)
* **http2**:
  * The `http2` module is no longer experimental. [#22466](https://github.com/nodejs/node/pull/22466)
* **os**:
  * Added two new methods: `os.getPriority` and `os.setPriority`, allowing to
    manipulate the scheduling priority of processes. [#22407](https://github.com/nodejs/node/pull/22407)
* **process**:
  * Added `process.allowedNodeEnvironmentFlags`. This object can be used to
    programmatically validate and list flags that are allowed in the
    `NODE_OPTIONS` environment variable. [#19335](https://github.com/nodejs/node/pull/19335)
* **src**:
  * Deprecated option variables in public C++ API. [#22515](https://github.com/nodejs/node/pull/22515)
  * Refactored options parsing. [#22392](https://github.com/nodejs/node/pull/22392)
* **vm**:
  * Added `vm.compileFunction`, a method to create new JavaScript functions from
    a source body, with options similar to those of the other `vm` methods. [#21571](https://github.com/nodejs/node/pull/21571)
* **Added new collaborators**:
  * [lundibundi](https://github.com/lundibundi) - Denys Otrishko

### Commits

* \[[`bdd3afbb87`](https://github.com/nodejs/node/commit/bdd3afbb87)] - **assert**: fix loose set and map comparison (Ruben Bridgewater) [#22495](https://github.com/nodejs/node/pull/22495)
* \[[`e2a801a5e6`](https://github.com/nodejs/node/commit/e2a801a5e6)] - **async\_hooks**: adding regression test case for async/await (Anto Aravinth) [#22374](https://github.com/nodejs/node/pull/22374)
* \[[`48648f5194`](https://github.com/nodejs/node/commit/48648f5194)] - **benchmark**: add lines to scatter plots (Denys Otrishko) [#22074](https://github.com/nodejs/node/pull/22074)
* \[[`9a10421f53`](https://github.com/nodejs/node/commit/9a10421f53)] - **build**: use arm64 as DESTCPU for aarch64 (Daniel Bevenius) [#22548](https://github.com/nodejs/node/pull/22548)
* \[[`4862ce1816`](https://github.com/nodejs/node/commit/4862ce1816)] - **build**: use `0o` octal notation in configure (Anna Henningsen) [#22536](https://github.com/nodejs/node/pull/22536)
* \[[`efe71e9e31`](https://github.com/nodejs/node/commit/efe71e9e31)] - **build**: Don't set `-fno-threadsafe-statics` on macOS (Kyle Fuller) [#22198](https://github.com/nodejs/node/pull/22198)
* \[[`fc1259bf56`](https://github.com/nodejs/node/commit/fc1259bf56)] - **build**: use `npm ci` (Refael Ackermann) [#22399](https://github.com/nodejs/node/pull/22399)
* \[[`660c515e60`](https://github.com/nodejs/node/commit/660c515e60)] - **build**: move available-node variable to top (Daniel Bevenius) [#22356](https://github.com/nodejs/node/pull/22356)
* \[[`8f760c2476`](https://github.com/nodejs/node/commit/8f760c2476)] - **build**: touch tools/doc/node\_modules after run (Daniel Bevenius) [#22350](https://github.com/nodejs/node/pull/22350)
* \[[`fd6033c341`](https://github.com/nodejs/node/commit/fd6033c341)] - **build**: add test-doc to test target (Daniel Bevenius) [#22294](https://github.com/nodejs/node/pull/22294)
* \[[`ed874e40d1`](https://github.com/nodejs/node/commit/ed874e40d1)] - **build**: use echo command instead of shell comments (Daniel Bevenius) [#22293](https://github.com/nodejs/node/pull/22293)
* \[[`3915537c13`](https://github.com/nodejs/node/commit/3915537c13)] - **build,tools**: tweak the travis config (Refael Ackermann) [#22417](https://github.com/nodejs/node/pull/22417)
* \[[`2f9295e68b`](https://github.com/nodejs/node/commit/2f9295e68b)] - **build,win**: remove unmatched `endlocal` statement (Refael Ackermann) [#22627](https://github.com/nodejs/node/pull/22627)
* \[[`180bb0b7d8`](https://github.com/nodejs/node/commit/180bb0b7d8)] - **child\_process**: fix handling of incorrect uid/gid in spawn (Denys Otrishko) [#22574](https://github.com/nodejs/node/pull/22574)
* \[[`5321c312c2`](https://github.com/nodejs/node/commit/5321c312c2)] - **(SEMVER-MINOR)** **child\_process**: allow typed arrays for input (Sarat Addepalli) [#22409](https://github.com/nodejs/node/pull/22409)
* \[[`43092ebfa2`](https://github.com/nodejs/node/commit/43092ebfa2)] - **cli**: more flexible width when printing `--help` (Anna Henningsen) [#22637](https://github.com/nodejs/node/pull/22637)
* \[[`18ce2b8911`](https://github.com/nodejs/node/commit/18ce2b8911)] - **cli**: generate --help text in JS (Anna Henningsen) [#22490](https://github.com/nodejs/node/pull/22490)
* \[[`dec42b54f7`](https://github.com/nodejs/node/commit/dec42b54f7)] - **cli**: fix flags on help output (Gus Caplan) [#22271](https://github.com/nodejs/node/pull/22271)
* \[[`9a0dad2097`](https://github.com/nodejs/node/commit/9a0dad2097)] - **(SEMVER-MINOR)** **coverage**: expose native V8 coverage (Benjamin Coe) [#22527](https://github.com/nodejs/node/pull/22527)
* \[[`989fd73f1e`](https://github.com/nodejs/node/commit/989fd73f1e)] - **crypto**: fix incorrect use of INT\_MAX in validation (Tobias Nießen) [#22581](https://github.com/nodejs/node/pull/22581)
* \[[`c47c79e1ca`](https://github.com/nodejs/node/commit/c47c79e1ca)] - **crypto**: improve setAuthTag (Tobias Nießen) [#22538](https://github.com/nodejs/node/pull/22538)
* \[[`ea34cc7b88`](https://github.com/nodejs/node/commit/ea34cc7b88)] - **crypto**: deduplicate public key parsing (Tobias Nießen) [#22553](https://github.com/nodejs/node/pull/22553)
* \[[`59a6c60a92`](https://github.com/nodejs/node/commit/59a6c60a92)] - **crypto**: add support for OCB mode for AEAD (Tobias Nießen) [#21447](https://github.com/nodejs/node/pull/21447)
* \[[`2c33dc36b1`](https://github.com/nodejs/node/commit/2c33dc36b1)] - **deps**: update to nghttp2 1.33.0 (Anna Henningsen) [#22649](https://github.com/nodejs/node/pull/22649)
* \[[`212e6bb092`](https://github.com/nodejs/node/commit/212e6bb092)] - **deps**: cherry-pick 22116dd from upstream V8 (Marcel Laverdet) [#21992](https://github.com/nodejs/node/pull/21992)
* \[[`f7295493c4`](https://github.com/nodejs/node/commit/f7295493c4)] - **deps**: backport a8f6869 from upstream V8 (Ben Newman) [#22122](https://github.com/nodejs/node/pull/22122)
* \[[`c84c27f7de`](https://github.com/nodejs/node/commit/c84c27f7de)] - **deps**: cherry-pick bf5ea81 from upstream V8 (Ali Ijaz Sheikh) [#22114](https://github.com/nodejs/node/pull/22114)
* \[[`a986abc529`](https://github.com/nodejs/node/commit/a986abc529)] - **deps**: fix V8 test regression (Michaël Zasso) [#22677](https://github.com/nodejs/node/pull/22677)
* \[[`a5c0bc44ac`](https://github.com/nodejs/node/commit/a5c0bc44ac)] - **deps**: backport 4 CPU profiler commits from upstream V8 (Peter Marshall) [#22028](https://github.com/nodejs/node/pull/22028)
* \[[`11c96987ff`](https://github.com/nodejs/node/commit/11c96987ff)] - **(SEMVER-MINOR)** **deps**: upgrade npm to 6.4.1 (Kat Marchán) [#22591](https://github.com/nodejs/node/pull/22591)
* \[[`5f44ce8b8b`](https://github.com/nodejs/node/commit/5f44ce8b8b)] - **deps**: backport String::Utf8Length with isolate (Michaël Zasso) [#22531](https://github.com/nodejs/node/pull/22531)
* \[[`d50e1ffa52`](https://github.com/nodejs/node/commit/d50e1ffa52)] - **deps**: backport String::Write{OneByte,Utf8} with isolate (Michaël Zasso) [#22531](https://github.com/nodejs/node/pull/22531)
* \[[`3dc9cfc4af`](https://github.com/nodejs/node/commit/3dc9cfc4af)] - **deps**: backport StackFrame::GetFrame with isolate (Michaël Zasso) [#22531](https://github.com/nodejs/node/pull/22531)
* \[[`1be23f7b95`](https://github.com/nodejs/node/commit/1be23f7b95)] - **deps**: sync V8 embedder string with master branch (Michaël Zasso) [#22573](https://github.com/nodejs/node/pull/22573)
* \[[`aa22dc8d68`](https://github.com/nodejs/node/commit/aa22dc8d68)] - **deps**: import acorn\@5.7.2 (Sam Ruby) [#22488](https://github.com/nodejs/node/pull/22488)
* \[[`611f423e1b`](https://github.com/nodejs/node/commit/611f423e1b)] - **deps**: patch V8 to 6.8.275.30 (Michaël Zasso) [#22125](https://github.com/nodejs/node/pull/22125)
* \[[`90e99dac86`](https://github.com/nodejs/node/commit/90e99dac86)] - **deps**: upgrade to libuv 1.23.0 (cjihrig) [#22365](https://github.com/nodejs/node/pull/22365)
* \[[`eab377f681`](https://github.com/nodejs/node/commit/eab377f681)] - **deps**: fix CRLF in text file not present in upstream (Joyee Cheung) [#22340](https://github.com/nodejs/node/pull/22340)
* \[[`c4ef170484`](https://github.com/nodejs/node/commit/c4ef170484)] - **doc**: remove usage of deprecated V8 APIs in addons.md (Michaël Zasso) [#22667](https://github.com/nodejs/node/pull/22667)
* \[[`a448c8b779`](https://github.com/nodejs/node/commit/a448c8b779)] - **doc**: add blurb about implications of ABI stability (Gabriel Schulhof) [#22508](https://github.com/nodejs/node/pull/22508)
* \[[`a3e3ae01fb`](https://github.com/nodejs/node/commit/a3e3ae01fb)] - **doc**: clarify Readable paused/flowing!==object mode (Chris White) [#22619](https://github.com/nodejs/node/pull/22619)
* \[[`56e654a47f`](https://github.com/nodejs/node/commit/56e654a47f)] - **doc**: update a link in v8.md (lakamsani) [#22639](https://github.com/nodejs/node/pull/22639)
* \[[`805875d33b`](https://github.com/nodejs/node/commit/805875d33b)] - **doc**: add personal pronoun for danbev (Daniel Bevenius) [#22670](https://github.com/nodejs/node/pull/22670)
* \[[`71502f219c`](https://github.com/nodejs/node/commit/71502f219c)] - **doc**: improve ECDH example (Tobias Nießen) [#22607](https://github.com/nodejs/node/pull/22607)
* \[[`a4545ad8dc`](https://github.com/nodejs/node/commit/a4545ad8dc)] - **doc**: indicate createSecureContext arg is optional (Rich Trott) [#22545](https://github.com/nodejs/node/pull/22545)
* \[[`0e862da422`](https://github.com/nodejs/node/commit/0e862da422)] - **doc**: remove \_optional\_ designation for tls options (Rich Trott) [#22545](https://github.com/nodejs/node/pull/22545)
* \[[`c7268c45bc`](https://github.com/nodejs/node/commit/c7268c45bc)] - **doc**: improve examples in buffer docs (pranshuchittora) [#22170](https://github.com/nodejs/node/pull/22170)
* \[[`395ba7b046`](https://github.com/nodejs/node/commit/395ba7b046)] - **doc**: fix a typo in fs.md (Vse Mozhet Byt) [#22635](https://github.com/nodejs/node/pull/22635)
* \[[`7d8ef42058`](https://github.com/nodejs/node/commit/7d8ef42058)] - **doc**: clarify fallback behavior of module require (TomCoded) [#22494](https://github.com/nodejs/node/pull/22494)
* \[[`3cec988e79`](https://github.com/nodejs/node/commit/3cec988e79)] - **doc**: Remove 'dnt\_helper.js' (MaleDong) [#22595](https://github.com/nodejs/node/pull/22595)
* \[[`5c2a6d8dfb`](https://github.com/nodejs/node/commit/5c2a6d8dfb)] - **doc**: add section on how to build debug build (Troels Liebe Bentsen) [#22510](https://github.com/nodejs/node/pull/22510)
* \[[`bfdb28e45a`](https://github.com/nodejs/node/commit/bfdb28e45a)] - **doc**: fix up warning text about character devices (Anna Henningsen) [#22569](https://github.com/nodejs/node/pull/22569)
* \[[`56f73a1996`](https://github.com/nodejs/node/commit/56f73a1996)] - **doc**: add profiling APIs to the diagnostics support document (Matheus Marchini) [#22588](https://github.com/nodejs/node/pull/22588)
* \[[`6f0e83ee03`](https://github.com/nodejs/node/commit/6f0e83ee03)] - **doc**: update Linux perf test status in our CI (Matheus Marchini) [#22588](https://github.com/nodejs/node/pull/22588)
* \[[`ae934186df`](https://github.com/nodejs/node/commit/ae934186df)] - **doc**: make Stability Index more concise (Rich Trott) [#22544](https://github.com/nodejs/node/pull/22544)
* \[[`c3a4cc4c16`](https://github.com/nodejs/node/commit/c3a4cc4c16)] - **doc**: unify deprecation wording (Tobias Nießen) [#22555](https://github.com/nodejs/node/pull/22555)
* \[[`e24cd92b66`](https://github.com/nodejs/node/commit/e24cd92b66)] - **doc**: remove redundant 'Example:' and similar notes (Vse Mozhet Byt) [#22537](https://github.com/nodejs/node/pull/22537)
* \[[`1d38399bcd`](https://github.com/nodejs/node/commit/1d38399bcd)] - **doc**: replace `1` by `process.stdout.fd` (Weijia Wang) [#22564](https://github.com/nodejs/node/pull/22564)
* \[[`5e7c6518a3`](https://github.com/nodejs/node/commit/5e7c6518a3)] - **doc**: warn against streaming from character devices (Gireesh Punathil) [#21212](https://github.com/nodejs/node/pull/21212)
* \[[`05d432c2a6`](https://github.com/nodejs/node/commit/05d432c2a6)] - **doc**: initial cut at support tiers for diag tools (Michael Dawson) [#21870](https://github.com/nodejs/node/pull/21870)
* \[[`397235ec62`](https://github.com/nodejs/node/commit/397235ec62)] - **doc**: simplify http2 wording and formatting (Rich Trott) [#22541](https://github.com/nodejs/node/pull/22541)
* \[[`81364a7e16`](https://github.com/nodejs/node/commit/81364a7e16)] - **doc**: clarify ERR\_AMBIGUOUS\_ARGUMENT (Rich Trott) [#22542](https://github.com/nodejs/node/pull/22542)
* \[[`46063b8479`](https://github.com/nodejs/node/commit/46063b8479)] - **doc**: add GitHub email set up link to COLLABORATOR\_GUIDE (Denys Otrishko) [#22525](https://github.com/nodejs/node/pull/22525)
* \[[`9b4403dd7d`](https://github.com/nodejs/node/commit/9b4403dd7d)] - **doc**: clarify git config name/email requirements (Anna Henningsen) [#22433](https://github.com/nodejs/node/pull/22433)
* \[[`2875f72c46`](https://github.com/nodejs/node/commit/2875f72c46)] - **doc**: document removed error codes (Sarat Addepalli) [#22100](https://github.com/nodejs/node/pull/22100)
* \[[`c833d83d21`](https://github.com/nodejs/node/commit/c833d83d21)] - **doc**: support 'removed' field in doc YAML sections (Sarat Addepalli) [#22100](https://github.com/nodejs/node/pull/22100)
* \[[`e2541303f3`](https://github.com/nodejs/node/commit/e2541303f3)] - **doc**: tweak macOS-firewall note position (ZYSzys) [#22440](https://github.com/nodejs/node/pull/22440)
* \[[`6228433926`](https://github.com/nodejs/node/commit/6228433926)] - **doc**: add lundibundi to collaborators (Denys Otrishko) [#22491](https://github.com/nodejs/node/pull/22491)
* \[[`2a849ba241`](https://github.com/nodejs/node/commit/2a849ba241)] - **doc**: state callback behavior on empty buffer (Ruben Verborgh) [#22461](https://github.com/nodejs/node/pull/22461)
* \[[`f27a25472c`](https://github.com/nodejs/node/commit/f27a25472c)] - **doc**: make createPushResponse() more detailled (MaleDong) [#22366](https://github.com/nodejs/node/pull/22366)
* \[[`282a45d042`](https://github.com/nodejs/node/commit/282a45d042)] - **doc**: update wrapping-related documentation (Gabriel Schulhof) [#22363](https://github.com/nodejs/node/pull/22363)
* \[[`c17e980534`](https://github.com/nodejs/node/commit/c17e980534)] - **doc**: clarify fs.write\[Sync]\() descriptions (Vse Mozhet Byt) [#22402](https://github.com/nodejs/node/pull/22402)
* \[[`1ebaa2af4a`](https://github.com/nodejs/node/commit/1ebaa2af4a)] - **doc**: unify optional arguments format in headings (Vse Mozhet Byt) [#22397](https://github.com/nodejs/node/pull/22397)
* \[[`d86e615549`](https://github.com/nodejs/node/commit/d86e615549)] - **doc**: clarify documentation of pipes and zlib objects (Andreas Girgensohn) [#22354](https://github.com/nodejs/node/pull/22354)
* \[[`e6440888b1`](https://github.com/nodejs/node/commit/e6440888b1)] - **doc**: add doc for --loader option (Sarat Addepalli) [#22104](https://github.com/nodejs/node/pull/22104)
* \[[`9142935eb2`](https://github.com/nodejs/node/commit/9142935eb2)] - **doc**: clarify that new URL().port could be an empty string (Matteo Collina) [#22232](https://github.com/nodejs/node/pull/22232)
* \[[`c894145e28`](https://github.com/nodejs/node/commit/c894145e28)] - **doc**: Windows building supported on x64 (Refael Ackermann) [#21443](https://github.com/nodejs/node/pull/21443)
* \[[`797229810e`](https://github.com/nodejs/node/commit/797229810e)] - **doc**: clarify ServerResponse explanations (MaleDong) [#22305](https://github.com/nodejs/node/pull/22305)
* \[[`2260bb9214`](https://github.com/nodejs/node/commit/2260bb9214)] - **(SEMVER-MINOR)** **fs**: update read to work with any TypedArray/DataView (Sarat Addepalli) [#22150](https://github.com/nodejs/node/pull/22150)
* \[[`ad97314418`](https://github.com/nodejs/node/commit/ad97314418)] - **(SEMVER-MINOR)** **fs**: readdir optionally returning type information (Bryan English) [#22020](https://github.com/nodejs/node/pull/22020)
* \[[`1e9d3e64cd`](https://github.com/nodejs/node/commit/1e9d3e64cd)] - **gyp**: muffle xcodebuild warnings (Ujjwal Sharma) [#21999](https://github.com/nodejs/node/pull/21999)
* \[[`c07a065699`](https://github.com/nodejs/node/commit/c07a065699)] - **http**: adding doc and debug for calling empty string on write function (Anto Aravinth) [#22118](https://github.com/nodejs/node/pull/22118)
* \[[`4cdecc5ebe`](https://github.com/nodejs/node/commit/4cdecc5ebe)] - **http2**: don't expose the original socket through the socket proxy (Szymon Marczak) [#22650](https://github.com/nodejs/node/pull/22650)
* \[[`f77bbe8cab`](https://github.com/nodejs/node/commit/f77bbe8cab)] - **(SEMVER-MINOR)** **http2**: graduate from experimental (James M Snell) [#22466](https://github.com/nodejs/node/pull/22466)
* \[[`a740145e1b`](https://github.com/nodejs/node/commit/a740145e1b)] - **http2**: throw better error when accessing unbound socket proxy (James M Snell) [#22486](https://github.com/nodejs/node/pull/22486)
* \[[`d3ceaa1d41`](https://github.com/nodejs/node/commit/d3ceaa1d41)] - **http2**: emit timeout on compat request and response (James M Snell) [#22252](https://github.com/nodejs/node/pull/22252)
* \[[`f0be05342b`](https://github.com/nodejs/node/commit/f0be05342b)] - **lib**: merge onread handlers for http2 streams & net.Socket (Ashok) [#22449](https://github.com/nodejs/node/pull/22449)
* \[[`1eac11f626`](https://github.com/nodejs/node/commit/1eac11f626)] - **lib**: extract validateNumber validator (Jon Moss) [#22249](https://github.com/nodejs/node/pull/22249)
* \[[`3f93782767`](https://github.com/nodejs/node/commit/3f93782767)] - **lib**: remove unused exec param (MaleDong) [#22274](https://github.com/nodejs/node/pull/22274)
* \[[`46fbc23614`](https://github.com/nodejs/node/commit/46fbc23614)] - **lib,src**: standardize `owner_symbol` for handles (Anna Henningsen) [#22002](https://github.com/nodejs/node/pull/22002)
* \[[`96213c8027`](https://github.com/nodejs/node/commit/96213c8027)] - **n-api**: clean up thread-safe function (Gabriel Schulhof) [#22259](https://github.com/nodejs/node/pull/22259)
* \[[`609ae33bbe`](https://github.com/nodejs/node/commit/609ae33bbe)] - **n-api**: remove idle\_running from TsFn (Lars-Magnus Skog) [#22520](https://github.com/nodejs/node/pull/22520)
* \[[`ad0072abfa`](https://github.com/nodejs/node/commit/ad0072abfa)] - **os**: don't use getCheckedFunction() in userInfo() (cjihrig) [#22609](https://github.com/nodejs/node/pull/22609)
* \[[`219da67e2e`](https://github.com/nodejs/node/commit/219da67e2e)] - **(SEMVER-MINOR)** **os**: add os.{get,set}Priority() (cjihrig) [#22407](https://github.com/nodejs/node/pull/22407)
* \[[`30b22a676d`](https://github.com/nodejs/node/commit/30b22a676d)] - **os**: destructure ERR\_SYSTEM\_ERROR properly (cjihrig) [#22394](https://github.com/nodejs/node/pull/22394)
* \[[`3b44053ce8`](https://github.com/nodejs/node/commit/3b44053ce8)] - **os**: improve networkInterfaces performance (Ruben Bridgewater) [#22359](https://github.com/nodejs/node/pull/22359)
* \[[`107c8c0d4d`](https://github.com/nodejs/node/commit/107c8c0d4d)] - **perf\_hooks**: move strings to env (James M Snell) [#22401](https://github.com/nodejs/node/pull/22401)
* \[[`2bf46ae45e`](https://github.com/nodejs/node/commit/2bf46ae45e)] - **(SEMVER-MINOR)** **process**: add allowedNodeEnvironmentFlags property (Christopher Hiller) [#19335](https://github.com/nodejs/node/pull/19335)
* \[[`5af6a89a73`](https://github.com/nodejs/node/commit/5af6a89a73)] - **process**: use owner\_symbol for `_getActive*` (Anna Henningsen) [#22002](https://github.com/nodejs/node/pull/22002)
* \[[`0b340ab5e7`](https://github.com/nodejs/node/commit/0b340ab5e7)] - **repl**: tab auto complete big arrays (Ruben Bridgewater) [#22408](https://github.com/nodejs/node/pull/22408)
* \[[`1025868d5c`](https://github.com/nodejs/node/commit/1025868d5c)] - **src**: remove calls to deprecated V8 functions (Equals) (Michaël Zasso) [#22665](https://github.com/nodejs/node/pull/22665)
* \[[`c637d41b9d`](https://github.com/nodejs/node/commit/c637d41b9d)] - **src**: remove calls to deprecated v8 functions (IntegerValue) (Ujjwal Sharma) [#22129](https://github.com/nodejs/node/pull/22129)
* \[[`be86ddb7ec`](https://github.com/nodejs/node/commit/be86ddb7ec)] - **src**: promote v8 name spaces with using (Gireesh Punathil) [#22641](https://github.com/nodejs/node/pull/22641)
* \[[`b1e5491ae9`](https://github.com/nodejs/node/commit/b1e5491ae9)] - **src**: remove calls to deprecated V8 functions (Int32Value) (Michaël Zasso) [#22662](https://github.com/nodejs/node/pull/22662)
* \[[`e5e72e60f0`](https://github.com/nodejs/node/commit/e5e72e60f0)] - **src**: skip warnings for our own deprecated APIs (Anna Henningsen) [#22666](https://github.com/nodejs/node/pull/22666)
* \[[`dbb8f37377`](https://github.com/nodejs/node/commit/dbb8f37377)] - **src**: remove editing leftovers from options help text (Anna Henningsen) [#22636](https://github.com/nodejs/node/pull/22636)
* \[[`4e651983e5`](https://github.com/nodejs/node/commit/4e651983e5)] - **src**: allow UTF-16 in generic StringBytes decode call (Anna Henningsen) [#22622](https://github.com/nodejs/node/pull/22622)
* \[[`f064d44fad`](https://github.com/nodejs/node/commit/f064d44fad)] - **src**: warn about odd UTF-16 decoding function signature (Anna Henningsen) [#22623](https://github.com/nodejs/node/pull/22623)
* \[[`516d71af66`](https://github.com/nodejs/node/commit/516d71af66)] - **src**: fix a typo in the comment (Gireesh Punathil) [#22640](https://github.com/nodejs/node/pull/22640)
* \[[`1edd47e0b7`](https://github.com/nodejs/node/commit/1edd47e0b7)] - **src**: disable debug options when inspector is unavailable (Anna Henningsen) [#22657](https://github.com/nodejs/node/pull/22657)
* \[[`cfca8518f8`](https://github.com/nodejs/node/commit/cfca8518f8)] - **src**: add `NODE_EXTERN` to class definition (Anna Henningsen) [#22559](https://github.com/nodejs/node/pull/22559)
* \[[`c8e586c859`](https://github.com/nodejs/node/commit/c8e586c859)] - **src**: add trace points to dns (Chin Huang) [#21840](https://github.com/nodejs/node/pull/21840)
* \[[`b8299585bc`](https://github.com/nodejs/node/commit/b8299585bc)] - **src**: make CLI options programatically accesible (Anna Henningsen) [#22490](https://github.com/nodejs/node/pull/22490)
* \[[`8930268382`](https://github.com/nodejs/node/commit/8930268382)] - **src**: fix node::FatalException (Tobias Nießen) [#22654](https://github.com/nodejs/node/pull/22654)
* \[[`bac4c41328`](https://github.com/nodejs/node/commit/bac4c41328)] - **(SEMVER-MINOR)** **src**: deprecate option variables in public API (Anna Henningsen) [#22515](https://github.com/nodejs/node/pull/22515)
* \[[`956502949b`](https://github.com/nodejs/node/commit/956502949b)] - **src**: remove calls to deprecated v8 functions (Uint32Value) (Ujjwal Sharma) [#22143](https://github.com/nodejs/node/pull/22143)
* \[[`b2a955a269`](https://github.com/nodejs/node/commit/b2a955a269)] - **src**: rework (mostly internal) functions to use Maybes (Ujjwal Sharma) [#21935](https://github.com/nodejs/node/pull/21935)
* \[[`0a65727f0a`](https://github.com/nodejs/node/commit/0a65727f0a)] - **src**: remove calls to deprecated v8 functions (ToString) (Ujjwal Sharma) [#21935](https://github.com/nodejs/node/pull/21935)
* \[[`75a9192549`](https://github.com/nodejs/node/commit/75a9192549)] - **src**: fix external memory usage going negative (Mathias Buus) [#22594](https://github.com/nodejs/node/pull/22594)
* \[[`99146772e0`](https://github.com/nodejs/node/commit/99146772e0)] - **src**: remove calls to deprecated v8 functions (BooleanValue) (Ujjwal Sharma) [#22075](https://github.com/nodejs/node/pull/22075)
* \[[`a7c0cb87be`](https://github.com/nodejs/node/commit/a7c0cb87be)] - **src**: do not pass code to ScriptCompiler::CreateCodeCacheForFunction (Michaël Zasso) [#22596](https://github.com/nodejs/node/pull/22596)
* \[[`332b035a96`](https://github.com/nodejs/node/commit/332b035a96)] - **src**: use String::Utf8Length with isolate (Michaël Zasso) [#22531](https://github.com/nodejs/node/pull/22531)
* \[[`8375f753c0`](https://github.com/nodejs/node/commit/8375f753c0)] - **src**: use String::Write{OneByte,Utf8} with isolate (Michaël Zasso) [#22531](https://github.com/nodejs/node/pull/22531)
* \[[`9478f29387`](https://github.com/nodejs/node/commit/9478f29387)] - **src**: use StackFrame::GetFrame with isolate (Michaël Zasso) [#22531](https://github.com/nodejs/node/pull/22531)
* \[[`f8feb0253d`](https://github.com/nodejs/node/commit/f8feb0253d)] - **src**: add missing `NODE_WANT_INTERNALS` guards (Anna Henningsen) [#22514](https://github.com/nodejs/node/pull/22514)
* \[[`2c5dfef393`](https://github.com/nodejs/node/commit/2c5dfef393)] - **src**: fix NODE\_OPTIONS parsing bug (Anna Henningsen) [#22529](https://github.com/nodejs/node/pull/22529)
* \[[`034ba7322f`](https://github.com/nodejs/node/commit/034ba7322f)] - **src**: fix --without-ssl build (Ian McKellar) [#22484](https://github.com/nodejs/node/pull/22484)
* \[[`2767ebad2f`](https://github.com/nodejs/node/commit/2767ebad2f)] - **src**: move more to node\_process.cc from node.cc (James M Snell) [#22422](https://github.com/nodejs/node/pull/22422)
* \[[`8fd55fffee`](https://github.com/nodejs/node/commit/8fd55fffee)] - **(SEMVER-MINOR)** **src**: refactor options parsing (Anna Henningsen) [#22392](https://github.com/nodejs/node/pull/22392)
* \[[`198cf417b5`](https://github.com/nodejs/node/commit/198cf417b5)] - **src**: yield empty maybes for failed AsyncWrap::MakeCallback calls (Anna Henningsen) [#22078](https://github.com/nodejs/node/pull/22078)
* \[[`02e3daaa57`](https://github.com/nodejs/node/commit/02e3daaa57)] - **src**: implement v8::Platform::CallDelayedOnWorkerThread (Alexey Kozyatinskiy) [#22383](https://github.com/nodejs/node/pull/22383)
* \[[`c207865e24`](https://github.com/nodejs/node/commit/c207865e24)] - **src**: encode 0x27 (') for special URLs (Timothy Gu) [#22022](https://github.com/nodejs/node/pull/22022)
* \[[`4638ce6f03`](https://github.com/nodejs/node/commit/4638ce6f03)] - **src**: perform integrity checks on built-in code cache (Joyee Cheung) [#22152](https://github.com/nodejs/node/pull/22152)
* \[[`866965ec0e`](https://github.com/nodejs/node/commit/866965ec0e)] - **src**: fix race on modpending (Ryan Petrich) [#21611](https://github.com/nodejs/node/pull/21611)
* \[[`383d578d76`](https://github.com/nodejs/node/commit/383d578d76)] - **src,deps**: add isolate parameter to String::Concat (Michaël Zasso) [#22521](https://github.com/nodejs/node/pull/22521)
* \[[`4ed300a585`](https://github.com/nodejs/node/commit/4ed300a585)] - **stream**: update emit readable debug statement (Daniel Bevenius) [#22613](https://github.com/nodejs/node/pull/22613)
* \[[`53fb7af1b2`](https://github.com/nodejs/node/commit/53fb7af1b2)] - **stream**: restore flow if there are 'data' handlers after once('readable') (Matteo Collina) [#22209](https://github.com/nodejs/node/pull/22209)
* \[[`dd772c1f13`](https://github.com/nodejs/node/commit/dd772c1f13)] - **test**: refactor test-gc-tls-external-memory (Anna Henningsen) [#22651](https://github.com/nodejs/node/pull/22651)
* \[[`7a3bbd21f3`](https://github.com/nodejs/node/commit/7a3bbd21f3)] - _**Revert**_ "**test**: mark async-hooks/test-callback-error as flaky" (Anna Henningsen) [#22655](https://github.com/nodejs/node/pull/22655)
* \[[`4791cd7f0a`](https://github.com/nodejs/node/commit/4791cd7f0a)] - **test**: fix flaky async-hooks/test-callback-error (Anna Henningsen) [#22655](https://github.com/nodejs/node/pull/22655)
* \[[`c26747d9af`](https://github.com/nodejs/node/commit/c26747d9af)] - **test**: fix flaky test-worker-message-port-transfer-self (Anna Henningsen) [#22658](https://github.com/nodejs/node/pull/22658)
* \[[`e5b732f25d`](https://github.com/nodejs/node/commit/e5b732f25d)] - **test**: add test to dynamic enablement of trace-events (Ali Ijaz Sheikh) [#22114](https://github.com/nodejs/node/pull/22114)
* \[[`2025eaf999`](https://github.com/nodejs/node/commit/2025eaf999)] - **test**: improve assertion in process test (Anna Henningsen) [#22634](https://github.com/nodejs/node/pull/22634)
* \[[`7a70dce251`](https://github.com/nodejs/node/commit/7a70dce251)] - **test**: fix test-trace-events-dns (Rich Trott) [#22674](https://github.com/nodejs/node/pull/22674)
* \[[`cb15017bfe`](https://github.com/nodejs/node/commit/cb15017bfe)] - **test**: fix flaky parallel/test-fs-write-file-typedarrays (Anna Henningsen) [#22659](https://github.com/nodejs/node/pull/22659)
* \[[`7627b0430a`](https://github.com/nodejs/node/commit/7627b0430a)] - **test**: use module.exports consistently (James M Snell) [#22557](https://github.com/nodejs/node/pull/22557)
* \[[`d3740d843a`](https://github.com/nodejs/node/commit/d3740d843a)] - **test**: improve assertions in test-cli-node-print-help (Anna Henningsen) [#22489](https://github.com/nodejs/node/pull/22489)
* \[[`67372016bb`](https://github.com/nodejs/node/commit/67372016bb)] - **test**: move test that depends on dns query to internet (Joyee Cheung) [#22516](https://github.com/nodejs/node/pull/22516)
* \[[`82732ef4f7`](https://github.com/nodejs/node/commit/82732ef4f7)] - **test**: fix typo in test name (Rich Trott) [#22605](https://github.com/nodejs/node/pull/22605)
* \[[`d3bb7419f2`](https://github.com/nodejs/node/commit/d3bb7419f2)] - **test**: refacor spawn\[Sync]Pwd (Refael Ackermann) [#22522](https://github.com/nodejs/node/pull/22522)
* \[[`4cdc61bc8c`](https://github.com/nodejs/node/commit/4cdc61bc8c)] - **test**: move AEAD test vectors out of script (Tobias Nießen) [#21873](https://github.com/nodejs/node/pull/21873)
* \[[`d27e463ca6`](https://github.com/nodejs/node/commit/d27e463ca6)] - **test**: properly extend process.env in child\_process (Lucas Woo) [#22430](https://github.com/nodejs/node/pull/22430)
* \[[`863899970b`](https://github.com/nodejs/node/commit/863899970b)] - **test**: add test for internalConnect() when address type is IPv6 (Yaniv Friedensohn) [#22444](https://github.com/nodejs/node/pull/22444)
* \[[`7f85288808`](https://github.com/nodejs/node/commit/7f85288808)] - **test**: remove string literal from strictEqual() (Scott Van Gilder) [#22512](https://github.com/nodejs/node/pull/22512)
* \[[`81d824b132`](https://github.com/nodejs/node/commit/81d824b132)] - **test**: move custom WHATWG URL tests into separate files (Joyee Cheung) [#22442](https://github.com/nodejs/node/pull/22442)
* \[[`6f31478229`](https://github.com/nodejs/node/commit/6f31478229)] - **test**: remove third argument from strictEqual() (Neeraj Laad) [#22451](https://github.com/nodejs/node/pull/22451)
* \[[`d02fb36379`](https://github.com/nodejs/node/commit/d02fb36379)] - **test**: move common.isCPPSymbolsNotMapped to tick-processor tests (James M Snell) [#22459](https://github.com/nodejs/node/pull/22459)
* \[[`9ec105ccdc`](https://github.com/nodejs/node/commit/9ec105ccdc)] - **test**: improve code coverage for string decoder (Benjamin Chen) [#22306](https://github.com/nodejs/node/pull/22306)
* \[[`1e7deb72d2`](https://github.com/nodejs/node/commit/1e7deb72d2)] - **test**: add streams benchmark test (Denys Otrishko) [#22335](https://github.com/nodejs/node/pull/22335)
* \[[`ef60a8d7a5`](https://github.com/nodejs/node/commit/ef60a8d7a5)] - **test**: add vm benchmark test (Denys Otrishko) [#22335](https://github.com/nodejs/node/pull/22335)
* \[[`400aac8c5f`](https://github.com/nodejs/node/commit/400aac8c5f)] - **test**: add v8 benchmark test (Denys Otrishko) [#22335](https://github.com/nodejs/node/pull/22335)
* \[[`a8b8d3fe56`](https://github.com/nodejs/node/commit/a8b8d3fe56)] - **test**: move common.onGC to individual module (James M Snell) [#22446](https://github.com/nodejs/node/pull/22446)
* \[[`6d0c3d19b8`](https://github.com/nodejs/node/commit/6d0c3d19b8)] - **test**: flaky everywhere test-trace-events-fs-sync (Refael Ackermann) [#22483](https://github.com/nodejs/node/pull/22483)
* \[[`7f2d3d0ed4`](https://github.com/nodejs/node/commit/7f2d3d0ed4)] - **test**: move hijackstdio out of require('common') (James M Snell) [#22462](https://github.com/nodejs/node/pull/22462)
* \[[`fcf059a667`](https://github.com/nodejs/node/commit/fcf059a667)] - **test**: add test unknown credential error of process.setgroups (Masashi Hirano) [#22368](https://github.com/nodejs/node/pull/22368)
* \[[`ae016c8e6d`](https://github.com/nodejs/node/commit/ae016c8e6d)] - **test**: add tests for dnsPromises.lookup (Masashi Hirano) [#21559](https://github.com/nodejs/node/pull/21559)
* \[[`98af1704ae`](https://github.com/nodejs/node/commit/98af1704ae)] - **test**: move common.ArrayStream to separate module (James M Snell) [#22447](https://github.com/nodejs/node/pull/22447)
* \[[`e68438246e`](https://github.com/nodejs/node/commit/e68438246e)] - **test**: remove isGlibc from common (James M Snell) [#22443](https://github.com/nodejs/node/pull/22443)
* \[[`acfb29cbd8`](https://github.com/nodejs/node/commit/acfb29cbd8)] - **test**: harden sequential/test-performance (Ruben Bridgewater) [#22404](https://github.com/nodejs/node/pull/22404)
* \[[`38b0c1f04d`](https://github.com/nodejs/node/commit/38b0c1f04d)] - **test**: remove redundant cli tests (Bryan English) [#22355](https://github.com/nodejs/node/pull/22355)
* \[[`e8e014a8dc`](https://github.com/nodejs/node/commit/e8e014a8dc)] - **test**: improve assert message in http timeout test (Rich Trott) [#22403](https://github.com/nodejs/node/pull/22403)
* \[[`22adebfc9a`](https://github.com/nodejs/node/commit/22adebfc9a)] - **test**: move http timeout test to parallel (Rich Trott) [#22403](https://github.com/nodejs/node/pull/22403)
* \[[`5aa3100c29`](https://github.com/nodejs/node/commit/5aa3100c29)] - **test**: fix flaky http timeout test (Rich Trott) [#22403](https://github.com/nodejs/node/pull/22403)
* \[[`33994d896a`](https://github.com/nodejs/node/commit/33994d896a)] - **test**: remove third argument from assert.strictEqual() (Dzmitry\_Prudnikau) [#22371](https://github.com/nodejs/node/pull/22371)
* \[[`fbc189b9eb`](https://github.com/nodejs/node/commit/fbc189b9eb)] - **test**: cover error case in os getCheckedFunction() (cjihrig) [#22394](https://github.com/nodejs/node/pull/22394)
* \[[`149c209171`](https://github.com/nodejs/node/commit/149c209171)] - **test**: harden test-gc-http-client (Ruben Bridgewater) [#22373](https://github.com/nodejs/node/pull/22373)
* \[[`acfb72486d`](https://github.com/nodejs/node/commit/acfb72486d)] - **test**: remove harmony flags (Ruben Bridgewater) [#22285](https://github.com/nodejs/node/pull/22285)
* \[[`44bcc1d71a`](https://github.com/nodejs/node/commit/44bcc1d71a)] - **test**: fix cctest URLTest.ToFilePath on Win32 without Intl (James M Snell) [#22265](https://github.com/nodejs/node/pull/22265)
* \[[`2ed22dfa3a`](https://github.com/nodejs/node/commit/2ed22dfa3a)] - **test**: mark async-hooks/test-callback-error as flaky (Joyee Cheung) [#22330](https://github.com/nodejs/node/pull/22330)
* \[[`4a28d38788`](https://github.com/nodejs/node/commit/4a28d38788)] - **test**: mark async-hooks/test-statwatcher as flaky (Joyee Cheung) [#22330](https://github.com/nodejs/node/pull/22330)
* \[[`5cfab145a1`](https://github.com/nodejs/node/commit/5cfab145a1)] - **test**: remove common.hasTracing (Rich Trott) [#22250](https://github.com/nodejs/node/pull/22250)
* \[[`7794d4e0b8`](https://github.com/nodejs/node/commit/7794d4e0b8)] - **test,stream**: fix pipeline test so it runs well on Windows in older nodes (Matteo Collina) [#22456](https://github.com/nodejs/node/pull/22456)
* \[[`696f7a54b5`](https://github.com/nodejs/node/commit/696f7a54b5)] - **tls**: improve debugging assertion (Anna Henningsen) [#22625](https://github.com/nodejs/node/pull/22625)
* \[[`2ca21998d3`](https://github.com/nodejs/node/commit/2ca21998d3)] - **tools**: add \[src] links to async\_hooks.html (Sam Ruby) [#22656](https://github.com/nodejs/node/pull/22656)
* \[[`c32d5577b6`](https://github.com/nodejs/node/commit/c32d5577b6)] - **tools**: add \[src] links to assert.html (Sam Ruby) [#22601](https://github.com/nodejs/node/pull/22601)
* \[[`f5520cc53d`](https://github.com/nodejs/node/commit/f5520cc53d)] - **tools**: specify rule disabled in test-assert.js (Rich Trott) [#22563](https://github.com/nodejs/node/pull/22563)
* \[[`15b7f75e49`](https://github.com/nodejs/node/commit/15b7f75e49)] - **tools**: specify rules disabled in common/dns.js (Rich Trott) [#22563](https://github.com/nodejs/node/pull/22563)
* \[[`50100f3a9c`](https://github.com/nodejs/node/commit/50100f3a9c)] - **tools**: Include links to source code in documentation (Sam Ruby) [#22405](https://github.com/nodejs/node/pull/22405)
* \[[`14ac77e2e2`](https://github.com/nodejs/node/commit/14ac77e2e2)] - **tools**: add missing package-lock to clang-format (Michaël Zasso) [#22500](https://github.com/nodejs/node/pull/22500)
* \[[`9d246f97d1`](https://github.com/nodejs/node/commit/9d246f97d1)] - **tools**: update ESLint to 5.4.0 (Rich Trott) [#22454](https://github.com/nodejs/node/pull/22454)
* \[[`725a2b14f2`](https://github.com/nodejs/node/commit/725a2b14f2)] - **tools**: simplify ESLint invocation in Makefile (Rich Trott) [#22348](https://github.com/nodejs/node/pull/22348)
* \[[`5b14066c14`](https://github.com/nodejs/node/commit/5b14066c14)] - **util**: restore all information in inspect (Ruben Bridgewater) [#22437](https://github.com/nodejs/node/pull/22437)
* \[[`f86ca8948a`](https://github.com/nodejs/node/commit/f86ca8948a)] - **util**: Fix number format for `pad` (MaleDong) [#21906](https://github.com/nodejs/node/pull/21906)
* \[[`1828017053`](https://github.com/nodejs/node/commit/1828017053)] - **util**: mark special entries as such (Ruben Bridgewater) [#22287](https://github.com/nodejs/node/pull/22287)
* \[[`f763ac7dd0`](https://github.com/nodejs/node/commit/f763ac7dd0)] - **util**: escape symbol and non-enumerable keys (Ruben Bridgewater) [#22300](https://github.com/nodejs/node/pull/22300)
* \[[`3dc3a3196a`](https://github.com/nodejs/node/commit/3dc3a3196a)] - **util**: improve empty typed array inspection (Ruben Bridgewater) [#22284](https://github.com/nodejs/node/pull/22284)
* \[[`e9ac683efc`](https://github.com/nodejs/node/commit/e9ac683efc)] - **util**: properly indent special properties (Ruben Bridgewater) [#22291](https://github.com/nodejs/node/pull/22291)
* \[[`459d676203`](https://github.com/nodejs/node/commit/459d676203)] - **util**: harden util.inspect (Ruben Bridgewater) [#21869](https://github.com/nodejs/node/pull/21869)
* \[[`cdf6471234`](https://github.com/nodejs/node/commit/cdf6471234)] - **util**: fix sparse array inspection (Ruben Bridgewater) [#22283](https://github.com/nodejs/node/pull/22283)
* \[[`2b1cb3b01f`](https://github.com/nodejs/node/commit/2b1cb3b01f)] - **util,assert**: improve performance (Ruben Bridgewater) [#22197](https://github.com/nodejs/node/pull/22197)
* \[[`4d4180b46b`](https://github.com/nodejs/node/commit/4d4180b46b)] - **util,assert**: improve comparison performance (Ruben Bridgewater) [#22258](https://github.com/nodejs/node/pull/22258)
* \[[`2937a79c45`](https://github.com/nodejs/node/commit/2937a79c45)] - **(SEMVER-MINOR)** **vm**: add bindings for v8::CompileFunctionInContext (Ujjwal Sharma) [#21571](https://github.com/nodejs/node/pull/21571)
* \[[`eebcec7db5`](https://github.com/nodejs/node/commit/eebcec7db5)] - **win, build**: remove superfluous error message (Bartosz Sosnowski) [#22580](https://github.com/nodejs/node/pull/22580)
* \[[`041c779814`](https://github.com/nodejs/node/commit/041c779814)] - **win,build**: build N-API addons in parallel (Bartosz Sosnowski) [#22582](https://github.com/nodejs/node/pull/22582)
* \[[`1daa82a8fc`](https://github.com/nodejs/node/commit/1daa82a8fc)] - **worker**: display MessagePort status in util.inspect() (Anna Henningsen) [#22658](https://github.com/nodejs/node/pull/22658)
* \[[`887c43ffa7`](https://github.com/nodejs/node/commit/887c43ffa7)] - **worker**: remove redundant function call to `setupPortReferencing` (Ouyang Yadong) [#22298](https://github.com/nodejs/node/pull/22298)
* \[[`8e542eaf5f`](https://github.com/nodejs/node/commit/8e542eaf5f)] - **zlib**: fix memory leak for invalid input (Anna Henningsen) [#22713](https://github.com/nodejs/node/pull/22713)

<a id="10.9.0"></a>

## 2018-08-15, Version 10.9.0 (Current), @rvagg

This is a security release. All Node.js users should consult the security release summary at:

<https://nodejs.org/en/blog/vulnerability/august-2018-security-releases/>

for details on patched vulnerabilities.

Fixes for the following CVEs are included in this release:

* CVE-2018-0732 (OpenSSL)
* CVE-2018-7166 (Node.js)
* CVE-2018-12115 (Node.js)

### Notable Changes

* **buffer**:
  * Fix out-of-bounds (OOB) write in `Buffer.write()` for UCS-2 encoding (CVE-2018-12115)
  * Fix unintentional exposure of uninitialized memory in `Buffer.alloc()` (CVE-2018-7166)
* **deps**:
  * Upgrade to OpenSSL 1.1.0i, fixing:
    * Client DoS due to large DH parameter (CVE-2018-0732)
    * ECDSA key extraction via local side-channel (CVE not assigned)
  * Upgrade V8 from 6.7 to 6.8 (Michaël Zasso) [#21079](https://github.com/nodejs/node/pull/21079)
    * Memory reduction and performance improvements, details at: <https://v8project.blogspot.com/2018/06/v8-release-68.html>
* **http**: `http.get()` and `http.request()` (and `https` variants) can now accept three arguments to allow for a `URL` _and_ an `options` object (Sam Ruby) [#21616](https://github.com/nodejs/node/pull/21616)
* Added new collaborators
  * Sam Ruby (<https://github.com/rubys>)
  * George Adams (<https://github.com/gdams>)

### Commits

* \[[`58a9ae118e`](https://github.com/nodejs/node/commit/58a9ae118e)] - **assert**: fix loose assert with map and set (Ruben Bridgewater) [#22145](https://github.com/nodejs/node/pull/22145)
* \[[`1c577016b8`](https://github.com/nodejs/node/commit/1c577016b8)] - **benchmark**: improve assert benchmarks (Ruben Bridgewater) [#22211](https://github.com/nodejs/node/pull/22211)
* \[[`734323d9eb`](https://github.com/nodejs/node/commit/734323d9eb)] - **buffer**: stop alloc() uninitialized memory return (cjihrig) [nodejs-private/node-private#137](https://github.com/nodejs-private/node-private/pull/137)
* \[[`2c4c17b708`](https://github.com/nodejs/node/commit/2c4c17b708)] - **buffer**: avoid overrun on UCS-2 string write (Rod Vagg) [nodejs-private/node-private#138](https://github.com/nodejs-private/node-private/pull/138)
* \[[`6622ac798d`](https://github.com/nodejs/node/commit/6622ac798d)] - **buffer**: use FastBuffer when fill is set to 0 (Сковорода Никита Андреевич) [#21989](https://github.com/nodejs/node/pull/21989)
* \[[`f506a5f46e`](https://github.com/nodejs/node/commit/f506a5f46e)] - **build**: make --shared-\[...]-path work on Windows (Jeremy Apthorp) [#21530](https://github.com/nodejs/node/pull/21530)
* \[[`1be6fb93c8`](https://github.com/nodejs/node/commit/1be6fb93c8)] - **build**: add CONFIG\_FLAGS to with-code-cache target (Daniel Bevenius) [#22207](https://github.com/nodejs/node/pull/22207)
* \[[`4520bb8a73`](https://github.com/nodejs/node/commit/4520bb8a73)] - **build**: make tools/doc/node\_modules non-phony (Daniel Bevenius) [#22189](https://github.com/nodejs/node/pull/22189)
* \[[`c42ff4ebd8`](https://github.com/nodejs/node/commit/c42ff4ebd8)] - **build**: add crypto check to build targets (Daniel Bevenius) [#22148](https://github.com/nodejs/node/pull/22148)
* \[[`cdb8c1b44d`](https://github.com/nodejs/node/commit/cdb8c1b44d)] - **build**: extract common parts from addon .buildstamp (Daniel Bevenius) [#22171](https://github.com/nodejs/node/pull/22171)
* \[[`1e7a8c3016`](https://github.com/nodejs/node/commit/1e7a8c3016)] - **build**: reset embedder string to "-node.0" (Michaël Zasso) [#21079](https://github.com/nodejs/node/pull/21079)
* \[[`86ab2c041e`](https://github.com/nodejs/node/commit/86ab2c041e)] - **crypto**: remove unused SSLWrap handle methods (Jon Moss) [#22216](https://github.com/nodejs/node/pull/22216)
* \[[`9212875406`](https://github.com/nodejs/node/commit/9212875406)] - **crypto**: simplify state failure handling (Tobias Nießen) [#22131](https://github.com/nodejs/node/pull/22131)
* \[[`916a1d59f0`](https://github.com/nodejs/node/commit/916a1d59f0)] - **crypto**: simplify Hmac::HmacUpdate (Tobias Nießen) [#22132](https://github.com/nodejs/node/pull/22132)
* \[[`2dc7f17e8b`](https://github.com/nodejs/node/commit/2dc7f17e8b)] - **(SEMVER-MINOR)** **crypto**: add better scrypt option aliases (Anna Henningsen) [#21525](https://github.com/nodejs/node/pull/21525)
* \[[`fcf422e921`](https://github.com/nodejs/node/commit/fcf422e921)] - **deps**: backport c608122b from upstream (Ruben Bridgewater) [#22210](https://github.com/nodejs/node/pull/22210)
* \[[`a07ccaeb19`](https://github.com/nodejs/node/commit/a07ccaeb19)] - **deps**: update archs files for OpenSSL-1.1.0i (Shigeki Ohtsu) [#22318](https://github.com/nodejs/node/pull/22318)
* \[[`473996c90f`](https://github.com/nodejs/node/commit/473996c90f)] - **deps**: add s390 asm rules for OpenSSL-1.1.0 (Shigeki Ohtsu) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`05e48fd018`](https://github.com/nodejs/node/commit/05e48fd018)] - **deps**: upgrade openssl sources to 1.1.0i (Shigeki Ohtsu) [#22318](https://github.com/nodejs/node/pull/22318)
* \[[`f8bc5d6320`](https://github.com/nodejs/node/commit/f8bc5d6320)] - **deps**: cherry-pick 09bca09 from upstream V8 (Matheus Marchini) [#22068](https://github.com/nodejs/node/pull/22068)
* \[[`c69fdc9d5f`](https://github.com/nodejs/node/commit/c69fdc9d5f)] - **(SEMVER-MINOR)** **deps**: remove thread\_local to fix V8 compilation (Peter Marshall) [#21668](https://github.com/nodejs/node/pull/21668)
* \[[`981fff714e`](https://github.com/nodejs/node/commit/981fff714e)] - **deps**: refactor v8.gyp (Michaël Zasso) [#22017](https://github.com/nodejs/node/pull/22017)
* \[[`5fa3ffad20`](https://github.com/nodejs/node/commit/5fa3ffad20)] - **(SEMVER-MINOR)** **deps**: patch the V8 API to be backwards compatible with 6.7 (Peter Marshall) [#21668](https://github.com/nodejs/node/pull/21668)
* \[[`6eed40acbb`](https://github.com/nodejs/node/commit/6eed40acbb)] - **deps**: cherry-pick 804a693 from upstream V8 (Matheus Marchini) [#21855](https://github.com/nodejs/node/pull/21855)
* \[[`7eccaf86d6`](https://github.com/nodejs/node/commit/7eccaf86d6)] - **deps**: V8: Backport of 0dd3390 from upstream (James M Snell) [#21899](https://github.com/nodejs/node/pull/21899)
* \[[`328c89925a`](https://github.com/nodejs/node/commit/328c89925a)] - **deps**: cherry-pick 907d7bc from upstream V8 (Michaël Zasso) [#21838](https://github.com/nodejs/node/pull/21838)
* \[[`afacfd2992`](https://github.com/nodejs/node/commit/afacfd2992)] - **deps**: cherry-pick 2075910 from upstream V8 (Michaël Zasso) [#21838](https://github.com/nodejs/node/pull/21838)
* \[[`4f24256274`](https://github.com/nodejs/node/commit/4f24256274)] - **deps**: cherry-pick 555c811 from upstream V8 (Anna Henningsen) [#21741](https://github.com/nodejs/node/pull/21741)
* \[[`7b4272a14d`](https://github.com/nodejs/node/commit/7b4272a14d)] - **deps**: cherry-pick 477df06 from upstream v8 (Gus Caplan) [#21644](https://github.com/nodejs/node/pull/21644)
* \[[`a0bf7aa07c`](https://github.com/nodejs/node/commit/a0bf7aa07c)] - **deps**: cherry-pick 70c4340 from upstream V8 (Matheus Marchini) [#21126](https://github.com/nodejs/node/pull/21126)
* \[[`4994ac65b0`](https://github.com/nodejs/node/commit/4994ac65b0)] - **deps**: cherry-pick acc336c from upstream V8 (Matheus Marchini) [#21126](https://github.com/nodejs/node/pull/21126)
* \[[`be569f82f1`](https://github.com/nodejs/node/commit/be569f82f1)] - **deps**: cherry-pick b20faff from upstream V8 (Matheus Marchini) [#21126](https://github.com/nodejs/node/pull/21126)
* \[[`6df5feb13f`](https://github.com/nodejs/node/commit/6df5feb13f)] - **deps**: cherry-pick aa6ce3e from upstream V8 (Michaël Zasso) [#21079](https://github.com/nodejs/node/pull/21079)
* \[[`8b9a956f9e`](https://github.com/nodejs/node/commit/8b9a956f9e)] - **deps**: cherry-pick 5dd3395 from upstream V8 (Matheus Marchini) [#21386](https://github.com/nodejs/node/pull/21386)
* \[[`548008a6f6`](https://github.com/nodejs/node/commit/548008a6f6)] - **deps**: update v8.gyp and run Torque (Michaël Zasso) [#21079](https://github.com/nodejs/node/pull/21079)
* \[[`9c74271a96`](https://github.com/nodejs/node/commit/9c74271a96)] - **deps**: update V8 to 6.8.275.24 (Michaël Zasso) [#21079](https://github.com/nodejs/node/pull/21079)
* \[[`a3f3c40966`](https://github.com/nodejs/node/commit/a3f3c40966)] - **doc**: simplify urlObject.hash text (Rich Trott) [#22326](https://github.com/nodejs/node/pull/22326)
* \[[`d2848697dc`](https://github.com/nodejs/node/commit/d2848697dc)] - **doc**: simplify urlObject.hash description (Rich Trott) [#22326](https://github.com/nodejs/node/pull/22326)
* \[[`6d29986f4d`](https://github.com/nodejs/node/commit/6d29986f4d)] - **doc**: simplify format description of urlObject.auth (Rich Trott) [#22324](https://github.com/nodejs/node/pull/22324)
* \[[`a658a4df34`](https://github.com/nodejs/node/commit/a658a4df34)] - **doc**: remove redundant explanation of format (Rich Trott) [#22324](https://github.com/nodejs/node/pull/22324)
* \[[`3236697c0b`](https://github.com/nodejs/node/commit/3236697c0b)] - **doc**: use italics for words-as-words (Rich Trott) [#22324](https://github.com/nodejs/node/pull/22324)
* \[[`da76b61f59`](https://github.com/nodejs/node/commit/da76b61f59)] - **doc**: bump ICU version to avoid confusion (Csaba Palfi) [#22313](https://github.com/nodejs/node/pull/22313)
* \[[`e04b0532bf`](https://github.com/nodejs/node/commit/e04b0532bf)] - **doc**: document 'inherit' option for stdio (non-shorthand) (James Bromwell) [#22309](https://github.com/nodejs/node/pull/22309)
* \[[`882c2c017a`](https://github.com/nodejs/node/commit/882c2c017a)] - **doc**: clarify http2 docs around class exports (James M Snell) [#22247](https://github.com/nodejs/node/pull/22247)
* \[[`dd96ba5b89`](https://github.com/nodejs/node/commit/dd96ba5b89)] - **doc**: add multiple issue templates for GitHub (Tobias Nießen) [#22215](https://github.com/nodejs/node/pull/22215)
* \[[`d95a22c304`](https://github.com/nodejs/node/commit/d95a22c304)] - **doc**: declare all parameter types (Sam Ruby) [#21782](https://github.com/nodejs/node/pull/21782)
* \[[`9e25028981`](https://github.com/nodejs/node/commit/9e25028981)] - **doc**: add missing option for child\_process.spawnSync() (James Bromwell) [#22231](https://github.com/nodejs/node/pull/22231)
* \[[`ef8d0fc490`](https://github.com/nodejs/node/commit/ef8d0fc490)] - **doc**: list encodings supported by buffer.transcode (James M Snell) [#22263](https://github.com/nodejs/node/pull/22263)
* \[[`1b41cd44b5`](https://github.com/nodejs/node/commit/1b41cd44b5)] - **doc**: discuss special protocol handling (James M Snell) [#22261](https://github.com/nodejs/node/pull/22261)
* \[[`cea8d4f4e9`](https://github.com/nodejs/node/commit/cea8d4f4e9)] - **doc**: replace \_WG\_ with \_team\_ (Rich Trott) [#22183](https://github.com/nodejs/node/pull/22183)
* \[[`fafdae4ce1`](https://github.com/nodejs/node/commit/fafdae4ce1)] - **doc**: add subprocess.ref() and subprocess.unref() (Thomas Hunter II) [#22220](https://github.com/nodejs/node/pull/22220)
* \[[`d4f3615aaf`](https://github.com/nodejs/node/commit/d4f3615aaf)] - **doc**: add gdams to collaborators (George Adams) [#22236](https://github.com/nodejs/node/pull/22236)
* \[[`e75885f2e6`](https://github.com/nodejs/node/commit/e75885f2e6)] - **doc**: specify `options` parameter type in zlib.md (Vse Mozhet Byt) [#21920](https://github.com/nodejs/node/pull/21920)
* \[[`40af9767a2`](https://github.com/nodejs/node/commit/40af9767a2)] - **doc**: declare all parameter types (Sam Ruby) [#21782](https://github.com/nodejs/node/pull/21782)
* \[[`38dd407c83`](https://github.com/nodejs/node/commit/38dd407c83)] - **doc**: remove unused error codes from errors.md (Сковорода Никита Андреевич) [#21491](https://github.com/nodejs/node/pull/21491)
* \[[`6c7733f58a`](https://github.com/nodejs/node/commit/6c7733f58a)] - **doc**: update recommendations for createCipher (Tobias Nießen) [#22087](https://github.com/nodejs/node/pull/22087)
* \[[`34300aaaa4`](https://github.com/nodejs/node/commit/34300aaaa4)] - **doc**: correct crypto.randomFill() and randomFillSync() (Gerhard Stoebich) [#21550](https://github.com/nodejs/node/pull/21550)
* \[[`28870a46ac`](https://github.com/nodejs/node/commit/28870a46ac)] - **doc**: add rubys to collaborators (Sam Ruby) [#22109](https://github.com/nodejs/node/pull/22109)
* \[[`d2ad9a2c13`](https://github.com/nodejs/node/commit/d2ad9a2c13)] - **doc**: fix return type of server.address() (Weijia Wang) [#22043](https://github.com/nodejs/node/pull/22043)
* \[[`168abb5801`](https://github.com/nodejs/node/commit/168abb5801)] - **doc**: rename stackStartFunction in assert.md (Eugene Y. Q. Shen) [#22077](https://github.com/nodejs/node/pull/22077)
* \[[`d364f9c8e7`](https://github.com/nodejs/node/commit/d364f9c8e7)] - **doc**: fix changelog for v10.8.0 (Michaël Zasso) [#22072](https://github.com/nodejs/node/pull/22072)
* \[[`abac0c56b8`](https://github.com/nodejs/node/commit/abac0c56b8)] - **doc**: mark DEP0004 and DEP0042 as End-of-Life (Jon Moss) [#22033](https://github.com/nodejs/node/pull/22033)
* \[[`c6a56ae23e`](https://github.com/nodejs/node/commit/c6a56ae23e)] - **doc**: correct grammatical error in BUILDING.md (Brandon Lee) [#22067](https://github.com/nodejs/node/pull/22067)
* \[[`29bc55320c`](https://github.com/nodejs/node/commit/29bc55320c)] - **doc**: fixup process.binding deprecation code (James M Snell) [#22062](https://github.com/nodejs/node/pull/22062)
* \[[`ec9d529a32`](https://github.com/nodejs/node/commit/ec9d529a32)] - **doc**: documentation deprecation of process.binding (James M Snell) [#22004](https://github.com/nodejs/node/pull/22004)
* \[[`37369eba38`](https://github.com/nodejs/node/commit/37369eba38)] - **(SEMVER-MINOR)** **http**: allow url and options to be passed to http\*.request and http\*.get (Sam Ruby) [#21616](https://github.com/nodejs/node/pull/21616)
* \[[`1ca46ab6f4`](https://github.com/nodejs/node/commit/1ca46ab6f4)] - **http,tls**: name anonymous callbacks (Marco Levrero) [#21412](https://github.com/nodejs/node/pull/21412)
* \[[`8d226c6a79`](https://github.com/nodejs/node/commit/8d226c6a79)] - **http2**: correcting the heading format (Anto Aravinth) [#22262](https://github.com/nodejs/node/pull/22262)
* \[[`7223a91a50`](https://github.com/nodejs/node/commit/7223a91a50)] - **http2**: explicitly disallow nested push streams (James M Snell) [#22245](https://github.com/nodejs/node/pull/22245)
* \[[`cee78bf7a2`](https://github.com/nodejs/node/commit/cee78bf7a2)] - **http2**: avoid race condition in OnHeaderCallback (James M Snell) [#22256](https://github.com/nodejs/node/pull/22256)
* \[[`fcca2f7e49`](https://github.com/nodejs/node/commit/fcca2f7e49)] - **http2**: remove `streamError` from docs (James M Snell) [#22246](https://github.com/nodejs/node/pull/22246)
* \[[`2bf9a4a09e`](https://github.com/nodejs/node/commit/2bf9a4a09e)] - **https**: allow url and options to be passed to https.request (Sam Ruby) [#22003](https://github.com/nodejs/node/pull/22003)
* \[[`4c5dc6e012`](https://github.com/nodejs/node/commit/4c5dc6e012)] - **inspector**: tie objects lifetime to the thread they belong to (Eugene Ostroukhov) [#22242](https://github.com/nodejs/node/pull/22242)
* \[[`1afcea107e`](https://github.com/nodejs/node/commit/1afcea107e)] - **inspector**: unmark tests as flaky (Eugene Ostroukhov) [#22253](https://github.com/nodejs/node/pull/22253)
* \[[`39898695b6`](https://github.com/nodejs/node/commit/39898695b6)] - **inspector**: add inspector\_protocol as a direct dependency (Andrey Lushnikov) [#21975](https://github.com/nodejs/node/pull/21975)
* \[[`311ec12702`](https://github.com/nodejs/node/commit/311ec12702)] - **inspector**: fixed V8InspectorClient::currentTimeMS (Aleksey Kozyatinskiy) [#21917](https://github.com/nodejs/node/pull/21917)
* \[[`8f7e37337f`](https://github.com/nodejs/node/commit/8f7e37337f)] - **lib**: remove unused filterInternalStackFrames param (MaleDong) [#22267](https://github.com/nodejs/node/pull/22267)
* \[[`3f729aac20`](https://github.com/nodejs/node/commit/3f729aac20)] - **lib**: extract validateString validator (Jon Moss) [#22101](https://github.com/nodejs/node/pull/22101)
* \[[`f570c19c89`](https://github.com/nodejs/node/commit/f570c19c89)] - **perf\_hooks**: avoid memory leak on gc observer (James M Snell) [#22241](https://github.com/nodejs/node/pull/22241)
* \[[`76a65921d3`](https://github.com/nodejs/node/commit/76a65921d3)] - **readline,zlib**: named anonymous functions (Anto Aravinth) [#21792](https://github.com/nodejs/node/pull/21792)
* \[[`e4f346892c`](https://github.com/nodejs/node/commit/e4f346892c)] - **repl**: support mult-line string-keyed objects (Sam Ruby) [#21805](https://github.com/nodejs/node/pull/21805)
* \[[`d0b0ea971a`](https://github.com/nodejs/node/commit/d0b0ea971a)] - **src**: remove unnecessary writes in tls\_wrap.cc (Anna Henningsen) [#21984](https://github.com/nodejs/node/pull/21984)
* \[[`b2ac7a750f`](https://github.com/nodejs/node/commit/b2ac7a750f)] - **src**: avoid possible race during NodeBIO initialization (Anna Henningsen) [#21984](https://github.com/nodejs/node/pull/21984)
* \[[`d85b0a3c10`](https://github.com/nodejs/node/commit/d85b0a3c10)] - **src**: use smart pointers for NodeBIO (Anna Henningsen) [#21984](https://github.com/nodejs/node/pull/21984)
* \[[`82e71dd8bd`](https://github.com/nodejs/node/commit/82e71dd8bd)] - **src**: fix integer overflow in GetNow (Anatoli Papirovski) [#22214](https://github.com/nodejs/node/pull/22214)
* \[[`2737b46e16`](https://github.com/nodejs/node/commit/2737b46e16)] - **src**: add READONLY\_STRING\_PROPERTY and simplify config (Jon Moss) [#22222](https://github.com/nodejs/node/pull/22222)
* \[[`8b5485dcf5`](https://github.com/nodejs/node/commit/8b5485dcf5)] - **src**: fix up doc comment for experimental-worker bool (Anna Henningsen) [#22165](https://github.com/nodejs/node/pull/22165)
* \[[`e90e56f4ca`](https://github.com/nodejs/node/commit/e90e56f4ca)] - **src**: remove calls to deprecated v8 functions (NumberValue) (Ujjwal Sharma) [#22094](https://github.com/nodejs/node/pull/22094)
* \[[`c09872b749`](https://github.com/nodejs/node/commit/c09872b749)] - **src**: remove unused env->vm\_parsing\_context\_symbol (Jon Moss) [#22034](https://github.com/nodejs/node/pull/22034)
* \[[`6ca00d7044`](https://github.com/nodejs/node/commit/6ca00d7044)] - **src**: remove unused env strings (Jon Moss) [#22137](https://github.com/nodejs/node/pull/22137)
* \[[`0ca831a0ed`](https://github.com/nodejs/node/commit/0ca831a0ed)] - **src**: clean up PackageConfig pseudo-boolean fields (Anna Henningsen) [#21987](https://github.com/nodejs/node/pull/21987)
* \[[`00c33a5131`](https://github.com/nodejs/node/commit/00c33a5131)] - **src**: clean up agent loop when exiting through destructor (Anna Henningsen) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`ba480d33ce`](https://github.com/nodejs/node/commit/ba480d33ce)] - **src**: use only one tracing write fs req at a time (Anna Henningsen) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`6b58746b2e`](https://github.com/nodejs/node/commit/6b58746b2e)] - **src**: use unique\_ptr for internal JSON trace writer (Anna Henningsen) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`ce48936077`](https://github.com/nodejs/node/commit/ce48936077)] - **src**: plug trace file file descriptor leak (Anna Henningsen) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`89e23021fb`](https://github.com/nodejs/node/commit/89e23021fb)] - **src**: initialize file trace writer on tracing thread (Anna Henningsen) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`56edd5fc5b`](https://github.com/nodejs/node/commit/56edd5fc5b)] - **src**: close tracing event loop (Anna Henningsen) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`4c9c1bbc45`](https://github.com/nodejs/node/commit/4c9c1bbc45)] - **src**: fix tracing if cwd or file path is inaccessible (Anna Henningsen) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`c101b396aa`](https://github.com/nodejs/node/commit/c101b396aa)] - **src**: refactor default trace writer out of agent (Anna Henningsen) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`daafe6c195`](https://github.com/nodejs/node/commit/daafe6c195)] - **src**: refactor tracing agent code (Anna Henningsen) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`4379140dbf`](https://github.com/nodejs/node/commit/4379140dbf)] - **src**: minor refactor of node\_trace\_events.cc (Anna Henningsen) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`cde0e5f396`](https://github.com/nodejs/node/commit/cde0e5f396)] - **src**: reduce unnecessary includes (Anna Henningsen) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`31e3e6f1f8`](https://github.com/nodejs/node/commit/31e3e6f1f8)] - **stream**: fix readable behavior for highWaterMark === 0 (Denys Otrishko) [#21690](https://github.com/nodejs/node/pull/21690)
* \[[`9d89b3c7ec`](https://github.com/nodejs/node/commit/9d89b3c7ec)] - **test**: rename some allegories (Vse Mozhet Byt) [#22307](https://github.com/nodejs/node/pull/22307)
* \[[`1d15f33277`](https://github.com/nodejs/node/commit/1d15f33277)] - **test**: call gc() explicitly to avoid OOM (Refael Ackermann) [#22301](https://github.com/nodejs/node/pull/22301)
* \[[`a7dad4565b`](https://github.com/nodejs/node/commit/a7dad4565b)] - **test**: move test-http-client-timeout-option-with-agent to sequential (Ouyang Yadong) [#22083](https://github.com/nodejs/node/pull/22083)
* \[[`a414b0757a`](https://github.com/nodejs/node/commit/a414b0757a)] - **test**: add test-http2-large-file sequential test (James M Snell) [#22254](https://github.com/nodejs/node/pull/22254)
* \[[`01fe2cee5b`](https://github.com/nodejs/node/commit/01fe2cee5b)] - **test**: fix error messages for OpenSSL-1.1.0i (Shigeki Ohtsu) [#22318](https://github.com/nodejs/node/pull/22318)
* \[[`c145690aad`](https://github.com/nodejs/node/commit/c145690aad)] - **test**: improve test coverage for comparisons (Ruben Bridgewater) [#22212](https://github.com/nodejs/node/pull/22212)
* \[[`bdc644f2ec`](https://github.com/nodejs/node/commit/bdc644f2ec)] - **test**: remove common.fileExists() (Rich Trott) [#22151](https://github.com/nodejs/node/pull/22151)
* \[[`bc1cb7b7fc`](https://github.com/nodejs/node/commit/bc1cb7b7fc)] - **test**: handle errors correctly in GC http test (Ouyang Yadong) [#22185](https://github.com/nodejs/node/pull/22185)
* \[[`cefc4a03cc`](https://github.com/nodejs/node/commit/cefc4a03cc)] - **test**: remove second arg from assert.ifError() (Musa Hamwala) [#22190](https://github.com/nodejs/node/pull/22190)
* \[[`b1cbbbc7af`](https://github.com/nodejs/node/commit/b1cbbbc7af)] - **test**: move require of https to after crypto check (Daniel Bevenius) [#22148](https://github.com/nodejs/node/pull/22148)
* \[[`a6ab19a96a`](https://github.com/nodejs/node/commit/a6ab19a96a)] - **test**: move require of http2 to after crypto check (Daniel Bevenius) [#22148](https://github.com/nodejs/node/pull/22148)
* \[[`7a4c7e6c82`](https://github.com/nodejs/node/commit/7a4c7e6c82)] - **test**: don't mask descriptor.enumerable (Thomas Leah) [#22172](https://github.com/nodejs/node/pull/22172)
* \[[`5018661a85`](https://github.com/nodejs/node/commit/5018661a85)] - **test**: remove common.fileExists() (Richard Lau) [#22200](https://github.com/nodejs/node/pull/22200)
* \[[`77ce40fa03`](https://github.com/nodejs/node/commit/77ce40fa03)] - **test**: remove unused argument in assertion (yahavfuchs) [#22113](https://github.com/nodejs/node/pull/22113)
* \[[`ca0fb3acce`](https://github.com/nodejs/node/commit/ca0fb3acce)] - **test**: check arg type for dnsPromises.resolve (Masashi Hirano) [#22000](https://github.com/nodejs/node/pull/22000)
* \[[`6daa4f8797`](https://github.com/nodejs/node/commit/6daa4f8797)] - **test**: update postmortem metadata test (cjihrig) [#21079](https://github.com/nodejs/node/pull/21079)
* \[[`16a929b867`](https://github.com/nodejs/node/commit/16a929b867)] - **test**: fix scriptParsed event expectations (Ingvar Stepanyan) [#21079](https://github.com/nodejs/node/pull/21079)
* \[[`e58c17b849`](https://github.com/nodejs/node/commit/e58c17b849)] - **test**: update certificates and private keys (Fedor Indutny) [#22184](https://github.com/nodejs/node/pull/22184)
* \[[`d38ccaa421`](https://github.com/nodejs/node/commit/d38ccaa421)] - **test**: fix n-api addon build warnings (Kyle Farnung) [#21808](https://github.com/nodejs/node/pull/21808)
* \[[`d66e52fb8e`](https://github.com/nodejs/node/commit/d66e52fb8e)] - **test**: run ESM tests in parallel (Michaël Zasso) [#21919](https://github.com/nodejs/node/pull/21919)
* \[[`6cff57e98d`](https://github.com/nodejs/node/commit/6cff57e98d)] - **test**: fix incorrect file mode check (Timothy Gu) [#22023](https://github.com/nodejs/node/pull/22023)
* \[[`dafaff3a5e`](https://github.com/nodejs/node/commit/dafaff3a5e)] - **test**: remove unused config (Benjamin Gruenbaum) [#21985](https://github.com/nodejs/node/pull/21985)
* \[[`a569ae4b44`](https://github.com/nodejs/node/commit/a569ae4b44)] - **test**: remove third argument from assert.strictEqual() (Rishabh Singh) [#22051](https://github.com/nodejs/node/pull/22051)
* \[[`a60060b499`](https://github.com/nodejs/node/commit/a60060b499)] - **test**: remove third argument from call to assert.strictEqual() (Michael Sommer) [#22047](https://github.com/nodejs/node/pull/22047)
* \[[`246a94f301`](https://github.com/nodejs/node/commit/246a94f301)] - **test**: see value of "hadError" in tls test (Oryan Moshe) [#22069](https://github.com/nodejs/node/pull/22069)
* \[[`a40ee213b3`](https://github.com/nodejs/node/commit/a40ee213b3)] - **test**: improve reliability in http2-session-timeout (Rich Trott) [#22026](https://github.com/nodejs/node/pull/22026)
* \[[`e2d97eeb65`](https://github.com/nodejs/node/commit/e2d97eeb65)] - **test**: remove outdated documentation (Jon Moss) [#22009](https://github.com/nodejs/node/pull/22009)
* \[[`94746d6a47`](https://github.com/nodejs/node/commit/94746d6a47)] - **test**: remove outdated, non-functioning test (Anatoli Papirovski) [#20894](https://github.com/nodejs/node/pull/20894)
* \[[`0beffc0f3b`](https://github.com/nodejs/node/commit/0beffc0f3b)] - **test**: remove test/gc, integrate into parallel (Anna Henningsen) [#22001](https://github.com/nodejs/node/pull/22001)
* \[[`c2372eac16`](https://github.com/nodejs/node/commit/c2372eac16)] - **test**: add tracing crash regression test (Eugene Ostroukhov) [#21867](https://github.com/nodejs/node/pull/21867)
* \[[`7e23080d45`](https://github.com/nodejs/node/commit/7e23080d45)] - **test**: pass through stderr in benchmark tests (Anna Henningsen) [#21860](https://github.com/nodejs/node/pull/21860)
* \[[`52020dc09a`](https://github.com/nodejs/node/commit/52020dc09a)] - **test**: refactor test-http2-compat-serverresponse-finished.js (Anto Aravinth) [#21929](https://github.com/nodejs/node/pull/21929)
* \[[`88665b3cef`](https://github.com/nodejs/node/commit/88665b3cef)] - **test,doc**: fix async-hooks coverage doc for md lint (Rod Vagg) [#22296](https://github.com/nodejs/node/pull/22296)
* \[[`d60b017135`](https://github.com/nodejs/node/commit/d60b017135)] - **test,doc**: adjust markdown table for linting (Rich Trott) [#22221](https://github.com/nodejs/node/pull/22221)
* \[[`8f56cc0321`](https://github.com/nodejs/node/commit/8f56cc0321)] - **test,doc**: adjust async-hooks coverage doc for lint (Rich Trott) [#22221](https://github.com/nodejs/node/pull/22221)
* \[[`5c41caa1cc`](https://github.com/nodejs/node/commit/5c41caa1cc)] - **test,doc**: wrap common module md doc at 80 chars (Rich Trott) [#22221](https://github.com/nodejs/node/pull/22221)
* \[[`21883be05d`](https://github.com/nodejs/node/commit/21883be05d)] - **test,doc**: fix lint error in test fixtures (Rich Trott) [#22221](https://github.com/nodejs/node/pull/22221)
* \[[`ec2209dc8b`](https://github.com/nodejs/node/commit/ec2209dc8b)] - **tls**: change var to const (Eugen Cazacu) [#22219](https://github.com/nodejs/node/pull/22219)
* \[[`2d1c1853e9`](https://github.com/nodejs/node/commit/2d1c1853e9)] - **tls**: remove SLAB\_BUFFER\_SIZE (Anatoli Papirovski) [#21199](https://github.com/nodejs/node/pull/21199)
* \[[`f989681e34`](https://github.com/nodejs/node/commit/f989681e34)] - **tls**: preallocate SSL cipher array (Tobias Nießen) [#22136](https://github.com/nodejs/node/pull/22136)
* \[[`6cd2d1dddc`](https://github.com/nodejs/node/commit/6cd2d1dddc)] - **tools**: fix header escaping regression (Sam Ruby) [#22084](https://github.com/nodejs/node/pull/22084)
* \[[`80dd0445c6`](https://github.com/nodejs/node/commit/80dd0445c6)] - **tools**: add no-misleading-character-class ESLint rule (Vse Mozhet Byt) [#22278](https://github.com/nodejs/node/pull/22278)
* \[[`bc35f17b7b`](https://github.com/nodejs/node/commit/bc35f17b7b)] - **tools**: do not autolink section to itself (Vse Mozhet Byt) [#22138](https://github.com/nodejs/node/pull/22138)
* \[[`950a4a9b91`](https://github.com/nodejs/node/commit/950a4a9b91)] - **tools**: update ESLint to 5.3.0 (Rich Trott) [#22134](https://github.com/nodejs/node/pull/22134)
* \[[`0c67d326dc`](https://github.com/nodejs/node/commit/0c67d326dc)] - **tools**: convert addon-verify to remark (Sam Ruby) [#21978](https://github.com/nodejs/node/pull/21978)
* \[[`c85d00b786`](https://github.com/nodejs/node/commit/c85d00b786)] - **tools**: produce JSON documentation using unified/remark/rehype (Sam Ruby) [#21697](https://github.com/nodejs/node/pull/21697)
* \[[`f0c871b0c7`](https://github.com/nodejs/node/commit/f0c871b0c7)] - **tools**: add `make format-cpp` to run clang-format on C++ diffs (Joyee Cheung) [#21997](https://github.com/nodejs/node/pull/21997)
* \[[`5a4abbadfe`](https://github.com/nodejs/node/commit/5a4abbadfe)] - **tools**: update to using dmn 1.0.11 (Rich Trott) [#22035](https://github.com/nodejs/node/pull/22035)
* \[[`7a7c194f4e`](https://github.com/nodejs/node/commit/7a7c194f4e)] - **tools**: fix docs and run known\_issues by default (Jon Moss) [#21910](https://github.com/nodejs/node/pull/21910)
* \[[`4995b28a11`](https://github.com/nodejs/node/commit/4995b28a11)] - **tools,build**: apply markdown linting to test dir (Rich Trott) [#22221](https://github.com/nodejs/node/pull/22221)
* \[[`ad46cca104`](https://github.com/nodejs/node/commit/ad46cca104)] - **trace\_events**: add node.promises category, rejection counter (James M Snell) [#22124](https://github.com/nodejs/node/pull/22124)
* \[[`b171fa2530`](https://github.com/nodejs/node/commit/b171fa2530)] - **util**: improve display of iterators and weak entries (Ruben Bridgewater) [#20961](https://github.com/nodejs/node/pull/20961)
* \[[`f1c22eaa56`](https://github.com/nodejs/node/commit/f1c22eaa56)] - **util,assert**: fix boxed primitives bug (Ruben Bridgewater) [#22243](https://github.com/nodejs/node/pull/22243)
* \[[`677d10cdd1`](https://github.com/nodejs/node/commit/677d10cdd1)] - **worker**: fix deadlock when calling terminate from exit handler (Anna Henningsen) [#22073](https://github.com/nodejs/node/pull/22073)
* \[[`4b0d2de5f4`](https://github.com/nodejs/node/commit/4b0d2de5f4)] - **zlib**: remove unused parameters (MaleDong) [#22115](https://github.com/nodejs/node/pull/22115)

<a id="10.8.0"></a>

## 2018-08-01, Version 10.8.0 (Current), @targos

### Notable Changes

* **deps**:
  * Upgrade npm to 6.2.0. [#21592](https://github.com/nodejs/node/pull/21592)
    * npm has moved. This release updates various URLs to point to the right
      places for bugs, support, and PRs.
    * Fix the regular expression matching in `xcode_emulation` in `node-gyp` to
      also handle version numbers with multiple-digit major versions which would
      otherwise break under use of XCode 10.
    * The npm tree has been _significantly_ flattened. Tarball size for the npm
      package has gone from 8MB to 4.8MB.
    * Changelogs:
      [6.2.0-next.0](https://github.com/npm/npm/releases/tag/v6.2.0-next.0),
      [6.2.0-next.1](https://github.com/npm/npm/releases/tag/v6.2.0-next.1),
      [6.2.0](https://github.com/npm/cli/releases/tag/v6.2.0).

### Commits

* \[[`335575e49b`](https://github.com/nodejs/node/commit/335575e49b)] - **benchmark**: remove arrays benchmark (Peter Marshall) [#21831](https://github.com/nodejs/node/pull/21831)
* \[[`62024b651e`](https://github.com/nodejs/node/commit/62024b651e)] - **build**: create V8 code cache after script is run (Joyee Cheung) [#21567](https://github.com/nodejs/node/pull/21567)
* \[[`50ccda2a00`](https://github.com/nodejs/node/commit/50ccda2a00)] - **build**: increase macOS minimum supported version (Michaël Zasso) [#21883](https://github.com/nodejs/node/pull/21883)
* \[[`5e1ceaabaa`](https://github.com/nodejs/node/commit/5e1ceaabaa)] - **build**: remove redundant Makefile target (Rich Trott) [#21915](https://github.com/nodejs/node/pull/21915)
* \[[`4f00562ef0`](https://github.com/nodejs/node/commit/4f00562ef0)] - **build**: add new benchmark targets (Kenny Yuan) [#20905](https://github.com/nodejs/node/pull/20905)
* \[[`4c5fc5c7ce`](https://github.com/nodejs/node/commit/4c5fc5c7ce)] - **build**: move to `npm ci` where possible (Rich Trott) [#21802](https://github.com/nodejs/node/pull/21802)
* \[[`e0f3d5703a`](https://github.com/nodejs/node/commit/e0f3d5703a)] - **build,win,v8**: allow precompiling objects-inl.h (João Reis) [#21772](https://github.com/nodejs/node/pull/21772)
* \[[`87ed6e6351`](https://github.com/nodejs/node/commit/87ed6e6351)] - **(SEMVER-MINOR)** **deps**: upgrade npm to 6.2.0 (Kat Marchán) [#21592](https://github.com/nodejs/node/pull/21592)
* \[[`f868415cf6`](https://github.com/nodejs/node/commit/f868415cf6)] - **deps**: cherry-pick 804a693 from upstream V8 (Matheus Marchini) [#21855](https://github.com/nodejs/node/pull/21855)
* \[[`b56c8ad879`](https://github.com/nodejs/node/commit/b56c8ad879)] - **deps**: V8: Backport of 0dd3390 from upstream (James M Snell) [#21899](https://github.com/nodejs/node/pull/21899)
* \[[`ec0ff7008a`](https://github.com/nodejs/node/commit/ec0ff7008a)] - **deps**: cherry-pick 907d7bc from upstream V8 (Michaël Zasso) [#21838](https://github.com/nodejs/node/pull/21838)
* \[[`c23e8b51ea`](https://github.com/nodejs/node/commit/c23e8b51ea)] - **deps**: cherry-pick 2075910 from upstream V8 (Michaël Zasso) [#21838](https://github.com/nodejs/node/pull/21838)
* \[[`40fedd3620`](https://github.com/nodejs/node/commit/40fedd3620)] - **dgram**: add getters/setters for private APIs (cjihrig) [#21923](https://github.com/nodejs/node/pull/21923)
* \[[`98ef8cfb8e`](https://github.com/nodejs/node/commit/98ef8cfb8e)] - **dgram**: make \_createSocketHandle() internal only (cjihrig) [#21923](https://github.com/nodejs/node/pull/21923)
* \[[`ae17d18013`](https://github.com/nodejs/node/commit/ae17d18013)] - **dgram**: hide underscored Socket properties (cjihrig) [#21923](https://github.com/nodejs/node/pull/21923)
* \[[`b5b74382e0`](https://github.com/nodejs/node/commit/b5b74382e0)] - **dgram**: hide \_healthCheck() and \_stopReceiving() (cjihrig) [#21923](https://github.com/nodejs/node/pull/21923)
* \[[`b5ae33959b`](https://github.com/nodejs/node/commit/b5ae33959b)] - **doc**: add pronouns to readme (Teddy Katz) [#22036](https://github.com/nodejs/node/pull/22036)
* \[[`f4b6031e39`](https://github.com/nodejs/node/commit/f4b6031e39)] - **doc**: clarify text about internal module changes (MaleDong) [#22024](https://github.com/nodejs/node/pull/22024)
* \[[`1f9570bd10`](https://github.com/nodejs/node/commit/1f9570bd10)] - **doc**: add missing worker error (Benjamin Gruenbaum) [#21947](https://github.com/nodejs/node/pull/21947)
* \[[`67d7a15886`](https://github.com/nodejs/node/commit/67d7a15886)] - **doc**: fix typo in releases.md (Vitor Bruno de Oliveira Barth) [#21990](https://github.com/nodejs/node/pull/21990)
* \[[`2a0fa4792e`](https://github.com/nodejs/node/commit/2a0fa4792e)] - **doc**: do not advise to cancel full CI on onboarding (Vse Mozhet Byt) [#21977](https://github.com/nodejs/node/pull/21977)
* \[[`478dbee8fe`](https://github.com/nodejs/node/commit/478dbee8fe)] - **doc**: replace deprecated CI job (Vse Mozhet Byt) [#21938](https://github.com/nodejs/node/pull/21938)
* \[[`5b0c451e61`](https://github.com/nodejs/node/commit/5b0c451e61)] - **doc**: add guide for updating N-API API surface (Hitesh Kanwathirtha) [#21877](https://github.com/nodejs/node/pull/21877)
* \[[`96bb6052e9`](https://github.com/nodejs/node/commit/96bb6052e9)] - **doc**: add node-test-commit-custom-suites to docs (Rich Trott) [#21927](https://github.com/nodejs/node/pull/21927)
* \[[`c44df51249`](https://github.com/nodejs/node/commit/c44df51249)] - **doc**: link n-api module init to multi-load addons (Gabriel Schulhof) [#21891](https://github.com/nodejs/node/pull/21891)
* \[[`c3d9000111`](https://github.com/nodejs/node/commit/c3d9000111)] - **doc**: document http2 network error behaviour (Anna Henningsen) [#21861](https://github.com/nodejs/node/pull/21861)
* \[[`e8d5787840`](https://github.com/nodejs/node/commit/e8d5787840)] - **doc**: document MODULE\_NOT\_FOUND error (Jacob Page) [#21894](https://github.com/nodejs/node/pull/21894)
* \[[`5e562fd792`](https://github.com/nodejs/node/commit/5e562fd792)] - **doc**: fix sorting in the `vm.Module` section (Vse Mozhet Byt) [#21931](https://github.com/nodejs/node/pull/21931)
* \[[`eabe907e03`](https://github.com/nodejs/node/commit/eabe907e03)] - **doc**: fix descriptions of sync methods in fs.md (Tim Ruffles) [#21747](https://github.com/nodejs/node/pull/21747)
* \[[`bd352f0298`](https://github.com/nodejs/node/commit/bd352f0298)] - **doc**: update and improve the release guide (Michaël Zasso) [#21868](https://github.com/nodejs/node/pull/21868)
* \[[`fd5a0c7a1f`](https://github.com/nodejs/node/commit/fd5a0c7a1f)] - **doc**: fix incorrect method name (Anto Aravinth) [#21908](https://github.com/nodejs/node/pull/21908)
* \[[`af1530e06d`](https://github.com/nodejs/node/commit/af1530e06d)] - **doc**: add cjihrig pronouns (cjihrig) [#21901](https://github.com/nodejs/node/pull/21901)
* \[[`4d78a21d8c`](https://github.com/nodejs/node/commit/4d78a21d8c)] - **doc**: add missing `require` to example in http2.md (Kevin Simper) [#21858](https://github.com/nodejs/node/pull/21858)
* \[[`ab0da57150`](https://github.com/nodejs/node/commit/ab0da57150)] - **doc**: make minor improvements to collab guide (Rich Trott) [#21862](https://github.com/nodejs/node/pull/21862)
* \[[`b510cdc756`](https://github.com/nodejs/node/commit/b510cdc756)] - **doc**: fix worker example to receive message (Sakthipriyan Vairamani (thefourtheye)) [#21486](https://github.com/nodejs/node/pull/21486)
* \[[`d91742aa9a`](https://github.com/nodejs/node/commit/d91742aa9a)] - **fs**: reduce memory retention when streaming small files (Anna Henningsen) [#21968](https://github.com/nodejs/node/pull/21968)
* \[[`484140e223`](https://github.com/nodejs/node/commit/484140e223)] - **fs**: stop lazy loading stream constructors (Michaël Zasso) [#21776](https://github.com/nodejs/node/pull/21776)
* \[[`8799f43fb0`](https://github.com/nodejs/node/commit/8799f43fb0)] - **http**: revert "http: always emit close on req and res" (Michaël Zasso) [#21809](https://github.com/nodejs/node/pull/21809)
* \[[`a5928712c9`](https://github.com/nodejs/node/commit/a5928712c9)] - **http**: name anonymous function in \_http\_common.js (Petras) [#21755](https://github.com/nodejs/node/pull/21755)
* \[[`337b2df82f`](https://github.com/nodejs/node/commit/337b2df82f)] - **http2**: release request()'s "connect" event listener after it runs (James Ide) [#21916](https://github.com/nodejs/node/pull/21916)
* \[[`1e15581823`](https://github.com/nodejs/node/commit/1e15581823)] - **http2**: remove unused nghttp2 error list (Anna Henningsen) [#21827](https://github.com/nodejs/node/pull/21827)
* \[[`baf3027c77`](https://github.com/nodejs/node/commit/baf3027c77)] - **lib**: remove usc-2 encoding (Brian White) [#21964](https://github.com/nodejs/node/pull/21964)
* \[[`9817e405ee`](https://github.com/nodejs/node/commit/9817e405ee)] - **(SEMVER-MINOR)** **lib,src**: replace all C++ promises with JS promises (Ruben Bridgewater) [#20830](https://github.com/nodejs/node/pull/20830)
* \[[`45816c50ac`](https://github.com/nodejs/node/commit/45816c50ac)] - **n-api**: guard against cond null dereference (Gabriel Schulhof) [#21871](https://github.com/nodejs/node/pull/21871)
* \[[`2548f75a92`](https://github.com/nodejs/node/commit/2548f75a92)] - **src**: use UTF-8 for naming interfaces in unix (Ujjwal Sharma) [#21926](https://github.com/nodejs/node/pull/21926)
* \[[`6b6a26bb8d`](https://github.com/nodejs/node/commit/6b6a26bb8d)] - **src**: use kInternalized instead of kNormal (Ujjwal Sharma) [#21926](https://github.com/nodejs/node/pull/21926)
* \[[`2c95b96e8e`](https://github.com/nodejs/node/commit/2c95b96e8e)] - **src**: remove calls to deprecated v8 functions (NewFromUtf8) (Ujjwal Sharma) [#21926](https://github.com/nodejs/node/pull/21926)
* \[[`e0336b2891`](https://github.com/nodejs/node/commit/e0336b2891)] - **src**: fix may be uninitialized warning in n-api (Michael Dawson) [#21898](https://github.com/nodejs/node/pull/21898)
* \[[`2f3a28dbf2`](https://github.com/nodejs/node/commit/2f3a28dbf2)] - **src**: use available ReqWrap instance for libuv req (Jon Moss) [#21980](https://github.com/nodejs/node/pull/21980)
* \[[`80b5c914bb`](https://github.com/nodejs/node/commit/80b5c914bb)] - **src**: add proper MemoryInfoName to wrappers (Joyee Cheung) [#21939](https://github.com/nodejs/node/pull/21939)
* \[[`f6606bf9e4`](https://github.com/nodejs/node/commit/f6606bf9e4)] - **src**: add missing cmath include to traced\_value.cc (Anna Henningsen) [#21924](https://github.com/nodejs/node/pull/21924)
* \[[`be75795868`](https://github.com/nodejs/node/commit/be75795868)] - **src**: don't store one-use strings in variable (Jon Moss) [#21876](https://github.com/nodejs/node/pull/21876)
* \[[`d9cd171a6b`](https://github.com/nodejs/node/commit/d9cd171a6b)] - **src**: remove unnecessary else (Jon Moss) [#21874](https://github.com/nodejs/node/pull/21874)
* \[[`4f8620e2b7`](https://github.com/nodejs/node/commit/4f8620e2b7)] - **src**: fix formatting of PIDs (Tobias Nießen) [#21852](https://github.com/nodejs/node/pull/21852)
* \[[`d0f8af021f`](https://github.com/nodejs/node/commit/d0f8af021f)] - **src**: use offset calc. instead of `req->data` in node\_file (Anna Henningsen) [#21839](https://github.com/nodejs/node/pull/21839)
* \[[`41ff1bb9c7`](https://github.com/nodejs/node/commit/41ff1bb9c7)] - **src**: prepare for V8 Swallowed Rejection Hook (Benedikt Meurer) [#21838](https://github.com/nodejs/node/pull/21838)
* \[[`c45623a548`](https://github.com/nodejs/node/commit/c45623a548)] - **src**: avoid unnecessarily formatting a warning (Tobias Nießen) [#21832](https://github.com/nodejs/node/pull/21832)
* \[[`6af4f1f515`](https://github.com/nodejs/node/commit/6af4f1f515)] - **stream**: name anonymous function in \_stream\_writable.js (mariotsi) [#21753](https://github.com/nodejs/node/pull/21753)
* \[[`d0c16f4b2a`](https://github.com/nodejs/node/commit/d0c16f4b2a)] - **stream**: named anonymous functions in \_stream\_readable.js (Simionescu, Radu) [#21750](https://github.com/nodejs/node/pull/21750)
* \[[`3d05d82353`](https://github.com/nodejs/node/commit/3d05d82353)] - **test**: improve assertions in child-process-execsync (bhavayAnand9) [#22016](https://github.com/nodejs/node/pull/22016)
* \[[`62fd84528e`](https://github.com/nodejs/node/commit/62fd84528e)] - **test**: improve inspect readability (Ruben Bridgewater) [#21624](https://github.com/nodejs/node/pull/21624)
* \[[`fe1823dc21`](https://github.com/nodejs/node/commit/fe1823dc21)] - **test**: remove custom AsyncHooksTestConfiguration (Jon Moss) [#22008](https://github.com/nodejs/node/pull/22008)
* \[[`4510ca349e`](https://github.com/nodejs/node/commit/4510ca349e)] - **test**: add tests for fs/promises chown functions (shisama) [#20574](https://github.com/nodejs/node/pull/20574)
* \[[`61ae592c4f`](https://github.com/nodejs/node/commit/61ae592c4f)] - **test**: remove setTimeout in test-net-connect-unref (conectado) [#21969](https://github.com/nodejs/node/pull/21969)
* \[[`4958501ac0`](https://github.com/nodejs/node/commit/4958501ac0)] - **test**: remove timeout from test-pipe-stream (Anna Henningsen) [#21837](https://github.com/nodejs/node/pull/21837)
* \[[`af6b82469d`](https://github.com/nodejs/node/commit/af6b82469d)] - **test**: fix unreliable test-fs-stat-bigint (sagulati) [#21949](https://github.com/nodejs/node/pull/21949)
* \[[`793a5bb4af`](https://github.com/nodejs/node/commit/793a5bb4af)] - **test**: don't fail http2 abort test if 'data' is called multiple times (Sam Ruby) [#21925](https://github.com/nodejs/node/pull/21925)
* \[[`623ef4961b`](https://github.com/nodejs/node/commit/623ef4961b)] - **test**: address flaky worker test (Rich Trott) [#21893](https://github.com/nodejs/node/pull/21893)
* \[[`3213c09e3a`](https://github.com/nodejs/node/commit/3213c09e3a)] - **test**: provide better message for orphan output documentation (Sam Ruby) [#21913](https://github.com/nodejs/node/pull/21913)
* \[[`eea199bf98`](https://github.com/nodejs/node/commit/eea199bf98)] - **test**: fix http2 connection abort test (Anna Henningsen) [#21861](https://github.com/nodejs/node/pull/21861)
* \[[`bea1ee8e8e`](https://github.com/nodejs/node/commit/bea1ee8e8e)] - **test**: make crashOnUnhandleRejection opt-out (Michaël Zasso) [#21849](https://github.com/nodejs/node/pull/21849)
* \[[`81915632e4`](https://github.com/nodejs/node/commit/81915632e4)] - **test**: allow tests to pass without internet (Helio Frota) [#21909](https://github.com/nodejs/node/pull/21909)
* \[[`46d14fc0e8`](https://github.com/nodejs/node/commit/46d14fc0e8)] - **test**: refactor cluster-net-listen-relative-path (Rich Trott) [#21863](https://github.com/nodejs/node/pull/21863)
* \[[`756dff498a`](https://github.com/nodejs/node/commit/756dff498a)] - **test**: refactor test-module-loading assertions (Bruno Pinho) [#21833](https://github.com/nodejs/node/pull/21833)
* \[[`292aa42bd1`](https://github.com/nodejs/node/commit/292aa42bd1)] - **test**: fix faulty relpath test (Gus Caplan) [#20954](https://github.com/nodejs/node/pull/20954)
* \[[`a086604f8f`](https://github.com/nodejs/node/commit/a086604f8f)] - **test**: remove 3rd arg from to assert.strictEqual() (hectorcoronado) [#21828](https://github.com/nodejs/node/pull/21828)
* \[[`580071dde4`](https://github.com/nodejs/node/commit/580071dde4)] - **tls**: named anonymous functions in \_tls\_wrap.js (prayag21) [#21756](https://github.com/nodejs/node/pull/21756)
* \[[`0f70017f35`](https://github.com/nodejs/node/commit/0f70017f35)] - **tls**: name anonymous function in tls.js (Kevin Lacabane) [#21754](https://github.com/nodejs/node/pull/21754)
* \[[`0151486b9d`](https://github.com/nodejs/node/commit/0151486b9d)] - **tools**: patch gyp to avoid xcrun errors (Ujjwal Sharma) [#21520](https://github.com/nodejs/node/pull/21520)
* \[[`b520216518`](https://github.com/nodejs/node/commit/b520216518)] - **tools**: update cpplint to check for inline headers (Ujjwal Sharma) [#21521](https://github.com/nodejs/node/pull/21521)
* \[[`98d461e8cc`](https://github.com/nodejs/node/commit/98d461e8cc)] - **tools**: update ESLint to 5.2.0 (Yuta Hiroto) [#21817](https://github.com/nodejs/node/pull/21817)
* \[[`ce527d973a`](https://github.com/nodejs/node/commit/ce527d973a)] - **tools**: define xrange() in Python 3 (cclauss) [#21945](https://github.com/nodejs/node/pull/21945)
* \[[`254aa83174`](https://github.com/nodejs/node/commit/254aa83174)] - **tools**: remove obsolete entries from license (Rich Trott) [#21979](https://github.com/nodejs/node/pull/21979)
* \[[`36f8b82697`](https://github.com/nodejs/node/commit/36f8b82697)] - **tools**: flatten apidoc headers (Sam Ruby) [#21936](https://github.com/nodejs/node/pull/21936)
* \[[`5e71d63bfe`](https://github.com/nodejs/node/commit/5e71d63bfe)] - **tools**: validate apidoc links (Sam Ruby) [#21889](https://github.com/nodejs/node/pull/21889)
* \[[`b98bf829d0`](https://github.com/nodejs/node/commit/b98bf829d0)] - **tools**: build API TOC using raw headers (Sam Ruby) [#21922](https://github.com/nodejs/node/pull/21922)
* \[[`5606f0b1f2`](https://github.com/nodejs/node/commit/5606f0b1f2)] - **tools**: create HTML docs with unified/remark/rehype (Sam Ruby) [#21490](https://github.com/nodejs/node/pull/21490)
* \[[`f89d194deb`](https://github.com/nodejs/node/commit/f89d194deb)] - **tools**: improve update-eslint.sh (Rich Trott) [#21819](https://github.com/nodejs/node/pull/21819)
* \[[`6b925ebaba`](https://github.com/nodejs/node/commit/6b925ebaba)] - **tools**: make getnodeversion.py python3-compatible (silverwind) [#21872](https://github.com/nodejs/node/pull/21872)
* \[[`ff5c6dcd1b`](https://github.com/nodejs/node/commit/ff5c6dcd1b)] - **tools**: properly convert .gypi in install.py (Michael Achenbach) [#21850](https://github.com/nodejs/node/pull/21850)
* \[[`02e665c712`](https://github.com/nodejs/node/commit/02e665c712)] - **tools,test**: remove unused config hooks (Jon Moss) [#22010](https://github.com/nodejs/node/pull/22010)
* \[[`cfeed2b193`](https://github.com/nodejs/node/commit/cfeed2b193)] - **trace\_events**: add support for builtin trace (James M Snell) [#21899](https://github.com/nodejs/node/pull/21899)
* \[[`d7edee4954`](https://github.com/nodejs/node/commit/d7edee4954)] - **trace\_events**: add more process metadata (James M Snell) [#21785](https://github.com/nodejs/node/pull/21785)
* \[[`9a88fe4d5e`](https://github.com/nodejs/node/commit/9a88fe4d5e)] - **vm**: rename vm.Module to vm.SourceTextModule (Gus Caplan) [#22007](https://github.com/nodejs/node/pull/22007)

<a id="10.7.0"></a>

## 2018-07-18, Version 10.7.0 (Current), @targos

### Notable Changes

* **console**:
  * The `console.timeLog()` method has been implemented. [#21312](https://github.com/nodejs/node/pull/21312)
* **deps**:
  * Upgrade to libuv 1.22.0. [#21731](https://github.com/nodejs/node/pull/21731)
  * Upgrade to ICU 62.1 (Unicode 11, CLDR 33.1). [#21728](https://github.com/nodejs/node/pull/21728)
* **http**:
  * Added support for passing both `timeout` and `agent` options to
    `http.request`. [#21204](https://github.com/nodejs/node/pull/21204)
* **inspector**:
  * Expose the original console API in `require('inspector').console`. [#21659](https://github.com/nodejs/node/pull/21659)
* **napi**:
  * Added experimental support for functions dealing with bigint numbers. [#21226](https://github.com/nodejs/node/pull/21226)
* **process**:
  * The `process.hrtime.bigint()` method has been implemented. [#21256](https://github.com/nodejs/node/pull/21256)
  * Added the `--title` command line argument to set the process title on
    startup. [#21477](https://github.com/nodejs/node/pull/21477)
* **trace\_events**:
  * Added process\_name metadata. [#21477](https://github.com/nodejs/node/pull/21477)
* **Added new collaborators**
  * [codebytere](https://github.com/codebytere) - Shelley Vohr

### Commits

* \[[`8c97ffb2f5`](https://github.com/nodejs/node/commit/8c97ffb2f5)] - **assert**: improve simple assert (Ruben Bridgewater) [#21626](https://github.com/nodejs/node/pull/21626)
* \[[`9776f1cbef`](https://github.com/nodejs/node/commit/9776f1cbef)] - **benchmark**: add n-api function args benchmark (Kenny Yuan) [#21555](https://github.com/nodejs/node/pull/21555)
* \[[`576f1ea978`](https://github.com/nodejs/node/commit/576f1ea978)] - **buffer**: remove superfluous assignment (Tobias Nießen) [#21844](https://github.com/nodejs/node/pull/21844)
* \[[`6bb2b5a51d`](https://github.com/nodejs/node/commit/6bb2b5a51d)] - **build**: account for pure C sources in `build-addons-napi` (Anna Henningsen) [#21797](https://github.com/nodejs/node/pull/21797)
* \[[`c02fb88936`](https://github.com/nodejs/node/commit/c02fb88936)] - **build**: enabling lto at configure (Octavian Soldea) [#21677](https://github.com/nodejs/node/pull/21677)
* \[[`2a0862cec9`](https://github.com/nodejs/node/commit/2a0862cec9)] - **console**: fix timeEnd() not coercing the input (Ruben Bridgewater) [#21779](https://github.com/nodejs/node/pull/21779)
* \[[`f3c397cd21`](https://github.com/nodejs/node/commit/f3c397cd21)] - **(SEMVER-MINOR)** **console**: implement timeLog method (Michaël Zasso) [#21312](https://github.com/nodejs/node/pull/21312)
* \[[`73cafd853c`](https://github.com/nodejs/node/commit/73cafd853c)] - **console,util**: avoid pair array generation in C++ (Anna Henningsen) [#20831](https://github.com/nodejs/node/pull/20831)
* \[[`d9825c7a16`](https://github.com/nodejs/node/commit/d9825c7a16)] - **crypto**: prevent Sign::SignFinal from crashing (Tobias Nießen) [#21815](https://github.com/nodejs/node/pull/21815)
* \[[`07cce880bf`](https://github.com/nodejs/node/commit/07cce880bf)] - **crypto**: handle OpenSSL error queue in CipherBase (Tobias Nießen) [#21288](https://github.com/nodejs/node/pull/21288)
* \[[`355c5e3c95`](https://github.com/nodejs/node/commit/355c5e3c95)] - **deps**: cherry-pick 555c811 from upstream V8 (Anna Henningsen) [#21741](https://github.com/nodejs/node/pull/21741)
* \[[`42d75392c5`](https://github.com/nodejs/node/commit/42d75392c5)] - **deps**: patch V8 to 6.7.288.49 (Myles Borins) [#21727](https://github.com/nodejs/node/pull/21727)
* \[[`6920091488`](https://github.com/nodejs/node/commit/6920091488)] - **deps**: upgrade to libuv 1.22.0 (cjihrig) [#21731](https://github.com/nodejs/node/pull/21731)
* \[[`122ae24f62`](https://github.com/nodejs/node/commit/122ae24f62)] - **deps**: icu 62.1 bump (Unicode 11, CLDR 33.1) (Steven R. Loomis) [#21728](https://github.com/nodejs/node/pull/21728)
* \[[`a5233c7e17`](https://github.com/nodejs/node/commit/a5233c7e17)] - **deps**: cherry-pick 477df06 from upstream v8 (Gus Caplan) [#21644](https://github.com/nodejs/node/pull/21644)
* \[[`506631a9f9`](https://github.com/nodejs/node/commit/506631a9f9)] - **doc**: fix structure and formatting in inspector.md (Vse Mozhet Byt) [#21709](https://github.com/nodejs/node/pull/21709)
* \[[`53b587a5af`](https://github.com/nodejs/node/commit/53b587a5af)] - **doc**: add documentation for buffer.byteOffset (Andreas Madsen) [#21718](https://github.com/nodejs/node/pull/21718)
* \[[`51dfebf9ac`](https://github.com/nodejs/node/commit/51dfebf9ac)] - **doc**: fix vm.runInNewContext signature (Michaël Zasso) [#21824](https://github.com/nodejs/node/pull/21824)
* \[[`10f9374ea3`](https://github.com/nodejs/node/commit/10f9374ea3)] - **doc**: make markdown input compliant (Sam Ruby) [#21780](https://github.com/nodejs/node/pull/21780)
* \[[`02982998db`](https://github.com/nodejs/node/commit/02982998db)] - **doc**: add my pronoun (Ruben Bridgewater) [#21813](https://github.com/nodejs/node/pull/21813)
* \[[`ca8c96035a`](https://github.com/nodejs/node/commit/ca8c96035a)] - **doc**: update readme with my pronouns (Lance Ball) [#21818](https://github.com/nodejs/node/pull/21818)
* \[[`d33281b36f`](https://github.com/nodejs/node/commit/d33281b36f)] - **doc**: prevent some redirections (Vse Mozhet Byt) [#21811](https://github.com/nodejs/node/pull/21811)
* \[[`0de0f89d0c`](https://github.com/nodejs/node/commit/0de0f89d0c)] - **doc**: add "Edit on GitHub" link (Rich Trott) [#21703](https://github.com/nodejs/node/pull/21703)
* \[[`7ab6efdb94`](https://github.com/nodejs/node/commit/7ab6efdb94)] - **doc**: add policy for landing new npm releases (Myles Borins) [#21594](https://github.com/nodejs/node/pull/21594)
* \[[`3d93273bf7`](https://github.com/nodejs/node/commit/3d93273bf7)] - **doc**: add OS X to instead of only macOS (XadillaX) [#21033](https://github.com/nodejs/node/pull/21033)
* \[[`577d24baa4`](https://github.com/nodejs/node/commit/577d24baa4)] - **doc**: fix module.children description (Travis Fischer) [#21672](https://github.com/nodejs/node/pull/21672)
* \[[`cd6601b87a`](https://github.com/nodejs/node/commit/cd6601b87a)] - **doc**: fix HTTP res 'finish' description (Sergey Zelenov) [#21670](https://github.com/nodejs/node/pull/21670)
* \[[`51db88b0f1`](https://github.com/nodejs/node/commit/51db88b0f1)] - **doc**: fix http2stream.pushStream error doc (Сковорода Никита Андреевич) [#21487](https://github.com/nodejs/node/pull/21487)
* \[[`6e1917a596`](https://github.com/nodejs/node/commit/6e1917a596)] - **doc**: update changelog with 9.x EOL (Сковорода Никита Андреевич) [#21612](https://github.com/nodejs/node/pull/21612)
* \[[`cd77d8782a`](https://github.com/nodejs/node/commit/cd77d8782a)] - **doc**: improve documentation of fs sync methods (iwko) [#21243](https://github.com/nodejs/node/pull/21243)
* \[[`1044bafec4`](https://github.com/nodejs/node/commit/1044bafec4)] - **doc**: remove \_Node.js style callback\_ (Rich Trott) [#21701](https://github.com/nodejs/node/pull/21701)
* \[[`971679328e`](https://github.com/nodejs/node/commit/971679328e)] - **doc**: add codebytere as collaborator (Shelley Vohr) [#21700](https://github.com/nodejs/node/pull/21700)
* \[[`034fe19862`](https://github.com/nodejs/node/commit/034fe19862)] - **doc**: add links to inline HTML table (Rich Trott) [#21678](https://github.com/nodejs/node/pull/21678)
* \[[`04eed2342d`](https://github.com/nodejs/node/commit/04eed2342d)] - **doc**: remove "note that" from fs doc (Rich Trott) [#21646](https://github.com/nodejs/node/pull/21646)
* \[[`c8d5bab022`](https://github.com/nodejs/node/commit/c8d5bab022)] - **doc**: fix doc for napi\_create\_function (Gabriel Schulhof)
* \[[`f7aa22a0eb`](https://github.com/nodejs/node/commit/f7aa22a0eb)] - **doc**: improve guide text for CI runs (Rich Trott) [#21645](https://github.com/nodejs/node/pull/21645)
* \[[`6f8ebc08b9`](https://github.com/nodejs/node/commit/6f8ebc08b9)] - **doc**: unify spelling of backpressure (Thomas Watson) [#21630](https://github.com/nodejs/node/pull/21630)
* \[[`3fffc7e95f`](https://github.com/nodejs/node/commit/3fffc7e95f)] - **errors**: fix undefined HTTP2 and tls errors (Shailesh Shekhawat) [#21564](https://github.com/nodejs/node/pull/21564)
* \[[`b758006c23`](https://github.com/nodejs/node/commit/b758006c23)] - **fs**: fix fsPromises.lchmod error on non-Mac (Masashi Hirano) [#21435](https://github.com/nodejs/node/pull/21435)
* \[[`4fa7150962`](https://github.com/nodejs/node/commit/4fa7150962)] - **fs**: support pseudofiles in promises.readFile (Timothy Gu) [#21497](https://github.com/nodejs/node/pull/21497)
* \[[`bba500d0ea`](https://github.com/nodejs/node/commit/bba500d0ea)] - **(SEMVER-MINOR)** **http**: fix request with option timeout and agent (killagu) [#21204](https://github.com/nodejs/node/pull/21204)
* \[[`0b3c80ca31`](https://github.com/nodejs/node/commit/0b3c80ca31)] - **http2**: fix issues with aborted `respondWithFile()`s (Anna Henningsen) [#21561](https://github.com/nodejs/node/pull/21561)
* \[[`238ef58841`](https://github.com/nodejs/node/commit/238ef58841)] - **http2**: remove `waitTrailers` listener after closing a stream (RidgeA) [#21764](https://github.com/nodejs/node/pull/21764)
* \[[`07160cd2fd`](https://github.com/nodejs/node/commit/07160cd2fd)] - **http2**: order declarations in core.js (Rich Trott) [#21689](https://github.com/nodejs/node/pull/21689)
* \[[`c88af232c8`](https://github.com/nodejs/node/commit/c88af232c8)] - **http2**: pass incoming set-cookie header as array (Gerhard Stoebich) [#21360](https://github.com/nodejs/node/pull/21360)
* \[[`2922028362`](https://github.com/nodejs/node/commit/2922028362)] - **(SEMVER-MINOR)** **inspector**: expose original console (Matteo Collina) [#21659](https://github.com/nodejs/node/pull/21659)
* \[[`b2291296ef`](https://github.com/nodejs/node/commit/b2291296ef)] - **inspector**: split main thread interface from transport (Eugene Ostroukhov) [#21182](https://github.com/nodejs/node/pull/21182)
* \[[`4ed4bf3bdd`](https://github.com/nodejs/node/commit/4ed4bf3bdd)] - **lib**: update punycode to 2.1.1 (Rich Trott) [#21768](https://github.com/nodejs/node/pull/21768)
* \[[`4433ecbf30`](https://github.com/nodejs/node/commit/4433ecbf30)] - **lib**: refactor cli table (Ruben Bridgewater) [#20960](https://github.com/nodejs/node/pull/20960)
* \[[`92d79212ec`](https://github.com/nodejs/node/commit/92d79212ec)] - **lib**: consolidate redundant require() calls (cjihrig) [#21699](https://github.com/nodejs/node/pull/21699)
* \[[`ed774b7930`](https://github.com/nodejs/node/commit/ed774b7930)] - **messaging**: fix edge cases with transferring ports (Timothy Gu) [#21540](https://github.com/nodejs/node/pull/21540)
* \[[`221c8bd58f`](https://github.com/nodejs/node/commit/221c8bd58f)] - **messaging**: use actual DOMException for DataCloneError (Timothy Gu) [#21540](https://github.com/nodejs/node/pull/21540)
* \[[`4f3bbfaaca`](https://github.com/nodejs/node/commit/4f3bbfaaca)] - **n-api**: test uint32 truncation (Gabriel Schulhof) [#21722](https://github.com/nodejs/node/pull/21722)
* \[[`b8ba003fbf`](https://github.com/nodejs/node/commit/b8ba003fbf)] - **n-api**: remove experimental gate from status codes (Gabriel Schulhof) [#21680](https://github.com/nodejs/node/pull/21680)
* \[[`109c59971a`](https://github.com/nodejs/node/commit/109c59971a)] - **n-api**: create functions directly (Gabriel Schulhof) [#21688](https://github.com/nodejs/node/pull/21688)
* \[[`cec166e85f`](https://github.com/nodejs/node/commit/cec166e85f)] - **n-api**: restrict exports by version (Kyle Farnung) [#19962](https://github.com/nodejs/node/pull/19962)
* \[[`3096ee5a4b`](https://github.com/nodejs/node/commit/3096ee5a4b)] - **(SEMVER-MINOR)** **napi**: add bigint support (Gus Caplan) [#21226](https://github.com/nodejs/node/pull/21226)
* \[[`581390c59d`](https://github.com/nodejs/node/commit/581390c59d)] - **process**: split bootstrappers by threads that can run them (Joyee Cheung) [#21378](https://github.com/nodejs/node/pull/21378)
* \[[`f1b18ba412`](https://github.com/nodejs/node/commit/f1b18ba412)] - **(SEMVER-MINOR)** **process**: implement process.hrtime.bigint() (Joyee Cheung) [#21256](https://github.com/nodejs/node/pull/21256)
* \[[`961f6e8623`](https://github.com/nodejs/node/commit/961f6e8623)] - **process**: fix process.exitCode handling for fatalException (Denys Otrishko) [#21739](https://github.com/nodejs/node/pull/21739)
* \[[`4b613d3976`](https://github.com/nodejs/node/commit/4b613d3976)] - **repl**: make own properties shadow prototype properties (Sam Ruby) [#21588](https://github.com/nodejs/node/pull/21588)
* \[[`1019c2d317`](https://github.com/nodejs/node/commit/1019c2d317)] - **src**: fix async hooks crashing when there is no node context (Javier Gonzalez) [#19134](https://github.com/nodejs/node/pull/19134)
* \[[`a9a718696e`](https://github.com/nodejs/node/commit/a9a718696e)] - **src**: make heap snapshot & embedder graph accessible for tests (Anna Henningsen) [#21741](https://github.com/nodejs/node/pull/21741)
* \[[`5121278f5c`](https://github.com/nodejs/node/commit/5121278f5c)] - **src**: use V8 graph heap snapshot API (Anna Henningsen) [#21741](https://github.com/nodejs/node/pull/21741)
* \[[`d42dbde1a8`](https://github.com/nodejs/node/commit/d42dbde1a8)] - **src**: add iteration over all base objects to Environment (Anna Henningsen) [#21741](https://github.com/nodejs/node/pull/21741)
* \[[`4ed5d1a623`](https://github.com/nodejs/node/commit/4ed5d1a623)] - **src**: add HandleWrap::AddWrapMethods (Jon Moss) [#21769](https://github.com/nodejs/node/pull/21769)
* \[[`51d613db2d`](https://github.com/nodejs/node/commit/51d613db2d)] - **src**: start annotating native code side effect (Timothy Gu) [#21458](https://github.com/nodejs/node/pull/21458)
* \[[`466601f47f`](https://github.com/nodejs/node/commit/466601f47f)] - **src**: remove .h if -inl.h is already included (Daniel Bevenius) [#21381](https://github.com/nodejs/node/pull/21381)
* \[[`a68b7dda5f`](https://github.com/nodejs/node/commit/a68b7dda5f)] - **src**: add node\_process.cc (James M Snell) [#21105](https://github.com/nodejs/node/pull/21105)
* \[[`cb698111c4`](https://github.com/nodejs/node/commit/cb698111c4)] - **src**: add comment on CallbackScope exception behaviour (Anna Henningsen) [#21743](https://github.com/nodejs/node/pull/21743)
* \[[`712809eb1b`](https://github.com/nodejs/node/commit/712809eb1b)] - **src**: enable more detailed memory tracking (Anna Henningsen) [#21742](https://github.com/nodejs/node/pull/21742)
* \[[`277077853f`](https://github.com/nodejs/node/commit/277077853f)] - **src**: make Environment::is\_stopping\_worker inline (Jon Moss) [#21720](https://github.com/nodejs/node/pull/21720)
* \[[`d06305635d`](https://github.com/nodejs/node/commit/d06305635d)] - **(SEMVER-MINOR)** **src**: add --title command line argument (James M Snell) [#21477](https://github.com/nodejs/node/pull/21477)
* \[[`ceec23e6e4`](https://github.com/nodejs/node/commit/ceec23e6e4)] - **src**: remove using directives from spawn\_sync.h (Daniel Bevenius) [#21634](https://github.com/nodejs/node/pull/21634)
* \[[`3a627c830b`](https://github.com/nodejs/node/commit/3a627c830b)] - **src**: add context-aware init macro and doc (Gabriel Schulhof) [#21318](https://github.com/nodejs/node/pull/21318)
* \[[`aa5994f2b9`](https://github.com/nodejs/node/commit/aa5994f2b9)] - **src,tools**: use <https://nodejs.org> URL when possible. (XhmikosR) [#21719](https://github.com/nodejs/node/pull/21719)
* \[[`0108ff6b51`](https://github.com/nodejs/node/commit/0108ff6b51)] - **test**: add support for NODE\_TEST\_DIR on a separate mount point (Antoine du HAMEL) [#21552](https://github.com/nodejs/node/pull/21552)
* \[[`eef975ebae`](https://github.com/nodejs/node/commit/eef975ebae)] - **test**: move inspector test back to parallel, unmark flaky (Anna Henningsen) [#21806](https://github.com/nodejs/node/pull/21806)
* \[[`67908e9933`](https://github.com/nodejs/node/commit/67908e9933)] - **test**: fix build warnings in bigint N-API test (Anna Henningsen) [#21796](https://github.com/nodejs/node/pull/21796)
* \[[`6b72583bf8`](https://github.com/nodejs/node/commit/6b72583bf8)] - **test**: refactor test-tls-connect-memleak, move to parallel (Anna Henningsen) [#21794](https://github.com/nodejs/node/pull/21794)
* \[[`174a9db51a`](https://github.com/nodejs/node/commit/174a9db51a)] - **test**: refactor test-net-connect-memleak, move to parallel (Anna Henningsen) [#21794](https://github.com/nodejs/node/pull/21794)
* \[[`b338ff54bb`](https://github.com/nodejs/node/commit/b338ff54bb)] - **test**: add gc tracking to common API (Anna Henningsen) [#21794](https://github.com/nodejs/node/pull/21794)
* \[[`4e60ce8f87`](https://github.com/nodejs/node/commit/4e60ce8f87)] - **test**: fix flaky test-debug-prompt (Rich Trott) [#21826](https://github.com/nodejs/node/pull/21826)
* \[[`a2edb59870`](https://github.com/nodejs/node/commit/a2edb59870)] - **test**: fix comment of fs.promises write (Ryuichi Sakagami) [#21708](https://github.com/nodejs/node/pull/21708)
* \[[`32ad163038`](https://github.com/nodejs/node/commit/32ad163038)] - **test**: add test of fs.promises write for non-string buffers (Ryuichi Sakagami) [#21708](https://github.com/nodejs/node/pull/21708)
* \[[`7352b72fc9`](https://github.com/nodejs/node/commit/7352b72fc9)] - **test**: add heap snapshot tests (Anna Henningsen) [#21741](https://github.com/nodejs/node/pull/21741)
* \[[`678313d18b`](https://github.com/nodejs/node/commit/678313d18b)] - **test**: add filehandle sync() and datasync() tests (Masashi Hirano) [#20530](https://github.com/nodejs/node/pull/20530)
* \[[`a09bdb5847`](https://github.com/nodejs/node/commit/a09bdb5847)] - **test**: improve console table error output (Ruben Bridgewater) [#20960](https://github.com/nodejs/node/pull/20960)
* \[[`600349aaba`](https://github.com/nodejs/node/commit/600349aaba)] - **test**: refactor process/worker exitCode tests (Denys Otrishko) [#21739](https://github.com/nodejs/node/pull/21739)
* \[[`15026511b8`](https://github.com/nodejs/node/commit/15026511b8)] - **test**: remove timer in fs.watchFile() test (Rich Trott) [#21694](https://github.com/nodejs/node/pull/21694)
* \[[`ae5d5658b9`](https://github.com/nodejs/node/commit/ae5d5658b9)] - **test**: fix flaky watchFile() (Rich Trott) [#21694](https://github.com/nodejs/node/pull/21694)
* \[[`ada3f34cd4`](https://github.com/nodejs/node/commit/ada3f34cd4)] - **test**: fix weird string error (Jon Moss) [#21793](https://github.com/nodejs/node/pull/21793)
* \[[`f46536be23`](https://github.com/nodejs/node/commit/f46536be23)] - **test**: fix timeouts when running worker tests with `--worker` (Anna Henningsen) [#21791](https://github.com/nodejs/node/pull/21791)
* \[[`f386c0a517`](https://github.com/nodejs/node/commit/f386c0a517)] - **test**: add test for dns.promises.resolve . (Keita Akutsu) [#21691](https://github.com/nodejs/node/pull/21691)
* \[[`11e9b4ecee`](https://github.com/nodejs/node/commit/11e9b4ecee)] - **test**: fix parallel/test-tls-env-extra-ca.js (Niicck) [#21647](https://github.com/nodejs/node/pull/21647)
* \[[`eda7fffba4`](https://github.com/nodejs/node/commit/eda7fffba4)] - **test**: swap arguments in strictEqual() (Sohail Rajdev) [#21660](https://github.com/nodejs/node/pull/21660)
* \[[`194d1955a7`](https://github.com/nodejs/node/commit/194d1955a7)] - **test**: fix test-tls-connect-memleak (Rich Trott) [#21681](https://github.com/nodejs/node/pull/21681)
* \[[`24f649c8cf`](https://github.com/nodejs/node/commit/24f649c8cf)] - **test**: fix pummel/test-net-connect-memleak (Rich Trott) [#21658](https://github.com/nodejs/node/pull/21658)
* \[[`021dd5404c`](https://github.com/nodejs/node/commit/021dd5404c)] - **test**: remove unnecessary string literals (Jacek Pospychała) [#21638](https://github.com/nodejs/node/pull/21638)
* \[[`47b10e30c0`](https://github.com/nodejs/node/commit/47b10e30c0)] - **test**: replace third argument with comment in strict equals (Developer Davo) [#21603](https://github.com/nodejs/node/pull/21603)
* \[[`25dac95164`](https://github.com/nodejs/node/commit/25dac95164)] - **test**: fix args passed to strictEqual (Haroon Khan) [#21584](https://github.com/nodejs/node/pull/21584)
* \[[`fe9888a34a`](https://github.com/nodejs/node/commit/fe9888a34a)] - **test**: check type for Worker filename argument (Masashi Hirano) [#21620](https://github.com/nodejs/node/pull/21620)
* \[[`9cd5c0ec79`](https://github.com/nodejs/node/commit/9cd5c0ec79)] - **test**: add test for missing dynamic instantiate hook (Michaël Zasso) [#21506](https://github.com/nodejs/node/pull/21506)
* \[[`dc84858787`](https://github.com/nodejs/node/commit/dc84858787)] - **test,util**: add missing tests and conditions (MaleDong) [#21455](https://github.com/nodejs/node/pull/21455)
* \[[`c26ba082ae`](https://github.com/nodejs/node/commit/c26ba082ae)] - **tools**: avoid global install of dmn for lint update (Rich Trott) [#21744](https://github.com/nodejs/node/pull/21744)
* \[[`e030dd7d65`](https://github.com/nodejs/node/commit/e030dd7d65)] - **tools**: add no-duplicate-requires rule (Gus Caplan) [#21712](https://github.com/nodejs/node/pull/21712)
* \[[`b9bbbbe5d1`](https://github.com/nodejs/node/commit/b9bbbbe5d1)] - **tools**: build all.json by combining generated JSON (Sam Ruby) [#21637](https://github.com/nodejs/node/pull/21637)
* \[[`214c608208`](https://github.com/nodejs/node/commit/214c608208)] - **tools**: lint doc code examples in strict mode (Vse Mozhet Byt) [#21615](https://github.com/nodejs/node/pull/21615)
* \[[`27d17d4600`](https://github.com/nodejs/node/commit/27d17d4600)] - **trace\_events**: add traced\_value.cc/traced\_value.h (James M Snell) [#21475](https://github.com/nodejs/node/pull/21475)
* \[[`c4d7413a15`](https://github.com/nodejs/node/commit/c4d7413a15)] - **(SEMVER-MINOR)** **trace\_events**: add process\_name metadata (James M Snell) [#21477](https://github.com/nodejs/node/pull/21477)
* \[[`b0943a655e`](https://github.com/nodejs/node/commit/b0943a655e)] - **worker**: exit after uncaught exception (Denys Otrishko) [#21739](https://github.com/nodejs/node/pull/21739)
* \[[`25fef3d8d4`](https://github.com/nodejs/node/commit/25fef3d8d4)] - **workers**: fix invalid exit code in parent upon uncaught exception (Denys Otrishko) [#21713](https://github.com/nodejs/node/pull/21713)
* \[[`48b16aad47`](https://github.com/nodejs/node/commit/48b16aad47)] - **zlib**: instance-ify two methods (Jon Moss) [#21702](https://github.com/nodejs/node/pull/21702)
* \[[`dae7130929`](https://github.com/nodejs/node/commit/dae7130929)] - **zlib**: track memory allocated by zlib (Anna Henningsen) [#21608](https://github.com/nodejs/node/pull/21608)
* \[[`96dae83713`](https://github.com/nodejs/node/commit/96dae83713)] - **zlib**: fix memory leak for unused zlib instances (Anna Henningsen) [#21607](https://github.com/nodejs/node/pull/21607)

<a id="10.6.0"></a>

## 2018-07-04, Version 10.6.0 (Current), @targos

### Notable Changes

* **dns**:
  * An experimental promisified version of the dns module is now available. Give
    it a try with `require('dns').promises`. [#21264](https://github.com/nodejs/node/pull/21264)
* **fs**:
  * `fs.lchown` has been undeprecated now that libuv supports it. [#21498](https://github.com/nodejs/node/pull/21498)
* **lib**:
  * `Atomics.wake` is being renamed to `Atomics.notify` in the ECMAScript
    specification ([reference](https://github.com/tc39/ecma262/pull/1220)).
    Since Node.js now has experimental support for worker threads, we are being
    proactive and added a `notify` alias, while emitting a warning if
    `wake` is used. [#21413](https://github.com/nodejs/node/pull/21413) [#21518](https://github.com/nodejs/node/pull/21518)
* **n-api**:
  * Add API for asynchronous functions. [#17887](https://github.com/nodejs/node/pull/17887)
* **util**:
  * `util.inspect` is now able to return a result instead of throwing when the
    maximum call stack size is exceeded during inspection. [#20725](https://github.com/nodejs/node/pull/20725)
* **vm**:
  * Add `script.createCachedData()`. This API replaces the `produceCachedData`
    option of the `Script` constructor that is now deprecated. [#20300](https://github.com/nodejs/node/pull/20300)
* **worker**:
  * Support for relative paths has been added to the `Worker` constructor. Paths
    are interpreted relative to the current working directory. [#21407](https://github.com/nodejs/node/pull/21407)

### Commits

* \[[`a526b4e2c7`](https://github.com/nodejs/node/commit/a526b4e2c7)] - **atomis**: add notify alias (Gus Caplan) [#21413](https://github.com/nodejs/node/pull/21413)
* \[[`9030e933f4`](https://github.com/nodejs/node/commit/9030e933f4)] - **benchmark**: create napi benchmark directory (Rich Trott) [#21046](https://github.com/nodejs/node/pull/21046)
* \[[`3d3dbae7d8`](https://github.com/nodejs/node/commit/3d3dbae7d8)] - **build**: remove requirement to re-run ./configure (Anna Henningsen) [#21371](https://github.com/nodejs/node/pull/21371)
* \[[`a7505c029a`](https://github.com/nodejs/node/commit/a7505c029a)] - **build**: speed up startup with V8 code cache (Joyee Cheung) [#21405](https://github.com/nodejs/node/pull/21405)
* \[[`7d2fe5d770`](https://github.com/nodejs/node/commit/7d2fe5d770)] - **build**: improve Travis CI settings (Timothy Gu) [#21459](https://github.com/nodejs/node/pull/21459)
* \[[`225063184d`](https://github.com/nodejs/node/commit/225063184d)] - **build**: fail on instrumentation errors (Benjamin Coe) [#21071](https://github.com/nodejs/node/pull/21071)
* \[[`6f80e305d0`](https://github.com/nodejs/node/commit/6f80e305d0)] - **build**: build addons in parallel on Windows (Bartosz Sosnowski) [#21403](https://github.com/nodejs/node/pull/21403)
* \[[`42f5ff8346`](https://github.com/nodejs/node/commit/42f5ff8346)] - **build**: add crypto check to markdown lint target (Daniel Bevenius) [#21326](https://github.com/nodejs/node/pull/21326)
* \[[`c214403c1a`](https://github.com/nodejs/node/commit/c214403c1a)] - **build**: fix building with --build-v8-with-gn (Yang Guo) [#21330](https://github.com/nodejs/node/pull/21330)
* \[[`76ef7acf6d`](https://github.com/nodejs/node/commit/76ef7acf6d)] - **(SEMVER-MINOR)** **build, win**: make LTCG optional (Bartosz Sosnowski) [#21186](https://github.com/nodejs/node/pull/21186)
* \[[`45a83760ec`](https://github.com/nodejs/node/commit/45a83760ec)] - **crypto**: fix UB in computing max message size (Ben Noordhuis) [#21462](https://github.com/nodejs/node/pull/21462)
* \[[`fefa57a7a4`](https://github.com/nodejs/node/commit/fefa57a7a4)] - **crypto**: remove outdated comment (Timothy Gu) [#21511](https://github.com/nodejs/node/pull/21511)
* \[[`e7776c63da`](https://github.com/nodejs/node/commit/e7776c63da)] - **crypto**: refer to correct deprecation id in comment (Michaël Zasso) [#21399](https://github.com/nodejs/node/pull/21399)
* \[[`b30840da5f`](https://github.com/nodejs/node/commit/b30840da5f)] - **deps**: fix gypi sysroot settings on V8 (Matheus Marchini) [#21494](https://github.com/nodejs/node/pull/21494)
* \[[`a48d98ef04`](https://github.com/nodejs/node/commit/a48d98ef04)] - **deps**: float fix on node-gyp in npm tree (Myles Borins) [#21448](https://github.com/nodejs/node/pull/21448)
* \[[`fe6d707bc4`](https://github.com/nodejs/node/commit/fe6d707bc4)] - **deps**: float 0c27d793 from openssl (ECDSA blinding) (Rod Vagg) [#21345](https://github.com/nodejs/node/pull/21345)
* \[[`f162939c32`](https://github.com/nodejs/node/commit/f162939c32)] - **deps**: upgrade to libuv 1.21.0 (cjihrig) [#21466](https://github.com/nodejs/node/pull/21466)
* \[[`62ca2cf21c`](https://github.com/nodejs/node/commit/62ca2cf21c)] - **deps**: cherry-pick 70c4340 from upstream V8 (Matheus Marchini) [#21126](https://github.com/nodejs/node/pull/21126)
* \[[`ab27e0e785`](https://github.com/nodejs/node/commit/ab27e0e785)] - **deps**: cherry-pick acc336c from upstream V8 (Matheus Marchini) [#21126](https://github.com/nodejs/node/pull/21126)
* \[[`37a5c8c2ff`](https://github.com/nodejs/node/commit/37a5c8c2ff)] - **deps**: cherry-pick b20faff from upstream V8 (Matheus Marchini) [#21126](https://github.com/nodejs/node/pull/21126)
* \[[`4663d1c22e`](https://github.com/nodejs/node/commit/4663d1c22e)] - **deps**: backport aa6ce3e from upstream V8 (Matheus Marchini) [#21126](https://github.com/nodejs/node/pull/21126)
* \[[`5d7218965d`](https://github.com/nodejs/node/commit/5d7218965d)] - **deps**: cherry-pick 5dd3395 from upstream V8 (Matheus Marchini) [#21386](https://github.com/nodejs/node/pull/21386)
* \[[`18179f8ae9`](https://github.com/nodejs/node/commit/18179f8ae9)] - **(SEMVER-MINOR)** **dns**: remove Resolver#cancel() from promises API (cjihrig) [#21264](https://github.com/nodejs/node/pull/21264)
* \[[`aa864ba4a9`](https://github.com/nodejs/node/commit/aa864ba4a9)] - **(SEMVER-MINOR)** **dns**: add promisified dns module (cjihrig) [#21264](https://github.com/nodejs/node/pull/21264)
* \[[`1d73ba8322`](https://github.com/nodejs/node/commit/1d73ba8322)] - **doc**: fix some links (Vse Mozhet Byt) [#21619](https://github.com/nodejs/node/pull/21619)
* \[[`24bc6ab726`](https://github.com/nodejs/node/commit/24bc6ab726)] - **doc**: fix some typos in N-API docs (Vse Mozhet Byt) [#21614](https://github.com/nodejs/node/pull/21614)
* \[[`cadc74d92d`](https://github.com/nodejs/node/commit/cadc74d92d)] - **doc**: fix heading level in errors.md (Vse Mozhet Byt) [#21618](https://github.com/nodejs/node/pull/21618)
* \[[`eb6dcf2696`](https://github.com/nodejs/node/commit/eb6dcf2696)] - **doc**: fix typo in fs.md (Hugo Josefson) [#21579](https://github.com/nodejs/node/pull/21579)
* \[[`e081866f64`](https://github.com/nodejs/node/commit/e081866f64)] - **doc**: add DataView to appropriate crypto methods (Gerhard Stoebich) [#21549](https://github.com/nodejs/node/pull/21549)
* \[[`51a434f711`](https://github.com/nodejs/node/commit/51a434f711)] - **doc**: fix some typos in deprecations.md and vm.md (Vse Mozhet Byt) [#21569](https://github.com/nodejs/node/pull/21569)
* \[[`0f1d73761d`](https://github.com/nodejs/node/commit/0f1d73761d)] - **doc**: fix function name in process.md (Joonas Rouhiainen) [#21523](https://github.com/nodejs/node/pull/21523)
* \[[`bc28398cbe`](https://github.com/nodejs/node/commit/bc28398cbe)] - **doc**: separate unrelated info about child\_process.exec() (Charmander) [#21516](https://github.com/nodejs/node/pull/21516)
* \[[`504c0cdd01`](https://github.com/nodejs/node/commit/504c0cdd01)] - **doc**: fix code example and formatting in crypto.md (Victor Belozyorov) [#21500](https://github.com/nodejs/node/pull/21500)
* \[[`511d610dca`](https://github.com/nodejs/node/commit/511d610dca)] - **doc**: updated docs to include --experimental-worker flag (Jo Colina) [#21461](https://github.com/nodejs/node/pull/21461)
* \[[`c050279d23`](https://github.com/nodejs/node/commit/c050279d23)] - **doc**: add bcoe as collaborator (Benjamin Coe) [#21536](https://github.com/nodejs/node/pull/21536)
* \[[`f5fc412092`](https://github.com/nodejs/node/commit/f5fc412092)] - **doc**: clarify setServers() methods in dns.md (Shivang Saxena) [#21469](https://github.com/nodejs/node/pull/21469)
* \[[`4647f61a94`](https://github.com/nodejs/node/commit/4647f61a94)] - **doc**: Improve doc for Http2 headers object (Gerhard Stoebich) [#21296](https://github.com/nodejs/node/pull/21296)
* \[[`6cca5a8b0e`](https://github.com/nodejs/node/commit/6cca5a8b0e)] - **doc**: update AUTHORS list (Michaël Zasso) [#21468](https://github.com/nodejs/node/pull/21468)
* \[[`de195d50dd`](https://github.com/nodejs/node/commit/de195d50dd)] - **doc**: update LICENSE file (Rich Trott) [#21472](https://github.com/nodejs/node/pull/21472)
* \[[`dad782165a`](https://github.com/nodejs/node/commit/dad782165a)] - **doc**: fix sort in sections, lists, tables of dns.md (Vse Mozhet Byt) [#21505](https://github.com/nodejs/node/pull/21505)
* \[[`dbd810e5d4`](https://github.com/nodejs/node/commit/dbd810e5d4)] - **doc**: show options arg to new Worker is optional (Thomas Watson) [#21508](https://github.com/nodejs/node/pull/21508)
* \[[`23598239d1`](https://github.com/nodejs/node/commit/23598239d1)] - **doc**: fix HTTP req/res 'close' description (Robert Nagy) [#21047](https://github.com/nodejs/node/pull/21047)
* \[[`02bc99daa7`](https://github.com/nodejs/node/commit/02bc99daa7)] - **doc**: correct parameters, return types in crypto.md (ZaneHannanAU) [#21420](https://github.com/nodejs/node/pull/21420)
* \[[`5bb6e5c5df`](https://github.com/nodejs/node/commit/5bb6e5c5df)] - **doc**: restore documentation for two error codes (Сковорода Никита Андреевич) [#21484](https://github.com/nodejs/node/pull/21484)
* \[[`c324b85a15`](https://github.com/nodejs/node/commit/c324b85a15)] - **doc**: sort error codes in errors.md (Сковорода Никита Андреевич) [#21485](https://github.com/nodejs/node/pull/21485)
* \[[`361e4f250c`](https://github.com/nodejs/node/commit/361e4f250c)] - **doc**: fix list format in cli.md (Vse Mozhet Byt) [#21467](https://github.com/nodejs/node/pull/21467)
* \[[`8e5104b094`](https://github.com/nodejs/node/commit/8e5104b094)] - **doc**: explain HTTP writeHead()'s fast path behavior (Gireesh Punathil) [#21289](https://github.com/nodejs/node/pull/21289)
* \[[`8a997a503c`](https://github.com/nodejs/node/commit/8a997a503c)] - **doc**: note synchronous part of child\_process.spawn (Jamie Davis) [#21234](https://github.com/nodejs/node/pull/21234)
* \[[`e94474913e`](https://github.com/nodejs/node/commit/e94474913e)] - **doc**: add example of using filter with cctest (Daniel Bevenius) [#21401](https://github.com/nodejs/node/pull/21401)
* \[[`9e3168478c`](https://github.com/nodejs/node/commit/9e3168478c)] - **doc**: fix missing parentPort link in worker\_threads (Thomas Watson) [#21430](https://github.com/nodejs/node/pull/21430)
* \[[`1e5afb7d22`](https://github.com/nodejs/node/commit/1e5afb7d22)] - **errors**: fix ERR\_MISSING\_DYNAMIC\_INSTANTIATE\_HOOK (Сковорода Никита Андреевич) [#21493](https://github.com/nodejs/node/pull/21493)
* \[[`29299cc50a`](https://github.com/nodejs/node/commit/29299cc50a)] - **esm**: loader hook URL validation and error messages (guybedford) [#21352](https://github.com/nodejs/node/pull/21352)
* \[[`2e07d4596c`](https://github.com/nodejs/node/commit/2e07d4596c)] - **fs**: undeprecate lchown() (cjihrig) [#21498](https://github.com/nodejs/node/pull/21498)
* \[[`5a71e7941d`](https://github.com/nodejs/node/commit/5a71e7941d)] - **http2**: track memory allocated by nghttp2 (Anna Henningsen) [#21374](https://github.com/nodejs/node/pull/21374)
* \[[`3ba9a445de`](https://github.com/nodejs/node/commit/3ba9a445de)] - **http2**: fix memory leak when headers are not emitted (Anna Henningsen) [#21373](https://github.com/nodejs/node/pull/21373)
* \[[`45fe865fbc`](https://github.com/nodejs/node/commit/45fe865fbc)] - **inspector**: use js\_app.html as the landing page for chrome devtools (GauthamBanasandra) [#21385](https://github.com/nodejs/node/pull/21385)
* \[[`d1b750d360`](https://github.com/nodejs/node/commit/d1b750d360)] - **inspector**: add debugging for WebSocket messages (Timothy Gu) [#21473](https://github.com/nodejs/node/pull/21473)
* \[[`0d98fe6ef9`](https://github.com/nodejs/node/commit/0d98fe6ef9)] - **lib**: fix segfault with --without-intl (Rich Trott) [#21589](https://github.com/nodejs/node/pull/21589)
* \[[`5cd78ba911`](https://github.com/nodejs/node/commit/5cd78ba911)] - **module**: experimental modules runMain separation (guybedford) [#21350](https://github.com/nodejs/node/pull/21350)
* \[[`c87037286f`](https://github.com/nodejs/node/commit/c87037286f)] - **n-api**: fix compiler warning (cjihrig) [#21597](https://github.com/nodejs/node/pull/21597)
* \[[`91384bfe5f`](https://github.com/nodejs/node/commit/91384bfe5f)] - **(SEMVER-MINOR)** **n-api**: add API for asynchronous functions (Gabriel Schulhof) [#17887](https://github.com/nodejs/node/pull/17887)
* \[[`50f833db07`](https://github.com/nodejs/node/commit/50f833db07)] - **net**: report uv\_tcp\_open() errors (cjihrig) [#21428](https://github.com/nodejs/node/pull/21428)
* \[[`881d99b3e6`](https://github.com/nodejs/node/commit/881d99b3e6)] - **net**: validate fds passed to Socket constructor (cjihrig) [#21429](https://github.com/nodejs/node/pull/21429)
* \[[`0a1e8e0172`](https://github.com/nodejs/node/commit/0a1e8e0172)] - **per\_context**: add warning to Atomics.wake (Gus Caplan) [#21518](https://github.com/nodejs/node/pull/21518)
* \[[`cd2b80c1f5`](https://github.com/nodejs/node/commit/cd2b80c1f5)] - **process**: avoid using the same fd for ipc and stdio (cjihrig) [#21466](https://github.com/nodejs/node/pull/21466)
* \[[`2d6b337df9`](https://github.com/nodejs/node/commit/2d6b337df9)] - **process**: remove unused arguments in setup() (Joyee Cheung) [#21377](https://github.com/nodejs/node/pull/21377)
* \[[`1894d6c985`](https://github.com/nodejs/node/commit/1894d6c985)] - **repl**: fix tab completion for object properties with special char (Weijia Wang) [#21556](https://github.com/nodejs/node/pull/21556)
* \[[`0550a58b08`](https://github.com/nodejs/node/commit/0550a58b08)] - **src**: remove StreamBase::kFlagHasWritev (Anna Henningsen) [#21527](https://github.com/nodejs/node/pull/21527)
* \[[`a8a7575410`](https://github.com/nodejs/node/commit/a8a7575410)] - **src**: remove extra `ReadStop()` call (Anna Henningsen) [#21528](https://github.com/nodejs/node/pull/21528)
* \[[`bb0795a5c5`](https://github.com/nodejs/node/commit/bb0795a5c5)] - **src**: slightly simplify `FSEventWrap` (Anna Henningsen) [#21533](https://github.com/nodejs/node/pull/21533)
* \[[`7acfacbee0`](https://github.com/nodejs/node/commit/7acfacbee0)] - **src**: add null check to GetCategoryGroupEnabled() (cjihrig) [#21545](https://github.com/nodejs/node/pull/21545)
* \[[`eb8d60b447`](https://github.com/nodejs/node/commit/eb8d60b447)] - **src**: move context bootstrap to js (Gus Caplan) [#21518](https://github.com/nodejs/node/pull/21518)
* \[[`54227ee133`](https://github.com/nodejs/node/commit/54227ee133)] - **src**: add native debugging code to workers (Anna Henningsen) [#21423](https://github.com/nodejs/node/pull/21423)
* \[[`e0bcb6aa17`](https://github.com/nodejs/node/commit/e0bcb6aa17)] - **src**: avoid common case heap allocation (Ben Noordhuis) [#21409](https://github.com/nodejs/node/pull/21409)
* \[[`75e07feba8`](https://github.com/nodejs/node/commit/75e07feba8)] - **src**: introduce inspect-brk-node (Daniel Bevenius) [#20819](https://github.com/nodejs/node/pull/20819)
* \[[`2377aec000`](https://github.com/nodejs/node/commit/2377aec000)] - **src**: fix debugging for multiple categories (Anna Henningsen) [#21422](https://github.com/nodejs/node/pull/21422)
* \[[`95fa3c6535`](https://github.com/nodejs/node/commit/95fa3c6535)] - **test**: add worker prefix to test-message\* tests (Michaël Zasso) [#21512](https://github.com/nodejs/node/pull/21512)
* \[[`b28fd37a69`](https://github.com/nodejs/node/commit/b28fd37a69)] - **test**: fix ESM test (Anna Henningsen) [#21605](https://github.com/nodejs/node/pull/21605)
* \[[`e7abde44db`](https://github.com/nodejs/node/commit/e7abde44db)] - **test**: add a request-response test for MessageChannel (itaysabato) [#21514](https://github.com/nodejs/node/pull/21514)
* \[[`623cf11dda`](https://github.com/nodejs/node/commit/623cf11dda)] - **test**: skip non-doc files in test-make-doc checks (Vse Mozhet Byt) [#21531](https://github.com/nodejs/node/pull/21531)
* \[[`8f1aa3c5e8`](https://github.com/nodejs/node/commit/8f1aa3c5e8)] - **test**: use aliases for smart pointers in fixture (Daniel Bevenius) [#21419](https://github.com/nodejs/node/pull/21419)
* \[[`7e10697ba0`](https://github.com/nodejs/node/commit/7e10697ba0)] - **test**: make cctest fixture use node::NewIsolate (Daniel Bevenius) [#21419](https://github.com/nodejs/node/pull/21419)
* \[[`9f2bf3c1b3`](https://github.com/nodejs/node/commit/9f2bf3c1b3)] - **test**: add some test cases for validateOffsetLengthWrite (Keita Akutsu) [#21195](https://github.com/nodejs/node/pull/21195)
* \[[`245c885abb`](https://github.com/nodejs/node/commit/245c885abb)] - **test**: fix test-net-socket-constructor (Santiago Gimeno) [#21466](https://github.com/nodejs/node/pull/21466)
* \[[`357eaf3c95`](https://github.com/nodejs/node/commit/357eaf3c95)] - **test**: lint fixes for ESLint update (cjihrig) [#20855](https://github.com/nodejs/node/pull/20855)
* \[[`bfac7beaf5`](https://github.com/nodejs/node/commit/bfac7beaf5)] - **test**: move net bytes-per-chunk test to sequential (Rich Trott) [#21457](https://github.com/nodejs/node/pull/21457)
* \[[`91f111fcb2`](https://github.com/nodejs/node/commit/91f111fcb2)] - **test**: remove string error from strictEqual (Fernando Doglio) [#21292](https://github.com/nodejs/node/pull/21292)
* \[[`2fa49a39e6`](https://github.com/nodejs/node/commit/2fa49a39e6)] - **test**: add tests for end event of stream.Duplex (Masashi Hirano) [#21325](https://github.com/nodejs/node/pull/21325)
* \[[`6b40ba11c1`](https://github.com/nodejs/node/commit/6b40ba11c1)] - **test**: avoid running fsync on directory on AIX (John Barboza) [#21298](https://github.com/nodejs/node/pull/21298)
* \[[`e038b2fa9a`](https://github.com/nodejs/node/commit/e038b2fa9a)] - **test**: assert process.setgroups is undefined on windows (Masashi Hirano) [#21286](https://github.com/nodejs/node/pull/21286)
* \[[`d7ff752e9e`](https://github.com/nodejs/node/commit/d7ff752e9e)] - **test**: add tests for process.setgroups() (Masashi Hirano) [#21286](https://github.com/nodejs/node/pull/21286)
* \[[`81046f94ff`](https://github.com/nodejs/node/commit/81046f94ff)] - **test**: move net bytes-per-chunk test to parallel (Anna Henningsen) [#21322](https://github.com/nodejs/node/pull/21322)
* \[[`9cef72dd21`](https://github.com/nodejs/node/commit/9cef72dd21)] - **test**: remove the third string literal argument from assert.strictEqual() (Kevin Thomas) [#21406](https://github.com/nodejs/node/pull/21406)
* \[[`23f22bc614`](https://github.com/nodejs/node/commit/23f22bc614)] - **test**: check that benchmark tests are minimal (Rich Trott) [#21046](https://github.com/nodejs/node/pull/21046)
* \[[`29593e20d5`](https://github.com/nodejs/node/commit/29593e20d5)] - **test**: run misc benchmark only once in tests (Rich Trott) [#21046](https://github.com/nodejs/node/pull/21046)
* \[[`f461ae2f45`](https://github.com/nodejs/node/commit/f461ae2f45)] - **test**: move test-benchmark-path to sequential (Rich Trott) [#21393](https://github.com/nodejs/node/pull/21393)
* \[[`5d6d6fb121`](https://github.com/nodejs/node/commit/5d6d6fb121)] - **tools**: build all.html by combining generated HTML (Sam Ruby) [#21568](https://github.com/nodejs/node/pull/21568)
* \[[`21d73a5869`](https://github.com/nodejs/node/commit/21d73a5869)] - **tools**: update ESLint to 5.0.0 (cjihrig) [#20855](https://github.com/nodejs/node/pull/20855)
* \[[`a1580a0c4e`](https://github.com/nodejs/node/commit/a1580a0c4e)] - **tools**: fix typo in .eslintrc.js (Christopher Hiller) [#21449](https://github.com/nodejs/node/pull/21449)
* \[[`7cc979d4d3`](https://github.com/nodejs/node/commit/7cc979d4d3)] - **(SEMVER-MINOR)** **util**: recover from maximum call stack size (Ruben Bridgewater) [#20725](https://github.com/nodejs/node/pull/20725)
* \[[`140836a1bc`](https://github.com/nodejs/node/commit/140836a1bc)] - **util**: fix comment typos (Renée Kooi) [#21436](https://github.com/nodejs/node/pull/21436)
* \[[`4fc05ac7e1`](https://github.com/nodejs/node/commit/4fc05ac7e1)] - **(SEMVER-MINOR)** **vm**: add Script.createCodeCache() (Gus Caplan) [#20300](https://github.com/nodejs/node/pull/20300)
* \[[`97b21862f5`](https://github.com/nodejs/node/commit/97b21862f5)] - **(SEMVER-MINOR)** **win, build**: generate .sln only when necessary (Bartosz Sosnowski) [#21284](https://github.com/nodejs/node/pull/21284)
* \[[`ba8ee17de5`](https://github.com/nodejs/node/commit/ba8ee17de5)] - **win, build**: fix building on 32-bit machines (Bartosz Sosnowski) [#21437](https://github.com/nodejs/node/pull/21437)
* \[[`206e5bf7af`](https://github.com/nodejs/node/commit/206e5bf7af)] - **worker**: support relative paths (itaysabato) [#21407](https://github.com/nodejs/node/pull/21407)
* \[[`41c4b2c76a`](https://github.com/nodejs/node/commit/41c4b2c76a)] - **workers**: add test for messagePort.onmessage (Michaël Zasso) [#21510](https://github.com/nodejs/node/pull/21510)
* \[[`49706b44b7`](https://github.com/nodejs/node/commit/49706b44b7)] - **workers**: replace message types string by constants (Weijia Wang) [#21537](https://github.com/nodejs/node/pull/21537)
* \[[`fb2592ff12`](https://github.com/nodejs/node/commit/fb2592ff12)] - **workers,trace\_events**: set thread name for workers (James M Snell) [#21246](https://github.com/nodejs/node/pull/21246)

<a id="10.5.0"></a>

## 2018-06-20, Version 10.5.0 (Current), @targos

### Notable Changes

* **crypto**:
  * Support for `crypto.scrypt()` has been added. [#20816](https://github.com/nodejs/node/pull/20816)
* **fs**:
  * BigInt support has been added to `fs.stat` and `fs.watchFile`. [#20220](https://github.com/nodejs/node/pull/20220)
  * APIs that take `mode` as arguments no longer throw on values larger than
    `0o777`. [#20636](https://github.com/nodejs/node/pull/20636) [#20975](https://github.com/nodejs/node/pull/20975) (Fixes: [#20498](https://github.com/nodejs/node/issues/20498))
  * Fix crashes in closed event watchers. [#20985](https://github.com/nodejs/node/pull/20985) (Fixes: [#20297](https://github.com/nodejs/node/issues/20297))
* **Worker Threads**:
  * Support for multi-threading has been added behind the
    `--experimental-worker` flag in the `worker_threads` module. This feature
    is _experimental_ and may receive breaking changes at any time. [#20876](https://github.com/nodejs/node/pull/20876)

### Commits

* \[[`a6986fe8b6`](https://github.com/nodejs/node/commit/a6986fe8b6)] - **async\_hooks**: remove deprecated example (Mathias Buus) [#20998](https://github.com/nodejs/node/pull/20998)
* \[[`4b9817bf1e`](https://github.com/nodejs/node/commit/4b9817bf1e)] - **benchmark**: disable only the ESLint rule needing it (Rich Trott) [#21133](https://github.com/nodejs/node/pull/21133)
* \[[`ecba1c57b1`](https://github.com/nodejs/node/commit/ecba1c57b1)] - **(SEMVER-MINOR)** **benchmark**: port cluster/echo to worker (Timothy Gu) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`02adb2d62c`](https://github.com/nodejs/node/commit/02adb2d62c)] - **(SEMVER-MINOR)** **build**: expose openssl scrypt functions to addons (Ben Noordhuis) [#20816](https://github.com/nodejs/node/pull/20816)
* \[[`c3fbac432f`](https://github.com/nodejs/node/commit/c3fbac432f)] - **build**: install markdown linter for travis (Richard Lau) [#21215](https://github.com/nodejs/node/pull/21215)
* \[[`896017b134`](https://github.com/nodejs/node/commit/896017b134)] - **build**: build addon tests in parallel (Anna Henningsen) [#21155](https://github.com/nodejs/node/pull/21155)
* \[[`76927fc734`](https://github.com/nodejs/node/commit/76927fc734)] - **build**: stop distclean from deleting v8 files (Ujjwal Sharma) [#21164](https://github.com/nodejs/node/pull/21164)
* \[[`b044256f2a`](https://github.com/nodejs/node/commit/b044256f2a)] - **build**: use LC\_ALL of C for maximum compatibility (Rich Trott) [#21222](https://github.com/nodejs/node/pull/21222)
* \[[`78c7d666fb`](https://github.com/nodejs/node/commit/78c7d666fb)] - **build**: don't change locale on smartos (Refael Ackermann) [#21220](https://github.com/nodejs/node/pull/21220)
* \[[`c688a00a6d`](https://github.com/nodejs/node/commit/c688a00a6d)] - **build**: fix 'gas\_version' check on localized environments (Evandro Oliveira) [#20394](https://github.com/nodejs/node/pull/20394)
* \[[`79b3423fb5`](https://github.com/nodejs/node/commit/79b3423fb5)] - **build**: initial .travis.yml implementation (Anna Henningsen) [#21059](https://github.com/nodejs/node/pull/21059)
* \[[`ea4be72f22`](https://github.com/nodejs/node/commit/ea4be72f22)] - **child\_process**: swallow errors in internal communication (Anatoli Papirovski) [#21108](https://github.com/nodejs/node/pull/21108)
* \[[`9981220e2a`](https://github.com/nodejs/node/commit/9981220e2a)] - **crypto**: fix behavior of createCipher in wrap mode (Tobias Nießen) [#21287](https://github.com/nodejs/node/pull/21287)
* \[[`d0cb9cbb35`](https://github.com/nodejs/node/commit/d0cb9cbb35)] - **(SEMVER-MINOR)** **crypto**: drop Math.pow(), use static exponentation (Ben Noordhuis) [#20816](https://github.com/nodejs/node/pull/20816)
* \[[`2d9c3cc89d`](https://github.com/nodejs/node/commit/2d9c3cc89d)] - **(SEMVER-MINOR)** **crypto**: refactor randomBytes() (Ben Noordhuis) [#20816](https://github.com/nodejs/node/pull/20816)
* \[[`6262fa44d6`](https://github.com/nodejs/node/commit/6262fa44d6)] - **(SEMVER-MINOR)** **crypto**: refactor pbkdf2() and pbkdf2Sync() methods (Ben Noordhuis) [#20816](https://github.com/nodejs/node/pull/20816)
* \[[`c9b4592dbf`](https://github.com/nodejs/node/commit/c9b4592dbf)] - **(SEMVER-MINOR)** **crypto**: add scrypt() and scryptSync() methods (Ben Noordhuis) [#20816](https://github.com/nodejs/node/pull/20816)
* \[[`495756264a`](https://github.com/nodejs/node/commit/495756264a)] - **(SEMVER-MINOR)** **crypto**: DRY type checking (Ben Noordhuis) [#20816](https://github.com/nodejs/node/pull/20816)
* \[[`e4a7e0d28b`](https://github.com/nodejs/node/commit/e4a7e0d28b)] - **deps**: float ea7abee from openssl / CVE-2018-0732 (Rod Vagg) [#21282](https://github.com/nodejs/node/pull/21282)
* \[[`0b90b071c4`](https://github.com/nodejs/node/commit/0b90b071c4)] - **deps**: Upgrade node-inspect to 1.11.5 (Jan Krems) [#21055](https://github.com/nodejs/node/pull/21055)
* \[[`ffc29c12da`](https://github.com/nodejs/node/commit/ffc29c12da)] - **deps**: patch V8 to 6.7.288.46 (Myles Borins) [#21260](https://github.com/nodejs/node/pull/21260)
* \[[`14bb905d18`](https://github.com/nodejs/node/commit/14bb905d18)] - **deps**: V8: cherry-pick a440efb27f from upstream (Yang Guo) [#21022](https://github.com/nodejs/node/pull/21022)
* \[[`65b9c427ac`](https://github.com/nodejs/node/commit/65b9c427ac)] - **dns**: improve setServers() errors and performance (Jamie Davis) [#20445](https://github.com/nodejs/node/pull/20445)
* \[[`bc20ec0c0f`](https://github.com/nodejs/node/commit/bc20ec0c0f)] - **doc**: eliminate \_you\_ from N-API doc (Rich Trott) [#21382](https://github.com/nodejs/node/pull/21382)
* \[[`318d6831bf`](https://github.com/nodejs/node/commit/318d6831bf)] - **doc**: use imperative in COLLABORATOR\_GUIDE (Rich Trott) [#21340](https://github.com/nodejs/node/pull/21340)
* \[[`177a7c06a8`](https://github.com/nodejs/node/commit/177a7c06a8)] - **doc**: remove obsolete wiki references from BUILDING (Rich Trott) [#21369](https://github.com/nodejs/node/pull/21369)
* \[[`15023df050`](https://github.com/nodejs/node/commit/15023df050)] - **doc**: add davisjam to collaborators (Jamie Davis) [#21273](https://github.com/nodejs/node/pull/21273)
* \[[`17c21b67ac`](https://github.com/nodejs/node/commit/17c21b67ac)] - **doc**: fix indentation in console.md (Vse Mozhet Byt) [#21367](https://github.com/nodejs/node/pull/21367)
* \[[`ef74368416`](https://github.com/nodejs/node/commit/ef74368416)] - **doc**: fix heading of optional console method args (Michaël Zasso) [#21311](https://github.com/nodejs/node/pull/21311)
* \[[`4f17841c20`](https://github.com/nodejs/node/commit/4f17841c20)] - **doc**: use Class Method label consistently (Rich Trott) [#21357](https://github.com/nodejs/node/pull/21357)
* \[[`4566ebacf4`](https://github.com/nodejs/node/commit/4566ebacf4)] - **doc**: wrap style guide at 80 characters (Rich Trott) [#21361](https://github.com/nodejs/node/pull/21361)
* \[[`6c41f33571`](https://github.com/nodejs/node/commit/6c41f33571)] - **doc**: wrap pull-requests.md at 80 characters (Rich Trott) [#21361](https://github.com/nodejs/node/pull/21361)
* \[[`b8213f17cc`](https://github.com/nodejs/node/commit/b8213f17cc)] - **doc**: remove linking of url text to url (Rich Trott) [#21361](https://github.com/nodejs/node/pull/21361)
* \[[`3f78220c2b`](https://github.com/nodejs/node/commit/3f78220c2b)] - **doc**: correct styling of \_GitHub\_ in onboarding doc (Rich Trott) [#21361](https://github.com/nodejs/node/pull/21361)
* \[[`9e994cb119`](https://github.com/nodejs/node/commit/9e994cb119)] - **doc**: wrap releases.md at 80 chars (Rich Trott) [#21361](https://github.com/nodejs/node/pull/21361)
* \[[`e00e5e6d5d`](https://github.com/nodejs/node/commit/e00e5e6d5d)] - **doc**: switch the order of Writable and Readable (Joseph Gordon) [#21333](https://github.com/nodejs/node/pull/21333)
* \[[`e1b571d6b7`](https://github.com/nodejs/node/commit/e1b571d6b7)] - **doc**: make Deprecation cycle explanation more brief (Rich Trott) [#21303](https://github.com/nodejs/node/pull/21303)
* \[[`df0f7a3b4d`](https://github.com/nodejs/node/commit/df0f7a3b4d)] - **doc**: clarify async execute callback usage (Michael Dawson) [#21217](https://github.com/nodejs/node/pull/21217)
* \[[`c5a65594ef`](https://github.com/nodejs/node/commit/c5a65594ef)] - **doc**: move 5 collaborators to emeritus status (Rich Trott) [#21272](https://github.com/nodejs/node/pull/21272)
* \[[`c1d53f86f8`](https://github.com/nodejs/node/commit/c1d53f86f8)] - **doc**: update NODE\_OPTIONS section in cli.md (Vse Mozhet Byt) [#21229](https://github.com/nodejs/node/pull/21229)
* \[[`13fd09bfa7`](https://github.com/nodejs/node/commit/13fd09bfa7)] - **doc**: add build wg info to releases.md (Jon Moss) [#21275](https://github.com/nodejs/node/pull/21275)
* \[[`0da910f9a5`](https://github.com/nodejs/node/commit/0da910f9a5)] - **doc**: move Italo A. Casas to Release Emeritus (Myles Borins) [#21315](https://github.com/nodejs/node/pull/21315)
* \[[`6f7de0b8d9`](https://github.com/nodejs/node/commit/6f7de0b8d9)] - **doc**: trim deprecation level definition text (Rich Trott) [#21241](https://github.com/nodejs/node/pull/21241)
* \[[`dd2fc90dcf`](https://github.com/nodejs/node/commit/dd2fc90dcf)] - **doc**: fix reference to workerData in worker\_threads (Jeremiah Senkpiel) [#21180](https://github.com/nodejs/node/pull/21180)
* \[[`5e46c16371`](https://github.com/nodejs/node/commit/5e46c16371)] - **doc**: fix type in stream doc (Aliaksei Tuzik) [#21178](https://github.com/nodejs/node/pull/21178)
* \[[`85dc9ac418`](https://github.com/nodejs/node/commit/85dc9ac418)] - **doc**: add Michaël Zasso to Release team (Michaël Zasso) [#21114](https://github.com/nodejs/node/pull/21114)
* \[[`5fa5ab6c48`](https://github.com/nodejs/node/commit/5fa5ab6c48)] - **doc**: naming function as suggested in addon docs (Tommaso Allevi) [#21067](https://github.com/nodejs/node/pull/21067)
* \[[`fe5d35123b`](https://github.com/nodejs/node/commit/fe5d35123b)] - **(SEMVER-MINOR)** **doc**: document BigInt support in fs.Stats (Joyee Cheung) [#20220](https://github.com/nodejs/node/pull/20220)
* \[[`2c4f80ffba`](https://github.com/nodejs/node/commit/2c4f80ffba)] - **doc**: remove spaces around slashes (Rich Trott) [#21140](https://github.com/nodejs/node/pull/21140)
* \[[`72e7e1da2d`](https://github.com/nodejs/node/commit/72e7e1da2d)] - **doc**: alphabetize tls options (Rich Trott) [#21139](https://github.com/nodejs/node/pull/21139)
* \[[`06ac81e786`](https://github.com/nodejs/node/commit/06ac81e786)] - **doc**: streamline errors.md introductory material (Rich Trott) [#21138](https://github.com/nodejs/node/pull/21138)
* \[[`73b8975b41`](https://github.com/nodejs/node/commit/73b8975b41)] - **doc**: simplify deprecation language (Rich Trott) [#21136](https://github.com/nodejs/node/pull/21136)
* \[[`6caa354377`](https://github.com/nodejs/node/commit/6caa354377)] - **(SEMVER-MINOR)** **doc**: explain Worker semantics in async\_hooks.md (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`9f9355d6d2`](https://github.com/nodejs/node/commit/9f9355d6d2)] - **doc**: fix inconsistent documentation (host vs hostname) (Davis Okoth) [#20933](https://github.com/nodejs/node/pull/20933)
* \[[`a5c571424a`](https://github.com/nodejs/node/commit/a5c571424a)] - **doc**: document file mode caveats on Windows (Joyee Cheung) [#20636](https://github.com/nodejs/node/pull/20636)
* \[[`a75e44d135`](https://github.com/nodejs/node/commit/a75e44d135)] - **esm**: ensure require.main for CJS top-level loads (Guy Bedford) [#21150](https://github.com/nodejs/node/pull/21150)
* \[[`04e8f0749e`](https://github.com/nodejs/node/commit/04e8f0749e)] - **(SEMVER-MINOR)** **fs**: support BigInt in fs.\*stat and fs.watchFile (Joyee Cheung) [#20220](https://github.com/nodejs/node/pull/20220)
* \[[`c09bfd81b7`](https://github.com/nodejs/node/commit/c09bfd81b7)] - **fs**: do not crash when using a closed fs event watcher (Joyee Cheung) [#20985](https://github.com/nodejs/node/pull/20985)
* \[[`bacb2cb550`](https://github.com/nodejs/node/commit/bacb2cb550)] - **fs**: refactor fs module (James M Snell) [#20764](https://github.com/nodejs/node/pull/20764)
* \[[`db0bb5214a`](https://github.com/nodejs/node/commit/db0bb5214a)] - **fs**: improve fchmod{Sync} validation (cjihrig) [#20588](https://github.com/nodejs/node/pull/20588)
* \[[`2ffb9d6b5c`](https://github.com/nodejs/node/commit/2ffb9d6b5c)] - **fs**: drop duplicate API in promises mode (Сковорода Никита Андреевич) [#20559](https://github.com/nodejs/node/pull/20559)
* \[[`fc0b3610e2`](https://github.com/nodejs/node/commit/fc0b3610e2)] - **fs**: don't limit ftruncate() length to 32 bits (cjihrig) [#20851](https://github.com/nodejs/node/pull/20851)
* \[[`469baa062e`](https://github.com/nodejs/node/commit/469baa062e)] - **fs**: add length validation to fs.truncate() (cjihrig) [#20851](https://github.com/nodejs/node/pull/20851)
* \[[`6aade4a765`](https://github.com/nodejs/node/commit/6aade4a765)] - **http**: remove a pair of outdated comments (Mark S. Everitt) [#21214](https://github.com/nodejs/node/pull/21214)
* \[[`bcaf59c739`](https://github.com/nodejs/node/commit/bcaf59c739)] - **http2**: fix memory leak for uncommon headers (Anna Henningsen) [#21336](https://github.com/nodejs/node/pull/21336)
* \[[`dee250fd77`](https://github.com/nodejs/node/commit/dee250fd77)] - **http2**: safer Http2Session destructor (Anatoli Papirovski) [#21194](https://github.com/nodejs/node/pull/21194)
* \[[`296fd57324`](https://github.com/nodejs/node/commit/296fd57324)] - **inspector**: stop dragging platform pointer (Eugene Ostroukhov)
* \[[`fb71337bdf`](https://github.com/nodejs/node/commit/fb71337bdf)] - **(SEMVER-MINOR)** **lib**: rename checkIsArrayBufferView() (Ben Noordhuis) [#20816](https://github.com/nodejs/node/pull/20816)
* \[[`f3570f201b`](https://github.com/nodejs/node/commit/f3570f201b)] - **(SEMVER-MINOR)** **lib**: replace checkUint() with validateInt32() (Ben Noordhuis) [#20816](https://github.com/nodejs/node/pull/20816)
* \[[`b4b7d368be`](https://github.com/nodejs/node/commit/b4b7d368be)] - **lib**: unmask mode\_t values with 0o777 (Joyee Cheung) [#20975](https://github.com/nodejs/node/pull/20975)
* \[[`36e5100a39`](https://github.com/nodejs/node/commit/36e5100a39)] - **lib**: support ranges in validateInt32() (cjihrig) [#20588](https://github.com/nodejs/node/pull/20588)
* \[[`2fe88d2218`](https://github.com/nodejs/node/commit/2fe88d2218)] - **lib**: mask mode\_t type of arguments with 0o777 (Joyee Cheung) [#20636](https://github.com/nodejs/node/pull/20636)
* \[[`a0cfb0c9d4`](https://github.com/nodejs/node/commit/a0cfb0c9d4)] - **lib**: add validateInteger() validator (cjihrig) [#20851](https://github.com/nodejs/node/pull/20851)
* \[[`740d9f1a0e`](https://github.com/nodejs/node/commit/740d9f1a0e)] - **lib,src**: make `StatWatcher` a `HandleWrap` (Anna Henningsen) [#21244](https://github.com/nodejs/node/pull/21244)
* \[[`a657984109`](https://github.com/nodejs/node/commit/a657984109)] - **lib,src**: remove openssl feature conditionals (Ben Noordhuis) [#21094](https://github.com/nodejs/node/pull/21094)
* \[[`653b20b26d`](https://github.com/nodejs/node/commit/653b20b26d)] - **loader**: remove unused error code in module\_job (Gus Caplan) [#21354](https://github.com/nodejs/node/pull/21354)
* \[[`5d3dfedca2`](https://github.com/nodejs/node/commit/5d3dfedca2)] - **meta**: remove CODEOWNERS (Rich Trott) [#21161](https://github.com/nodejs/node/pull/21161)
* \[[`169bff3e9e`](https://github.com/nodejs/node/commit/169bff3e9e)] - **n-api**: name CallbackBundle function fields (Anna Henningsen) [#21240](https://github.com/nodejs/node/pull/21240)
* \[[`1dc9330b3a`](https://github.com/nodejs/node/commit/1dc9330b3a)] - **n-api**: improve runtime perf of n-api func call (Kenny Yuan) [#21072](https://github.com/nodejs/node/pull/21072)
* \[[`9047c8182c`](https://github.com/nodejs/node/commit/9047c8182c)] - **n-api**: remove unused napi\_env member (Gabriel Schulhof) [#21127](https://github.com/nodejs/node/pull/21127)
* \[[`18c057ab26`](https://github.com/nodejs/node/commit/18c057ab26)] - **net**: emit 'close' when socket ends before connect (Brett Kiefer) [#21290](https://github.com/nodejs/node/pull/21290)
* \[[`a3fd1cd8ea`](https://github.com/nodejs/node/commit/a3fd1cd8ea)] - **perf\_hooks**: remove less useful bootstrap marks (James M Snell) [#21247](https://github.com/nodejs/node/pull/21247)
* \[[`8fddf591c5`](https://github.com/nodejs/node/commit/8fddf591c5)] - **perf\_hooks**: set bootstrap complete in only one place (James M Snell) [#21247](https://github.com/nodejs/node/pull/21247)
* \[[`fc2956d37a`](https://github.com/nodejs/node/commit/fc2956d37a)] - **process**: backport process/methods file (Michaël Zasso) [#21172](https://github.com/nodejs/node/pull/21172)
* \[[`78ad4e9dde`](https://github.com/nodejs/node/commit/78ad4e9dde)] - **src**: remove unused argc var in node\_stat\_watcher (Daniel Bevenius) [#21337](https://github.com/nodejs/node/pull/21337)
* \[[`7fa1344143`](https://github.com/nodejs/node/commit/7fa1344143)] - **src**: use `%zx` in printf for size\_t (Anna Henningsen) [#21323](https://github.com/nodejs/node/pull/21323)
* \[[`671346ee8f`](https://github.com/nodejs/node/commit/671346ee8f)] - **src**: do proper error checking in `AsyncWrap::MakeCallback` (Anna Henningsen) [#21189](https://github.com/nodejs/node/pull/21189)
* \[[`aa468abc4c`](https://github.com/nodejs/node/commit/aa468abc4c)] - **src**: unify native symbol inspection code (Anna Henningsen) [#21238](https://github.com/nodejs/node/pull/21238)
* \[[`e92b89a75d`](https://github.com/nodejs/node/commit/e92b89a75d)] - **src**: fix http2 typos (Anatoli Papirovski) [#21194](https://github.com/nodejs/node/pull/21194)
* \[[`4f01168414`](https://github.com/nodejs/node/commit/4f01168414)] - **src**: do not persist fs\_poll handle in stat\_watcher (Anatoli Papirovski) [#21093](https://github.com/nodejs/node/pull/21093)
* \[[`685b9b2a6a`](https://github.com/nodejs/node/commit/685b9b2a6a)] - **src**: do not persist timer handle in cares\_wrap (Anatoli Papirovski) [#21093](https://github.com/nodejs/node/pull/21093)
* \[[`4757771db3`](https://github.com/nodejs/node/commit/4757771db3)] - **src**: add consistency check to node\_platform.cc (Anna Henningsen) [#21156](https://github.com/nodejs/node/pull/21156)
* \[[`8e2e16721b`](https://github.com/nodejs/node/commit/8e2e16721b)] - **src**: add node\_encoding.cc (James M Snell) [#21112](https://github.com/nodejs/node/pull/21112)
* \[[`39b38754eb`](https://github.com/nodejs/node/commit/39b38754eb)] - **src**: cleanup beforeExit for consistency (James M Snell) [#21113](https://github.com/nodejs/node/pull/21113)
* \[[`314b47d1cf`](https://github.com/nodejs/node/commit/314b47d1cf)] - **(SEMVER-MINOR)** **src**: add Env::profiler\_idle\_notifier\_started() (Timothy Gu) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`5209ff9562`](https://github.com/nodejs/node/commit/5209ff9562)] - **(SEMVER-MINOR)** **src**: remove unused fields msg\_ and env\_ (Daniel Bevenius) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`9a734132f9`](https://github.com/nodejs/node/commit/9a734132f9)] - **(SEMVER-MINOR)** **src**: make handle onclose property a Symbol (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`e6f06807b1`](https://github.com/nodejs/node/commit/e6f06807b1)] - **(SEMVER-MINOR)** **src**: simplify handle closing (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`65924c70e8`](https://github.com/nodejs/node/commit/65924c70e8)] - **(SEMVER-MINOR)** **src**: remove unused fields isolate\_ (Daniel Bevenius) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`de7403f813`](https://github.com/nodejs/node/commit/de7403f813)] - **(SEMVER-MINOR)** **src**: cleanup per-isolate state on platform on isolate unregister (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`ba17c9e46b`](https://github.com/nodejs/node/commit/ba17c9e46b)] - **src**: refactor bootstrap to use bootstrap object (James M Snell) [#20917](https://github.com/nodejs/node/pull/20917)
* \[[`cbdc1fdf44`](https://github.com/nodejs/node/commit/cbdc1fdf44)] - **src, tools**: add check for left leaning pointers (Daniel Bevenius) [#21010](https://github.com/nodejs/node/pull/21010)
* \[[`935309325b`](https://github.com/nodejs/node/commit/935309325b)] - **test**: fix deprecation warning due to util.print (Tobias Nießen) [#21265](https://github.com/nodejs/node/pull/21265)
* \[[`d7ba75f8aa`](https://github.com/nodejs/node/commit/d7ba75f8aa)] - **test**: add test to check colorMode type of Console (Masashi Hirano) [#21248](https://github.com/nodejs/node/pull/21248)
* \[[`0b00172df8`](https://github.com/nodejs/node/commit/0b00172df8)] - **test**: removing unnecessary parameter from assert call (djmgit) [#21307](https://github.com/nodejs/node/pull/21307)
* \[[`dea3ac7bff`](https://github.com/nodejs/node/commit/dea3ac7bff)] - **test**: improve statwatcher async\_hooks test (Anna Henningsen) [#21244](https://github.com/nodejs/node/pull/21244)
* \[[`792335f712`](https://github.com/nodejs/node/commit/792335f712)] - **test**: add workerdata-sharedarraybuffer test (Jeremiah Senkpiel) [#21180](https://github.com/nodejs/node/pull/21180)
* \[[`e8d15cb149`](https://github.com/nodejs/node/commit/e8d15cb149)] - **test**: mark test-inspector-port-zero-cluster flaky (Rich Trott) [#21251](https://github.com/nodejs/node/pull/21251)
* \[[`688bdfef7f`](https://github.com/nodejs/node/commit/688bdfef7f)] - **test**: add crypto check to test-http2-debug (Daniel Bevenius) [#21205](https://github.com/nodejs/node/pull/21205)
* \[[`2270ab2a12`](https://github.com/nodejs/node/commit/2270ab2a12)] - **test**: remove string literals from assert.strictEqual() calls (James Kylstra) [#21211](https://github.com/nodejs/node/pull/21211)
* \[[`187951c0fc`](https://github.com/nodejs/node/commit/187951c0fc)] - **test**: move inspector-stress-http to sequential (Rich Trott) [#21227](https://github.com/nodejs/node/pull/21227)
* \[[`bda34ea203`](https://github.com/nodejs/node/commit/bda34ea203)] - **test**: check gc does not resurrect the loop (Anatoli Papirovski) [#21093](https://github.com/nodejs/node/pull/21093)
* \[[`4d782c4720`](https://github.com/nodejs/node/commit/4d782c4720)] - **test**: improve assert error messages (Hristijan Gjorgjievski) [#21160](https://github.com/nodejs/node/pull/21160)
* \[[`2655c7b194`](https://github.com/nodejs/node/commit/2655c7b194)] - **test**: mark fs-readfile-tostring-fail flaky for all (Rich Trott) [#21177](https://github.com/nodejs/node/pull/21177)
* \[[`17954c2b01`](https://github.com/nodejs/node/commit/17954c2b01)] - **test**: improve internal/buffer.js test coverage (Masashi Hirano) [#21061](https://github.com/nodejs/node/pull/21061)
* \[[`2ff4704447`](https://github.com/nodejs/node/commit/2ff4704447)] - **test**: move test-readuint to test-buffer-readuint (Michaël Zasso) [#21170](https://github.com/nodejs/node/pull/21170)
* \[[`9c3a7bf076`](https://github.com/nodejs/node/commit/9c3a7bf076)] - **test**: make url-util-format engine agnostic (Rich Trott) [#21141](https://github.com/nodejs/node/pull/21141)
* \[[`3d8ec8f85c`](https://github.com/nodejs/node/commit/3d8ec8f85c)] - **test**: make url-parse-invalid-input engine agnostic (Rich Trott) [#21132](https://github.com/nodejs/node/pull/21132)
* \[[`0b0370f884`](https://github.com/nodejs/node/commit/0b0370f884)] - **test**: remove unref in http2 test (Anatoli Papirovski) [#21145](https://github.com/nodejs/node/pull/21145)
* \[[`14a017cf8d`](https://github.com/nodejs/node/commit/14a017cf8d)] - **test**: apply promises API to fourth appendFile test (Rich Trott) [#21131](https://github.com/nodejs/node/pull/21131)
* \[[`aa9dbf666b`](https://github.com/nodejs/node/commit/aa9dbf666b)] - **test**: apply promises API to fourth appendFile test (Rich Trott) [#21131](https://github.com/nodejs/node/pull/21131)
* \[[`185b9e45d3`](https://github.com/nodejs/node/commit/185b9e45d3)] - **test**: apply promises API to third appendFile test (Rich Trott) [#21131](https://github.com/nodejs/node/pull/21131)
* \[[`c400448e85`](https://github.com/nodejs/node/commit/c400448e85)] - **test**: improve debug output in trace-events test (Rich Trott) [#21120](https://github.com/nodejs/node/pull/21120)
* \[[`a4ad9891e3`](https://github.com/nodejs/node/commit/a4ad9891e3)] - **test**: add test for Linux perf (Matheus Marchini) [#20783](https://github.com/nodejs/node/pull/20783)
* \[[`e16036c462`](https://github.com/nodejs/node/commit/e16036c462)] - **test**: create new directory v8-updates (Matheus Marchini) [#20783](https://github.com/nodejs/node/pull/20783)
* \[[`93ce63c89f`](https://github.com/nodejs/node/commit/93ce63c89f)] - **(SEMVER-MINOR)** **test**: add test against unsupported worker features (Timothy Gu) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`94dcdfb898`](https://github.com/nodejs/node/commit/94dcdfb898)] - **test**: increase coverage for fs.promises.truncate (Masashi Hirano) [#20638](https://github.com/nodejs/node/pull/20638)
* \[[`c9cee63179`](https://github.com/nodejs/node/commit/c9cee63179)] - **test,tools**: refactor custom ESLint for readability (Rich Trott) [#21134](https://github.com/nodejs/node/pull/21134)
* \[[`ed05d9a821`](https://github.com/nodejs/node/commit/ed05d9a821)] - **(SEMVER-MINOR)** **test,tools**: enable running tests under workers (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`6285fe94f6`](https://github.com/nodejs/node/commit/6285fe94f6)] - **tools**: do not disable `quotes` rule in .eslintrc.js (Rich Trott) [#21338](https://github.com/nodejs/node/pull/21338)
* \[[`98346de08c`](https://github.com/nodejs/node/commit/98346de08c)] - **tools**: lint doc/\*.md files (Rich Trott) [#21361](https://github.com/nodejs/node/pull/21361)
* \[[`521f8f1d95`](https://github.com/nodejs/node/commit/521f8f1d95)] - **tools**: add BigInt64Array and BigUint64Array to globals (Joyee Cheung) [#21255](https://github.com/nodejs/node/pull/21255)
* \[[`a5c386d1ba`](https://github.com/nodejs/node/commit/a5c386d1ba)] - **tools**: add option to use custom template with js2c.py (Shelley Vohr) [#21187](https://github.com/nodejs/node/pull/21187)
* \[[`7f70fe83ef`](https://github.com/nodejs/node/commit/7f70fe83ef)] - **tools**: add BigInt to globals (Nikolai Vavilov) [#21237](https://github.com/nodejs/node/pull/21237)
* \[[`4e742e379b`](https://github.com/nodejs/node/commit/4e742e379b)] - **tools**: update tooling to work with new macOS CLI … (Rich Trott) [#21173](https://github.com/nodejs/node/pull/21173)
* \[[`ed2b57bcd5`](https://github.com/nodejs/node/commit/ed2b57bcd5)] - **tools**: remove unused global types from type-parser (Rich Trott) [#21135](https://github.com/nodejs/node/pull/21135)
* \[[`d46446afc5`](https://github.com/nodejs/node/commit/d46446afc5)] - **v8**: replace Buffer with FastBuffer in deserialize (Ujjwal Sharma) [#21196](https://github.com/nodejs/node/pull/21196)
* \[[`917960e0a1`](https://github.com/nodejs/node/commit/917960e0a1)] - **win, build**: add documentation support to vcbuild (Bartosz Sosnowski) [#19663](https://github.com/nodejs/node/pull/19663)
* \[[`03fbc9e749`](https://github.com/nodejs/node/commit/03fbc9e749)] - **(SEMVER-MINOR)** **worker**: rename to worker\_threads (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`9ad42b766e`](https://github.com/nodejs/node/commit/9ad42b766e)] - **(SEMVER-MINOR)** **worker**: improve error (de)serialization (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`6b1a887aa2`](https://github.com/nodejs/node/commit/6b1a887aa2)] - **(SEMVER-MINOR)** **worker**: enable stdio (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`c97fb91e55`](https://github.com/nodejs/node/commit/c97fb91e55)] - **(SEMVER-MINOR)** **worker**: restrict supported extensions (Timothy Gu) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`109c92e8fa`](https://github.com/nodejs/node/commit/109c92e8fa)] - **(SEMVER-MINOR)** **worker**: initial implementation (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`d1f372f052`](https://github.com/nodejs/node/commit/d1f372f052)] - **(SEMVER-MINOR)** **worker**: add `SharedArrayBuffer` sharing (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`f447acd87b`](https://github.com/nodejs/node/commit/f447acd87b)] - **(SEMVER-MINOR)** **worker**: support MessagePort passing in messages (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`337be58ee6`](https://github.com/nodejs/node/commit/337be58ee6)] - **(SEMVER-MINOR)** **worker**: implement `MessagePort` and `MessageChannel` (Anna Henningsen) [#20876](https://github.com/nodejs/node/pull/20876)
* \[[`4a54ebc3bd`](https://github.com/nodejs/node/commit/4a54ebc3bd)] - **worker,src**: display remaining handles if `uv_loop_close` fails (Anna Henningsen) [#21238](https://github.com/nodejs/node/pull/21238)
* \[[`529d24e3e8`](https://github.com/nodejs/node/commit/529d24e3e8)] - _**Revert**_ "**workers,trace\_events**: set thread name for workers" (James M Snell) [#21363](https://github.com/nodejs/node/pull/21363)
* \[[`dfb5cf6963`](https://github.com/nodejs/node/commit/dfb5cf6963)] - **workers,trace\_events**: set thread name for workers (James M Snell) [#21246](https://github.com/nodejs/node/pull/21246)

<a id="10.4.1"></a>

## 2018-06-12, Version 10.4.1 (Current), @evanlucas

### Notable Changes

* **Fixes memory exhaustion DoS** (CVE-2018-7164): Fixes a bug introduced in 9.7.0 that increases the memory consumed when reading from the network into JavaScript using the net.Socket object directly as a stream.
* **http2**
  * (CVE-2018-7161): Fixes Denial of Service vulnerability by updating the http2 implementation to not crash under certain circumstances during cleanup
  * (CVE-2018-1000168): Fixes Denial of Service vulnerability by upgrading nghttp2 to 1.32.0
* **tls** (CVE-2018-7162): Fixes Denial of Service vulnerability by updating the TLS implementation to not crash upon receiving
* **n-api**: Prevent use-after-free in napi\_delete\_async\_work

### Commits

* \[[`1bbfe9a72b`](https://github.com/nodejs/node/commit/1bbfe9a72b)] - **build**: fix configure script for double-digits (Misty De Meo) [#21183](https://github.com/nodejs/node/pull/21183)
* \[[`4c90ee8fc6`](https://github.com/nodejs/node/commit/4c90ee8fc6)] - **deps**: update to nghttp2 1.32.0 (James M Snell) [nodejs-private/node-private#117](https://github.com/nodejs-private/node-private/pull/117)
* \[[`e5c2f575b1`](https://github.com/nodejs/node/commit/e5c2f575b1)] - **deps**: patch V8 to 6.7.288.45 (Michaël Zasso) [#21192](https://github.com/nodejs/node/pull/21192)
* \[[`03ded94ffe`](https://github.com/nodejs/node/commit/03ded94ffe)] - **deps**: patch V8 to 6.7.288.44 (Michaël Zasso) [#21146](https://github.com/nodejs/node/pull/21146)
* \[[`4de7e0c96c`](https://github.com/nodejs/node/commit/4de7e0c96c)] - **deps,npm**: float node-gyp patch on npm (Rich Trott) [#21239](https://github.com/nodejs/node/pull/21239)
* \[[`92d7b6c9a0`](https://github.com/nodejs/node/commit/92d7b6c9a0)] - **fs**: fix promises reads with pos > 4GB (cjihrig) [#21148](https://github.com/nodejs/node/pull/21148)
* \[[`8681402228`](https://github.com/nodejs/node/commit/8681402228)] - **http2**: fixup http2stream cleanup and other nits (James M Snell) [nodejs-private/node-private#115](https://github.com/nodejs-private/node-private/pull/115)
* \[[`53f8563353`](https://github.com/nodejs/node/commit/53f8563353)] - **n-api**: back up env before async work finalize (Gabriel Schulhof) [#21129](https://github.com/nodejs/node/pull/21129)
* \[[`9ba8ed1371`](https://github.com/nodejs/node/commit/9ba8ed1371)] - **src**: re-add `Realloc()` shrink after reading stream data (Anna Henningsen) [nodejs-private/node-private#128](https://github.com/nodejs-private/node-private/pull/128)
* \[[`8e979482fa`](https://github.com/nodejs/node/commit/8e979482fa)] - _**Revert**_ "**src**: restore stdio on program exit" (Evan Lucas) [#21257](https://github.com/nodejs/node/pull/21257)
* \[[`cb5ec64956`](https://github.com/nodejs/node/commit/cb5ec64956)] - **src**: reset TTY mode before cleaning up resources (Anna Henningsen) [#21257](https://github.com/nodejs/node/pull/21257)
* \[[`ae5567eaea`](https://github.com/nodejs/node/commit/ae5567eaea)] - **test**: add regression test for nghttp2 CVE-2018-1000168 (James M Snell) [nodejs-private/node-private#117](https://github.com/nodejs-private/node-private/pull/117)
* \[[`e87bf625dd`](https://github.com/nodejs/node/commit/e87bf625dd)] - **test**: add tls write error regression test (Shigeki Ohtsu) [nodejs-private/node-private#127](https://github.com/nodejs-private/node-private/pull/127)
* \[[`eea2bce58d`](https://github.com/nodejs/node/commit/eea2bce58d)] - **tls**: fix SSL write error handling (Anna Henningsen) [nodejs-private/node-private#127](https://github.com/nodejs-private/node-private/pull/127)
* \[[`1e49eadd68`](https://github.com/nodejs/node/commit/1e49eadd68)] - **tools,gyp**: fix regex for version matching (Rich Trott) [#21216](https://github.com/nodejs/node/pull/21216)

<a id="10.4.0"></a>

## 2018-06-06, Version 10.4.0 (Current), @MylesBorins

### Notable Changes

* **deps**:
  * update V8 to 6.7.288.43 (Michaël Zasso) [#19989](https://github.com/nodejs/node/pull/19989)
* **stream**:
  * ensure Stream.pipeline re-throws errors without callback (Blaine Bublitz) [#20437](https://github.com/nodejs/node/pull/20437)

### Commits

* \[[`9ada68b186`](https://github.com/nodejs/node/commit/9ada68b186)] - **benchmark**: refactor benchmark/assert/throws.js (Rich Trott) [#21030](https://github.com/nodejs/node/pull/21030)
* \[[`b8470b929f`](https://github.com/nodejs/node/commit/b8470b929f)] - **benchmark**: refactor deepequal-typedarrays (Rich Trott) [#21030](https://github.com/nodejs/node/pull/21030)
* \[[`686587ba1a`](https://github.com/nodejs/node/commit/686587ba1a)] - **benchmark**: refactor deepequal-set (Rich Trott) [#21030](https://github.com/nodejs/node/pull/21030)
* \[[`56c67595db`](https://github.com/nodejs/node/commit/56c67595db)] - **benchmark**: refactor prims-and-objs-big-loop (Rich Trott) [#21030](https://github.com/nodejs/node/pull/21030)
* \[[`6fbb00e887`](https://github.com/nodejs/node/commit/6fbb00e887)] - **benchmark**: refactor prims-and-objs-big-array-set (Rich Trott) [#21030](https://github.com/nodejs/node/pull/21030)
* \[[`4d714421e9`](https://github.com/nodejs/node/commit/4d714421e9)] - **benchmark**: refactor deepequal-object (Rich Trott) [#21030](https://github.com/nodejs/node/pull/21030)
* \[[`9b0fc59723`](https://github.com/nodejs/node/commit/9b0fc59723)] - **benchmark**: refactor deepequal-map (Rich Trott) [#21030](https://github.com/nodejs/node/pull/21030)
* \[[`90d86586d2`](https://github.com/nodejs/node/commit/90d86586d2)] - **benchmark**: refactor deepequal-buffer (Rich Trott) [#21030](https://github.com/nodejs/node/pull/21030)
* \[[`be249d9eb5`](https://github.com/nodejs/node/commit/be249d9eb5)] - **benchmark**: fix "comparisons"' typo (Yuta Hiroto) [#21085](https://github.com/nodejs/node/pull/21085)
* \[[`bad3c92124`](https://github.com/nodejs/node/commit/bad3c92124)] - **(SEMVER-MINOR)** **build**: reset embedder string to "-node.0" (Michaël Zasso) [#19989](https://github.com/nodejs/node/pull/19989)
* \[[`35d6661973`](https://github.com/nodejs/node/commit/35d6661973)] - **deps**: cherry-pick 6989b3f6d7 from V8 upstream (Timothy Gu) [#20826](https://github.com/nodejs/node/pull/20826)
* \[[`4e788dc2f5`](https://github.com/nodejs/node/commit/4e788dc2f5)] - **(SEMVER-MINOR)** **deps**: backport 91ddb65d from upstream V8 (Maya Lekova) [#19989](https://github.com/nodejs/node/pull/19989)
* \[[`fb2686148e`](https://github.com/nodejs/node/commit/fb2686148e)] - **deps**: cherry-pick ff0a9793334 from upstream V8 (Anna Henningsen) [#20719](https://github.com/nodejs/node/pull/20719)
* \[[`40c8bbecec`](https://github.com/nodejs/node/commit/40c8bbecec)] - **deps**: cherry-pick 23652c5f from upstream V8 (Eugene Ostroukhov) [#20608](https://github.com/nodejs/node/pull/20608)
* \[[`a7aff77a97`](https://github.com/nodejs/node/commit/a7aff77a97)] - **(SEMVER-MINOR)** **deps**: cherry-pick 39d546a from upstream V8 (Gus Caplan) [#20016](https://github.com/nodejs/node/pull/20016)
* \[[`fed1d18054`](https://github.com/nodejs/node/commit/fed1d18054)] - **(SEMVER-MINOR)** **deps**: update v8.gyp (Michaël Zasso) [#19989](https://github.com/nodejs/node/pull/19989)
* \[[`da8ad4aba9`](https://github.com/nodejs/node/commit/da8ad4aba9)] - **(SEMVER-MINOR)** **deps**: update V8 to 6.7.288.43 (Michaël Zasso) [#19989](https://github.com/nodejs/node/pull/19989)
* \[[`2c671ab2fd`](https://github.com/nodejs/node/commit/2c671ab2fd)] - **doc**: fix typo in addons.md (Rich Trott) [#21137](https://github.com/nodejs/node/pull/21137)
* \[[`e2a792866c`](https://github.com/nodejs/node/commit/e2a792866c)] - **doc**: add offboarding doc (Rich Trott) [#21103](https://github.com/nodejs/node/pull/21103)
* \[[`15aa3c1046`](https://github.com/nodejs/node/commit/15aa3c1046)] - **doc**: add notable-change to onboarding.md exercise (Rich Trott) [#21040](https://github.com/nodejs/node/pull/21040)
* \[[`29c35bd0de`](https://github.com/nodejs/node/commit/29c35bd0de)] - **doc**: remove link prediction from STYLE\_GUIDE.md (Rich Trott) [#21031](https://github.com/nodejs/node/pull/21031)
* \[[`261ef1d242`](https://github.com/nodejs/node/commit/261ef1d242)] - **doc**: remove POST\_STATUS\_TO\_PR from onboarding.md (Rich Trott) [#21042](https://github.com/nodejs/node/pull/21042)
* \[[`2edf1728a0`](https://github.com/nodejs/node/commit/2edf1728a0)] - **doc**: fix typos on `e.g.` abbreviations (Rich Trott) [#21045](https://github.com/nodejs/node/pull/21045)
* \[[`b1f0907416`](https://github.com/nodejs/node/commit/b1f0907416)] - **doc**: use "is" rather than "has been" (Rich Trott) [#21043](https://github.com/nodejs/node/pull/21043)
* \[[`f5bf2c8d08`](https://github.com/nodejs/node/commit/f5bf2c8d08)] - **doc**: move upstream information to onboarding doc (Rich Trott) [#21029](https://github.com/nodejs/node/pull/21029)
* \[[`09aec436cb`](https://github.com/nodejs/node/commit/09aec436cb)] - **doc**: remove vestigial onboarding section (Rich Trott) [#21028](https://github.com/nodejs/node/pull/21028)
* \[[`fd201e0d32`](https://github.com/nodejs/node/commit/fd201e0d32)] - **doc**: add guides on writing tests involving promises (Joyee Cheung) [#20988](https://github.com/nodejs/node/pull/20988)
* \[[`4cd44203de`](https://github.com/nodejs/node/commit/4cd44203de)] - **doc**: remove invalid `vm.Script` arguments (Simen Bekkhus) [#20984](https://github.com/nodejs/node/pull/20984)
* \[[`4012e0550a`](https://github.com/nodejs/node/commit/4012e0550a)] - **doc**: fix typo in n-api.md (ohbarye) [#21060](https://github.com/nodejs/node/pull/21060)
* \[[`bb8d341714`](https://github.com/nodejs/node/commit/bb8d341714)] - **doc**: better font stack for monospace in docs (Roman Reiss) [#21036](https://github.com/nodejs/node/pull/21036)
* \[[`1b8e8e90af`](https://github.com/nodejs/node/commit/1b8e8e90af)] - **doc**: make minor improvements to fs.realpath() docs (Rich Trott) [#20953](https://github.com/nodejs/node/pull/20953)
* \[[`c2ae93db63`](https://github.com/nodejs/node/commit/c2ae93db63)] - **doc**: add missing link for 10.3.0 changelog (Myles Borins) [#21017](https://github.com/nodejs/node/pull/21017)
* \[[`8dc7c883a7`](https://github.com/nodejs/node/commit/8dc7c883a7)] - **doc**: improve note on zlib APIs threadpool usage (Luigi Pinca) [#20380](https://github.com/nodejs/node/pull/20380)
* \[[`ab43581f15`](https://github.com/nodejs/node/commit/ab43581f15)] - **doc**: make constants enumeration consistent (Diego Rodríguez Baquero) [#20991](https://github.com/nodejs/node/pull/20991)
* \[[`44ef458d9c`](https://github.com/nodejs/node/commit/44ef458d9c)] - **fs**: ensure options.flag defaults to 'r' in readFile (Unknown) [#20268](https://github.com/nodejs/node/pull/20268)
* \[[`341b2c21f3`](https://github.com/nodejs/node/commit/341b2c21f3)] - **http2**: fix premature destroy (Anatoli Papirovski) [#21051](https://github.com/nodejs/node/pull/21051)
* \[[`d4787cfd61`](https://github.com/nodejs/node/commit/d4787cfd61)] - **http2**: force through RST\_STREAM in destroy (Anatoli Papirovski) [#21016](https://github.com/nodejs/node/pull/21016)
* \[[`2a9912c0df`](https://github.com/nodejs/node/commit/2a9912c0df)] - **http2**: delay closing stream (Anatoli Papirovski) [#20997](https://github.com/nodejs/node/pull/20997)
* \[[`182c73bf7f`](https://github.com/nodejs/node/commit/182c73bf7f)] - **http2**: switch to new runtime-controlled debugging system (Anna Henningsen) [#20987](https://github.com/nodejs/node/pull/20987)
* \[[`1d22254c4d`](https://github.com/nodejs/node/commit/1d22254c4d)] - **https**: removed extra \_http\_server require (ErnestoSalazar) [#21069](https://github.com/nodejs/node/pull/21069)
* \[[`1c211ec901`](https://github.com/nodejs/node/commit/1c211ec901)] - **inspector**: code cleanup (Eugene Ostroukhov) [#21070](https://github.com/nodejs/node/pull/21070)
* \[[`a30bf55e69`](https://github.com/nodejs/node/commit/a30bf55e69)] - **lib**: use focused ESLint disabling in util.js (Rich Trott) [#21041](https://github.com/nodejs/node/pull/21041)
* \[[`f2c9e5af09`](https://github.com/nodejs/node/commit/f2c9e5af09)] - **lib**: introduce internal/validators (Michaël Zasso) [#21149](https://github.com/nodejs/node/pull/21149)
* \[[`46d1025add`](https://github.com/nodejs/node/commit/46d1025add)] - **net**: use object destructuring (starkewang) [#20959](https://github.com/nodejs/node/pull/20959)
* \[[`afc811cc1c`](https://github.com/nodejs/node/commit/afc811cc1c)] - **src**: break out of timers loop if `!can_call_into_js()` (Anna Henningsen) [#20884](https://github.com/nodejs/node/pull/20884)
* \[[`8862f0a613`](https://github.com/nodejs/node/commit/8862f0a613)] - **src**: store pointer to Environment on DestroyParam (Anatoli Papirovski) [#21099](https://github.com/nodejs/node/pull/21099)
* \[[`66f4c7bdec`](https://github.com/nodejs/node/commit/66f4c7bdec)] - **src**: fix typo string\_search.h comment (Masashi Hirano) [#21115](https://github.com/nodejs/node/pull/21115)
* \[[`f79096a3f2`](https://github.com/nodejs/node/commit/f79096a3f2)] - **src**: do not cache `NumberOfHeapSpaces()` globally (Anna Henningsen) [#20971](https://github.com/nodejs/node/pull/20971)
* \[[`7c0c61bde1`](https://github.com/nodejs/node/commit/7c0c61bde1)] - **(SEMVER-MINOR)** **src**: update postmortem constant name (cjihrig) [#19989](https://github.com/nodejs/node/pull/19989)
* \[[`2d3137c5a9`](https://github.com/nodejs/node/commit/2d3137c5a9)] - **(SEMVER-MINOR)** **src**: fix GetCpuProfiler() deprecation warning (Michaël Zasso) [#19989](https://github.com/nodejs/node/pull/19989)
* \[[`af62a16ff6`](https://github.com/nodejs/node/commit/af62a16ff6)] - **(SEMVER-MINOR)** _**Revert**_ "**src**: fix GetCpuProfiler() deprecation warning" (Michaël Zasso) [#19989](https://github.com/nodejs/node/pull/19989)
* \[[`af06581b84`](https://github.com/nodejs/node/commit/af06581b84)] - **src**: restore stdio on program exit (Ben Noordhuis) [#20592](https://github.com/nodejs/node/pull/20592)
* \[[`45eeea4330`](https://github.com/nodejs/node/commit/45eeea4330)] - **src**: implement debug output utilities (Anna Henningsen) [#20987](https://github.com/nodejs/node/pull/20987)
* \[[`ebbd036d0b`](https://github.com/nodejs/node/commit/ebbd036d0b)] - **src**: remove unused private data member (Ben Noordhuis) [#20974](https://github.com/nodejs/node/pull/20974)
* \[[`d4f507b23b`](https://github.com/nodejs/node/commit/d4f507b23b)] - **src**: remove unused req\_wrap-inl.h (Daniel Bevenius) [#20996](https://github.com/nodejs/node/pull/20996)
* \[[`44fe78b09a`](https://github.com/nodejs/node/commit/44fe78b09a)] - **stream**: inline needMoreData function (Miklos Suveges) [#21009](https://github.com/nodejs/node/pull/21009)
* \[[`d1e81b0f17`](https://github.com/nodejs/node/commit/d1e81b0f17)] - **stream**: ensure Stream.pipeline re-throws errors without callback (Blaine Bublitz) [#20437](https://github.com/nodejs/node/pull/20437)
* \[[`8161287b40`](https://github.com/nodejs/node/commit/8161287b40)] - **test**: move benchmark-dgram to sequential (Anatoli Papirovski) [#21144](https://github.com/nodejs/node/pull/21144)
* \[[`9d41ab466b`](https://github.com/nodejs/node/commit/9d41ab466b)] - **test**: refactor child-process-fork-net (Rich Trott) [#21095](https://github.com/nodejs/node/pull/21095)
* \[[`820236fd0d`](https://github.com/nodejs/node/commit/820236fd0d)] - **test**: mark test-trace-events-fs-sync as flaky (Matheus Marchini) [#21039](https://github.com/nodejs/node/pull/21039)
* \[[`2d36150852`](https://github.com/nodejs/node/commit/2d36150852)] - **test**: string-decorater.lastChar (Masashi Hirano) [#21084](https://github.com/nodejs/node/pull/21084)
* \[[`1733ef9dec`](https://github.com/nodejs/node/commit/1733ef9dec)] - **test**: make handling of noWarnCode stricter (Tobias Nießen) [#21075](https://github.com/nodejs/node/pull/21075)
* \[[`1e607d0910`](https://github.com/nodejs/node/commit/1e607d0910)] - **test**: add source for test.wasm (Daniel Bevenius) [#21082](https://github.com/nodejs/node/pull/21082)
* \[[`28f2dcb22a`](https://github.com/nodejs/node/commit/28f2dcb22a)] - **test**: update test-dns error message (Rich Trott) [#21116](https://github.com/nodejs/node/pull/21116)
* \[[`c60810a853`](https://github.com/nodejs/node/commit/c60810a853)] - **test**: increase slop limit in memory leak test (Ben Noordhuis) [#21080](https://github.com/nodejs/node/pull/21080)
* \[[`fda8654161`](https://github.com/nodejs/node/commit/fda8654161)] - **test**: log before and after RSS in memory leak test (Ben Noordhuis) [#21080](https://github.com/nodejs/node/pull/21080)
* \[[`8e3e18ef7d`](https://github.com/nodejs/node/commit/8e3e18ef7d)] - **test**: unmark test-zlib.zlib-binding.deflate flaky (Anatoli Papirovski) [#21109](https://github.com/nodejs/node/pull/21109)
* \[[`bd0d19dae7`](https://github.com/nodejs/node/commit/bd0d19dae7)] - **test**: minor adjustments to test-http2-respond-file (Anna Henningsen) [#21098](https://github.com/nodejs/node/pull/21098)
* \[[`c4fc1ff295`](https://github.com/nodejs/node/commit/c4fc1ff295)] - **test**: fix flaky async-hooks/test-zlib.zlib-binding.deflate (Anna Henningsen) [#21077](https://github.com/nodejs/node/pull/21077)
* \[[`c8ee379d85`](https://github.com/nodejs/node/commit/c8ee379d85)] - **test**: run crypto benchmark only once in tests (Rich Trott) [#21032](https://github.com/nodejs/node/pull/21032)
* \[[`a3fdd2e4c5`](https://github.com/nodejs/node/commit/a3fdd2e4c5)] - **test**: add option to test-benchmark-timers (Rich Trott) [#21032](https://github.com/nodejs/node/pull/21032)
* \[[`60abd08c7f`](https://github.com/nodejs/node/commit/60abd08c7f)] - **test**: remove unused empty fixture (Rich Trott) [#21044](https://github.com/nodejs/node/pull/21044)
* \[[`f7886ab8ad`](https://github.com/nodejs/node/commit/f7886ab8ad)] - **test**: avoid empty fixture in module test (Rich Trott) [#21044](https://github.com/nodejs/node/pull/21044)
* \[[`c74c83a4c1`](https://github.com/nodejs/node/commit/c74c83a4c1)] - **test**: avoid empty fixture in fs test (Rich Trott) [#21044](https://github.com/nodejs/node/pull/21044)
* \[[`d84aa51dc7`](https://github.com/nodejs/node/commit/d84aa51dc7)] - **test**: removed message from strictEqual (Lucas Liepert) [#20983](https://github.com/nodejs/node/pull/20983)
* \[[`e4224fd793`](https://github.com/nodejs/node/commit/e4224fd793)] - **test**: improve path tests (Shivang) [#20967](https://github.com/nodejs/node/pull/20967)
* \[[`df97791447`](https://github.com/nodejs/node/commit/df97791447)] - **(SEMVER-MINOR)** **test**: update postmortem metadata test (cjihrig) [#19989](https://github.com/nodejs/node/pull/19989)
* \[[`aa08f6464c`](https://github.com/nodejs/node/commit/aa08f6464c)] - **(SEMVER-MINOR)** **test**: add read\_only\_space heap space (cjihrig) [#19989](https://github.com/nodejs/node/pull/19989)
* \[[`ea81d42ddc`](https://github.com/nodejs/node/commit/ea81d42ddc)] - **test**: show actual error in next-tick-when-exiting (Shailesh Shekhawat) [#20956](https://github.com/nodejs/node/pull/20956)
* \[[`7e1f61070e`](https://github.com/nodejs/node/commit/7e1f61070e)] - **test**: fix flaky test-domain-timers (Anatoli Papirovski) [#21019](https://github.com/nodejs/node/pull/21019)
* \[[`2bbd99c7b2`](https://github.com/nodejs/node/commit/2bbd99c7b2)] - **test**: check TTY mode reset on exit (Anna Henningsen) [#21027](https://github.com/nodejs/node/pull/21027)
* \[[`adbbf0d625`](https://github.com/nodejs/node/commit/adbbf0d625)] - **test**: mark test-fs-readfile-tostring-fail as flaky (Matheus Marchini) [#21013](https://github.com/nodejs/node/pull/21013)
* \[[`ff5f20fc7b`](https://github.com/nodejs/node/commit/ff5f20fc7b)] - **test**: add test for fs.promises.lchmod (Masashi Hirano) [#20584](https://github.com/nodejs/node/pull/20584)
* \[[`04af69750c`](https://github.com/nodejs/node/commit/04af69750c)] - **test**: mark test-child-process-fork-net as flaky (Matheus Marchini) [#21018](https://github.com/nodejs/node/pull/21018)
* \[[`edf42985d7`](https://github.com/nodejs/node/commit/edf42985d7)] - **test**: fix worker send error (Gireesh Punathil) [#20973](https://github.com/nodejs/node/pull/20973)
* \[[`ba71fe8bd3`](https://github.com/nodejs/node/commit/ba71fe8bd3)] - **timers**: check can\_call\_into\_js in Immediates (Anatoli Papirovski) [#21057](https://github.com/nodejs/node/pull/21057)
* \[[`440e899d94`](https://github.com/nodejs/node/commit/440e899d94)] - **tools**: ensure doc-only doesn't update package-lock (Myles Borins) [#21015](https://github.com/nodejs/node/pull/21015)
* \[[`b5b7459e5c`](https://github.com/nodejs/node/commit/b5b7459e5c)] - **trace\_events**: add version metadata (James M Snell) [#20852](https://github.com/nodejs/node/pull/20852)
* \[[`4c48b69e90`](https://github.com/nodejs/node/commit/4c48b69e90)] - **(SEMVER-MINOR)** **util**: add type check function for BigIntObject (Michaël Zasso) [#19989](https://github.com/nodejs/node/pull/19989)
* \[[`b2808ed929`](https://github.com/nodejs/node/commit/b2808ed929)] - **util**: fix inspection of module namespaces (Gus Caplan) [#20962](https://github.com/nodejs/node/pull/20962)
* \[[`ec058193a8`](https://github.com/nodejs/node/commit/ec058193a8)] - **v8**: backport 9fb02b526f1cd3b859a530a01adb08bc0d089f4f (Gus Caplan) [#20575](https://github.com/nodejs/node/pull/20575)
* \[[`48aa4c32d0`](https://github.com/nodejs/node/commit/48aa4c32d0)] - **zlib**: removed extra util require (ErnestoSalazar) [#21069](https://github.com/nodejs/node/pull/21069)

<a id="10.3.0"></a>

## 2018-05-29, Version 10.3.0 (Current), @MylesBorins

### Notable Changes

* **deps**:
  * upgrade npm to 6.1.0 (Rebecca Turner) [#20190](https://github.com/nodejs/node/pull/20190)
* **fs**:
  * fix reads with pos > 4GB (Mathias Buus) [#21003](https://github.com/nodejs/node/pull/21003)
* **net**:
  * new option to allow IPC servers to be readable and writable by all users (Bartosz Sosnowski) [#19472](https://github.com/nodejs/node/pull/19472)
* **stream**:
  * fix removeAllListeners() for Stream.Readable to work as expected when no arguments are passed (Kael Zhang) [#20924](https://github.com/nodejs/node/pull/20924)
* **Added new collaborators**
  * [jdlaton](https://github.com/jdalton) John-David Dalton

### Commits

* \[[`ea702e2812`](https://github.com/nodejs/node/commit/ea702e2812)] - **assert**: handle undefined filename in getErrMessage (Tim Seckinger) [#20848](https://github.com/nodejs/node/pull/20848)
* \[[`d7fed22511`](https://github.com/nodejs/node/commit/d7fed22511)] - **build,win**: disable DLL-interface warnings (Bert Belder) [#20958](https://github.com/nodejs/node/pull/20958)
* \[[`efc7f91354`](https://github.com/nodejs/node/commit/efc7f91354)] - **deps**: cherry-pick 6989b3f6d7 from V8 upstream (Timothy Gu) [#20826](https://github.com/nodejs/node/pull/20826)
* \[[`d0cdcb61fe`](https://github.com/nodejs/node/commit/d0cdcb61fe)] - **(SEMVER-MINOR)** **deps**: upgrade npm to 6.1.0 (Rebecca Turner) [#20190](https://github.com/nodejs/node/pull/20190)
* \[[`ce13797dca`](https://github.com/nodejs/node/commit/ce13797dca)] - **doc**: fix doc for napi\_get\_typedarray\_info (Michael Dawson) [#20747](https://github.com/nodejs/node/pull/20747)
* \[[`babc9da6f9`](https://github.com/nodejs/node/commit/babc9da6f9)] - **doc**: add jdalton to collaborators (John-David Dalton) [#20968](https://github.com/nodejs/node/pull/20968)
* \[[`f0704f2407`](https://github.com/nodejs/node/commit/f0704f2407)] - **doc**: mark Node 4 as EOL in changelog (Teddy Katz) [#20926](https://github.com/nodejs/node/pull/20926)
* \[[`87ad9318bb`](https://github.com/nodejs/node/commit/87ad9318bb)] - **doc**: update the notable changes (Ruben Bridgewater) [#20316](https://github.com/nodejs/node/pull/20316)
* \[[`c036cda1f5`](https://github.com/nodejs/node/commit/c036cda1f5)] - **doc**: fix outdated link FSEvents (amitbend) [#20949](https://github.com/nodejs/node/pull/20949)
* \[[`1f3eb1cc1e`](https://github.com/nodejs/node/commit/1f3eb1cc1e)] - **doc**: fix filehandle.truncate() sample codes (Masashi Hirano) [#20913](https://github.com/nodejs/node/pull/20913)
* \[[`819bba6d2b`](https://github.com/nodejs/node/commit/819bba6d2b)] - **doc**: removed LTS label from v4 in doc version picker (Chris Young) [#20904](https://github.com/nodejs/node/pull/20904)
* \[[`be2a467395`](https://github.com/nodejs/node/commit/be2a467395)] - **doc**: fix incorrect fs.readFileSync example output (Teddy Katz) [#20902](https://github.com/nodejs/node/pull/20902)
* \[[`bfe6dc369d`](https://github.com/nodejs/node/commit/bfe6dc369d)] - **fs**: fix reads with pos > 4GB (Mathias Buus) [#21003](https://github.com/nodejs/node/pull/21003)
* \[[`c2c3b6f434`](https://github.com/nodejs/node/commit/c2c3b6f434)] - **lib**: use object destructuring for ContextifyScript (Daniel Bevenius) [#20934](https://github.com/nodejs/node/pull/20934)
* \[[`d2bcd55fb5`](https://github.com/nodejs/node/commit/d2bcd55fb5)] - **lib**: remove unnecessary string interpolation (Daniel Bevenius) [#20890](https://github.com/nodejs/node/pull/20890)
* \[[`099c6b6c5d`](https://github.com/nodejs/node/commit/099c6b6c5d)] - **meta**: add link to unofficial discord (Gus Caplan) [#20508](https://github.com/nodejs/node/pull/20508)
* \[[`45adec2616`](https://github.com/nodejs/node/commit/45adec2616)] - **module**: name anonymous function for debugging (Nicholas Dangles) [#20811](https://github.com/nodejs/node/pull/20811)
* \[[`ba30d149ea`](https://github.com/nodejs/node/commit/ba30d149ea)] - **n-api**: throw when entry point is null (Gabriel Schulhof) [#20779](https://github.com/nodejs/node/pull/20779)
* \[[`b242248188`](https://github.com/nodejs/node/commit/b242248188)] - **(SEMVER-MINOR)** **net**: allow IPC servers be accessible by all (Bartosz Sosnowski) [#19472](https://github.com/nodejs/node/pull/19472)
* \[[`ed9e964357`](https://github.com/nodejs/node/commit/ed9e964357)] - **net**: remove unnecessary variables (chainhelen) [#20864](https://github.com/nodejs/node/pull/20864)
* \[[`5f9c01b646`](https://github.com/nodejs/node/commit/5f9c01b646)] - _**Revert**_ "**repl**: add friendly tips about how to exit repl" (cjihrig) [#20972](https://github.com/nodejs/node/pull/20972)
* \[[`902120a927`](https://github.com/nodejs/node/commit/902120a927)] - **src**: add CHECK\_NULL/CHECK\_NOT\_NULL macros (Tobias Nießen) [#20914](https://github.com/nodejs/node/pull/20914)
* \[[`5e69e1a51e`](https://github.com/nodejs/node/commit/5e69e1a51e)] - **src**: add CHECK\_IMPLIES macro (Tobias Nießen) [#20914](https://github.com/nodejs/node/pull/20914)
* \[[`418739c021`](https://github.com/nodejs/node/commit/418739c021)] - **src**: fix MallocedBuffer move assignment operator (Anna Henningsen) [#20883](https://github.com/nodejs/node/pull/20883)
* \[[`b4519cac20`](https://github.com/nodejs/node/commit/b4519cac20)] - **src**: move DeleteFnPtr into util.h (Anna Henningsen) [#20885](https://github.com/nodejs/node/pull/20885)
* \[[`b0023d7bc9`](https://github.com/nodejs/node/commit/b0023d7bc9)] - **src,doc**: add doc of --prof flag to help command (ohbarye) [#20845](https://github.com/nodejs/node/pull/20845)
* \[[`8f52c3fb6b`](https://github.com/nodejs/node/commit/8f52c3fb6b)] - **stream**: fix removeAllListeners() for Stream.Readable (Kael Zhang) [#20924](https://github.com/nodejs/node/pull/20924)
* \[[`011235768c`](https://github.com/nodejs/node/commit/011235768c)] - **test**: improve assert test hygiene (Rich Trott) [#20861](https://github.com/nodejs/node/pull/20861)
* \[[`88f9a399d6`](https://github.com/nodejs/node/commit/88f9a399d6)] - **test**: isolate unusual assert test in its own file (Rich Trott) [#20861](https://github.com/nodejs/node/pull/20861)
* \[[`460a5025d0`](https://github.com/nodejs/node/commit/460a5025d0)] - **test**: fix test failure on aix (Ruben Bridgewater) [#20940](https://github.com/nodejs/node/pull/20940)
* \[[`d09bec8a04`](https://github.com/nodejs/node/commit/d09bec8a04)] - **test**: improve error message in async-wrap test (Rich Trott) [#20948](https://github.com/nodejs/node/pull/20948)
* \[[`460add98fb`](https://github.com/nodejs/node/commit/460add98fb)] - **test**: reduce runtime (Ruben Bridgewater) [#20688](https://github.com/nodejs/node/pull/20688)
* \[[`82afb4cf7d`](https://github.com/nodejs/node/commit/82afb4cf7d)] - **test**: remove message argument from strictEqual() (sagirk) [#20912](https://github.com/nodejs/node/pull/20912)
* \[[`40e57885d4`](https://github.com/nodejs/node/commit/40e57885d4)] - **test**: remove string literal from strictEqual (AbhimanyuVashisht) [#20920](https://github.com/nodejs/node/pull/20920)
* \[[`9bbab91479`](https://github.com/nodejs/node/commit/9bbab91479)] - **test**: include port in assertion message (nam) [#20889](https://github.com/nodejs/node/pull/20889)
* \[[`554ad478d4`](https://github.com/nodejs/node/commit/554ad478d4)] - **test**: improve coverage for readline.Interface (Masashi Hirano) [#20704](https://github.com/nodejs/node/pull/20704)
* \[[`443d60afcc`](https://github.com/nodejs/node/commit/443d60afcc)] - **test**: use log only in test-child-process-fork-net (Rich Trott) [#20873](https://github.com/nodejs/node/pull/20873)
* \[[`ed84b7d42f`](https://github.com/nodejs/node/commit/ed84b7d42f)] - **test**: changed assert message from string literal to template literal (CoreyGMartin) [#20870](https://github.com/nodejs/node/pull/20870)
* \[[`b62cbe106c`](https://github.com/nodejs/node/commit/b62cbe106c)] - **tools**: update tools/doc/package-lock.json (Rich Trott) [#20970](https://github.com/nodejs/node/pull/20970)
* \[[`46e7cec7a5`](https://github.com/nodejs/node/commit/46e7cec7a5)] - **tools**: fix sorting in doc/type-parser.js (Vse Mozhet Byt) [#20976](https://github.com/nodejs/node/pull/20976)

<a id="10.2.1"></a>

## 2018-05-24, Version 10.2.1 (Current), @MylesBorins

### Notable Changes

This is a follow up release to fix two regressions that were introduced in v10.2.0.

### Commits

* \[[`2a9c83321b`](https://github.com/nodejs/node/commit/2a9c83321b)] - **http**: fix res emit close before user finish (Robert Nagy) [#20941](https://github.com/nodejs/node/pull/20941)
* \[[`0b1ba20fc0`](https://github.com/nodejs/node/commit/0b1ba20fc0)] - **src**: re-integrate headers into node.h (Anna Henningsen) [#20939](https://github.com/nodejs/node/pull/20939)
* \[[`52f21fbfbc`](https://github.com/nodejs/node/commit/52f21fbfbc)] - **test**: mark test-zlib.zlib-binding.deflate as flaky (Matheus Marchini) [#20935](https://github.com/nodejs/node/pull/20935)

<a id="10.2.0"></a>

## 2018-05-23, Version 10.2.0 (Current), @MylesBorins

### Notable Changes

* **addons**:
  * Fixed a memory leak for users of `AsyncResource` and N-API. (Michael Dawson) [#20668](https://github.com/nodejs/node/pull/20668)
* **assert**:
  * The `error` parameter of `assert.throws()` can be an object containing regular expressions now. (Ruben Bridgewater) [#20485](https://github.com/nodejs/node/pull/20485)
* **crypto**:
  * The `authTagLength` option has been made more flexible. (Tobias Nießen) [#20235](https://github.com/nodejs/node/pull/20235), [#20039](https://github.com/nodejs/node/pull/20039)
* **esm**:
  * Builtin modules (e.g. `fs`) now provide named exports in ES6 modules. (Gus Caplan) [#20403](https://github.com/nodejs/node/pull/20403)
* **http**:
  * Handling of `close` and `aborted` events has been made more consistent. (Robert Nagy) [#20075](https://github.com/nodejs/node/pull/20075), [#20611](https://github.com/nodejs/node/pull/20611)
* **module**:
  * add --preserve-symlinks-main (David Goldstein) [#19911](https://github.com/nodejs/node/pull/19911)
* **timers**:
  * `timeout.refresh()` has been added to the public API. (Jeremiah Senkpiel) [#20298](https://github.com/nodejs/node/pull/20298)
* Embedder support:
  * Functions for creating V8 `Isolate` and `Context` objects with Node.js-specific behaviour have been added to the API. (Allen Yonghuang Wang) [#20639](https://github.com/nodejs/node/pull/20639)
  * Node.js `Environment`s clean up resources before exiting now. (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
  * Support for multi-threaded embedding has been improved. (Anna Henningsen) [#20542](https://github.com/nodejs/node/pull/20542), [#20539](https://github.com/nodejs/node/pull/20539), [#20541](https://github.com/nodejs/node/pull/20541)

### Commits

* \[[`8f8a0e3483`](https://github.com/nodejs/node/commit/8f8a0e3483)] - **assert**: fix wrong message indentation (Ruben Bridgewater) [#20791](https://github.com/nodejs/node/pull/20791)
* \[[`338e663860`](https://github.com/nodejs/node/commit/338e663860)] - **assert**: fix EOL issue in messages on Windows (Ruben Bridgewater) [#20754](https://github.com/nodejs/node/pull/20754)
* \[[`1160d61cd9`](https://github.com/nodejs/node/commit/1160d61cd9)] - **assert**: support symbols as assertion messages (cjihrig) [#20693](https://github.com/nodejs/node/pull/20693)
* \[[`bb857d9e71`](https://github.com/nodejs/node/commit/bb857d9e71)] - **assert**: make sure throws is able to handle primitives (Ruben Bridgewater) [#20482](https://github.com/nodejs/node/pull/20482)
* \[[`5d06c1e1ae`](https://github.com/nodejs/node/commit/5d06c1e1ae)] - **assert**: move AssertionError into own file (Ruben Bridgewater) [#20486](https://github.com/nodejs/node/pull/20486)
* \[[`a5ee31bba1`](https://github.com/nodejs/node/commit/a5ee31bba1)] - **(SEMVER-MINOR)** **assert**: accept regular expressions to validate (Ruben Bridgewater) [#20485](https://github.com/nodejs/node/pull/20485)
* \[[`74db9f43ba`](https://github.com/nodejs/node/commit/74db9f43ba)] - **assert,util**: lazy load comparison functions (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`9feca3ea32`](https://github.com/nodejs/node/commit/9feca3ea32)] - **async\_hooks**: lazy loading for startup performance (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`e61337d36d`](https://github.com/nodejs/node/commit/e61337d36d)] - **async\_wrap**: fix memory leak in AsyncResource (Michael Dawson) [#20668](https://github.com/nodejs/node/pull/20668)
* \[[`56de3bfb70`](https://github.com/nodejs/node/commit/56de3bfb70)] - **benchmark**: add tls benchmark for legacy SecurePair (Alex Fernández) [#20344](https://github.com/nodejs/node/pull/20344)
* \[[`3b516177c8`](https://github.com/nodejs/node/commit/3b516177c8)] - **build**: use nyc's merge command (Benjamin Coe) [#20760](https://github.com/nodejs/node/pull/20760)
* \[[`aaf1df59be`](https://github.com/nodejs/node/commit/aaf1df59be)] - **build**: export openssl TLSv1 methods again (Ben Noordhuis) [#20712](https://github.com/nodejs/node/pull/20712)
* \[[`7a980086c8`](https://github.com/nodejs/node/commit/7a980086c8)] - **build**: always use BUILDTYPE binary to run JS tests (Joyee Cheung) [#20362](https://github.com/nodejs/node/pull/20362)
* \[[`47103493f7`](https://github.com/nodejs/node/commit/47103493f7)] - **child\_process**: fix exec set stdout.setEncoding (killagu) [#18976](https://github.com/nodejs/node/pull/18976)
* \[[`4a872b98a0`](https://github.com/nodejs/node/commit/4a872b98a0)] - **cluster**: remove obsolete array allocation (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`a41c44a307`](https://github.com/nodejs/node/commit/a41c44a307)] - **codeowners**: add rule for \*.gypi files (Ben Noordhuis) [#20740](https://github.com/nodejs/node/pull/20740)
* \[[`b701f5af18`](https://github.com/nodejs/node/commit/b701f5af18)] - **codeowners**: fix typo in v8-inspector team name (Ben Noordhuis) [#20740](https://github.com/nodejs/node/pull/20740)
* \[[`3fd67249df`](https://github.com/nodejs/node/commit/3fd67249df)] - **console**: .table fall back to logging for function too (ohbarye) [#20681](https://github.com/nodejs/node/pull/20681)
* \[[`bc6dbc3bfc`](https://github.com/nodejs/node/commit/bc6dbc3bfc)] - **console**: lazy load cli (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`cecec46204`](https://github.com/nodejs/node/commit/cecec46204)] - **crypto**: add test case for AES key wrapping (Yihong Wang) [#20587](https://github.com/nodejs/node/pull/20587)
* \[[`34d67085d5`](https://github.com/nodejs/node/commit/34d67085d5)] - **crypto**: allocate more memory for cipher.update() (Yihong Wang) [#20370](https://github.com/nodejs/node/pull/20370)
* \[[`2b2ccae390`](https://github.com/nodejs/node/commit/2b2ccae390)] - **(SEMVER-MINOR)** **crypto**: support authTagLength in GCM encryption (Tobias Nießen) [#20235](https://github.com/nodejs/node/pull/20235)
* \[[`1e5de6fe97`](https://github.com/nodejs/node/commit/1e5de6fe97)] - **crypto**: add using directives for v8::Int32, Uint32 (Tobias Nießen) [#20225](https://github.com/nodejs/node/pull/20225)
* \[[`f5e7010eb9`](https://github.com/nodejs/node/commit/f5e7010eb9)] - **crypto**: use kNoAuthTagLength in InitAuthenticated (Tobias Nießen) [#20225](https://github.com/nodejs/node/pull/20225)
* \[[`5ea1a58db9`](https://github.com/nodejs/node/commit/5ea1a58db9)] - **crypto**: remove rsaPrivate and rename rsaPublic (Daniel Bevenius) [#20164](https://github.com/nodejs/node/pull/20164)
* \[[`503844eb73`](https://github.com/nodejs/node/commit/503844eb73)] - **crypto**: add addCipherPrototypeFunctions function (Daniel Bevenius) [#20164](https://github.com/nodejs/node/pull/20164)
* \[[`72029b8cc7`](https://github.com/nodejs/node/commit/72029b8cc7)] - **crypto**: add createCipher/WithIV functions (Daniel Bevenius) [#20164](https://github.com/nodejs/node/pull/20164)
* \[[`bdd2856152`](https://github.com/nodejs/node/commit/bdd2856152)] - **(SEMVER-MINOR)** **crypto**: allow to restrict valid GCM tag length (Tobias Nießen) [#20039](https://github.com/nodejs/node/pull/20039)
* \[[`e56716e396`](https://github.com/nodejs/node/commit/e56716e396)] - **deps**: cherry-pick ff0a9793334 from upstream V8 (Anna Henningsen) [#20719](https://github.com/nodejs/node/pull/20719)
* \[[`8e058d5f94`](https://github.com/nodejs/node/commit/8e058d5f94)] - **deps**: patch V8 to 6.6.346.32 (Myles Borins) [#20748](https://github.com/nodejs/node/pull/20748)
* \[[`cb94601cf2`](https://github.com/nodejs/node/commit/cb94601cf2)] - **deps**: cherry-pick 23652c5f from upstream V8 (Eugene Ostroukhov) [#20608](https://github.com/nodejs/node/pull/20608)
* \[[`91e60b0d33`](https://github.com/nodejs/node/commit/91e60b0d33)] - **deps**: V8: cherry-pick b49206d from upstream (Ali Ijaz Sheikh) [#20727](https://github.com/nodejs/node/pull/20727)
* \[[`6ce589f7f4`](https://github.com/nodejs/node/commit/6ce589f7f4)] - **deps**: patch V8 to 6.6.346.31 (Myles Borins) [#20603](https://github.com/nodejs/node/pull/20603)
* \[[`f69a823f8e`](https://github.com/nodejs/node/commit/f69a823f8e)] - **deps**: upgrade to libuv 1.20.3 (cjihrig) [#20585](https://github.com/nodejs/node/pull/20585)
* \[[`60eab9100f`](https://github.com/nodejs/node/commit/60eab9100f)] - **dns**: lazy loaded (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`c1fe9b29b1`](https://github.com/nodejs/node/commit/c1fe9b29b1)] - **doc**: add note about autocrlf required for tests (Bartosz Sosnowski) [#20752](https://github.com/nodejs/node/pull/20752)
* \[[`8a17a259f3`](https://github.com/nodejs/node/commit/8a17a259f3)] - **doc**: fix some nits in hardcoded manpage links (Vse Mozhet Byt) [#20854](https://github.com/nodejs/node/pull/20854)
* \[[`8317a468db`](https://github.com/nodejs/node/commit/8317a468db)] - **doc**: fix fs.promises sample codes (Keita Akutsu) [#20838](https://github.com/nodejs/node/pull/20838)
* \[[`37b9fe1e68`](https://github.com/nodejs/node/commit/37b9fe1e68)] - **doc**: fix typo in http2.md (Keita Akutsu) [#20843](https://github.com/nodejs/node/pull/20843)
* \[[`88aee8a65c`](https://github.com/nodejs/node/commit/88aee8a65c)] - **doc**: improve \_Deprecation\_ definition (Rich Trott) [#20788](https://github.com/nodejs/node/pull/20788)
* \[[`7b1c035218`](https://github.com/nodejs/node/commit/7b1c035218)] - **doc**: describe using multiple link-module on win (Bartosz Sosnowski) [#20774](https://github.com/nodejs/node/pull/20774)
* \[[`9a8cdc93ff`](https://github.com/nodejs/node/commit/9a8cdc93ff)] - **doc**: fix typo in COLLABORATOR\_GUIDE.md (Vse Mozhet Byt) [#20742](https://github.com/nodejs/node/pull/20742)
* \[[`657f8cbe41`](https://github.com/nodejs/node/commit/657f8cbe41)] - **doc**: fix linter warnings and typos in manpage (Alhadis) [#20741](https://github.com/nodejs/node/pull/20741)
* \[[`165971d35b`](https://github.com/nodejs/node/commit/165971d35b)] - **doc**: sort references in ASCII order (Rich Trott) [#20790](https://github.com/nodejs/node/pull/20790)
* \[[`8f489a2447`](https://github.com/nodejs/node/commit/8f489a2447)] - **doc**: add .github to CODEOWNERS (Rich Trott) [#20733](https://github.com/nodejs/node/pull/20733)
* \[[`7943449305`](https://github.com/nodejs/node/commit/7943449305)] - **doc**: improve specificity in CODEOWNERS (Rich Trott) [#20729](https://github.com/nodejs/node/pull/20729)
* \[[`7d28f5bb1b`](https://github.com/nodejs/node/commit/7d28f5bb1b)] - **doc**: reorder CODEOWNERS file (Rich Trott) [#20732](https://github.com/nodejs/node/pull/20732)
* \[[`fd14ec1101`](https://github.com/nodejs/node/commit/fd14ec1101)] - **doc**: add missing `changes:` entry for assert.throws (Anna Henningsen) [#20723](https://github.com/nodejs/node/pull/20723)
* \[[`a66aad4a50`](https://github.com/nodejs/node/commit/a66aad4a50)] - **doc**: fixup NODE\_EXTERN -> NAPI\_EXTERN (Michael Dawson) [#20641](https://github.com/nodejs/node/pull/20641)
* \[[`f263340731`](https://github.com/nodejs/node/commit/f263340731)] - **doc**: fix signature for napi\_create\_range\_error (Michael Dawson) [#20641](https://github.com/nodejs/node/pull/20641)
* \[[`d11a435875`](https://github.com/nodejs/node/commit/d11a435875)] - **doc**: fix typo in dns docs (Anna Henningsen) [#20711](https://github.com/nodejs/node/pull/20711)
* \[[`512982c0ff`](https://github.com/nodejs/node/commit/512982c0ff)] - **doc**: update AUTHORS list (Michaël Zasso) [#20658](https://github.com/nodejs/node/pull/20658)
* \[[`e06c5874f6`](https://github.com/nodejs/node/commit/e06c5874f6)] - **doc**: add global node\_modules to require.resolve() (musgravejw) [#20534](https://github.com/nodejs/node/pull/20534)
* \[[`1d7379d641`](https://github.com/nodejs/node/commit/1d7379d641)] - **doc**: fix stability text for n-api (Michael Dawson) [#20659](https://github.com/nodejs/node/pull/20659)
* \[[`73492233c3`](https://github.com/nodejs/node/commit/73492233c3)] - **doc**: add util.types.isModuleNamespaceObject() (Gus Caplan) [#20616](https://github.com/nodejs/node/pull/20616)
* \[[`3929516a6f`](https://github.com/nodejs/node/commit/3929516a6f)] - **doc**: fix nits in doc/api\_assets/style.css (Vse Mozhet Byt) [#20601](https://github.com/nodejs/node/pull/20601)
* \[[`01abed1c36`](https://github.com/nodejs/node/commit/01abed1c36)] - **doc**: update assert documentation (Ruben Bridgewater) [#20486](https://github.com/nodejs/node/pull/20486)
* \[[`c546746396`](https://github.com/nodejs/node/commit/c546746396)] - **doc**: add util.types.isBig{Int,Uint}64Array() (cjihrig) [#20615](https://github.com/nodejs/node/pull/20615)
* \[[`d568952b8c`](https://github.com/nodejs/node/commit/d568952b8c)] - **doc**: fix missing napi\_get\_typedarray\_info() param (Gabriel Schulhof) [#20631](https://github.com/nodejs/node/pull/20631)
* \[[`9177f734e3`](https://github.com/nodejs/node/commit/9177f734e3)] - **doc**: update VM section text (Daniel Bevenius) [#20595](https://github.com/nodejs/node/pull/20595)
* \[[`88bc6da6e9`](https://github.com/nodejs/node/commit/88bc6da6e9)] - **doc**: add parameters for Http2Stream:error event (Ujjwal Sharma) [#20610](https://github.com/nodejs/node/pull/20610)
* \[[`b3b267a87c`](https://github.com/nodejs/node/commit/b3b267a87c)] - **doc**: add params for ClientHttp2Session:altsvc (Ujjwal Sharma) [#20598](https://github.com/nodejs/node/pull/20598)
* \[[`d327893193`](https://github.com/nodejs/node/commit/d327893193)] - **doc**: refactor mode constants parts in fs.md (Shobhit Chittora) [#20558](https://github.com/nodejs/node/pull/20558)
* \[[`4a7bb406fe`](https://github.com/nodejs/node/commit/4a7bb406fe)] - **doc, tools**: unify stability signatures (Vse Mozhet Byt) [#20552](https://github.com/nodejs/node/pull/20552)
* \[[`c244436707`](https://github.com/nodejs/node/commit/c244436707)] - **errors**: move functions to error code (Ruben Bridgewater) [#20486](https://github.com/nodejs/node/pull/20486)
* \[[`104c3bc443`](https://github.com/nodejs/node/commit/104c3bc443)] - **(SEMVER-MINOR)** **esm**: provide named exports for builtin libs (Gus Caplan) [#20403](https://github.com/nodejs/node/pull/20403)
* \[[`9b43af3703`](https://github.com/nodejs/node/commit/9b43af3703)] - **fs**: lazy load createPromise/promiseResolve (James M Snell) [#20766](https://github.com/nodejs/node/pull/20766)
* \[[`2d2897855f`](https://github.com/nodejs/node/commit/2d2897855f)] - **fs**: lazy load the promises impl (James M Snell) [#20766](https://github.com/nodejs/node/pull/20766)
* \[[`dc30d36467`](https://github.com/nodejs/node/commit/dc30d36467)] - **fs**: consistent constants use and cleanup (James M Snell) [#20765](https://github.com/nodejs/node/pull/20765)
* \[[`e5a0c197bd`](https://github.com/nodejs/node/commit/e5a0c197bd)] - **fs**: refactor promises version of lchown and lchmod (cjihrig) [#20551](https://github.com/nodejs/node/pull/20551)
* \[[`39caa6ddaf`](https://github.com/nodejs/node/commit/39caa6ddaf)] - **fs**: use \_final() for fs.WriteStream (Jackson Tian) [#20562](https://github.com/nodejs/node/pull/20562)
* \[[`de06115d18`](https://github.com/nodejs/node/commit/de06115d18)] - **fs**: make fs.promises non-enumerable (cjihrig) [#20632](https://github.com/nodejs/node/pull/20632)
* \[[`fe7e8d6a3e`](https://github.com/nodejs/node/commit/fe7e8d6a3e)] - **http**: fix capitalization of 418 status message (я котик пур-пур) [#20700](https://github.com/nodejs/node/pull/20700)
* \[[`75e4415c40`](https://github.com/nodejs/node/commit/75e4415c40)] - **http**: do not rely on the 'agentRemove' event (Luigi Pinca) [#20786](https://github.com/nodejs/node/pull/20786)
* \[[`4c6bfbdbb4`](https://github.com/nodejs/node/commit/4c6bfbdbb4)] - **http**: fix client response close & aborted (Robert Nagy) [#20075](https://github.com/nodejs/node/pull/20075)
* \[[`8029a2473e`](https://github.com/nodejs/node/commit/8029a2473e)] - **http**: always emit close on req and res (Robert Nagy) [#20611](https://github.com/nodejs/node/pull/20611)
* \[[`2687d44739`](https://github.com/nodejs/node/commit/2687d44739)] - **http2**: fix several serious bugs (Anatoli Papirovski) [#20772](https://github.com/nodejs/node/pull/20772)
* \[[`b2fb1d70bb`](https://github.com/nodejs/node/commit/b2fb1d70bb)] - **http2**: fix end without read (Anatoli Papirovski) [#20621](https://github.com/nodejs/node/pull/20621)
* \[[`de2b04772b`](https://github.com/nodejs/node/commit/de2b04772b)] - **http2**: avoid bind and properly clean up in compat (Robert Nagy) [#20374](https://github.com/nodejs/node/pull/20374)
* \[[`28ecf93dc5`](https://github.com/nodejs/node/commit/28ecf93dc5)] - **http2**: destroy the socket properly and add tests (Mathias Buus) [#19852](https://github.com/nodejs/node/pull/19852)
* \[[`92dd9b59eb`](https://github.com/nodejs/node/commit/92dd9b59eb)] - **inspector**: get rid of the make\_unique (Eugene Ostroukhov) [#20895](https://github.com/nodejs/node/pull/20895)
* \[[`04f7678edb`](https://github.com/nodejs/node/commit/04f7678edb)] - **inspector**: add a "NodeTracing" domain support (Eugene Ostroukhov) [#20608](https://github.com/nodejs/node/pull/20608)
* \[[`ccf69dd3b6`](https://github.com/nodejs/node/commit/ccf69dd3b6)] - **inspector**: fix inspector::Agent::HasConnectedSessions (helloshuangzi) [#20614](https://github.com/nodejs/node/pull/20614)
* \[[`e0fd80c641`](https://github.com/nodejs/node/commit/e0fd80c641)] - **lib**: do not call performance hooks (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`bd13193979`](https://github.com/nodejs/node/commit/bd13193979)] - **lib**: remove unnecessary require (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`07537749db`](https://github.com/nodejs/node/commit/07537749db)] - **lib**: use capital letters in comments (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`72f3228203`](https://github.com/nodejs/node/commit/72f3228203)] - **lib**: lazy loaded (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`3aab6ce39d`](https://github.com/nodejs/node/commit/3aab6ce39d)] - **lib**: lazy load necessary loaders (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`486ac23cb0`](https://github.com/nodejs/node/commit/486ac23cb0)] - **lib**: only load inspector stuff if necessary (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`61415dccc4`](https://github.com/nodejs/node/commit/61415dccc4)] - **(SEMVER-MINOR)** **lib**: defer pausing stdin to the next tick (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`7c13e54ca7`](https://github.com/nodejs/node/commit/7c13e54ca7)] - **lib**: return directly from packageMainCache (Daniel Bevenius) [#20591](https://github.com/nodejs/node/pull/20591)
* \[[`fb7a775242`](https://github.com/nodejs/node/commit/fb7a775242)] - **lib,src**: use V8 API for collection inspection (Anna Henningsen) [#20719](https://github.com/nodejs/node/pull/20719)
* \[[`8d8b0bdf38`](https://github.com/nodejs/node/commit/8d8b0bdf38)] - **lib,src,test**: fix comments (Tobias Nießen) [#20846](https://github.com/nodejs/node/pull/20846)
* \[[`b10823506d`](https://github.com/nodejs/node/commit/b10823506d)] - **meta**: add initial CODEOWNERS file (James M Snell) [#20554](https://github.com/nodejs/node/pull/20554)
* \[[`678b7544df`](https://github.com/nodejs/node/commit/678b7544df)] - **module**: introduce defaultModuleName in module.js (Daniel Bevenius) [#20709](https://github.com/nodejs/node/pull/20709)
* \[[`b6ea5df08a`](https://github.com/nodejs/node/commit/b6ea5df08a)] - **(SEMVER-MINOR)** **module**: add --preserve-symlinks-main (David Goldstein) [#19911](https://github.com/nodejs/node/pull/19911)
* \[[`eac7aad55e`](https://github.com/nodejs/node/commit/eac7aad55e)] - **net**: lazy load dns (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`1f34c04bd0`](https://github.com/nodejs/node/commit/1f34c04bd0)] - **net**: remove typo in setTimeout comment (Daniel Bevenius) [#20576](https://github.com/nodejs/node/pull/20576)
* \[[`d614511b9f`](https://github.com/nodejs/node/commit/d614511b9f)] - **net,http2**: refactor \_write and \_writev (Ujjwal Sharma) [#20643](https://github.com/nodejs/node/pull/20643)
* \[[`28d00a18c8`](https://github.com/nodejs/node/commit/28d00a18c8)] - **os**: lazy loaded (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`2e9957641e`](https://github.com/nodejs/node/commit/2e9957641e)] - **perf\_hooks**: always set bootstrapComplete (James M Snell) [#20768](https://github.com/nodejs/node/pull/20768)
* \[[`c8fe8e8f5d`](https://github.com/nodejs/node/commit/c8fe8e8f5d)] - **(SEMVER-MINOR)** **process**: create stdin with `manualStart: true` (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`4a92da15dc`](https://github.com/nodejs/node/commit/4a92da15dc)] - **querystring**: lazy loaded (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`3eb38debb4`](https://github.com/nodejs/node/commit/3eb38debb4)] - **readline**: lazy loaded (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`ada41b02c5`](https://github.com/nodejs/node/commit/ada41b02c5)] - **repl**: make console, module and require non-enumerable (Ruben Bridgewater) [#20717](https://github.com/nodejs/node/pull/20717)
* \[[`83119db45e`](https://github.com/nodejs/node/commit/83119db45e)] - **repl**: add friendly tips about how to exit repl (monkingxue) [#20617](https://github.com/nodejs/node/pull/20617)
* \[[`c4f0e81dd0`](https://github.com/nodejs/node/commit/c4f0e81dd0)] - **src**: trace\_events: background thread events (Ali Ijaz Sheikh) [#20823](https://github.com/nodejs/node/pull/20823)
* \[[`3110d15f2b`](https://github.com/nodejs/node/commit/3110d15f2b)] - **src**: make pointers lean left in node\_crypto.cc (Daniel Bevenius) [#20799](https://github.com/nodejs/node/pull/20799)
* \[[`b6225349f4`](https://github.com/nodejs/node/commit/b6225349f4)] - **src**: use unqualified names in node\_crypto.cc (Daniel Bevenius) [#20799](https://github.com/nodejs/node/pull/20799)
* \[[`010ad8c26c`](https://github.com/nodejs/node/commit/010ad8c26c)] - **src**: move \*Exceptions out to separate cc/h (James M Snell) [#20789](https://github.com/nodejs/node/pull/20789)
* \[[`08b98d17f1`](https://github.com/nodejs/node/commit/08b98d17f1)] - **src**: fix odd linting issue (James M Snell) [#20789](https://github.com/nodejs/node/pull/20789)
* \[[`36d4a42e35`](https://github.com/nodejs/node/commit/36d4a42e35)] - **src**: move CallbackScope to separate cc/h (James M Snell) [#20789](https://github.com/nodejs/node/pull/20789)
* \[[`4b64c847f1`](https://github.com/nodejs/node/commit/4b64c847f1)] - **src**: trace\_events: support for metadata events (Ali Ijaz Sheikh) [#20757](https://github.com/nodejs/node/pull/20757)
* \[[`3edb04d065`](https://github.com/nodejs/node/commit/3edb04d065)] - **src**: remove 2nd `undefined` argument in node\_file.cc (Dan Kang) [#20629](https://github.com/nodejs/node/pull/20629)
* \[[`d6805c15a5`](https://github.com/nodejs/node/commit/d6805c15a5)] - **src**: add override to ThreadPool methods in zlib (Daniel Bevenius) [#20769](https://github.com/nodejs/node/pull/20769)
* \[[`01aa0581fe`](https://github.com/nodejs/node/commit/01aa0581fe)] - **src**: order C++ error list alphabetically (Anna Henningsen) [#20707](https://github.com/nodejs/node/pull/20707)
* \[[`5eb0765fc9`](https://github.com/nodejs/node/commit/5eb0765fc9)] - **src**: handle TryCatch with empty message (Ben Noordhuis) [#20708](https://github.com/nodejs/node/pull/20708)
* \[[`e0b438a641`](https://github.com/nodejs/node/commit/e0b438a641)] - **(SEMVER-MINOR)** **src**: add public API to create isolate and context (helloshuangzi) [#20639](https://github.com/nodejs/node/pull/20639)
* \[[`d223e3ca41`](https://github.com/nodejs/node/commit/d223e3ca41)] - **src**: make `AsyncResource` destructor virtual (Anna Henningsen) [#20633](https://github.com/nodejs/node/pull/20633)
* \[[`28b58b56a8`](https://github.com/nodejs/node/commit/28b58b56a8)] - **src**: replace `template<` → `template <` (Anna Henningsen) [#20675](https://github.com/nodejs/node/pull/20675)
* \[[`30aceedba6`](https://github.com/nodejs/node/commit/30aceedba6)] - **src**: make env\_ and context\_ private (Daniel Bevenius) [#20671](https://github.com/nodejs/node/pull/20671)
* \[[`9422909e07`](https://github.com/nodejs/node/commit/9422909e07)] - **src**: remove unused includes from node\_contextify.h (Daniel Bevenius) [#20670](https://github.com/nodejs/node/pull/20670)
* \[[`e732b4ce5c`](https://github.com/nodejs/node/commit/e732b4ce5c)] - **src**: use unqualified names in node\_contextify.cc (Daniel Bevenius) [#20669](https://github.com/nodejs/node/pull/20669)
* \[[`57dfd64f8f`](https://github.com/nodejs/node/commit/57dfd64f8f)] - **src**: add missing override to ThreadPoolWork funcs (Daniel Bevenius) [#20663](https://github.com/nodejs/node/pull/20663)
* \[[`2347ce8870`](https://github.com/nodejs/node/commit/2347ce8870)] - **(SEMVER-MINOR)** **src**: unify thread pool work (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`7153bec955`](https://github.com/nodejs/node/commit/7153bec955)] - **(SEMVER-MINOR)** **src**: always call ReadStop() before Close() (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`9e1dcdc5bd`](https://github.com/nodejs/node/commit/9e1dcdc5bd)] - **(SEMVER-MINOR)** **src**: remove NodeCategorySet destructor (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`97d939a5f0`](https://github.com/nodejs/node/commit/97d939a5f0)] - **(SEMVER-MINOR)** **src**: store fd for libuv streams on Windows (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`5b0d2e7b19`](https://github.com/nodejs/node/commit/5b0d2e7b19)] - **(SEMVER-MINOR)** **src**: add can\_call\_into\_js flag (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`9e2554ce98`](https://github.com/nodejs/node/commit/9e2554ce98)] - **(SEMVER-MINOR)** **src**: use cleanup hooks to tear down BaseObjects (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`8995408748`](https://github.com/nodejs/node/commit/8995408748)] - **(SEMVER-MINOR)** **src**: keep track of open requests (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`75aad9069b`](https://github.com/nodejs/node/commit/75aad9069b)] - **(SEMVER-MINOR)** **src**: unify ReqWrap libuv calling (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`e253edb48a`](https://github.com/nodejs/node/commit/e253edb48a)] - **(SEMVER-MINOR)** **src**: make CleanupHandles() tear down handles/reqs (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`ba269585ed`](https://github.com/nodejs/node/commit/ba269585ed)] - **(SEMVER-MINOR)** **src**: add environment cleanup hooks (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`40fb885ecf`](https://github.com/nodejs/node/commit/40fb885ecf)] - **src**: more automatic memory management in node\_crypto.cc (Anna Henningsen) [#20238](https://github.com/nodejs/node/pull/20238)
* \[[`fd5adbc9c3`](https://github.com/nodejs/node/commit/fd5adbc9c3)] - **src**: fix node\_crypto.cc compiler warnings (Daniel Bevenius) [#20216](https://github.com/nodejs/node/pull/20216)
* \[[`db457cb6a0`](https://github.com/nodejs/node/commit/db457cb6a0)] - **src**: fix typo in util.h comment (Anna Henningsen) [#20656](https://github.com/nodejs/node/pull/20656)
* \[[`e93726ad10`](https://github.com/nodejs/node/commit/e93726ad10)] - **src**: fix nullptr dereference for signal during startup (Anna Henningsen) [#20637](https://github.com/nodejs/node/pull/20637)
* \[[`0824ea9d7b`](https://github.com/nodejs/node/commit/0824ea9d7b)] - **src**: use unqualified names in module\_wrap.cc (Daniel Bevenius) [#20594](https://github.com/nodejs/node/pull/20594)
* \[[`43ec938634`](https://github.com/nodejs/node/commit/43ec938634)] - **src**: remove static variables from string\_search (Anna Henningsen) [#20541](https://github.com/nodejs/node/pull/20541)
* \[[`4873fbaf63`](https://github.com/nodejs/node/commit/4873fbaf63)] - **src**: remove unused freelist.h header (Anna Henningsen) [#20544](https://github.com/nodejs/node/pull/20544)
* \[[`a89cc2886e`](https://github.com/nodejs/node/commit/a89cc2886e)] - **src**: protect global state with mutexes (Anna Henningsen) [#20542](https://github.com/nodejs/node/pull/20542)
* \[[`2df99ac095`](https://github.com/nodejs/node/commit/2df99ac095)] - **src**: use lock for c-ares library init/cleanup (Anna Henningsen) [#20539](https://github.com/nodejs/node/pull/20539)
* \[[`5803973206`](https://github.com/nodejs/node/commit/5803973206)] - **src**: minor refactor to string\_search.h (Anna Henningsen) [#20546](https://github.com/nodejs/node/pull/20546)
* \[[`983cb269e0`](https://github.com/nodejs/node/commit/983cb269e0)] - **src**: don't create Undefined if not needed (Daniel Bevenius) [#20573](https://github.com/nodejs/node/pull/20573)
* \[[`e01e060763`](https://github.com/nodejs/node/commit/e01e060763)] - **src**: rename handle parameter object (Daniel Bevenius) [#20570](https://github.com/nodejs/node/pull/20570)
* \[[`328a2c7c28`](https://github.com/nodejs/node/commit/328a2c7c28)] - **stream**: lazy load end-of-stream (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`94d217f877`](https://github.com/nodejs/node/commit/94d217f877)] - **stream**: lazy load ReadableAsyncIterator (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`ed5f253cfa`](https://github.com/nodejs/node/commit/ed5f253cfa)] - **stream**: refactor getHighWaterMark in state.js (Daniel Bevenius) [#20415](https://github.com/nodejs/node/pull/20415)
* \[[`39a41120d4`](https://github.com/nodejs/node/commit/39a41120d4)] - **stream**: simplify writable's validChunk() (cjihrig) [#20696](https://github.com/nodejs/node/pull/20696)
* \[[`981a2f7b16`](https://github.com/nodejs/node/commit/981a2f7b16)] - **stream**: simplify Writable.prototype.cork() (cjihrig) [#20697](https://github.com/nodejs/node/pull/20697)
* \[[`ebc1b77e5a`](https://github.com/nodejs/node/commit/ebc1b77e5a)] - **stream**: no need to initial er with false (Jackson Tian) [#20607](https://github.com/nodejs/node/pull/20607)
* \[[`0ace8f9835`](https://github.com/nodejs/node/commit/0ace8f9835)] - **string\_decoder**: lazy loaded (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`5886b7826c`](https://github.com/nodejs/node/commit/5886b7826c)] - **test**: test about:blank against invalid WHATWG URL (Joyee Cheung) [#20796](https://github.com/nodejs/node/pull/20796)
* \[[`b6d678b018`](https://github.com/nodejs/node/commit/b6d678b018)] - **test**: fix tests that fail under coverage (Benjamin Coe) [#20794](https://github.com/nodejs/node/pull/20794)
* \[[`dc29a3b386`](https://github.com/nodejs/node/commit/dc29a3b386)] - **test**: add promise API test for appendFile() (Rich Trott) [#20842](https://github.com/nodejs/node/pull/20842)
* \[[`d9aecc0c07`](https://github.com/nodejs/node/commit/d9aecc0c07)] - **test**: improve coverage for internal/readline (Masashi Hirano) [#20840](https://github.com/nodejs/node/pull/20840)
* \[[`9c560ca907`](https://github.com/nodejs/node/commit/9c560ca907)] - **test**: rename and document tls test (Anna Henningsen) [#20820](https://github.com/nodejs/node/pull/20820)
* \[[`dd32a7a0d4`](https://github.com/nodejs/node/commit/dd32a7a0d4)] - **test**: fix flaky http2-session-unref (Anatoli Papirovski) [#20772](https://github.com/nodejs/node/pull/20772)
* \[[`a8c74e89ae`](https://github.com/nodejs/node/commit/a8c74e89ae)] - **test**: use error code rather than message in test (Rich Trott) [#20859](https://github.com/nodejs/node/pull/20859)
* \[[`f5f9cdc110`](https://github.com/nodejs/node/commit/f5f9cdc110)] - **test**: define SharedArrayBuffer as a known global (cjihrig) [#20849](https://github.com/nodejs/node/pull/20849)
* \[[`22f46e7766`](https://github.com/nodejs/node/commit/22f46e7766)] - **test**: remove common.globalCheck (Ruben Bridgewater) [#20717](https://github.com/nodejs/node/pull/20717)
* \[[`5ffce3ef06`](https://github.com/nodejs/node/commit/5ffce3ef06)] - **test**: remove untested knownGlobals (Ruben Bridgewater) [#20717](https://github.com/nodejs/node/pull/20717)
* \[[`e7c2616d10`](https://github.com/nodejs/node/commit/e7c2616d10)] - **test**: mark tests as flaky as intermediate step (Ruben Bridgewater) [#20835](https://github.com/nodejs/node/pull/20835)
* \[[`b664a848fa`](https://github.com/nodejs/node/commit/b664a848fa)] - **test**: improve assertion in test-performance (Anna Henningsen) [#20809](https://github.com/nodejs/node/pull/20809)
* \[[`045b37b32d`](https://github.com/nodejs/node/commit/045b37b32d)] - **test**: add eslint rule to verify assertion input (Ruben Bridgewater) [#20718](https://github.com/nodejs/node/pull/20718)
* \[[`1ae076b30e`](https://github.com/nodejs/node/commit/1ae076b30e)] - **test**: add loaded modules test (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`9e432ca79c`](https://github.com/nodejs/node/commit/9e432ca79c)] - **test**: add promise API test for appendFile() (Rich Trott) [#20739](https://github.com/nodejs/node/pull/20739)
* \[[`a6667d68f3`](https://github.com/nodejs/node/commit/a6667d68f3)] - **test**: slightly improve test-util-inspect assertions (Anna Henningsen) [#20721](https://github.com/nodejs/node/pull/20721)
* \[[`a4cbe30791`](https://github.com/nodejs/node/commit/a4cbe30791)] - **test**: improve reliability of http2-session-timeout (Rich Trott) [#20692](https://github.com/nodejs/node/pull/20692)
* \[[`0d28b4b6ba`](https://github.com/nodejs/node/commit/0d28b4b6ba)] - **test**: disable colors in test-assert-checktag.js (cjihrig) [#20695](https://github.com/nodejs/node/pull/20695)
* \[[`dccbc3a153`](https://github.com/nodejs/node/commit/dccbc3a153)] - **test**: disable colors in test-assert-deep.js (cjihrig) [#20695](https://github.com/nodejs/node/pull/20695)
* \[[`90c77bcc18`](https://github.com/nodejs/node/commit/90c77bcc18)] - **test**: disable colors in test-assert.js (cjihrig) [#20695](https://github.com/nodejs/node/pull/20695)
* \[[`2b6e8ccfd4`](https://github.com/nodejs/node/commit/2b6e8ccfd4)] - **test**: increase test coverage for fs/promises.js (David Humphrey) [#19811](https://github.com/nodejs/node/pull/19811)
* \[[`e6c0bbe185`](https://github.com/nodejs/node/commit/e6c0bbe185)] - **test**: display values in AssertionErrors (RakshithNM) [#20545](https://github.com/nodejs/node/pull/20545)
* \[[`886116f837`](https://github.com/nodejs/node/commit/886116f837)] - **test**: apply test-fs-access to promises API (Rich Trott) [#20667](https://github.com/nodejs/node/pull/20667)
* \[[`2a7c863d3d`](https://github.com/nodejs/node/commit/2a7c863d3d)] - **test**: modernize and correct test-doctool-html.js (Vse Mozhet Byt) [#20676](https://github.com/nodejs/node/pull/20676)
* \[[`9c1c03e5d4`](https://github.com/nodejs/node/commit/9c1c03e5d4)] - **test**: better error message in trace events test (Anna Henningsen) [#20655](https://github.com/nodejs/node/pull/20655)
* \[[`0aab92f6b2`](https://github.com/nodejs/node/commit/0aab92f6b2)] - **test**: add test for async hooks parity for async/await (Maya Lekova) [#20626](https://github.com/nodejs/node/pull/20626)
* \[[`2db83fdc0c`](https://github.com/nodejs/node/commit/2db83fdc0c)] - **test**: remove deepStrictEqual() third argument (Francesco Falanga) [#20702](https://github.com/nodejs/node/pull/20702)
* \[[`87f3f5af2e`](https://github.com/nodejs/node/commit/87f3f5af2e)] - **test**: plug AliasedBuffer cctest memory leak (Anna Henningsen) [#20665](https://github.com/nodejs/node/pull/20665)
* \[[`eb21a6b7f6`](https://github.com/nodejs/node/commit/eb21a6b7f6)] - **test**: remove crypto.DEFAULT\_ENCODING usage (Daniel Bevenius) [#20221](https://github.com/nodejs/node/pull/20221)
* \[[`de34cfad58`](https://github.com/nodejs/node/commit/de34cfad58)] - **test**: make sure linked lists are inspectable with defaults (Anna Henningsen) [#20017](https://github.com/nodejs/node/pull/20017)
* \[[`41e1dc09de`](https://github.com/nodejs/node/commit/41e1dc09de)] - **test**: add regression test for #11257 (Benjamin Coe) [#20391](https://github.com/nodejs/node/pull/20391)
* \[[`56530f0844`](https://github.com/nodejs/node/commit/56530f0844)] - **(SEMVER-MINOR)** **timers**: make timer.refresh() a public API (Jeremiah Senkpiel) [#20298](https://github.com/nodejs/node/pull/20298)
* \[[`bd500af2ff`](https://github.com/nodejs/node/commit/bd500af2ff)] - **tools**: update prohibited-strings md linting (Rich Trott) [#20742](https://github.com/nodejs/node/pull/20742)
* \[[`2361f6454c`](https://github.com/nodejs/node/commit/2361f6454c)] - **tools**: stricter eslint rule for globals (Ruben Bridgewater) [#20567](https://github.com/nodejs/node/pull/20567)
* \[[`38fc741c36`](https://github.com/nodejs/node/commit/38fc741c36)] - **tools**: eliminate intermediate module in doctools (Vse Mozhet Byt) [#20701](https://github.com/nodejs/node/pull/20701)
* \[[`6f4e9ffb7b`](https://github.com/nodejs/node/commit/6f4e9ffb7b)] - **tools**: fix "the the" typos in comments (Masashi Hirano) [#20716](https://github.com/nodejs/node/pull/20716)
* \[[`b795953b5f`](https://github.com/nodejs/node/commit/b795953b5f)] - **tools**: hide symbols for builtin JS files in binary (Anna Henningsen) [#20634](https://github.com/nodejs/node/pull/20634)
* \[[`44960a0d5a`](https://github.com/nodejs/node/commit/44960a0d5a)] - **tools**: make C++ linter reject `template<` (Anna Henningsen) [#20675](https://github.com/nodejs/node/pull/20675)
* \[[`7bff6d15b2`](https://github.com/nodejs/node/commit/7bff6d15b2)] - **tools**: overhaul tools/doc/html.js (Vse Mozhet Byt) [#20613](https://github.com/nodejs/node/pull/20613)
* \[[`f2ad1d5d22`](https://github.com/nodejs/node/commit/f2ad1d5d22)] - **(SEMVER-MINOR)** **tools**: remove `--quiet` from run-valgrind.py (Anna Henningsen) [#19377](https://github.com/nodejs/node/pull/19377)
* \[[`ebd102e473`](https://github.com/nodejs/node/commit/ebd102e473)] - **tools**: use macOS as operating system name (Rich Trott) [#20579](https://github.com/nodejs/node/pull/20579)
* \[[`08097ccf84`](https://github.com/nodejs/node/commit/08097ccf84)] - **tools**: ignore VS compiler output (Yulong Wang) [#20527](https://github.com/nodejs/node/pull/20527)
* \[[`8781bcb1ee`](https://github.com/nodejs/node/commit/8781bcb1ee)] - **tools, doc**: wrap manpage links in code elements (Vse Mozhet Byt) [#20785](https://github.com/nodejs/node/pull/20785)
* \[[`e1ff587a26`](https://github.com/nodejs/node/commit/e1ff587a26)] - **tools, doc**: fix stability index isssues (Vse Mozhet Byt) [#20731](https://github.com/nodejs/node/pull/20731)
* \[[`526163cff9`](https://github.com/nodejs/node/commit/526163cff9)] - **url**: introduce `URL_FLAGS_IS_DEFAULT_SCHEME_PORT` flag (Ayush Gupta) [#20479](https://github.com/nodejs/node/pull/20479)
* \[[`c8c9211fa6`](https://github.com/nodejs/node/commit/c8c9211fa6)] - **util**: improve error inspection (Ruben Bridgewater) [#20802](https://github.com/nodejs/node/pull/20802)
* \[[`f0d6a37c5c`](https://github.com/nodejs/node/commit/f0d6a37c5c)] - **util**: fix inspected stack indentation (Ruben Bridgewater) [#20802](https://github.com/nodejs/node/pull/20802)
* \[[`38bc5fbd6b`](https://github.com/nodejs/node/commit/38bc5fbd6b)] - **util**: remove erroneous whitespace (Ruben Bridgewater) [#20802](https://github.com/nodejs/node/pull/20802)
* \[[`5ce85a72cb`](https://github.com/nodejs/node/commit/5ce85a72cb)] - **util**: wrap error in brackets without stack (Ruben Bridgewater) [#20802](https://github.com/nodejs/node/pull/20802)
* \[[`b308a07301`](https://github.com/nodejs/node/commit/b308a07301)] - **util**: support inspecting namespaces of unevaluated modules (Gus Caplan) [#20782](https://github.com/nodejs/node/pull/20782)
* \[[`105f606202`](https://github.com/nodejs/node/commit/105f606202)] - **v8**: backport 9fb02b526f1cd3b859a530a01adb08bc0d089f4f (Gus Caplan) [#20575](https://github.com/nodejs/node/pull/20575)
* \[[`8604481b2e`](https://github.com/nodejs/node/commit/8604481b2e)] - **vm**: move emitExperimentalWarning (Daniel Bevenius) [#20593](https://github.com/nodejs/node/pull/20593)
* \[[`740bf783e5`](https://github.com/nodejs/node/commit/740bf783e5)] - **vm,trace\_events**: add node.vm.script trace events category (James M Snell) [#20728](https://github.com/nodejs/node/pull/20728)
* \[[`d5db576d15`](https://github.com/nodejs/node/commit/d5db576d15)] - **zlib**: reduce number of static internal methods (Anna Henningsen) [#20674](https://github.com/nodejs/node/pull/20674)

<a id="10.1.0"></a>

## 2018-05-08, Version 10.1.0 (Current), @MylesBorins

### Notable Changes

* **console**:
  * make console.table() use colored inspect (TSUYUSATO Kitsune) [#20510](https://github.com/nodejs/node/pull/20510)
* **fs**:
  * move fs/promises to fs.promises (cjihrig) [#20504](https://github.com/nodejs/node/pull/20504)
* **http**:
  * added aborted property to request (Robert Nagy) [#20094](https://github.com/nodejs/node/pull/20094)
* **n-api**:
  * initialize a module via a special symbol (Gabriel Schulhof) [#20161](https://github.com/nodejs/node/pull/20161)
* **src**:
  * add public API to expose the main V8 Platform (Allen Yonghuang Wang) [#20447](https://github.com/nodejs/node/pull/20447)

### Commits

* \[[`7293c58d51`](https://github.com/nodejs/node/commit/7293c58d51)] - **assert**: make skipping indicator blue (Ruben Bridgewater) [#20315](https://github.com/nodejs/node/pull/20315)
* \[[`f5054d3412`](https://github.com/nodejs/node/commit/f5054d3412)] - **assert**: minor error message improvements (Ruben Bridgewater) [#20315](https://github.com/nodejs/node/pull/20315)
* \[[`16970ffda4`](https://github.com/nodejs/node/commit/16970ffda4)] - **benchmark**: track exec time in next-tick-exec (Anatoli Papirovski) [#20462](https://github.com/nodejs/node/pull/20462)
* \[[`289e4cef3f`](https://github.com/nodejs/node/commit/289e4cef3f)] - **benchmark**: fix next-tick-depth (Anatoli Papirovski) [#20461](https://github.com/nodejs/node/pull/20461)
* \[[`b0e6f10530`](https://github.com/nodejs/node/commit/b0e6f10530)] - **benchmark**: add bench for zlib gzip + gunzip cycle (Anna Henningsen) [#20034](https://github.com/nodejs/node/pull/20034)
* \[[`167de1f038`](https://github.com/nodejs/node/commit/167de1f038)] - **build**: check for different deprecation signatures (Ruben Bridgewater) [#20384](https://github.com/nodejs/node/pull/20384)
* \[[`348d391a71`](https://github.com/nodejs/node/commit/348d391a71)] - **build**: remove --xcode configure switch (Ben Noordhuis) [#20328](https://github.com/nodejs/node/pull/20328)
* \[[`2ce4b7cb8c`](https://github.com/nodejs/node/commit/2ce4b7cb8c)] - **build**: do not depend on `cp` in `PATH` (Anna Henningsen) [#20296](https://github.com/nodejs/node/pull/20296)
* \[[`c5b3459003`](https://github.com/nodejs/node/commit/c5b3459003)] - **build**: use -9 with `kill` in Makefile (Rich Trott) [#20195](https://github.com/nodejs/node/pull/20195)
* \[[`b5931e1d45`](https://github.com/nodejs/node/commit/b5931e1d45)] - **child\_process**: name anonymous functions (Denis Fäcke) [#20399](https://github.com/nodejs/node/pull/20399)
* \[[`ec2037da12`](https://github.com/nodejs/node/commit/ec2037da12)] - **child\_process**: fix leak when passing http sockets (Santiago Gimeno) [#20305](https://github.com/nodejs/node/pull/20305)
* \[[`a7758c76c0`](https://github.com/nodejs/node/commit/a7758c76c0)] - **(SEMVER-MINOR)** **console**: make console.table() use colored inspect (TSUYUSATO Kitsune) [#20510](https://github.com/nodejs/node/pull/20510)
* \[[`29bc735d42`](https://github.com/nodejs/node/commit/29bc735d42)] - **console**: fix console.table() display edge case (Rich Trott) [#20323](https://github.com/nodejs/node/pull/20323)
* \[[`dfcf20f5fd`](https://github.com/nodejs/node/commit/dfcf20f5fd)] - **crypto**: use new OpenSSL constants in CipherBase (Tobias Nießen) [#20339](https://github.com/nodejs/node/pull/20339)
* \[[`e17280e8c9`](https://github.com/nodejs/node/commit/e17280e8c9)] - **crypto**: make pbkdf2 use checkIsArrayBufferView (Daniel Bevenius) [#20251](https://github.com/nodejs/node/pull/20251)
* \[[`61e93963ce`](https://github.com/nodejs/node/commit/61e93963ce)] - **crypto**: add checkIsArrayBufferView (Daniel Bevenius) [#20251](https://github.com/nodejs/node/pull/20251)
* \[[`e81bb9f8a3`](https://github.com/nodejs/node/commit/e81bb9f8a3)] - **crypto**: add getIntOption function to reduce dupl (Daniel Bevenius) [#20247](https://github.com/nodejs/node/pull/20247)
* \[[`391d2f830a`](https://github.com/nodejs/node/commit/391d2f830a)] - **crypto**: simplify diffiehellman getFormat function (Daniel Bevenius) [#20246](https://github.com/nodejs/node/pull/20246)
* \[[`3cf53b66c2`](https://github.com/nodejs/node/commit/3cf53b66c2)] - **deps**: patch V8 to 6.6.346.27 (Myles Borins) [#20480](https://github.com/nodejs/node/pull/20480)
* \[[`da8bc6ab50`](https://github.com/nodejs/node/commit/da8bc6ab50)] - **deps**: cherry-pick 76cab5f from upstream V8 (Michaël Zasso) [#20350](https://github.com/nodejs/node/pull/20350)
* \[[`05ce635e9a`](https://github.com/nodejs/node/commit/05ce635e9a)] - **doc**: match console.count()/countReset() signatures (Lambdac0re) [#20599](https://github.com/nodejs/node/pull/20599)
* \[[`e995ae5992`](https://github.com/nodejs/node/commit/e995ae5992)] - **doc**: clarify `this` in event listeners (daGo) [#20537](https://github.com/nodejs/node/pull/20537)
* \[[`bd27a59865`](https://github.com/nodejs/node/commit/bd27a59865)] - **doc**: move tunniclm to Emeritus (Rich Trott) [#20533](https://github.com/nodejs/node/pull/20533)
* \[[`ec65fe48d8`](https://github.com/nodejs/node/commit/ec65fe48d8)] - **doc**: add trace category for fs sync methods (Chin Huang) [#20526](https://github.com/nodejs/node/pull/20526)
* \[[`8148fca730`](https://github.com/nodejs/node/commit/8148fca730)] - **doc**: update "Who to cc..." in COLLABORATOR\_GUIDE (Vse Mozhet Byt) [#20564](https://github.com/nodejs/node/pull/20564)
* \[[`70586c0334`](https://github.com/nodejs/node/commit/70586c0334)] - **doc**: excise "periodically" before "emit events" (Jesse W. Collins) [#20581](https://github.com/nodejs/node/pull/20581)
* \[[`01560b69a7`](https://github.com/nodejs/node/commit/01560b69a7)] - **doc**: edit text about revoking deprecations (Rich Trott) [#20519](https://github.com/nodejs/node/pull/20519)
* \[[`eed3f10615`](https://github.com/nodejs/node/commit/eed3f10615)] - **doc**: edit text for DEP0013 (Rich Trott) [#20519](https://github.com/nodejs/node/pull/20519)
* \[[`b2b4871c15`](https://github.com/nodejs/node/commit/b2b4871c15)] - **doc**: minor edit to DEP0065 (Rich Trott) [#20519](https://github.com/nodejs/node/pull/20519)
* \[[`73f5ea9bd9`](https://github.com/nodejs/node/commit/73f5ea9bd9)] - **doc**: fix minor typographical error in DEP0079 text (Rich Trott) [#20519](https://github.com/nodejs/node/pull/20519)
* \[[`faa81937a5`](https://github.com/nodejs/node/commit/faa81937a5)] - **doc**: edit text for DEP0082 (Rich Trott) [#20519](https://github.com/nodejs/node/pull/20519)
* \[[`f796b0856c`](https://github.com/nodejs/node/commit/f796b0856c)] - **doc**: fix text for DEP0085 (Rich Trott) [#20519](https://github.com/nodejs/node/pull/20519)
* \[[`74c74db35e`](https://github.com/nodejs/node/commit/74c74db35e)] - **doc**: edit text for DEP0094 (Rich Trott) [#20519](https://github.com/nodejs/node/pull/20519)
* \[[`c6e4ffa429`](https://github.com/nodejs/node/commit/c6e4ffa429)] - **doc**: edit text for DEP0012 (Rich Trott) [#20519](https://github.com/nodejs/node/pull/20519)
* \[[`adf5b80b20`](https://github.com/nodejs/node/commit/adf5b80b20)] - **doc**: edit text for DEP0101 (Rich Trott) [#20519](https://github.com/nodejs/node/pull/20519)
* \[[`67e44bf588`](https://github.com/nodejs/node/commit/67e44bf588)] - **doc**: edit text for DEP0104 (Rich Trott) [#20519](https://github.com/nodejs/node/pull/20519)
* \[[`0e8805186f`](https://github.com/nodejs/node/commit/0e8805186f)] - **doc**: add parameters for Http2Session:stream event (Ujjwal Sharma) [#20547](https://github.com/nodejs/node/pull/20547)
* \[[`98ccaead0d`](https://github.com/nodejs/node/commit/98ccaead0d)] - **doc**: clearer doc-only deprecations (Ruben Bridgewater) [#20381](https://github.com/nodejs/node/pull/20381)
* \[[`bea4ffcc97`](https://github.com/nodejs/node/commit/bea4ffcc97)] - **doc**: update one more command in crypto.md (Shobhit Chittora) [#20500](https://github.com/nodejs/node/pull/20500)
* \[[`018b5ad800`](https://github.com/nodejs/node/commit/018b5ad800)] - **doc**: add snake\_case section for C-like structs (Daniel Bevenius) [#20423](https://github.com/nodejs/node/pull/20423)
* \[[`8bd45d8212`](https://github.com/nodejs/node/commit/8bd45d8212)] - **doc**: updates crypto doc with openssl list -cipher-algorithms (Shobhit Chittora) [#20502](https://github.com/nodejs/node/pull/20502)
* \[[`880772a7ff`](https://github.com/nodejs/node/commit/880772a7ff)] - **doc**: fix N-API property descriptor documentation (Gabriel Schulhof) [#20433](https://github.com/nodejs/node/pull/20433)
* \[[`79e1260cd8`](https://github.com/nodejs/node/commit/79e1260cd8)] - **doc**: fix manpage warning (Jérémy Lal) [#20383](https://github.com/nodejs/node/pull/20383)
* \[[`745e0a5583`](https://github.com/nodejs/node/commit/745e0a5583)] - **doc**: document using `domain` in REPL (Ayush Gupta) [#20382](https://github.com/nodejs/node/pull/20382)
* \[[`b2e8b9c473`](https://github.com/nodejs/node/commit/b2e8b9c473)] - **doc**: fix mkdtemp() documentation (Rich Trott) [#20512](https://github.com/nodejs/node/pull/20512)
* \[[`d7db306d3b`](https://github.com/nodejs/node/commit/d7db306d3b)] - **doc**: update examples for fs.access() (BeniCheni) [#20460](https://github.com/nodejs/node/pull/20460)
* \[[`b2d6eb74d4`](https://github.com/nodejs/node/commit/b2d6eb74d4)] - **doc**: cleanup n-api.md doc (Michael Dawson) [#20430](https://github.com/nodejs/node/pull/20430)
* \[[`e5537477d4`](https://github.com/nodejs/node/commit/e5537477d4)] - **doc**: update Collaborator Guide reference (Rich Trott) [#20473](https://github.com/nodejs/node/pull/20473)
* \[[`391c420c3e`](https://github.com/nodejs/node/commit/391c420c3e)] - **doc**: synchronize argument names for appendFile() (Rich Trott) [#20489](https://github.com/nodejs/node/pull/20489)
* \[[`8b17e7ae04`](https://github.com/nodejs/node/commit/8b17e7ae04)] - **doc**: update cli flag in crypto.md (Shobhit Chittora) [#20400](https://github.com/nodejs/node/pull/20400)
* \[[`74685f1b8f`](https://github.com/nodejs/node/commit/74685f1b8f)] - **doc**: add missing periods in documentation.md (Vse Mozhet Byt) [#20469](https://github.com/nodejs/node/pull/20469)
* \[[`b0ed31cf9c`](https://github.com/nodejs/node/commit/b0ed31cf9c)] - **doc**: update writing-and-running-benchmarks.md (xsbchen) [#20379](https://github.com/nodejs/node/pull/20379)
* \[[`658fbdc105`](https://github.com/nodejs/node/commit/658fbdc105)] - **doc**: add http.ClientRequest maxHeadersCount (Daiki Arai) [#20361](https://github.com/nodejs/node/pull/20361)
* \[[`7a769ebba8`](https://github.com/nodejs/node/commit/7a769ebba8)] - **doc**: add squash guideline to pull-requests doc (Rich Trott) [#20413](https://github.com/nodejs/node/pull/20413)
* \[[`166df9e15c`](https://github.com/nodejs/node/commit/166df9e15c)] - **doc**: remove squash guideline from onboarding doc (Rich Trott) [#20413](https://github.com/nodejs/node/pull/20413)
* \[[`56c27c6a2b`](https://github.com/nodejs/node/commit/56c27c6a2b)] - **doc**: add more missing backticks (Vse Mozhet Byt) [#20438](https://github.com/nodejs/node/pull/20438)
* \[[`abf11550b2`](https://github.com/nodejs/node/commit/abf11550b2)] - **doc**: add missing periods or colons (Vse Mozhet Byt) [#20401](https://github.com/nodejs/node/pull/20401)
* \[[`261776d6b4`](https://github.com/nodejs/node/commit/261776d6b4)] - **doc**: mitigate `marked` bug (Vse Mozhet Byt) [#20411](https://github.com/nodejs/node/pull/20411)
* \[[`54e93315ed`](https://github.com/nodejs/node/commit/54e93315ed)] - **doc**: specify types of listener parameter (Vse Mozhet Byt) [#20405](https://github.com/nodejs/node/pull/20405)
* \[[`fcc5492df2`](https://github.com/nodejs/node/commit/fcc5492df2)] - **doc**: clarify FileHandle text (Rich Trott) [#20450](https://github.com/nodejs/node/pull/20450)
* \[[`5a839b9911`](https://github.com/nodejs/node/commit/5a839b9911)] - **doc**: remove unclear text from fs.write() (Rich Trott) [#20450](https://github.com/nodejs/node/pull/20450)
* \[[`459c20c0b8`](https://github.com/nodejs/node/commit/459c20c0b8)] - **doc**: edit fs.createReadStream() highWaterMark (Rich Trott) [#20450](https://github.com/nodejs/node/pull/20450)
* \[[`f36a5e3ba5`](https://github.com/nodejs/node/commit/f36a5e3ba5)] - **doc**: remove redundant table of contents for N-API (Ayush Gupta) [#20395](https://github.com/nodejs/node/pull/20395)
* \[[`4bc87c185b`](https://github.com/nodejs/node/commit/4bc87c185b)] - **doc**: add parameters for settings events (Ujjwal Sharma) [#20371](https://github.com/nodejs/node/pull/20371)
* \[[`d7557e111e`](https://github.com/nodejs/node/commit/d7557e111e)] - **doc**: refine napi\_get\_property\_names() doc (Gabriel Schulhof) [#20427](https://github.com/nodejs/node/pull/20427)
* \[[`b61ae7fe09`](https://github.com/nodejs/node/commit/b61ae7fe09)] - **doc**: remove "has been known" tentativeness (Rich Trott) [#20412](https://github.com/nodejs/node/pull/20412)
* \[[`de9d1f15de`](https://github.com/nodejs/node/commit/de9d1f15de)] - **doc**: remove parenthetical in onboarding-extras (Rich Trott) [#20393](https://github.com/nodejs/node/pull/20393)
* \[[`5542a98aa4`](https://github.com/nodejs/node/commit/5542a98aa4)] - **doc**: improve process event headers (Ruben Bridgewater) [#20312](https://github.com/nodejs/node/pull/20312)
* \[[`90026c3f3e`](https://github.com/nodejs/node/commit/90026c3f3e)] - **doc**: improve assert docs (Ruben Bridgewater) [#20313](https://github.com/nodejs/node/pull/20313)
* \[[`57e5a3e15f`](https://github.com/nodejs/node/commit/57e5a3e15f)] - **doc**: remove redundant empty lines (Vse Mozhet Byt) [#20398](https://github.com/nodejs/node/pull/20398)
* \[[`9cf3ae5bc3`](https://github.com/nodejs/node/commit/9cf3ae5bc3)] - **doc**: add missing backticks in n-api.md (Vse Mozhet Byt) [#20390](https://github.com/nodejs/node/pull/20390)
* \[[`be34388a07`](https://github.com/nodejs/node/commit/be34388a07)] - **doc**: unify and dedupe returned values in timers.md (Vse Mozhet Byt) [#20310](https://github.com/nodejs/node/pull/20310)
* \[[`9c11a18f70`](https://github.com/nodejs/node/commit/9c11a18f70)] - **doc**: remove eu-strip from tarball (jvelezpo) [#20304](https://github.com/nodejs/node/pull/20304)
* \[[`b47044ac0f`](https://github.com/nodejs/node/commit/b47044ac0f)] - **doc**: improve parameters for Http2Session:goaway event (Ujjwal Sharma)
* \[[`701f536ef4`](https://github.com/nodejs/node/commit/701f536ef4)] - **doc**: remove superfluous URL require statement (Mark Tiedemann) [#20364](https://github.com/nodejs/node/pull/20364)
* \[[`d9bc9217a7`](https://github.com/nodejs/node/commit/d9bc9217a7)] - **doc**: fix typo in console.md (Daniel Hritzkiv) [#20349](https://github.com/nodejs/node/pull/20349)
* \[[`cc09d7ec5b`](https://github.com/nodejs/node/commit/cc09d7ec5b)] - **doc**: remove console.table() as inspector-dependent (Rich Trott) [#20346](https://github.com/nodejs/node/pull/20346)
* \[[`14188b1266`](https://github.com/nodejs/node/commit/14188b1266)] - **doc**: add Slack community to support options (Tracy) [#18191](https://github.com/nodejs/node/pull/18191)
* \[[`3a3144cf04`](https://github.com/nodejs/node/commit/3a3144cf04)] - **doc**: remove os.uptime() Windows note (cjihrig) [#20308](https://github.com/nodejs/node/pull/20308)
* \[[`c139d2ab8d`](https://github.com/nodejs/node/commit/c139d2ab8d)] - **doc**: fix unhandled to uncaught (Ruben Bridgewater) [#20293](https://github.com/nodejs/node/pull/20293)
* \[[`7f6172b64b`](https://github.com/nodejs/node/commit/7f6172b64b)] - **doc**: improve docs for Http2Session:frameError (Ujjwal Sharma) [#20236](https://github.com/nodejs/node/pull/20236)
* \[[`c9b202f817`](https://github.com/nodejs/node/commit/c9b202f817)] - **doc**: add emitter.off() to events.md (Ajido) [#20291](https://github.com/nodejs/node/pull/20291)
* \[[`3bf736e569`](https://github.com/nodejs/node/commit/3bf736e569)] - **doc**: update pull request template in guide (Zachary Vacura) [#20277](https://github.com/nodejs/node/pull/20277)
* \[[`171cbb1c64`](https://github.com/nodejs/node/commit/171cbb1c64)] - **doc**: fix net.Socket link inconsistencies (Hackzzila) [#20271](https://github.com/nodejs/node/pull/20271)
* \[[`26525ef5ab`](https://github.com/nodejs/node/commit/26525ef5ab)] - **doc**: fix typos in doc/changelogs/CHANGELOG\_V10.md (Vse Mozhet Byt) [#20265](https://github.com/nodejs/node/pull/20265)
* \[[`3bc5353110`](https://github.com/nodejs/node/commit/3bc5353110)] - **doc**: fix spelling of API name in 10.0.0 changelog (Tobias Nießen) [#20257](https://github.com/nodejs/node/pull/20257)
* \[[`e25f2c9e91`](https://github.com/nodejs/node/commit/e25f2c9e91)] - **errors**: remove dead code (Ruben Bridgewater) [#20483](https://github.com/nodejs/node/pull/20483)
* \[[`b89d8178b4`](https://github.com/nodejs/node/commit/b89d8178b4)] - **errors**: minor (SystemError) refactoring (Ruben Bridgewater) [#20337](https://github.com/nodejs/node/pull/20337)
* \[[`58a65d6689`](https://github.com/nodejs/node/commit/58a65d6689)] - **events**: optimize condition for optimal scenario (Anatoli Papirovski) [#20452](https://github.com/nodejs/node/pull/20452)
* \[[`eb483dbac5`](https://github.com/nodejs/node/commit/eb483dbac5)] - **fs**: fchmod->fchown in promises/lchown (Сковорода Никита Андреевич) [#20407](https://github.com/nodejs/node/pull/20407)
* \[[`eb724f00a3`](https://github.com/nodejs/node/commit/eb724f00a3)] - **fs**: remove broken code in promises/write (Сковорода Никита Андреевич) [#20407](https://github.com/nodejs/node/pull/20407)
* \[[`0b5dd102e0`](https://github.com/nodejs/node/commit/0b5dd102e0)] - **fs**: move fs/promises to fs.promises (cjihrig) [#20504](https://github.com/nodejs/node/pull/20504)
* \[[`e45e5b809d`](https://github.com/nodejs/node/commit/e45e5b809d)] - **fs**: point isFd to isUint32 (Daniel Bevenius) [#20330](https://github.com/nodejs/node/pull/20330)
* \[[`f0b2b2605a`](https://github.com/nodejs/node/commit/f0b2b2605a)] - **http**: refactor outgoing headers processing (Anatoli Papirovski) [#20250](https://github.com/nodejs/node/pull/20250)
* \[[`1385ffcccf`](https://github.com/nodejs/node/commit/1385ffcccf)] - **(SEMVER-MINOR)** **http**: added aborted property to request (Robert Nagy) [#20094](https://github.com/nodejs/node/pull/20094)
* \[[`6acefc36ee`](https://github.com/nodejs/node/commit/6acefc36ee)] - **http2**: rename http2\_state class to Http2State (Daniel Bevenius) [#20423](https://github.com/nodejs/node/pull/20423)
* \[[`42bbaa338d`](https://github.com/nodejs/node/commit/42bbaa338d)] - **http2**: reduce require calls in http2/core (Daniel Bevenius) [#20422](https://github.com/nodejs/node/pull/20422)
* \[[`e397d19e58`](https://github.com/nodejs/node/commit/e397d19e58)] - **http2**: remove unnecessary v8 qualified names (Daniel Bevenius) [#20420](https://github.com/nodejs/node/pull/20420)
* \[[`b2bbc3619e`](https://github.com/nodejs/node/commit/b2bbc3619e)] - **http2**: remove unused using declarations node\_http2 (Daniel Bevenius) [#20420](https://github.com/nodejs/node/pull/20420)
* \[[`7d9f1f3971`](https://github.com/nodejs/node/commit/7d9f1f3971)] - **http2**: fix ping callback (Ruben Bridgewater) [#20311](https://github.com/nodejs/node/pull/20311)
* \[[`46bd86235d`](https://github.com/nodejs/node/commit/46bd86235d)] - **http2**: fix responses to long payload reqs (Anatoli Papirovski) [#20084](https://github.com/nodejs/node/pull/20084)
* \[[`0b16c2482d`](https://github.com/nodejs/node/commit/0b16c2482d)] - **https**: defines maxHeadersCount in the constructor (Daiki Arai) [#20359](https://github.com/nodejs/node/pull/20359)
* \[[`1490164230`](https://github.com/nodejs/node/commit/1490164230)] - **inspector**: allow concurrent inspector sessions (Eugene Ostroukhov) [#20137](https://github.com/nodejs/node/pull/20137)
* \[[`375994f940`](https://github.com/nodejs/node/commit/375994f940)] - **inspector**: Use default uv\_listen backlog size (Eugene Ostroukhov) [#20254](https://github.com/nodejs/node/pull/20254)
* \[[`7b8e9ca7b8`](https://github.com/nodejs/node/commit/7b8e9ca7b8)] - **lib**: expose FixedQueue internally and fix nextTick bug (Anatoli Papirovski) [#20468](https://github.com/nodejs/node/pull/20468)
* \[[`b6de6a7e35`](https://github.com/nodejs/node/commit/b6de6a7e35)] - **lib**: named anonymous functions (Carrie Coxwell) [#20408](https://github.com/nodejs/node/pull/20408)
* \[[`9eacd66bcb`](https://github.com/nodejs/node/commit/9eacd66bcb)] - **lib**: make sure `console` is writable (Kyle Farnung) [#20185](https://github.com/nodejs/node/pull/20185)
* \[[`17dbf6c77f`](https://github.com/nodejs/node/commit/17dbf6c77f)] - **n-api**: make test\_error functions static (Gabriel Schulhof)
* \[[`ad793ab93c`](https://github.com/nodejs/node/commit/ad793ab93c)] - **n-api**: test and doc napi\_throw() of a primitive (Gabriel Schulhof) [#20428](https://github.com/nodejs/node/pull/20428)
* \[[`1908668826`](https://github.com/nodejs/node/commit/1908668826)] - **n-api**: document the look of napi\_external values (Gabriel Schulhof) [#20426](https://github.com/nodejs/node/pull/20426)
* \[[`7ac491b8ac`](https://github.com/nodejs/node/commit/7ac491b8ac)] - **n-api**: document that native strings are copied (Gabriel Schulhof) [#20425](https://github.com/nodejs/node/pull/20425)
* \[[`705d9ecd13`](https://github.com/nodejs/node/commit/705d9ecd13)] - **n-api**: remove unused Test function (Daniel Bevenius) [#20320](https://github.com/nodejs/node/pull/20320)
* \[[`8d24b6ed34`](https://github.com/nodejs/node/commit/8d24b6ed34)] - **n-api**: update cli documentation (Gabriel Schulhof) [#20301](https://github.com/nodejs/node/pull/20301)
* \[[`cd83df386b`](https://github.com/nodejs/node/commit/cd83df386b)] - **(SEMVER-MINOR)** **n-api**: initialize a module via a special symbol (Gabriel Schulhof) [#20161](https://github.com/nodejs/node/pull/20161)
* \[[`b5c1c146f5`](https://github.com/nodejs/node/commit/b5c1c146f5)] - **n-api,test**: remove superfluous persistent (Gabriel Schulhof) [#20299](https://github.com/nodejs/node/pull/20299)
* \[[`2de3343474`](https://github.com/nodejs/node/commit/2de3343474)] - **n-api,test**: make method static (Gabriel Schulhof) [#20292](https://github.com/nodejs/node/pull/20292)
* \[[`b239591ed8`](https://github.com/nodejs/node/commit/b239591ed8)] - **n-api,test**: make methods static (Gabriel Schulhof) [#20243](https://github.com/nodejs/node/pull/20243)
* \[[`d3a219c6ec`](https://github.com/nodejs/node/commit/d3a219c6ec)] - **repl**: add spaces to load/save messages (cjihrig) [#20536](https://github.com/nodejs/node/pull/20536)
* \[[`d357875ea1`](https://github.com/nodejs/node/commit/d357875ea1)] - **(SEMVER-MINOR)** **src**: add public API to expose the main V8 Platform (Allen Yonghuang Wang) [#20447](https://github.com/nodejs/node/pull/20447)
* \[[`df2cddc9c7`](https://github.com/nodejs/node/commit/df2cddc9c7)] - **src**: removed unnecessary prototypes from Environment::SetProtoMethod (Brandon Ruggles) [#20321](https://github.com/nodejs/node/pull/20321)
* \[[`54f30658a3`](https://github.com/nodejs/node/commit/54f30658a3)] - **src**: fix inconsistency in extern declaration (Yang Guo) [#20436](https://github.com/nodejs/node/pull/20436)
* \[[`f5d42532a3`](https://github.com/nodejs/node/commit/f5d42532a3)] - **src**: refactor `BaseObject` internal field management (Anna Henningsen) [#20455](https://github.com/nodejs/node/pull/20455)
* \[[`c21a52f415`](https://github.com/nodejs/node/commit/c21a52f415)] - **src**: access `ContextifyContext*` more directly in property cbs (Anna Henningsen) [#20455](https://github.com/nodejs/node/pull/20455)
* \[[`c0f153528e`](https://github.com/nodejs/node/commit/c0f153528e)] - **src**: remove `kFlagNoShutdown` flag (Anna Henningsen) [#20388](https://github.com/nodejs/node/pull/20388)
* \[[`58be6efd29`](https://github.com/nodejs/node/commit/58be6efd29)] - **src**: avoid `std::make_unique` (Anna Henningsen) [#20386](https://github.com/nodejs/node/pull/20386)
* \[[`31812edb2d`](https://github.com/nodejs/node/commit/31812edb2d)] - **src**: remove unnecessary copy operations in tracing (Anna Henningsen) [#20356](https://github.com/nodejs/node/pull/20356)
* \[[`e0d2bc5cce`](https://github.com/nodejs/node/commit/e0d2bc5cce)] - **src**: improve fatal exception (Ruben Bridgewater) [#20294](https://github.com/nodejs/node/pull/20294)
* \[[`44fdd36b96`](https://github.com/nodejs/node/commit/44fdd36b96)] - **src**: remove SecureContext `_external` getter (Anna Henningsen) [#20237](https://github.com/nodejs/node/pull/20237)
* \[[`81de533836`](https://github.com/nodejs/node/commit/81de533836)] - **src**: create per-isolate strings after platform setup (Ulan Degenbaev) [#20175](https://github.com/nodejs/node/pull/20175)
* \[[`b5bc6bd94b`](https://github.com/nodejs/node/commit/b5bc6bd94b)] - **src**: fix Systemtap node\_gc\_stop probe (William Cohen) [#20152](https://github.com/nodejs/node/pull/20152)
* \[[`6bf816fde2`](https://github.com/nodejs/node/commit/6bf816fde2)] - **src**: limit foreground tasks draining loop (Ulan Degenbaev) [#19987](https://github.com/nodejs/node/pull/19987)
* \[[`bd2e521096`](https://github.com/nodejs/node/commit/bd2e521096)] - **src**: rename return var in VerifySpkac functions (Daniel Bevenius) [#20218](https://github.com/nodejs/node/pull/20218)
* \[[`a4dae6c226`](https://github.com/nodejs/node/commit/a4dae6c226)] - **src**: prefer false instead of bool zero (Daniel Bevenius) [#20218](https://github.com/nodejs/node/pull/20218)
* \[[`4c4be85655`](https://github.com/nodejs/node/commit/4c4be85655)] - _**Revert**_ "**stream**: prevent 'end' to be emitted after 'error'" (Brian White) [#20449](https://github.com/nodejs/node/pull/20449)
* \[[`05b7b8d506`](https://github.com/nodejs/node/commit/05b7b8d506)] - **stream**: fix error handling with async iteration (Julien Fontanet) [#20329](https://github.com/nodejs/node/pull/20329)
* \[[`fd912a37a0`](https://github.com/nodejs/node/commit/fd912a37a0)] - **stream**: only check options once in Duplex ctor (Daniel Bevenius) [#20353](https://github.com/nodejs/node/pull/20353)
* \[[`e19200a666`](https://github.com/nodejs/node/commit/e19200a666)] - **test**: fix flaky http2-flow-control test (Anatoli Papirovski) [#20556](https://github.com/nodejs/node/pull/20556)
* \[[`b2d3db433d`](https://github.com/nodejs/node/commit/b2d3db433d)] - **test**: use common.canCreateSymLink() consistently (cjihrig) [#20540](https://github.com/nodejs/node/pull/20540)
* \[[`578e0546e0`](https://github.com/nodejs/node/commit/578e0546e0)] - **test**: fix test-cli-node-options.js on mips (Ruben Bridgewater) [#20377](https://github.com/nodejs/node/pull/20377)
* \[[`601f138063`](https://github.com/nodejs/node/commit/601f138063)] - **test**: fix buffer writes on mips (Ruben Bridgewater) [#20377](https://github.com/nodejs/node/pull/20377)
* \[[`1de67c71fb`](https://github.com/nodejs/node/commit/1de67c71fb)] - **test**: fix common.canCreateSymLink() on non-Windows (Masashi Hirano) [#20511](https://github.com/nodejs/node/pull/20511)
* \[[`70b2e169b4`](https://github.com/nodejs/node/commit/70b2e169b4)] - **test**: fix up N-API error test (Gabriel Schulhof) [#20487](https://github.com/nodejs/node/pull/20487)
* \[[`6052ccc009`](https://github.com/nodejs/node/commit/6052ccc009)] - **test**: rename misnamed test (Rich Trott) [#20532](https://github.com/nodejs/node/pull/20532)
* \[[`80bdff0086`](https://github.com/nodejs/node/commit/80bdff0086)] - **test**: add fs/promises filehandle stat test (Masashi Hirano) [#20492](https://github.com/nodejs/node/pull/20492)
* \[[`4dce39a919`](https://github.com/nodejs/node/commit/4dce39a919)] - **test**: use fs.copyFileSync() (Richard Lau) [#20340](https://github.com/nodejs/node/pull/20340)
* \[[`b24ee078f6`](https://github.com/nodejs/node/commit/b24ee078f6)] - **test**: remove unnecessary strictEqual() argument from remoteClose() (Daylor Yanes) [#20343](https://github.com/nodejs/node/pull/20343)
* \[[`2b8b40f800`](https://github.com/nodejs/node/commit/2b8b40f800)] - **test**: fix a TODO and remove obsolete TODOs (Ruben Bridgewater) [#20319](https://github.com/nodejs/node/pull/20319)
* \[[`645a97a44e`](https://github.com/nodejs/node/commit/645a97a44e)] - **test**: verify arguments length in common.expectsError (Ruben Bridgewater) [#20311](https://github.com/nodejs/node/pull/20311)
* \[[`b646566ab4`](https://github.com/nodejs/node/commit/b646566ab4)] - **test**: removed assert.strictEqual message (kailash k yogeshwar) [#20223](https://github.com/nodejs/node/pull/20223)
* \[[`61a56fe437`](https://github.com/nodejs/node/commit/61a56fe437)] - **test**: added coverage for fs/promises API (Mithun Sasidharan) [#20219](https://github.com/nodejs/node/pull/20219)
* \[[`769b6c8fd2`](https://github.com/nodejs/node/commit/769b6c8fd2)] - **test**: fix flaky child-process-exec-kill-throws (Santiago Gimeno) [#20213](https://github.com/nodejs/node/pull/20213)
* \[[`99e0b913c6`](https://github.com/nodejs/node/commit/99e0b913c6)] - **test**: add checkMethods function for Certificate (Daniel Bevenius) [#20224](https://github.com/nodejs/node/pull/20224)
* \[[`d4b19cf43f`](https://github.com/nodejs/node/commit/d4b19cf43f)] - **test,n-api**: re-write test\_error in C (Gabriel Schulhof) [#20244](https://github.com/nodejs/node/pull/20244)
* \[[`e552158dd2`](https://github.com/nodejs/node/commit/e552158dd2)] - **timers**: named anonymous functions (Kyle Martin) [#20397](https://github.com/nodejs/node/pull/20397)
* \[[`1109104206`](https://github.com/nodejs/node/commit/1109104206)] - **tls**: remove sharedCreds in Server constructor (Daniel Bevenius) [#20491](https://github.com/nodejs/node/pull/20491)
* \[[`1ebec18624`](https://github.com/nodejs/node/commit/1ebec18624)] - **tls**: cleanup onhandshakestart callback (Anatoli Papirovski) [#20466](https://github.com/nodejs/node/pull/20466)
* \[[`9b30bc4f81`](https://github.com/nodejs/node/commit/9b30bc4f81)] - **tls**: fix getEphemeralKeyInfo to support X25519 (Shigeki Ohtsu) [#20273](https://github.com/nodejs/node/pull/20273)
* \[[`73cd2798df`](https://github.com/nodejs/node/commit/73cd2798df)] - **tls**: specify options.name in validateKeyCert (Daniel Bevenius) [#20284](https://github.com/nodejs/node/pull/20284)
* \[[`f7267b4af0`](https://github.com/nodejs/node/commit/f7267b4af0)] - **tools**: add eslint check for skipIfEslintMissing (Richard Lau) [#20372](https://github.com/nodejs/node/pull/20372)
* \[[`2a1efa26a7`](https://github.com/nodejs/node/commit/2a1efa26a7)] - **tools**: add v10 to alternative version docs menu (Vse Mozhet Byt) [#20586](https://github.com/nodejs/node/pull/20586)
* \[[`a4d2089c76`](https://github.com/nodejs/node/commit/a4d2089c76)] - **tools**: remove redundant code in doc/html.js (Vse Mozhet Byt) [#20514](https://github.com/nodejs/node/pull/20514)
* \[[`3912551252`](https://github.com/nodejs/node/commit/3912551252)] - **tools**: fix TypeError from `test.py --time` (Richard Lau) [#20368](https://github.com/nodejs/node/pull/20368)
* \[[`b0c0352742`](https://github.com/nodejs/node/commit/b0c0352742)] - **tools**: dedupe property access in doc/type-parser (Vse Mozhet Byt) [#20387](https://github.com/nodejs/node/pull/20387)
* \[[`ccf1b24af2`](https://github.com/nodejs/node/commit/ccf1b24af2)] - **tools**: remove redundant RegExp flag (Vse Mozhet Byt) [#20309](https://github.com/nodejs/node/pull/20309)
* \[[`a12d13ad06`](https://github.com/nodejs/node/commit/a12d13ad06)] - **tools**: simplify HTML generation (Vse Mozhet Byt) [#20307](https://github.com/nodejs/node/pull/20307)
* \[[`8ddbac2fd6`](https://github.com/nodejs/node/commit/8ddbac2fd6)] - **tools**: add log output to crashes (Ruben Bridgewater) [#20295](https://github.com/nodejs/node/pull/20295)
* \[[`ab13f13a6c`](https://github.com/nodejs/node/commit/ab13f13a6c)] - **tools**: show stdout/stderr for timed out tests (Rich Trott) [#20260](https://github.com/nodejs/node/pull/20260)
* \[[`b5584c448a`](https://github.com/nodejs/node/commit/b5584c448a)] - **tools**: modernize and optimize doc/addon-verify.js (Vse Mozhet Byt) [#20188](https://github.com/nodejs/node/pull/20188)
* \[[`ff619d39e6`](https://github.com/nodejs/node/commit/ff619d39e6)] - **url**: fix WHATWG host formatting error (Yichao 'Peak' Ji) [#20493](https://github.com/nodejs/node/pull/20493)
* \[[`1b9c40cc71`](https://github.com/nodejs/node/commit/1b9c40cc71)] - **util**: named anonymous functions (Carrie Coxwell) [#20408](https://github.com/nodejs/node/pull/20408)
* \[[`e854c953fd`](https://github.com/nodejs/node/commit/e854c953fd)] - **util**: improve spliceOne perf (Anatoli Papirovski) [#20453](https://github.com/nodejs/node/pull/20453)
* \[[`3962c734ae`](https://github.com/nodejs/node/commit/3962c734ae)] - **util**: fix isInsideNodeModules inside error (Anatoli Papirovski) [#20266](https://github.com/nodejs/node/pull/20266)

<a id="10.0.0"></a>

## 2018-04-24, Version 10.0.0 (Current), @jasnell

### Notable Changes

* Assert
  * Calling `assert.fail()` with more than one argument is deprecated. \[[`70dcacd710`](https://github.com/nodejs/node/commit/70dcacd710)]
  * Calling `assert.ifError()` will now throw with any argument other than `undefined` or `null`. Previously the method would throw with any truthy value. \[[`e65a6e81ef`](https://github.com/nodejs/node/commit/e65a6e81ef)]
  * The `assert.rejects()` and `assert.doesNotReject()` methods have been added for working with async functions. \[[`599337f43e`](https://github.com/nodejs/node/commit/599337f43e)]
  * Assertion errors will show a diff in case objects are used. \[[`2d9e87695e`](https://github.com/nodejs/node/commit/2d9e87695e)]
  * `assert.throws()` accepts an object for comparison to the error. \[[`2d374916eb`](https://github.com/nodejs/node/commit/2d374916eb)]
  * The error message from `assert.ok(expression)` now also contains the expression itself. \[[`f76ef50432`](https://github.com/nodejs/node/commit/f76ef50432)]
* Async\_hooks
  * Older experimental async\_hooks APIs have been removed. \[[`1cc6b993b9`](https://github.com/nodejs/node/commit/1cc6b993b9)]
* Buffer
  * Uses of `new Buffer()` and `Buffer()` outside of the `node_modules` directory will now emit a runtime deprecation warning. \[[`9d4ab90117`](https://github.com/nodejs/node/commit/9d4ab90117)]
  * `Buffer.isEncoding()` now returns `undefined` for falsy values, including an empty string. \[[`452eed956e`](https://github.com/nodejs/node/commit/452eed956e)]
  * `Buffer.fill()` will throw if an attempt is made to fill with an empty `Buffer`. \[[`1e802539b2`](https://github.com/nodejs/node/commit/1e802539b2)]
  * `noAssert` argument was removed from all `Buffer` read and write functions. \[[`e8bb1f35df`](https://github.com/nodejs/node/commit/e8bb1f35df)]
* Child Process
  * Undefined properties of env are ignored. \[[`38ee25e2e2`](https://github.com/nodejs/node/commit/38ee25e2e2)], \[[`85739b6c5b`](https://github.com/nodejs/node/commit/85739b6c5b)]
* Console
  * The `console.table()` method has been added. \[[`97ace04492`](https://github.com/nodejs/node/commit/97ace04492)]
* Crypto
  * The `crypto.createCipher()` and `crypto.createDecipher()` methods have been deprecated. Please use `crypto.createCipheriv()` and `crypto.createDecipheriv()` instead. \[[`81f88e30dd`](https://github.com/nodejs/node/commit/81f88e30dd)]
  * The `decipher.finaltol()` method has been deprecated. \[[`19f3927d92`](https://github.com/nodejs/node/commit/19f3927d92)]
  * The `crypto.DEFAULT_ENCODING` property has been deprecated. \[[`6035beea93`](https://github.com/nodejs/node/commit/6035beea93)]
  * The `ECDH.convertKey()` method has been added. \[[`f2e02883e7`](https://github.com/nodejs/node/commit/f2e02883e7)]
  * The `crypto.fips` property has been deprecated. \[[`6e7992e8b8`](https://github.com/nodejs/node/commit/6e7992e8b8)]
  * The AES-CCM algorithm has been implemented. \[[`1e07acd476`](https://github.com/nodejs/node/commit/1e07acd476)]
* Dependencies
  * V8 has been updated to 6.6. \[[`9daebb48d6`](https://github.com/nodejs/node/commit/9daebb48d6)]
  * OpenSSL has been updated to 1.1.0h. \[[`66cb29e646`](https://github.com/nodejs/node/commit/66cb29e646)]
* EventEmitter
  * The `EventEmitter.prototype.off()` method has been added as an alias for `EventEmitter.prototype.removeListener()`. \[[`3bb6f07d52`](https://github.com/nodejs/node/commit/3bb6f07d52)]
* File System
  * The `fs/promises` API provides experimental promisified versions of the `fs` functions. \[[`329fc78e49`](https://github.com/nodejs/node/commit/329fc78e49)]
  * Invalid path errors are now thrown synchronously. \[[`d8f73385e2`](https://github.com/nodejs/node/commit/d8f73385e2)]
  * The `fs.readFile()` method now partitions reads to avoid thread pool exhaustion. \[[`67a4ce1c6e`](https://github.com/nodejs/node/commit/67a4ce1c6e)]
* HTTP
  * Processing of HTTP Status codes `100`, `102-199` has been improved. \[[`baf8495078`](https://github.com/nodejs/node/commit/baf8495078)]
  * Multi-byte characters in URL paths are now forbidden. \[[`b961d9fd83`](https://github.com/nodejs/node/commit/b961d9fd83)]
* N-API
  * The n-api is no longer experimental. \[[`cd7d7b15c1`](https://github.com/nodejs/node/commit/cd7d7b15c1)]
* Net
  * The `'close'` event will be emitted after `'end'`. \[[`9b7a6914a7`](https://github.com/nodejs/node/commit/9b7a6914a7)]
* Perf\_hooks
  * The `PerformanceObserver` class is now an `AsyncResource` and can be monitored using `async_hooks`. \[[`009e41826f`](https://github.com/nodejs/node/commit/009e41826f)]
  * Trace events are now emitted for performance events. \[[`9e509b622b`](https://github.com/nodejs/node/commit/9e509b622b)]
  * The `performance` API has been simplified. \[[`2ec6995555`](https://github.com/nodejs/node/commit/2ec6995555)]
  * Performance milestone marks will be emitted as trace events. \[[`96cb4fb795`](https://github.com/nodejs/node/commit/96cb4fb795)]
* Process
  * Using non-string values for `process.env` is deprecated. \[[`5826fe4e79`](https://github.com/nodejs/node/commit/5826fe4e79)]
  * The `process.assert()` method is deprecated. \[[`703e37cf3f`](https://github.com/nodejs/node/commit/703e37cf3f)]
* REPL
  * REPL now experimentally supports top-level await when using the `--experimental-repl-await` flag. \[[`eeab7bc068`](https://github.com/nodejs/node/commit/eeab7bc068)]
  * The previously deprecated "magic mode" has been removed. \[[`4893f70d12`](https://github.com/nodejs/node/commit/4893f70d12)]
  * The previously deprecated `NODE_REPL_HISTORY_FILE` environment variable has been removed. \[[`60c9ad7979`](https://github.com/nodejs/node/commit/60c9ad7979)]
  * Proxy objects are shown as Proxy objects when inspected. \[[`90a43906ab`](https://github.com/nodejs/node/commit/90a43906ab)]
* Streams
  * The `'readable'` event is now always deferred with nextTick. \[[`1e0f3315c7`](https://github.com/nodejs/node/commit/1e0f3315c7)]
  * A new `pipeline()` method has been provided for building end-to-data stream pipelines. \[[`a5cf3feaf1`](https://github.com/nodejs/node/commit/a5cf3feaf1)]
  * Experimental support for async for-await has been added to `stream.Readable`. \[[`61b4d60c5d`](https://github.com/nodejs/node/commit/61b4d60c5d)]
* Timers
  * The `enroll()` and `unenroll()` methods have been deprecated. \[[`68783ae0b8`](https://github.com/nodejs/node/commit/68783ae0b8)]
* TLS
  * The `tls.convertNPNProtocols()` method has been deprecated. \[[`9204a0db6e`](https://github.com/nodejs/node/commit/9204a0db6e)]
  * Support for NPN (next protocol negotiation) has been dropped. \[[`5bfbe5ceae`](https://github.com/nodejs/node/commit/5bfbe5ceae)]
  * The `ecdhCurve` default is now `'auto'`. \[[`af78840b19`](https://github.com/nodejs/node/commit/af78840b19)]
* Trace Events
  * A new `trace_events` top-level module allows trace event categories to be enabled/disabled at runtime. \[[`da5d818a54`](https://github.com/nodejs/node/commit/da5d818a54)]
* URL
  * The WHATWG URL API is now a global. \[[`312414662b`](https://github.com/nodejs/node/commit/312414662b)]
* Util
  * `util.types.is[…]` type checks have been added. \[[`b20af8088a`](https://github.com/nodejs/node/commit/b20af8088a)]
  * Support for bigint formatting has been added to `util.inspect()`. \[[`39dc947409`](https://github.com/nodejs/node/commit/39dc947409)]
  * `util.inspect()` custom inspection with `inspect` property has been deprecated at runtime. \[[`617e3e96e6`](https://github.com/nodejs/node/commit/617e3e96e6)]

#### Deprecations:

The following APIs have been deprecated in Node.js 10.0.0

* Passing more than one argument to `assert.fail()` will emit a runtime deprecation warning. \[[`70dcacd710`](https://github.com/nodejs/node/commit/70dcacd710)]
* Previously deprecated legacy async\_hooks APIs have reached end-of-life and have been removed. \[[`1cc6b993b9`](https://github.com/nodejs/node/commit/1cc6b993b9)]
* Using `require()` to access several of Node.js' own internal dependencies will emit a runtime deprecation. \[[`0e10717e43`](https://github.com/nodejs/node/commit/0e10717e43)]
* The `crypto.createCipher()` and `crypto.createDecipher()` methods have been deprecated in documentation.\[[`81f88e30dd`](https://github.com/nodejs/node/commit/81f88e30dd)]
* Using the `Decipher.finaltol()` method will emit a runtime deprecation warning. \[[`19f3927d92`](https://github.com/nodejs/node/commit/19f3927d92)]
* Using the `crypto.DEFAULT_ENCODING` property will emit a runtime deprecation warning. \[[`6035beea93`](https://github.com/nodejs/node/commit/6035beea93)]
* Use by native addons of the `MakeCallback()` variant that passes a `Domain` will emit a runtime deprecation warning. \[[`14bc3e22f3`](https://github.com/nodejs/node/commit/14bc3e22f3)], \[[`efb32592e1`](https://github.com/nodejs/node/commit/efb32592e1)]
* Previously deprecated internal getters/setters on `net.Server` has reached end-of-life and have been removed. \[[`3701b02309`](https://github.com/nodejs/node/commit/3701b02309)]
* Use of non-string values for `process.env` has been deprecated in documentation. \[[`5826fe4e79`](https://github.com/nodejs/node/commit/5826fe4e79)]
* Use of `process.assert()` will emit a runtime deprecation warning. \[[`703e37cf3f`](https://github.com/nodejs/node/commit/703e37cf3f)]
* Previously deprecated `NODE_REPL_HISTORY_FILE` environment variable has reached end-of-life and has been removed. \[[`60c9ad7979`](https://github.com/nodejs/node/commit/60c9ad7979)]
* Use of the `timers.enroll()` and `timers.unenroll()` methods will emit a runtime deprecation warning. \[[`68783ae0b8`](https://github.com/nodejs/node/commit/68783ae0b8)]
* Use of the `tls.convertNPNProtocols()` method will emit a runtime deprecation warning. Support for NPN has been removed from Node.js. \[[`9204a0db6e`](https://github.com/nodejs/node/commit/9204a0db6e)]
* The `crypto.fips` property has been deprecated in documentation. \[[`6e7992e8b8`](https://github.com/nodejs/node/commit/6e7992e8b8)]

### Commits

#### Semver-major

* \[[`c9bb91af33`](https://github.com/nodejs/node/commit/c9bb91af33)] - **(SEMVER-MAJOR)** **assert**: remove `errorDiff` property (Ruben Bridgewater) [#19467](https://github.com/nodejs/node/pull/19467)
* \[[`eb427caadd`](https://github.com/nodejs/node/commit/eb427caadd)] - **(SEMVER-MAJOR)** **assert**: improve default error messages (Ruben Bridgewater) [#19467](https://github.com/nodejs/node/pull/19467)
* \[[`1964978fb8`](https://github.com/nodejs/node/commit/1964978fb8)] - **(SEMVER-MAJOR)** **assert**: detect faulty throws usage (Ruben Bridgewater) [#19867](https://github.com/nodejs/node/pull/19867)
* \[[`9743e756e2`](https://github.com/nodejs/node/commit/9743e756e2)] - **(SEMVER-MAJOR)** **assert**: provide info about actual error (Ruben Bridgewater) [#19884](https://github.com/nodejs/node/pull/19884)
* \[[`70dcacd710`](https://github.com/nodejs/node/commit/70dcacd710)] - **(SEMVER-MAJOR)** **assert**: deprecate assert.fail partially (Ruben Bridgewater) [#18418](https://github.com/nodejs/node/pull/18418)
* \[[`3cd7977a42`](https://github.com/nodejs/node/commit/3cd7977a42)] - **(SEMVER-MAJOR)** **assert**: use a default message in assert (Ruben Bridgewater) [#18319](https://github.com/nodejs/node/pull/18319)
* \[[`e65a6e81ef`](https://github.com/nodejs/node/commit/e65a6e81ef)] - **(SEMVER-MAJOR)** **assert**: stricter ifError (Ruben Bridgewater) [#18247](https://github.com/nodejs/node/pull/18247)
* \[[`72bb4445c6`](https://github.com/nodejs/node/commit/72bb4445c6)] - **(SEMVER-MAJOR)** **assert**: wrap original error in ifError (Ruben Bridgewater) [#18247](https://github.com/nodejs/node/pull/18247)
* \[[`d07c6f9739`](https://github.com/nodejs/node/commit/d07c6f9739)] - **(SEMVER-MAJOR)** **assert**: throw without args in ok (Ruben Bridgewater) [#17581](https://github.com/nodejs/node/pull/17581)
* \[[`f76ef50432`](https://github.com/nodejs/node/commit/f76ef50432)] - **(SEMVER-MAJOR)** **assert**: improve simple assert (Ruben Bridgewater) [#17581](https://github.com/nodejs/node/pull/17581)
* \[[`493340f56e`](https://github.com/nodejs/node/commit/493340f56e)] - **(SEMVER-MAJOR)** **assert**: use Object.is comparison in .strictEqual (Ruben Bridgewater) [#17003](https://github.com/nodejs/node/pull/17003)
* \[[`1cc6b993b9`](https://github.com/nodejs/node/commit/1cc6b993b9)] - **(SEMVER-MAJOR)** **async\_hooks**: remove deprecated API (Andreas Madsen) [#17147](https://github.com/nodejs/node/pull/17147)
* \[[`81aaab75ca`](https://github.com/nodejs/node/commit/81aaab75ca)] - **(SEMVER-MAJOR)** **benchmark**: remove noAssert argument (Ruben Bridgewater) [#18395](https://github.com/nodejs/node/pull/18395)
* \[[`876836b135`](https://github.com/nodejs/node/commit/876836b135)] - **(SEMVER-MAJOR)** **benchmark**: rename file (Ruben Bridgewater) [#18790](https://github.com/nodejs/node/pull/18790)
* \[[`e9ec9ff269`](https://github.com/nodejs/node/commit/e9ec9ff269)] - **(SEMVER-MAJOR)** **benchmark**: add buffer fill benchmark (Ruben Bridgewater) [#18790](https://github.com/nodejs/node/pull/18790)
* \[[`94d64877ff`](https://github.com/nodejs/node/commit/94d64877ff)] - **(SEMVER-MAJOR)** **benchmark**: improve buffer.readInt(B|L)E benchmarks (Rich Trott) [#11146](https://github.com/nodejs/node/pull/11146)
* \[[`9d4ab90117`](https://github.com/nodejs/node/commit/9d4ab90117)] - **(SEMVER-MAJOR)** **buffer**: do deprecation warning outside `node_modules` (Anna Henningsen) [#19524](https://github.com/nodejs/node/pull/19524)
* \[[`e8bb1f35df`](https://github.com/nodejs/node/commit/e8bb1f35df)] - **(SEMVER-MAJOR)** **buffer**: refactor all read/write functions (Ruben Bridgewater) [#18395](https://github.com/nodejs/node/pull/18395)
* \[[`a6c490cc8e`](https://github.com/nodejs/node/commit/a6c490cc8e)] - **(SEMVER-MAJOR)** **buffer**: remove double ln (Ruben Bridgewater) [#18395](https://github.com/nodejs/node/pull/18395)
* \[[`1411b30f46`](https://github.com/nodejs/node/commit/1411b30f46)] - **(SEMVER-MAJOR)** **buffer**: move c++ float functions to js (Ruben Bridgewater) [#18395](https://github.com/nodejs/node/pull/18395)
* \[[`452eed956e`](https://github.com/nodejs/node/commit/452eed956e)] - **(SEMVER-MAJOR)** **buffer**: stricter isEncoding (Ruben Bridgewater) [#18790](https://github.com/nodejs/node/pull/18790)
* \[[`177b7314cf`](https://github.com/nodejs/node/commit/177b7314cf)] - **(SEMVER-MAJOR)** **buffer**: improve Buffer#fill performance (Ruben Bridgewater) [#18790](https://github.com/nodejs/node/pull/18790)
* \[[`1e802539b2`](https://github.com/nodejs/node/commit/1e802539b2)] - **(SEMVER-MAJOR)** **buffer**: throw when filling with empty buffers (cjihrig) [#18129](https://github.com/nodejs/node/pull/18129)
* \[[`9fea7eae9a`](https://github.com/nodejs/node/commit/9fea7eae9a)] - **(SEMVER-MAJOR)** **buffer**: check byteLength in readUInt(B|L)E (Rich Trott) [#11146](https://github.com/nodejs/node/pull/11146)
* \[[`d964ffeec3`](https://github.com/nodejs/node/commit/d964ffeec3)] - **(SEMVER-MAJOR)** **buffer**: check byteLength in readInt(B|L)E (Sebastian Van Sande) [#11146](https://github.com/nodejs/node/pull/11146)
* \[[`cd174df353`](https://github.com/nodejs/node/commit/cd174df353)] - **(SEMVER-MAJOR)** **buffer**: throw on failed fill attempts (cjihrig) [#17427](https://github.com/nodejs/node/pull/17427)
* \[[`010587b7c4`](https://github.com/nodejs/node/commit/010587b7c4)] - **(SEMVER-MAJOR)** **build**: remove implied support for win 2012 not R2 (Beth Griggs) [#19378](https://github.com/nodejs/node/pull/19378)
* \[[`36a02d401c`](https://github.com/nodejs/node/commit/36a02d401c)] - **(SEMVER-MAJOR)** **build**: add option to build v8 with GN (Yang Guo) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`608557a1fc`](https://github.com/nodejs/node/commit/608557a1fc)] - **(SEMVER-MAJOR)** **build**: update node.gyp to reference gypfiles/v8.gyp (Joyee Cheung) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`3542411fda`](https://github.com/nodejs/node/commit/3542411fda)] - **(SEMVER-MAJOR)** **build**: reset embedder string to "-node.0" (Myles Borins) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`08af7dba2a`](https://github.com/nodejs/node/commit/08af7dba2a)] - **(SEMVER-MAJOR)** **build**: add OpenSSL-1.1.0 support (Shigeki Ohtsu) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`549b280b87`](https://github.com/nodejs/node/commit/549b280b87)] - **(SEMVER-MAJOR)** **build**: reset embedder string to "-node.0" (Michaël Zasso) [#18453](https://github.com/nodejs/node/pull/18453)
* \[[`56ee94f184`](https://github.com/nodejs/node/commit/56ee94f184)] - **(SEMVER-MAJOR)** **build**: compile V8 using system compiler (Ben Noordhuis) [#17489](https://github.com/nodejs/node/pull/17489)
* \[[`e9bcb39ef2`](https://github.com/nodejs/node/commit/e9bcb39ef2)] - **(SEMVER-MAJOR)** **build**: remove --no-i18n from V8 test options (Michaël Zasso) [#17489](https://github.com/nodejs/node/pull/17489)
* \[[`4a16a5d988`](https://github.com/nodejs/node/commit/4a16a5d988)] - **(SEMVER-MAJOR)** **build**: compile with -std=gnu++1y (Michaël Zasso) [#17489](https://github.com/nodejs/node/pull/17489)
* \[[`fe6bcce9af`](https://github.com/nodejs/node/commit/fe6bcce9af)] - **(SEMVER-MAJOR)** **build**: reset embedder string to "-node.0" (Michaël Zasso) [#17489](https://github.com/nodejs/node/pull/17489)
* \[[`2c75b52af8`](https://github.com/nodejs/node/commit/2c75b52af8)] - **(SEMVER-MAJOR)** **build**: replace runtime flag with compiler option (Peter Marshall) [#16271](https://github.com/nodejs/node/pull/16271)
* \[[`6e7028ea76`](https://github.com/nodejs/node/commit/6e7028ea76)] - **(SEMVER-MAJOR)** **build**: reset embedder string to "-node.0" (Michaël Zasso) [#16271](https://github.com/nodejs/node/pull/16271)
* \[[`0e10717e43`](https://github.com/nodejs/node/commit/0e10717e43)] - **(SEMVER-MAJOR)** **build**: runtime-deprecate requiring deps (Timothy Gu) [#16392](https://github.com/nodejs/node/pull/16392)
* \[[`eec659c138`](https://github.com/nodejs/node/commit/eec659c138)] - **(SEMVER-MAJOR)** **build, tools, win**: add nasm detection for OpenSSL (João Reis) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`9bfe55e184`](https://github.com/nodejs/node/commit/9bfe55e184)] - **(SEMVER-MAJOR)** **child\_process**: better spawn error message (Bartosz Sosnowski) [#19305](https://github.com/nodejs/node/pull/19305)
* \[[`11b6c0de41`](https://github.com/nodejs/node/commit/11b6c0de41)] - **(SEMVER-MAJOR)** **child\_process**: define EACCES as a runtime error (Gireesh Punathil) [#19294](https://github.com/nodejs/node/pull/19294)
* \[[`38ee25e2e2`](https://github.com/nodejs/node/commit/38ee25e2e2)] - **(SEMVER-MAJOR)** **child\_process**: do not ignore proto values of env (Anatoli Papirovski) [#18210](https://github.com/nodejs/node/pull/18210)
* \[[`85739b6c5b`](https://github.com/nodejs/node/commit/85739b6c5b)] - **(SEMVER-MAJOR)** **child\_process**: ignore undef/proto values of env (现充) [#15089](https://github.com/nodejs/node/pull/15089)
* \[[`15d880bcb6`](https://github.com/nodejs/node/commit/15d880bcb6)] - **(SEMVER-MAJOR)** **console**: make .assert standard compliant (Ruben Bridgewater) [#17706](https://github.com/nodejs/node/pull/17706)
* \[[`970ce14f61`](https://github.com/nodejs/node/commit/970ce14f61)] - **(SEMVER-MAJOR)** **crypto**: remove deperecated methods of TLS version (Shigeki Ohtsu) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`1e07acd476`](https://github.com/nodejs/node/commit/1e07acd476)] - **(SEMVER-MAJOR)** **crypto**: add support for AES-CCM (Tobias Nießen) [#18138](https://github.com/nodejs/node/pull/18138)
* \[[`333adf61eb`](https://github.com/nodejs/node/commit/333adf61eb)] - **(SEMVER-MAJOR)** **crypto**: fix error handling (Ruben Bridgewater) [#19445](https://github.com/nodejs/node/pull/19445)
* \[[`81f88e30dd`](https://github.com/nodejs/node/commit/81f88e30dd)] - **(SEMVER-MAJOR)** **crypto**: doc-only deprecate createCipher/Decipher (Tobias Nießen) [#19343](https://github.com/nodejs/node/pull/19343)
* \[[`19f3927d92`](https://github.com/nodejs/node/commit/19f3927d92)] - **(SEMVER-MAJOR)** **crypto**: deprecate Decipher.finaltol (Tobias Nießen) [#19353](https://github.com/nodejs/node/pull/19353)
* \[[`6035beea93`](https://github.com/nodejs/node/commit/6035beea93)] - **(SEMVER-MAJOR)** **crypto**: runtime deprecate DEFAULT\_ENCODING (James M Snell) [#18333](https://github.com/nodejs/node/pull/18333)
* \[[`858b48b692`](https://github.com/nodejs/node/commit/858b48b692)] - **(SEMVER-MAJOR)** **crypto**: assign deprecation code for setAuthTag/GCM (Tobias Nießen) [#18017](https://github.com/nodejs/node/pull/18017)
* \[[`845633a7c6`](https://github.com/nodejs/node/commit/845633a7c6)] - **(SEMVER-MAJOR)** **crypto**: better docs for cases where peer's public key is invalid (Jose M. Palacios Diaz) [#16849](https://github.com/nodejs/node/pull/16849)
* \[[`e567402aba`](https://github.com/nodejs/node/commit/e567402aba)] - **(SEMVER-MAJOR)** **crypto**: migrate CipherBase to internal/errors (James M Snell) [#16527](https://github.com/nodejs/node/pull/16527)
* \[[`2a3f8c3a83`](https://github.com/nodejs/node/commit/2a3f8c3a83)] - **(SEMVER-MAJOR)** **deps**: patch the V8 API to be forward compatible with 6.7 (Peter Marshall) [#19999](https://github.com/nodejs/node/pull/19999)
* \[[`ea9de2c81a`](https://github.com/nodejs/node/commit/ea9de2c81a)] - **(SEMVER-MAJOR)** **deps**: split v8\_monolith target into separate file (Yang Guo) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`e8fc6b6901`](https://github.com/nodejs/node/commit/e8fc6b6901)] - **(SEMVER-MAJOR)** **deps**: update v8.gyp (Michaël Zasso) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`9daebb48d6`](https://github.com/nodejs/node/commit/9daebb48d6)] - **(SEMVER-MAJOR)** **deps**: update V8 to 6.6.346.23 (Myles Borins) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`7812ec735b`](https://github.com/nodejs/node/commit/7812ec735b)] - **(SEMVER-MAJOR)** **deps**: update archs files for OpenSSL-1.1.0 (Shigeki Ohtsu) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`99eb744842`](https://github.com/nodejs/node/commit/99eb744842)] - **(SEMVER-MAJOR)** **deps**: add gyp, header and Makefile for openssl110 (Shigeki Ohtsu) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`1bcb6c0d26`](https://github.com/nodejs/node/commit/1bcb6c0d26)] - **(SEMVER-MAJOR)** **deps**: add s390 asm rules for OpenSSL-1.1.0 (Shigeki Ohtsu) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`6bab3c23b1`](https://github.com/nodejs/node/commit/6bab3c23b1)] - **(SEMVER-MAJOR)** **deps**: delete files of OpenSSL-1.0.2 (Shigeki Ohtsu) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`66cb29e646`](https://github.com/nodejs/node/commit/66cb29e646)] - **(SEMVER-MAJOR)** **deps**: upgrade openssl sources to 1.1.0h (Shigeki Ohtsu) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`9759573997`](https://github.com/nodejs/node/commit/9759573997)] - **(SEMVER-MAJOR)** **deps**: cherry-pick 46c4979 from upstream V8 (Michaël Zasso) [#18453](https://github.com/nodejs/node/pull/18453)
* \[[`b4c1222acc`](https://github.com/nodejs/node/commit/b4c1222acc)] - **(SEMVER-MAJOR)** **deps**: skip some V8 tests for ppc and s390 (Michaël Zasso) [#18453](https://github.com/nodejs/node/pull/18453)
* \[[`9396a9f02c`](https://github.com/nodejs/node/commit/9396a9f02c)] - **(SEMVER-MAJOR)** **deps**: cherry-pick 8bfbe25 from upstream V8 (Michaël Zasso) [#18453](https://github.com/nodejs/node/pull/18453)
* \[[`d68ee7eab7`](https://github.com/nodejs/node/commit/d68ee7eab7)] - **(SEMVER-MAJOR)** **deps**: cherry-pick 04a06c9 from upstream V8 (Michaël Zasso) [#18453](https://github.com/nodejs/node/pull/18453)
* \[[`88786fecff`](https://github.com/nodejs/node/commit/88786fecff)] - **(SEMVER-MAJOR)** **deps**: update V8 to 6.5.254.31 (Michaël Zasso) [#18453](https://github.com/nodejs/node/pull/18453)
* \[[`142d6237b6`](https://github.com/nodejs/node/commit/142d6237b6)] - **(SEMVER-MAJOR)** **deps**: V8: reintroduce missing whitespace in test (Ali Ijaz Sheikh) [#18360](https://github.com/nodejs/node/pull/18360)
* \[[`b06440356d`](https://github.com/nodejs/node/commit/b06440356d)] - **(SEMVER-MAJOR)** **deps**: cherry-pick c3bb73f from upstream V8 (Ali Ijaz Sheikh) [#18196](https://github.com/nodejs/node/pull/18196)
* \[[`a1c5dddbb2`](https://github.com/nodejs/node/commit/a1c5dddbb2)] - **(SEMVER-MAJOR)** **deps**: cherry-pick 814577e from upstream V8 (Ali Ijaz Sheikh) [#18196](https://github.com/nodejs/node/pull/18196)
* \[[`4c4af643e5`](https://github.com/nodejs/node/commit/4c4af643e5)] - **(SEMVER-MAJOR)** **deps**: update V8 to 6.4.388.40 (Michaël Zasso) [#17489](https://github.com/nodejs/node/pull/17489)
* \[[`51054dac54`](https://github.com/nodejs/node/commit/51054dac54)] - **(SEMVER-MAJOR)** **deps**: cherry-pick c3bb73f from upstream V8 (Ali Ijaz Sheikh) [#18196](https://github.com/nodejs/node/pull/18196)
* \[[`7d7a549219`](https://github.com/nodejs/node/commit/7d7a549219)] - **(SEMVER-MAJOR)** **deps**: cherry-pick 814577e from upstream V8 (Ali Ijaz Sheikh) [#18196](https://github.com/nodejs/node/pull/18196)
* \[[`1854ba04e9`](https://github.com/nodejs/node/commit/1854ba04e9)] - **(SEMVER-MAJOR)** **deps**: update V8 to 6.3.292.46 (Michaël Zasso) [#16271](https://github.com/nodejs/node/pull/16271)
* \[[`9ad994befb`](https://github.com/nodejs/node/commit/9ad994befb)] - **(SEMVER-MAJOR)** **dgram**: migrate bufferSize to use internal/errors (James M Snell) [#16567](https://github.com/nodejs/node/pull/16567)
* \[[`8a5b7b2afe`](https://github.com/nodejs/node/commit/8a5b7b2afe)] - **(SEMVER-MAJOR)** **doc**: update required compiler level for AIX (Michael Dawson) [#20153](https://github.com/nodejs/node/pull/20153)
* \[[`ae096ba27c`](https://github.com/nodejs/node/commit/ae096ba27c)] - **(SEMVER-MAJOR)** **doc**: fix API descriptions for OpenSSL-1.1.0 (Shigeki Ohtsu) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`c111e133ae`](https://github.com/nodejs/node/commit/c111e133ae)] - **(SEMVER-MAJOR)** **doc**: add deprecation notice (Ruben Bridgewater) [#18395](https://github.com/nodejs/node/pull/18395)
* \[[`740c426b21`](https://github.com/nodejs/node/commit/740c426b21)] - **(SEMVER-MAJOR)** **doc**: add a deprecation message for removing lttng (Glen Keane) [#18982](https://github.com/nodejs/node/pull/18982)
* \[[`300f5ce346`](https://github.com/nodejs/node/commit/300f5ce346)] - **(SEMVER-MAJOR)** **doc**: deprecate top-level `this` (Hackzzila) [#16878](https://github.com/nodejs/node/pull/16878)
* \[[`dbdcf12187`](https://github.com/nodejs/node/commit/dbdcf12187)] - **(SEMVER-MAJOR)** **doc**: correct buffer changelog ordering (cjihrig) [#18129](https://github.com/nodejs/node/pull/18129)
* \[[`4319780389`](https://github.com/nodejs/node/commit/4319780389)] - **(SEMVER-MAJOR)** **doc**: remove double line break (Ruben Bridgewater) [#17581](https://github.com/nodejs/node/pull/17581)
* \[[`ccc87ebb33`](https://github.com/nodejs/node/commit/ccc87ebb33)] - **(SEMVER-MAJOR)** **doc**: improve documentation for util.deprecate() (Rich Trott) [#16393](https://github.com/nodejs/node/pull/16393)
* \[[`14bc3e22f3`](https://github.com/nodejs/node/commit/14bc3e22f3)] - **(SEMVER-MAJOR)** **domain**: runtime deprecate MakeCallback (Andreas Madsen) [#17417](https://github.com/nodejs/node/pull/17417)
* \[[`5135e24133`](https://github.com/nodejs/node/commit/5135e24133)] - **(SEMVER-MAJOR)** **errors**: alter ERR\_INVALID\_CURSOR\_POS (davidmarkclements) [#19960](https://github.com/nodejs/node/pull/19960)
* \[[`eca95a9ea5`](https://github.com/nodejs/node/commit/eca95a9ea5)] - **(SEMVER-MAJOR)** **errors**: alter ERR\_INVALID\_PROTOCOL (davidmarkclements) [#19983](https://github.com/nodejs/node/pull/19983)
* \[[`afb4d55ac4`](https://github.com/nodejs/node/commit/afb4d55ac4)] - **(SEMVER-MAJOR)** **errors**: alter ERR\_INVALID\_DOMAIN\_NAME (davidmarkclements) [#19961](https://github.com/nodejs/node/pull/19961)
* \[[`83a8261764`](https://github.com/nodejs/node/commit/83a8261764)] - **(SEMVER-MAJOR)** **errors**: alter and test ERR\_INVALID\_REPL\_EVAL\_CONFIG (davidmarkclements) [#19984](https://github.com/nodejs/node/pull/19984)
* \[[`b40efa43bd`](https://github.com/nodejs/node/commit/b40efa43bd)] - **(SEMVER-MAJOR)** **errors**: alter ERR\_INVALID\_IP\_ADDRESS (davidmarkclements) [#19979](https://github.com/nodejs/node/pull/19979)
* \[[`d28211ec3d`](https://github.com/nodejs/node/commit/d28211ec3d)] - **(SEMVER-MAJOR)** **errors**: validate input arguments (Ruben Bridgewater) [#19924](https://github.com/nodejs/node/pull/19924)
* \[[`b29c36b807`](https://github.com/nodejs/node/commit/b29c36b807)] - **(SEMVER-MAJOR)** **errors**: make dns errors consistent (Ruben Bridgewater) [#19754](https://github.com/nodejs/node/pull/19754)
* \[[`7d06761f83`](https://github.com/nodejs/node/commit/7d06761f83)] - **(SEMVER-MAJOR)** **errors**: improve SystemError messages (Joyee Cheung) [#19514](https://github.com/nodejs/node/pull/19514)
* \[[`28e4e43e51`](https://github.com/nodejs/node/commit/28e4e43e51)] - **(SEMVER-MAJOR)** **errors**: make input mandatory (Ruben Bridgewater) [#19445](https://github.com/nodejs/node/pull/19445)
* \[[`6ef17303a7`](https://github.com/nodejs/node/commit/6ef17303a7)] - **(SEMVER-MAJOR)** **errors**: only init colors when util is not loaded (Joyee Cheung) [#18359](https://github.com/nodejs/node/pull/18359)
* \[[`b1e6c0d44c`](https://github.com/nodejs/node/commit/b1e6c0d44c)] - **(SEMVER-MAJOR)** **errors, child\_process**: use internal/errors codes (Jon Moss) [#14998](https://github.com/nodejs/node/pull/14998)
* \[[`3bb6f07d52`](https://github.com/nodejs/node/commit/3bb6f07d52)] - **(SEMVER-MAJOR)** **events**: add off alias to removeListener (Ulmanb) [#17156](https://github.com/nodejs/node/pull/17156)
* \[[`acc3c770e7`](https://github.com/nodejs/node/commit/acc3c770e7)] - **(SEMVER-MAJOR)** **fs**: fix error handling (Ruben Bridgewater) [#19445](https://github.com/nodejs/node/pull/19445)
* \[[`897f7b6c6b`](https://github.com/nodejs/node/commit/897f7b6c6b)] - **(SEMVER-MAJOR)** **fs**: improve errors in watchFile and unwatchFile (Joyee Cheung) [#19345](https://github.com/nodejs/node/pull/19345)
* \[[`301f6cc553`](https://github.com/nodejs/node/commit/301f6cc553)] - **(SEMVER-MAJOR)** **fs**: remove watcher state errors for fs.watch (Joyee Cheung) [#19345](https://github.com/nodejs/node/pull/19345)
* \[[`6c25f2ea49`](https://github.com/nodejs/node/commit/6c25f2ea49)] - **(SEMVER-MAJOR)** **fs**: improve errors thrown from fs.watch() (Joyee Cheung) [#19089](https://github.com/nodejs/node/pull/19089)
* \[[`f7e5b385a7`](https://github.com/nodejs/node/commit/f7e5b385a7)] - **(SEMVER-MAJOR)** **fs**: remove unused SYNC\_\* helpers (Joyee Cheung) [#19041](https://github.com/nodejs/node/pull/19041)
* \[[`80bd2da6e1`](https://github.com/nodejs/node/commit/80bd2da6e1)] - **(SEMVER-MAJOR)** **fs**: use SyncCall in WriteBuffers (Joyee Cheung) [#19041](https://github.com/nodejs/node/pull/19041)
* \[[`49dd80935c`](https://github.com/nodejs/node/commit/49dd80935c)] - **(SEMVER-MAJOR)** **fs**: throw futimesSync errors in JS (Joyee Cheung) [#19041](https://github.com/nodejs/node/pull/19041)
* \[[`994320b07b`](https://github.com/nodejs/node/commit/994320b07b)] - **(SEMVER-MAJOR)** **fs**: throw writeSync errors in JS (Joyee Cheung) [#19041](https://github.com/nodejs/node/pull/19041)
* \[[`1650eaeac4`](https://github.com/nodejs/node/commit/1650eaeac4)] - **(SEMVER-MAJOR)** **fs**: throw fchownSync errors in JS (Joyee Cheung) [#19041](https://github.com/nodejs/node/pull/19041)
* \[[`79b195437c`](https://github.com/nodejs/node/commit/79b195437c)] - **(SEMVER-MAJOR)** **fs**: throw fchmodSync errors in JS (Joyee Cheung) [#19041](https://github.com/nodejs/node/pull/19041)
* \[[`c6acfdb3ac`](https://github.com/nodejs/node/commit/c6acfdb3ac)] - **(SEMVER-MAJOR)** **fs**: throw readSync errors in JS (Joyee Cheung) [#19041](https://github.com/nodejs/node/pull/19041)
* \[[`4eb45b884d`](https://github.com/nodejs/node/commit/4eb45b884d)] - **(SEMVER-MAJOR)** **fs**: throw copyFileSync errors in JS (Joyee Cheung) [#18871](https://github.com/nodejs/node/pull/18871)
* \[[`d2dc2a5011`](https://github.com/nodejs/node/commit/d2dc2a5011)] - **(SEMVER-MAJOR)** **fs**: throw fs.mkdtempSync errors in JS land (Joyee Cheung) [#18871](https://github.com/nodejs/node/pull/18871)
* \[[`82523d3b6e`](https://github.com/nodejs/node/commit/82523d3b6e)] - **(SEMVER-MAJOR)** **fs**: throw fs.utimesSync errors in JS land (Joyee Cheung) [#18871](https://github.com/nodejs/node/pull/18871)
* \[[`8fb5a6cd81`](https://github.com/nodejs/node/commit/8fb5a6cd81)] - **(SEMVER-MAJOR)** **fs**: throw fs.chownSync errors in JS land (Joyee Cheung) [#18871](https://github.com/nodejs/node/pull/18871)
* \[[`437c756493`](https://github.com/nodejs/node/commit/437c756493)] - **(SEMVER-MAJOR)** **fs**: throw fs.chmodSync errors in JS land (Joyee Cheung) [#18871](https://github.com/nodejs/node/pull/18871)
* \[[`e8ec898a7d`](https://github.com/nodejs/node/commit/e8ec898a7d)] - **(SEMVER-MAJOR)** **fs**: use SyncCall in OpenFileHandle (Joyee Cheung) [#18871](https://github.com/nodejs/node/pull/18871)
* \[[`fea5dda1d1`](https://github.com/nodejs/node/commit/fea5dda1d1)] - **(SEMVER-MAJOR)** **fs**: throw openSync errors in JS (Joyee Cheung) [#18871](https://github.com/nodejs/node/pull/18871)
* \[[`d2c4f5082f`](https://github.com/nodejs/node/commit/d2c4f5082f)] - **(SEMVER-MAJOR)** **fs**: throw readdirSync errors in JS (Joyee Cheung) [#18871](https://github.com/nodejs/node/pull/18871)
* \[[`72d150ea6f`](https://github.com/nodejs/node/commit/72d150ea6f)] - **(SEMVER-MAJOR)** **fs**: throw realpathSync.native errors in JS (Joyee Cheung) [#18871](https://github.com/nodejs/node/pull/18871)
* \[[`77b42e34de`](https://github.com/nodejs/node/commit/77b42e34de)] - **(SEMVER-MAJOR)** **fs**: throw mkdirSync errors in JS (Joyee Cheung) [#18871](https://github.com/nodejs/node/pull/18871)
* \[[`46164ba212`](https://github.com/nodejs/node/commit/46164ba212)] - **(SEMVER-MAJOR)** **fs**: throw rmdirSync errors in JS (Joyee Cheung) [#18871](https://github.com/nodejs/node/pull/18871)
* \[[`c3eb3efa31`](https://github.com/nodejs/node/commit/c3eb3efa31)] - **(SEMVER-MAJOR)** **fs**: fix functions executed in wrong context (Ruben Bridgewater) [#18668](https://github.com/nodejs/node/pull/18668)
* \[[`e9f2cecf1a`](https://github.com/nodejs/node/commit/e9f2cecf1a)] - **(SEMVER-MAJOR)** _**Revert**_ "**fs**: Revert throw on invalid callbacks" (Ruben Bridgewater) [#18668](https://github.com/nodejs/node/pull/18668)
* \[[`d8f73385e2`](https://github.com/nodejs/node/commit/d8f73385e2)] - **(SEMVER-MAJOR)** **fs**: throw errors on invalid paths synchronously (Joyee Cheung) [#18308](https://github.com/nodejs/node/pull/18308)
* \[[`67a4ce1c6e`](https://github.com/nodejs/node/commit/67a4ce1c6e)] - **(SEMVER-MAJOR)** **fs**: partition readFile against pool exhaustion (Jamie Davis) [#17054](https://github.com/nodejs/node/pull/17054)
* \[[`776f6cdfc4`](https://github.com/nodejs/node/commit/776f6cdfc4)] - **(SEMVER-MAJOR)** **fs**: throw errors from fs.unlinkSync in JS (Joyee Cheung) [#18348](https://github.com/nodejs/node/pull/18348)
* \[[`eca93e631f`](https://github.com/nodejs/node/commit/eca93e631f)] - **(SEMVER-MAJOR)** **fs**: throw errors from fs.fsyncSync in JS (Joyee Cheung) [#18348](https://github.com/nodejs/node/pull/18348)
* \[[`f5e287ba20`](https://github.com/nodejs/node/commit/f5e287ba20)] - **(SEMVER-MAJOR)** **fs**: throw errors from fs.fdatasyncSync in JS (Joyee Cheung) [#18348](https://github.com/nodejs/node/pull/18348)
* \[[`b3a7df7c6d`](https://github.com/nodejs/node/commit/b3a7df7c6d)] - **(SEMVER-MAJOR)** **fs**: throw errors from fs.ftruncateSync in JS (Joyee Cheung) [#18348](https://github.com/nodejs/node/pull/18348)
* \[[`5583981c52`](https://github.com/nodejs/node/commit/5583981c52)] - **(SEMVER-MAJOR)** **fs**: throw errors from fs.renameSync in JS (Joyee Cheung) [#18348](https://github.com/nodejs/node/pull/18348)
* \[[`09da11e5e1`](https://github.com/nodejs/node/commit/09da11e5e1)] - **(SEMVER-MAJOR)** **fs**: throw errors from fs.readlinkSync in JS (Joyee Cheung) [#18348](https://github.com/nodejs/node/pull/18348)
* \[[`167e22937c`](https://github.com/nodejs/node/commit/167e22937c)] - **(SEMVER-MAJOR)** **fs**: throw errors from fs.linkSync in JS (Joyee Cheung) [#18348](https://github.com/nodejs/node/pull/18348)
* \[[`32bf0f6c5b`](https://github.com/nodejs/node/commit/32bf0f6c5b)] - **(SEMVER-MAJOR)** **fs**: throw errors from fs.symlinkSync in JS (Joyee Cheung) [#18348](https://github.com/nodejs/node/pull/18348)
* \[[`8c00a809bc`](https://github.com/nodejs/node/commit/8c00a809bc)] - **(SEMVER-MAJOR)** **fs**: throw fs.fstat{Sync} errors in JS (Joyee Cheung) [#17914](https://github.com/nodejs/node/pull/17914)
* \[[`da7804f259`](https://github.com/nodejs/node/commit/da7804f259)] - **(SEMVER-MAJOR)** **fs**: throw fs.lstat{Sync} errors in JS (Joyee Cheung) [#17914](https://github.com/nodejs/node/pull/17914)
* \[[`57d7638af3`](https://github.com/nodejs/node/commit/57d7638af3)] - **(SEMVER-MAJOR)** **fs**: throw fs.stat{Sync} errors in JS (Joyee Cheung) [#17914](https://github.com/nodejs/node/pull/17914)
* \[[`791975d189`](https://github.com/nodejs/node/commit/791975d189)] - **(SEMVER-MAJOR)** **fs**: return errno and take fs\_req\_wrap in SyncCall (Joyee Cheung) [#17914](https://github.com/nodejs/node/pull/17914)
* \[[`71396a200d`](https://github.com/nodejs/node/commit/71396a200d)] - **(SEMVER-MAJOR)** **fs**: validate path in fs.exists{Sync} (Joyee Cheung) [#17852](https://github.com/nodejs/node/pull/17852)
* \[[`9ec700b073`](https://github.com/nodejs/node/commit/9ec700b073)] - **(SEMVER-MAJOR)** **fs**: validate path in fs.readFile (Joyee Cheung) [#17852](https://github.com/nodejs/node/pull/17852)
* \[[`8599465d33`](https://github.com/nodejs/node/commit/8599465d33)] - **(SEMVER-MAJOR)** **fs**: migrate errors to internal/errors (Steven) [#17719](https://github.com/nodejs/node/pull/17719)
* \[[`6100e12667`](https://github.com/nodejs/node/commit/6100e12667)] - **(SEMVER-MAJOR)** **fs**: move type checking to js (James M Snell) [#17667](https://github.com/nodejs/node/pull/17667)
* \[[`805dca199a`](https://github.com/nodejs/node/commit/805dca199a)] - **(SEMVER-MAJOR)** **fs**: remove unnecessary throw on fs.mkdtemp (James M Snell) [#17334](https://github.com/nodejs/node/pull/17334)
* \[[`163869879e`](https://github.com/nodejs/node/commit/163869879e)] - **(SEMVER-MAJOR)** **fs**: move type checking for fs.read to js (James M Snell) [#17334](https://github.com/nodejs/node/pull/17334)
* \[[`448ec0b5aa`](https://github.com/nodejs/node/commit/448ec0b5aa)] - **(SEMVER-MAJOR)** **fs**: move type checking in fs.futimes to js (James M Snell) [#17334](https://github.com/nodejs/node/pull/17334)
* \[[`82eb459e3f`](https://github.com/nodejs/node/commit/82eb459e3f)] - **(SEMVER-MAJOR)** **fs**: move type checking for fs.fchown to js (James M Snell) [#17334](https://github.com/nodejs/node/pull/17334)
* \[[`0a01aa8e94`](https://github.com/nodejs/node/commit/0a01aa8e94)] - **(SEMVER-MAJOR)** **fs**: move type checking for fs.fchmod to js (James M Snell) [#17334](https://github.com/nodejs/node/pull/17334)
* \[[`d453fac33b`](https://github.com/nodejs/node/commit/d453fac33b)] - **(SEMVER-MAJOR)** **fs**: move type checking for fs.ftruncate to js (James M Snell) [#17334](https://github.com/nodejs/node/pull/17334)
* \[[`8cb080c486`](https://github.com/nodejs/node/commit/8cb080c486)] - **(SEMVER-MAJOR)** **fs**: move type checking for fs.sync to js (James M Snell) [#17334](https://github.com/nodejs/node/pull/17334)
* \[[`956f97b875`](https://github.com/nodejs/node/commit/956f97b875)] - **(SEMVER-MAJOR)** **fs**: move type checking for fs.fdatasync to js (James M Snell) [#17334](https://github.com/nodejs/node/pull/17334)
* \[[`639096855e`](https://github.com/nodejs/node/commit/639096855e)] - **(SEMVER-MAJOR)** **fs**: move type checking on fs.fstat to js (James M Snell) [#17334](https://github.com/nodejs/node/pull/17334)
* \[[`8974df15a9`](https://github.com/nodejs/node/commit/8974df15a9)] - **(SEMVER-MAJOR)** **fs**: move type checking for fs.close to js (James M Snell) [#17334](https://github.com/nodejs/node/pull/17334)
* \[[`07d34092b1`](https://github.com/nodejs/node/commit/07d34092b1)] - **(SEMVER-MAJOR)** **fs**: throw fs.access errors in JS (Joyee Cheung) [#17160](https://github.com/nodejs/node/pull/17160)
* \[[`ab8bf26994`](https://github.com/nodejs/node/commit/ab8bf26994)] - **(SEMVER-MAJOR)** **fs,cluster,net**: assign error codes to remaining errors (Michaël Zasso) [#19373](https://github.com/nodejs/node/pull/19373)
* \[[`33ce9a6409`](https://github.com/nodejs/node/commit/33ce9a6409)] - **(SEMVER-MAJOR)** **http**: relax requirements on upgrade listener (Anatoli Papirovski) [#19981](https://github.com/nodejs/node/pull/19981)
* \[[`29be1e5f84`](https://github.com/nodejs/node/commit/29be1e5f84)] - **(SEMVER-MAJOR)** **http**: do not replace .read() in IncomingMessage (Matteo Collina) [#18939](https://github.com/nodejs/node/pull/18939)
* \[[`51be03cd57`](https://github.com/nodejs/node/commit/51be03cd57)] - **(SEMVER-MAJOR)** **http**: remove default 'error' listener on upgrade (Luigi Pinca) [#18868](https://github.com/nodejs/node/pull/18868)
* \[[`8118da7430`](https://github.com/nodejs/node/commit/8118da7430)] - **(SEMVER-MAJOR)** **http**: OutgoingMessage.end() should return this (Matteo Collina) [#18780](https://github.com/nodejs/node/pull/18780)
* \[[`baf8495078`](https://github.com/nodejs/node/commit/baf8495078)] - **(SEMVER-MAJOR)** **http**: process 100, 102-199 according to specs. (Miles Elam) [#18033](https://github.com/nodejs/node/pull/18033)
* \[[`b961d9fd83`](https://github.com/nodejs/node/commit/b961d9fd83)] - **(SEMVER-MAJOR)** **http**: disallow two-byte characters in URL path (Benno Fünfstück) [#16237](https://github.com/nodejs/node/pull/16237)
* \[[`0a84e95cd9`](https://github.com/nodejs/node/commit/0a84e95cd9)] - **(SEMVER-MAJOR)** **http**: improve errors thrown in header validation (Joyee Cheung) [#16719](https://github.com/nodejs/node/pull/16719)
* \[[`3d93f39190`](https://github.com/nodejs/node/commit/3d93f39190)] - **(SEMVER-MAJOR)** **http2**: make response.end() return this (Matteo Collina) [#18780](https://github.com/nodejs/node/pull/18780)
* \[[`fc61ee32fe`](https://github.com/nodejs/node/commit/fc61ee32fe)] - **(SEMVER-MAJOR)** **http2**: use session kUpdateTimer from kUpdateTimer (Jeremiah Senkpiel) [#17704](https://github.com/nodejs/node/pull/17704)
* \[[`93eb68e6d2`](https://github.com/nodejs/node/commit/93eb68e6d2)] - **(SEMVER-MAJOR)** **http2**: use actual Timeout instances (Jeremiah Senkpiel) [#17704](https://github.com/nodejs/node/pull/17704)
* \[[`4e1f0907da`](https://github.com/nodejs/node/commit/4e1f0907da)] - **(SEMVER-MAJOR)** **inspector**: migrate errors from C++ to JS (Michaël Zasso) [#19387](https://github.com/nodejs/node/pull/19387)
* \[[`0876a0314d`](https://github.com/nodejs/node/commit/0876a0314d)] - **(SEMVER-MAJOR)** **lib**: ensure --check flag works with --require (John-David Dalton) [#19600](https://github.com/nodejs/node/pull/19600)
* \[[`b38c81cb44`](https://github.com/nodejs/node/commit/b38c81cb44)] - **(SEMVER-MAJOR)** **lib**: improve error handling (Ruben Bridgewater) [#19445](https://github.com/nodejs/node/pull/19445)
* \[[`c6b6c92185`](https://github.com/nodejs/node/commit/c6b6c92185)] - **(SEMVER-MAJOR)** **lib**: always show ERR\_INVALID\_ARG\_TYPE received part (Ruben Bridgewater) [#19445](https://github.com/nodejs/node/pull/19445)
* \[[`1d2fd8b65b`](https://github.com/nodejs/node/commit/1d2fd8b65b)] - **(SEMVER-MAJOR)** **lib**: port remaining errors to new system (Michaël Zasso) [#19137](https://github.com/nodejs/node/pull/19137)
* \[[`1e8d110e64`](https://github.com/nodejs/node/commit/1e8d110e64)] - **(SEMVER-MAJOR)** **lib**: port errors to new system (Michaël Zasso) [#19034](https://github.com/nodejs/node/pull/19034)
* \[[`341770fedf`](https://github.com/nodejs/node/commit/341770fedf)] - **(SEMVER-MAJOR)** **lib**: improve normalize encoding performance (Ruben Bridgewater) [#18790](https://github.com/nodejs/node/pull/18790)
* \[[`e99ae7764d`](https://github.com/nodejs/node/commit/e99ae7764d)] - **(SEMVER-MAJOR)** **lib**: make console writable and non-enumerable (Ruben Bridgewater) [#17708](https://github.com/nodejs/node/pull/17708)
* \[[`d3ac18a176`](https://github.com/nodejs/node/commit/d3ac18a176)] - **(SEMVER-MAJOR)** **lib**: migrate \_http\_outgoing.js's remaining errors (Anton Paras) [#17837](https://github.com/nodejs/node/pull/17837)
* \[[`d022cb1bdd`](https://github.com/nodejs/node/commit/d022cb1bdd)] - **(SEMVER-MAJOR)** **lib**: combine similar error codes (Weijia Wang) [#17648](https://github.com/nodejs/node/pull/17648)
* \[[`05948d8e4e`](https://github.com/nodejs/node/commit/05948d8e4e)] - **(SEMVER-MAJOR)** **lib**: remove use of Debug.MakeMirror() (Ben Noordhuis) [#13295](https://github.com/nodejs/node/pull/13295)
* \[[`6f724e1563`](https://github.com/nodejs/node/commit/6f724e1563)] - **(SEMVER-MAJOR)** **lib,src**: remove vm.runInDebugContext() (Ben Noordhuis) [#13295](https://github.com/nodejs/node/pull/13295)
* \[[`c1278e5329`](https://github.com/nodejs/node/commit/c1278e5329)] - **(SEMVER-MAJOR)** **lib,test**: minor refactoring (Ruben Bridgewater) [#19445](https://github.com/nodejs/node/pull/19445)
* \[[`77b52fd58f`](https://github.com/nodejs/node/commit/77b52fd58f)] - **(SEMVER-MAJOR)** **module**: move options checks from C++ to JS (Michaël Zasso) [#19822](https://github.com/nodejs/node/pull/19822)
* \[[`1ed36aeb53`](https://github.com/nodejs/node/commit/1ed36aeb53)] - **(SEMVER-MAJOR)** **module**: check file ext before dir as documented (Bradley Farias) [#15015](https://github.com/nodejs/node/pull/15015)
* \[[`bd4773a043`](https://github.com/nodejs/node/commit/bd4773a043)] - **(SEMVER-MAJOR)** **module**: use undefined if no main (Rich Trott) [#18593](https://github.com/nodejs/node/pull/18593)
* \[[`9fb91fe1d6`](https://github.com/nodejs/node/commit/9fb91fe1d6)] - **(SEMVER-MAJOR)** **module**: validate request in require.resolve.paths (Joyee Cheung) [#18359](https://github.com/nodejs/node/pull/18359)
* \[[`d4dd0665f5`](https://github.com/nodejs/node/commit/d4dd0665f5)] - **(SEMVER-MAJOR)** **module**: validate request in require.resolve (Joyee Cheung) [#18359](https://github.com/nodejs/node/pull/18359)
* \[[`b21715403b`](https://github.com/nodejs/node/commit/b21715403b)] - **(SEMVER-MAJOR)** **module**: use internal/errors.js in module.require (Joyee Cheung) [#18359](https://github.com/nodejs/node/pull/18359)
* \[[`fea1e05ba5`](https://github.com/nodejs/node/commit/fea1e05ba5)] - **(SEMVER-MAJOR)** **module**: rename internalModuleReadFile to internalModuleReadJSON (John-David Dalton) [#17084](https://github.com/nodejs/node/pull/17084)
* \[[`0fdd88a374`](https://github.com/nodejs/node/commit/0fdd88a374)] - **(SEMVER-MAJOR)** **module**: speed up package.json parsing more (Ben Noordhuis) [#15767](https://github.com/nodejs/node/pull/15767)
* \[[`fdbb6dd042`](https://github.com/nodejs/node/commit/fdbb6dd042)] - **(SEMVER-MAJOR)** **module**: speed up package.json parsing (Ben Noordhuis) [#15767](https://github.com/nodejs/node/pull/15767)
* \[[`9b7a6914a7`](https://github.com/nodejs/node/commit/9b7a6914a7)] - **(SEMVER-MAJOR)** **net**: emit 'close' after 'end' (Luigi Pinca) [#19241](https://github.com/nodejs/node/pull/19241)
* \[[`b98aaa312e`](https://github.com/nodejs/node/commit/b98aaa312e)] - **(SEMVER-MAJOR)** **net**: migrate errors to internal/errors (kysnm) [#17766](https://github.com/nodejs/node/pull/17766)
* \[[`24dd92e77f`](https://github.com/nodejs/node/commit/24dd92e77f)] - **(SEMVER-MAJOR)** **net**: use actual Timeout instance on Sockets (Jeremiah Senkpiel) [#17704](https://github.com/nodejs/node/pull/17704)
* \[[`3701b02309`](https://github.com/nodejs/node/commit/3701b02309)] - **(SEMVER-MAJOR)** **net**: remove deprecated getters for internals (Anna Henningsen) [#17141](https://github.com/nodejs/node/pull/17141)
* \[[`056b858e57`](https://github.com/nodejs/node/commit/056b858e57)] - **(SEMVER-MAJOR)** **os**: migrate node\_os.cc to internal/errors (James M Snell) [#16567](https://github.com/nodejs/node/pull/16567)
* \[[`058e7fb8e6`](https://github.com/nodejs/node/commit/058e7fb8e6)] - **(SEMVER-MAJOR)** **process**: fix error handling (Ruben Bridgewater) [#19445](https://github.com/nodejs/node/pull/19445)
* \[[`5826fe4e79`](https://github.com/nodejs/node/commit/5826fe4e79)] - **(SEMVER-MAJOR)** **process**: doc-only deprecate non-string env value (Timothy Gu) [#18990](https://github.com/nodejs/node/pull/18990)
* \[[`b32bcf7e9c`](https://github.com/nodejs/node/commit/b32bcf7e9c)] - **(SEMVER-MAJOR)** **process**: unify error message from chdir() errors (Sarat Addepalli) [#19088](https://github.com/nodejs/node/pull/19088)
* \[[`703e37cf3f`](https://github.com/nodejs/node/commit/703e37cf3f)] - **(SEMVER-MAJOR)** **process**: deprecate process.assert() (Ruben Bridgewater) [#18666](https://github.com/nodejs/node/pull/18666)
* \[[`4893f70d12`](https://github.com/nodejs/node/commit/4893f70d12)] - **(SEMVER-MAJOR)** **repl**: remove magic mode (Ruben Bridgewater) [#19187](https://github.com/nodejs/node/pull/19187)
* \[[`60c9ad7979`](https://github.com/nodejs/node/commit/60c9ad7979)] - **(SEMVER-MAJOR)** **repl**: remove deprecated NODE\_REPL\_HISTORY\_FILE (Ruben Bridgewater) [#13876](https://github.com/nodejs/node/pull/13876)
* \[[`ab5a2aba38`](https://github.com/nodejs/node/commit/ab5a2aba38)] - **(SEMVER-MAJOR)** **repl**: migrate errors to internal/errors (kysnm) [#17716](https://github.com/nodejs/node/pull/17716)
* \[[`90a43906ab`](https://github.com/nodejs/node/commit/90a43906ab)] - **(SEMVER-MAJOR)** **repl**: show proxies as Proxy objects (Ben Noordhuis) [#16485](https://github.com/nodejs/node/pull/16485)
* \[[`a6be27a77f`](https://github.com/nodejs/node/commit/a6be27a77f)] - **(SEMVER-MAJOR)** **src**: throw ERR\_MISSING\_ARGS in node\_crypto.cc (Joyee Cheung) [#20121](https://github.com/nodejs/node/pull/20121)
* \[[`f042929c3c`](https://github.com/nodejs/node/commit/f042929c3c)] - **(SEMVER-MAJOR)** **src**: throw ERR\_INVALID\_ARG\_VALUE in node\_crypto.cc (Joyee Cheung) [#20121](https://github.com/nodejs/node/pull/20121)
* \[[`7946910475`](https://github.com/nodejs/node/commit/7946910475)] - **(SEMVER-MAJOR)** **src**: throw ERR\_MISSING\_MODULE in module\_wrap.cc (Joyee Cheung) [#20121](https://github.com/nodejs/node/pull/20121)
* \[[`02db891bcc`](https://github.com/nodejs/node/commit/02db891bcc)] - **(SEMVER-MAJOR)** **src**: throw ERR\_BUFFER\_OUT\_OF\_BOUNDS in node\_buffer.cc (Joyee Cheung) [#20121](https://github.com/nodejs/node/pull/20121)
* \[[`0fdf39aefa`](https://github.com/nodejs/node/commit/0fdf39aefa)] - **(SEMVER-MAJOR)** **src**: throw ERR\_INVALID\_ARG\_TYPE in C++ argument checks (Joyee Cheung) [#20121](https://github.com/nodejs/node/pull/20121)
* \[[`1d0ad63887`](https://github.com/nodejs/node/commit/1d0ad63887)] - **(SEMVER-MAJOR)** **src**: migrate ERR\_INDEX\_OUT\_OF\_RANGE in C++ (Joyee Cheung) [#20121](https://github.com/nodejs/node/pull/20121)
* \[[`c218854bc8`](https://github.com/nodejs/node/commit/c218854bc8)] - **(SEMVER-MAJOR)** **src**: add THROW\_ERR\_\* helpers (Joyee Cheung) [#20121](https://github.com/nodejs/node/pull/20121)
* \[[`03f8c4f039`](https://github.com/nodejs/node/commit/03f8c4f039)] - **(SEMVER-MAJOR)** **src**: update NODE\_MODULE\_VERSION to 63 (Myles Borins) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`63eb267c34`](https://github.com/nodejs/node/commit/63eb267c34)] - **(SEMVER-MAJOR)** **src**: migrate string\_bytes.cc to throw errors with code (Joyee Cheung) [#19739](https://github.com/nodejs/node/pull/19739)
* \[[`289d152ce0`](https://github.com/nodejs/node/commit/289d152ce0)] - **(SEMVER-MAJOR)** **src**: add error code helpers to src/node\_errors.h (Joyee Cheung) [#19739](https://github.com/nodejs/node/pull/19739)
* \[[`3b1e5d9cf7`](https://github.com/nodejs/node/commit/3b1e5d9cf7)] - **(SEMVER-MAJOR)** **src**: request code cache explicitly (Mythri Alle) [#18453](https://github.com/nodejs/node/pull/18453)
* \[[`a9755d493e`](https://github.com/nodejs/node/commit/a9755d493e)] - **(SEMVER-MAJOR)** **src**: update NODE\_MODULE\_VERSION to 62 (Michaël Zasso) [#18453](https://github.com/nodejs/node/pull/18453)
* \[[`30fd3d25df`](https://github.com/nodejs/node/commit/30fd3d25df)] - **(SEMVER-MAJOR)** **src**: Remove lttng support. (Glen Keane) [#18982](https://github.com/nodejs/node/pull/18982)
* \[[`efb32592e1`](https://github.com/nodejs/node/commit/efb32592e1)] - **(SEMVER-MAJOR)** **src**: deprecate legacy node::MakeCallback (Ali Ijaz Sheikh) [#18632](https://github.com/nodejs/node/pull/18632)
* \[[`3154d83a02`](https://github.com/nodejs/node/commit/3154d83a02)] - **(SEMVER-MAJOR)** **src**: update postmortem constant name (cjihrig) [#17489](https://github.com/nodejs/node/pull/17489)
* \[[`0398debe81`](https://github.com/nodejs/node/commit/0398debe81)] - **(SEMVER-MAJOR)** **src**: update NODE\_MODULE\_VERSION to 61 (Michaël Zasso) [#17489](https://github.com/nodejs/node/pull/17489)
* \[[`98d9540dd7`](https://github.com/nodejs/node/commit/98d9540dd7)] - **(SEMVER-MAJOR)** **src**: use uv\_hrtime as tracing timestamp (Ali Ijaz Sheikh) [#18196](https://github.com/nodejs/node/pull/18196)
* \[[`2a61ce5996`](https://github.com/nodejs/node/commit/2a61ce5996)] - **(SEMVER-MAJOR)** **src**: validate args length in Access and Close (Sakthipriyan Vairamani (thefourtheye)) [#18203](https://github.com/nodejs/node/pull/18203)
* \[[`a1ed29b1c6`](https://github.com/nodejs/node/commit/a1ed29b1c6)] - **(SEMVER-MAJOR)** **src**: implement getting current time in NodePlatform (Sergei Datsenko) [#16271](https://github.com/nodejs/node/pull/16271)
* \[[`a7c5fe9ba6`](https://github.com/nodejs/node/commit/a7c5fe9ba6)] - **(SEMVER-MAJOR)** **src**: update NODE\_MODULE\_VERSION to 60 (Michaël Zasso) [#16271](https://github.com/nodejs/node/pull/16271)
* \[[`804eb3cd73`](https://github.com/nodejs/node/commit/804eb3cd73)] - **(SEMVER-MAJOR)** **src**: remove process.\_debugPause() (Ben Noordhuis) [#17060](https://github.com/nodejs/node/pull/17060)
* \[[`c3dc0e0d75`](https://github.com/nodejs/node/commit/c3dc0e0d75)] - **(SEMVER-MAJOR)** **src**: add CollectExceptionInfo & errors.SystemError (James M Snell) [#16567](https://github.com/nodejs/node/pull/16567)
* \[[`3d20190a3a`](https://github.com/nodejs/node/commit/3d20190a3a)] - **(SEMVER-MAJOR)** **src**: remove throws in set/getHiddenValue (James M Snell) [#16544](https://github.com/nodejs/node/pull/16544)
* \[[`67c8511ea1`](https://github.com/nodejs/node/commit/67c8511ea1)] - **(SEMVER-MAJOR)** **src**: use internal/errors for startSigintWatchdog (James M Snell) [#16546](https://github.com/nodejs/node/pull/16546)
* \[[`cf5f9867ff`](https://github.com/nodejs/node/commit/cf5f9867ff)] - **(SEMVER-MAJOR)** **stream**: 'readable' have precedence over flowing (Matteo Collina) [#18994](https://github.com/nodejs/node/pull/18994)
* \[[`c9794880e8`](https://github.com/nodejs/node/commit/c9794880e8)] - **(SEMVER-MAJOR)** **stream**: make virtual methods errors consistent (Luigi Pinca) [#18813](https://github.com/nodejs/node/pull/18813)
* \[[`5e3f51648e`](https://github.com/nodejs/node/commit/5e3f51648e)] - **(SEMVER-MAJOR)** **stream**: updated streams error handling (Mathias Buus) [#18438](https://github.com/nodejs/node/pull/18438)
* \[[`f6721c20df`](https://github.com/nodejs/node/commit/f6721c20df)] - **(SEMVER-MAJOR)** **stream**: writable.end should return this. (Matteo Collina) [#18780](https://github.com/nodejs/node/pull/18780)
* \[[`faeee11c1f`](https://github.com/nodejs/node/commit/faeee11c1f)] - **(SEMVER-MAJOR)** **stream**: readable continues to read when `push('')` (陈刚) [#18211](https://github.com/nodejs/node/pull/18211)
* \[[`46e0a55b84`](https://github.com/nodejs/node/commit/46e0a55b84)] - **(SEMVER-MAJOR)** **stream**: add type and range check for highWaterMark (Tobias Nießen) [#18098](https://github.com/nodejs/node/pull/18098)
* \[[`9d3958102e`](https://github.com/nodejs/node/commit/9d3958102e)] - **(SEMVER-MAJOR)** **stream**: add custom inspect to BufferList (Ruben Bridgewater) [#17907](https://github.com/nodejs/node/pull/17907)
* \[[`1e0f3315c7`](https://github.com/nodejs/node/commit/1e0f3315c7)] - **(SEMVER-MAJOR)** **stream**: always defer 'readable' with nextTick (Matteo Collina) [#17979](https://github.com/nodejs/node/pull/17979)
* \[[`dd49778938`](https://github.com/nodejs/node/commit/dd49778938)] - **(SEMVER-MAJOR)** **test**: fix promise message test after V8 update (Michaël Zasso) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`61f87837a9`](https://github.com/nodejs/node/commit/61f87837a9)] - **(SEMVER-MAJOR)** **test**: remove test for shared array buffers transfer (Malcolm White) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`425c5ca27d`](https://github.com/nodejs/node/commit/425c5ca27d)] - **(SEMVER-MAJOR)** **test**: remove openssl -no\_rand\_screen opts (Shigeki Ohtsu) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`3e0d40d4af`](https://github.com/nodejs/node/commit/3e0d40d4af)] - **(SEMVER-MAJOR)** **test**: add info option to common.expectsError (Joyee Cheung) [#19514](https://github.com/nodejs/node/pull/19514)
* \[[`74553465e6`](https://github.com/nodejs/node/commit/74553465e6)] - **(SEMVER-MAJOR)** **test**: refactor test-cluster-send-deadlock (Luigi Pinca) [#19241](https://github.com/nodejs/node/pull/19241)
* \[[`5c8937c3c6`](https://github.com/nodejs/node/commit/5c8937c3c6)] - **(SEMVER-MAJOR)** **test**: fix esm message tests after V8 update (Michaël Zasso) [#18453](https://github.com/nodejs/node/pull/18453)
* \[[`bde8de8892`](https://github.com/nodejs/node/commit/bde8de8892)] - **(SEMVER-MAJOR)** **test**: update postmortem metadata test (cjihrig) [#18453](https://github.com/nodejs/node/pull/18453)
* \[[`069dd10ca2`](https://github.com/nodejs/node/commit/069dd10ca2)] - **(SEMVER-MAJOR)** **test**: remove vulgar language (Ruben Bridgewater) [#18395](https://github.com/nodejs/node/pull/18395)
* \[[`ac2af1361e`](https://github.com/nodejs/node/commit/ac2af1361e)] - **(SEMVER-MAJOR)** **test**: fix inspector test after V8 upgrade (Michaël Zasso) [#17489](https://github.com/nodejs/node/pull/17489)
* \[[`4e51512148`](https://github.com/nodejs/node/commit/4e51512148)] - **(SEMVER-MAJOR)** **test**: update postmortem metadata test (cjihrig) [#17489](https://github.com/nodejs/node/pull/17489)
* \[[`7809f386b0`](https://github.com/nodejs/node/commit/7809f386b0)] - **(SEMVER-MAJOR)** **test**: improve console tests (Ruben Bridgewater) [#17708](https://github.com/nodejs/node/pull/17708)
* \[[`6ff52b69cc`](https://github.com/nodejs/node/commit/6ff52b69cc)] - **(SEMVER-MAJOR)** **test**: add standard console tests (wandalen) [#17708](https://github.com/nodejs/node/pull/17708)
* \[[`1312db5651`](https://github.com/nodejs/node/commit/1312db5651)] - **(SEMVER-MAJOR)** **test**: test error messages from fs.realpath{Sync} (Joyee Cheung) [#17914](https://github.com/nodejs/node/pull/17914)
* \[[`5eccbb09fa`](https://github.com/nodejs/node/commit/5eccbb09fa)] - **(SEMVER-MAJOR)** **test**: verify errors thrown from fs stat APIs (Joyee Cheung) [#17914](https://github.com/nodejs/node/pull/17914)
* \[[`7939a5e708`](https://github.com/nodejs/node/commit/7939a5e708)] - **(SEMVER-MAJOR)** **test**: change test expectation for string decoder (Marja Hölttä) [#16271](https://github.com/nodejs/node/pull/16271)
* \[[`60698c2455`](https://github.com/nodejs/node/commit/60698c2455)] - **(SEMVER-MAJOR)** **test**: apply eslint exceptions narrowly (Rich Trott) [#16393](https://github.com/nodejs/node/pull/16393)
* \[[`47a984ada0`](https://github.com/nodejs/node/commit/47a984ada0)] - **(SEMVER-MAJOR)** **timers**: prevent event loop blocking (Anatoli Papirovski) [#18486](https://github.com/nodejs/node/pull/18486)
* \[[`d7894f3969`](https://github.com/nodejs/node/commit/d7894f3969)] - **(SEMVER-MAJOR)** **timers**: use start instead of stop + start (Anatoli Papirovski) [#18486](https://github.com/nodejs/node/pull/18486)
* \[[`71c0d0370a`](https://github.com/nodejs/node/commit/71c0d0370a)] - **(SEMVER-MAJOR)** **timers**: use const as appropriate (Anatoli Papirovski) [#18486](https://github.com/nodejs/node/pull/18486)
* \[[`a986158cbf`](https://github.com/nodejs/node/commit/a986158cbf)] - **(SEMVER-MAJOR)** **timers**: re-enter C++ less frequently (Anatoli Papirovski) [#18486](https://github.com/nodejs/node/pull/18486)
* \[[`9b8e1c2e4f`](https://github.com/nodejs/node/commit/9b8e1c2e4f)] - **(SEMVER-MAJOR)** **timers**: refactor error handling (Anatoli Papirovski) [#18486](https://github.com/nodejs/node/pull/18486)
* \[[`68783ae0b8`](https://github.com/nodejs/node/commit/68783ae0b8)] - **(SEMVER-MAJOR)** **timers**: runtime-deprecate {un}enroll() (Jeremiah Senkpiel) [#18066](https://github.com/nodejs/node/pull/18066)
* \[[`1385e1bc63`](https://github.com/nodejs/node/commit/1385e1bc63)] - **(SEMVER-MAJOR)** **timers**: setInterval interval includes cb duration (zhangzifa) [#14815](https://github.com/nodejs/node/pull/14815)
* \[[`593941ac0b`](https://github.com/nodejs/node/commit/593941ac0b)] - **(SEMVER-MAJOR)** **timers**: extract enroll() validation into a fn (Jeremiah Senkpiel) [#17704](https://github.com/nodejs/node/pull/17704)
* \[[`9204a0db6e`](https://github.com/nodejs/node/commit/9204a0db6e)] - **(SEMVER-MAJOR)** **tls**: runtime-deprecate tls.convertNPNProtocols() (Ben Noordhuis) [#19403](https://github.com/nodejs/node/pull/19403)
* \[[`5bfbe5ceae`](https://github.com/nodejs/node/commit/5bfbe5ceae)] - **(SEMVER-MAJOR)** **tls**: drop NPN (next protocol negotiation) support (Ben Noordhuis) [#19403](https://github.com/nodejs/node/pull/19403)
* \[[`eda702104b`](https://github.com/nodejs/node/commit/eda702104b)] - **(SEMVER-MAJOR)** **tls**: better error message for socket disconnect (Anna Henningsen) [#18989](https://github.com/nodejs/node/pull/18989)
* \[[`1c29da8236`](https://github.com/nodejs/node/commit/1c29da8236)] - **(SEMVER-MAJOR)** **tls**: migrate C++ errors to internal/errors.js (Joyee Cheung) [#18125](https://github.com/nodejs/node/pull/18125)
* \[[`9ffebeab48`](https://github.com/nodejs/node/commit/9ffebeab48)] - **(SEMVER-MAJOR)** **tls**: migrate argument type-checking errors (Joyee Cheung) [#18125](https://github.com/nodejs/node/pull/18125)
* \[[`9301b8a9c6`](https://github.com/nodejs/node/commit/9301b8a9c6)] - **(SEMVER-MAJOR)** **tls**: make deprecated tls.createSecurePair() use public API (Anna Henningsen) [#17882](https://github.com/nodejs/node/pull/17882)
* \[[`79261f3003`](https://github.com/nodejs/node/commit/79261f3003)] - **(SEMVER-MAJOR)** **tls**: migrate errors in \_tls\_wrap.js (Mir Mufaqam Ali) [#17792](https://github.com/nodejs/node/pull/17792)
* \[[`af78840b19`](https://github.com/nodejs/node/commit/af78840b19)] - **(SEMVER-MAJOR)** **tls**: set ecdhCurve default to 'auto' (Hativ) [#16853](https://github.com/nodejs/node/pull/16853)
* \[[`7aa64b9fb9`](https://github.com/nodejs/node/commit/7aa64b9fb9)] - **(SEMVER-MAJOR)** **tools**: implement ninja build with --build-v8-with-gn (Yang Guo) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`91a5ee1137`](https://github.com/nodejs/node/commit/91a5ee1137)] - **(SEMVER-MAJOR)** **tools**: fix make test-v8 (Michaël Zasso) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`2b235830fb`](https://github.com/nodejs/node/commit/2b235830fb)] - **(SEMVER-MAJOR)** **tools**: install all header files OpenSSL-1.1.0 (Shigeki Ohtsu) [#19794](https://github.com/nodejs/node/pull/19794)
* \[[`6a9f049968`](https://github.com/nodejs/node/commit/6a9f049968)] - **(SEMVER-MAJOR)** **tools,lib**: forbid native Error constructors (Michaël Zasso) [#19373](https://github.com/nodejs/node/pull/19373)
* \[[`da5d818a54`](https://github.com/nodejs/node/commit/da5d818a54)] - **(SEMVER-MAJOR)** **trace\_events**: adds a new trace\_events api (James M Snell) [#19803](https://github.com/nodejs/node/pull/19803)
* \[[`3d9d84940a`](https://github.com/nodejs/node/commit/3d9d84940a)] - **(SEMVER-MAJOR)** **tty**: convert to internal/errors using SystemError (James M Snell) [#16567](https://github.com/nodejs/node/pull/16567)
* \[[`312414662b`](https://github.com/nodejs/node/commit/312414662b)] - **(SEMVER-MAJOR)** **url**: expose the WHATWG URL API globally (Michaël Zasso) [#18281](https://github.com/nodejs/node/pull/18281)
* \[[`f848c60f64`](https://github.com/nodejs/node/commit/f848c60f64)] - **(SEMVER-MAJOR)** **util**: inspect arguments properly (Ruben Bridgewater) [#19467](https://github.com/nodejs/node/pull/19467)
* \[[`be4950d58c`](https://github.com/nodejs/node/commit/be4950d58c)] - **(SEMVER-MAJOR)** **util**: add type check functions for BigInt arrays (Michaël Zasso) [#19201](https://github.com/nodejs/node/pull/19201)
* \[[`1029dd3686`](https://github.com/nodejs/node/commit/1029dd3686)] - **(SEMVER-MAJOR)** **util**: show Weak(Set|Map) entries in inspect (Ruben Bridgewater) [#19259](https://github.com/nodejs/node/pull/19259)
* \[[`0fbd4b1d02`](https://github.com/nodejs/node/commit/0fbd4b1d02)] - **(SEMVER-MAJOR)** **util**: improve iterator inspect output (Ruben Bridgewater) [#19259](https://github.com/nodejs/node/pull/19259)
* \[[`8f153092d8`](https://github.com/nodejs/node/commit/8f153092d8)] - **(SEMVER-MAJOR)** **util**: change %o depth default (Ruben Bridgewater) [#17907](https://github.com/nodejs/node/pull/17907)
* \[[`b994b8eff6`](https://github.com/nodejs/node/commit/b994b8eff6)] - **(SEMVER-MAJOR)** **util**: change util.inspect depth default (Ruben Bridgewater) [#17907](https://github.com/nodejs/node/pull/17907)
* \[[`c64ca56def`](https://github.com/nodejs/node/commit/c64ca56def)] - **(SEMVER-MAJOR)** **util**: improve error message of \_errnoException (Weijia Wang) [#17626](https://github.com/nodejs/node/pull/17626)
* \[[`31e0dbc0c7`](https://github.com/nodejs/node/commit/31e0dbc0c7)] - **(SEMVER-MAJOR)** **util**: use @@toStringTag (Gus Caplan) [#16956](https://github.com/nodejs/node/pull/16956)
* \[[`617e3e96e6`](https://github.com/nodejs/node/commit/617e3e96e6)] - **(SEMVER-MAJOR)** **util**: runtime deprecation for custom .inspect() (Rich Trott) [#16393](https://github.com/nodejs/node/pull/16393)
* \[[`07d39a2262`](https://github.com/nodejs/node/commit/07d39a2262)] - **(SEMVER-MAJOR)** **util**: emit deprecation code only once (Rich Trott) [#16393](https://github.com/nodejs/node/pull/16393)
* \[[`34d988f122`](https://github.com/nodejs/node/commit/34d988f122)] - **(SEMVER-MAJOR)** **vm**: move options checks from C++ to JS (Michaël Zasso) [#19398](https://github.com/nodejs/node/pull/19398)
* \[[`49b2969ef4`](https://github.com/nodejs/node/commit/49b2969ef4)] - **(SEMVER-MAJOR)** **vm**: migrate isContext to internal/errors (dustinnewman98) [#19268](https://github.com/nodejs/node/pull/19268)
* \[[`da886d9a4c`](https://github.com/nodejs/node/commit/da886d9a4c)] - **(SEMVER-MAJOR)** **zlib**: improve zlib errors (Joyee Cheung) [#18675](https://github.com/nodejs/node/pull/18675)

#### Semver-minor

* \[[`b3c1bd38f6`](https://github.com/nodejs/node/commit/b3c1bd38f6)] - **(SEMVER-MINOR)** **assert**: add direct promises support in rejects (Ruben Bridgewater) [#19885](https://github.com/nodejs/node/pull/19885)
* \[[`599337f43e`](https://github.com/nodejs/node/commit/599337f43e)] - **(SEMVER-MINOR)** **assert**: add rejects() and doesNotReject() (feugy) [#18023](https://github.com/nodejs/node/pull/18023)
* \[[`559e23a459`](https://github.com/nodejs/node/commit/559e23a459)] - **(SEMVER-MINOR)** **console**: auto-detect color support by default (Anna Henningsen) [#19372](https://github.com/nodejs/node/pull/19372)
* \[[`3f1562dea8`](https://github.com/nodejs/node/commit/3f1562dea8)] - **(SEMVER-MINOR)** **console**: add color support (Anna Henningsen) [#19372](https://github.com/nodejs/node/pull/19372)
* \[[`4fe51755ff`](https://github.com/nodejs/node/commit/4fe51755ff)] - **(SEMVER-MINOR)** **console**: allow `options` object as constructor arg (Anna Henningsen) [#19372](https://github.com/nodejs/node/pull/19372)
* \[[`97ace04492`](https://github.com/nodejs/node/commit/97ace04492)] - **(SEMVER-MINOR)** **console**: add table method (Gus Caplan) [#18137](https://github.com/nodejs/node/pull/18137)
* \[[`f2e02883e7`](https://github.com/nodejs/node/commit/f2e02883e7)] - **(SEMVER-MINOR)** **crypto**: add ECDH.convertKey to convert public keys (Wei-Wei Wu) [#19080](https://github.com/nodejs/node/pull/19080)
* \[[`6e7992e8b8`](https://github.com/nodejs/node/commit/6e7992e8b8)] - **(SEMVER-MINOR)** **crypto**: docs-only deprecate crypto.fips, replace (James M Snell) [#18335](https://github.com/nodejs/node/pull/18335)
* \[[`5303a509fb`](https://github.com/nodejs/node/commit/5303a509fb)] - **(SEMVER-MINOR)** **deps**: cherry-pick 39d546a from upstream V8 (Gus Caplan) [#20016](https://github.com/nodejs/node/pull/20016)
* \[[`25a816dcda`](https://github.com/nodejs/node/commit/25a816dcda)] - **(SEMVER-MINOR)** **deps**: upgrade npm to 5.8.0 (FallenRiteMonk) [#19560](https://github.com/nodejs/node/pull/19560)
* \[[`5bd9d68a45`](https://github.com/nodejs/node/commit/5bd9d68a45)] - **(SEMVER-MINOR)** **doc**: improve assert documentation (Ruben Bridgewater) [#19885](https://github.com/nodejs/node/pull/19885)
* \[[`63565e1063`](https://github.com/nodejs/node/commit/63565e1063)] - **(SEMVER-MINOR)** **doc**: document `Console(…, ignoreErrors)` option (Anna Henningsen) [#19372](https://github.com/nodejs/node/pull/19372)
* \[[`bd6e0be0df`](https://github.com/nodejs/node/commit/bd6e0be0df)] - **(SEMVER-MINOR)** **doc**: provide replacements for deprecated util methods (Anna Henningsen) [#18415](https://github.com/nodejs/node/pull/18415)
* \[[`5b705cddcc`](https://github.com/nodejs/node/commit/5b705cddcc)] - **(SEMVER-MINOR)** **fs**: add 'close' event to FSWatcher (Alec Larson) [#19900](https://github.com/nodejs/node/pull/19900)
* \[[`a16d88d9e9`](https://github.com/nodejs/node/commit/a16d88d9e9)] - **(SEMVER-MINOR)** **fs**: expose copy-on-write flags for fs.copyFile() (cjihrig) [#19759](https://github.com/nodejs/node/pull/19759)
* \[[`329fc78e49`](https://github.com/nodejs/node/commit/329fc78e49)] - **(SEMVER-MINOR)** **fs**: add initial set of fs.promises APIs (James M Snell) [#18297](https://github.com/nodejs/node/pull/18297)
* \[[`85b37db684`](https://github.com/nodejs/node/commit/85b37db684)] - **(SEMVER-MINOR)** **fs**: add FileHandle object fd wrapper (James M Snell) [#18297](https://github.com/nodejs/node/pull/18297)
* \[[`7154bc097c`](https://github.com/nodejs/node/commit/7154bc097c)] - **(SEMVER-MINOR)** **fs**: add FSReqPromise (James M Snell) [#18297](https://github.com/nodejs/node/pull/18297)
* \[[`cd7d7b15c1`](https://github.com/nodejs/node/commit/cd7d7b15c1)] - **(SEMVER-MINOR)** **n-api**: take n-api out of experimental (Michael Dawson) [#19262](https://github.com/nodejs/node/pull/19262)
* \[[`009e41826f`](https://github.com/nodejs/node/commit/009e41826f)] - **(SEMVER-MINOR)** **perf\_hooks**: make PerformanceObserver an AsyncResource (James M Snell) [#18789](https://github.com/nodejs/node/pull/18789)
* \[[`9e509b622b`](https://github.com/nodejs/node/commit/9e509b622b)] - **(SEMVER-MINOR)** **perf\_hooks**: emit trace events for marks, measures, and timerify (James M Snell) [#18789](https://github.com/nodejs/node/pull/18789)
* \[[`aca8e764da`](https://github.com/nodejs/node/commit/aca8e764da)] - **(SEMVER-MINOR)** **perf\_hooks**: eliminate deprecation warning (James M Snell) [#18789](https://github.com/nodejs/node/pull/18789)
* \[[`cf4e6fd03f`](https://github.com/nodejs/node/commit/cf4e6fd03f)] - **(SEMVER-MINOR)** **process**: add version constants and compare (Gus Caplan) [#19587](https://github.com/nodejs/node/pull/19587)
* \[[`982e3bdb1f`](https://github.com/nodejs/node/commit/982e3bdb1f)] - **(SEMVER-MINOR)** **process**: add more version properties to release (Gus Caplan) [#19438](https://github.com/nodejs/node/pull/19438)
* \[[`446c1ecfda`](https://github.com/nodejs/node/commit/446c1ecfda)] - **(SEMVER-MINOR)** **src, tools**: add debug symbols for node internals (Matheus Marchini) [#14901](https://github.com/nodejs/node/pull/14901)
* \[[`a5cf3feaf1`](https://github.com/nodejs/node/commit/a5cf3feaf1)] - **(SEMVER-MINOR)** **stream**: add pipeline and finished (Mathias Buus) [#19828](https://github.com/nodejs/node/pull/19828)
* \[[`61b4d60c5d`](https://github.com/nodejs/node/commit/61b4d60c5d)] - **(SEMVER-MINOR)** **stream**: added experimental support for for-await (Matteo Collina) [#17755](https://github.com/nodejs/node/pull/17755)
* \[[`c667c87528`](https://github.com/nodejs/node/commit/c667c87528)] - **(SEMVER-MINOR)** **tools**: add eslintrc rule for `assert.rejects` (Ruben Bridgewater) [#19885](https://github.com/nodejs/node/pull/19885)
* \[[`4b733834fc`](https://github.com/nodejs/node/commit/4b733834fc)] - **(SEMVER-MINOR)** **util**: introduce types.isModuleNamespaceObject (Gus Caplan) [#20016](https://github.com/nodejs/node/pull/20016)
* \[[`678f2c261a`](https://github.com/nodejs/node/commit/678f2c261a)] - **(SEMVER-MINOR)** **util**: introduce `formatWithOptions()` (Anna Henningsen) [#19372](https://github.com/nodejs/node/pull/19372)
* \[[`b20af8088a`](https://github.com/nodejs/node/commit/b20af8088a)] - **(SEMVER-MINOR)** **util**: introduce `util.types.is[…]` type checks (Anna Henningsen) [#18415](https://github.com/nodejs/node/pull/18415)
* \[[`39dc947409`](https://github.com/nodejs/node/commit/39dc947409)] - **(SEMVER-MINOR)** **util**: add bigint formatting to util.inspect (Gus Caplan) [#18412](https://github.com/nodejs/node/pull/18412)
* \[[`cb5f358ee7`](https://github.com/nodejs/node/commit/cb5f358ee7)] - **(SEMVER-MINOR)** **vm**: add code generation options (Gus Caplan) [#19016](https://github.com/nodejs/node/pull/19016)
* \[[`49fd9c63d2`](https://github.com/nodejs/node/commit/49fd9c63d2)] - **(SEMVER-MINOR)** **zlib**: use `.bytesWritten` instead of `.bytesRead` (Anna Henningsen) [#19414](https://github.com/nodejs/node/pull/19414)

#### Semver-patch

* \[[`655ab65a90`](https://github.com/nodejs/node/commit/655ab65a90)] - **assert**: validate the block return type (Ruben Bridgewater) [#19886](https://github.com/nodejs/node/pull/19886)
* \[[`e9a33da58c`](https://github.com/nodejs/node/commit/e9a33da58c)] - **assert**: fix actual & expected input (Ruben Bridgewater) [#19925](https://github.com/nodejs/node/pull/19925)
* \[[`9c06770443`](https://github.com/nodejs/node/commit/9c06770443)] - **assert**: lazy load acorn (Ruben Bridgewater) [#19863](https://github.com/nodejs/node/pull/19863)
* \[[`252eb2deb2`](https://github.com/nodejs/node/commit/252eb2deb2)] - **assert**: fix error message (Ruben Bridgewater) [#19865](https://github.com/nodejs/node/pull/19865)
* \[[`fdb35d8960`](https://github.com/nodejs/node/commit/fdb35d8960)] - **assert**: ensure .rejects() disallows sync throws (Teddy Katz) [#19650](https://github.com/nodejs/node/pull/19650)
* \[[`2e6dd93aaa`](https://github.com/nodejs/node/commit/2e6dd93aaa)] - **assert**: fix diff color output (Ruben Bridgewater) [#19464](https://github.com/nodejs/node/pull/19464)
* \[[`a1c96f8e07`](https://github.com/nodejs/node/commit/a1c96f8e07)] - **assert**: improve assert.throws (Ruben Bridgewater) [#19463](https://github.com/nodejs/node/pull/19463)
* \[[`5d6d1fedcf`](https://github.com/nodejs/node/commit/5d6d1fedcf)] - **assert**: add warning about `assert.doesNotReject` (Ruben Bridgewater) [#19462](https://github.com/nodejs/node/pull/19462)
* \[[`3c61b87e59`](https://github.com/nodejs/node/commit/3c61b87e59)] - **assert**: improve assert()/assert.ok() performance (Brian White) [#19292](https://github.com/nodejs/node/pull/19292)
* \[[`a27f48d619`](https://github.com/nodejs/node/commit/a27f48d619)] - **assert**: fix generatedMessage (Ruben Bridgewater) [#18322](https://github.com/nodejs/node/pull/18322)
* \[[`3e910fb8f7`](https://github.com/nodejs/node/commit/3e910fb8f7)] - **assert**: do not read Node.js modules (Ruben Bridgewater) [#18322](https://github.com/nodejs/node/pull/18322)
* \[[`8c46fa6903`](https://github.com/nodejs/node/commit/8c46fa6903)] - **async\_hooks**: remove async\_wrap from async\_hooks.js (Daniel Bevenius) [#19368](https://github.com/nodejs/node/pull/19368)
* \[[`e9ac80bb39`](https://github.com/nodejs/node/commit/e9ac80bb39)] - **async\_hooks**: clean up usage in internal code (Anatoli Papirovski) [#18720](https://github.com/nodejs/node/pull/18720)
* \[[`4d074343dd`](https://github.com/nodejs/node/commit/4d074343dd)] - **async\_hooks,process**: remove internalNextTick (Anatoli Papirovski) [#19147](https://github.com/nodejs/node/pull/19147)
* \[[`abc87862ff`](https://github.com/nodejs/node/commit/abc87862ff)] - **async\_wrap**: fix use-after-free for inspector session (Anna Henningsen) [#19381](https://github.com/nodejs/node/pull/19381)
* \[[`f572927147`](https://github.com/nodejs/node/commit/f572927147)] - **benchmark**: do not multiply n by 1e6 in arrays (Anatoli Papirovski) [#20125](https://github.com/nodejs/node/pull/20125)
* \[[`b80da63b99`](https://github.com/nodejs/node/commit/b80da63b99)] - **benchmark**: changed millions and thousands to n (juggernaut451) [#18917](https://github.com/nodejs/node/pull/18917)
* \[[`e136903700`](https://github.com/nodejs/node/commit/e136903700)] - **benchmark**: remove excessive value from http2 benchmark (Anna Henningsen) [#18936](https://github.com/nodejs/node/pull/18936)
* \[[`d7994764fa`](https://github.com/nodejs/node/commit/d7994764fa)] - **buffer**: fix deprecation warning emit (Anatoli Papirovski) [#20163](https://github.com/nodejs/node/pull/20163)
* \[[`cdacafc8bb`](https://github.com/nodejs/node/commit/cdacafc8bb)] - **buffer**: use a default offset (Ruben Bridgewater) [#19749](https://github.com/nodejs/node/pull/19749)
* \[[`d6ce4ecb57`](https://github.com/nodejs/node/commit/d6ce4ecb57)] - **buffer**: do not emit deprecation notice on Buffer.of (Timothy Gu) [#19682](https://github.com/nodejs/node/pull/19682)
* \[[`daef2e7fd7`](https://github.com/nodejs/node/commit/daef2e7fd7)] - **buffer**: removed unneeded FastBuffer constructor (Timothy Gu) [#19684](https://github.com/nodejs/node/pull/19684)
* \[[`e5f8924064`](https://github.com/nodejs/node/commit/e5f8924064)] - **buffer**: reduce overhead of StringBytes::Encode for UCS2 (Joyee Cheung) [#19798](https://github.com/nodejs/node/pull/19798)
* \[[`3d61e14704`](https://github.com/nodejs/node/commit/3d61e14704)] - **buffer**: shorten deprecation warning (Rich Trott) [#19741](https://github.com/nodejs/node/pull/19741)
* \[[`f4e5f969ba`](https://github.com/nodejs/node/commit/f4e5f969ba)] - **buffer**: improve write(U)Int functions (Ruben Bridgewater) [#19289](https://github.com/nodejs/node/pull/19289)
* \[[`b935e63710`](https://github.com/nodejs/node/commit/b935e63710)] - **build**: limit assembler version check on x86 (Shigeki Ohtsu) [#20226](https://github.com/nodejs/node/pull/20226)
* \[[`adc3e8ad87`](https://github.com/nodejs/node/commit/adc3e8ad87)] - **build**: require --openssl-no-asm if old assembler (Rod Vagg) [#20226](https://github.com/nodejs/node/pull/20226)
* \[[`160d2d5a9a`](https://github.com/nodejs/node/commit/160d2d5a9a)] - **build**: extract error() function in configure (Rod Vagg) [#20226](https://github.com/nodejs/node/pull/20226)
* \[[`a4cba2d7a4`](https://github.com/nodejs/node/commit/a4cba2d7a4)] - **build**: normalise test.py calls to use PARALLEL\_ARGS (Chris Miller) [#20124](https://github.com/nodejs/node/pull/20124)
* \[[`f421fb33a7`](https://github.com/nodejs/node/commit/f421fb33a7)] - **build**: check without\_ssl in warn openssl\_no\_asm (Daniel Bevenius) [#19934](https://github.com/nodejs/node/pull/19934)
* \[[`8170f4f463`](https://github.com/nodejs/node/commit/8170f4f463)] - **build**: add support for IBM i platform (Jesse Gorzinski) [#19667](https://github.com/nodejs/node/pull/19667)
* \[[`a972ed4d50`](https://github.com/nodejs/node/commit/a972ed4d50)] - **build**: allow vcbuild to merely build addon tests (Gabriel Schulhof) [#19637](https://github.com/nodejs/node/pull/19637)
* \[[`c5928ab631`](https://github.com/nodejs/node/commit/c5928ab631)] - **build**: make lint-ci work properly on Linux make (Rod Vagg) [#19746](https://github.com/nodejs/node/pull/19746)
* \[[`c6ae8a2810`](https://github.com/nodejs/node/commit/c6ae8a2810)] - **build**: disable V8 untrusted code mitigations (Michaël Zasso) [#19222](https://github.com/nodejs/node/pull/19222)
* \[[`f05eaa4a53`](https://github.com/nodejs/node/commit/f05eaa4a53)] - **build**: lint .eslintrc.js file (Rich Trott) [#19122](https://github.com/nodejs/node/pull/19122)
* \[[`b13233aa39`](https://github.com/nodejs/node/commit/b13233aa39)] - **build**: remove support for VS2015 (Nikolai Vavilov) [#16969](https://github.com/nodejs/node/pull/16969)
* \[[`cd4766d1d3`](https://github.com/nodejs/node/commit/cd4766d1d3)] - **build, win**: opt-in openssl\_no\_asm if no nasm found (Shigeki Ohtsu) [#19943](https://github.com/nodejs/node/pull/19943)
* \[[`57bd27eda8`](https://github.com/nodejs/node/commit/57bd27eda8)] - _**Revert**_ "**build,test**: make building addon tests less fragile" (Rod Vagg) [#18287](https://github.com/nodejs/node/pull/18287)
* \[[`d9b59def72`](https://github.com/nodejs/node/commit/d9b59def72)] - **build,test**: make building addon tests less fragile (Ben Noordhuis) [#17407](https://github.com/nodejs/node/pull/17407)
* \[[`d5d024d6ec`](https://github.com/nodejs/node/commit/d5d024d6ec)] - _**Revert**_ "**build,tools**: check freshness of doc addons" (Rod Vagg) [#18287](https://github.com/nodejs/node/pull/18287)
* \[[`2cb9e2a6f7`](https://github.com/nodejs/node/commit/2cb9e2a6f7)] - **build,tools**: check freshness of doc addons (Ben Noordhuis) [#17407](https://github.com/nodejs/node/pull/17407)
* \[[`53035b142b`](https://github.com/nodejs/node/commit/53035b142b)] - **build,windows**: make vcbuild fail if upload fails (Refael Ackermann)
* \[[`4f68133568`](https://github.com/nodejs/node/commit/4f68133568)] - **console**: fix class inheritance regression (Anatoli Papirovski) [#20158](https://github.com/nodejs/node/pull/20158)
* \[[`f274e6921f`](https://github.com/nodejs/node/commit/f274e6921f)] - **crypto**: fix explanation in CipherBase::SetAuthTag (Tobias Nießen) [#20197](https://github.com/nodejs/node/pull/20197)
* \[[`2ac6658296`](https://github.com/nodejs/node/commit/2ac6658296)] - **crypto,doc**: fix unassignd deprecation codes (James M Snell) [#18492](https://github.com/nodejs/node/pull/18492)
* \[[`ffd57cd7b2`](https://github.com/nodejs/node/commit/ffd57cd7b2)] - **deps**: upgrade to libuv 1.20.2 (cjihrig) [#20129](https://github.com/nodejs/node/pull/20129)
* \[[`60eb95ad7d`](https://github.com/nodejs/node/commit/60eb95ad7d)] - **deps**: bump V8 embedder string (Myles Borins) [#20105](https://github.com/nodejs/node/pull/20105)
* \[[`1f01112b6f`](https://github.com/nodejs/node/commit/1f01112b6f)] - **deps**: patch V8 to 6.6.346.24 (Myles Borins) [#19995](https://github.com/nodejs/node/pull/19995)
* \[[`aa5ae9e91d`](https://github.com/nodejs/node/commit/aa5ae9e91d)] - **deps**: c-ares float, win ipv6 bad fec0 prefix (Rod Vagg) [#19939](https://github.com/nodejs/node/pull/19939)
* \[[`dbc6163977`](https://github.com/nodejs/node/commit/dbc6163977)] - **deps**: c-ares float, manual ares\_ssize\_t definition (Rod Vagg) [#19939](https://github.com/nodejs/node/pull/19939)
* \[[`b82f905a8b`](https://github.com/nodejs/node/commit/b82f905a8b)] - **deps**: upgrade to c-ares v1.14.0 (Rod Vagg) [#19939](https://github.com/nodejs/node/pull/19939)
* \[[`b6aec1d00a`](https://github.com/nodejs/node/commit/b6aec1d00a)] - **deps**: cherry-pick b767cde1e7 from upstream V8 (Ben Noordhuis) [#19980](https://github.com/nodejs/node/pull/19980)
* \[[`a6db6404ff`](https://github.com/nodejs/node/commit/a6db6404ff)] - **deps**: cherry-pick b767cde1e7 from upstream V8 (Ben Noordhuis) [#19710](https://github.com/nodejs/node/pull/19710)
* \[[`e37effe4ce`](https://github.com/nodejs/node/commit/e37effe4ce)] - _**Revert**_ "**deps**: upgrade npm to 5.8.0" (Anna Henningsen) [#19837](https://github.com/nodejs/node/pull/19837)
* \[[`026f6b787a`](https://github.com/nodejs/node/commit/026f6b787a)] - _**Revert**_ "**deps**: manually add 10.x support to npm" (Anna Henningsen) [#19837](https://github.com/nodejs/node/pull/19837)
* \[[`55557babca`](https://github.com/nodejs/node/commit/55557babca)] - **deps**: manually add 10.x support to npm (Myles Borins) [#17777](https://github.com/nodejs/node/pull/17777)
* \[[`ae2b5bcb7c`](https://github.com/nodejs/node/commit/ae2b5bcb7c)] - **deps**: upgrade libuv to 1.20.0 (cjihrig) [#19758](https://github.com/nodejs/node/pull/19758)
* \[[`b22a189b43`](https://github.com/nodejs/node/commit/b22a189b43)] - **deps**: fix typo in openssl upgrading doc (Daniel Bevenius) [#19789](https://github.com/nodejs/node/pull/19789)
* \[[`b3f23910a2`](https://github.com/nodejs/node/commit/b3f23910a2)] - **deps**: patch V8 to 6.5.254.43 (Myles Borins) [#19615](https://github.com/nodejs/node/pull/19615)
* \[[`41193bcf2f`](https://github.com/nodejs/node/commit/41193bcf2f)] - **deps**: patch V8 to 6.5.254.41 (Myles Borins) [#19432](https://github.com/nodejs/node/pull/19432)
* \[[`9c9324768f`](https://github.com/nodejs/node/commit/9c9324768f)] - **deps**: patch V8 to 6.5.254.40 (Myles Borins) [#19380](https://github.com/nodejs/node/pull/19380)
* \[[`cac4da05ad`](https://github.com/nodejs/node/commit/cac4da05ad)] - **deps**: allow disabling V8 untrusted code mitigations (Michaël Zasso) [#19222](https://github.com/nodejs/node/pull/19222)
* \[[`040dd244de`](https://github.com/nodejs/node/commit/040dd244de)] - **deps**: patch V8 to 6.5.254.38 (Myles Borins) [#19303](https://github.com/nodejs/node/pull/19303)
* \[[`13cb056e4c`](https://github.com/nodejs/node/commit/13cb056e4c)] - **deps**: cherry-pick 46c4979e86 from upstream v8 (Ben Noordhuis) [#18920](https://github.com/nodejs/node/pull/18920)
* \[[`81232320aa`](https://github.com/nodejs/node/commit/81232320aa)] - **deps**: patch V8 to 6.4.388.46 (Myles Borins) [#18827](https://github.com/nodejs/node/pull/18827)
* \[[`36386dc4e3`](https://github.com/nodejs/node/commit/36386dc4e3)] - **deps**: patch V8 to 6.4.388.45 (Myles Borins) [#18751](https://github.com/nodejs/node/pull/18751)
* \[[`b6000d8285`](https://github.com/nodejs/node/commit/b6000d8285)] - **deps**: patch V8 to 6.4.388.44 (Myles Borins) [#18687](https://github.com/nodejs/node/pull/18687)
* \[[`d0e4d4e0a1`](https://github.com/nodejs/node/commit/d0e4d4e0a1)] - **deps**: patch V8 to 6.4.388.42 (Myles Borins) [#18578](https://github.com/nodejs/node/pull/18578)
* \[[`1f7648272e`](https://github.com/nodejs/node/commit/1f7648272e)] - **deps**: patch V8 to 6.4.388.41 (Myles Borins) [#18522](https://github.com/nodejs/node/pull/18522)
* \[[`70277d6170`](https://github.com/nodejs/node/commit/70277d6170)] - **deps**: V8: resolve remaining whitespace diff (Myles Borins) [#18366](https://github.com/nodejs/node/pull/18366)
* \[[`cbd634947d`](https://github.com/nodejs/node/commit/cbd634947d)] - **deps**: manually add 10.x support to npm (Myles Borins) [#17777](https://github.com/nodejs/node/pull/17777)
* \[[`d3b1c971bc`](https://github.com/nodejs/node/commit/d3b1c971bc)] - **deps**: upgrade npm to 5.6.0 (Kat Marchán) [#17777](https://github.com/nodejs/node/pull/17777)
* \[[`b5d415311b`](https://github.com/nodejs/node/commit/b5d415311b)] - **deps**: patch V8 to 6.3.292.48 (Myles Borins) [#17773](https://github.com/nodejs/node/pull/17773)
* \[[`e01a210c7f`](https://github.com/nodejs/node/commit/e01a210c7f)] - **deps**: cherry-pick 37a3a15c3 from V8 upstream (Franziska Hinkelmann) [#16294](https://github.com/nodejs/node/pull/16294)
* \[[`e38570fe56`](https://github.com/nodejs/node/commit/e38570fe56)] - **deps**: import acorn\@5.2.1 (Timothy Gu) [#15566](https://github.com/nodejs/node/pull/15566)
* \[[`4c6a47f7d7`](https://github.com/nodejs/node/commit/4c6a47f7d7)] - **doc**: add parameters for Http2Session:error event (Ujjwal Sharma) [#20206](https://github.com/nodejs/node/pull/20206)
* \[[`b7d1e19e30`](https://github.com/nodejs/node/commit/b7d1e19e30)] - **doc**: update trace events categories description (Beni von Cheni) [#20092](https://github.com/nodejs/node/pull/20092)
* \[[`4125a9f8de`](https://github.com/nodejs/node/commit/4125a9f8de)] - **doc**: fix incorrect net listen signature (Anatoli Papirovski) [#20209](https://github.com/nodejs/node/pull/20209)
* \[[`8ff73aa82d`](https://github.com/nodejs/node/commit/8ff73aa82d)] - **doc**: modify net.Server.listen arg list (musgravejw) [#20142](https://github.com/nodejs/node/pull/20142)
* \[[`a4975cab41`](https://github.com/nodejs/node/commit/a4975cab41)] - **doc**: detail CI sub-tasks rerunning (Vse Mozhet Byt) [#20200](https://github.com/nodejs/node/pull/20200)
* \[[`3d7605561f`](https://github.com/nodejs/node/commit/3d7605561f)] - **doc**: remove "For example" expression in N-API doc (Gabriel Schulhof) [#20187](https://github.com/nodejs/node/pull/20187)
* \[[`0d56982e56`](https://github.com/nodejs/node/commit/0d56982e56)] - **doc**: fix a typo in console documentation (Mykola Bilochub) [#20176](https://github.com/nodejs/node/pull/20176)
* \[[`9214d64760`](https://github.com/nodejs/node/commit/9214d64760)] - **doc**: Uint8Array support in Buffer functions (SheetJS) [#19949](https://github.com/nodejs/node/pull/19949)
* \[[`9495d9477b`](https://github.com/nodejs/node/commit/9495d9477b)] - **doc**: wrap buffer.md at 80 characters (Rich Trott) [#19546](https://github.com/nodejs/node/pull/19546)
* \[[`6e05a96125`](https://github.com/nodejs/node/commit/6e05a96125)] - **doc**: add flags section to document all flags (Indranil Dasgupta) [#20042](https://github.com/nodejs/node/pull/20042)
* \[[`0b7e626fed`](https://github.com/nodejs/node/commit/0b7e626fed)] - **doc**: fix inconsistency in documentation for building (Spencer Greene) [#20091](https://github.com/nodejs/node/pull/20091)
* \[[`193d808c25`](https://github.com/nodejs/node/commit/193d808c25)] - **doc**: improve buf.write() text in buffer.md (Rich Trott) [#20115](https://github.com/nodejs/node/pull/20115)
* \[[`9566603f35`](https://github.com/nodejs/node/commit/9566603f35)] - **doc**: add hiding comments note to contributor guide (Vse Mozhet Byt) [#20149](https://github.com/nodejs/node/pull/20149)
* \[[`5c1580c99d`](https://github.com/nodejs/node/commit/5c1580c99d)] - **doc**: add myself to list of TSC members (Timothy Gu) [#20132](https://github.com/nodejs/node/pull/20132)
* \[[`56d6e82b0a`](https://github.com/nodejs/node/commit/56d6e82b0a)] - **doc**: fully document --experimental-repl-await (Timothy Gu) [#20133](https://github.com/nodejs/node/pull/20133)
* \[[`c31f0d0ba2`](https://github.com/nodejs/node/commit/c31f0d0ba2)] - **doc**: fix misplaced entries in test/common doc (Rich Trott) [#20117](https://github.com/nodejs/node/pull/20117)
* \[[`c798adcc1c`](https://github.com/nodejs/node/commit/c798adcc1c)] - **doc**: move mikeal to Collaborator Emeriti list (Rich Trott) [#20113](https://github.com/nodejs/node/pull/20113)
* \[[`793bf211d7`](https://github.com/nodejs/node/commit/793bf211d7)] - **doc**: adjust slightly awkward wording in buffer.md (Rich Trott) [#20037](https://github.com/nodejs/node/pull/20037)
* \[[`efda6fbce6`](https://github.com/nodejs/node/commit/efda6fbce6)] - **doc**: update links and names for DevTools Protocol (Vse Mozhet Byt) [#20111](https://github.com/nodejs/node/pull/20111)
* \[[`ed45a8b0cc`](https://github.com/nodejs/node/commit/ed45a8b0cc)] - **doc**: prevent one more false-positive linkification (Vse Mozhet Byt) [#20087](https://github.com/nodejs/node/pull/20087)
* \[[`b6fa3ae41e`](https://github.com/nodejs/node/commit/b6fa3ae41e)] - **doc**: fix suspicious heading emphasis in n-api.md (Vse Mozhet Byt) [#20086](https://github.com/nodejs/node/pull/20086)
* \[[`0a99cb1a3d`](https://github.com/nodejs/node/commit/0a99cb1a3d)] - **doc**: add ryzokuken to collaborators (Ujjwal Sharma) [#20081](https://github.com/nodejs/node/pull/20081)
* \[[`fc0ddaa114`](https://github.com/nodejs/node/commit/fc0ddaa114)] - **doc**: fix two sorting nits in fs.md (Vse Mozhet Byt) [#20078](https://github.com/nodejs/node/pull/20078)
* \[[`eca96f57fd`](https://github.com/nodejs/node/commit/eca96f57fd)] - **doc**: add tools/doc/README link in doc/STYLE\_GUIDE (Vse Mozhet Byt) [#20071](https://github.com/nodejs/node/pull/20071)
* \[[`27e6fd3983`](https://github.com/nodejs/node/commit/27e6fd3983)] - **doc**: unify and compact some fragments in fs.md (Vse Mozhet Byt) [#20050](https://github.com/nodejs/node/pull/20050)
* \[[`a93a0ec9cf`](https://github.com/nodejs/node/commit/a93a0ec9cf)] - **doc**: update tools/doc/README.md (Vse Mozhet Byt) [#20047](https://github.com/nodejs/node/pull/20047)
* \[[`ae327d6d1e`](https://github.com/nodejs/node/commit/ae327d6d1e)] - **doc**: unify more headings (Vse Mozhet Byt) [#20046](https://github.com/nodejs/node/pull/20046)
* \[[`6d1c3e5ffc`](https://github.com/nodejs/node/commit/6d1c3e5ffc)] - **doc**: clarify url doc (James M Snell) [#19899](https://github.com/nodejs/node/pull/19899)
* \[[`faf563e6a1`](https://github.com/nodejs/node/commit/faf563e6a1)] - **doc**: unify format of iterables (Vse Mozhet Byt) [#20036](https://github.com/nodejs/node/pull/20036)
* \[[`5008c5a273`](https://github.com/nodejs/node/commit/5008c5a273)] - **doc**: improved flow for macOS firewall script (Joseph Gordon) [#18689](https://github.com/nodejs/node/pull/18689)
* \[[`7248171e4c`](https://github.com/nodejs/node/commit/7248171e4c)] - **doc**: unify section structures (Vse Mozhet Byt) [#20028](https://github.com/nodejs/node/pull/20028)
* \[[`98008dc6a0`](https://github.com/nodejs/node/commit/98008dc6a0)] - **doc**: close event does not take arguments (Indranil Dasgupta) [#20031](https://github.com/nodejs/node/pull/20031)
* \[[`b806b04688`](https://github.com/nodejs/node/commit/b806b04688)] - **doc**: include error code in buffer documentation (Rich Trott) [#19982](https://github.com/nodejs/node/pull/19982)
* \[[`846f4e1c9f`](https://github.com/nodejs/node/commit/846f4e1c9f)] - **doc**: add missing type=misc top comments (Vse Mozhet Byt) [#20022](https://github.com/nodejs/node/pull/20022)
* \[[`86c1f19a8c`](https://github.com/nodejs/node/commit/86c1f19a8c)] - **doc**: add missing YAML keyword in v8.md metadata (Vse Mozhet Byt) [#20023](https://github.com/nodejs/node/pull/20023)
* \[[`cb2e78aca3`](https://github.com/nodejs/node/commit/cb2e78aca3)] - **doc**: remove \_writableState reference (Anatoli Papirovski) [#20004](https://github.com/nodejs/node/pull/20004)
* \[[`e635723157`](https://github.com/nodejs/node/commit/e635723157)] - **doc**: add net socket write signature (Gurin, Sebastian) [#19967](https://github.com/nodejs/node/pull/19967)
* \[[`ba438fe592`](https://github.com/nodejs/node/commit/ba438fe592)] - **doc**: improve http.setHeader and getHeader typeinfo (Gerhard Stoebich) [#19902](https://github.com/nodejs/node/pull/19902)
* \[[`fbf9e0609b`](https://github.com/nodejs/node/commit/fbf9e0609b)] - **doc**: fix wrong response.end() at request.socket (ikasumiwt) [#19507](https://github.com/nodejs/node/pull/19507)
* \[[`15e8bdf95c`](https://github.com/nodejs/node/commit/15e8bdf95c)] - **doc**: fix typo in README (Tobias Nießen) [#20011](https://github.com/nodejs/node/pull/20011)
* \[[`0d1b77eeb2`](https://github.com/nodejs/node/commit/0d1b77eeb2)] - **doc**: mention CCM along with GCM in crypto APIs (Tobias Nießen) [#19945](https://github.com/nodejs/node/pull/19945)
* \[[`fc17e2dcb3`](https://github.com/nodejs/node/commit/fc17e2dcb3)] - **doc**: add pronouns for ofrobots (Ali Ijaz Sheikh) [#19992](https://github.com/nodejs/node/pull/19992)
* \[[`4d7bbe8ad2`](https://github.com/nodejs/node/commit/4d7bbe8ad2)] - **doc**: move trevnorris to TSC Emeritus (Trevor Norris) [#19985](https://github.com/nodejs/node/pull/19985)
* \[[`cdc1171af3`](https://github.com/nodejs/node/commit/cdc1171af3)] - **doc**: fix errors in sample code comments (Rich Trott) [#19963](https://github.com/nodejs/node/pull/19963)
* \[[`90fc496da4`](https://github.com/nodejs/node/commit/90fc496da4)] - **doc**: fix punctuation and wrapping in buffer.md (Rich Trott) [#19964](https://github.com/nodejs/node/pull/19964)
* \[[`c29f2f26c8`](https://github.com/nodejs/node/commit/c29f2f26c8)] - **doc**: added ready events to fs/streams,net/socket (Matei Copot) [#19968](https://github.com/nodejs/node/pull/19968)
* \[[`4766f51823`](https://github.com/nodejs/node/commit/4766f51823)] - **doc**: remove superfluous word from crypto doc (Tobias Nießen) [#19946](https://github.com/nodejs/node/pull/19946)
* \[[`105980f6e4`](https://github.com/nodejs/node/commit/105980f6e4)] - **doc**: fix parameter type format (Vse Mozhet Byt) [#19957](https://github.com/nodejs/node/pull/19957)
* \[[`a8533cf543`](https://github.com/nodejs/node/commit/a8533cf543)] - **doc**: add quotes for event names + fix similar nits (Vse Mozhet Byt) [#19915](https://github.com/nodejs/node/pull/19915)
* \[[`a60e4989cb`](https://github.com/nodejs/node/commit/a60e4989cb)] - **doc**: `vm.runIn*Context` can accept a string as options (Gerhard Stoebich) [#19910](https://github.com/nodejs/node/pull/19910)
* \[[`0a553d56b6`](https://github.com/nodejs/node/commit/0a553d56b6)] - **doc**: improve buf.lastIndexOf() text (Rich Trott) [#19904](https://github.com/nodejs/node/pull/19904)
* \[[`31b5ed49e0`](https://github.com/nodejs/node/commit/31b5ed49e0)] - **doc**: add and unify even more return values (Vse Mozhet Byt) [#19955](https://github.com/nodejs/node/pull/19955)
* \[[`0be14def2c`](https://github.com/nodejs/node/commit/0be14def2c)] - **doc**: replace unneeded snake cases (Vse Mozhet Byt) [#19951](https://github.com/nodejs/node/pull/19951)
* \[[`4c70616c7b`](https://github.com/nodejs/node/commit/4c70616c7b)] - **doc**: move evanlucas to TSC Emeritus (Evan Lucas) [#19953](https://github.com/nodejs/node/pull/19953)
* \[[`7d2814e790`](https://github.com/nodejs/node/commit/7d2814e790)] - **doc**: unify End-of-Life marker (Tobias Nießen) [#19942](https://github.com/nodejs/node/pull/19942)
* \[[`e590cfceed`](https://github.com/nodejs/node/commit/e590cfceed)] - **doc**: add missing backticks around code fragments. (Vse Mozhet Byt) [#19938](https://github.com/nodejs/node/pull/19938)
* \[[`645516cd43`](https://github.com/nodejs/node/commit/645516cd43)] - **doc**: add Http2Session.connecting property (Pieter Mees) [#19842](https://github.com/nodejs/node/pull/19842)
* \[[`5e6817261c`](https://github.com/nodejs/node/commit/5e6817261c)] - **doc**: prevent a false-positive linkification (Vse Mozhet Byt) [#19913](https://github.com/nodejs/node/pull/19913)
* \[[`87880466b1`](https://github.com/nodejs/node/commit/87880466b1)] - **doc**: fix about `decodeStrings` property of `stream.Writable` (Ryusei Yamaguchi) [#19752](https://github.com/nodejs/node/pull/19752)
* \[[`28e5c462d4`](https://github.com/nodejs/node/commit/28e5c462d4)] - **doc**: improve buf.indexOf() documentation style (Rich Trott) [#19861](https://github.com/nodejs/node/pull/19861)
* \[[`38c97f5dc7`](https://github.com/nodejs/node/commit/38c97f5dc7)] - **doc**: fix punctuation in doc/releases.md (erwinwahyura) [#19774](https://github.com/nodejs/node/pull/19774)
* \[[`51c2c51029`](https://github.com/nodejs/node/commit/51c2c51029)] - **doc**: explain edge case when assigning port to url (nodeav) [#19645](https://github.com/nodejs/node/pull/19645)
* \[[`99c77dc018`](https://github.com/nodejs/node/commit/99c77dc018)] - **doc**: improve CCM example (Tobias Nießen) [#19851](https://github.com/nodejs/node/pull/19851)
* \[[`dff214153f`](https://github.com/nodejs/node/commit/dff214153f)] - **doc**: specify definite Array types (Vse Mozhet Byt) [#19895](https://github.com/nodejs/node/pull/19895)
* \[[`321c178faa`](https://github.com/nodejs/node/commit/321c178faa)] - **doc**: add missing quotes in default string values (Vse Mozhet Byt) [#19894](https://github.com/nodejs/node/pull/19894)
* \[[`0cd8359652`](https://github.com/nodejs/node/commit/0cd8359652)] - **doc**: remove wrong default value in buffer.md (Vse Mozhet Byt) [#19883](https://github.com/nodejs/node/pull/19883)
* \[[`0bd3da15a0`](https://github.com/nodejs/node/commit/0bd3da15a0)] - **doc**: add and unify return statements in crypto.md (Vse Mozhet Byt) [#19853](https://github.com/nodejs/node/pull/19853)
* \[[`08a36a0666`](https://github.com/nodejs/node/commit/08a36a0666)] - **doc**: unify property sections (Vse Mozhet Byt) [#19869](https://github.com/nodejs/node/pull/19869)
* \[[`0a679327be`](https://github.com/nodejs/node/commit/0a679327be)] - **doc**: update language regarding key stretching (Ujjwal Sharma) [#19810](https://github.com/nodejs/node/pull/19810)
* \[[`0ac6ced2e9`](https://github.com/nodejs/node/commit/0ac6ced2e9)] - **doc**: fix some links (Vse Mozhet Byt) [#19860](https://github.com/nodejs/node/pull/19860)
* \[[`4545cc17b9`](https://github.com/nodejs/node/commit/4545cc17b9)] - **doc**: improve buf.fill() documentation (Rich Trott) [#19846](https://github.com/nodejs/node/pull/19846)
* \[[`0c55abf5d1`](https://github.com/nodejs/node/commit/0c55abf5d1)] - **doc**: added missing reference to test coverage info (Mithun Sasidharan) [#19825](https://github.com/nodejs/node/pull/19825)
* \[[`53aaa55a3a`](https://github.com/nodejs/node/commit/53aaa55a3a)] - **doc**: clarify lifecycle of domain sockets (Gireesh Punathil) [#19471](https://github.com/nodejs/node/pull/19471)
* \[[`dca09a77d5`](https://github.com/nodejs/node/commit/dca09a77d5)] - **doc**: update AUTHORS list (Michaël Zasso) [#19768](https://github.com/nodejs/node/pull/19768)
* \[[`617946779c`](https://github.com/nodejs/node/commit/617946779c)] - **doc**: improve prepositions in buffer.md (Rich Trott) [#19817](https://github.com/nodejs/node/pull/19817)
* \[[`3db0d62c68`](https://github.com/nodejs/node/commit/3db0d62c68)] - **doc**: reword poolSize explanation in buffer.md (Rich Trott) [#19785](https://github.com/nodejs/node/pull/19785)
* \[[`8b1db6df80`](https://github.com/nodejs/node/commit/8b1db6df80)] - **doc**: add instructions to update local git config (Trivikram Kamat) [#19777](https://github.com/nodejs/node/pull/19777)
* \[[`f02e4b90a2`](https://github.com/nodejs/node/commit/f02e4b90a2)] - **doc**: create list for commonly edited files in PRs (Trivikram Kamat) [#19776](https://github.com/nodejs/node/pull/19776)
* \[[`422ac61535`](https://github.com/nodejs/node/commit/422ac61535)] - **doc**: remove link to "breaking changes" wiki (Trivikram Kamat) [#19795](https://github.com/nodejs/node/pull/19795)
* \[[`acc328ef58`](https://github.com/nodejs/node/commit/acc328ef58)] - **doc**: move mafintosh to Collaborators (Rich Trott) [#19806](https://github.com/nodejs/node/pull/19806)
* \[[`3567ea034e`](https://github.com/nodejs/node/commit/3567ea034e)] - **doc**: fix added value for `assert` module (Ruben Bridgewater) [#19724](https://github.com/nodejs/node/pull/19724)
* \[[`5bdd6a7b9e`](https://github.com/nodejs/node/commit/5bdd6a7b9e)] - **doc**: properly document AssertionError (Ruben Bridgewater) [#19724](https://github.com/nodejs/node/pull/19724)
* \[[`9125479be9`](https://github.com/nodejs/node/commit/9125479be9)] - **doc**: add `http2` to performanceEntry.entryType (Yuta Hiroto) [#19584](https://github.com/nodejs/node/pull/19584)
* \[[`54fbbb1037`](https://github.com/nodejs/node/commit/54fbbb1037)] - **doc**: add metadata for vm code generation options (TomCoded) [#19440](https://github.com/nodejs/node/pull/19440)
* \[[`d1720bddf4`](https://github.com/nodejs/node/commit/d1720bddf4)] - **doc**: fix linting issue in process.md (Vse Mozhet Byt) [#19542](https://github.com/nodejs/node/pull/19542)
* \[[`3662934b5a`](https://github.com/nodejs/node/commit/3662934b5a)] - **doc**: fix paragraph order in stream.md (Vse Mozhet Byt) [#19501](https://github.com/nodejs/node/pull/19501)
* \[[`45c86e33e1`](https://github.com/nodejs/node/commit/45c86e33e1)] - **doc**: add note to readable stream async iterator (Ivan Filenko) [#19331](https://github.com/nodejs/node/pull/19331)
* \[[`9a70b27254`](https://github.com/nodejs/node/commit/9a70b27254)] - **doc**: fix punctuation issue in async\_hooks.md (Rich Trott) [#19364](https://github.com/nodejs/node/pull/19364)
* \[[`8d336dd8b1`](https://github.com/nodejs/node/commit/8d336dd8b1)] - **doc**: improve text in async\_hooks.md (Rich Trott) [#19312](https://github.com/nodejs/node/pull/19312)
* \[[`a2c0fcc0d8`](https://github.com/nodejs/node/commit/a2c0fcc0d8)] - **doc**: add returned values and options to stream.md (Ivan Filenko) [#19361](https://github.com/nodejs/node/pull/19361)
* \[[`603afe25c8`](https://github.com/nodejs/node/commit/603afe25c8)] - **doc**: fix some recent nits in assert.md (Vse Mozhet Byt) [#19284](https://github.com/nodejs/node/pull/19284)
* \[[`0eec0735d0`](https://github.com/nodejs/node/commit/0eec0735d0)] - **doc**: update internal errors documentation (Michaël Zasso) [#19203](https://github.com/nodejs/node/pull/19203)
* \[[`1a5ec837ca`](https://github.com/nodejs/node/commit/1a5ec837ca)] - **doc**: fix max length on stream.md (Matteo Collina) [#19169](https://github.com/nodejs/node/pull/19169)
* \[[`35c7238bb7`](https://github.com/nodejs/node/commit/35c7238bb7)] - **doc**: replace to Node.js (Yuta Hiroto) [#19056](https://github.com/nodejs/node/pull/19056)
* \[[`e6b823d84a`](https://github.com/nodejs/node/commit/e6b823d84a)] - **doc**: remove redundant `the` (Leko) [#19008](https://github.com/nodejs/node/pull/19008)
* \[[`a29089d7c8`](https://github.com/nodejs/node/commit/a29089d7c8)] - **doc**: add new documentation lint rule (estrada9166) [#18726](https://github.com/nodejs/node/pull/18726)
* \[[`1bd32087ee`](https://github.com/nodejs/node/commit/1bd32087ee)] - **doc**: fix deprecation number (Ruben Bridgewater) [#18818](https://github.com/nodejs/node/pull/18818)
* \[[`80ac941407`](https://github.com/nodejs/node/commit/80ac941407)] - **doc**: make linter happy (Anna Henningsen) [#18769](https://github.com/nodejs/node/pull/18769)
* \[[`dbd1d1d43f`](https://github.com/nodejs/node/commit/dbd1d1d43f)] - **doc**: fix arg definition in fs (Anatoli Papirovski) [#18678](https://github.com/nodejs/node/pull/18678)
* \[[`ac829f0135`](https://github.com/nodejs/node/commit/ac829f0135)] - **doc**: add missing URL types in fs promise API (Vse Mozhet Byt) [#18599](https://github.com/nodejs/node/pull/18599)
* \[[`05e702d9f1`](https://github.com/nodejs/node/commit/05e702d9f1)] - **doc**: fix `REPLACEME` in changelog PR URLs (Anna Henningsen) [#18561](https://github.com/nodejs/node/pull/18561)
* \[[`359a232348`](https://github.com/nodejs/node/commit/359a232348)] - **doc**: fix typo in esm.md (Rich Trott) [#18142](https://github.com/nodejs/node/pull/18142)
* \[[`6c76de13c5`](https://github.com/nodejs/node/commit/6c76de13c5)] - **doc**: add missing link references (Vse Mozhet Byt) [#18222](https://github.com/nodejs/node/pull/18222)
* \[[`4d1baf82ae`](https://github.com/nodejs/node/commit/4d1baf82ae)] - **doc**: fix links in errors.md (Vse Mozhet Byt) [#17829](https://github.com/nodejs/node/pull/17829)
* \[[`3b9803838c`](https://github.com/nodejs/node/commit/3b9803838c)] - **doc**: clarify util.inspect usage intent (Gus Caplan) [#17375](https://github.com/nodejs/node/pull/17375)
* \[[`70f23ec9c0`](https://github.com/nodejs/node/commit/70f23ec9c0)] - **doc**: fix typo in Buffer.prototype.fill() (cjihrig) [#17501](https://github.com/nodejs/node/pull/17501)
* \[[`c60c93cba2`](https://github.com/nodejs/node/commit/c60c93cba2)] - **doc, http2**: add sections for server.close() (Chris Miller) [#19802](https://github.com/nodejs/node/pull/19802)
* \[[`04491db1d3`](https://github.com/nodejs/node/commit/04491db1d3)] - **doc, src**: sort + fill up cli options and env vars (willhayslett) [#19878](https://github.com/nodejs/node/pull/19878)
* \[[`f600e95ff0`](https://github.com/nodejs/node/commit/f600e95ff0)] - **doc, tools**: make type parsing more strict (Vse Mozhet Byt) [#19881](https://github.com/nodejs/node/pull/19881)
* \[[`82a7347050`](https://github.com/nodejs/node/commit/82a7347050)] - **doc,assert,timers**: assign deprecation codes (Anna Henningsen) [#18564](https://github.com/nodejs/node/pull/18564)
* \[[`0799b60f50`](https://github.com/nodejs/node/commit/0799b60f50)] - **doc,http2**: add parameters for Http2Session:connect event (Ujjwal Sharma) [#20193](https://github.com/nodejs/node/pull/20193)
* \[[`237cbe10fb`](https://github.com/nodejs/node/commit/237cbe10fb)] - **doc,tools**: formalize, unify, codify default values (Vse Mozhet Byt) [#19737](https://github.com/nodejs/node/pull/19737)
* \[[`cf46ca76ff`](https://github.com/nodejs/node/commit/cf46ca76ff)] - **domain**: converted anonymous to named function (Daven Casia) [#20021](https://github.com/nodejs/node/pull/20021)
* \[[`f086354d3b`](https://github.com/nodejs/node/commit/f086354d3b)] - **errors**: alter ERR\_HTTP2\_PSEUDOHEADER\_NOT\_ALLOWED (davidmarkclements) [#19958](https://github.com/nodejs/node/pull/19958)
* \[[`b6fbe16b41`](https://github.com/nodejs/node/commit/b6fbe16b41)] - **errors**: alter ERR\_HTTP2\_INVALID\_CONNECTION\_HEADERS (davidmarkclements) [#19807](https://github.com/nodejs/node/pull/19807)
* \[[`2a3a66afb3`](https://github.com/nodejs/node/commit/2a3a66afb3)] - **errors**: pass missing `message` parameter to `internalAssert` (Ayush Gupta) [#19908](https://github.com/nodejs/node/pull/19908)
* \[[`ef07d6570f`](https://github.com/nodejs/node/commit/ef07d6570f)] - **errors**: change ERR\_HTTP2\_HEADER\_SINGLE\_VALUE to TypeError (davidmarkclements) [#19805](https://github.com/nodejs/node/pull/19805)
* \[[`add1c02bda`](https://github.com/nodejs/node/commit/add1c02bda)] - **errors**: alter ERR\_HTTP2\_INVALID\_PSEUDOHEADER (davidmarkclements) [#19808](https://github.com/nodejs/node/pull/19808)
* \[[`f8b3774d85`](https://github.com/nodejs/node/commit/f8b3774d85)] - **errors**: fix typo in internal/errors.js (davidmarkclements) [#19800](https://github.com/nodejs/node/pull/19800)
* \[[`22da2f731d`](https://github.com/nodejs/node/commit/22da2f731d)] - **errors**: make message non-enumerable (Ruben Bridgewater) [#19719](https://github.com/nodejs/node/pull/19719)
* \[[`95bae85809`](https://github.com/nodejs/node/commit/95bae85809)] - **errors**: simplify sysError (Ruben Bridgewater) [#18857](https://github.com/nodejs/node/pull/18857)
* \[[`65e62e5665`](https://github.com/nodejs/node/commit/65e62e5665)] - **fs**: return stats to JS in sync methods (Joyee Cheung) [#20167](https://github.com/nodejs/node/pull/20167)
* \[[`e3579a007f`](https://github.com/nodejs/node/commit/e3579a007f)] - **fs**: handle long files reading in fs.promises (Antoine du HAMEL) [#19643](https://github.com/nodejs/node/pull/19643)
* \[[`d7b162cfa0`](https://github.com/nodejs/node/commit/d7b162cfa0)] - **fs**: complete error message for validate function (buji) [#19909](https://github.com/nodejs/node/pull/19909)
* \[[`6e2d5af0e4`](https://github.com/nodejs/node/commit/6e2d5af0e4)] - **fs**: fix missing 'error' event in (Read|Write)Stream#destroy (Kohei Hiraga) [#19735](https://github.com/nodejs/node/pull/19735)
* \[[`38a692963f`](https://github.com/nodejs/node/commit/38a692963f)] - **fs**: make ReadStream throw TypeError on NaN (Ujjwal Sharma) [#19775](https://github.com/nodejs/node/pull/19775)
* \[[`f7049a2006`](https://github.com/nodejs/node/commit/f7049a2006)] - **fs**: refactor stats array to be more generic (Joyee Cheung) [#19714](https://github.com/nodejs/node/pull/19714)
* \[[`e06ad5faf9`](https://github.com/nodejs/node/commit/e06ad5faf9)] - **fs**: use encoding in readFile (Benjamin Gruenbaum) [#19296](https://github.com/nodejs/node/pull/19296)
* \[[`897cec43c6`](https://github.com/nodejs/node/commit/897cec43c6)] - **fs**: fix memory leak in WriteString (Joyee Cheung) [#19357](https://github.com/nodejs/node/pull/19357)
* \[[`f96bd54dd5`](https://github.com/nodejs/node/commit/f96bd54dd5)] - **fs**: simplify FSReqBase slightly (Anna Henningsen) [#19174](https://github.com/nodejs/node/pull/19174)
* \[[`523d44a66e`](https://github.com/nodejs/node/commit/523d44a66e)] - **fs**: replace duplicate conditions by function (Sergey Golovin) [#18717](https://github.com/nodejs/node/pull/18717)
* \[[`96b2d8d3dc`](https://github.com/nodejs/node/commit/96b2d8d3dc)] - **fs**: check for symlink support in fs-promises test (Seth Brenith) [#19018](https://github.com/nodejs/node/pull/19018)
* \[[`12412ef43f`](https://github.com/nodejs/node/commit/12412ef43f)] - **fs**: fix potential segfault in async calls (Joyee Cheung) [#18811](https://github.com/nodejs/node/pull/18811)
* \[[`513d939720`](https://github.com/nodejs/node/commit/513d939720)] - **fs**: move fs.promises API to fs/promises (Michaël Zasso) [#18777](https://github.com/nodejs/node/pull/18777)
* \[[`2620358624`](https://github.com/nodejs/node/commit/2620358624)] - **fs**: move utility functions to internal/fs (Michaël Zasso) [#18777](https://github.com/nodejs/node/pull/18777)
* \[[`3e1e450f92`](https://github.com/nodejs/node/commit/3e1e450f92)] - **fs**: use Persistent::Reset() for resetting handles (Anna Henningsen) [#18650](https://github.com/nodejs/node/pull/18650)
* \[[`28dc56dc71`](https://github.com/nodejs/node/commit/28dc56dc71)] - **fs**: fix typo in promises.lchmod & lchown (Sho Miyamoto) [#18783](https://github.com/nodejs/node/pull/18783)
* \[[`b2e20b002b`](https://github.com/nodejs/node/commit/b2e20b002b)] - **fs**: extract binding error handling into a helper (Joyee Cheung) [#18642](https://github.com/nodejs/node/pull/18642)
* \[[`b1c6ecb2c6`](https://github.com/nodejs/node/commit/b1c6ecb2c6)] - **fs**: fix misplaced errors in fs.symlinkSync (Joyee Cheung) [#18548](https://github.com/nodejs/node/pull/18548)
* \[[`030384833f`](https://github.com/nodejs/node/commit/030384833f)] - **fs**: do not call new when creating uvException (Joyee Cheung) [#18546](https://github.com/nodejs/node/pull/18546)
* \[[`d09d87821d`](https://github.com/nodejs/node/commit/d09d87821d)] - **fs**: use AliasedBuffer for fs\_stats\_field\_array (Joyee Cheung) [#18276](https://github.com/nodejs/node/pull/18276)
* \[[`4b9ba9b833`](https://github.com/nodejs/node/commit/4b9ba9b833)] - **fs**: encapsulate FSReqWrap more (James M Snell) [#18112](https://github.com/nodejs/node/pull/18112)
* \[[`eca73a2f82`](https://github.com/nodejs/node/commit/eca73a2f82)] - **fs**: migrate ASYNC\_CALL to AsyncCall (Joyee Cheung) [#18144](https://github.com/nodejs/node/pull/18144)
* \[[`8aec3638ce`](https://github.com/nodejs/node/commit/8aec3638ce)] - **fs**: extract out validateUint32 and validateLen functions (Jon Moss) [#17682](https://github.com/nodejs/node/pull/17682)
* \[[`46e1d69bd1`](https://github.com/nodejs/node/commit/46e1d69bd1)] - **fs**: extract out validatePath function (Jon Moss) [#17682](https://github.com/nodejs/node/pull/17682)
* \[[`300ea7396f`](https://github.com/nodejs/node/commit/300ea7396f)] - **fs**: extract out validateOffsetLengthWrite function (Jon Moss) [#17682](https://github.com/nodejs/node/pull/17682)
* \[[`8983405508`](https://github.com/nodejs/node/commit/8983405508)] - **fs**: extract out validateBuffer function (Jon Moss) [#17682](https://github.com/nodejs/node/pull/17682)
* \[[`fc8c1b1ded`](https://github.com/nodejs/node/commit/fc8c1b1ded)] - **fs**: extract out validateOffsetLengthRead function (Jon Moss) [#17682](https://github.com/nodejs/node/pull/17682)
* \[[`b9b8294dda`](https://github.com/nodejs/node/commit/b9b8294dda)] - **fs**: extract out validateFd function (Jon Moss) [#17682](https://github.com/nodejs/node/pull/17682)
* \[[`9f122e3b55`](https://github.com/nodejs/node/commit/9f122e3b55)] - **fs**: throw fs.close errors in JS (Joyee Cheung) [#17338](https://github.com/nodejs/node/pull/17338)
* \[[`6ca10de946`](https://github.com/nodejs/node/commit/6ca10de946)] - **fs**: simplify the error context collection in C++ (Joyee Cheung) [#17338](https://github.com/nodejs/node/pull/17338)
* \[[`14ad0bd6a0`](https://github.com/nodejs/node/commit/14ad0bd6a0)] - **fs**: remove unused macro (James M Snell) [#17689](https://github.com/nodejs/node/pull/17689)
* \[[`c0d6327dcf`](https://github.com/nodejs/node/commit/c0d6327dcf)] - **fs**: refactor After for easier maintainability (James M Snell) [#17689](https://github.com/nodejs/node/pull/17689)
* \[[`2ca227f642`](https://github.com/nodejs/node/commit/2ca227f642)] - **fs**: refactor FSReqWrap and After (James M Snell) [#17689](https://github.com/nodejs/node/pull/17689)
* \[[`49275c450a`](https://github.com/nodejs/node/commit/49275c450a)] - **http**: remove duplicate parser unset (Anatoli Papirovski) [#20126](https://github.com/nodejs/node/pull/20126)
* \[[`cda94b2bb8`](https://github.com/nodejs/node/commit/cda94b2bb8)] - **http**: cleanup parser properties (Anatoli Papirovski) [#20126](https://github.com/nodejs/node/pull/20126)
* \[[`ea60148c16`](https://github.com/nodejs/node/commit/ea60148c16)] - **http**: remove duplicate comment (Anatoli Papirovski) [#20126](https://github.com/nodejs/node/pull/20126)
* \[[`6886dd1a6c`](https://github.com/nodejs/node/commit/6886dd1a6c)] - **http**: cleanup \_http\_common.js (Anatoli Papirovski) [#20126](https://github.com/nodejs/node/pull/20126)
* \[[`28834542c8`](https://github.com/nodejs/node/commit/28834542c8)] - **http**: simplify connection: close search (Anatoli Papirovski) [#20131](https://github.com/nodejs/node/pull/20131)
* \[[`4fe1b60c5d`](https://github.com/nodejs/node/commit/4fe1b60c5d)] - **http**: use switch in matchHeader (Anatoli Papirovski) [#20131](https://github.com/nodejs/node/pull/20131)
* \[[`c449eb5e8a`](https://github.com/nodejs/node/commit/c449eb5e8a)] - **http**: simplify isCookieField (Anatoli Papirovski) [#20131](https://github.com/nodejs/node/pull/20131)
* \[[`299da1f503`](https://github.com/nodejs/node/commit/299da1f503)] - **http**: fix \_dump regression (Anatoli Papirovski) [#20088](https://github.com/nodejs/node/pull/20088)
* \[[`54a2e933c2`](https://github.com/nodejs/node/commit/54a2e933c2)] - **http**: fix undefined error in parser event (Anatoli Papirovski) [#20029](https://github.com/nodejs/node/pull/20029)
* \[[`1ac1424476`](https://github.com/nodejs/node/commit/1ac1424476)] - **http**: align parser with StreamBase interface changes (Anna Henningsen) [#18936](https://github.com/nodejs/node/pull/18936)
* \[[`648d668fcc`](https://github.com/nodejs/node/commit/648d668fcc)] - **http**: emit timeout duration overflow warning sync (Anna Henningsen) [#18906](https://github.com/nodejs/node/pull/18906)
* \[[`f94eec0218`](https://github.com/nodejs/node/commit/f94eec0218)] - **http**: convert utcDate to use setTimeout (Jeremiah Senkpiel) [#17800](https://github.com/nodejs/node/pull/17800)
* \[[`2ecdb6d54f`](https://github.com/nodejs/node/commit/2ecdb6d54f)] - **http2**: refactor how trailers are done (James M Snell) [#19959](https://github.com/nodejs/node/pull/19959)
* \[[`a890864d79`](https://github.com/nodejs/node/commit/a890864d79)] - **http2**: fix ping duration calculation (James M Snell) [#19956](https://github.com/nodejs/node/pull/19956)
* \[[`db307bd628`](https://github.com/nodejs/node/commit/db307bd628)] - **http2**: emit session connect on next tick (Pieter Mees) [#19842](https://github.com/nodejs/node/pull/19842)
* \[[`cef909797a`](https://github.com/nodejs/node/commit/cef909797a)] - **http2**: do not emit our own close emit in Http2Stream (James M Snell) [#19451](https://github.com/nodejs/node/pull/19451)
* \[[`12b9ec09b0`](https://github.com/nodejs/node/commit/12b9ec09b0)] - **http2**: remove regular-file-only restriction (Anna Henningsen) [#18936](https://github.com/nodejs/node/pull/18936)
* \[[`1eb6b01fca`](https://github.com/nodejs/node/commit/1eb6b01fca)] - **http2**: use native pipe instead of synchronous I/O (Anna Henningsen) [#18936](https://github.com/nodejs/node/pull/18936)
* \[[`0812ebda88`](https://github.com/nodejs/node/commit/0812ebda88)] - **http2**: fix kUpdateTimer timer refresh (Jeremiah Senkpiel) [#18062](https://github.com/nodejs/node/pull/18062)
* \[[`4a96a5041b`](https://github.com/nodejs/node/commit/4a96a5041b)] - **inspector**: migrate node to js\_protocol.pdl (Alexey Kozyatinskiy) [#20141](https://github.com/nodejs/node/pull/20141)
* \[[`e8ea61be41`](https://github.com/nodejs/node/commit/e8ea61be41)] - **lib**: remove unnecessary assignment of exports (Daniel Bevenius) [#20143](https://github.com/nodejs/node/pull/20143)
* \[[`881fca418c`](https://github.com/nodejs/node/commit/881fca418c)] - **lib**: remove unused binding const (Daniel Bevenius) [#20144](https://github.com/nodejs/node/pull/20144)
* \[[`c64632ea3b`](https://github.com/nodejs/node/commit/c64632ea3b)] - **lib**: remove duplicate require calls in tls.js (Daniel Bevenius) [#20099](https://github.com/nodejs/node/pull/20099)
* \[[`beaa7bb671`](https://github.com/nodejs/node/commit/beaa7bb671)] - **lib**: make c, ca and certs const in \_tls\_common (Daniel Bevenius) [#20073](https://github.com/nodejs/node/pull/20073)
* \[[`6348ec869f`](https://github.com/nodejs/node/commit/6348ec869f)] - **lib**: use object destructuring tls.js (Daniel Bevenius) [#20070](https://github.com/nodejs/node/pull/20070)
* \[[`445a89f6a9`](https://github.com/nodejs/node/commit/445a89f6a9)] - **lib**: fix coverage reporting (Anna Henningsen) [#20035](https://github.com/nodejs/node/pull/20035)
* \[[`e88cd882f5`](https://github.com/nodejs/node/commit/e88cd882f5)] - **lib**: move Pipe/TCPConnectWrap to obj destructuring (Daniel Bevenius) [#19611](https://github.com/nodejs/node/pull/19611)
* \[[`f2b10799ef`](https://github.com/nodejs/node/commit/f2b10799ef)] - **lib**: rename js source to lower snake\_case (Daniel Bevenius) [#19556](https://github.com/nodejs/node/pull/19556)
* \[[`c2835e5e47`](https://github.com/nodejs/node/commit/c2835e5e47)] - **lib**: merge stream code for http2 streams & net.Socket (Ashok) [#19527](https://github.com/nodejs/node/pull/19527)
* \[[`49963f4da9`](https://github.com/nodejs/node/commit/49963f4da9)] - **lib**: remove unused internal error constructors (Michaël Zasso) [#19203](https://github.com/nodejs/node/pull/19203)
* \[[`42258d7e54`](https://github.com/nodejs/node/commit/42258d7e54)] - **lib**: include missing profiler file (cjihrig) [#18455](https://github.com/nodejs/node/pull/18455)
* \[[`916cfeca77`](https://github.com/nodejs/node/commit/916cfeca77)] - **lib,src**: audit process.env in lib/ for setuid binary (Jose M. Palacios Diaz) [#18511](https://github.com/nodejs/node/pull/18511)
* \[[`742ae6141c`](https://github.com/nodejs/node/commit/742ae6141c)] - **lib,src**: port isIPv4() to js (Ben Noordhuis) [#18398](https://github.com/nodejs/node/pull/18398)
* \[[`6934792eb3`](https://github.com/nodejs/node/commit/6934792eb3)] - **lint**: move eslint to new plugin system (Gus Caplan) [#18566](https://github.com/nodejs/node/pull/18566)
* \[[`d591a59ac1`](https://github.com/nodejs/node/commit/d591a59ac1)] - **meta**: document commit msg exception for long URLs (Vse Mozhet Byt) [#20207](https://github.com/nodejs/node/pull/20207)
* \[[`b34a1e1785`](https://github.com/nodejs/node/commit/b34a1e1785)] - **module**: fix `e.stack` error when throwing undefined or null (Zhenzhen Zhan) [#19282](https://github.com/nodejs/node/pull/19282)
* \[[`070a82e82c`](https://github.com/nodejs/node/commit/070a82e82c)] - **module**: replace "magic" numbers by constants (Sergey Golovin) [#18869](https://github.com/nodejs/node/pull/18869)
* \[[`c86fe511f4`](https://github.com/nodejs/node/commit/c86fe511f4)] - **module**: replace magic numbers by constants (Sergey Golovin) [#18785](https://github.com/nodejs/node/pull/18785)
* \[[`3b9cc424a4`](https://github.com/nodejs/node/commit/3b9cc424a4)] - **module**: remove unused code in module.js (Rich Trott) [#18768](https://github.com/nodejs/node/pull/18768)
* \[[`c529168249`](https://github.com/nodejs/node/commit/c529168249)] - **n-api**: add more `int64_t` tests (Kyle Farnung) [#19402](https://github.com/nodejs/node/pull/19402)
* \[[`a342cd693c`](https://github.com/nodejs/node/commit/a342cd693c)] - **net**: honor default values in Socket constructor (Santiago Gimeno) [#19971](https://github.com/nodejs/node/pull/19971)
* \[[`923fb5cc18`](https://github.com/nodejs/node/commit/923fb5cc18)] - **net**: track bytesWritten in C++ land (Anna Henningsen) [#19551](https://github.com/nodejs/node/pull/19551)
* \[[`7c73cd4c70`](https://github.com/nodejs/node/commit/7c73cd4c70)] - **net**: emit error on invalid address family (cjihrig) [#19415](https://github.com/nodejs/node/pull/19415)
* \[[`67b5985c08`](https://github.com/nodejs/node/commit/67b5985c08)] - **net**: fix usage of writeBuffer in makeSyncWrite (Joyee Cheung) [#19103](https://github.com/nodejs/node/pull/19103)
* \[[`03ddd13d8a`](https://github.com/nodejs/node/commit/03ddd13d8a)] - **net**: use `_final` instead of `on('finish')` (Anna Henningsen) [#18608](https://github.com/nodejs/node/pull/18608)
* \[[`e85c20b511`](https://github.com/nodejs/node/commit/e85c20b511)] - **net,http2**: merge write error handling & property names (Anna Henningsen) [#19734](https://github.com/nodejs/node/pull/19734)
* \[[`496d6023e0`](https://github.com/nodejs/node/commit/496d6023e0)] - **net,stream**: remove DuplexBase (Luigi Pinca) [#19779](https://github.com/nodejs/node/pull/19779)
* \[[`2ec6995555`](https://github.com/nodejs/node/commit/2ec6995555)] - **perf\_hooks**: simplify perf\_hooks (James M Snell) [#19563](https://github.com/nodejs/node/pull/19563)
* \[[`1f356a26ae`](https://github.com/nodejs/node/commit/1f356a26ae)] - **perf\_hooks,trace\_events**: fix timescale on bootstrap marks (James M Snell) [#19450](https://github.com/nodejs/node/pull/19450)
* \[[`96cb4fb795`](https://github.com/nodejs/node/commit/96cb4fb795)] - **perf\_hooks,trace\_events**: emit perf milestone trace events (James M Snell) [#19175](https://github.com/nodejs/node/pull/19175)
* \[[`fccff2702e`](https://github.com/nodejs/node/commit/fccff2702e)] - _**Revert**_ "**process**: add version constants and compare" (Rod Vagg) [#20062](https://github.com/nodejs/node/pull/20062)
* \[[`eeb1b9dcb7`](https://github.com/nodejs/node/commit/eeb1b9dcb7)] - _**Revert**_ "**process**: add more version properties to release" (Tobias Nießen) [#19577](https://github.com/nodejs/node/pull/19577)
* \[[`f2396ee60c`](https://github.com/nodejs/node/commit/f2396ee60c)] - **repl**: hide top-level await feature behind a flag (Timothy Gu) [#19604](https://github.com/nodejs/node/pull/19604)
* \[[`1fc373bdf6`](https://github.com/nodejs/node/commit/1fc373bdf6)] - _**Revert**_ "**repl**: refactor tests to not rely on timing" (Ruben Bridgewater) [#18715](https://github.com/nodejs/node/pull/18715)
* \[[`de848ac1e0`](https://github.com/nodejs/node/commit/de848ac1e0)] - **repl**: refactor tests to not rely on timing (Bradley Farias) [#17828](https://github.com/nodejs/node/pull/17828)
* \[[`727339e9c2`](https://github.com/nodejs/node/commit/727339e9c2)] - **repl**: fix util.inspect() coloring regression (Ben Noordhuis) [#17565](https://github.com/nodejs/node/pull/17565)
* \[[`eeab7bc068`](https://github.com/nodejs/node/commit/eeab7bc068)] - **repl**: support top-level await (Timothy Gu) [#15566](https://github.com/nodejs/node/pull/15566)
* \[[`ab64b6d799`](https://github.com/nodejs/node/commit/ab64b6d799)] - **repl**: add async and await as keywords (Timothy Gu) [#15566](https://github.com/nodejs/node/pull/15566)
* \[[`cff6e69057`](https://github.com/nodejs/node/commit/cff6e69057)] - **repl**: add an internal "paused" mode (Timothy Gu) [#15566](https://github.com/nodejs/node/pull/15566)
* \[[`69495436e2`](https://github.com/nodejs/node/commit/69495436e2)] - **src**: cover extra load-via-special-symbol scenario (Gabriel Schulhof) [#20186](https://github.com/nodejs/node/pull/20186)
* \[[`51164dd6ad`](https://github.com/nodejs/node/commit/51164dd6ad)] - **src**: CancelTerminateExecution before throwing errors (Joyee Cheung) [#20146](https://github.com/nodejs/node/pull/20146)
* \[[`80c46c1576`](https://github.com/nodejs/node/commit/80c46c1576)] - **src**: remove `MarkIndependent()` calls (Anna Henningsen) [#20108](https://github.com/nodejs/node/pull/20108)
* \[[`1aa74cc2e5`](https://github.com/nodejs/node/commit/1aa74cc2e5)] - **src**: move v8::HandleScope call to Emit (Ujjwal Sharma) [#20045](https://github.com/nodejs/node/pull/20045)
* \[[`8e969b6a77`](https://github.com/nodejs/node/commit/8e969b6a77)] - **src**: remove req\_wrap-inl.h from stream\_base.h (Daniel Bevenius) [#20063](https://github.com/nodejs/node/pull/20063)
* \[[`1396996b02`](https://github.com/nodejs/node/commit/1396996b02)] - **src**: use v8:: namepace consistently in node\_file (Daniel Bevenius) [#20059](https://github.com/nodejs/node/pull/20059)
* \[[`2d40895797`](https://github.com/nodejs/node/commit/2d40895797)] - **src**: add sync trace to fs (Chin Huang) [#19649](https://github.com/nodejs/node/pull/19649)
* \[[`80de8302e0`](https://github.com/nodejs/node/commit/80de8302e0)] - **src**: add HandleScope to fix error (Ujjwal Sharma) [#19972](https://github.com/nodejs/node/pull/19972)
* \[[`17deb5fe85`](https://github.com/nodejs/node/commit/17deb5fe85)] - **src**: add node\_internal.h includes for arraysize (Daniel Bevenius) [#19916](https://github.com/nodejs/node/pull/19916)
* \[[`f3e107aeef`](https://github.com/nodejs/node/commit/f3e107aeef)] - **src**: add punctuation in --inspector doc url message (Nick Filatov) [#19871](https://github.com/nodejs/node/pull/19871)
* \[[`362694401f`](https://github.com/nodejs/node/commit/362694401f)] - **src**: rename ERR\_STRING\_TOO\_LARGE to ERR\_STRING\_TOO\_LONG (Joyee Cheung) [#19864](https://github.com/nodejs/node/pull/19864)
* \[[`3650972bfb`](https://github.com/nodejs/node/commit/3650972bfb)] - **src**: remove unused util.h from tls\_wrap.h (Daniel Bevenius) [#19849](https://github.com/nodejs/node/pull/19849)
* \[[`ed86cc570e`](https://github.com/nodejs/node/commit/ed86cc570e)] - **src**: rename req\_wrap with -async/-sync suffix (Daniel Bevenius) [#19628](https://github.com/nodejs/node/pull/19628)
* \[[`b7cfd278a5`](https://github.com/nodejs/node/commit/b7cfd278a5)] - **src**: clean up `req.bytes` tracking (Anna Henningsen) [#19551](https://github.com/nodejs/node/pull/19551)
* \[[`852ba3a0f9`](https://github.com/nodejs/node/commit/852ba3a0f9)] - **src**: sort ENVIRONMENT\_STRONG\_PERSISTENT\_PROPERTIES (Daniel Bevenius) [#19627](https://github.com/nodejs/node/pull/19627)
* \[[`376f949510`](https://github.com/nodejs/node/commit/376f949510)] - **src**: rename fs\_req\_wrap -> FSReqWrapSync (Daniel Bevenius) [#19614](https://github.com/nodejs/node/pull/19614)
* \[[`2d94f77fd3`](https://github.com/nodejs/node/commit/2d94f77fd3)] - **src**: ensure that `SetImmediate()`s have `HandleScope`s (Anna Henningsen) [#19470](https://github.com/nodejs/node/pull/19470)
* \[[`e8c2917b44`](https://github.com/nodejs/node/commit/e8c2917b44)] - **src**: simplify http2 perf tracking code (Anna Henningsen) [#19470](https://github.com/nodejs/node/pull/19470)
* \[[`a1a409a8ca`](https://github.com/nodejs/node/commit/a1a409a8ca)] - **src**: simplify Environment::HandleCleanup (Joyee Cheung) [#19319](https://github.com/nodejs/node/pull/19319)
* \[[`855dabd675`](https://github.com/nodejs/node/commit/855dabd675)] - **src**: call CleanupHandles in FreeEnvironment (Joyee Cheung) [#19319](https://github.com/nodejs/node/pull/19319)
* \[[`d93c48bf61`](https://github.com/nodejs/node/commit/d93c48bf61)] - **src**: use ObjectTemplate for creating stream req objs (Anna Henningsen) [#18936](https://github.com/nodejs/node/pull/18936)
* \[[`67f1d76956`](https://github.com/nodejs/node/commit/67f1d76956)] - **src**: introduce native-layer stream piping (Anna Henningsen) [#18936](https://github.com/nodejs/node/pull/18936)
* \[[`f7f1437d44`](https://github.com/nodejs/node/commit/f7f1437d44)] - **src**: add helper for before/after scope without JS calls (Anna Henningsen) [#18936](https://github.com/nodejs/node/pull/18936)
* \[[`f734b3eb04`](https://github.com/nodejs/node/commit/f734b3eb04)] - **src**: give StreamBases the capability to ask for data (Anna Henningsen) [#18936](https://github.com/nodejs/node/pull/18936)
* \[[`c412150582`](https://github.com/nodejs/node/commit/c412150582)] - **src**: make `FileHandle` a (readonly) `StreamBase` (Anna Henningsen) [#18936](https://github.com/nodejs/node/pull/18936)
* \[[`8695273948`](https://github.com/nodejs/node/commit/8695273948)] - **src**: tighten handle scopes for stream operations (Anna Henningsen) [#18936](https://github.com/nodejs/node/pull/18936)
* \[[`a7e298a4a2`](https://github.com/nodejs/node/commit/a7e298a4a2)] - **src**: init emit\_env\_nonstring\_warning\_ (Daniel Bevenius) [#19283](https://github.com/nodejs/node/pull/19283)
* \[[`e0bd2f31e5`](https://github.com/nodejs/node/commit/e0bd2f31e5)] - **src**: move `Environment` ctor/dtor into env.cc (Anna Henningsen) [#19202](https://github.com/nodejs/node/pull/19202)
* \[[`1dd9c9787b`](https://github.com/nodejs/node/commit/1dd9c9787b)] - **src**: add tracing category macros (James M Snell) [#19155](https://github.com/nodejs/node/pull/19155)
* \[[`50b1cb39bd`](https://github.com/nodejs/node/commit/50b1cb39bd)] - **src**: fix deprecation id for non-string env value (Sakthipriyan Vairamani (thefourtheye)) [#19209](https://github.com/nodejs/node/pull/19209)
* \[[`c9b4de55c0`](https://github.com/nodejs/node/commit/c9b4de55c0)] - **src**: standardise context embedder indices (Gus Caplan) [#19135](https://github.com/nodejs/node/pull/19135)
* \[[`ca79fc5373`](https://github.com/nodejs/node/commit/ca79fc5373)] - **src**: replace var for (let|const) in utilities module (jvelezpo) [#18814](https://github.com/nodejs/node/pull/18814)
* \[[`197258bda7`](https://github.com/nodejs/node/commit/197258bda7)] - **src**: changing node\_file's usage of v8::Resolver (Jimmy Thomson) [#18765](https://github.com/nodejs/node/pull/18765)
* \[[`42c14c5c17`](https://github.com/nodejs/node/commit/42c14c5c17)] - **src**: set thread local env in CreateEnvironment (Daniel Bevenius) [#18573](https://github.com/nodejs/node/pull/18573)
* \[[`a16081cbad`](https://github.com/nodejs/node/commit/a16081cbad)] - **src**: use non-deprecated V8 microtasks API (Michaël Zasso) [#18753](https://github.com/nodejs/node/pull/18753)
* \[[`d8ec49ed9d`](https://github.com/nodejs/node/commit/d8ec49ed9d)] - **src**: update trace event macros to v8 6.4 version (Kelvin Jin) [#17640](https://github.com/nodejs/node/pull/17640)
* \[[`28708677d9`](https://github.com/nodejs/node/commit/28708677d9)] - **src**: resolve issues reported by coverity (cjihrig) [#18629](https://github.com/nodejs/node/pull/18629)
* \[[`8ccd320549`](https://github.com/nodejs/node/commit/8ccd320549)] - **src**: don't abort when package.json is a directory (Ben Noordhuis) [#18270](https://github.com/nodejs/node/pull/18270)
* \[[`1573e4563a`](https://github.com/nodejs/node/commit/1573e4563a)] - **src**: move GetNow to Environment (Anatoli Papirovski) [#18562](https://github.com/nodejs/node/pull/18562)
* \[[`b2b9d11a14`](https://github.com/nodejs/node/commit/b2b9d11a14)] - **src**: fix fs.write() externalized string handling (Ben Noordhuis) [#18216](https://github.com/nodejs/node/pull/18216)
* \[[`e1c29f2c52`](https://github.com/nodejs/node/commit/e1c29f2c52)] - **src**: clean up argument assertions in node\_file.cc (Joyee Cheung) [#18192](https://github.com/nodejs/node/pull/18192)
* \[[`5f6478759b`](https://github.com/nodejs/node/commit/5f6478759b)] - **src**: fix -Wunused-but-set-variable warnings (Ben Noordhuis) [#18205](https://github.com/nodejs/node/pull/18205)
* \[[`c8ac188e3f`](https://github.com/nodejs/node/commit/c8ac188e3f)] - **src**: remove unused function (cjihrig) [#17671](https://github.com/nodejs/node/pull/17671)
* \[[`02bad59f00`](https://github.com/nodejs/node/commit/02bad59f00)] - **src**: fix -Wunused-result warning (Ben Noordhuis) [#16726](https://github.com/nodejs/node/pull/16726)
* \[[`088bba31a3`](https://github.com/nodejs/node/commit/088bba31a3)] - _**Revert**_ "**src, tools**: add debug symbols for node internals" (Ben Noordhuis) [#17272](https://github.com/nodejs/node/pull/17272)
* \[[`9e1a6f8cb1`](https://github.com/nodejs/node/commit/9e1a6f8cb1)] - **src,lib**: implement import.meta (Michaël Zasso) [#18368](https://github.com/nodejs/node/pull/18368)
* \[[`22819aa998`](https://github.com/nodejs/node/commit/22819aa998)] - **stream**: prevent 'end' to be emitted after 'error' (Matteo Collina) [#20104](https://github.com/nodejs/node/pull/20104)
* \[[`3c1ad38e64`](https://github.com/nodejs/node/commit/3c1ad38e64)] - **stream**: fix incorrect comment in \_stream\_readable.js (Snehil Verma) [#19882](https://github.com/nodejs/node/pull/19882)
* \[[`a7c25b7d42`](https://github.com/nodejs/node/commit/a7c25b7d42)] - **stream**: always emit error before close (Mathias Buus) [#19836](https://github.com/nodejs/node/pull/19836)
* \[[`d37e59fa6a`](https://github.com/nodejs/node/commit/d37e59fa6a)] - **stream**: fix backpressure when multiple sync (Matteo Collina) [#19613](https://github.com/nodejs/node/pull/19613)
* \[[`d111d7b91c`](https://github.com/nodejs/node/commit/d111d7b91c)] - **stream**: give error message if `write()` cb called twice (Anna Henningsen) [#19510](https://github.com/nodejs/node/pull/19510)
* \[[`86c659ba61`](https://github.com/nodejs/node/commit/86c659ba61)] - **stream**: add a test case for the underlying cause. (陈刚) [#18575](https://github.com/nodejs/node/pull/18575)
* \[[`87b9bceacb`](https://github.com/nodejs/node/commit/87b9bceacb)] - **stream**: always defer readable in EOF when sync (Matteo Collina) [#18615](https://github.com/nodejs/node/pull/18615)
* \[[`e7cb694a60`](https://github.com/nodejs/node/commit/e7cb694a60)] - **stream**: always reset awaitDrain when emitting data (Anna Henningsen) [#18516](https://github.com/nodejs/node/pull/18516)
* \[[`563fff2938`](https://github.com/nodejs/node/commit/563fff2938)] - **stream**: defer readable and flow when sync (Mathias Buus) [#18515](https://github.com/nodejs/node/pull/18515)
* \[[`ccf64e5f22`](https://github.com/nodejs/node/commit/ccf64e5f22)] - **stream**: augment BufferList.prototype (Luigi Pinca) [#18353](https://github.com/nodejs/node/pull/18353)
* \[[`0778f79cb3`](https://github.com/nodejs/node/commit/0778f79cb3)] - **stream**: do not emit readable if the stream ended (Mathias Buus) [#18372](https://github.com/nodejs/node/pull/18372)
* \[[`e782715d0a`](https://github.com/nodejs/node/commit/e782715d0a)] - **string\_decoder**: fix regressions (Anatoli Papirovski) [#18723](https://github.com/nodejs/node/pull/18723)
* \[[`180af17b52`](https://github.com/nodejs/node/commit/180af17b52)] - **string\_decoder**: reimplement in C++ (Anna Henningsen) [#18537](https://github.com/nodejs/node/pull/18537)
* \[[`0ddc06098d`](https://github.com/nodejs/node/commit/0ddc06098d)] - **test**: improve http res write and end dont take array (Ilya Sotov) [#20199](https://github.com/nodejs/node/pull/20199)
* \[[`d7ff4f0750`](https://github.com/nodejs/node/commit/d7ff4f0750)] - **test**: fix test when NODE\_OPTIONS env var is set to --trace-warnings (Ashok) [#20027](https://github.com/nodejs/node/pull/20027)
* \[[`c322fca2ad`](https://github.com/nodejs/node/commit/c322fca2ad)] - **test**: improve common.expectsError (Ruben Bridgewater) [#19797](https://github.com/nodejs/node/pull/19797)
* \[[`bb3ead8ba6`](https://github.com/nodejs/node/commit/bb3ead8ba6)] - **test**: update non-string header names should throw (Dhansuhu Uzumaki) [#20172](https://github.com/nodejs/node/pull/20172)
* \[[`2fd7284add`](https://github.com/nodejs/node/commit/2fd7284add)] - **test**: add test for loading read-only modules (Bill Ticehurst) [#20138](https://github.com/nodejs/node/pull/20138)
* \[[`bc6965bdd2`](https://github.com/nodejs/node/commit/bc6965bdd2)] - **test**: fix arg names in benchmark string\_decoder (Anatoli Papirovski) [#20125](https://github.com/nodejs/node/pull/20125)
* \[[`6c90aee0b5`](https://github.com/nodejs/node/commit/6c90aee0b5)] - **test**: reduce duration in misc benchmark (Anatoli Papirovski) [#20125](https://github.com/nodejs/node/pull/20125)
* \[[`26a0a4659d`](https://github.com/nodejs/node/commit/26a0a4659d)] - **test**: fix missing param in url benchmark (Anatoli Papirovski) [#20125](https://github.com/nodejs/node/pull/20125)
* \[[`77dc257f67`](https://github.com/nodejs/node/commit/77dc257f67)] - **test**: use correct arg name in domains benchmark (Anatoli Papirovski) [#20125](https://github.com/nodejs/node/pull/20125)
* \[[`8c3e672543`](https://github.com/nodejs/node/commit/8c3e672543)] - **test**: use correct arg name in assert benchmark (Anatoli Papirovski) [#20125](https://github.com/nodejs/node/pull/20125)
* \[[`6278c4b268`](https://github.com/nodejs/node/commit/6278c4b268)] - **test**: fix long-running http benchmarks (Anatoli Papirovski) [#20125](https://github.com/nodejs/node/pull/20125)
* \[[`c61db33865`](https://github.com/nodejs/node/commit/c61db33865)] - **test**: fix long-running buffer benchmarks (Anatoli Papirovski) [#20125](https://github.com/nodejs/node/pull/20125)
* \[[`f4a559b240`](https://github.com/nodejs/node/commit/f4a559b240)] - **test**: add strictEqual method to assert (Christine E. Taylor) [#20189](https://github.com/nodejs/node/pull/20189)
* \[[`b4e86f12f8`](https://github.com/nodejs/node/commit/b4e86f12f8)] - **test**: resolve process.setgid() error on Ubuntu (Divyanshu Singh) [#19755](https://github.com/nodejs/node/pull/19755)
* \[[`18f41dda90`](https://github.com/nodejs/node/commit/18f41dda90)] - **test**: remove message from strictEqual assertions (Bryan Azofeifa) [#20174](https://github.com/nodejs/node/pull/20174)
* \[[`82c52b5841`](https://github.com/nodejs/node/commit/82c52b5841)] - **test**: fix test-child-process-send-returns-boolean (Rich Trott) [#20136](https://github.com/nodejs/node/pull/20136)
* \[[`392ed93bf0`](https://github.com/nodejs/node/commit/392ed93bf0)] - **test**: fix flaky http-server-keep-alive-timeout (Santiago Gimeno) [#20093](https://github.com/nodejs/node/pull/20093)
* \[[`bed57ef2be`](https://github.com/nodejs/node/commit/bed57ef2be)] - **test**: removes string literals from test-domain-timer.js (Palash Nigam) [#20120](https://github.com/nodejs/node/pull/20120)
* \[[`1fab8b44c3`](https://github.com/nodejs/node/commit/1fab8b44c3)] - **test**: remove message from strictEqual assertions (isurusiri) [#20067](https://github.com/nodejs/node/pull/20067)
* \[[`77f3c1f8f7`](https://github.com/nodejs/node/commit/77f3c1f8f7)] - **test**: fix http-agent-destroyed-socket cb not firing (Anatoli Papirovski) [#20006](https://github.com/nodejs/node/pull/20006)
* \[[`8a0b994de3`](https://github.com/nodejs/node/commit/8a0b994de3)] - **test**: remove expectations based on v8 headers from types test (Gus Caplan) [#20003](https://github.com/nodejs/node/pull/20003)
* \[[`eb0cfaf88e`](https://github.com/nodejs/node/commit/eb0cfaf88e)] - **test**: remove test case 0 from tls-cnnic-whitelist (Daniel Bevenius) [#19767](https://github.com/nodejs/node/pull/19767)
* \[[`0ffd79b60c`](https://github.com/nodejs/node/commit/0ffd79b60c)] - **test**: set clientOpts.port property (Daniel Bevenius) [#19767](https://github.com/nodejs/node/pull/19767)
* \[[`43ed1eedd5`](https://github.com/nodejs/node/commit/43ed1eedd5)] - **test**: update keys/Makefile to clean and build all (Daniel Bevenius) [#19975](https://github.com/nodejs/node/pull/19975)
* \[[`65bd225f13`](https://github.com/nodejs/node/commit/65bd225f13)] - **test**: fix warning in dlopen-ping-pong/binding.cc (Daniel Bevenius) [#19966](https://github.com/nodejs/node/pull/19966)
* \[[`974d07dca5`](https://github.com/nodejs/node/commit/974d07dca5)] - **test**: fixed flaky test-http-readable-data-event (Matteo Collina) [#19931](https://github.com/nodejs/node/pull/19931)
* \[[`fde5a6b65a`](https://github.com/nodejs/node/commit/fde5a6b65a)] - **test**: fix test-http-dump-req-when-res-ends (Luigi Pinca) [#19866](https://github.com/nodejs/node/pull/19866)
* \[[`e14585fa27`](https://github.com/nodejs/node/commit/e14585fa27)] - **test**: move require('http2') after crypto check (Daniel Bevenius) [#19907](https://github.com/nodejs/node/pull/19907)
* \[[`4162115326`](https://github.com/nodejs/node/commit/4162115326)] - **test**: add check for root user (Daniel Bevenius) [#19850](https://github.com/nodejs/node/pull/19850)
* \[[`dfea13a168`](https://github.com/nodejs/node/commit/dfea13a168)] - **test**: verify inspector help url works (cjihrig) [#19887](https://github.com/nodejs/node/pull/19887)
* \[[`d1156da815`](https://github.com/nodejs/node/commit/d1156da815)] - **test**: refactor parallel/test-tls-async-cb-after-socket-end (juggernaut451) [#18985](https://github.com/nodejs/node/pull/18985)
* \[[`cbc7eb7eec`](https://github.com/nodejs/node/commit/cbc7eb7eec)] - **test**: refactor parallel/test-tls-cert-chains-concat (juggernaut451) [#19096](https://github.com/nodejs/node/pull/19096)
* \[[`5b8c62c60d`](https://github.com/nodejs/node/commit/5b8c62c60d)] - **test**: fix flaky http-client-timeout-agent (Santiago Gimeno) [#19856](https://github.com/nodejs/node/pull/19856)
* \[[`e048b15523`](https://github.com/nodejs/node/commit/e048b15523)] - **test**: refactor parallel/test-tls-delayed-attach (juggernaut451) [#19421](https://github.com/nodejs/node/pull/19421)
* \[[`244af7a9d5`](https://github.com/nodejs/node/commit/244af7a9d5)] - **test**: verify multiple init via well-known symbol (Gabriel Schulhof) [#19875](https://github.com/nodejs/node/pull/19875)
* \[[`3217c70718`](https://github.com/nodejs/node/commit/3217c70718)] - **test**: update assert messages to show expected and actual values (Dave O'Mahony) [#19420](https://github.com/nodejs/node/pull/19420)
* \[[`a639ec4ca8`](https://github.com/nodejs/node/commit/a639ec4ca8)] - **test**: move test-http-dump-req-when-res-end (Rich Trott) [#19819](https://github.com/nodejs/node/pull/19819)
* \[[`95dc59010b`](https://github.com/nodejs/node/commit/95dc59010b)] - **test**: move http-client-timeout-agent to sequential (Rich Trott) [#19809](https://github.com/nodejs/node/pull/19809)
* \[[`fde93f82b2`](https://github.com/nodejs/node/commit/fde93f82b2)] - **test**: rename test cases (Rajkumar Purushothaman) [#19765](https://github.com/nodejs/node/pull/19765)
* \[[`3dc5404105`](https://github.com/nodejs/node/commit/3dc5404105)] - **test**: resolve process.setegid error on Ubuntu (Divyanshu Singh) [#19757](https://github.com/nodejs/node/pull/19757)
* \[[`682b85036e`](https://github.com/nodejs/node/commit/682b85036e)] - **test**: fix multiple expectedWarnings bug (Daniel Bevenius) [#19766](https://github.com/nodejs/node/pull/19766)
* \[[`126b03e2f9`](https://github.com/nodejs/node/commit/126b03e2f9)] - **test**: add tests for fs/promises.js fileHandle methods (willhayslett) [#19605](https://github.com/nodejs/node/pull/19605)
* \[[`2fef227a61`](https://github.com/nodejs/node/commit/2fef227a61)] - **test**: check all properties in common.expectsError (Ruben Bridgewater) [#19722](https://github.com/nodejs/node/pull/19722)
* \[[`8995125c14`](https://github.com/nodejs/node/commit/8995125c14)] - **test**: ensure failed assertions cause build to fail (Teddy Katz) [#19650](https://github.com/nodejs/node/pull/19650)
* \[[`1dc8eb4bd3`](https://github.com/nodejs/node/commit/1dc8eb4bd3)] - **test**: add regression test for large write (Anna Henningsen) [#19551](https://github.com/nodejs/node/pull/19551)
* \[[`42c740212d`](https://github.com/nodejs/node/commit/42c740212d)] - **test**: fix incorrect assumptions on uid and gid (garwahl) [#19554](https://github.com/nodejs/node/pull/19554)
* \[[`ce2ed584c8`](https://github.com/nodejs/node/commit/ce2ed584c8)] - **test**: improve tty.getColorDepth coverage (Ruben Bridgewater) [#19446](https://github.com/nodejs/node/pull/19446)
* \[[`8fb4ea9f75`](https://github.com/nodejs/node/commit/8fb4ea9f75)] - **test**: add deprecation code to expectWarning (Daniel Bevenius) [#19474](https://github.com/nodejs/node/pull/19474)
* \[[`fddcd6253b`](https://github.com/nodejs/node/commit/fddcd6253b)] - **test**: move ESM fixtures to fixtures dir (Michaël Zasso) [#19409](https://github.com/nodejs/node/pull/19409)
* \[[`3ad7c1ae97`](https://github.com/nodejs/node/commit/3ad7c1ae97)] - **test**: remove unused deprecation code (Daniel Bevenius) [#19317](https://github.com/nodejs/node/pull/19317)
* \[[`8181c607e5`](https://github.com/nodejs/node/commit/8181c607e5)] - **test**: add regression tests (Ruben Bridgewater) [#19188](https://github.com/nodejs/node/pull/19188)
* \[[`4bfc03b57d`](https://github.com/nodejs/node/commit/4bfc03b57d)] - _**Revert**_ "**test**: add test cases for fsPromises" (Rich Trott) [#19101](https://github.com/nodejs/node/pull/19101)
* \[[`c05c73a634`](https://github.com/nodejs/node/commit/c05c73a634)] - **test**: add test cases for fsPromises (Daijiro Wachi) [#19064](https://github.com/nodejs/node/pull/19064)
* \[[`fecc64d6dc`](https://github.com/nodejs/node/commit/fecc64d6dc)] - **test**: fix test-http-connect (Ruben Bridgewater) [#18941](https://github.com/nodejs/node/pull/18941)
* \[[`0a26280388`](https://github.com/nodejs/node/commit/0a26280388)] - **test**: really test the ttywrap bits of getasyncid (Jeremiah Senkpiel) [#18886](https://github.com/nodejs/node/pull/18886)
* \[[`5055c29e82`](https://github.com/nodejs/node/commit/5055c29e82)] - **test**: use runWithInvalidFD() in tests expecting EBADF (Joyee Cheung) [#18864](https://github.com/nodejs/node/pull/18864)
* \[[`acf2fd39f7`](https://github.com/nodejs/node/commit/acf2fd39f7)] - **test**: introduce common.runWithInvalidFD() (Joyee Cheung) [#18864](https://github.com/nodejs/node/pull/18864)
* \[[`53a5d87bec`](https://github.com/nodejs/node/commit/53a5d87bec)] - **test**: fix deprecation warning in binding.cc (Daniel Bevenius) [#18877](https://github.com/nodejs/node/pull/18877)
* \[[`7514eb3cff`](https://github.com/nodejs/node/commit/7514eb3cff)] - **test**: actually test tty `getColorDepth()` (Jeremiah Senkpiel) [#18800](https://github.com/nodejs/node/pull/18800)
* \[[`92bf2492cd`](https://github.com/nodejs/node/commit/92bf2492cd)] - **test**: move getTTYfd() to common helpers (Jeremiah Senkpiel) [#18800](https://github.com/nodejs/node/pull/18800)
* \[[`94e8d2a5ff`](https://github.com/nodejs/node/commit/94e8d2a5ff)] - **test**: fix unrelated variable name changes (Anatoli Papirovski) [#18823](https://github.com/nodejs/node/pull/18823)
* \[[`3e8af961b3`](https://github.com/nodejs/node/commit/3e8af961b3)] - **test**: formalize exposure of internal bindings (Gus Caplan) [#18698](https://github.com/nodejs/node/pull/18698)
* \[[`cf52ab19dc`](https://github.com/nodejs/node/commit/cf52ab19dc)] - **test**: remove unused using declarations (Daniel Bevenius) [#18637](https://github.com/nodejs/node/pull/18637)
* \[[`1729af2ce9`](https://github.com/nodejs/node/commit/1729af2ce9)] - **test**: convert new tests to use error types (Jack Horton) [#18581](https://github.com/nodejs/node/pull/18581)
* \[[`075eef5956`](https://github.com/nodejs/node/commit/075eef5956)] - **test**: added input validation test for fchmod (Luca Maraschi) [#18217](https://github.com/nodejs/node/pull/18217)
* \[[`4372185ef8`](https://github.com/nodejs/node/commit/4372185ef8)] - **test**: fix builds (Ruben Bridgewater) [#18500](https://github.com/nodejs/node/pull/18500)
* \[[`a025723e01`](https://github.com/nodejs/node/commit/a025723e01)] - **test**: fix flaky test-process-fatal-execption-tick (Rich Trott) [#18461](https://github.com/nodejs/node/pull/18461)
* \[[`94e36f1f31`](https://github.com/nodejs/node/commit/94e36f1f31)] - **test**: fix flaky test-fs-write (Joyee Cheung) [#18374](https://github.com/nodejs/node/pull/18374)
* \[[`bea5f26d34`](https://github.com/nodejs/node/commit/bea5f26d34)] - **test**: fix if-error-has-good-stack (Joyee Cheung) [#18378](https://github.com/nodejs/node/pull/18378)
* \[[`63f78f5ddc`](https://github.com/nodejs/node/commit/63f78f5ddc)] - **test**: improve fs error message test (Joyee Cheung) [#18277](https://github.com/nodejs/node/pull/18277)
* \[[`080a72c349`](https://github.com/nodejs/node/commit/080a72c349)] - **test**: check fs.read and fs.readsync input (Omar Crisostomo) [#17910](https://github.com/nodejs/node/pull/17910)
* \[[`f576341dc2`](https://github.com/nodejs/node/commit/f576341dc2)] - **test**: replace assert.equal with assert.strictEqual (Sho Miyamoto) [#18119](https://github.com/nodejs/node/pull/18119)
* \[[`b88da496ef`](https://github.com/nodejs/node/commit/b88da496ef)] - **test**: fix flaky interval test (Anatoli Papirovski) [#18161](https://github.com/nodejs/node/pull/18161)
* \[[`8d043238de`](https://github.com/nodejs/node/commit/8d043238de)] - **test**: fix flaky interval test (Anatoli Papirovski) [#18140](https://github.com/nodejs/node/pull/18140)
* \[[`6707903fae`](https://github.com/nodejs/node/commit/6707903fae)] - **test**: improve coverage for Cipheriv and Decipheriv (Leko) [#17458](https://github.com/nodejs/node/pull/17458)
* \[[`84b7a86786`](https://github.com/nodejs/node/commit/84b7a86786)] - **test**: improve coverage for Cipher and Decipher (Leko) [#17449](https://github.com/nodejs/node/pull/17449)
* \[[`7ce6d23387`](https://github.com/nodejs/node/commit/7ce6d23387)] - **test**: add test for importing acorn (Timothy Gu) [#15566](https://github.com/nodejs/node/pull/15566)
* \[[`1f29963eac`](https://github.com/nodejs/node/commit/1f29963eac)] - **test,http**: fix http dump test (Matteo Collina) [#19823](https://github.com/nodejs/node/pull/19823)
* \[[`d784dbf36a`](https://github.com/nodejs/node/commit/d784dbf36a)] - **timers**: call destroy on interval error (Anatoli Papirovski) [#20001](https://github.com/nodejs/node/pull/20001)
* \[[`f395c2107e`](https://github.com/nodejs/node/commit/f395c2107e)] - **timers**: fix subsequent enroll calls not working (Anatoli Papirovski) [#19936](https://github.com/nodejs/node/pull/19936)
* \[[`12bad69871`](https://github.com/nodejs/node/commit/12bad69871)] - **timers**: fix clearInterval to work with timers from setTimeout (Rémi Berson) [#19952](https://github.com/nodejs/node/pull/19952)
* \[[`28f3ffba0f`](https://github.com/nodejs/node/commit/28f3ffba0f)] - **timers**: add helper fn for async init (Anatoli Papirovski) [#18825](https://github.com/nodejs/node/pull/18825)
* \[[`2aa3e3b00f`](https://github.com/nodejs/node/commit/2aa3e3b00f)] - **timers**: fix enroll deprecation wording (Anatoli Papirovski) [#18704](https://github.com/nodejs/node/pull/18704)
* \[[`0f9efef05d`](https://github.com/nodejs/node/commit/0f9efef05d)] - **timers**: refactor timer list processing (Anatoli Papirovski) [#18582](https://github.com/nodejs/node/pull/18582)
* \[[`8204b0f9c6`](https://github.com/nodejs/node/commit/8204b0f9c6)] - **timers**: simplify clearTimeout & clearInterval (Anatoli Papirovski) [#18579](https://github.com/nodejs/node/pull/18579)
* \[[`c11cb038a1`](https://github.com/nodejs/node/commit/c11cb038a1)] - **timers**: async track unref timers (Anatoli Papirovski) [#18579](https://github.com/nodejs/node/pull/18579)
* \[[`568b6a5c9e`](https://github.com/nodejs/node/commit/568b6a5c9e)] - **timers**: be more defensive with intervals (Anatoli Papirovski) [#18579](https://github.com/nodejs/node/pull/18579)
* \[[`1b05d7bc86`](https://github.com/nodejs/node/commit/1b05d7bc86)] - **timers**: remove unused variable (Anatoli Papirovski) [#18579](https://github.com/nodejs/node/pull/18579)
* \[[`bb5575aa75`](https://github.com/nodejs/node/commit/bb5575aa75)] - **timers**: add internal \[@@ refresh()] function (Jeremiah Senkpiel) [#18065](https://github.com/nodejs/node/pull/18065)
* \[[`54fe0a6cbb`](https://github.com/nodejs/node/commit/54fe0a6cbb)] - **timers**: reposition getTimers definition internally (Jeremiah Senkpiel) [#18065](https://github.com/nodejs/node/pull/18065)
* \[[`92ba624fa1`](https://github.com/nodejs/node/commit/92ba624fa1)] - **tls**: provide now value from C++ (Anatoli Papirovski) [#18562](https://github.com/nodejs/node/pull/18562)
* \[[`1bdd3b0dcf`](https://github.com/nodejs/node/commit/1bdd3b0dcf)] - **tools**: improve heading type detection in json.js (Vse Mozhet Byt) [#20074](https://github.com/nodejs/node/pull/20074)
* \[[`0a3876d025`](https://github.com/nodejs/node/commit/0a3876d025)] - **tools**: delete redundant .eslintignore rule (Vse Mozhet Byt) [#20203](https://github.com/nodejs/node/pull/20203)
* \[[`44856f72cb`](https://github.com/nodejs/node/commit/44856f72cb)] - **tools**: fix broken link in icu notes (Harry Sarson) [#20030](https://github.com/nodejs/node/pull/20030)
* \[[`512a6a55b7`](https://github.com/nodejs/node/commit/512a6a55b7)] - **tools**: stricter no-undef eslint rule (Ruben Bridgewater) [#19926](https://github.com/nodejs/node/pull/19926)
* \[[`4f4e716dc3`](https://github.com/nodejs/node/commit/4f4e716dc3)] - **tools**: treat SIGABRT as crash (Anna Henningsen) [#19990](https://github.com/nodejs/node/pull/19990)
* \[[`b43866cbaa`](https://github.com/nodejs/node/commit/b43866cbaa)] - **tools**: include exit code in TAP log (Refael Ackermann) [#19855](https://github.com/nodejs/node/pull/19855)
* \[[`114ba67b02`](https://github.com/nodejs/node/commit/114ba67b02)] - **tools**: include exit code in test failures (Rich Trott) [#19855](https://github.com/nodejs/node/pull/19855)
* \[[`9a6dd07e8d`](https://github.com/nodejs/node/commit/9a6dd07e8d)] - **tools**: overhaul tools/doc/json.js (Vse Mozhet Byt) [#19832](https://github.com/nodejs/node/pull/19832)
* \[[`254058109f`](https://github.com/nodejs/node/commit/254058109f)] - **tools**: add 'spaced-comment' into eslint rules (Weijia Wang) [#19596](https://github.com/nodejs/node/pull/19596)
* \[[`ebfed17fec`](https://github.com/nodejs/node/commit/ebfed17fec)] - **tools**: enable ESLint quote-props rule (Rich Trott) [#19156](https://github.com/nodejs/node/pull/19156)
* \[[`c221355c50`](https://github.com/nodejs/node/commit/c221355c50)] - **tools**: alphabetize ESLint rules (Rich Trott) [#19100](https://github.com/nodejs/node/pull/19100)
* \[[`3a2e912b2d`](https://github.com/nodejs/node/commit/3a2e912b2d)] - **tools**: update eslint rule (Ruben Bridgewater) [#18831](https://github.com/nodejs/node/pull/18831)
* \[[`cbc6f39b71`](https://github.com/nodejs/node/commit/cbc6f39b71)] - **tools**: enable eslint no-whitespace-before-property rule (Ruben Bridgewater) [#18831](https://github.com/nodejs/node/pull/18831)
* \[[`13637d23f7`](https://github.com/nodejs/node/commit/13637d23f7)] - **tools**: add falsely removed eslint rules (Ruben Bridgewater) [#18933](https://github.com/nodejs/node/pull/18933)
* \[[`bff5d5b8f0`](https://github.com/nodejs/node/commit/bff5d5b8f0)] - **tools**: add FileHandle to doc/type-parser.js (Vse Mozhet Byt) [#18601](https://github.com/nodejs/node/pull/18601)
* \[[`fa9f31a4fd`](https://github.com/nodejs/node/commit/fa9f31a4fd)] - _**Revert**_ "**tools**: teach gyp to write an 'all deps' rule" (Rod Vagg) [#18287](https://github.com/nodejs/node/pull/18287)
* \[[`90f882e50d`](https://github.com/nodejs/node/commit/90f882e50d)] - _**Revert**_ "**tools**: simplify tools/doc/addon-verify.js" (Rod Vagg) [#18287](https://github.com/nodejs/node/pull/18287)
* \[[`c6682636be`](https://github.com/nodejs/node/commit/c6682636be)] - **tools**: simplify tools/doc/addon-verify.js (Ben Noordhuis) [#17407](https://github.com/nodejs/node/pull/17407)
* \[[`920c13203d`](https://github.com/nodejs/node/commit/920c13203d)] - **tools**: teach gyp to write an 'all deps' rule (Ben Noordhuis) [#17407](https://github.com/nodejs/node/pull/17407)
* \[[`e46c3f743d`](https://github.com/nodejs/node/commit/e46c3f743d)] - **tools**: fix typo in gen-postmortem-metadata.py (Daniel Bevenius) [#17268](https://github.com/nodejs/node/pull/17268)
* \[[`ceaeee0120`](https://github.com/nodejs/node/commit/ceaeee0120)] - **tty**: add color support for more terminals (Ruben Bridgewater) [#19730](https://github.com/nodejs/node/pull/19730)
* \[[`1b715221b9`](https://github.com/nodejs/node/commit/1b715221b9)] - **tty**: add attribution for chalk (Ruben Bridgewater) [#19730](https://github.com/nodejs/node/pull/19730)
* \[[`fa2d43bd3e`](https://github.com/nodejs/node/commit/fa2d43bd3e)] - **url**: make urlToOptions() handle IPv6 literals (Luigi Pinca) [#19720](https://github.com/nodejs/node/pull/19720)
* \[[`a892d9a0c1`](https://github.com/nodejs/node/commit/a892d9a0c1)] - **url**: use existing handlers instead of duplicated code (Sergey Golovin) [#19267](https://github.com/nodejs/node/pull/19267)
* \[[`cc6abc6e84`](https://github.com/nodejs/node/commit/cc6abc6e84)] - **url**: fix error type (Benjamin Gruenbaum) [#19299](https://github.com/nodejs/node/pull/19299)
* \[[`354849eeb5`](https://github.com/nodejs/node/commit/354849eeb5)] - **url**: replace "magic" numbers by constants (Sergey Golovin) [#19300](https://github.com/nodejs/node/pull/19300)
* \[[`7f3838bb3e`](https://github.com/nodejs/node/commit/7f3838bb3e)] - **util**: improve inspect performance (Ruben Bridgewater) [#20009](https://github.com/nodejs/node/pull/20009)
* \[[`554ed3740d`](https://github.com/nodejs/node/commit/554ed3740d)] - _**Revert**_ "**util**: change util.inspect depth default" (Anna Henningsen) [#20089](https://github.com/nodejs/node/pull/20089)
* \[[`47af0a0eda`](https://github.com/nodejs/node/commit/47af0a0eda)] - _**Revert**_ "**util**: change %o depth default" (Anna Henningsen) [#20089](https://github.com/nodejs/node/pull/20089)
* \[[`a167b6aab6`](https://github.com/nodejs/node/commit/a167b6aab6)] - **util**: fix inspect performance bug (Ruben Bridgewater) [#20007](https://github.com/nodejs/node/pull/20007)
* \[[`1329844a08`](https://github.com/nodejs/node/commit/1329844a08)] - _**Revert**_ "**util**: use blue on non-windows systems for number/bigint" (Ruben Bridgewater) [#19256](https://github.com/nodejs/node/pull/19256)
* \[[`893432ad92`](https://github.com/nodejs/node/commit/893432ad92)] - **util**: add boxed BigInt formatting to util.inspect (Michaël Zasso) [#19341](https://github.com/nodejs/node/pull/19341)
* \[[`ae3137049f`](https://github.com/nodejs/node/commit/ae3137049f)] - **util**: assign missed deprecation number (Anna Henningsen) [#19149](https://github.com/nodejs/node/pull/19149)
* \[[`1708af369b`](https://github.com/nodejs/node/commit/1708af369b)] - **util**: use blue on non-windows systems for number/bigint (Gus Caplan) [#18925](https://github.com/nodejs/node/pull/18925)
* \[[`07ba9141e4`](https://github.com/nodejs/node/commit/07ba9141e4)] - **vm**: add support for import.meta to Module (punteek) [#19277](https://github.com/nodejs/node/pull/19277)
* \[[`7b46503706`](https://github.com/nodejs/node/commit/7b46503706)] - **win, tools**: add nasm to boxstarter script (Bartosz Sosnowski) [#19950](https://github.com/nodejs/node/pull/19950)
* \[[`7bc5151d5e`](https://github.com/nodejs/node/commit/7bc5151d5e)] - **zlib**: fix windowBits validation to allow 0 for decompression mode (Anand Suresh) [#19686](https://github.com/nodejs/node/pull/19686)
* \[[`e765257283`](https://github.com/nodejs/node/commit/e765257283)] - **zlib,stream**: use “official” util.types typechecks (Anna Henningsen) [#19602](https://github.com/nodejs/node/pull/19602)
